<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
    xmlns:ns3="http://purl.org/dc/elements/1.1/" xmlns:ns4="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns2="http://schema.ibm.com/vega/2008/" xmlns:ta="http://jazz.net/xmlns/alm/qm/v0.1/"
    xmlns:atom="http://www.w3.org/2005/Atom"
    exclude-result-prefixes="ns8 ns7 ns6 ns5 ns4 ns3 ns2 ta atom xsl">
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                    	<fo:block-container height="0.1in" padding-after="0.07in">
							<fo:block text-align="center">
								<fo:leader leader-pattern='rule' rule-thickness='1pt' leader-length='100%'/>
							</fo:block>
						</fo:block-container>
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{originUrl}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="originUrl"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ta:teamarea"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ta:teamarea"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ta:teamarea">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                <xsl:choose>
                    <xsl:when
                        test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
                        <xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
                            <fo:block font-size="14pt" space-before="6mm" space-after="2mm">
                                <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                /> : <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelRequiredTeamArea"
                                />
                            </fo:block>
                        </xsl:if>
                        <fo:table border="0.5pt solid black" text-align="left" font-size="8pt">
                            <fo:table-header>
                                <fo:table-row background-color="rgb(249,245,219)">
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelName"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-header>
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:apply-templates select="ns3:title"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <xsl:choose>
                                                <xsl:when
                                                  test="../../atom:memberNames/atom:memberName">
                                                  <xsl:for-each
                                                  select="../../atom:memberNames/atom:memberName">
                                                  <fo:block>
                                                  <xsl:value-of select="."/>
                                                  </fo:block>
                                                  </xsl:for-each>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                  <fo:block/>
                                                </xsl:otherwise>
                                            </xsl:choose>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:table-row font-size="8pt">
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:apply-templates select="ns3:title"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <xsl:choose>
                                        <xsl:when test="../../atom:memberNames/atom:memberName">
                                            <xsl:for-each
                                                select="../../atom:memberNames/atom:memberName">
                                                <fo:block>
                                                  <xsl:value-of select="."/>
                                                </fo:block>
                                            </xsl:for-each>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <fo:block/>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </fo:block-container>
                            </fo:table-cell>
                        </fo:table-row>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:when test="(../../componentType='COMPOSITE') and (../../recursive)">
                <fo:wrapper>
                    <fo:table-row font-size="8pt">
                        <fo:table-cell padding="3pt" border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <fo:block>
                                    <xsl:apply-templates select="ns3:title"/>
                                </fo:block>
                            </fo:block-container>
                        </fo:table-cell>
                        <fo:table-cell padding="3pt" border="0.5pt solid black">
                            <fo:block-container overflow="hidden">
                                <xsl:choose>
                                    <xsl:when test="../../atom:memberNames/atom:memberName">
                                        <xsl:for-each
                                            select="../../atom:memberNames/atom:memberName">
                                            <fo:block>
                                                <xsl:value-of select="."/>
                                            </fo:block>
                                        </xsl:for-each>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <fo:block/>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </fo:block-container>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    	<xsl:if test="//pageBreaks = 'true'">
                        	<xsl:attribute name="break-after">page</xsl:attribute>
                        </xsl:if>
                        <fo:block font-size="14pt" space-before="2mm" space-after="2mm"
                            border-after-style="solid" border-after-width="thin">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelRequiredTeamArea"
                            /> : <xsl:value-of select="ns3:title"/>
                        </fo:block>
                        <fo:block space-after="4mm">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                            /> : <xsl:value-of select="ta:summary"/>
                        </fo:block>
                        <fo:block space-after="2mm">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelteammembers"
                            /> : </fo:block>
                        <xsl:for-each select="../../atom:memberNames/atom:memberName">
                            <fo:block text-indent="15pt">
                                <xsl:value-of select="."/>
                            </fo:block>
                        </xsl:for-each>
                    </fo:block>
                </fo:wrapper>
            </xsl:when>
            <xsl:otherwise>
                <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    <xsl:if test="(../../componentType='COMPOSITE' )">
                    	<xsl:if test="//pageBreaks = 'true'">
                        	<xsl:attribute name="break-after">page</xsl:attribute>
                        </xsl:if>
                    </xsl:if>
                    <fo:block font-size="14pt" space-before="2mm" space-after="2mm"
                        border-after-style="solid" border-after-width="thin">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelRequiredTeamArea"
                        /> : <xsl:value-of select="ns3:title"/>
                    </fo:block>
                    <fo:block space-after="4mm">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                        /> : <xsl:value-of select="ta:summary"/>
                    </fo:block>
                    <fo:block space-after="2mm">
                        <xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelteammembers"
                        /> : </fo:block>
                    <xsl:for-each select="../../atom:memberNames/atom:memberName">
                        <fo:block text-indent="15pt">
                            <xsl:value-of select="."/>
                        </fo:block>
                    </xsl:for-each>
                </fo:block>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
