/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.client.RequirementsManager2");

dojo.require("com.ibm.rqm.defects.web.client.AbstractOSLCManager");
dojo.require("com.ibm.rqm.defects.web.client.OSLCRmProvider");

(function(){
    var PROJECT_LINK_TYPE_VALIDATES = "validates";
    dojo.declare("com.ibm.rqm.defects.web.client.RequirementsManager2", com.ibm.rqm.defects.web.client.AbstractOSLCManager, {
        /* implementation */
        getAPIConstructor: function(){
            return com.ibm.rqm.defects.web.client.OSLCRmProvider
        },
        
        getProjectLinkType: function(){
            return PROJECT_LINK_TYPE_VALIDATES;
        },
        
        __sentinel: null // terminates this class definition
    });
    
    var MANAGER_INSTANCE = null;
    
    /**
     * <p>
     * Example usage:
     * </p>
     * <pre>
     * dojo.require("com.ibm.rqm.defects.web.client.RequirementsManager2");
     *
     * var serviceProviderManager = com.ibm.rqm.defects.web.client.RequirementsManager2.getInstance();
     *
     * // discover dialog uri
     * serviceProviderManager.getCurrentServiceProvider(dojo.hitch(this, function(currentServiceProvider) {
     * 		if(currentServiceProvider) {
     * 			var selectionDialogUri = currentServiceProvider.providerUris.selectionDialog.uri;
     * 			// select an item from the selection dialog
     * 		} else {
     * 			// Neither cq rest nor RTC project area is configured.
     * 		}
     * }));
     * // invoke RM APIs
     * serviceProviderManager.getCurrentServiceProvider(dojo.hitch(this, function(currentServiceProvider) {
     * 		if(currentServiceProvider) {
     * 			//post a new link to the RM service provider
     * 			currentServiceProvider.postLink(linkDescription, responseCallback);
     * 		} else {
     * 		}
     * }));
     *
     * </pre>
     */
    com.ibm.rqm.defects.web.client.RequirementsManager2.getInstance = function(){
        if (MANAGER_INSTANCE == null) {
            var instance = new com.ibm.rqm.defects.web.client.RequirementsManager2();
            MANAGER_INSTANCE = instance;
        }
        
        return MANAGER_INSTANCE;
    };
})();
