/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container

var session					= com.ibm.team.repository.web.client.session;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.reports.cognos.web.client.internal.CognosReportsClient = {

	SERVICE_URI: "com.ibm.rqm.reports.service.cognos.internal.ICognosReportRestService",
	
	/**
	 * Fetch cognos report descriptors. 
	 * This method will supply the projectAreaUUID.
	 */
	getCognosReportDescriptors: function(responseHandler, args) {
		var currentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea();
		args.projectAreaUUID = currentProjectArea.itemId;
		this._invokeReportsService(responseHandler, "getCognosReportDescriptors", args);
	},
	
	postUploadCognosReportTemplate : function(responseHandler, args){
		this._invokeReportsService(responseHandler, "postUploadCognosReportTemplate", args);
	},

	/**
	 * Invokes the requested method on the Cognos Reports REST service.
	 */
	_invokeReportsService: function(responseHandler, method, args) {
		// args is optional, so test whether or not it was sent
		var serviceRequest;
		if (arguments.length == 2) {
			serviceRequest = new ServiceRequest(
					this.SERVICE_URI,
					method);
		} else {
			serviceRequest = new ServiceRequest(
					this.SERVICE_URI,
					method,
					args);
		}
		TeamServerClient.invokeService(
				serviceRequest,
				responseHandler);
	}
};

})();