/**TeamConcertConnectionClient*****************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.client.internal.TeamConcertConnectionClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");

(function() {

var ServiceRequest					= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient				= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status							= com.ibm.team.repository.web.foundation.Status;
var getCurrentPA            		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var BuildUiUtil		 				= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;

var SERVICE_URI						= "com.ibm.rqm.integrationprovider.service.rest.internal.IConnectionRestService";

com.ibm.rqm.buildintegration.web.client.internal.TeamConcertConnectionClient= {

	getDefaultTeamConcertConnection: function(responceCallback,params) {
		return this._invokeTeamConcertConnectionService("getDefaultTeamConcertDefectsConnection", responceCallback,params);
	},

	postDefaultTeamConcertConnection: function(connectionParams, responceCallback) {
		var callback = function(status, response){
			if(!status.isOK()){
				status = new Status(Status.ERROR, BuildUiUtil.getMessage("msgRQMConnectionProblemToRTC"), status);
			} 
			responceCallback(status, response);
		};
		this._invokeTeamConcertConnectionService("postDefaultTeamConcertConnection", callback, connectionParams);
	},
	
	postDeleteDefaultTeamConcertConnection: function(connectionParams, responceCallback) {
		this._invokeTeamConcertConnectionService("postDeleteDefaultTeamConcertConnection", responceCallback, connectionParams);
	},

	_invokeTeamConcertConnectionService: function(method, serviceCallback, appArgs) {
		// scope each service call to current project area
		if (!appArgs) {
			var appArgs = {};
		}
		appArgs.rqmProjectAreaItemId = getCurrentPA().itemId;
		var serviceRequest= new ServiceRequest(SERVICE_URI, method, appArgs);
		var serviceResponseHandler= new ServiceResponseHandler({
			success: function(result) {
				serviceCallback(Status.OK_STATUS, result);
			},
			failure: function(error) {
				serviceCallback(new Status(Status.ERROR, error.message, error), null);
			}
		}, "success", "failure");

		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},

	__sentinel: null // terminates this class definition
};

})();
