/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function(){
dojo.provide("com.ibm.asq.common.web.client.internal._catalog._AttributeBase");
dojo.require("com.ibm.asq.common.web.client.internal._catalog._NodeBase");
dojo.declare("com.ibm.asq.common.web.client.internal._catalog._AttributeBase", com.ibm.asq.common.web.client.internal._catalog._NodeBase, 
{
    constructor: function(document, parent, instanceRoot, templateObj, path){
        this.marked = false;
    },
    // Get the dotted long name of the attribute
    // The returned path is only valid on instance
    // attributes.  Not on attributes obtained 
    // from the template.
    getPathName: function(){
        return this.path;
    },
    // Get the current value of the attribute.  This method is 
    // only valid if the attribute is not an array.
    getValue: function(){
        return this._getValue(false);
    },
    // Get the value of the attribute at the given array
    // index.  This method is only valid if the attribute
    // is an array.
    getArrayValueByTag: function(tag){
        return this.getArrayValue(this.getIndexByTag(tag));
    },
    // Set the value of the attribute at the given array
    // tag.  If this method is called with a value of null,
    // the part at the corresponding index will be removed.
    // This method is only valid if the attribute
    // is an array.
    setArrayValueByTag: function(tag, value){
        this.setArrayValue(this.getIndexByTag(tag), value);
    },
    // Remove the value of the attribute at the given tag
    // This method is only valid if the attribute
    // is an array.  This will re-index all of the values
    // in the array.
    removeArrayValueByTag: function(tag){
        return this.removeArrayValue(this.getIndexByTag(tag));
    },
    // Set the indicator that this attribute has been placed in the custom UI
    setMarked: function(isMarked){
        this.marked = isMarked;
    },
    // Get the indicator that this attribute has been placed in the custom UI
    isMarked: function(){
        return this.marked;
    },
    _getParent: function(){
        return this.parent;
    },
    getIndexByTag: function(tag){
        var parts = this.partCache;
        var length = parts.length;
        for(var i=0; i<length; i++){
            if(parts[i].tag == tag){
                return i;
            }
        }
        throw new Error("Part " + i + " not found.");
    }
}   
)
})();
