/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//	Author(s): Paul Beaulieu

/*
*
*  This class is specific to machines.  It extends to container object.
*
*/
dojo.require("dojo.io.iframe");
dojo.require("com.ibm.asq.common.web.client.internal.container");
dojo.provide("com.ibm.rational.test.lm.web.client.internal.audit");
dojo.declare("com.ibm.rational.test.lm.web.client.internal.audit", com.ibm.asq.common.web.client.internal.container, 
    
    {
    	constructor: function(){
        	this.setServiceInterface('com.ibm.rational.test.lm.common.IAuditTrailRestService');
        	console.debug("initialized serviceInterface: "+this.serviceInterface);
    	},
    
        //
        //Any custom (non-CRUD) properties of a machine would go here.
        //
        _getHost : function(url) {
        	var h = url.match(/^[^\/]+\/\/[^\/]+\//);
        	return h;
        },
        
        
        //
        //Get the history for a particular machine
        //
        getMachineAuditTrail: function(responseHandler, uuid)
        {
        	var args = {};
        	args[ "uuid" ] = uuid;
        	return this._invokeService(	responseHandler, 
        								"getRecords", 
        								args );
        }      
    }
)
