/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	
com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient = {

    DATAPOOL_SERVICE_URI: "com.ibm.rqm.datapool.common.service.rest.IDatapoolRestService",
    
    _invokeService: function(responseHandler, method, appArgs){
        var actualArgs = {};
        if (appArgs.itemId) {
            actualArgs.itemId = appArgs.itemId;
        }
        if (appArgs.id) {
            actualArgs.id = appArgs.id;
        }
        if (appArgs.name) {
			actualArgs.name = appArgs.name;
		}
		if (appArgs.isDataRequired) {
			actualArgs.isDataRequired = appArgs.isDataRequired;
		}
		if (appArgs.isIterationRequired) {
			actualArgs.isIterationRequired = appArgs.isIterationRequired;
		}
		if (appArgs.dataItemUUID) {
			actualArgs.dataItemUUID = appArgs.dataItemUUID;
		}
		if (appArgs.dataItemStateUUID) {
			actualArgs.dataItemStateUUID = appArgs.dataItemStateUUID;
		}
		if (appArgs.execItemUUID) {
			actualArgs.execItemUUID = appArgs.execItemUUID;
		}
		if (appArgs.execItemStateUUID) {
			actualArgs.execItemStateUUID = appArgs.execItemStateUUID;
		}
		if (appArgs.linkedTestScriptUUID){
			actualArgs.linkedTestScriptUUID = appArgs.linkedTestScriptUUID;
		}
		if (appArgs.linkedTestScriptStateUUID){
			actualArgs.linkedTestScriptStateUUID = appArgs.linkedTestScriptStateUUID;
		}
		if (appArgs.variableItemId) {
			actualArgs.variableItemId = appArgs.variableItemId;
		}
		if (appArgs.jsonString) {
			actualArgs.jsonString = appArgs.jsonString;
		}
		if (appArgs.externalId) {
			actualArgs.externalId = appArgs.externalId;
		}
		if (appArgs.stateId) {
			actualArgs.stateId = appArgs.stateId;
		}
		if (appArgs.archive) {
			actualArgs.archive = appArgs.archive;
		}
        if (appArgs.includeArchived) {
            actualArgs.includeArchived = appArgs.includeArchived;
        }
        if (appArgs.policy) {
            actualArgs.policy = appArgs.policy;
        }
        if (appArgs.description) {
            actualArgs.description = appArgs.description;
        }
        if(appArgs.queryToken) {
            actualArgs.queryToken = appArgs.queryToken; 
        }       
        if(appArgs.page) {
            actualArgs.page = appArgs.page; 
        }       
        if(appArgs.pageSize) {
            actualArgs.pageSize = appArgs.pageSize; 
        }       
        if(appArgs.sortColumns) {
            actualArgs.sortColumns = appArgs.sortColumns; 
        }                               
        if(appArgs.textSearch) {
            actualArgs.textSearch = appArgs.textSearch; 
        }                               
        if(appArgs.kindOfHandles) {
            actualArgs.kindOfHandles = appArgs.kindOfHandles; 
        }                               
		actualArgs.processArea = getCurrentProjectArea().itemId;
        actualArgs.projectArea = appArgs.projectArea ? appArgs.projectArea : actualArgs.processArea;
        var serviceRequest = new ServiceRequest(this.DATAPOOL_SERVICE_URI, method, actualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
    
	postDatapoolLink: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postDatapoolLink", params);
	},
	
    getDatapools: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getDatapools", params);
    },
    
	getDatapoolDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getDatapoolDTOs", params);
    },
	
	getVariableValues: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getVariableValues", params);
    },
	
	postDatapoolVariableLink2: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postDatapoolVariableLink2", params);
    },
    
    archiveDatapool: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postArchiveDatapool", params);
    },
	
	deleteDataFile: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postDeleteDataFile", params);
    },


    getAllSearchResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        console.dir(args)
        return this._invokeService(serviceResponseHandler, "getAllItemHandles", args);
    },          

    getSearchDatapools: function(serviceResponseHandler, params){
        /*
         valid parameters:
            public String projectArea;
            public String name;
            public String description;
            public boolean includeArchived = false;
            public String policy;
            String queryToken;
            int page;
            int pageSize;
            String[] sortColumns;
            String textSearch;
        */
        this._invokeService(serviceResponseHandler, "getPagedSearchResult", params);
    }
};

