/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionEnvironmentClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

//var checkNotNull 			= com.ibm.team.repository.web.toolbox.lang.checkNotNull;
//var checkNotEmpty 			= com.ibm.team.repository.web.toolbox.lang.checkNotEmpty;
//var findIf					= com.ibm.team.repository.web.toolbox.lang.findIf;
//var removeIf				= com.ibm.team.repository.web.toolbox.lang.removeIf;

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
//var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionEnvironmentClient= {

	EXECUTION_ENV_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IExecutionEnvironmentRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			var envEntryNames = [];
			var envEntryValues = [];
			var newEnv = false;
			var count = 0;
			
			if(appArgs.browser)
			{
				envEntryNames[count] = "Browser";
				envEntryValues[count] = appArgs.browser;
				count++;
			}
		
			if(appArgs.hardware)
			{
				envEntryNames[count] = "Platform";
				envEntryValues[count] = appArgs.hardware;
				count++;
			}
			if(appArgs.os)
			{
				envEntryNames[count] = "Operating System";
				envEntryValues[count] = appArgs.os;
				count++;
			}
			if(appArgs.newEnv)
			{
				newEnv = appArgs.newEnv;
			}
			actualArgs ={
				envEntryNames: envEntryNames,
				envEntryValues: envEntryValues,
				newEnv: newEnv
			}					
		}
		var serviceRequest= new ServiceRequest(this.EXECUTION_ENV_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getEnvironmentDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getExecutionEnvironmentDTOs", params);
	}
	
};

})();
