/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient= {

	EXECUTION_RESULT_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.IExecutionResultRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs = dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			
			if (appArgs.workItemId) {
				actualArgs.workItemId = appArgs.workItemId;
			}
			if (appArgs.stepIndex != null) {
				actualArgs.stepIndex = appArgs.stepIndex;
			}
			if (appArgs.executionResult != null) {
				actualArgs.executionResult = appArgs.executionResult;
			}
			if (appArgs.resultStateId) {
				actualArgs.resultStateId = appArgs.resultStateId;
			}
            if(appArgs.resultState)
                actualArgs.resultState = appArgs.resultState;
			
            if (appArgs.resultElementStateTypeId != null) {
				actualArgs.resultElementStateTypeId = appArgs.resultElementStateTypeId;
			}
			if (appArgs.id) {
				actualArgs.id = appArgs.id;
			}
			if (appArgs.startTime != null) {
				actualArgs.startTime = appArgs.startTime;
			}
			if (appArgs.endTime != null) {
				actualArgs.endTime = appArgs.endTime;
			}	
			if (appArgs.machine != null) {
				actualArgs.machine = appArgs.machine;
			}
			if (appArgs.workItemID) {
				actualArgs.workItemID = appArgs.workItemID;
			}
			if (appArgs.workItemStateId) {
				actualArgs.workItemStateId = appArgs.workItemStateId;
			}	
			if (appArgs.resultItemId) {
				actualArgs.resultItemId = appArgs.resultItemId;
			}	
			if (appArgs.stepResultItemId) {
				actualArgs.stepResultItemId = appArgs.stepResultItemId;
			}						
			if (appArgs.ewiItemId) {
				actualArgs.ewiItemId = appArgs.ewiItemId;
			}
			if (appArgs.ewiStateId) {
				actualArgs.ewiStateId = appArgs.ewiStateId;
			}			
			if (appArgs.verdict) {
				actualArgs.verdict = appArgs.verdict;
			}
			if (appArgs.state) {
				actualArgs.state = appArgs.state;
			}		
			if (appArgs.addAttachments) {
				actualArgs.addAttachments = appArgs.addAttachments;
			}	
			if (appArgs.removeAttachments) {
				actualArgs.removeAttachments = appArgs.removeAttachments;
			}
			if (appArgs.addProperties) {
				actualArgs.stepPropsJsonString = dojo.toJson(appArgs.addProperties);
			}
			if (appArgs.pointsPassed) {
	            actualArgs.pointsPassed = appArgs.pointsPassed;
			}
			if (appArgs.pointsFailed) {
    	        actualArgs.pointsFailed = appArgs.pointsFailed;
        	}
			if (appArgs.pointsBlocked) {
    	        actualArgs.pointsBlocked = appArgs.pointsBlocked;
        	}
			if (appArgs.pointsInconclusive) {
    	        actualArgs.pointsInconclusive = appArgs.pointsInconclusive;
        	}
			if (appArgs.pointsAttempted) {
            	actualArgs.pointsAttempted = appArgs.pointsAttempted;
         	}
		 	if(appArgs.addAttachmentItemIds){
		 		actualArgs.addAttachmentItemIds = appArgs.addAttachmentItemIds;
		 	}
		 	if(appArgs.removeAttachmentItemIds){
		 		actualArgs.removeAttachmentItemIds = appArgs.removeAttachmentItemIds;
			}
			if(appArgs.addStepAttachmentItemIds){
				actualArgs.addStepAttachmentItemIds = appArgs.addStepAttachmentItemIds;
			}
			if(appArgs.removeStepAttachmentItemIds){
				actualArgs.removeStepAttachmentItemIds = appArgs.removeStepAttachmentItemIds;
			}
		 	if(appArgs.content){
		 		actualArgs.content = appArgs.content;
			}
		 	if(appArgs.contentType){
		 		actualArgs.contentType = appArgs.contentType;
			}
		 	if(appArgs.defectIds){
		 		actualArgs.defectIds = appArgs.defectIds;
			}
			if(appArgs.resolveDefects){
				actualArgs.resolveDefects = appArgs.resolveDefects;
			}
			if(appArgs.testCase){
				actualArgs.testCase = appArgs.testCase;
			}
			if(appArgs.testcaseStateId){
				actualArgs.testcaseStateId = appArgs.testcaseStateId;
			}
			if(appArgs.phase){
				actualArgs.phase = appArgs.phase;
			}
			if(appArgs.newExecutionResult){
				actualArgs.newExecutionResult = appArgs.newExecutionResult;
			}
			if(appArgs.owner){
				actualArgs.owner = appArgs.owner;
			}
			if(appArgs.uuid_er)
				actualArgs.uuid_er = appArgs.uuid_er;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;
			if(appArgs.stepItemId)
                actualArgs.stepItemId = appArgs.stepItemId;
			if(appArgs.elementResultJsonString)
				actualArgs.elementResultJsonString = appArgs.elementResultJsonString;
			if(appArgs.removeDefectIds)
				actualArgs.removeDefectIds = appArgs.removeDefectIds;
			if(appArgs.iterations)
				actualArgs.iterations = appArgs.iterations;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		if(appArgs.skipStepUpdate){
			actualArgs.skipStepUpdate = true;
		}
		if(appArgs.actualResult){
			actualArgs.actualResult = appArgs.actualResult;
		}
		if(appArgs.buildRecordItemId){
			actualArgs.buildRecordItemId = appArgs.buildRecordItemId;
		}
		if(appArgs.buildId){
			actualArgs.buildId = appArgs.buildId;
		}
		if(appArgs.removeBuildLink != null){
			actualArgs.removeBuildLink = appArgs.removeBuildLink;
		}
		if(appArgs.uuids){
			actualArgs.uuids = appArgs.uuids;
		}
		if(appArgs.stateIds){
			actualArgs.stateIds = appArgs.stateIds;
		}
		if(appArgs.comment){
			actualArgs.comment = appArgs.comment;
		}
		if(appArgs.compare){
			actualArgs.compare = appArgs.compare;
		}
		if(appArgs.elementApplyAllJsonString){
			actualArgs.elementApplyAllJsonString = appArgs.elementApplyAllJsonString;
		}
		actualArgs.isWebUI = true;
		
		var serviceRequest= new ServiceRequest(this.EXECUTION_RESULT_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getExecutionResult: function(serviceResponseHandler, workItemId) {
		this._invokeService(serviceResponseHandler, "getExecutionResult", {workItemId: workItemId});
	},
	
	getExecutionResultDTOs: function(serviceResponseHandler, args) {
		var params = {};
		if(args)
			params = args;
		this._invokeService(serviceResponseHandler, "getExecutionResultDTOs", params);
	},
	
	getExecutionResultSummaryDTOs: function(serviceResponseHandler, args) {
		var params = {};
		if(args)
			params = args;
		this._invokeService(serviceResponseHandler, "getExecutionResultSummaryDTOs", params);
	},
	
	getExecutionResultDTO: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getExecutionResultDTO", params);
	},
	
	postApplyResult: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "postApplyStep", params);
	},
	
	postDeleteResult: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postDeleteResult", params);
	},
	
	postExecutionResult: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postExecutionResult", params);
	},
	
	postExecutionResultDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postExecutionResultDTO", params);
	},
	
	postUpdateStep: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postUpdateStep", params);
	},

	archiveExecutionResult: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postArchiveER", params);
	},
    getAllSearchResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        var serviceRequest= new ServiceRequest(this.EXECUTION_RESULT_SERVICE_URI, "getAllItemHandles", args);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
    },          
	searchAllResults: function(serviceResponseHandler, params) {
        /*
            VALID PARAMETERS
            --------------------------------
            String processArea;         //itemId
            String name;                    
            String[] ownerUUIDs;        //itemId
            String[] stateIds;          // eg. 'com.ibm.rqm.state.new'
            boolean myItemsOnly = false;
            boolean includeArchived = false;
            String policy;              //'enforce', 'truncate', 'ignore'  
            String textSearch;
        */         
        params = params ? params : {};
        if (!params.processArea) {
            params.processArea = getCurrentPA().itemId;
        }   
        var serviceRequest= new ServiceRequest(this.EXECUTION_RESULT_SERVICE_URI, "getPagedSearchResult", params);
        TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);		
    }

};	
})();
