/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient = {

	RESULT_STATE_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.IExecutionResultStateRestService",

	_invokeService: function(responseHandler, method, args) {
		if (args && !args.projectAreaItemId) {
			args.projectAreaItemId = getCurrentPA().itemId;
		}		
		var serviceRequest= new ServiceRequest(this.RESULT_STATE_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getExecutionResultStates: function(serviceResponseHandler, args) {
		this._invokeService(serviceResponseHandler, "getExecutionResultStatesDTO", args);
	},
	
    postExecutionResultState: function(serviceResponseHandler, args) {
        this._invokeService(serviceResponseHandler, "postExecutionResultStateDTO", args);
    }
	
};

})();
