/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient = {

	TEST_SCRIPT_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IRemoteExecutionScriptRestService",

	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.newScript) {
				actualArgs.newScript = appArgs.newScript;
			}			
			if (appArgs.newItem) {
				actualArgs.newScript = appArgs.newItem;
			}				
			if(appArgs.id) {
				actualArgs.id = appArgs.id;
			}
			if(appArgs.itemId) {
				actualArgs.itemId = appArgs.itemId;
			}
			if(appArgs.versionableItemId) {
				actualArgs.versionableItemId = appArgs.versionableItemId;
			}

			if(appArgs.stateId) {
				actualArgs.stateId = appArgs.stateId;
			}			
			if(appArgs.name) {
				actualArgs.name = appArgs.name;
			}
			if(appArgs.ownerId) {
				actualArgs.ownerId = appArgs.ownerId;
			}			
			if(appArgs.description) {
				actualArgs.description = appArgs.description;
			}
			if(appArgs.state) {
				actualArgs.state = appArgs.state;
			}																	
			if(appArgs.type) {
				actualArgs.type = appArgs.type;
			}
			if(appArgs.properties)
			{
				actualArgs.propertiesJsonString = dojo.toJson(appArgs.properties);
			}
			if(appArgs.uuid)
			{
				actualArgs.uuid = appArgs.uuid;
			}
			if(appArgs.supportUniqueName)
			{
				actualArgs.supportUniqueName = appArgs.supportUniqueName;
			}
			if(appArgs.uuid_script)
				actualArgs.uuid_script = appArgs.uuid_script;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;
			
			if(appArgs.managedByAdapter == true || appArgs.managedByAdapter == false)
				actualArgs.managedByAdapter = appArgs.managedByAdapter;
			if(appArgs.adapterId)
				actualArgs.adapterId = appArgs.adapterId;
			if(appArgs.fullPath)
				actualArgs.fullPath = appArgs.fullPath;
			if(appArgs.relativePath)
				actualArgs.relativePath = appArgs.relativePath;
			if(appArgs.sharePrefix)
				actualArgs.sharePrefix = appArgs.sharePrefix;
			if(appArgs.workItemsJsonString)
				actualArgs.workItemsJsonString = appArgs.workItemsJsonString;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		
		var serviceRequest= new ServiceRequest(this.TEST_SCRIPT_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	saveScript: function(serviceResponseHandler, scriptObject) {
		this._invokeService(serviceResponseHandler, "postExecutionScriptDTO", scriptObject);
	},
	
	getExecutionScripts: function(serviceResponseHandler, scriptObject) {
		this._invokeService(serviceResponseHandler, "getExecutionScriptsDTO", scriptObject);
	},
	
	archiveTestScript: function(serviceResponseHandler, archiveArgs) {
		this._invokeService(serviceResponseHandler, "postArchiveTestScript", archiveArgs);
	}
	
};

})();
