/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var WorkItemUtils          = com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient= {

	TEST_SUITE_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.ITestExecutionSuiteRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			
			if(appArgs.ids)
                actualArgs.ids = appArgs.ids;			
			if(appArgs.name)
				actualArgs.name = appArgs.name;
			if(appArgs.owner)
				actualArgs.owner = appArgs.owner;
			if(appArgs.ownerId)
			    actualArgs.ownerId = appArgs.ownerId;
			if(appArgs.name)
				actualArgs.name = appArgs.name;								
			if(appArgs.id)
				actualArgs.id = appArgs.id;								
			if(appArgs.originator)
				actualArgs.originator = appArgs.originator;
			if(appArgs.description != null)
				actualArgs.description = appArgs.description;	
			
			if(appArgs.externalId)
				actualArgs.externalId = appArgs.externalId;
			if(appArgs.suiteElementsJsonString)
				actualArgs.suiteElementsJsonString = appArgs.suiteElementsJsonString;	
			if(appArgs.addRresultGroups)
				actualArgs.addRresultGroups = appArgs.addRresultGroups;	
			if(appArgs.removeResultGroups)
				actualArgs.removeResultGroups = appArgs.removeResultGroups;	
			if(appArgs.newTestExecutionSuite)
				actualArgs.newTestExecutionSuite = appArgs.newTestExecutionSuite;	
			if(appArgs.itemId)
				actualArgs.itemId = appArgs.itemId;
			if(appArgs.ewiId)
				actualArgs.ewiId = appArgs.ewiId;
			if(appArgs.resultGroupId)
				actualArgs.resultGroupId = appArgs.resultGroupId;
			if(appArgs.uuid_ts)
				actualArgs.uuid_ts = appArgs.uuid_ts;			
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;
			if(appArgs.testSuiteId)
				actualArgs.testSuiteId = appArgs.testSuiteId;
			if(appArgs.startTime)
				actualArgs.startTime = appArgs.startTime;		
			if(appArgs.suiteElementsJsonString)
				actualArgs.suiteElementsJsonString = appArgs.suiteElementsJsonString;	
			if(appArgs.endTime)
				actualArgs.endTime = appArgs.endTime;
			if(appArgs.stateId)
				actualArgs.stateId = appArgs.stateId;
			if(appArgs.isSerialExecution == true || appArgs.isSerialExecution == false)
				actualArgs.isSerialExecution = appArgs.isSerialExecution;
			if(appArgs.sectionJsonString)
				actualArgs.sectionJsonString = appArgs.sectionJsonString;
			if(appArgs.workItemsJsonString)
				actualArgs.workItemsJsonString = appArgs.workItemsJsonString;
			if(appArgs.sectionsOrder)
				actualArgs.sectionsOrder = appArgs.sectionsOrder;
			if(appArgs.sectionsRemoved)
				actualArgs.sectionsRemoved = appArgs.sectionsRemoved;
			if(appArgs.state)
				actualArgs.state = appArgs.state;
			if(appArgs.teamAreaItemId)
				actualArgs.teamAreaItemId = appArgs.teamAreaItemId;
			if(appArgs.projectAreaItemId)
				actualArgs.projectAreaItemId = appArgs.projectAreaItemId;
			if(appArgs.reservationUUIDs)
				actualArgs.reservationUUIDs = appArgs.reservationUUIDs;
			if(appArgs.createSnapshot) {
				actualArgs.createSnapshot = appArgs.createSnapshot;
			}
			if(appArgs.snapshotName) {
				actualArgs.snapshotName = appArgs.snapshotName;
			}
			if(appArgs.snapshotDescription) {
				actualArgs.snapshotDescription = appArgs.snapshotDescription;
			}
			if(appArgs.snapshotContent) {
				actualArgs.snapshotContent = appArgs.snapshotContent;
			}
			if(appArgs.revision) {
				actualArgs.revision = appArgs.revision;
			}
			if(appArgs.includeSnapshots == true || appArgs.includeSnapshots == false){
				actualArgs.includeSnapshots = appArgs.includeSnapshots;
			}
			if(appArgs.uuid) {
				actualArgs.uuid = appArgs.uuid;
			}

			if(appArgs.uid) {
				actualArgs.uid = appArgs.uid;
			}

			if(appArgs.resolveWorkItems == true || appArgs.resolveWorkItems == false){
				actualArgs.resolveWorkItems = appArgs.resolveWorkItems;
			}
			
			if(appArgs.resolvePlan == true || appArgs.resolvePlan == false){
				actualArgs.resolvePlan = appArgs.resolvePlan;
			}
			if(appArgs.resolveMinimalPlan == true || appArgs.resolveMinimalPlan == false){
				actualArgs.resolveMinimalPlan = appArgs.resolveMinimalPlan;
			}
			if(appArgs.resolveCurrentResult == true || appArgs.resolveCurrentResult == false){
				actualArgs.resolveCurrentResult = appArgs.resolveCurrentResult;
			}
			if(appArgs.resolveCurrentResultElements == true || appArgs.resolveCurrentResultElements == false){
				actualArgs.resolveCurrentResultElements = appArgs.resolveCurrentResultElements;
			}

			if(appArgs.resolveFullCurrentResult == true || appArgs.resolveFullCurrentResult == false){
				actualArgs.resolveFullCurrentResult = appArgs.resolveFullCurrentResult;
			}
			if(appArgs.resolveSection == true || appArgs.resolveSection == false){
				actualArgs.resolveSection = appArgs.resolveSection;
			}
			if(appArgs.resolveElements == true || appArgs.resolveElements == false){
				actualArgs.resolveElements = appArgs.resolveElements;
			}

			if(appArgs.includeArchived == true || appArgs.includeArchived == false){
				actualArgs.includeArchived = appArgs.includeArchived;
			}
			if(appArgs.resolveElementsResult == true || appArgs.resolveElementsResult == false){
				actualArgs.resolveElementsResult = appArgs.resolveElementsResult;
			}
			if(appArgs.resolveElementsFullResult == true || appArgs.resolveElementsFullResult == false){
				actualArgs.resolveElementsFullResult = appArgs.resolveElementsFullResult;
			}
			if(appArgs.resolveElementsRequest == true || appArgs.resolveElementsRequest == false){
				actualArgs.resolveElementsRequest = appArgs.resolveElementsRequest;
			}
			if(appArgs.resolveElementsTestcase == true || appArgs.resolveElementsTestcase == false){
				actualArgs.resolveElementsTestcase = appArgs.resolveElementsTestcase;
			}
			if(appArgs.resolveElementFullTestase == true || appArgs.resolveElementFullTestase == false){
				actualArgs.resolveElementFullTestase = appArgs.resolveElementFullTestase;
			}
			if(appArgs.resolveFlattenedTestCase == true || appArgs.resolveFlattenedTestCase == false){
				actualArgs.resolveFlattenedTestCase  = appArgs.resolveFlattenedTestCase ;
			}
			if(appArgs.resolveCategory == true || appArgs.resolveCategory == false){
				actualArgs.resolveCategory  = appArgs.resolveCategory ;
			}
			if(appArgs.categories){
				actualArgs.categories = appArgs.categories;
			}
            if(appArgs.category){
                actualArgs.category = appArgs.category;
            }
            if(appArgs.categoryType){
                actualArgs.categoryType = appArgs.categoryType;
            }
			if(appArgs.versionedTestPlanItemId){
				actualArgs.versionedTestPlanItemId = appArgs.versionedTestPlanItemId;
			}
			if(appArgs.removePlan == true || appArgs.removePlan == false){
				actualArgs.removePlan = appArgs.removePlan;
			}
            // paging parameters
            if(appArgs.queryToken) {
                actualArgs.queryToken = appArgs.queryToken; 
            }       
            if(appArgs.page) {
                actualArgs.page = appArgs.page; 
            }       
            if(appArgs.pageSize) {
                actualArgs.pageSize = appArgs.pageSize; 
            }       
            if(appArgs.sortColumns) {
                actualArgs.sortColumns = appArgs.sortColumns; 
            }           
            if(appArgs.kindOfHandles) {
                actualArgs.kindOfHandles = appArgs.kindOfHandles; 
            }           
            if(appArgs.statusIds) {
                actualArgs.statusIds = appArgs.statusIds; 
            }           
            if(appArgs.modifiedFrom) {
                actualArgs.modifiedFrom = appArgs.modifiedFrom; 
            }           
            if(appArgs.modifiedTo) {
                actualArgs.modifiedTo = appArgs.modifiedTo; 
            }           
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.TEST_SUITE_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getTestExecutionSuites: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getTestExecutionSuites", params);
	},

    getTestExecutionSuiteRevision: function(serviceResponseHandler, suiteId, aRevision){
        var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        this._invokeService(actualHandler, "getTestExecutionSuiteDTOs", {
            uid: suiteId,
            revision: aRevision
        });
     },

	getTestExecutionSuiteDTOs: function(serviceResponseHandler, params ){
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "getTestExecutionSuiteDTOs", params);
	},
	
	getTestExecutionSuiteSummaryDTOs: function(serviceResponseHandler, params ){
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "getTestExecutionSuiteSummaryDTOs", params);
	},
	
	getTestExecutionSuiteMinimalSummaryDTOs: function(serviceResponseHandler, params ){
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "getTestExecutionSuiteMinimalSummaryDTOs", params);
	},
	
    searchTestSuites: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------                
                String processArea;         //project area itemId
                public int id;
                String name;
                String[] originatorUUIDs;   //originator itemId
                String[] scriptTypeIds;     //array of registered script type ids
                String[] stateIds;          //eg. 'com.ibm.rqm.planning.common.new'
                public String[] statusIds;
                boolean myItemsOnly;
                boolean includeArchived = false;           
                public Long modifiedFrom;
                public Long modifiedTo;
                String policy;              //'enforce', 'truncate', 'ignore'     
                String queryToken;
                int page;
                int pageSize;
                String[] sortColumns;
                String textSearch;
         */         
        args = args || {};		
        if(!args.projectAreaItemId){
            args.projectAreaItemId = getCurrentPA().itemId;
        }
        if(!args.processArea){
            args.processArea = getCurrentPA().itemId;
        }
        var serviceRequest= new ServiceRequest(this.TEST_SUITE_SERVICE_URI, "getPagedSearchResult", args);
        return TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);		
    },  	

    getAllSearchResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        return this._invokeService(serviceResponseHandler, "getAllItemHandles", args);
    },          
	
	postBulkChangeTestSuite: function (serviceResponseHandler, params )
	{
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        this._invokeService(actualHandler, "postBulkChangeTestSuiteDTO", params);
	},
	
	postTestExecutionSuite: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postTestExecutionSuite", params);
	},
	
	postTestExecutionSuiteDTO: function(serviceResponseHandler, params )
	{
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "postTestExecutionSuiteDTO", params);
	},
	
	archiveTestExecutionSuite: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postArchiveTS", params);
	},
		
	postExecute: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postExecute", params);
	},

	getSnapshots: function(serviceResponseHandler, params)
	{
		if ( !params ) params = { };
		return this._invokeService(serviceResponseHandler, "getSnapshots", params);
	},
	
    getWorkItemMappingHandler: function(responseHandler) {
        var internalHandler = {
            success: function(testSuiteDTOs){
                //fixup each workitem for each test case
				if (dojo.isArray(testSuiteDTOs)) {
					testSuiteDTOs = WorkItemUtils.fixupArtifactsWorkItems(testSuiteDTOs);
				} else if (dojo.isObject(testSuiteDTOs)) {
					testSuiteDTOs = WorkItemUtils.fixupArtifactWorkItems(testSuiteDTOs);
				}
                responseHandler.doCallback(testSuiteDTOs);
            },
            failure: function(error){
                responseHandler.doErrorCallback(error);
            }
        };
        var handler = new ServiceResponseHandler(internalHandler, "success", "failure");
        return handler;
    }	
	
};

})();