/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.executionframework.ResourceClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
com.ibm.rqm.execution.web.client.internal.executionframework.ResourceClient= {

	RESOURCE_BROWSER_SERVICE_URI: "com.ibm.rqm.executionframework.common.service.rest.IResourceBrowserRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
		
			if(appArgs.dataStorePath)	
				actualArgs.dataStorePath = appArgs.dataStorePath;
			if(appArgs.fileShareProtocol)	
				actualArgs.fileShareProtocol = appArgs.fileShareProtocol;
			if(appArgs.resourceType)
				actualArgs.resourceType = appArgs.resourceType;
			if(appArgs.projectArea)
				actualArgs.projectArea = appArgs.projectArea;
			if(appArgs.isFilterByExtensionDisabled == true || appArgs.isFilterByExtensionDisabled == false)
				actualArgs.isFilterByExtensionDisabled = appArgs.isFilterByExtensionDisabled;
			if(appArgs.filterExtension)
				actualArgs.filterExtension = appArgs.filterExtension;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}	
		var serviceRequest= new ServiceRequest(this.RESOURCE_BROWSER_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getResourcesInfo: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getResourcesInfo", params);
	},
	
	getIsShareAccessible: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getIsShareAccessible", params);
	}
	
};

})();
