/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// transforms summary DTO to a full DTO
	map: function(summaryDTO) {
		// script
		var script = {id: summaryDTO.scriptId, name: summaryDTO.scriptName};
		summaryDTO.script = script;
		summaryDTO.scriptId = null;
		summaryDTO.scriptName = null;
		
		if(summaryDTO.scriptTypeId){
			var scriptType= {id: summaryDTO.scriptTypeId, name: summaryDTO.scriptTypeName};
			script.scriptType= scriptType;
			script.versionableItemId = summaryDTO.scriptVersionableItemId;
			summaryDTO.scriptTypeId = null;
			summaryDTO.scriptTypeName = null;
		}
		
		// test case
		var testCase = {id: summaryDTO.testCaseId, name: summaryDTO.testCaseName};
		summaryDTO.testCase = testCase;
		summaryDTO.testCaseId = null;
		summaryDTO.testCaseName = null;
		
		// state
		if (summaryDTO.state != null) {
			var stateId = summaryDTO.state;
			summaryDTO.state = { name : summaryDTO.stateName, id: stateId};
			summaryDTO.stateName = null;
		}
		if (summaryDTO.testPlanName != null) {
			summaryDTO.testPlan = { name : summaryDTO.testPlanName, id:summaryDTO.testPlanId};
			summaryDTO.testPlanName = null;
			summaryDTO.testPlanId = null;
		}
		
		return summaryDTO;
	}
	
});