/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.mapper.TestScriptMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper");

dojo.declare("com.ibm.rqm.planning.web.client.internal.mapper.TestScriptMapper",
             com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper, {
			 	
	// maps a summary DTO to a full DTO
	// optimus prime time.  transform summary DTO to look like a real DTO. 
	map: function(summaryDTO) {
		
		// snapshot info
		if (summaryDTO.snapshotInfoRevision != null ) {
			summaryDTO.snapshotInfo = { 
                revision: summaryDTO.snapshotInfoRevision,
				name: summaryDTO.snapshotInfoName
			};
			delete summaryDTO.snapshotInfoRevision;
			if (summaryDTO.snapshotInfoName) {
				delete summaryDTO.snapshotInfoName;
			}
		}
		summaryDTO.scriptType = {};
		summaryDTO.scriptType.id = summaryDTO.scriptTypeId;
		summaryDTO.scriptType.name = summaryDTO.scriptTypeName;
		delete summaryDTO.scriptTypeName;
		delete summaryDTO.scriptTypeId;
		
		return summaryDTO;
	}
	
});