/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient = {
    
	SEQUENCE_SERVICE_URI: "com.ibm.rational.test.lm.sequencer.common.service.rest.IExecutionSequenceRestService",
    SEQUENCE_SEARCH_SERVICE_URI: "com.ibm.rational.test.lm.sequencer.common.service.rest.IExecutionSequenceSearchRestService",
	
	_invokeService: function(responseHandler, method, args, isSeqSearch) {
		if (args && !args.projectArea) {
			args.projectArea = getCurrentPA().itemId;
		}
        var uri = (isSeqSearch) ? this.SEQUENCE_SEARCH_SERVICE_URI : this.SEQUENCE_SERVICE_URI;
		var serviceRequest= new ServiceRequest(uri, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getExecutionSequencesDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequencesDTO", args);
	},

	getExecutionSequencesSummaryDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequencesSummaryDTO", args);
	},
	
	getExecutionSequenceResultsDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequenceResultsDTO", args);
	},
	
	getExecutionSequenceResultsSummaryDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "getExecutionSequenceResultsSummaryDTO", args);
	},
	
	postExecutionSequenceDTO: function(responseHandler, args){
		this._invokeService(responseHandler, "postExecutionSequenceDTO", args);
	},
	
	postArchiveExecutionSequence: function(responseHandler, args){
		this._invokeService(responseHandler, "postArchiveExecutionSequence", args);
	},
	searchExecutionSequences:function(responseHandler, args){
        /*
         valid parameters:
            public String projectArea;
            public String name;
            String queryToken;
            int page;
            int pageSize;
            String[] sortColumns;
            String textSearch;            
        */
		if ( !args ) args = { };
		this._invokeService(responseHandler, "getPagedSearchResult", args, /* is exe sequence search */true);
	},
    getAllSearchResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'uuid': 'ItemHandle',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        return this._invokeService(serviceResponseHandler, "getAllItemHandles", args, /* is exe sequence search */true);
    },          	
	postCancelRunningExecutionSequence: function(responseHandler, args){
		this._invokeService(responseHandler, "postCancelRunningExecutionSequence", args);
	},
	getBuildRecordsWithStatisticsDTO:function(responseHandler, args){
		this._invokeService(responseHandler, "getBuildRecordsWithStatisticsDTO", args);
	},
    getAllSearchBuildRecordResultItemIds: function(serviceResponseHandler, args)
    {
        /*
                VALID PARAMETERS
                --------------------------------
                String queryToken;
                String idType;
         */         
        var typeMap = {
            'id': 'Id',
            'itemId': 'ItemHandle',
            'versionableItemId': 'VersionedItemHandle'
        };
        var type = args.kindOfHandles;
        args.kindOfHandles = typeMap[type];
        return this._invokeService(serviceResponseHandler, "getAllItemHandles", args);
    },              

    getSearchBuildRecordsWithStatistics:function(responseHandler, args){
        /*
         valid parameters:
            public String projectArea;
            public String name;
            public String description;
            public String[] statusIds;
            public String[] stateIds;
            public String[] bvtStatus;
            public int buildDefId;
            public Long completionFrom;
            public Long completionTo;
            public boolean includeArchived = false;
            public String policy;
            String queryToken;
            int page;
            int pageSize;
            String[] sortColumns;
            String textSearch;            
        */
        this._invokeService(responseHandler, "getPagedSearchResult", args);
    }
};

})();
