/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function(){
    var checkNotNull = net.jazz.ajax.toolbox.lang.checkNotNull;
    var checkNotEmpty = net.jazz.ajax.toolbox.lang.checkNotEmpty;
    var findIf = net.jazz.ajax.toolbox.lang.findIf;
    var removeIf = net.jazz.ajax.toolbox.lang.removeIf;
    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
    //    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    
    com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient = {
        TESTSCHEDULE_SERVICE_URI: "com.ibm.rqm.process.common.service.rest.ITestScheduleRestService",
        TESTPHASE_SERVICE_URI: "com.ibm.rqm.process.common.service.rest.ITestPhaseRestService",
        
        _invokeService: function(responseHandler, serviceURI, method, appArgs){
            var actualArgs = {};
            if (appArgs) {
                var jsonArgs = dojo.toJson(appArgs);
                actualArgs.jsonString = jsonArgs;
                
				if(appArgs.itemId) {
					actualArgs.itemId = appArgs.itemId;
				}
                if (appArgs.name) {
                    actualArgs.name = appArgs.name;
                }
                if (appArgs.description) {
                    actualArgs.description = appArgs.description;
                }
                if (appArgs.startDate) {
                    actualArgs.startDate = appArgs.startDate;
                }
                if (appArgs.endDate) {
                    actualArgs.endDate = appArgs.endDate;
                }
                if (appArgs.testPlanId) {
                    actualArgs.testPlanId = appArgs.testPlanId;
                }
                if (appArgs.owner) {
                    actualArgs.owner = appArgs.owner;
                }
                if (appArgs.tableType) {
                    actualArgs.tableType = appArgs.tableType;
                }
                if (appArgs.operationJson) {
                    actualArgs.operationJson = appArgs.operationJson;
                }
                if (appArgs.phaseDetailJsonString) {
                    actualArgs.phaseDetailJsonString = appArgs.phaseDetailJsonString;
                }
				if (appArgs.expectedTotalPoints) {
					actualArgs.expectedTotalPoints = appArgs.expectedTotalPoints;
				}
            }
            actualArgs.processArea = getCurrentProjectArea().itemId;
            var serviceRequest = new ServiceRequest(serviceURI, method, actualArgs);
            TeamServerClient.invokeService(serviceRequest, responseHandler);
        },
        
        postTestPhase: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "postTestPhase", args);
        },
        getTestPhases: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "getTestPhases", args);
        },
        getTestPhasesDTO: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "getTestPhasesDTO", args);
        },
        getTestPhasesSummaryDTO: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "getTestPhasesSummaryDTO", args);
        },
        getKeyDatesDTO: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "getKeyDatesDTO", args);
        },
        postDeleteTestPhase: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "postDeleteTestPhase", args);
        },
        postUpdateTestPhase: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "postUpdateTestPhase", args);
        },
        postBatchUpdate: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTPHASE_SERVICE_URI, "postBatchUpdate", args);
        },
        
        postTestSchedule: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTSCHEDULE_SERVICE_URI, "postTestSchedule", args);
        },
        postDeleteSchedule: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTSCHEDULE_SERVICE_URI, "postDeleteSchedule", args);
        },
        getTestSchedules: function(servicerResponseHandler, args){
            this._invokeService(servicerResponseHandler, this.TESTSCHEDULE_SERVICE_URI, "getTestSchedules", args);
        },
        getTestSchedulesDTO: function(serviceResponseHandler, args){
            this._invokeService(serviceResponseHandler, this.TESTSCHEDULE_SERVICE_URI, "getTestSchedulesDTO", args);
        }
    }
    
})();

