/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.rqm.defects.web.spi.DefectsProvider");

dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function() {

var Status					= com.ibm.team.repository.web.foundation.Status;
var DefectsUIUtil           = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;

dojo.declare("com.ibm.rqm.defects.web.spi.DefectsProvider", null, {
	
	_providerId: null,
	_providerName: null,

	constructor: function(id, name) {
		this._providerId= id;
		this._providerName= name;	
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getProviderId: function() {
		return this._providerId;
	},
	
	getProviderName: function() {
		return this._providerName;
	},

	getConnectionName: function() {
		return null;
	},

	getConnectionDetails: function() {
		return null;
	},
	
	clearConnectionDetails: function() {

	},

	checkProviderStatus: function(resultCallback, cancelIfNotNotLoggedIn) {
		resultCallback(Status.OK_STATUS);
	},

	needsConfiguration: function() {
		return false;
	},

	isConfigured: function() {
		return true;
	},
	
	getConfigurationWizard: function() {
		return null;
	},
	
	initialize: function(runAfterInitialization) {
		runAfterInitialization();
	},
	
	createDefect: function(linkType, itemIdOrUriArray, defectDescription, monitor, runAfterCreation) {
		throw new Error(DefectsUIUtil.getMessage("labelNoCreateDefect", this._providerId));
	},
	
	deleteDefect: function(draftUri, ewiItemId, monitor, runAfterCreation) {
		throw new Error(DefectsUIUtil.getMessage("labelNoDeleteDefect", this._providerId));
	},
	
	changeBlockingDefect: function(draftUri, resultItemId, blocking, monitor, runAfterCreation) {
		throw new Error(DefectsUIUtil.getMessage("labelNoCreateDefect", this._providerId));
	},
	
	queryExistingDefects: function(query, monitor, runAfterQuery) {
		throw new Error(DefectsUIUtil.getMessage("labelNoQueryExistingDefects", this._providerId));
	},

	queryAssociatedDefects: function(linkType, isExecutionResultRelated, itemIdOrUriArray, monitor, runAfterQuery) {
		throw new Error(DefectsUIUtil.getMessage("labelNoQueryAssociatedDefects", this._providerId));
	},

	associateDefect: function(linkType, linkDescription, monitor, runAfterAssociation) {
		throw new Error(DefectsUIUtil.getMessage("labelNoAssociateDefect", this._providerId));
	},
	
	unassociateDefect: function(linkType, itemIdOrURI, defectURIArray, isExecResultRelated, monitor, runAfterAssociation) {
		throw new Error(DefectsUIUtil.getMessage("labelNoUnassociateDefect", this._providerId));
	},
		
	// ---- spi ------------------------------------------------------------------------------------------------------------	

	__sentinel: null // terminates this class definition
});

})();
