/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

var RedisplayThreshold = 2000; // 2 sec.

(function() { //module container
    dojo.declare("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper",
        com.ibm.team.repository.web.transport.ServiceResponseHandler, {
        
        // class static attribute.
        LastInvoked: {time: null},

        // copied from Utility to avoid additional dependency here.
        printException: function(methodName, e) {
            console.debug("Exception caught in " + this.declaredClass + methodName);
            if(e) {
                if (dojo.isObject(e)) {
                    for (var i in e) {
                        console.debug(i + ": " + e[i]);
                    }
                }
                else if(dojo.isString(e)) {
                    console.debug(e);
                }
            }
        },
        
        doCallback: function(returnVal) {
            // avoid browser popping up client script errors. Silently
            // print out the error. The user may have closed a view/tab
            // before the content is returned, etc. Showing the error
            // to the user after the fact is really not that useful.
            try {
                this.inherited(arguments);
            }
            catch(e) {
                this.printException("#doCallback", e);
            }
        },
            
        // override the error call back to put up an alert dialog if the server seems to be down
        doErrorCallback: function(errorObj) {
            if (!errorObj.exception &&
                ((errorObj.status == 0) || (errorObj.status == 12029)) && // 12029 is used by IE for cannot connect
                (!errorObj.message ||
                (errorObj.message.indexOf("Unknown") >= 0) ||  // "Unknown" is used by IE
                (errorObj.message.indexOf("bad http response") >= 0))) {
                
                // avoid consecutive popups of the same alert. Put in a threshold for
                // displaying the dialog again. If the error came within the threshold,
                // don't show the alert.
                var display = true;
                if(this.LastInvoked.time) {
                    var now = new Date();
                    if((now.getTime() - this.LastInvoked.time.getTime()) < RedisplayThreshold) {
                        display = false;
                    }
                }
                // use javascript alert just in case the server is so down that
                // it can't create the alert dialog
                if (display) {
                    alert(MessageUtil.getMessage(MessageBundle.COMMON, "serverMsgMaybeDown"));
                    this.LastInvoked.time = new Date();
                }
            }
            com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper.superclass.doErrorCallback.apply(this, arguments);
        }
    })
})();