/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.config.BuildPageRepository");

dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.wizard.WizardPage");
dojo.require("dijit._Templated");

dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox");

dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");

(function(){

var BuildUiUtil = com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.config.BuildPageRepository", 
			 [com.ibm.rqm.buildintegration.web.ui.internal.wizard.WizardPage, dijit._Templated], {

	labelURL: BuildUiUtil.getMessage("labelURL"),
	labelName: BuildUiUtil.getMessage("labelName"),
	labelDescription: BuildUiUtil.getMessage("labelDescription"),
	labelRepositoryURLInvalid: BuildUiUtil.getMessage("labelRepositoryURLInvalid"),
	labelRepositoryNameRequired: BuildUiUtil.getMessage("labelRepositoryNameRequired"),

	_context: null,

	_rootNode: null,
	_repoUrl: null,
	_repoName: null,
	_repoDescription: null,

	constructor: function() {
	},

	// ---- WizardPage implementation --------------------------------------------------------------------------------------	

	getContentNode: function() {
		return this._rootNode;
	},
	
	aboutToHide: function() {
		this._context.url= this._repoUrl.value;
		this._context.name= this._repoName.value;
		this._context.description= this._repoDescription.value;
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.rqm.buildintegration.web", "ui/internal/config/templates/BuildPageRepository.html"),
	widgetsInTemplate: true,

	postCreate: function() {
		this._repoUrl.value= this._context.url;
		this._repoName.value= this._context.name;
		this._repoDescription.value= this._context.description;
		this._update();
		
		this.connect(this._repoUrl, "onkeyup", "_update");
		this.connect(this._repoName, "onkeyup", "_update");
		this.connect(this._repoDescription, "onkeyup", "_update");
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_update: function() {
		this.setPageComplete(this._repoUrl.value.length > 0 && this._repoName.value.length > 0);
	},

	__sentinel: null // terminates this class definition
});

com.ibm.rqm.buildintegration.web.ui.internal.config.BuildPageRepository.create= function(context) {
	var args= com.ibm.rqm.buildintegration.web.ui.internal.wizard.WizardPage.constructorArgs(BuildUiUtil.getMessage("labelRepository"), BuildUiUtil.getMessage("labelSpecifyRTCServer"));
	dojo.mixin(args, {
		_context: context
	});
	return new com.ibm.rqm.buildintegration.web.ui.internal.config.BuildPageRepository(args, null);
};

})();
