/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation  2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

 //
 // Summary:
 //    Handles the Duplciate Menu and its selection handler
 //


dojo.provide("com.ibm.rqm.planning.web.ui.internal.model.action.PrintPDFAction");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.AbstractAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("dijit.Menu");			  

(function()
{
	var CopyClient = com.ibm.rqm.planning.web.client.internal.CopyClient;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;	
	var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
	var AbstractAction = com.ibm.rqm.planning.web.ui.internal.model.action.AbstractAction;	
	var Widget = dojo.widget;
	var PrintPDFAction = com.ibm.rqm.planning.web.ui.internal.model.action.PrintPDFAction;
	var ActionEntityType = com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;


	var ProgressMonitor = {};	
	ProgressMonitor.TASK_SIZE = 100;			
		
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.model.action.PrintPDFAction", AbstractAction, {
		_history: false,
		_recursion: false,
		_partialRecursion: false,
		_printType: "testplan",
			
       constructor: function(args){
		},
		
	   setType: function()
	   {
	   	
	   },
	   
	   
	   execute: function(idArray, completeCallback, errorCallback)
	   {
			var projectAlias = Utility.getCurrentProjectAreaAlias();
	   		var id = idArray[0];   //This PDF print only works on single artifacts so just take the 0th id
			var identifier = this._printType + "/urn:com.ibm.rqm:" + this._printType +":"+ id;
			var locale = Utility.getSupportedLocale();
			
			var data = "<printReq><mimeType>application/pdf</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			data += "<resource>";
			data += "<identifier>" + identifier + "</identifier>";
			data += "<transformArgs>";
			var url = window.location.href;
			url = url.replace(/&/g,"&amp;");
			data += "<originUrl>" + url + "</originUrl>";
			data += "<reqNumber>0</reqNumber>";
			data += "<componentType>STAND_ALONE</componentType>";
			data += "<printType></printType>";
			data += "<containsTable>0</containsTable>";
			data += "<locale>" + locale + "</locale>";
			data += "<history>" + this._history + "</history>";
			data += "<recursive>" + this._recursion + "</recursive>";
			data += "<partialRecursion>" + this._partialRecursion + "</partialRecursion>";
			data += "</transformArgs>";
			data += "</resource>";
			if (dojo.isIE) {
				data += "<isIE>true</isIE>";
			}
			data += "</resources></printReq>";
			if (printFormDiv == null){
			var printFormDiv = document.createElement("div");
			var printForm = document.createElement("form");
			printForm.setAttribute("name","printViewForm");
			printForm.setAttribute("action","/jazz/secure/service/com.ibm.rqm.xslfo.service.IXSLFOService/" + projectAlias);
			printForm.setAttribute("method","POST");
			var printFormData = document.createElement("input");
			printFormData.setAttribute("name","printData");
			printFormData.setAttribute("type","hidden");
			printFormData.setAttribute("value","");
			printForm.appendChild(printFormData);
			printFormDiv.appendChild(printForm);
			document.body.appendChild(printFormDiv);}
			printFormData.value = data;
			printForm.submit();				
		},
			
		sendPdfPrintRequest: function(rows, type, loc, alias, summary) {
	   		var locale = Utility.getSupportedLocale();
			
    		if (!summary){
	        var mimeTypeVar = "application/pdf";
	        var data = "<printReq><mimeType>"+mimeTypeVar+"</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			for (var i=0; i<rows.length; i++){
				if (type == "datapool") {
					var identifier = type + "/" + rows[i].id;
				} else {
					var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[i].id;
				}
				data += "<resource>";
				data += "<identifier>" + identifier + "</identifier>";
				data += "<transformArgs>";
				data += "<originUrl>" + loc + "</originUrl>";
				data += "<reqNumber>" + i + "</reqNumber>";
				data += "<componentType>STAND_ALONE</componentType>";
				data += "<printType></printType>";
				data += "<containsTable>0</containsTable>";
				data += "<locale>" + locale + "</locale>";
				data += "<history>" + this._history + "</history>";
				data += "</transformArgs>";
				data += "</resource>";
			}
			
			data += "</resources></printReq>";
		}
		else {
	        var mimeTypeVar = "application/pdf";
	        var data = "<printReq><mimeType>"+mimeTypeVar+"</mimeType><fileExtension>pdf</fileExtension>";
			data += "<resources>";
			if (type == "request"){
				var identifier = type + "/RQ"+ rows[0]["visibleId"];
			} else if (type == "datapool") {
				var identifier = type + "/" + rows[0].id;
			} else {
				var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[0].id;
			}
			data += "<resource>";
			data += "<identifier>" + identifier + "</identifier>";
			data += "<transformArgs>";
			data += "<originUrl>" + loc + "</originUrl>";
			data += "<reqNumber>0</reqNumber>";
			data += "<componentType>STAND_ALONE_SUMMARY</componentType>";
			data += "<printType></printType>";
			data += "<containsTable>1</containsTable>";
			data += "<locale>" + locale + "</locale>";
			data += "<history>" + this._history + "</history>";
			data += "</transformArgs>";
			data += "</resource>";
			
			for (var i=1; i<rows.length; i++){
				if (type == "request"){
					var identifier = type + "/RQ"+ rows[i]["visibleId"];
				} else if (type == "datapool") {
					var identifier = type + "/" + rows[i].id;
				} else {
					var identifier = type + "/urn:com.ibm.rqm:" + type +":"+ rows[i].id;
				}
				data += "<resource>";
				data += "<identifier>" + identifier + "</identifier>";
				data += "<transformArgs>";
				data += "<originUrl>" + loc + "</originUrl>";
				data += "<reqNumber>" + i + "</reqNumber>";
				data += "<componentType>SUMMARY</componentType>";
				data += "<printType></printType>";
				data += "<containsTable>1</containsTable>";
				data += "<locale>" + locale + "</locale>";
				data += "<history>" + this._history + "</history>";
				data += "</transformArgs>";
				data += "</resource>";
			}
			if (dojo.isIE) {
				data += "<isIE>true</isIE>";
			}
			data += "</resources></printReq>";
		}
		if (printFormDiv == null){
		var printFormDiv = document.createElement("div");
		var printForm = document.createElement("form");
		printForm.setAttribute("name","printViewForm");
		printForm.setAttribute("action",net.jazz.ajax._contextRoot + "/secure/service/com.ibm.rqm.xslfo.service.IXSLFOService/" + alias);
		printForm.setAttribute("method","POST");
		var printFormData = document.createElement("input");
		printFormData.setAttribute("name","printData");
		printFormData.setAttribute("type","hidden");
		printFormData.setAttribute("value","");
		printForm.appendChild(printFormData);
		printFormDiv.appendChild(printForm);
            document.body.appendChild(printFormDiv);
        }
		printFormData.value = data;
		printForm.submit();
		}	
	});
})();
