/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.module.TestPlanPickerWidget");//$NON-NLS-1$
// declare dependencies on other Dojo modules
dojo.require("com.ibm.rqm.planning.web.ui.internal.module.AbstractSelectionPickerWidget");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){

    var TEST_PLAN_FACTORY_PREFIX = net.jazz.ajax._contextRoot + "/oslc_qm/contexts/";//$NON-NLS-1$
    var TestPlanTableView = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    // declare and implement the widget "class"
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestPlanPickerWidget", com.ibm.rqm.planning.web.ui.internal.module.AbstractSelectionPickerWidget, {
    	getItemType: function() {
			return Constants.getMessage("labelTestPlan");
		}, 
		
        getItemUri: function(versionableItemId){
            if (this.currentProjectArea) {
                var projectAreaId = this.currentProjectArea.itemId;
                return location.protocol + '//' + location.host + TEST_PLAN_FACTORY_PREFIX + projectAreaId + '/resources/com.ibm.rqm.planning.VersionedTestPlan/' + versionableItemId;
            }
            else {
                this._noProjectArea();
            }
        },
        
        getContentWidgetConstructor: function(){
            return TestPlanTableView;
        },
        
        getContentWidgetArgs: function(){
            var tableViewArgs = {
                parent: this,
                testPlans: [],
                showQueryFilters: true,
				isSingleSelect: false,
                enableRowEditable: false,
                editable: false,
                allowChangeSettings: false,
				isInPicker: true
            }
            return tableViewArgs;
        }
    });
    
})();
