/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.QualityManagerApplication");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("jazz.app._JazzApplication");
dojo.require("jazz.core.RegistryFactory");
dojo.require("jazz.core.loader");

dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient");
dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.team.repository.web.ui.internal.LicenseInfoWidget");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorRegistry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ActionBarRegistry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.QMPage");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ServerHealth");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector");


var _JazzApplication       = jazz.app._JazzApplication;
var RepositoryClient       = com.ibm.team.repository.web.client.internal.RepositoryClient;
var AdminClient 		   = com.ibm.team.repository.web.client.internal.AdminClient;
var ServerStatusClient	   = com.ibm.team.repository.web.client.internal.ServerStatusClient; 
var InitializationData     = com.ibm.team.repository.web.client.init.InitializationData;
var LicenseInfoWidget      = com.ibm.team.repository.web.ui.internal.LicenseInfoWidget;
var Session                = com.ibm.team.repository.web.client.session;
var PlatformUI			   = net.jazz.ajax.ui.PlatformUI;

var QMPage				   = com.ibm.rqm.planning.web.ui.internal.page.QMPage;
var NotAuthorized	   	   = com.ibm.rqm.planning.web.ui.internal.page.NotAuthorized;
var ProjectAreaDialog      = com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog;
var DEFAULT_PROJECT_AREA   = "Quality Manager";
var Constants              = com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var PermissionsClient      = com.ibm.asq.common.web.client.internal.PermissionsClient;
var Utility                = com.ibm.asq.common.web.ui.internal.util.Utility;
var ProjectAreaSelector    = com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector;

var checkNotNull    = net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNotEmpty   = net.jazz.ajax.toolbox.lang.checkNotEmpty;
var RegistryFactory = jazz.core.RegistryFactory;

// keys for data retrieved from Jazz's InitializationData 
var INITIALIZER_KEY_CONFIG_PROPS = "com.ibm.team.repository.service.configPropertyInitializer";
var INITIALIZER_KEY_PROJECT_AREAS = "com.ibm.team.process.service.projectAreaWebUIInitializionData";
var INITIALIZER_KEY_CONTRIBUTOR = "com.ibm.team.repository.service.currentContributorInitializer";
var INITIALIZER_KEY_CAN_GRANT_PERMISSION = "com.ibm.team.repository.service.canGrantPermissionInitializer";

var SETUP_URI = "/setup";

function workbenchRootNode(){
	// summary:
	//		helper to get workbench root node
	return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

// After the page loads, the Jazz Ajax Framework instantiates the workbench
// implementation specified in the web bundle's plugin.xml file. After creating
// the workbench implementation instance it calls the implementation's 'init'
// method. Note that the init method must call the parent _Application class's
// 'start' method in order for the workbench to begin normal event processing
// (e.g. watching for changes in the 
// 
// In this example, the extender creates a few top-level UI elements.
dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.QualityManagerApplication", _JazzApplication,
{
	productName: Constants.getMessage("labelRQMTitle"),
    productIconSmall: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/RQM_16.png"),
    productIconLarge: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/RQM_31.png"),
    productTitleImg: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/Rational-Quality-Manager.png"),
    
	constructor: function()
	{
        console.info("entering app constructor")
        // customize UI for RQM
        this.config.usePageRegistry = false;
		this.setName(this.productName);
        this.config.productTitleImg = this.productTitleImg;
		this.config.logout = {
			callback: function(){
				location.href = net.jazz.ajax._contextRoot + "/web/console" } }; //#" } };
        
        this.config.buttons.push({ //create the home button
            label: Constants.getMessage("labelDashboards"),
            iconSrc: this.productIconLarge,
            align: "left",
            href: Utility._getPlanningActionUri("viewUserHome")
        });
 
		//fetch initialization data  
		var srh = new ServiceResponseHandler(this, "success", "_initFailure");
		RepositoryClient.getInitializationData(srh);
		
		var root = document.getElementsByTagName("html")[0];
		root.setAttribute("lang", dojo.locale.split("-")[0]);
        
        // On IE, specifically set the tundra CSS link's media type 
        // to screen. If this CSS is sent to the print media on certain
        // RQM print views, it could crash IE. 
        if (dojo.isIE) {
            var links = document.getElementsByTagName("link");
            for (var i = 0; i < links.length; i++) {
                if (links[i].href && links[i].href.indexOf("tundra") > -1) {
                    links[i].media = "screen";
                }
            }
        }
	},
	
	_initFailure: function(e) {
		//unable to load init data; show error widget (with error message if exists)
		console.error(this.declaredClass + ": unable to load initializationData due to --> " + e.message);
        var args = {};
		if (e && e.message) {
			args.middleText = e.message
		}
		this._loginNotAllowed(args);
	},
	
	success: function(initData)
	{
		//set up all initialization data
		InitializationData._load(initData);
		
		//is the current user an admin
        var canGrantInit = InitializationData.get(INITIALIZER_KEY_CAN_GRANT_PERMISSION);
		this._isJazzAdmin = canGrantInit && canGrantInit.canGrantPermission == true;  
		
		//set up current contributor object
        var contributorInitData = InitializationData.get(INITIALIZER_KEY_CONTRIBUTOR);
        if (contributorInitData != null) {
			var contributor = contributorInitData.currentContributor;
			dojo.setObject(Constants.AUTH_USER_OBJECT_ID, contributor);
            this.config.user = {
                name: contributor.name, 
                userId: contributor.userId,
                href: Session.getUserProfileLink(),
                menuProvider: dojo.hitch(this, this._userMenuProvider)
            };  
            this.config.showLoginLogout = true;
			
			//augment the contributor object with role information
			var handler = {
				success: function(roleResponse) {
					if (roleResponse && roleResponse.roles) {
						contributor.roles = roleResponse.roles;
					}
				},
				failure: function(e) {
					console.warn(this.declaredClass + ": Unable to fetch role information --> " + e ? e.message : "Unknown"); //$NON-NLS$
				}
			}
            var srh = new ServiceResponseHandler(handler, "success", "failure");
            AdminClient.getUserRoles(srh);
						
        } else {
			//server is in a bad state; get server info to display message to user
			var handler = new ServiceResponseHandler(this, "_handleServerInBadState", "_handleServerInBadState");
			ServerStatusClient.getDatabaseStatus(handler);
			return;
		}
		
		//ensure at least one project area exists
		var paData = InitializationData.get(INITIALIZER_KEY_PROJECT_AREAS);
		if (!paData || !paData.projectAreas || paData.projectAreas.length == 0) {
			this._handleProductNotInitialized();
			return;
		}		

        var licenseInfoWidget = new LicenseInfoWidget();
        this.ui.bannerRightText.appendChild(licenseInfoWidget.domNode); 

        // append cjk specific css to the banner's licence info widget 
        if(Utility.isCJKLocale()) {
            dojo.addClass(licenseInfoWidget.domNode, "jazz-app-Navbar-cjk");
            dojo.addClass(this.ui.bannerRightText, "jazz-app-Navbar-cjk");            
        }                

        //store the configuration properties in global vars with corresponding names
        var configProperties = InitializationData.get(INITIALIZER_KEY_CONFIG_PROPS);
        for (var propName in configProperties) {
            var propVal = configProperties[propName];
            dojo.setObject(propName, propVal);
        }
		
        //add the editor registry to the global dojo context 
        var editorRegistry = new com.ibm.rqm.planning.web.ui.internal.util.EditorRegistry();
        dojo.setObject(Constants.EDITOR_REGISTRY_OBJECT_ID, editorRegistry);
		
        //add the action menu registry to the global dojo context 
        var actionRegistry = new com.ibm.rqm.planning.web.ui.internal.util.ActionBarRegistry();
        dojo.setObject(Constants.ACTION_BAR_REGISTRY_OBJECT_ID, actionRegistry);
				
		//check user license / login permissions
        var responseHandler = new ServiceResponseHandler(this, "_setUserProjectAreas", "_loginNotAllowed");        
        PermissionsClient.checkLogin(responseHandler);
	},
	
	_handleServerInBadState: function(status) {
		var message = status && status.code ? status.code + ": " + status.message : "Unknown";
		console.error(message);
		var args = {
			upperText: Constants.getMessage("labelServerError"),
			middleText: message,
			lowerTextPreLink: null,
			lowerTextPostLink: null,			
			showLockIcon: false
		}
		if (this._isJazzAdmin) {
			args.lowerTextPreLink = Constants.getMessage("labelServerErrorAdmin1");
			args.lowerTextPostLink = Constants.getMessage("labelServerErrorAdmin2");
			args.linkText = Constants.getMessage("labelJazzAdminApp");
			args.linkOnClick = function() {
				document.location.href = net.jazz.ajax._contextRoot + "/admin" + document.location.search;
			}			
		} else {
			args.lowerText = Constants.getMessage("labelServerErrorContact");
		}
		var notAuth = new NotAuthorized(args);		
		notAuth._middleText.style.fontSize = "11pt";
	},
	
	_handleProductNotInitialized: function() {
		var args = {
			upperText: Constants.getMessage("msgServerNotInitialized"),
			middleText: Constants.getMessage("labelNoLicenseContact")
		};
		
		//determine if the user has the JazzAdmins role and can run the setup wizard
		if (this._isJazzAdmin) {
			args.middleText = "";
			args.lowerTextPreLink = Constants.getMessage("msgCanPerformSetup");
			args.lowerTextPostLink = ".";
			args.linkText = Constants.getMessage("msgCanPerformSetupLinkText");
			args.linkOnClick = function() {
				document.location.href = net.jazz.ajax._contextRoot + "/setup" + document.location.search;
			}
		}
		var notAuth = new NotAuthorized(args);
	},	
	
	_setUserProjectAreas: function() {
        console.info("success permission data")
        //set user's allowed project areas      
        var projectsInitData = InitializationData.get(Constants.PERMISSIONS_INIT_DATA_KEY);
        var userProjectAreas = projectsInitData ? projectsInitData.userProjectAreas : [];
        dojo.setObject(Constants.USER_PROJECT_AREAS_OBJECT_ID, userProjectAreas);   
		
		//get desired project area from URL
		var path = location.pathname;
		var projectName = path.substring(path.lastIndexOf('/')+1); //$NON-NLS-1$
		
		//if no project area name appended
		if (projectName == 'console') {
            this._determineProjectArea(userProjectAreas);	  
		} else {
	        var decodedName = decodeURIComponent(projectName);
	        decodedName = decodedName.replace(/%3F/g,"?"); //$NON-NLS-1$
	        
	        //find the desired project
	        var project = this._findIn(userProjectAreas, decodedName, "name");
	        if (project != null) {
				//continue with initialization
	            this._checkPermissions(project, false);
	        } else {
				var allProjectAreas = InitializationData.get(INITIALIZER_KEY_PROJECT_AREAS).projectAreas;
				project = this._findIn(allProjectAreas, decodedName, "name");
				if (project == null) {
					//determine redirect behavior based on user's project areas
					this._determineProjectArea(userProjectAreas);  
				} else {
					//user is not allowed to log into the specified project area
				    this._loginNotAllowed({
						upperText: Constants.getMessage('labelUnauthProjectArea', decodedName)
					}); 
				}
			}
		}
    },
	
   /*
    *  Determine the appropriate behavior based on the fact that a project area
    *  was not specified on the URL.  There are 3 paths here:
    *   CONDITION                                       BEHAVIOR
    *   1. User belongs to 0 project areas              Show message indicating no project areas
    *   2. User belongs to exactly 1 project area       Redirect user to that project area
    *   3. User belongs to more than 1 project areas    Prompt user to choose, then redirect
    *   
    */
	_determineProjectArea: function(userProjectAreas) {
        if (!dojo.isArray(userProjectAreas) || userProjectAreas.length == 0) {
            //user doesn't belong to any project areas, show message
            this._loginNotAllowed({
				upperText: Constants.getMessage('labelNoProjectAreas')
			});
        } else if (userProjectAreas.length == 1) {
            //user belongs to exactly 1 project area, redirect to that PA
            this._redirect(userProjectAreas[0], false);         
        } else {
            //user belongs to more than 1 project area, prompt
            var paDlg = new ProjectAreaDialog({
                projectAreas: userProjectAreas,
                onOk: dojo.hitch(this, "_redirect")
            });         
        }		
	},
	
	_redirect: function(projectArea, setDefaultPA) {
		//TODO set new preferences here
		var redirectPath = net.jazz.ajax._contextRoot + "/web/console";
		if (projectArea) {
			redirectPath += "/" + encodeURIComponent(projectArea.name);
		}
		if (location.search) {
			redirectPath +=  location.search;
		}
//		if (location.hash) {
//			redirectPath += location.hash;
//		}
		location.href = redirectPath;
	},
	    
	_checkPermissions: function(projectArea, setDefaultPA)
	{		
		//set the current PA to the PA selected by the user
		if (projectArea && projectArea.itemId) {
			dojo.setObject("com.ibm.team.process.web.projectArea", projectArea);
		} else {
			throw new Error(Constants.getMessage("msgMissingProjectArea", DEFAULT_PROJECT_AREA));
		}	
			
        //this._loginNotAllowed();  //DEBUG ONLY
        var responseHandler = new ServiceResponseHandler(this, "_getCommonUserPreferences", "_initPermissionFailed");        
        PermissionsClient.fetchAndStoreAllPermissions(responseHandler);
		
		//get isProjectAreaAdmin for the current project area
		var handler = {
			success: function(isAdmin) {
				//boolean response from rest service comes back as string
				dojo.setObject(Constants.IS_PROJECT_AREA_ADMIN, (isAdmin == "true"));
			},
			failure: function(error) {
				console.warn("Unable to determine if User is Project Area ADMIN.  Some functions may be disabled.");
				dojo.setObject(Constants.IS_PROJECT_AREA_ADMIN, false);
			}
		}
        var responseHandler = new ServiceResponseHandler(handler, "success", "failure");        
        PermissionsClient.checkIsProjectAreaAdmin(responseHandler);		
	},
    
    _getCommonUserPreferences: function()
    {
        var internalHandlerObj = {
            self: this,
            success: function(response) {
                this.self._preInitRtlm();
            },
            failure: function(e) {
                this.self._preInitRtlm();
            }
        }
        var responseHandler = new ServiceResponseHandler(internalHandlerObj, "success", "failure");
        com.ibm.asq.common.web.client.internal.CommonPreferenceClient.fetchAndStoreUserPreferences(responseHandler);
    },	
	
    _loginNotAllowed: function(args) 
    {
        console.debug(this.declaredClass + ": Can't log in due to license issue.");
		var notAuth = new NotAuthorized(args || {});
    },

    _initPermissionFailed: function() 
    {
        console.debug("Unable to fetch permission information.");
        this._getCommonUserPreferences();
    },
     
    _preInitRtlm: function()
    {
        // initialize rtlm
        var cb = dojo.hitch(this, "_initRtlm");
        jazz.core.loader.load_async("com.ibm.rational.test.lm.web.client.internal.RtlmInitializer", cb);
        this._initAppUI();
    },
    
	_initRtlm: function() 
    {        
		var responseHandler = new ServiceResponseHandler(this, "_initRtlmSuccess", "_initRtlmFailure");
        com.ibm.rational.test.lm.web.client.internal.RtlmInitializer.initializeData(responseHandler);
    },
	
	_initRtlmSuccess: function(response) {
        //console.debug("initialized catalog successfully from QMApplication!");
	},
	
	// Major hack. Get rid of the default context switcher and drop ours in
	// The new context switcher is more scalable.
				
	updateContextSwitcher: function()
	{
		var context = jazz.app.currentApplication.config.contextSwitcher;
		var contextArgs = {}	
		contextArgs.onChange = context.onChange;
		contextArgs.globalMode = true;	
		contextArgs.className = "jazz-app-projectSelector";
		contextArgs.disableClassName = "jazz-app-projectSelector-grayed";							
		var selectorList = dojo.query(".project-selector");
		var  div = selectorList[0];
		dojox.data.dom.removeChildren(div);
		
		var pas = new ProjectAreaSelector(contextArgs);
		div.appendChild(pas.domNode);
	},
	
	_initRtlmFailure: function(response) {			
		//console.error("initialization failed from QMApplication! " + response['errorMessage']);
        // rtlm init failed, save the error object and disable the lab management only
        dojo.setObject("com.ibm.rqm.planning.web.ui.initError", response);
	},

	
    _initAppUI: function()
    {
        this.config.buttons.push({
            label: Constants.getMessage("labelHelp"),
            iconSrc: dojo.moduleUrl("jazz.app", "graphics/JazzUI/icons/help.png"),
            align: "right",
            menuProvider: dojo.hitch(this, this._helpMenuProvider)
        });
        
		// specify only to override the default Jazz logo 
//        this.config.footer = {
//            rightLogo: {src: dojo.moduleUrl("jazz.app", "graphics/JazzUI/rtl_logo_sm.gif"), href: "http://www.ibm.com/software/rational/"}
//        };
        
        // set up project area switcher
        this.config.contextSwitcher = {
            adminUI: false,
            contexts: dojo.getObject("com.ibm.rqm.web.userProjectAreas"),
            currentContext: dojo.getObject("com.ibm.team.process.web.projectArea"),
            onChange: dojo.hitch(this, this._changeProjectAreas)
        };
		
        // set up info center and CS help
        CSHelpEngine.init(Constants.CSHELP_URL, Constants.CSHELP_INFO_CENTER_LABEL, Constants.CSHELP_INFO_CENTER_HREF);                      
        Constants.validateMessageBundle();

        dojo.addClass(dojo.body(), "com-ibm-rqm-web");
        dojo.addClass(dojo.body(), "rqm-print");
                
        var myQMPage = new QMPage({ui: this.ui});

        dojo.connect(this, "start", function(){
            if (dojo.isFF) {
                // The designer has to put the search box in the common banner.  Not something the common
                // support and the help button is pushed down by our search box unless it is set to float
                // right.  It only happens in FF not IE.
                var helpButton = null;
                for (var i = 0; i < this.config.buttons.length; i++) {
                    if (this.config.buttons[i].label == Constants.getMessage("labelHelp")) {
                        helpButton = this.config.buttons[i];
                        break;
                    }
                }
                if (helpButton && helpButton._widget) {
                    dojo.style(helpButton._widget.domNode, "float", "right");
                }
            }
            this.updateContextSwitcher();
        });
        // yield to let the page paint first, before starting the app.
        setTimeout(dojo.hitch(this, "start"), 10);
    },
    
    _helpMenuProvider: function() {
        var menu = new dijit.Menu();
        menu.addChild(new dijit.MenuItem({
            label: Constants.getMessage("labelHelpContents"),
            iconClass: 'helpIcon',
            onClick: dojo.hitch(this, this._showInfoCtr)
        }));
        menu.addChild(new dijit.MenuItem({
            label: Constants.getMessage("labelServerHealth"),
            onClick: dojo.hitch(this, this._showServerHealth)
        }));
        menu.addChild(new dijit.MenuItem({
            label: Constants.getMessage("labelAboutDialogTitle"),
            onClick: dojo.hitch(this, this._showAbout)
        }));
        
        return menu;
    },

    _userMenuProvider: function() {
        var menu = new dijit.Menu();
        dojo.addClass(menu.domNode, "jazz-app-loginLogoutArea-userMenu");
        var menuItem = new dijit.MenuItem({
            label: Constants.getMessage("labelEditProfile"), 
            iconClass: 'userIcon',
            onClick: function() {
                if (PlatformUI.getWorkbench().shouldVetoNavigation() === false) {
                    location.href = Session.getUserProfileLink();
                }
            }}
        );
        menu.addChild(menuItem);
        return menu;
    },

    _showInfoCtr: function() {
        // get the content of the info center to ensure it is accessible
        dojo.xhrGet({
            url: "/help/index.jsp",
            handleAs: "text",
            timeout: 5000, // timeout in milliseconds
        
            // it is good to open the info center
            load: function(response, ioArgs) {
                var infoCtrWindow = window.open("/help/index.jsp", "_help");
                infoCtrWindow.focus();
                return response;
            },
        
            // post error for not able to get to the info center
            error: function(response, ioArgs) {
                var args = {
                    message: Constants.getMessage("msgFailedOpenInfoCenter"),
                    primaryTitle: ""
                };
                var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
                alertDialog.open();
                return response;
            }
        });
    },

    _showServerHealth: function() {
        var health = new com.ibm.rqm.planning.web.ui.internal.view.common.ServerHealth();
    },          

    _showAbout: function() {
        var about = new com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog();
    },

    _changeProjectAreas: function(contextObj) {
        this._redirect(contextObj);
    },

	failure: function(errorObj)
	{
		console.error(errorObj.message);
	},
	
	// functions for sorting pages	
	getCurrentWorkbenchID: function() {
		return net.jazz.ajax.ui.PlatformUI._getApplicationId();
	},

    _findIn: function(array, value, byProperty) {
        for (var i = 0; i < (dojo.isArray(array) ? array.length : 0); i++) {
			if (dojo.isObject(array[i]) && byProperty != null && array[i][byProperty] && array[i][byProperty] == value) {
				return array[i]; 		 	
			} else if (array[i] == value) {
				return array[i];
			}			
		}
		return null;
    }
		
});
})();
