//Report Viewer
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.ui.internal.view.ReportViewer");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportViewer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.reports.web.ui.internal.view.SaveReport");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamFactory");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamMultiSelect");

(function()
{   
	// TODO - review need for this after Jazz/RTC fixes defect 95189
	// The ReportParamMultiSelect code leaks quite a bit - give it a method we can call before
	// the destroy sequence so we can disconnect DOM references to to javascript objects.
	 
	// MVictory 12/04/09 Even with the fixes to 95189, it appears these are still needed
	// If I uncomment the console.debug messages, then a number entries are still output.
	// So while I was able to removed the appendDefaultValues and _appendCheckbox, it seems that
	// this method is still needed
	com.ibm.team.reports.web.ui.internal.ReportParamMultiSelect.prototype._magicPreUninitialize= function () {
		var liNodes=dojo.query("li", this.sectionDiv);
		var nLi = liNodes.length;
		//console.debug("--------------- found li nodes, count = "+nLi);
		while (nLi--) {
			var li = liNodes[nLi];
			li.checkBoxChild=null;
			li.labelChild=null;
			li.onclick=null;
			li.onmouseover=null;
			li.onmouseout=null;
		} 
		var divNodes=dojo.query("div", this.domNode);
		var nDiv = divNodes.length;
		//console.debug("--------------- found div nodes, count = "+nDiv);
		while (nDiv--) {
			var div = divNodes[nDiv];
			div._listItem=null;
		} 
		var inputNodes=dojo.query("input", this.domNode);
		var nInput = inputNodes.length;
		//console.debug("--------------- found input nodes, count = "+nInput);
		while (nInput--) {
			var inp = inputNodes[nInput];
			inp._listItem=null;
		} 
		// the span nodes are from the template
		var spanNodes=dojo.query("span", this.domNode);
		var nSpan = spanNodes.length;
		//console.debug("--------------- found span nodes, count = "+nSpan);
		while (nSpan--) {
			var span = spanNodes[nSpan];
			span.onmouseover=null;
		} 
		var anchorNodes=dojo.query("a", this.domNode);
		var nAnchor = anchorNodes.length;
		//console.debug("--------------- found anchor nodes, count = "+nAnchor);
		while (nAnchor--) {
			var anchor = anchorNodes[nAnchor];
			anchor.onclick=null;
		} 
	}
		
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var PlatformUI = net.jazz.ajax.ui.PlatformUI;
    var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;    
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ReportParamFactory = com.ibm.team.reports.web.ui.internal.ReportParamFactory;
    
    dojo.declare("com.ibm.rqm.reports.web.ui.internal.view.ReportViewer",  
    [dijit._Widget, dijit._Templated, com.ibm.team.reports.web.ui.internal.ReportViewer], 
    {
        constructor: function() {
            this.autoRun = false;     //auto-run report on load with default args
            this.isReport = false;
            this.reportId = null;
            this.uriArgs = null;
            this._view = null;
            this.reportUUID = "";
            this.queryUUID = "";
            this.title = null;          
            this._viewer = null;
            this._includeArchived = false;
            this.controller = this;
            this.enableParams = true;
            this.concealedReportParams=[];
        },
        
        //@Override from Jazz's ReportsViewer.js

		postCreate: function()
		{
			//Use the superclass' post create to do the real work.
			this.inherited('postCreate', arguments);
			
			//If we are NOT auto running remove the "Loading" message that is initially visible in the HTML
			if (!this.autoRun)
				this._removeChildren(this.renderedReportDiv);
			
	    	/*
    			Some tweeks to the default RTC ReportViewer:
    		
    			1.  Hide the "Set as Default" button.
    			2.  Add a Save As button  
       		*/

			//Hide RTC's Save as button
			this._saveAsButton.style.display = "none";
			            
			//Add in our  save-as button
        	var saveAsButton = document.createElement('button');
        	saveAsButton.innerHTML = Constants.getMessage("labelSaveAs");
        	saveAsButton.onclick = dojo.hitch(this, "_handleSaveAs");
        	this._saveButton.parentNode.insertBefore(saveAsButton, this._saveButton.nextSibling);
			
			//Hide the editable title
			this._titleSection.style.display = "none";
			
			//hide the "set as default button
			//Would prefer to use this._toolbar.getItem(1) but getItem doesn't work correctly.
			this._toolbar.removeItem(this._toolbar.items[1]);
			
            //Autorun Cognos-based report, skipping BIRT report dialogs
            //Basis is that Cognos reports are i + MD5 String as reportId
            if (this.reportId != null){
                if ( (this.reportId.length == 33) && (this.reportId.charAt(0) == 'i') ){
                    this.autoRun = true;
                }
            }
                        
			//If we are NOT immediately running the report then show the parameters
			if (!this.autoRun)
				this._handleEdit();
		},
		

		//TODO - clean this up ASAP
		// A copy of the method from the com.ibm.team.reports.web.ui.internal.ReportViewer
		// with some additional cleanup.
		destroy: function() {
			if (!this.rcpCall) {
				if (this.navigateAwayHandle) {
					PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
				}
				if (this.onBeforeUnloadHandle){
					PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);	
				}
			}
			this._exportDialog.destroyRecursive();
			
			// --------------- below this is the RQM-added cleanup. ---------------
			if (this._cshelp && this._cshelp.destroy){
				this._cshelp.destroy();
			}
			var params = this.concealedReportParams;
			if (params) {
				var length=params.length;
				for (var i = 0; i<length; ++i){
					params[i].destroy();
				}
			}
			dijit._Widget.prototype.destroy.apply(this);			
		},
		/*
			Copied from RTC's Report Viewer.
			The only difference here is deciding how/whether to auto run the report.
			In RTC's world, the report is supposed to auto run if there are initial parameter values.
			Unfortunately, I believe, that the initial check is wrong so the reports pretty much always auto run.
			I added in the use of the autoRun member variable as the deciding factor of whether to auto run or not.
	    */
		_handleParameters: function(baseParamsArray) {
			if (!baseParamsArray || baseParamsArray.length == 0) {
				baseParamsArray = [];
                //These
				this._button.title = "";
				this._button.onclick = null;
                this._button.style.display = "none";
			}
			else {
				this.enableParams = true;
			}
			
			if (!this._isQuery) {
				dojo.forEach(baseParamsArray, dojo.hitch(this, function(param) {
					if (param._eQualifiedClassName == "com.ibm.team.reports.dto:ReportParameterGroupDTO") {
						for (var i = 0; i < param.parameters.length; i++) {
							var parameterDTO = param.parameters[i];
							if (this[parameterDTO.name]) {
								this.parameterName[this.parameterName.length] = parameterDTO.name;
								this.parameterValue[this.parameterValue.length] = this[parameterDTO.name];
							}
						}
					}
					else if (param._eQualifiedClassName == "com.ibm.team.reports.dto:ReportParameterDTO") {
						var parameterDTO = param;
						if (this[parameterDTO.name]) {
							this.parameterName[this.parameterName.length] = parameterDTO.name;
							this.parameterValue[this.parameterValue.length] = this[parameterDTO.name];
						}
					}
				}));
			}
			
			var missingQueryParams = false;
			
			dojo.forEach(baseParamsArray, dojo.hitch(this, function(param) {
				var args = {
					projectAreaUUID: this.projectAreaUUID,
					queryUUID: this.queryUUID,
					reportUUID: this.reportUUID,
					showArchived: this.showArchived
				};
				if (param._eQualifiedClassName == "com.ibm.team.reports.dto:ReportParameterGroupDTO") {
					var reportParamGroup = new com.ibm.team.reports.web.ui.internal.ReportParamGroup({
						parameterGroupDTO: param,
						urlPrefix: this.urlPrefix,
						parameterName: this.parameterName,
						parameterValue: this.parameterValue
					});
					this.reportParamsPanel.appendParamGroup(reportParamGroup);
					reportParamGroup.appendReportParameters(this.reportParams);
					var responseHandler = new ServiceResponseHandler(reportParamGroup, "initGroupValues", "remoteError");
					args.groupName = param.name;
					ReportsClient.getParameterGroupValues(responseHandler, args);
					
					dojo.forEach(param.parameters, dojo.hitch(this, function(singleParam) {
						if (singleParam.required && 
						    (!singleParam.defaultValue || 
						     singleParam.defaultValue.length == 0 || 
						     param.defaultValue == "''")) {
							var found = -1;
							if (this.parameterName.length == 0) {
								missingQueryParams = true;
							} else {
								for (var i = 0; i < this.parameterName.length; i++) {
									if (singleParam.name == this.parameterName[i]) {
										found = i;
										break;
									}
									if (found != -1 && 
									    (found >= this.parameterValue.length || 
									     !this.parameterValue[found] || 
									     this.parameterValue[found].length == 0 ||
									     this.parameterValue[found] == "''")) {
										missingQueryParams = true;
									}
								}
							}
						}
					}));
				} else if (param._eQualifiedClassName == "com.ibm.team.reports.dto:ReportParameterDTO") {
					var reportParam = ReportParamFactory.create(param, this.urlPrefix);
					if (!param.concealed) {
						this.reportParamsPanel.appendParam(reportParam);
					}else{
						this.concealedReportParams.push(reportParam);
					}
					this.reportParams.push(reportParam);
					var self = this;
					var obj = {
						success: function(reportParameterDTO) {
							reportParam.init(reportParameterDTO);
							if (self.parameterName.length > 0) {
								for (var i = 0; i < self.parameterName.length; i++) {
									if (self.parameterName[i] == reportParam.parameterDTO.name) {
										reportParam.setValues(self.parameterValue[i]);
										break;
									}
								}
							}
							reportParam.postInit();
						},
						error: function(error) {
							alert(error.message);
						}
					}
					var srh = new ServiceResponseHandler(obj, "success", "error");
					args.parameter = param.name;
					ReportsClient.getParameterValues(srh, args);
					
					if (param.required && 
					    (!param.defaultValue || 
					     param.defaultValue.length == 0 || 
					     param.defaultValue == "''")) {
						var found = -1;
						if (this.parameterName.length == 0) {
							missingQueryParams = true;
						}
						else {
							for (var i = 0; i < this.parameterName.length; i++) {
								if (param.name == this.parameterName[i]) {
									found = i;
									break;
								}
							}
							if (found != -1 && 
							    (found >= this.parameterValue.length || 
							     !this.parameterValue[found] || 
							     this.parameterValue[found].length == 0 ||
							     this.parameterValue[found] == "''")) {
								missingQueryParams = true;
							}
						}
					}
				}
			}));
			if (this.controller) {
				this.controller.finishOperation();
			}
			
			this._showCSHelp();
			
			
//			if (missingQueryParams) {
//				this._removeChildren(this.renderedReportDiv);
//				this._handleEdit();
//			} else if (this.parameterName) {
//				this._updateReport(this.parameterName, this.parameterValue);
//			}
			//MFV this is what is different in this version.  In the RTC version _updateReport is run if this.parameterName is not null.
			//However, this.parameterName is initialized to an empty array (ie non null) in the constructor causing _updateReport to run needlessly
			
			//There are two reports that have no parameters.  In that case we had to add a parameter with name "NotUsedParameter".
			//If this is one of those reports lets remove the "loading" message.
			//Normally appendParam or appendParamGroup would remove the loading message but since there are no visible parameters those
			//methods do not get called.
			if (baseParamsArray && baseParamsArray.length == 1 && baseParamsArray[0].name == "NotUsedParameter")
			{
//				this.autoRun = true;  //Uncomment this if you want parameterless reports to run automatically
				this.reportParamsPanel._removeChildren(this.reportParamsPanel._mainSectionLeft);
			}				
				
			if (this.autoRun) {
				this._updateReport(this.parameterName, this.parameterValue);
			}
		},	 
        
        setView: function(view) {
            this._view = view;          
            this._updateView();
        },      
        
        _updateView: function() {
            if (this._view && this._view.controlButton) {
                //apply the tab class
                dojo.addClass(this._view.controlButton.containerNode, "report-icon-tab");
                //TODO update the tab label
            }           
        },

		_handleSaveAs: function() {
			var saveAsWidget = new com.ibm.rqm.reports.web.ui.internal.view.SaveReport({
                reportUUID: this.reportUUID,
				queryUUID: this.queryUUID,
				onOk: dojo.hitch(this, "_saveAsFinished"),
				newParameters: this._getParameterSelections()
			});			
		},
				
		_saveAsFinished: function(newQueryUUID) {
			//if a new query has been created, need to re-draw the parameters section,
			//in order to enable the 'Save' function
			if (newQueryUUID != null) {
				console.debug(this.declaredClass + ": created new Query: " + newQueryUUID);
				this.isReport = false;
				this.reportUUID = "";
				this.autoRun = false; //do not re-run report
				this.queryUUID = newQueryUUID;

				//Re-initialize the report.
				//This reloads the parameter list so lets clear them now.
				//If we don't do this we end up with multiple sets of parameters displayed.				
				this.reportParamsPanel._removeChildren(this.reportParamsPanel._mainSectionLeft);
				this._initQuery();
			}
		},
		
		_getParameterSelections: function(){
			var result = {
				parameterNames: [],
				parameterValues: []
			};
			var parameterNames = [];
			var parameterValues = [];
			for (var i = 0, len = this.reportParams.length; i < len; ++i) {
				var reportParam = this.reportParams[i];
				if (reportParam != null)
				{
					result.parameterNames[i] = reportParam.parameterDTO.name;
					var vals = reportParam.getSelectedValues() || [];
					if (reportParam.parameterDTO.required && (vals == null || vals.length == 0 || vals[0] == undefined)) {
						this._remoteError({
							message: dojo.string.substitute(this.messages.missingReqParam, [reportParam.parameterDTO.name])
						});
						return null;
					}
					result.parameterValues[i] = vals.join(",");
				}
			}
			return result;
		},

		_showCSHelp: function() {
            var cshelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp({
				contextID: "report_" + (this.reportId?this.reportId:this.reportUUID) + ".html"
            });
            
			this.reportTitleSpan.appendChild(cshelp.domNode);   
			this._cshelp=cshelp;			
		},

        
        //*******************************************************************************
        //             Overridde from Jazz's ReportsController to allow reuse of 
        //                    Jazz's ReportsViewer widget
        //*******************************************************************************
        /**
         * Marks the start of a long-running operation (needs more documentation).
         * May be called by code within the com.ibm.team.workitem.web bundle.
         */
        startOperation: function(message) {
            PlatformUI.getWorkbench().showMessage(message);
        },
    
        /**
         * Marks the end of a long-running operation (needs more documentation).
         * May be called by code within the com.ibm.team.workitem.web bundle.
         */
        finishOperation: function(operation) {
            PlatformUI.getWorkbench().hideMessageArea();
        },
        
        /**
         * Return whether archived things should be
         * included in reports
         */
        getIncludeArchived: function() {
            return this._includeArchived;
        },
        
        /**
         * Set whether archived things should be
         * included in reports
         */
        setIncludeArchived: function(includeArchived) {
            this._includeArchived = includeArchived;
        },      
        
        refreshNavigator: function() {
            //do nothing; not using navigator
        },
        
        setDefaultQuery: function(defaultQuery) {
            //do nothing; not using default
        },
        //*******************************************************************************
                
        _error: function(e) {
            console.error(this.declaredClass + ": Error: " + e.message);
        }   

    });
})();
