/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader");
 
(function() 
{
	var ArtifactEditorPageController = com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController;
	var ArtifactModel               = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;	
	var EditorFactory 	   			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
	var TestCaseClient         		= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var TestScriptClient       		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var TestCaseMapper				= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
    var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var CommonUtility               = com.ibm.asq.common.web.ui.internal.util.Utility;
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
				setTimeout(dojo.hitch(this,function(){
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.ScanClient",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.InfoClient",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.Constants",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingOverviewViewlet",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingViewlet",null);
				}),10);
			},
			
		   /*
			* Provide access to an EditorFactory instance.
			*/
			getEditorFactory: function()
			{
				return EditorFactory;
			},
			
			initialize: function(args)
			{
				var _dojo = dojo;
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry.superclass.initialize.call(this, args);
                this.inherited('initialize', arguments);
				
                var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                var ewiPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
                var dpPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_DATAPOOL);
                var tscriptPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SCRIPT);
                var tsuitePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);
				
                if (!tcPerm || tcPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestCase"), _dojo.hitch(this, "_onClickNewTestCase"), false, {'subAction': "newTestCase",'tq': ""});
                }
				this._addMenuEntry(Constants.getMessage("labelAllTestCase"), _dojo.hitch(this, "_onClickAllTestCases"), false, {'subAction': "viewTestCases"});

                if (!tcPerm || tcPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestCase"), _dojo.hitch(this, "_onClickImportTestCase"), false, {
                        'subAction': "importTestCase"
                    });
                }
				this._addMenuSeparator();
                
                if (!tscriptPerm || tscriptPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestScript"), _dojo.hitch(this, "_onClickNewTestScript"), false, {'subAction': "newTestScript", 'tq': ""});
                }
				this._addMenuEntry(Constants.getMessage("labelAllTestScript"), _dojo.hitch(this, "_onClickAllTestScripts"), false, {'subAction': "viewTestScripts"});

                if (!tscriptPerm || tscriptPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestScript"), _dojo.hitch(this, "_onClickImportTestScript"), false, {
                        'subAction': "importTestScript"
                    });
                }
				this._addMenuSeparator();
                
                if (!tsuitePerm || tsuitePerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestSuite"), _dojo.hitch(this, "_onClickNewTestSuite"), false, {'subAction': "newTestSuite", 'tq': ""});
                }
				
				this._addMenuEntry(Constants.getMessage("labelAllTestSuite"), _dojo.hitch(this, "_onClickTestSuites"), false, {'subAction': "viewTestSuites"});
                this._addMenuSeparator();

                if (!ewiPerm || ewiPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewEWI"), _dojo.hitch(this, "_onClickNewEwi"), false, {
                        'subAction': "newEwi",
                        'tq': ""
                    });
                    this._addMenuSeparator();
                }
				
                if (!dpPerm || dpPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewDatapool"), _dojo.hitch(this, "_onClickNewDatapool"), false, {
                        'subAction': "newDatapool",
                        'tq': ""
                    });
                }
				this._addMenuEntry(Constants.getMessage("labelAllDatapool"), _dojo.hitch(this, "_onClickAllDatapools"), false, {'subAction': "viewDatapools"});

				this._addMenuSeparator();
				this._addMenuEntry(Constants.getMessage("labelAllKeywords"), _dojo.hitch(this, "_onClickKeywords"), false, {'subAction': "keywords"});

                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewEwi", _dojo.hitch(this, "viewEwi"));
					this.actionDispatcher.registerDispatchAction("viewTestScript", _dojo.hitch(this, "viewTestScript"));
                    this.actionDispatcher.registerDispatchAction("copyTestScript", _dojo.hitch(this, "copyTestScript"));
					this.actionDispatcher.registerDispatchAction("viewTestCase", _dojo.hitch(this, "viewTestCase"));
					this.actionDispatcher.registerDispatchAction("viewTestSuite", _dojo.hitch(this, "viewTestSuite"));
					this.actionDispatcher.registerDispatchAction("copyTestSuite", _dojo.hitch(this, "copyTestSuite"));
                    this.actionDispatcher.registerDispatchAction("copyTestCase", _dojo.hitch(this, "copyTestCase"));
					this.actionDispatcher.registerDispatchAction("viewDatapool", _dojo.hitch(this, "viewDatapool"));
                }
			},
			
			_onClickNewTestCase: function()
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor", dojo.hitch(this, function(tab,onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
                        var args = {
                            parentController: this,
                            model: artifactModel
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelNewTestCase"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_onClickMyTestCases: function()
			{
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView"); 
                this._loadTestCases(Constants.getMessage("labelMyTestCase"), browserTitle, {authenticatedContributor: getAuthenticatedContributor().itemId});  			
			},
            
            _onClickAllTestCases: function()
            {
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._loadTestCases(Constants.getMessage("labelAllTestCase"), browserTitle, {});			
            },            

            _loadTestCases: function(name, browserTitle, queryArgs)
            {
                var func = function(tab, onComplete){
                    queryArgs = queryArgs ? queryArgs : {};
                    try {
                        this._loadClassAsync("com.ibm.rational.test.lm.web.client.internal.config", null);
                        this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient", null);
                        this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", null);
                        this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient", null);
                        //load class in Risk component
                        this._loadClassAsync("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", null);
                        this._loadClassAsync("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", null);
                    } 
                    catch (e) {
                        console.error("failed to load files async for ExecutionPopup in CABE");
                    }
                    
                    var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                    
                    var tableViewArgs = {
                        parent: this,
                        testCases: [],
                        queryName: name,
                        showQueryFilters: true,
                        isSingleSelect: false,
                        enableRowSelection: true,
                        enableRowEditable: (!permission || permission[PermissionsClient.ACTION_EDIT])
                    }
                    
                    var list = new com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView(tableViewArgs);
                    
                    // set the reference to the tabs container to allow checking for opened artifact editors
                    list.artifactsDisplayContainer = this._contentArea;
                    onComplete(tab, list);
                };
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView", dojo.hitch(this, func, tab, onComplete));
                }
                var pageName = name; 
                this._addPage( {
                    name: pageName,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
            }, 
                        
			_onClickImportTestCase: function()
			{
				var args = {
                    title: Constants.getMessage("labelImportTestCase"),
                    artifactType: "testcase",
                    importPrompt: Constants.getMessage("msgImportTestCase"),
                    contextHelpId: "rqm_import_test_case.html",
                    cshelpLabel: Constants.getMessage("labelImportTestCaseHelp")
                };
                
				
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
				this._addPage( {
                    name: Constants.getMessage("labelImportTestCase"),
                    widgetClass: com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader,
                    widgetArgs: args,
                    onWidgetCreated: dojo.hitch(this, function(widget) {
                        widget._header.setCSHelpButtonLabel(Constants.getMessage("labelImportTestCaseHelp"));
                    }),
                    closable: true,
                    browserTitle: browserTitle
                });			
            },
			
			_onClickExportTestCase: function()
			{
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestCase"), content: "Todo: implement export test case.", closable: true, browserTitle:browserTitle});
			},
			
			_onClickNewTestScript: function()
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor({});
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        view.setArtifactModel(artifactModel);
                        view.initialize({
                            parentController: this
                        });
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelNewTestScript"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},

			_onClickMyTestScripts: function()
			{
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
                this._loadTestScripts(Constants.getMessage("labelMyTestScript"), browserTitle, {originator: getAuthenticatedContributor().itemId}); 
			},
            
            _onClickAllTestScripts: function()
            {
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._loadTestScripts(Constants.getMessage("labelAllTestScript"), browserTitle, {}); 
            },           
            
			_loadTestScripts: function(name, browserTitle, queryArgs)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView", dojo.hitch(this, function(tab, onComplete){                        
                        var args = {
                            scripts: [],
                            showQueryFilters: true,
                            queryName: name
                        }
                        var list = new com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView(args);
                        list.artifactsDisplayContainer = this._contentArea;
                        onComplete(tab, list);
                    }, tab, onComplete));
                };
				this._addPage( {
                    name: name,
                    closable: true,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    browserTitle: browserTitle
                });
            },             
						
			_onClickImportTestScript: function()
			{
                var loadFunc = function(tab, onComplete){
                    jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage", dojo.hitch(this, "_loadImportScript", tab, onComplete));
                }
                var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
                var view = this._addPage( {
                    name: Constants.getMessage("labelImportTestScript"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
				// load async
			},
			
			_loadImportScript: function(tab, onComplete)
			{
				var widget = new com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage();
                onComplete(tab, widget);
			},
			
			_onClickExportTestScript: function()
			{
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestScript"), content: "Todo: implement export test script.", closable: true, browserTitle:browserTitle});
			},
			
			_onClickNewEwi: function()
			{
                var loadFunc = function(tab, onComplete){
                    jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem", dojo.hitch(this, "_loadNewEwi", tab, onComplete));
                }
                var browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelCapitalNew");
                var page = this._addPage( {
                    name: Constants.getMessage("labelNewEWI"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
                page.controlButton.containerNode.className = "ewi-icon-16-inTab";
			},
			
			_loadNewEwi: function(tab, onComplete)
			{
                var widget = new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({parentController: this});
                widget.page = tab;
                widget._updateBrowserTitle();
                onComplete(tab, widget);
			},
			
			viewEwi: function(kwArgs){
				var self = this;
				var func = function() {
					var callbackObj = {
						success: function(ewis){
							if(ewis && ewis.length > 1){
								self._loadEWIError(new Error(Constants.getMessage("errRetrieveEWI")));
                    			return;
							}else{
								if(dojo.isArray(ewis))
									self._openEWI(ewis[0]);
								else
									self._openEWI(ewis);	
							}
						},
						failure: function(e){
							self._loadEWIError(e)
						}
					}
					
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");          
	                com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, kwArgs);             
                };
				jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", func);
			},
			
			_openEWI: function(ewiObj){
				var func = function() {
					var editor =new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({parentController: this, ewi: ewiObj});
					var ewiName = ewiObj.name ? ewiObj.name:"";
					var page =this._addPage({name: ewiName, content: editor, closable: true});
					page.controlButton.containerNode.className = "ewi-icon-16-inTab";
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem";
                this._loadClassAsync(classname, func);
			},
			
			_loadEWIError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelEWI"), e.message);
            },
			
			_onClickNewDatapool: function()
			{
                var loadFunc = function(tab, onComplete){
                    jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor", dojo.hitch(this, "_loadNewDatapool", tab, onComplete));
                }
                var view = this._addPage( {
                    name: Constants.getMessage("labelNewDatapool"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_loadNewDatapool: function(tab, onComplete) {
				var artifactModel = new ArtifactModel(Constants.TYPE_DATAPOOL);
				var editor = new com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor();
                
                editor.setArtifactModel(artifactModel);
                editor.initialize({parentController: this});
                onComplete(tab, editor);
                var controller = new ArtifactEditorPageController(artifactModel, tab);
                controller.updateTab();
			},
			
			_onClickAllDatapools: function()
            {
                var self = this;
                var loadFunc = function(tab, onComplete){
                    jazz.core.loader.load_async("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient", function(){
                        jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView", dojo.hitch(self, "_loadDatapools", tab, onComplete));  
                    });
                };
                var browserTitle = Constants.getMessage("labelDatapool") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._addPage( {
                    name: Constants.getMessage("labelAllDatapool"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
            },            

            _loadDatapools: function(tab, onComplete)
            {
				var actions = [];
        		actions.push({
                    id: "refresh",
            		label: Constants.getMessage("labelRefresh"),
            		actionHandler: dojo.hitch(this, "_refreshDatapoolList"),
            		iconClass: "refresh-icon-image",
            		disabledOnReadOnly: true
        		});
                var list = new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView({
					queryName: Constants.getMessage("labelAllDatapool"),
                    datapools: [],
                    showInitLoadProgress: true,
					actions: actions
                });	
                onComplete(tab, list);			
            }, 
			
			_refreshDatapoolList: function(tableView){
            	var self = this;
            	var handler = {
                	success: function(datapools){
                    	if (tableView) {
                        	tableView.refresh(datapools);
                    	}
                	},
                	error: function(e){
                    	self._error(e);
                	}
           		}
            
           		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            	com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, {});
        	},
			
			viewDatapool: function(kwArgs) {
                var loadFunc = function(tab, onComplete){
                    var self = this;
                    jazz.core.loader.load_async("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient", function(){
                        jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor", dojo.hitch(self, "_loadDatapool", kwArgs.itemId, tab, onComplete));                        
                    });
                }
                var view = this._addPage( {
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_onClickNewTestSuite: function()
			{
				var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
				var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor();
				var view = this._addPage( {
                    name: Constants.getMessage("labelNewTestSuite"),
                    widgetClass: com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor,
                    widgetArgs: {},
                    onWidgetCreated: dojo.hitch(this, function(artifactModel,widget){
                        widget.setArtifactModel(artifactModel);
                        widget.initialize({
                            parentController: this
                        });
                    },artifactModel),
                    closable: true
                });
				var controller = new ArtifactEditorPageController(artifactModel, view);
				controller.updateTab();
            },
			
            _onClickTestSuites: function() {
                var pageName = Constants.getMessage("labelAllTestSuite");
				var func = function(tab, onComplete) {
					var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);
					var tableViewArgs = {
						parent: this,
						suites: [],
						queryName: pageName,
						showQueryFilters: true,
						enableRowEditable: !permission || permission[PermissionsClient.ACTION_EDIT]
					};
                    var list = new com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView(tableViewArgs);
                    onComplete(tab, list);          
				}
                var loadFunc = function(tab, onComplete){
                    var classname = "com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView";
                    this._loadClassAsync(classname, dojo.hitch(this, func, tab, onComplete));
                }
                var page = this._addPage({
                        name: pageName,
                        onDeferredLoad: dojo.hitch(this, loadFunc),
                        closable: true,
                        browserTitle: Constants.getMessage("labelTestSuite") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllTestSuite")
                });
			},
			
			_loadDatapool: function(itemId, tab, onComplete){
                // create the editor to show loading in progress in a new tab and reinitialize the editor
                // after the data is fetched from the server                
                var artifactModel = new ArtifactModel(Constants.TYPE_DATAPOOL);
                var editor = new com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor();
                editor.setArtifactModel(artifactModel);
                var controller = new ArtifactEditorPageController(artifactModel, tab);
                controller.updateTab();
                
                onComplete(tab, editor);
                
                var queryArgs = {itemId: itemId};
                var self = this;
                var handler = {
                    success: function(datapools){
                        if (datapools != null && datapools.length > 0) {
                            self._showDatapool(datapools[0], editor);
                        }
                        else {
                            self._loadDatapoolError(new Error(Constants.getMessage("errDatapoolNotFound")));
                        }
                    },
                    error: function(e){
                        self._loadDatapoolError(e);
                    }
                }
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, queryArgs);
            }, 
            
			_showDatapool: function(datapool, editor)
			{
                // initialize will implicitly update the tab button label
				editor.initialize({ parentController: this, datapool: datapool });
			},
            
            _loadDatapoolError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelDatapool"), e.message);
            },
            
			_onClickKeywords:function()
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList", dojo.hitch(this, "_viewKeywords", tab, onComplete));
                };
                var browserTitle = Constants.getMessage("labelKeywords") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._addPage( {
                    name: Constants.getMessage("labelAllKeywords"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });             
			},
            
			_viewKeywords:function(tab, onComplete)
			{
				var list = new com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList({});
                onComplete(tab, list);
			},
            
            viewTestScript: function(kwArgs) 
            {
                // create the editor to show loading in progress in a new tab and reinitialize the editor
            	// after the data is fetched from the server
                var self = this;
                var loadEditorFunc = function(widget){
                    
                    var handler = {
                        success: function(result){
                            self._doViewTestScript(result, widget);
                        },
                        error: function(e){
                            self._loadTestScriptError(e);
                        }
                    }
                    var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                    if (null != kwArgs.uid && null != kwArgs.revision) {
                        TestScriptClient.getTestScriptRevision(responseHandler, kwArgs.uid, kwArgs.revision);
                    }
                    else {
                        TestScriptClient.getTestScript(responseHandler, kwArgs.id);
                    }
                };
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor({});
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        view.setArtifactModel(artifactModel);
                        onComplete(tab, view);
                        controller.updateTab();
                        loadEditorFunc(view);
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },
            
            _doViewTestScript: function(result, editor) 
            {
				if (!result || result.length != 1)
                {
                    this._loadTestScriptError(new Error(Constants.getMessage("errTestScriptNotFound")));
                    return;
                }
				if ( dojo.isArray(result) ) 
                {
                    result = result[0]; 
                }
                // initialize will implicitly update the tab button label
                editor.initialize({parentController: this, testScript: result});
            },
            
            _loadTestScriptError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelTestScript"), e.message);
            },
            
			viewTestCase: function(kwArgs)
            {			
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
                        var args = {
                            parentController: this,
                            model: artifactModel,
                            kwArgs: kwArgs
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },
			
            copyTestCase: function(kwArgs)
            {              
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor", dojo.hitch(this, function(){
                        var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
                        var args = {
                            parentController: this,
                            model: artifactModel,
                            copy: true,
                            kwArgs: kwArgs
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },			

			viewTestSuite: function(kwArgs) {
                var self = this;
                var func = function(editor) {
                    var callbackObj = {
                        success: function(suite){
                            if (suite.length > 0) {
                                self._doViewTestSuite(suite[0], editor, kwArgs);
                            } else {
                                self._loadTestSuiteError(new Error(Constants.getMessage("errTestSuiteNotFound")));
                            }
                        },
                        failure: function(errorObj){
                            self._loadTestSuiteError(errorObj);
                        }
                    }
                    var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(callbackObj, "success", "failure");
                    if (null != kwArgs.uid && null != kwArgs.revision) {
                        com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteRevision(responseHandler, kwArgs.uid, kwArgs.revision);
                    } else { 
                        com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler, 
                            {id: kwArgs.id, 
                            resolveWorkItems: true, 
                            resolveElements: true,
                            resolveElementFullTestase: false, 
                            resolveElementsTestcase: true,
                            resolveElementsRequest: false,
                            resolveElementsResult: false,
                            resolveFullCurrentResult: false,
                            resolveCurrentResultElements: false,
                            resolveFlattenedTestCase: true,
                            resolvePlan: false,
                            resolveMinimalPlan: true, 
                            resolveSection: true,
                            resolveCategory: true
                        });
                    }
                };
                
                var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
                var view = this._addPage( {
                    name: Constants.getMessage("labelLoading"),
                    widgetClass: com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor,
                    widgetArgs: {},
                    onWidgetCreated: dojo.hitch(this, function(editor){
                        editor.setArtifactModel(artifactModel);
                        //Load both Mapper and client before calling
                        var loadClient = function(){
                            var cn = "com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient";
                            self._loadClassAsync(cn, dojo.hitch(self, func, editor));
                        };
                        var classname = "com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper";
                        this._loadClassAsync(classname, loadClient);
                    }),
                    closable: true
                });
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
			},

			copyTestSuite: function(kwArgs){
				var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
                var args = {
					parentController: this,
                		model: artifactModel,
                		copy: true,
                		kwArgs: kwArgs                  
				};
                
                var self = this;
                var onCreatedFunc = function(editor){
                    editor.setArtifactModel(artifactModel);
                    
                    var revision = kwArgs.revision;
                    var snapshotName = kwArgs.snapshotName;
                    var handler = {
                        success: function(suite){
                            if (suite.length > 0) {
                                self._doViewTestSuite(suite[0], editor, kwArgs);
                            }
                            else {
                                self._loadTestSuiteError(new Error(Constants.getMessage("errTestSuiteNotFound")));
                            }
                        },
                        error: function(errorObj){
                            self._loadTestSuiteError(errorObj);
                        }
                    }
                    var queryArgs = {
                        revision: kwArgs.revision,
                        itemId: kwArgs.uid
                    };
                    var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(handler, "success", "error");
                    com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler, queryArgs);
                }
                var view = this._addPage( {
                    name: Constants.getMessage("labelLoading"),
                    widgetClass: com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor,
                    widgetArgs: args,
                    onWidgetCreated: onCreatedFunc,
                    closable: true
                });
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();                
			},

			_doViewTestSuite: function(testSuite, editor, args){
				editor.initialize({ parentController: this, testSuite: testSuite });
			},
			
            _loadTestSuiteError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelTestSuite"), e.message);
            },
			
			copyTestScript: function(kwArgs){
                var self = this;
                var onCreatedFunc = function(editor){
                    var revision = kwArgs.revision;
                    var snapshotName = kwArgs.snapshotName;
                    var handler = {
                        success: function(result){
                            self._doViewTestScript(result, editor);
                        },
                        error: function(e){
                            self._loadTestScriptError(e);
                        }
                    }
                    var queryArgs = {
                        revision: kwArgs.revision,
                        itemId: kwArgs.uid
                    };
                    var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                    TestScriptClient.getTestScripts(responseHandler, queryArgs);
                };
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
                        var args = {
                            parentController: this,
                            model: artifactModel,
                            copy: true,
                            kwArgs: kwArgs
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        onComplete(tab, view);
                        controller.updateTab();
                        onCreatedFunc(view);
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },

			_error: function(error) 
			{
				console.debug("ConstructionActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
