/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.QueryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.SearchResultTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.itemtemplates.TemplatesView");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup");

(function() 
{
	var PlanningPageClient 			= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TestPlanMapper				= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
    var QueryClient                 = com.ibm.rqm.planning.web.client.internal.QueryClient;
	var TestPlanTableView  			= com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
	var SearchResultTableView       = com.ibm.rqm.planning.web.ui.internal.view.table.SearchResultTableView;
	var ArtifactEditorPageController = com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController;
	var ArtifactModel               = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;	
	var Constants          			= com.ibm.rqm.planning.web.client.internal.Constants;
	var EditorFactory 	   			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var CSHelp                      = com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var GlobalEvents                = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var PlanningClient              = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var ScoredResultMapper          = com.ibm.rqm.planning.web.client.internal.mapper.ScoredResultMapper;
	
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args) {
				this.inherited('initialize', arguments);
				
                var planPermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_PLAN);
                var canCreatePlan = (!planPermission || planPermission.create);
                
                if(canCreatePlan) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestPlan"), dojo.hitch(this, "_onClickNewTestPlan"), false, {'subAction':"newTestPlan", 'tq':""});
                }
                
				this._addMenuEntry(Constants.getMessage("labelAllTestPlan"), dojo.hitch(this, "_onClickAllTestPlans"), false, {'subAction':"viewTestPlans"});
                
                if (canCreatePlan) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestPlan"), dojo.hitch(this, "_onClickImportTestPlan"), false, {
                        'subAction': "importTestPlans"
                    });
                }
//				this._addMenuEntry(Constants.getMessage("labelExportTestPlan"), dojo.hitch(this, "_onClickExportTestPlan"), false, {'subAction':"exportTestPlans"});

                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("doSearch", dojo.hitch(this, "doSearch"));
					this.actionDispatcher.registerDispatchAction("viewTestPlan", dojo.hitch(this, "viewTestPlan"));
                    this.actionDispatcher.registerDispatchAction("copyTestPlan", dojo.hitch(this, "copyTestPlan"));
                }
				
				//show the 'templates' action if user has any template permissions
				if (PermissionsClient.hasAnyPermission(PermissionsClient.OP_TEMPLATE)) {
					this._addMenuSeparator();
					this._addMenuEntry(Constants.getMessage("labelManageTemplates"), dojo.hitch(this, "showTemplates"), false, {
						'subAction': "showTemplates"
					});
                    if (this.actionDispatcher) {
                        this.actionDispatcher.registerDispatchAction("showTemplates", dojo.hitch(this, "showTemplates"));
                    }
				}
			},
			
		   /*
			* Provide access to an EditorFactory instance.
			*/
			getEditorFactory: function()
			{
				return EditorFactory;
			},
			
			_onClickNewTestPlan: function()
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
                        var args = {
                            parentController: this,
                            model: artifactModel
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelNewTestPlan"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_onClickMyTestPlans: function()
			{
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
                this._loadTestPlans(Constants.getMessage("labelMyTestPlan"), browserTitle, {authenticatedContributor: getAuthenticatedContributor().itemId});		
			},
            
            _onClickAllTestPlans: function()
            {
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._loadTestPlans(Constants.getMessage("labelAllTestPlan"), browserTitle, {});			
            },        
            
			_loadTestPlans: function(name, browserTitle, queryArgs)
            {
                var loadFunc = function(tab, onComplete){
                    //load class in Risk component
                    jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", function(){});
                    jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", function(){});
                    
                    queryArgs = queryArgs ? queryArgs : {};
                    
                    var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_PLAN);
                    
                    var args = {
                        parent: this,
                        plans: [],
                        queryName: name,
                        showQueryFilters: true,
                        isSingleSelect: false,
                        enableRowEditable: (!permission || permission[PermissionsClient.ACTION_EDIT])
                    };
                    var planTableViewer = new TestPlanTableView(args);
                    
                    // set the reference to the tabs container to allow checking for opened artifact editors
                    planTableViewer.artifactsDisplayContainer = this._contentArea;
                    onComplete(tab, planTableViewer);
                };
				this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });       
            },                
			
			_onClickImportTestPlan: function()
			{
                var args = {
					title: Constants.getMessage("labelImportTestPlan"),
					artifactType: "testplan",
                    importPrompt: Constants.getMessage("msgImportTestPlan"),
                    contextHelpId: "rqm_import_test_plan.html",
                    cshelpLabel: Constants.getMessage("labelImportTestPlanHelp")
				};				
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
				this._addPage( {
                    name: Constants.getMessage("labelImportTestPlan"),
                    widgetClass: com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader,
                    widgetArgs: args,
                    onWidgetCreated: dojo.hitch(this, function(widget) {
                        widget._header.setCSHelpButtonLabel(Constants.getMessage("labelImportTestPlanHelp"));
                    }),
                    closable: true,
                    browserTitle: browserTitle
                });
			},
			
			_onClickExportTestPlan: function()
			{
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestPlan"), content: "This is the work area for exporting a Test Plan.", closable: true, browserTitle:browserTitle});
			},
			
			viewTestPlan: function(kwArgs)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
                        var args = {
                            parentController: this,
                            model: artifactModel,
                            kwArgs: kwArgs
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },  
            
			copyTestPlan: function(kwArgs)
            {              
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor", dojo.hitch(this, function(tab, onComplete){
                        var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
                        var args = {
                            parentController: this,
                            model: artifactModel,
                            copy: true,
                            kwArgs: kwArgs
                        };
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor(args);
                        var controller = new ArtifactEditorPageController(artifactModel, tab);
                        
                        onComplete(tab, view);
                        controller.updateTab();
                    }, tab, onComplete));
                }
                var view = this._addPage({
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },             
			
			//SEARCH
            doSearch: function(args) {
                // create a search result tab and show search in progress
				var self = this;
				var searchResult = function(){
					var handlerObj = {
						success: function(results) {
							self._showSearchResults(results, args.searchText, resultsTable, page);
						},
						failure: function(error) {
							self._error(error);
	                        self._showSearchResults(null, args.searchText, resultsTable, page);
						}
					} 
					
	                var responseHandler = new ScoredResultMapper(handlerObj, "success", "failure");
	                QueryClient.getGenericSearch(responseHandler, args.searchText, args.searchScope);
				};
				
                var resultsTable = new SearchResultTableView({
                    results: null,
                    searchText: args.searchText,
					refreshCallback: searchResult
                });
                var page = this._addPage({
                               name: Constants.getMessage("labelSearchingText", args.searchText), 
                               content: resultsTable, 
                               closable: true
                           });
                resultsTable.setInProgress(Constants.getMessage("labelSearchingText", args.searchText));
                
				searchResult();
            },
			
			_showSearchResults: function(results, searchText, resultsTable, page) {
                // update search result table
				resultsTable.refresh(results);
                resultsTable.stopInProgress();
                
                if (searchText.length > 20) {
                    // compact search text for label of the tab
                    searchText = searchText.substring(0, 8) + "..." + searchText.substring(searchText.length - 5);
                }
                // update page tab button label
                dojo.publish(GlobalEvents.UpdateTabLabel, [
                                    window.location.hash,
                                    Constants.getMessage("labelSearchResult", searchText, results ? results.length : 0),
                                    null,  // no icon
                                    false, // no dirty indicator
                                    true   // don't compact the label, already taken care of
                                ]);
			},
			
            showTemplates: function() {            
                var templatesView = new com.ibm.rqm.planning.web.ui.internal.view.itemtemplates.TemplatesView();
				var browserTitle = Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelTemplates");
                var view = this._addPage({
                    name: Constants.getMessage("labelManageTemplates"),
                    content: templatesView.domNode,
                    closable: true,
					browserTitle: browserTitle
                });             
            },			

			_error: function(error) 
			{
				console.debug("PlanningActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
