/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var _textContent=dojo.isIE?"innerText":"textContent"; 

	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea", [dijit._Widget, dijit._Templated], {
        templateString: '<div>' +
        '<table style="width:95%">' +
        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
        '<tr><td class="content-text"><span dojoAttachPoint="_text"></span></td></tr>' +
        '<tr><td><div dojoAttachPoint="_content"></div></td></tr>' +
        '</table>' +
        '</div>',
        
		name: "",
        text: "",
        content: "",
        csHelpId: "CSHelpPlaceHolder.html",
        csHelpLabel: null,
		parent: null,
		dirty: false,
		
        
        postCreate: function(){
            this.setName();
            this.setText();
            this._addCSHelpID();

        },
		
		uninitialize: function(){
			if (this.csHelp) 
				this.csHelp.destroy();
		},
		
		//@Abstract: Override if necessary, but these steps are necessary so call inherited
		onSelected: function() {
			if (!this._initialized) {
	            this.setContent();		
				this._initialized = true;	
			}
			this.refresh();
		},
        
		//@Abstract: Override
        refresh: function(){
        
        },
        
		//@Abstract: Override
        setName: function(){
            this.name = Constants.getMessage("labelNameArea");
            this._name[_textContent]=this.name;
        },
        
		//@Abstract: Override
        setText: function(){
            this.text = Constants.getMessage("labelTextArea");
            this._text[_textContent]=this.text;
        },
        
		//@Abstract: Override
        setContent: function(){
            var content = document.createTextNode(Constants.getMessage("labelContentArea"));
            this.content = content;
            dojox.data.dom.removeChildren(this._content);
            this._content.appendChild(this.content);
        },
        
		//@Abstract: Override
        getValues: function(){
            return [];
        },
        
        _addCSHelpID: function(){
            var csHelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp();
            csHelp.contextID = this.csHelpId;
            if(this.csHelpLabel) {
                csHelp.setButtonLabel(this.csHelpLabel);
            }
            this._cshelp.appendChild(csHelp.domNode);
			this.csHelp=csHelp;
        }
    });
    
})();
