/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009,2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.CatalogEditor");

/*
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
*/
dojo.require("jazz.util.ResizeNotifier");

dojo.require("com.ibm.asq.common.web.ui.internal.catalog.CatalogExplorer");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableView");


(function(){
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var PartAttributeTableDialog = com.ibm.rqm.planning.web.ui.internal.view.administration.PartAttributeTableDialog;
var AlertDialog     = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var MutexEditingTag  = "catalogEditor.editing";
var MutexSavedTag   = "catalogEditor.saved";

dojo.declare("CatalogEditor.ActionRegistry",
             com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.ActionRegistry,
{   
    init: function()
    {
        this.newAction = {
            label: Constants.getMessage("labelAddNewType"),
            needSelectionEnablement: false,
            iconClass: "add-icon-image",
            callback: dojo.hitch(this.parentView, "_handleNew")
        };
        this.editAction = {
            label: Constants.getMessage("labelEditTypeAttrs"),
            needSelectionEnablement: true,
            iconClass: "edit-icon-image",
            callback: dojo.hitch(this.parentView, "_handleEditAttribute")
        
        };
        this.hideAction = {
            label: Constants.getMessage("labelHideType"),
            needSelectionEnablement: true,
            enablementCallback: dojo.hitch(this.parentView, "_enableHideAction"),
            iconClass: "hide-icon-image",
            callback: dojo.hitch(this.parentView, "_handleRemove")
        };        
        this.unHideAction = {
            label: Constants.getMessage("labelRestoreType"),
            needSelectionEnablement: true,
            enablementCallback: dojo.hitch(this.parentView, "_enableRestoreAction"),
            iconClass: "restore-icon-image",
            callback: dojo.hitch(this.parentView, "_handleRestore")
        };
        this.deleteAction = {
            label: Constants.getMessage("labelDelete"),
            needSelectionEnablement: true,
            enablementCallback: dojo.hitch(this.parentView, "_enableDeleteAction"),
            iconClass: "delete-icon-image",
            callback: dojo.hitch(this.parentView, "_handleRemove")
        };
                     
        this.rootPartContextActions = {
            actions: [
                this.editAction
            ]
        };
        this.partContextActions = {
            actions: [
                this.hideAction,
                this.editAction
            ]
        };
        this.editablePartContextActions = {
            actions: [
                this.deleteAction,
                this.editAction
            ]
        };
        this.partShowHiddenContextActions = {
            actions: [
                this.hideAction,
                this.unHideAction,
                this.editAction
            ]
        };
        this.rootPartPanelActions = {
            actions: [
                this.newAction,
                this.editAction
            ]
        };
        this.partPanelActions = {
            actions: [
                this.newAction,
                this.hideAction,
                this.editAction
            ]
        };
        this.partShowHiddenPanelActions = {
            actions: [
                this.newAction,
                this.hideAction,
                this.unHideAction,
                this.editAction
            ]
        };
    },

    getPanelActions: function(model, item)
    {
        var showHidden = this.parentView.explorer.showHiddenToggle.attr('value');
        if (item.type == "root") {
            return this.rootPartPanelActions; 
        }
        else if (item.type == "part") {
            return showHidden ? this.partShowHiddenPanelActions : this.partPanelActions; 
        }
        return null;
    },
    
    getContextActions: function(model, item)
    {
        var showHidden = this.parentView.explorer.showHiddenToggle.attr('value');
        var isRootType = item.parent.type == "root";
        
        if (item.type == "part") {
            if(model.isLabelEditable(item)) {
                return this.editablePartContextActions;
            }
            else if(isRootType) {
                return this.rootPartContextActions;
                
            }
            return showHidden ? this.partShowHiddenContextActions : this.partContextActions; 
        }
        return null;
    }
});
    
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.CatalogEditor", 
             com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, 
{
    /*    
     * Keep the 'independent page layout here for now. Just in case we need to change our minds again... 
     *
    templateString: '<div id="${id}" class="com-ibm-rqm-catalog-editor" dojoAttachPoint="domNode">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoType="com.ibm.asq.common.web.ui.internal.catalog.CatalogExplorer" dojoAttachEvent="getIconClass:_getIconClass, getLabelClass:_getLabelClass" dojoAttachEvent="explorer" allowAutoResize="false" numVisiblePanels="4" canShowHidden="true" partIsAlwaysContainer="true" width="100%" height="400px">' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',
    */                    
    templateString: '<div id="${id}" class="com-ibm-rqm-catalog-editor" dojoAttachPoint="domNode">' +
                    '  <div style="margin-bottom: 12px;">' +
                    '    <div class="content-name" dojoAttachPoint="_name"></div>' +
                    '    <div>' +
                    '      <span class="content-text" dojoAttachPoint="_text" style="float:left;"></span>' + 
                    '      <span dojoAttachPoint="_cshelp"></span>' + 
                    '    </div>' +
                    '  </div>' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.catalog.CatalogExplorer" dojoAttachPoint="explorer" allowAutoResize="false" numVisiblePanels="3" canShowHidden="true" partIsAlwaysContainer="true" width="100%" height="400px">' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
    hasStartup: false,
    needRefreshOnActivate: true,  // to indicate that our refresh needs to be called when the page is in focus.
    
    initIds: function()
    {
        this.csHelpId = "rtlm_cust_catalog.html";
        this.csHelpLabel = Constants.getMessage("labelCustomizeCatalogHelp");
        this.editorId = "CatalogTypeEditor";
        this.editorName = Constants.getMessage("labelCustomizeCatalog");
    },

    postCreate: function()
    {
        this.initIds();
        this.inherited("postCreate", arguments);
        this.model = this.explorer.model;
        this.newEnvironmentItem = [];

        // get notification when item's name is edited.
        this.model.addLabelChangedListener(this);
        
        /*
        this.viewHeaderNode.setTitle(Constants.getMessage("labelCustomizeCatalog"));
        this._cancelButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
        this._cancelButton.disabled = true;
        this._saveButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
        this._saveButton.disabled = true;
        
        this.explorer.installActionRegistry(new CatalogEditor.ActionRegistry({parentView: this}));
        this.explorer.loadModelContents();
        */
       // We're disabling the explorer's auto resize on window's size change.
       // This is neccessary to constraint the explorer's size. Handle resizing
       // here explicitly.
       this.resizeNotifierId = jazz.util.ResizeNotifier.register({context: this, callback: "_resizeHandler"});
       
       // Note: our explorer is not initialized until this page is visited. Please see
       // the refresh method for details. 
    },
    
    // @override
    setDirty: function(dirty){            
        var editTag = dojo.getObject(MutexEditingTag);

        // User ignored our warning and went editing anyway. Don't 
        // really mark this dirty. Just keep an internal flag. This 
        // edit doesn't count. 
        if(dirty && editTag && editTag.id != this.editorId) {
            this.unauthorizedEdit = true;
            return;
        }
        this.inherited("setDirty", arguments);
        
        // grab the edit mutex
        if (dirty && !editTag) {
            dojo.setObject(MutexEditingTag, {
                id: this.editorId,
                name: this.editorName
            });
        } 
    },
    
    onLabelChanged: function(item)
    {
        this.setDirty(true);
    },
    
    _handleEditAttribute: function(parentItem, inChild)
    {
        var sHidden = (this.explorer.showHiddenToggle.attr('value') == "on") || false;

        this.settingsDialog = new PartAttributeTableDialog({ 
		  showHidden: sHidden,
		  templates:  this.explorer.model.getCatalog().getAssignableTemplateNamesFromSandbox(inChild.part),
		  onOkClicked: dojo.hitch(this, function(hasModified){
		      if(hasModified) {
			     this.setDirty(true);
			  }
		  })
		});
        this.settingsDialog.show(inChild);
    },
    
    
    _handleNew: function(parentItem, inChild)
    {
        
        if(parentItem && parentItem.id == "root"){
            //show dialog that allow to be added as Test plan environment type
            this._displayEnvironmentDialog(parentItem, inChild);
        }
        else{        
            var parent = inChild || parentItem;
            var model = this.explorer.model;
            var newItemPos = model.addNewItem(parentItem, inChild);
            var newItem = parentItem.children[newItemPos];
                
            // explicitly add the item to the display tree.
            this.explorer.htree.addItem(parent, newItem, newItemPos);
            this.setDirty(true);
        }    
        
        
       
    },
     
    _handleRemove: function(parentItem, item)
    {
        var model = this.explorer.model;
        var showHidden = this.explorer.showHiddenToggle.attr('value');
        var remove = (!showHidden || model.isLabelEditable(item));
        
        model.removeItem(parentItem, item);
        this._removeFromEnvironments(item);
        
        if (remove) {
            this.explorer.htree.removeItem(parentItem, item);
        }
        else {
            this.explorer.htree.updateItem(parentItem, item);
            this.explorer.htree.updateAllPanelActions();   
        }    
        this.setDirty(true);
    },
    
     _removeFromEnvironments: function(item){
         
         for(var i= 0;i <this.newEnvironmentItem.length; i++){
             if(this.newEnvironmentItem[i] == item){
                 this.newEnvironmentItem.splice(i,1);
                 break;
             }
         }
     },

    _handleRestore: function(parentItem, item)
    {
        var model = this.explorer.model;
        
        model.restoreItem(parentItem, item);
        
        this.explorer.htree.updateItem(parentItem, item);
        this.explorer.htree.updateAllPanelActions();   
        this.setDirty(true);
    },
    
    _enableRestoreAction: function(model, item)
    {       
        return this._checkAttr(item, "hidden");
    },
    
    _enableHideAction: function(model, item)
    {
        return !(model.isLabelEditable(item) || this._checkAttr(item, "hidden") || this._checkPredAttr(item, "hidden") || this._checkDescAttr(item, "hidden")); 
    },

    _enableDeleteAction: function(model, item)
    {
        return model.isLabelEditable(item);
    },

    _resizeHandler: function()
    {
        var contentBox = dojo.contentBox(this.domNode);
        if(contentBox.w > 0) {
            contentBox.h = 400;
            this.explorer.htree.resize(contentBox);
        }
    },
    
    initCatalogExplorer: function()
    {
        this.explorer.installActionRegistry(new CatalogEditor.ActionRegistry({parentView: this}));      
        this.explorer.htree.getLabelClass = dojo.hitch(this, "_getLabelClass");  
        this.explorer.loadModelContents();
    },
     
    //@Abstract: Override
    confirmationRequired: function(){
        return true;
    },
     
     //@Abstract: Override
     onConfirmation: function(){
        var foundNoChild = false;
        var childessType="";
        for(var i= 0;i <this.newEnvironmentItem.length; i++){
            if(!this.newEnvironmentItem[i].children || (this.newEnvironmentItem[i].children.length == 0)){ 
                foundNoChild= true;
                childessType+= " " + this.newEnvironmentItem[i].name; 
            } 
       }
       if(foundNoChild == false)
          this.parent.confirmationFinished(true);
       else{
           var self = this;
           var args = {
                okCallback: function() {
                    var parent = self.parent;
                    if(parent && parent.confirmationFinished){
                        parent.confirmationFinished(true);
                    }
                },
                cancelCallback: function() {
                    var parent = self.parent;
                        if(parent && parent.confirmationFinished){
                            parent.confirmationFinished(false);
                        }
                }
            };
                                
            var label1 = document.createElement("label");
            label1.innerHTML = Constants.getMessage("labelWarningNoTypeChild", childessType);
            var div = document.createElement("div"); 
            div.appendChild(label1); 
            this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
            this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
            this.confirmDialog.contentContainer.appendChild(div);
            this.confirmDialog.open();    
       }
     },
        
    //@Abstract: Override
    onValidate: function(){
       
        var hasError = this.model.hasEditErrors();
        return {pass: !hasError, message: (hasError ? Constants.getMessage("msgDuplicateTypeName") : "")}; 
    },
    
    //@Abstract: Override
    refresh: function()
    {
        // We live inside the administration properties page. We're only one of the
        // editors in that page. Don't activate the explorer, hence the loading of the
        // catalog sandbox until we're visited, which is when this method is called.
        // Initialize our content in our first visit.
                
        var editTag = dojo.getObject(MutexEditingTag);
        var hasForeignEdit = (editTag && editTag.id != this.editorId);
        
        if (hasForeignEdit) {
            // warn the user about the 'other' catalog editor is making editing.
            var warningDialog = new AlertDialog({
                'message': Constants.getMessage("msgWarnMultiEditSession", editTag.name)
            });
            warningDialog.setSecondaryTitle("");
            warningDialog.open();
        }
        if(!this.hasStartup) {     
            this.initCatalogExplorer();
            this.hasStartup = true;
        }
        else {            
            // don't refresh the explorer after we've shown. This would
            // cause the explorer to take up more space. The parent of the
            // admin editor allows the size to grow and doesn't restrict
            // the child content size. We'll explicitly handle resize 
            // here and pass in the size of this domNode to constraint
            // the explorer size. See resizeHandler. But if we don't have a
            // valid size yet and we are in view, refresh now.
            //
            if(!this.explorer.hasValidSize()) {
                this.explorer.refresh();
                this._resizeHandler();
            }
            
            // process mutex saved tag. If the editor saved the editing,
            // we have to reload the model (catalog sandbox) to pickup the 
            // latest changes and stateId. 
            var savedTag = dojo.getObject(MutexSavedTag);
            if (!editTag && savedTag && savedTag.id != this.editorId) {
                // handle the dirty case. If the user gone against our warning
                // and made 'unauthorized' changes here, tell the user that he
                // is about to lose them. Se la vi.
                if (this.unauthorizedEdit) {
                    // Alert the user that we'll reinitialize the sandbox and all of 
                    // the changes will be cleared.
                    var alertDialog = new AlertDialog({
                        'message': Constants.getMessage("msgAlertReloadCatalogContents", savedTag.name),
                        'okCallback': dojo.hitch(this, function(){
                            this.explorer.reloadModel();
                        })
                    });
                    alertDialog.setSecondaryTitle("");
                    alertDialog.open();
                }
                else {
                    // re-initialize the catalog explorer's sandbox
                    // this will update the stateId of the sandbox
                    this.explorer.reloadModel();
                }
                // we can clear the saved tag, now that we've processed it.
                dojo.setObject(MutexSavedTag, null);
            }
        }
    },
    
    //@Abstract: Override
    setName: function()
    {
        this.name = Constants.getMessage("labelCustomizeCatalog");
        dojox.data.dom.removeChildren(this._name);
        var name = document.createTextNode(this.name);
        this._name.appendChild(name);
    },
	
    //@Abstract: Override
    setText: function()
    {
        this.text = Constants.getMessage("labelCustomizeCatalogText");
        dojox.data.dom.removeChildren(this._text);
        var text = document.createTextNode(this.text);
        this._text.appendChild(text);
    },
    
    //@Abstract: Override
    setContent: function()
    {
    },
    
    //@Abstract: Override
    getValues: function()
    {
    },

    //@Abstract: Override
    onSave: function()
	{
		if(this.isDirty()) {
            // make sure that we've the edit mutex before saving the changes.
            var editTag = dojo.getObject(MutexEditingTag);
            
            // we have made 'un-authorized' changes. Don't save it.
            if(!editTag || editTag.id != this.editorId) {
                return;
            }
            
            this.parent.addSaveParticipantNum();

            this.model.updateCatalog(dojo.hitch(this, function(status){
                this.setDirty(false);
                this.parent.saveFinished();
                
                // clear the mutex edit flag.
                var editTag = dojo.getObject(MutexEditingTag);
                if(editTag && editTag.id == this.editorId);
                    dojo.setObject(MutexEditingTag, null);

                // set the saved flag.
                dojo.setObject(MutexSavedTag, {
                    id: this.editorId,
                    name: this.editorName
                });
                
                if(status.hasError) {
					var message = status.responseText != null ? status.responseText : status.errorMessage;
                    this.setSaveErrorMessage(Constants.getMessage("msgSaveCatalogError"), message);  
                }
                else {
                    this.setSuccessMessage(Constants.getMessage("msgSavedSuccessfully"));
                    this.explorer.reloadModel();
                    
                    var alertDialog = new AlertDialog({
                        'message': Constants.getMessage("msgSavedCatalogSuccessfully")
                    });
                    alertDialog.setSecondaryTitle("");
                    alertDialog.open();
                }
            }));
		}
	},
	
	//Internal method that allow the user to assign a new Type to the available Test plan enviroments
    _displayEnvironmentDialog: function(pItem, inChild){
        
        var parent = inChild || pItem;
        var model = this.explorer.model;
        var newItemPos = model.addNewItem(pItem, inChild);
        var newItem = pItem.children[newItemPos];
        
        //Creating the Environment dialog
        var tr = document.createElement("tr");
        var td = document.createElement("td");
        var inputLabel = document.createElement("label");
        var input = document.createElement("input");
        input.style.border =  "1px solid #69AAAA";
        input.value = newItem.name;
        
        //Input that will include the Type name:    
        this._inputNewElement = input;
         
        var text = document.createElement("label");
        text.innerHTML = Constants.getMessage("labelTypeName");
        text.style.paddingTop = "10px";
         
        inputLabel.appendChild(input);
        td.appendChild(text);
        td.appendChild(inputLabel);
        tr.appendChild(td);
        
        var table = document.createElement("table");
        var row = table.insertRow(0);
        var cell = row.insertCell(0);
        cell.appendChild(text);
        cell = row.insertCell(1);
        cell.appendChild(inputLabel);
        
        
        row = table.insertRow(1);
        var inputLabel2 = document.createElement("label");
        var checkBox = document.createElement("input");
        checkBox.type = "checkbox";
        
        this._dialogCheckbox = checkBox;
        inputLabel2.appendChild(checkBox);
              
        cell = row.insertCell(0);
        cell.colSpan = 2;
            
        var checkBoxLabel = document.createElement("label");
        checkBoxLabel.innerHTML = Constants.getMessage("labelAddAsEnvironment");
        checkBoxLabel.style.padding = "2px";  
           
        var div = document.createElement("div");
        div.appendChild(inputLabel2); 
        div.appendChild(checkBoxLabel);
        div.style.paddingBotton = "5px"; 
        div.style.paddingTop = "19px";
        cell.appendChild(div);
       
        var args = {
            okCallback: dojo.hitch(this, "_onOkEnvironmentClicked", pItem, newItem,newItemPos),
            cancelCallback: dojo.hitch(this, "_onCancelEnvironmentClicked", pItem, newItem)
        };
        
        this.environmentDialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
        this.environmentDialog.setTitle(Constants.getMessage("labelNewTypeTitle"));
        this.environmentDialog.contentContainer.appendChild(table); 
        var cshelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp({contextID: "rtlm_catalog_add_type.html"});
        cshelp.setButtonLabel(Constants.getMessage("execution_addstepCSHelp"));     
        this.environmentDialog.setSecondaryTitleNode(cshelp.domNode);
        this.environmentDialog.open();
        
    },
        
        
    
    _onOkEnvironmentClicked: function(pItem, newItem, newItemPos){
           
        var model = this.explorer.model;
        model.labelChanged(newItem, this._inputNewElement.value);
           
        //If set sub types as test plan environment is selected
        if(this._dialogCheckbox && this._dialogCheckbox.checked){
            for(var i=0; i<pItem.children.length;i++){
                // search for the Machine type to include on it a new attribute
                if(pItem.children[i].id == "root.Machine"){
                    var machineItem = pItem.children[i];
                    machineItem.part.createAttribute("ConfigurationPartType", newItem.name, true,newItem.name, machineItem.part.getTemplate().getId(), []);
                    break;
                }
            }
                
            // Set whitchTag to the new item
            var path = {components: {component: ["Machine",newItem.name]}};
            model.setWhitchTagOnItem(newItem, newItem.name, path);
            this.newEnvironmentItem.push(newItem);
        }
            
        this.explorer.htree.addItem(pItem, newItem, newItemPos,newItemPos);
        this.setDirty(true);    
    },
        
     
    _onCancelClicked: function(parentItem, item){
          
        var model = this.explorer.model; 
        model.removeItem(parentItem, item);
        
    },  
        
        
    // Summary:
    //    Internal method to check an item's attribute value, supported 'attributes' are:
    //    part's hidden and part's showInWhitch attributes.
    //
    _checkAttr: function(item, attr)
    {
        if(item.type != "part")
            return false;
        
        if(attr == "hidden") {
            return item.part.isHidden();
        }
        else if(attr == "whitchTagged") {
            return item.part.hasWhitchTag();
        }
        return false;
        
    },
    
    _checkPredAttr: function(item, attr) 
    {
        var parent = item.parent;
        var hasAttr = false;
        
        if(parent) {
            if(this._checkAttr(parent, attr))
                return true;
            else {
                hasAttr = this._checkPredAttr(parent, attr);
            }
        }
        return hasAttr;
    },
    
    _checkDescAttr: function(item, attr) 
    {
        // Call the model's chek attribute method. We might not have
        // loaded all of our descendants. This ensures that we return
        // an accurate test for the attribute in our descendants at
        // the model level.
        return this.model.checkDescendantsHasAttribute(item, attr);
    },
    
    _getIconClass: function(item, opened)
    {
        return null;        
    },
    
    _getLabelClass: function(item)
    {
        var showHidden = this.explorer.showHiddenToggle.attr('value');
        
        if(showHidden && (this._checkAttr(item, "hidden") || this._checkPredAttr(item, "hidden"))) {
            return "com-ibm-rqm-catalog-editor-text-strike-thru";
        }
        
        if(this.model.isLabelEditable(item)) {
            if(this.model.hasError(item))
                return "com-ibm-rqm-catalog-editor-text-error";
                
            return "com-ibm-rqm-catalog-editor-text-italic";
        }
        return null;
    },
    
    
    destroy: function()
    {
        this.inherited("destroy", arguments);
        
        // clears the mutex tags
        var tag = dojo.getObject(MutexEditingTag);
        if(tag && tag.id == this.editorId);
            dojo.setObject(MutexEditingTag, null);
            
        tag = dojo.getObject(MutexSavedTag);
        if(tag && tag.id == this.editorId);
            dojo.setObject(MutexSavedTag, null);
            
        if (this.resizeNotifierId) {
            jazz.util.ResizeNotifier.unregister(this.resizeNotifierId);
            delete this.resizeNotifierId;
        }
    }
        
});
    
})();
