/***ESCA************************************************************************ 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea", 
		com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
		className: "com.ibm.rqm.execution.web.ui.internal.view.administration.ExecutionStatesEditor",
        csHelpId: "rqm_admin_exec_state.html",
		
		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelExecutionStatesHelp"));
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelExecutionStates");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelManageExecutionStates");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			jazz.core.loader.load_async(this.className, dojo.hitch(this, "_showEditor"));
			//this._showEditor();
        },

        _showEditor: function() {
			var editorConstructor = dojo.getObject(this.className);
			if (editorConstructor) {
	            dojox.data.dom.removeChildren(this._content);
	            this._editor = new editorConstructor({
					container:this,
					onSaved: dojo.hitch(this, "_onSaveFinished")	
				});
				dojo.connect(this._editor, "setDirty", this, "_setDirty");
	            this._content.appendChild(this._editor.domNode);            				
			} else {
				console.error(this.declaredClass + ": Unabled to load widget: " + this.className);
			}
		},
		_notifyEditorUpdate:function(disableSave){
			if(disableSave){
				this.setErrorMessage(Constants.getMessage("msgExecStateValidationError"));   
				this.parent._saveButton.setDisabled(true);
			}else{
				this.clearMessage();
				this.parent._saveButton.setDisabled(false);
			}
		},
		_setDirty: function() {
			this.setDirty(this._editor.isDirty());
		},
		
		onSave: function() {
			if (this._editor && this._editor.isDirty()) {
				this.parent.addSaveParticipantNum();
				this._editor.doSave();
			}
		},
		
		_onSaveFinished: function(status) {
			//append error message if necessary
			if (!status.ok) {
				this.setErrorMessage(Constants.getMessage("msgCategorySaveError"), status.errorMessage);
			}
			else{
			    this.setDirty(false);
			}
			this.parent.saveFinished();
		},
		
        getValues: function(){
        	return [];
        }
    });
})();
