/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.FeedViews");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.FeedViewsContentArea");

(function(){
    var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var Constants 		= com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.FeedViews", 
                  com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor, {
        
        _feedViewsContentArea: null,
       
		constructor: function(){
            this.headerTitle = Constants.getMessage("labelAdministration");
        },
		
		postCreate: function(){
			// create the content area
            this._feedViewsContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.FeedViewsContentArea();
            
			this.inherited("postCreate", arguments);
			
			// intro text
			var introContent = new FeedViews.IntroContentArea();
			this._contentArea.appendChild(introContent.domNode);
		},
		
        setNameContentPairs: function(){
			
			var feedViewsContentArea = this._feedViewsContentArea;
        
	        this._nameContentPairs = [
	            {
	                "name": Constants.getMessage("labelExeResults"),
	                "content": feedViewsContentArea,
					"resourceType": "executionresult"
	            },
	            {
	                "name": Constants.getMessage("labelTestCases"),
	                "content": feedViewsContentArea,
					"resourceType": "testcase"
	            },
	            {
	                "name": Constants.getMessage("labelEWIs"),
	                "content": feedViewsContentArea,
					"resourceType": "executionworkitem"
	            },
				{
	                "name": Constants.getMessage("labelTestPlans"),
	                "content": feedViewsContentArea,
					"resourceType": "testplan"
	            },
	            {
	                "name": Constants.getMessage("labelTestScripts"),
	                "content": feedViewsContentArea,
					"resourceType": "testscript"
	            }
            ]
        },
        
        // overridden to handle switching the feed url
        displayContent: function(){
			this.inherited("displayContent", arguments);
            var name = this.getName();
			var nameContentPairs = this._nameContentPairs;
			var length = nameContentPairs.length;
			var feedViewsContentArea = this._feedViewsContentArea;
            for (var i = 0; i < length; i++) {
				var nameContentPair = nameContentPairs[i];
                if (nameContentPair.name == name) {
                	var resourceType = nameContentPair.resourceType;
                	feedViewsContentArea.setFeedType(resourceType);
		            feedViewsContentArea.setName(name);
                    break;
                }
            }
        },
        
		__sentinel: null // terminates this class definition
        
    });
    
	dojo.declare("FeedViews.IntroContentArea", 
				 [com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea], {
				 
		csHelpId: "rqm_pref_feed_views.html",
		
		// Overridden
		setName: function(){
		    this.name = Constants.getMessage("labelFeedViews");
		    dojox.data.dom.removeChildren(this._name);
		    var name = document.createTextNode(this.name);
		    this._name.appendChild(name);
		},
	        
		// Overridden
	     setText: function(){
	         this.text = Constants.getMessage("labelFeedViewsText");
	         dojox.data.dom.removeChildren(this._text);
	         var text = document.createTextNode(this.text);
	         this._text.appendChild(text);
	     },
	     
		// Overridden
        setContent: function(){
        },
	     
				 
		__sentinel: null // terminates this class definition
	});
    
})();
