//MSCCA
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptConverterDictionaryContentArea");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptDictionary");
dojo.require("dijit.form.CheckBox");

(function() { // module container 

var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var PreferenceClient				= com.ibm.rqm.planning.web.client.internal.PreferenceClient;
var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
var KEY 							= Constants.MANUALSCRIPT_CONVERTOR_DICTIONARY_CATEGORY;
var ManualScriptDictionary			= com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptDictionary;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptConverterDictionaryContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
	
	rowCounter: 0,
	constructor: function(){
		this.csHelpId = "rqm_pref_ms_dict.html";
		this.resourceNodes = [];
		this._itemType = Constants.getMessage("labelManualScriptDictionary");
		this.locations = [];
	},
	
	postCreate: function(){
        this.inherited("postCreate", arguments);
		this.csHelp.setButtonLabel(Constants.getMessage("labelManualScriptDictionaryHelp"));
    },
	
	setName: function(){
		this.name = Constants.getMessage("labelManualScriptDictionary");
        dojox.data.dom.removeChildren(this._name);
        var name = document.createTextNode(this.name);
        this._name.appendChild(name);
    },
    
    setText: function(){
		this.text = Constants.getMessage("msgManualScriptDictionary");
        dojox.data.dom.removeChildren(this._text);
        var text = document.createTextNode(this.text);
        this._text.appendChild(text);
    },
    
    setContent: function(){
		var option = new com.ibm.asq.common.web.client.internal.option();
		var responsehandler = new ServiceResponseHandler(this, "createContentArea", "_error")
		option.getProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY);
    },
	
	createContentArea: function(prefEntry){
		this.prefEntry = prefEntry;			
		var values = prefEntry ? dojo.fromJson(prefEntry.value) : {};
		var rpValues = values.rps ? values.rps : [];
		dojox.data.dom.removeChildren(this._content);
		this._scriptGenerationDisabled = values.disableGeneration ? values.disableGeneration : false;		
		this.reportingStepSection = new ManualScriptDictionary({parentEditor: this, title: Constants.getMessage("labelReportingStep"), editCallback: dojo.hitch(this, this.onChange), items: rpValues});
		this.reportingStepSection.initialize();
		this._content.appendChild(this._getEnablementFragment());
		this._content.appendChild(this.reportingStepSection.domNode);
		this.setDirty(false);
	},
	
	isScriptGenerationDisabled: function(){
		return this.scriptGenerationButton.checked;
	},
	
	_getEnablementFragment: function(){
		var doc = document;
		var fragment = doc.createDocumentFragment();
		var args = {
				'checked': this._scriptGenerationDisabled,
				onClick: dojo.hitch(this, this.onChange)
			};
		var checkNode = new dijit.form.CheckBox(args);
		var textNode = doc.createElement('label');
		textNode.innerHTML = Constants.getMessage("labelDisableScriptGeneration");
		fragment.appendChild(checkNode.domNode);
		fragment.appendChild(textNode);
		this.scriptGenerationButton = checkNode;
		fragment.appendChild(doc.createElement("br"));
		fragment.appendChild(doc.createElement("br"));
		return fragment;
	},
	
    getValues: function(){
		var res = [];
		var rpValues = this.reportingStepSection.getValues();
		var object = {
			vps: [],
			rps: rpValues,
			disableGeneration: this.isScriptGenerationDisabled()
		}
    	return object;
    },
	
	onChange: function(changeValue){
		this.setDirty(true);
	},
	
	onSave: function(){
		var option = new com.ibm.asq.common.web.client.internal.option();
		this.parent.addSaveParticipantNum();
		var self = this;
		var handler = {
			success: function(results){
			    self.setDirty(false);
				self.parent.saveFinished();
				self.prefEntry = results;
			},
			error: function(e){
			    self._saveError(e);    
				self.parent.saveFinished();
			}
		}
				
		var responsehandler = new ServiceResponseHandler(handler, "success", "error");
		var res = this.getValues();
		if(this.prefEntry){
			option.updateProjectPreferences(responsehandler, getCurrentProjectArea().itemId, this.prefEntry.itemId, dojo.toJson(res));
		}else{
			option.createProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY, dojo.toJson(res));
		}
	}
});

})();