/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea");

dojo.require("dijit.form.CheckBox");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea", 
             com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, 
{
    templateString: '<div>' +
                    '<table>' +
                    '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp""></span></td></tr>' +
                    '<tr><td><div dojoAttachPoint="_content">' +
                    '<table>' +
                    '    <tr><td width="16px" style="vertical-align: top;">' +
                    '        <input type="checkbox" dojoAttachPoint="autoRunCheckbox" dojoType="dijit.form.CheckBox" style="margin-right:4px"/>'+
					'    </td><td><label>${labelAutoRun}</label>' +
                    '    </td></tr>' +
                    '    <tr><td width="16px" style="vertical-align: top;">' +
                    '        <input type="checkbox" dojoAttachPoint="onlyMineCheckbox" dojoType="dijit.form.CheckBox" style="margin-right:4px"/>'+
					'    </td><td><label>${labelMyDefault}</label>' +
                    '    </td></tr>' +
                    '    <tr><td width="16px" style="vertical-align: top;">' +
                    '        <input type="checkbox" dojoAttachPoint="filterOpenCheckbox" dojoType="dijit.form.CheckBox" style="margin-right:4px"/>'+
					'    </td><td><label>${labelFilterOpen}</label>' +
                    '    </td></tr>' +
					'    <tr><td colspan="2"><br/>' +
                    '        ${labelDefaultArtifactListViewMode}:<br>' +
                    '        <span dojoAttachPoint="defaultViewMode"></span>' +
			        '    <br/></td></tr>' +
                    '    <tr><td colspan="2" style="padding-top: 10px;">' +
                    '        <label class="note-text">${labelNote}</label><label class="note-text">${labelArtifactListsNote}</label>' +
                    '    </td></tr>' +
                    '</table>' +
                    '</div></td></tr>' +
                    '</table>' +
                    '</div>',
    
    autoRunKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key,
	onlyMineKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_ONLY_MY_ASSETS_CATEGORY.key,
    filterOpenKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key,
    defaultViewModeKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_DEFAULT_VIEW_MODE.key,
    widgetsInTemplate: true,
    
	pageTitle: Constants.getMessage("labelArtifactViewBuilderSettings"),
    labelAutoRun: Constants.getMessage("labelAutoRunQuery"),
	labelMyDefault: Constants.getMessage("labelShowOnlyMyByDefault"),
    labelFilterOpen: Constants.getMessage("labelOpenQueryFilterSection"),
    labelAutoRunDescription: Constants.getMessage("labelAutoRunMyQueryDescription"),
    labelFilterOpenDescription: Constants.getMessage("labelOpenQueryFilterDescription"),
    labelArtifactListsNote: Constants.getMessage("labelArtifactListsNote"),
    labelNote: Constants.getMessage("labelNote"),
    labelDefaultArtifactListViewMode: Constants.getMessage("labelDefaultArtifactListViewMode"),
    
    postCreate: function(){
		// NOTE: not used. We didn't make the CS help content
		// cut off date. We need to add it later. The _cshelp content
		// node's display is turned off at this point.
		//
        this.csHelpId = "rqm_pref_artifact_list.html";
        this.csHelpLabel = Constants.getMessage("labelActionBarHelp");
		
		// radio buttons for default view mode.  choices are table, tree, htree (explorer)
        this.tableDefaultViewModeRadio = new dijit.form.RadioButton({value:"table",checked:true,name:"defaultViewMode"});
		this.tableDefaultViewModeRadio.style.marginRight="4px";
		this.connect(this.tableDefaultViewModeRadio, "onChange", "onChange");
        var text = document.createTextNode(" " + Constants.getMessage("labelViewAsTable"));
        var br = document.createElement("br");
        this.defaultViewMode.appendChild(this.tableDefaultViewModeRadio.domNode);
		this.defaultViewMode.appendChild(text);
		this.defaultViewMode.appendChild(br);
        
        this.treeDefaultViewModeRadio = new dijit.form.RadioButton({value:"tree",name:"defaultViewMode"});
		this.treeDefaultViewModeRadio.style.marginRight="4px";
		this.connect(this.treeDefaultViewModeRadio, "onChange", "onChange");

        var text2 = document.createTextNode(" " + Constants.getMessage("labelViewAsTree"));
        var br2 = document.createElement("br");
        this.defaultViewMode.appendChild(this.treeDefaultViewModeRadio.domNode);
		this.defaultViewMode.appendChild(text2);
		this.defaultViewMode.appendChild(br2);
		
        this.htreeDefaultViewModeRadio = new dijit.form.RadioButton({value:"htree",name:"defaultViewMode"});
		this.htreeDefaultViewModeRadio.style.marginRight="4px";
		this.connect(this.htreeDefaultViewModeRadio, "onChange", "onChange");
        var text3 = document.createTextNode(" " + Constants.getMessage("labelViewAsExplorer"));
        var br3 = document.createElement("br");
        this.defaultViewMode.appendChild(this.htreeDefaultViewModeRadio.domNode);
		this.defaultViewMode.appendChild(text3);
		this.defaultViewMode.appendChild(br3);
		
        this.inherited("postCreate", arguments);
        this.connect(this.autoRunCheckbox, "onChange", "onChange");
        this.connect(this.filterOpenCheckbox, "onChange", "onChange");
		this.connect(this.onlyMineCheckbox, "onChange", "onChange");
		
    },
    
    // @override for AbstractContentArea
    setName: function(){
        dojox.data.dom.removeChildren(this._name);
        this._name.appendChild(document.createTextNode(this.pageTitle));
    },
    
    // @override for AbstractPreferenceContentArea
    getValues: function(){
		var defaultViewMode = "table";
		if (this.treeDefaultViewModeRadio.checked) {
			 defaultViewMode = "tree";
		} else if (this.htreeDefaultViewModeRadio.checked) {
			 defaultViewMode = "htree";
		}
        return [{
            key: this.autoRunKey,
            value: this.autoRunCheckbox.checked
        },{
            key: this.onlyMineKey,
            value: this.onlyMineCheckbox.checked
        },{
            key: this.filterOpenKey,
            value: this.filterOpenCheckbox.checked
        },{
            key: this.defaultViewModeKey,
            value: defaultViewMode
        }];
		
    },

    // @override set the corresponding user preference for this content area
    setUserPreference: function(userPreference) {
		// flush our old preferences first, before loading
		// the new values.
		this.userPreference = [];
		
        for(var i = 0; i < userPreference.length; i++){
            if(userPreference[i].key == Constants[this.autoRunKey].key ||
               userPreference[i].key == Constants[this.onlyMineKey].key ||
			   userPreference[i].key == Constants[this.filterOpenKey].key ||
			   userPreference[i].key == Constants[this.defaultViewModeKey].key){
                this.setOldValues(userPreference[i]);
            }
        }
        this.displayUserPreference(this.getOldValues());
    },
    
    // @override
    displayUserPreference: function(userPreference){
        for(var i = 0; i < userPreference.length; i++){
            if(userPreference[i].key == this.autoRunKey) {
                this.autoRunCheckbox.setChecked(userPreference[i].value);
            }
            if(userPreference[i].key == this.onlyMineKey) {
                this.onlyMineCheckbox.setChecked(userPreference[i].value);
            }
	        if(userPreference[i].key == this.filterOpenKey) {
	            this.filterOpenCheckbox.setChecked(userPreference[i].value);
	        }
	        if(userPreference[i].key == this.defaultViewModeKey) {
				var defaultViewMode = userPreference[i].value;
				if (defaultViewMode == "tree") {
					this.treeDefaultViewModeRadio._setCheckedAttr(true);
					this.htreeDefaultViewModeRadio._setCheckedAttr(false);
					this.tableDefaultViewModeRadio._setCheckedAttr(false);
				}
				else if (defaultViewMode == "htree") {
					this.htreeDefaultViewModeRadio._setCheckedAttr(true);
					this.treeDefaultViewModeRadio._setCheckedAttr(false);
					this.tableDefaultViewModeRadio._setCheckedAttr(false);
				}else {
					this.tableDefaultViewModeRadio._setCheckedAttr(true);
					this.treeDefaultViewModeRadio._setCheckedAttr(false);
					this.htreeDefaultViewModeRadio._setCheckedAttr(false);
				}
	        }
        }
    },

    setOldValues: function(userPreference) {
        this.userPreference.push(userPreference);
    },
    
    getOldValues: function(){
        return this.userPreference;
    },
    
    getDefaultValues: function(){
        var defPref = [];
        defPref.push(Constants[this.autoRunKey]);
		defPref.push(Constants[this.onlyMineKey]);
        defPref.push(Constants[this.filterOpenKey]);
        defPref.push(Constants[this.defaultViewModeKey]);
        return defPref;
    },

    // @override for AbstractPreferenceContentArea
    isHotSwitchable: function(){
        return false;
    }
});
    
})();
