/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.RiskProfilesContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.RiskProfilesContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
		classProfilesName: "com.ibm.rqm.risk.web.ui.internal.view.table.RiskProfilesTableView",
		classDetailsName: "com.ibm.rqm.risk.web.ui.internal.view.table.RiskProfileDetailTableView",
        csHelpId: "rqm_risk_based.html",
		
		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelRiskProfilesAdminHelp"));
			jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.table.RiskProfilesTableView", function(){});
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelRiskProfiles");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelRiskProfileAdmin");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			jazz.core.internal.loader.load_async(this.classDetailsName, dojo.hitch(this, "_loadProfileClass"));
        },
		
		_loadProfileClass: function() {
			jazz.core.internal.loader.load_async(this.classProfilesName, dojo.hitch(this, "_showEditor"));
		},

        _showEditor: function() {
			if(!this.detailTable) {
				var detailConstructor = dojo.getObject(this.classDetailsName);
                if (detailConstructor) {
                    this.detailTable = new detailConstructor();
                }
                else {
                    console.error(this.declaredClass + ": Unabled to load widget: " + this.classDetailsName);
                }
			}
			if(!this.profileTable) {
				var profileConstructor = dojo.getObject(this.classProfilesName);
                if (profileConstructor) {
                    this.profileTable = new profileConstructor();
					this.profileTable.init({
						parentEditor: this,
						detailTable: this.detailTable
					});
					this.detailTable.setParentTable(this.profileTable);
                }
                else {
                    console.error(this.declaredClass + ": Unabled to load widget: " + this.classProfilesName);
                }
			}
            dojox.data.dom.removeChildren(this._content);
            this._content.appendChild(this.profileTable.domNode);
            this._content.appendChild(this.detailTable.domNode);      
		},
        
        //@Abstract: Override
        refresh: function(){
            if(this.profileTable && this.profileTable.tableViewer) {
                this.profileTable.tableViewer.refresh();
            }
            if(this.detailTable && this.detailTable.tableViewer) {
                this.detailTable.tableViewer.refresh();
            }
        },

		onSave: function(){
			this.profileTable.onSave();
		},
		
        getValues: function(){
        	return [];
        }
    });
})();
