/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.RisksContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.RisksContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
		classRisksName: "com.ibm.rqm.risk.web.ui.internal.view.table.RisksTableView",
//        csHelpId: "rqm_risk_based.html",
		
		postCreate: function(){
			this.csHelpId = "rqm_manage_custom_risks.html";
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelRisksAdminHelp"));
			jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.table.RisksTableView", function(){});
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelRisks");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelRisksAdmin");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			jazz.core.internal.loader.load_async(this.classRisksName, dojo.hitch(this, "_showEditor"));
		},

        _showEditor: function() {
			if(!this.risksTable) {
				var risksConstructor = dojo.getObject(this.classRisksName);
                if (risksConstructor) {
                    this.risksTable = new risksConstructor();
					this.risksTable.init({
						parentEditor: this
					});
                }
                else {
                    console.error(this.declaredClass + ": Unabled to load widget: " + this.classRisksName);
                }
			}
            dojox.data.dom.removeChildren(this._content);
            this._content.appendChild(this.risksTable.domNode);      
		},
        
        //@Abstract: Override
        refresh: function(){
            if(this.risksTable && this.risksTable.tableViewer) {
                this.risksTable.tableViewer.refresh();
            }
        },

		onSave: function(){
			this.risksTable.onSave();
		},
		
        getValues: function(){
        	return [];
        }
    });
})();
