/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalExtendTable");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.SummaryPopup", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/approval/SummaryPopup.html"),
        
		labelTestCaseReviewSummary: Constants.getMessage("labelTestCaseReviewSummary"),
		
        constructor: function(){
            this._childrenApprovalDTO = null;
        },
        
        postCreate: function(){
        },
        
        initialize: function(args){
            this._childrenApprovalDTO = args.childrenApprovalDTO;
            this._initialContent();
            this._initialMimi();
        },
        
        _initialContent: function(){
            var children = this._childrenApprovalDTO;
            dojox.data.dom.removeChildren(this._mainContent);
            var table = new com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalExtendTable();
            table.initialize({
                childrenApprovalDTO: this._childrenApprovalDTO
            })
            this._mainContent.appendChild(table.domNode);
        },
        
        _initialMimi: function(){
            var approved = 0;
            var reviewed = 0;
            var rejected = 0;
            if (this._childrenApprovalDTO != null) {
                for (var i = 0; i < this._childrenApprovalDTO.length; i++) {
                    var summary = this._childrenApprovalDTO[i].summary;
                    approved += summary.approveNum;
                    rejected += summary.rejectNum;
                    reviewed += summary.reviewNum;
                }
                this._approvedNum.innerHTML = approved + " " + Constants.APPROVAL_APPROVED_APPROVAL_TABLE;
                this._rejectedNum.innerHTML = rejected + " " + Constants.APPROVAL_REJECTED_APPROVAL_TABLE;
                this._reviewedNum.innerHTML = reviewed + " " + Constants.APPROVAL_REVIEWED_APPROVAL_TABLE;
            }
        }
        
    });
    
})();
