/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel");
dojo.require("com.ibm.rqm.risk.web.client.internal.risk.RiskClient");
dojo.require("com.ibm.rqm.risk.web.client.internal.mapper.RiskProfileMapper");

(function(){ // module container
    /* Jazz objects */
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    /* QM objects */
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var FilterListPanel		= com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel;
    var RiskClient = com.ibm.rqm.risk.web.client.internal.risk.RiskClient;
	var RiskProfileMapper = com.ibm.rqm.risk.web.client.internal.mapper.RiskProfileMapper;
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var DEFAULT_COMMENT_MSG = MessageUtil.getMessage(MessageBundle.COMMON, "tableViewer_filterPrompt");
	
	dojo.declare("RiskProfileTemplateDialog.TemplateFilterListPanel", [FilterListPanel], {
        templateString: '<div id="${id}" dojoAttachPoint="domNode" tabindex="-1">' +
					' <table border="0">' +
					'  <tr>' +
					'    <td>'+
					'       <label><input type="text" dojoAttachPoint="filterBox" size="54" dojoAttachEvent="onkeyup:_onFilterChange"></label>'+
//					'		<button dojoAttachPoint="filterButton" class="action-link clear-filter"><img dojoAttachPoint="filterImg" src=""/></button>' +
					'    </td>' +
					'  </tr>' +
					'  <tr>' +
					'    <td>'+
					'       <span>${labelTemplates}</span>'+
					'    </td>' +
					'  </tr>' +
					'  <tr>' +
					'    <td>'+
					'      <label><select dojoAttachPoint="selectionList" name="selectionList" style="width: 300px" multiple=false size="10" dojoAttachEvent="onchange: _onChange">' +
					'      </select></label>' +
					'    </td>' +
					'  </tr>'+
					'</table>'+
	                '</div>',
		labelTemplates: Constants.getMessage("labelTemplatesWithColon"),
		
		postCreate :function()
		{
			this.inherited("postCreate", arguments);
		}
		
	});
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="_content">' +
        '<div style="padding-left: 15px" dojoAttachPoint="_area"></div>' +
        '</div>', 
		
        width: "350px",
    	height: "450px", 
        
        labelReplace: Constants.getMessage("labelReplace"),
        labelAppend: Constants.getMessage("labelAppend"),
		
        // object initializer
        constructor: function(args){
			this.artifactType = args.artifactType;
			this.appendCallback = args.appendCallback;
			this.replaceCallback = args.replaceCallback;
			this.okCallback = args.okCallback;
			this.actionId = args.actionId;
        },
        
		postCreate: function() {
			if(!this.artifactType) {
				throw new Error("Parameter 'artifactType' is REQUIRED!");
			}
			var args = {
				artifactType: this.artifactType
			}
	        var responseHandler = new RiskProfileMapper(this, "_initialize", "_error");
            RiskClient.getRiskProfileDTOs(responseHandler, args);
		},	
		
        _initialize: function(riskProfiles){
			this.riskProfiles = riskProfiles ? riskProfiles : [];
						
            this.filterListPanel = new RiskProfileTemplateDialog.TemplateFilterListPanel();
			
            this.filterListPanel.addChangeLisner(dojo.hitch(this, "_validate"));
            for (var i = 0; i < this.riskProfiles.length; i++) {
                this.filterListPanel.addOption(this.riskProfiles[i].id, this.riskProfiles[i].profileName, this.riskProfiles[i].profileName);
            }
            
            dojox.data.dom.removeChildren(this._area);
            this._area.appendChild(this.filterListPanel.domNode);
            
            this._showAsDialog();
        },
        
        _showAsDialog: function(){
            if (!this._dialog) {
                var args = {
                    primaryTitle: Constants.getMessage("labelRiskProfileDetail"),
                    isClosable: true,
                    width: this.width,
                    contentNode: this.domNode,
					okCallback: dojo.hitch(this, "_onAppend")
                }
                this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
                this._dialog.setTitle(Constants.getMessage("labelSwitchRiskProfile"));
				
				this._dialog.getOkButton().innerHTML = this.labelAppend;

                var replaceDiv = document.createElement("span");
                this._replaceButton = document.createElement("button");
                this._replaceButton.innerHTML = this.labelReplace;
                this._replaceButton.tabIndex = "0";
				this._replaceButton.onclick = dojo.hitch(this, "_onReplace");
                replaceDiv.appendChild(this._replaceButton);
                this._replaceButton.className = "button-div";
				this._replaceButton.disabled = true;
				this._dialog.actionsContainer.insertBefore(replaceDiv, this._dialog.actionsContainer.firstChild);
		
            }
            this._dialog.open(false);
        },
        
        _onReplace: function() {
			var selectedProfile = this._getSelectedProfile();
			var args = {
				actionId: this.actionId,
				selectedProfile: selectedProfile,
				handleAction: "replace" //won't translate!!
			};
			if(this.replaceCallback) {
				this.replaceCallback(args);
			}
			else if(this.okCallback) {
				this.okCallback(args);
			}
			this._dialog.close();
		},
		
		_onAppend: function() {
			var selectedProfile = this._getSelectedProfile();
			var args = {
				actionId: this.actionId,
				selectedProfile: selectedProfile,
				handleAction: "append" //won't translate!!
			};
			if(this.appendCallback) {
				this.appendCallback(args);
			}
			else if(this.okCallback) {
				this.okCallback(args);
			}
		},
		
        _onCancel: function(){
        },
		
		_validate: function(){
            var currentValues = this.filterListPanel ? this.filterListPanel.getSelectedItems() : [];
            if (currentValues.length != 1) {
				this._replaceButton.disabled = true;
				this._dialog.getOkButton().disabled = true;
			}
			else {
				this._replaceButton.disabled = false;
				this._dialog.getOkButton().disabled = false;
			}
    	},
	
		_getSelectedProfile: function() {
            var selectedId = this.filterListPanel.getFirstSelectedValue();
            for (var i = 0; i < this.riskProfiles.length; i++) {
				if(this.riskProfiles[i].id == selectedId)
					return this.riskProfiles[i];
            }
			return null;
		},
		
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ RiskProfileTemplateDialog#_error");
        }
    });
    
})();
