/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

var Clipboard = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.Clipboard");

Clipboard.items = [];
Clipboard.counter = [];//unique number for each item
(function() {
	com.ibm.rqm.planning.web.ui.internal.view.common.Clipboard = {
		addItems:function(items,type){
			if (dojo.isArray(items)&& type) {
				var _items = Clipboard.items[type]||[];
				var counter = Clipboard.counter[type]||0;
				var len = items.length;
				for(var i=0;i<len;i++){
					items[i].index = counter+i;
				}
				counter = counter+len;
				Clipboard.counter[type] = counter;
				_items = _items.concat(items);
				Clipboard.items[type] = _items;
				dojo.publish("ClipboardUpdate",[type]);
				return _items;
			}
			return null;
		},
		removeItems:function(items,type){
			if (dojo.isArray(items) && type) {
				var _items = Clipboard.items[type]||[];
				var len2 = items.length;
				for (var j = 0; j < len2; j++) {
					var len = _items.length;
					var rowNum = -1;
					var index = items[j].index;
					for (var i = 0; i < len; i++) {
						if (_items[i].index == index) {
							rowNum = i;
							break;
						}
					}
					if (rowNum != -1) 
						_items.splice(rowNum, 1);
				}
				Clipboard.items[type] = _items;
				dojo.publish("ClipboardUpdate",[type]);
				return _items;
			
			}
			return null;
		},
		clear:function(type){
			if (type) {
				delete (Clipboard.items[type]);
				dojo.publish("ClipboardUpdate", [type]);
				Clipboard.items[type] = [];
			}
		},
		getItems:function(type){
			if (type) {
				var items = Clipboard.items[type] || [];
				return items;
			}
			return null;
		}
	
	};
})();
