/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.client.internal.Constants");

(function() { // module container
var _textContent=dojo.isIE?"innerText":"textContent"; 

var Constants = com.ibm.asq.common.web.client.internal.Constants;

dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionPrintView",
[dijit._Widget, dijit._Templated],
{    

    templateString:     '<div class="com-ibm-asq-common-web-ui-editor-section-print-view">' +
	                    '    <div class="header">' +
						'        <div class="title" dojoAttachPoint="_titleNode"></div>' +
						'    </div>' +
                        '    <div dojoAttachPoint="_contentNode" class="content"></div>' +					
                        '</div>',
						  
    constructor: function() {
		//AbstractArtifactEditorSection
		this.sectionProvider = null;
    },    

    postCreate: function() {	
		if (!this.sectionProvider) {
			throw new Error("EditorSectionPrintView: parameter 'sectionProvider' is REQUIRED.");
		}		
		this.renderContent(true);		
    },
	
	renderContent: function(updateContent) {  
		//add title
		var title = this.sectionProvider.getDisplayTitle();
        this._titleNode[_textContent]=title;
		
		//render main content
		var contentNode = this.sectionProvider.getMainContent(false);
		dojox.data.dom.removeChildren(this._contentNode);	   
        this._contentNode.appendChild(contentNode);
		
		//expand the section (loads any lazy data)
		var expandHandler = this.sectionProvider.getExpandHandler();
		if (dojo.isFunction(expandHandler)) {
			expandHandler();
		}
	},
	
	_onTitleClick: function() {
	   //do nothing, function not enabled	
	},
	
    //Focus on the Section's domNode. 
    setFocus: function() {
        this.domNode.focus();
    },	
	
    //////////////////////////////////////////////////////////////////////////////////////
    //     Addt'l API for Editor section support
    //////////////////////////////////////////////////////////////////////////////////////
	getProvider: function() {
		return this.sectionProvider;
	},
	
	getTitle: function() {
		return this.sectionProvider.getTitle();
	},
	
    setHeader: function(/* String || DOM Node */ header) {
        dojox.data.dom.removeChildren(this.headerRightNode);
        this.headerRightNode.appendChild(dojo.isString(header) ? document.createTextNode(header) : header);		
    },
        
    setMainContent: function(domNode) {
        dojox.data.dom.removeChildren(this.containerNode);
        this.containerNode.appendChild(domNode);
    }
});

})();
