/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){ // module container
    var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
    
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/common/FloatingDiv.html"),
        
        constructor: function(args){
			this._dialog = null;
        },
        
        postCreate: function(){
        },
        
        initialize: function(args){
			var self = this;
            if (this._dialog == null) {
                var args = {
                    isClosable: true,
					primaryTitle: args.title,
                	okCallback: dojo.hitch(this, "_onOK"),
                	cancelCallback: dojo.hitch(this, "_onCancel"),
					_truncate: function() {} 
                }
                this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
				this._dialog.setWidth("250px");	
				this._dialog.getOkButton().disabled = false;
            }
        },
        
        addChild: function(child){
            this.child = child;
			this._dialog.contentContainer.appendChild(child.domNode);
			this._dialog.open();
        },
        
        _onClose: function(e){
            this._FloatingDiv.style.display = "none";
            if(e){
                 dojo.stopEvent(e);
            }
        },
        
        _onCancel: function(e){
//            this._FloatingDiv.style.display = "none";
            if(e){
                 dojo.stopEvent(e);
            }
        },
        
        _onOK: function(e){
			this.child.onOK();
//			this._dialog.close();
//            this._FloatingDiv.style.display = "none";
            if(e){
                 dojo.stopEvent(e);
            }
        },
        
        _error: function(errorObj){
            alert("Error: (message: '" + errorObj.message + "')");
        }
    });
    
})();
