/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector");

(function(){
	
	var Constants				= com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtil  			= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var ProjectAreaSelector    =  com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector;	
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.ProjectAreaDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/ProjectArea.html"),

    	//STYLE: "position: absolute; top: 30%; left: 30%; width: 30%; height:40%",
		width: "400px",
    	title: Constants.getMessage("labelProjectAreaTitle"),
		labelSelectProjectArea: Constants.getMessage("labelSelectProjectArea"),
		labelDefaultProjectArea: Constants.getMessage("labelDefaultProjectArea"),
				            
        constructor: function(args){
            this.onOk = function(){};
			this.projectAreas = [];
        },
		
		postCreate: function() {          
		    var dialogArgs = {
				zIndex: 998, // The dojo combo box uses zindex 1000 for its popup. This zindex is to make sure the combo 
							 // shows up in front
				primaryTitle: this.title,
				okCallback: dojo.hitch(this, "_onOk"),
		        closable: false
		    };
		    this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);

		    this._dialog.setWidth(this.width);
			this._dialog.getOkButton().disabled = true;
			this._dialog.getCancelButton().style.display = "none";
		    this._dialog.contentContainer.appendChild(this.domNode);

            var paArgs = {};
            paArgs.onValueChanged = dojo.hitch(this, "_onValueChanged");
            paArgs.onEnterSelected = dojo.hitch(this, "_onEnterSelected"); 
            paArgs.onSelectorBuilt = dojo.hitch(this, "_onSelectorBuilt");                      
            this._paSelector = new ProjectAreaSelector(paArgs);  
            this._projectAreaSelect.appendChild(this._paSelector.domNode);
            
			this._dialog.open();			
		},
		
		_onSelectorBuilt: function(){
			 this._dialog.getOkButton().disabled = false;
		},
		
		_onOk: function() {
				this._paSelector.getSelection(this.onOk);
		},
		
		_onValueChanged: function(value, valid)
		{
			this._dialog.getOkButton().disabled = !valid;
		},
		
		_onEnterSelected: function(){
			if(!this._dialog.getOkButton().disabled){
				this._paSelector.getSelection(this.onOk);
				this.close();
			}				
		},
		
		_error: function(e){
            console.error(this.declaredClass + ": error: " + (e ? e.message : ""));          
        }
	
    });
      
})();
