/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.SectionGroup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.Section");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.common.SectionGroup",
			 [dijit._Widget, dijit._Templated], 
{
		
	templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/common/SectionGroup.html"),
	
	ImageCache: com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Initialization parameters
	///////////////////////////////////////////////////////////////////////////////////
	label: null,
	sectionWidgets: null,
	open: false,
	sectionIcon: 0,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Attach points
	//////////////////////////////////////////////////////////////////////////////////
	twistieImg: null,
	sectionImg: null,
	labelSpan: null,
	sectionsDiv: null,
	
	postCreate: function()
	{
		this._Loaded = false;
		this._setDisplay(this.open);
		this.sectionImg.src = this.sectionIcon;
		this.labelSpan.innerHTML= this.label;
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	///////////////////////////////////////////////////////////////////////////////////
	collapse: function() {
		this._setDisplay(false);
	},
	
	expand: function() {
		this._setDisplay(true);
	},
	
	setExpression: function(/* ExpressionDTO[] */ expressions) {
		var hasExpression= false;
		for (var i= 0; i < this.sectionWidgets.length; i++) {
			hasExpression|= this.sectionWidgets[i].setExpression(expressions);
		}
		this._setDisplay(hasExpression);
	},
	
	getWidgets: function()
	{
		return this.sectionWidgets;
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Helpers
	//////////////////////////////////////////////////////////////////////////////////
	_updateTwistie: function() {
		this.twistieImg.src= this._isVisible() ? this.ImageCache.TWISTIE_OPEN : this.ImageCache.TWISTIE_CLOSED;
	},
	
	_isVisible: function() {
		return this.sectionsDiv.style.display != "none"; //dojo.html.isDisplayed(this.sectionsDiv);
	},
	
	_setDisplay: function(show) {
		this.sectionsDiv.style.display = show ? "inline" : "none";
		this._updateTwistie();
		if(!this._Loaded && show)
		{
			
			//Lazy Loading of table
			for (var i= 0; i < this.sectionWidgets.length; i++) {
				if(dojo.isFunction(this.sectionWidgets[i].displayTable))
					this.sectionWidgets[i].displayTable();
				dojox.data.dom.removeChildren(this.sectionsDiv);
				this.sectionsDiv.appendChild(this.sectionWidgets[i].domNode);
			}
			this._Loaded = true;
		}
		
	},
		
	///////////////////////////////////////////////////////////////////////////////////
	// Event handlers
	//////////////////////////////////////////////////////////////////////////////////
	onMouseOver: function(e)
	{
		var row = e.currentTarget;
		dojo.addClass(row, "hover-bg-color");
		if(e){
            dojo.stopEvent(e);
        }
	},
	
	onMouseOut: function(e)
	{
		var row = e.currentTarget;
		dojo.removeClass(row, "hover-bg-color");
		if(e){
            dojo.stopEvent(e);
        }
	},
	
	onToggle: function(e) {
		e.preventDefault();
		if(!this._Loaded)
			this._setDisplay((this.sectionsDiv.style.display == "none") ? true : false);
		else
		{
			this.sectionsDiv.style.display = (this.sectionsDiv.style.display == "none") ? "inline" : "none"; 
			this._updateTwistie();
		}	

	}
	
});
	
