/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectStatePopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

(function() {
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil 			= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var SelectUtility       = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectStatePopup",
             [dijit._Widget, dijit._Templated], 
{
    templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/properties/SelectStatePopup.html"),
				    
	width: "450px",
    height: "450px", 
	labelState: Constants.getMessage("labelState")+Constants.getMessage("labelColen"),
		
    postCreate: function(){
    },
    
    initialize: function(args){
		this.okCallback = args.okCallback;
		this.actionId = args.actionId;
		SelectUtility.add(this._state,new Option(Constants.getMessage("labelLoading"), ""));
        this._showAsDialog();
		EditorUtil.initArtifactStates(dojo.hitch(this,"_loadStates"));
    },
    _loadStates:function(){
		dojox.data.dom.removeChildren(this._state);
		var artifactStates = EditorUtil.artifactStates;
		for(var i=0;i<artifactStates.length;i++){
			SelectUtility.add(this._state,new Option(artifactStates[i].name,artifactStates[i].id));
		}
	},
	_showAsDialog: function(){
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._dialog.setTitle(Constants.getMessage("labelChangeProperties", this.actionId));
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = false;                                
        }
        this._dialog.open(false);
    },  
	
	_okAction: function(){
		var args = {}; 		
		args.actionId = this.actionId;
		args.state = this._state.value;
        if (this.okCallback) {
            this.okCallback(args);
        }
    },
 
	_cancelAction: function(){
        if (this.cancelCallback) {
            this.cancelCallback();
        }
    }
    
});
})();