/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPhasePopup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel");

(function() {
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var FilterListPanel		= com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel;
var UNASSIGNED_TESTPHASE	= Constants.getMessage("labelUnassigned");

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPhasePopup",
             [dijit._Widget, dijit._Templated], 
{
        
    templateString: '<div dojoAttachPoint="_content">' +
        '<span dojoAttachPoint="_area"></span>' +
        '</div>',                    

	width: "300px",
    height: "450px", 
	
    postCreate: function(){  
		
    },
    
    initialize: function(args){
 		this.okCallback = args.okCallback;
        this.actionId = args.actionId;
		this.phases = args.phases;
		
 		this.filterListPanel = new FilterListPanel();
		this.filterListPanel.addChangeLisner(dojo.hitch(this, "_validate"));
//        this.filterListPanel.addOption(UNASSIGNED_TESTPHASE, UNASSIGNED_TESTPHASE, UNASSIGNED_TESTPHASE);
        for (var j = 0; j < (this.phases ? this.phases.length : 0); j++) {
            this.filterListPanel.addOption(this.phases[j].itemId, this.phases[j].name, this.phases[j].name);
        }
		
        dojox.data.dom.removeChildren(this._area);
        this._area.appendChild(this.filterListPanel.domNode);
		
		this._showAsDialog();
    },
	

    _showAsDialog: function()
    {
        if (!this._dialog) {
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_okAction"),
                cancelCallback: dojo.hitch(this, "_cancelAction")
            };
            
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._dialog.setTitle(Constants.getMessage("labelChangeProperties", this.actionId));
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = true;                                
        }
        this._dialog.open(false);
    },  
	
	_okAction: function(){
		
		var args = {};
		
 		args.actionId = this.actionId;
 
		args.testPhaseItemId = this.filterListPanel.getFirstSelectedValue() == UNASSIGNED_TESTPHASE ? null : this.filterListPanel.getFirstSelectedValue();
		
		var phases = this.phases;
		var length = phases.length;
		for(var i=0; i<length; i++){
			if(phases[i].itemId == args.testPhaseItemId){
				args.phase = phases[i];
				break;
			}
		}
		
        if (this.okCallback) {
            this.okCallback(args);
        }
    },
  
    _validate: function(){
        var currentValues = this.filterListPanel ? this.filterListPanel.getSelectedItems() : [];
        if (currentValues.length != 1) 
            this._dialog._yesButton.disabled = true;
        else 
            this._dialog._yesButton.disabled = false;
    },
			
	_cancelAction: function(){
        if (this.cancelCallback) {
            this.cancelCallback();
        }
    },
  
    _error: function(errorObj){
        console.error("Error in TestPhaseConfigSelector " + errorObj.message);
    }
    
});
})();
    
