/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var PropertiesSection = com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection;
	var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel", [dijit._Widget, dijit._Templated], {
		
        templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/GenerateEWIConfiguration.html"),
        
		labelStep1: Constants.getMessage("labelStep1"),
		labelStep2: Constants.getMessage("labelStep2"),
		labelStep3: Constants.getMessage("labelStep3"),
		labelNext: Constants.getMessage("labelNext"),
		noExistingEnvSelected: true,
		noCatalogItemSelected: true,
		
        constructor: function(args, frag){
            if (args.controller == null) {
                throw new Error("Create ConfigurationPanel#constructor: Missing required parameter 'args.parentController'");
            }
            
            this.controller = args.controller;
        },
        
        initialize: function(){
            this._initTitle();
            this._initOverview();
            this._initTCG();
            this._initEnvironment();
            this._executionwork_objImg.src = ImageCache.EWI;
        },
		
		//@Abstract - override it
		uninitialize: function(){
			return;
		},
        
		//@Abstract - override it
        _initTitle: function(){
			return;
        },
        
		//@Abstract - override it
        _initOverview: function(){
			return;
        },
        
		//@Abstract - override it
		_initTCG: function(){
            return;
        },
        
		//@Abstract - override it
        _initEnvironment: function(){
            return;
        },
        
		//@Abstract - override it
        onNext: function(){
            return;
        },
		
		enableNextButton: function(noExistingEnvSelected, noCatalogItemSelected){
			this.noExistingEnvSelected = noExistingEnvSelected != null ? noExistingEnvSelected : this.noExistingEnvSelected;
			this.noCatalogItemSelected = noCatalogItemSelected != null ? noCatalogItemSelected : this.noCatalogItemSelected;
			this._nextButtonTop.disabled = (this.noExistingEnvSelected && this.noCatalogItemSelected);
		},
        
        _error: function(errorObj){
            alert("Error: (message: '" + errorObj.message + "') from ConfigurationPanel#_error");
        }
    });
    
})();
