//EWILP
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIListPanel");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIListPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojox.uuid.generateRandomUuid");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.table.GeneratedEWITableView");
dojo.require("com.ibm.asq.common.web.client.internal.option");

dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup");

dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function(){ // module container
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var WHITCHClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
    var TestConfigurationUtil = com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
    var FloatingDiv = com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv;
    var ReassignPopup = com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup;
    var TimeboxClient = com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
    var GeneratedEWITableView = com.ibm.rqm.configuration.web.ui.internal.view.table.GeneratedEWITableView;
	var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var SelectWeightPopup = com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var UserClient = com.ibm.asq.common.web.client.internal.ContributorClient;
	var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EWIListPanel", [dijit._Widget, dijit._Templated], {
        
        templateString: '<div class="com-ibm-rqm-configuration-web-conf">' +
		
        '<div class="pretitle-row" dojoAttachPoint="_pretitleRow">' +
        '   <span class="span-gray"><span dojoAttachPoint="_stepLabel1">${labelStep1}</span>' +
		'   </span>' +
		'   <span class="span-gray"><span dojoAttachPoint="_stepLabel2">>${labelStep2}</span>' +
		'   </span>' +
		'   <span class="span-green"><span dojoAttachPoint="_stepLabel3">>${labelStep3}</span>' +
		'   </span>' +
        '</div>' +
        '<div class="title-row">' +
        '   <span>' +
        '       <button class="button" dojoAttachPoint="_nextButton">${labelFinish}</button>' +
        '   </span>' +
		'   <span>' +
        '       <button class="button" dojoAttachPoint="_previousButton">${labelPrevious}</button>' +
        '   </span>' +
        '       <img dojoAttachPoint="_executionwork_objImg2"/></img>' +
        '       <span class="span-stepname" dojoAttachPoint="_ewiTitle">' +
        '       </span>' +
        '       <span class="span-artifactname" dojoAttachPoint="_ewiTitleName">' +
        '       </span>' +
        '</div><br/>' +
		'<div dojoAttachPoint="_progressIndicator" class="progress-indicator" style="display: none">' +
    	'<div class="view-progress-image">' +
    	'<span dojoAttachPoint="_progressLabel" class="view-progress-label">${labelLoading}' +
    	'</span>' +
    	'</div>' +
    	'</div>' +
		'       <div dojoAttachPoint="_ewiList">' +
        '       </div>' +
        '</div>',
        
		labelStep1: Constants.getMessage("labelStep1"),
		labelStep2: Constants.getMessage("labelStep2"),
		labelStep3: Constants.getMessage("labelStep3"),
		labelPrevious: Constants.getMessage("labelPrevious"),
		labelFinish: Constants.getMessage("labelFinish"),
		labelLoading: Constants.getMessage("labelLoading"),
		
        constructor: function(args){
            this.owner = (args.owner != null) ? args.owner : null;
            this.testCases = args.testCases;
			this.parentTestPlan = (args.parentTestPlan != null) ? args.parentTestPlan : null;
            this.testPhase = (args.testPhase != null) ? args.testPhase : null;
            this.parentTestPlanUUID = (args.parentTestPlanUUID != null) ? args.parentTestPlanUUID : null;
            this.isRandomSelectCase = (args.isRandomSelectCase != null) ? args.isRandomSelectCase : null;
            this.configs = (args.configs != null) ? args.configs : null;
			this.modeledConfigs = [];
        },
        
        postCreate: function(){
            this._initTitle();
			this._showEWITable();
			this._fetchedWIForTestCasesCount = 0;
			//read pref and then check for block sttaus on plan items
			this.initExecutionPreference();
			this._createModeledConfigurations();
			this._assembleEWIs();
			this._displayEWIs(this.EWIList);
        },
        
		onPrevious: function(){
            this.controller.doPrevious({createNewList: false});
        },
        

		
        onFinish: function(){
			if (!this._validateEWI()){
				return;
			}
			this._displayLoadStatus(true);
            this.controller.commit(this._EWIListWidget.tableViewer.getContent());
        },
		
		deleteEWIs: function(){
			this._selectedEWI = this._EWIListWidget.getSelectedEWIs();
            if (this._selectedEWI.length == 0) {
				this._displayAlertDialog("", Constants.getMessage("msgSelectEWIs"));
                return;
            }
			for(var i = 0; i < this._selectedEWI.length; i++){
				var responseHandler = new ServiceResponseHandler(this, "_EWIDeleted", "_error");
	            WHITCHClient.postDelete(responseHandler, {id: this._selectedEWI[i].id});
			}
        },
		
        _initTitle: function(){
            this._ewiTitle.appendChild(document.createTextNode(Constants.getMessage("labelGeneratedEWI")));
			if(this.testCases.length == 1){
				this._ewiTitleName.appendChild(document.createTextNode(this.testCases[0].name));
			}else{
				this._ewiTitleName.appendChild(document.createTextNode(Constants.getMessage("labelTestCases")));
			}
            this.connect(this._nextButton, "onclick", "onFinish");
			this.connect(this._previousButton, "onclick", "onPrevious");
            this._executionwork_objImg2.src = ImageCache.EWI;
        },
        
		_assembleConfigIdArray: function(){
			var configIdArray = [];
			for(var i = 0 ; i < this.modeledConfigs.length; i++){
				configIdArray.push(this.modeledConfigs[i].id);
			}
			return configIdArray;
		},
		
		_assembleConfigNameArray: function(){
			var configNameArray = [];
			for(var i = 0 ; i < this.modeledConfigs.length; i++){
				configNameArray.push(this.modeledConfigs[i].name);
			}
			return configNameArray;
		},
		
		_assembleConfigWeightArray: function(){
			var configWeightArray = [];
			for(var i = 0 ; i < this.modeledConfigs.length; i++){
				configWeightArray.push(this.modeledConfigs[i].weight);
			}
			return configWeightArray;
		},
		
		_createModeledConfigurations: function(){
			 for (var i = 0; i < this.configs.length; i++) {
				if(this.configs[i].isExist != null && this.configs[i].isExist == true){
					this.configs[i].config.isExist = true;
					this.modeledConfigs.push(this.configs[i].config);
				}else{
					var theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
	                var config = theCatalog.createConfiguration("Machine");
	                var attributeValues = new Array();
	                
	                for (var j = 0; j < this.configs[i].length; j++) {
	                    var key = this.configs[i][j].key;
	                    var value = this.configs[i][j].value;
	                    attributeValues.push(value);
	                    config.setValue(key, value);
	                }
					config.name = this.namePrefix + TestConfigurationUtil.getTestConfigurationName(attributeValues);
					config.id = dojox.uuid.generateRandomUuid();
					this.modeledConfigs.push(config);
				}
            }
		},
		
		_assembleEWIs: function(){
			var testCaseIdArray = [];
			var testCaseNameArray = [];
			var testCaseWeightArray = [];
			var testCaseWorkitemArray = [];
			var defaultScriptIdArray = [];
			
			for(var i = 0; i < this.testCases.length; i++){
				testCaseIdArray.push(this.testCases[i].versionableItemId);
				testCaseNameArray.push(this.testCases[i].name);
				testCaseWeightArray.push(this.testCases[i].weight);
				if (this.testCases[i].scripts && this.testCases[i].scripts.length > 0) {
					defaultScriptIdArray.push(this.testCases[i].scripts[0].versionableItemId);
				}
				else{
					defaultScriptIdArray.push("-1");
				}
			}
            if (this.testCases) {
				
				var testConfigIdArray0 = this._assembleConfigIdArray();
				var testConfigNameArray0 = this._assembleConfigNameArray();
				
				var EWIList = [];
				var testPhase = this.testPhase;
				var phaseLen = testPhase.length;
				if (phaseLen > 0) {
					for (var k = 0; k < phaseLen; k++) {
						var testConfigIdArray = dojo.clone(testConfigIdArray0);
						var testConfigNameArray = dojo.clone(testConfigNameArray0);
						if(this.isRandomSelectCase == "true"){
							while(testConfigIdArray.length > 0){
								for (var i = 0; i < testCaseIdArray.length; i++) {
									var randomPickNum = Math.floor(Math.random() * testConfigIdArray.length);
									var EWI = {};
									EWI.id = dojox.uuid.generateRandomUuid();
									EWI.testConfigId = testConfigIdArray[randomPickNum];
									EWI.testConfigName = testConfigNameArray[randomPickNum];
									EWI.config = this._getConfiguration(testConfigIdArray[randomPickNum]);
									EWI.testCaseId = testCaseIdArray[i];
									EWI.testCaseName = testCaseNameArray[i];
									EWI.name = testCaseNameArray[i] + "_" + testConfigNameArray[randomPickNum]+(testPhase[k]?"_"+testPhase[k].name:"");
									if (EWI.name.length > 250) {//Trim the name as server can handle only 250
										EWI.name = EWI.name.substring(0, 249);
									}
									EWI.owner = this.owner;
									EWI.testPhase = testPhase[k];
									EWI.parentTestPlan = this.parentTestPlan;
									EWI.testPlanItemId = (this.parentTestPlanUUID == TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN) ? null : this.parentTestPlanUUID;
									EWI.defaultScript = defaultScriptIdArray[i];
									EWI.weight = testCaseWeightArray[randomPickNum];
									
									EWIList.push(EWI);
									
									testConfigIdArray.splice(randomPickNum, 1);
									testConfigNameArray.splice(randomPickNum, 1);
									
									if (testConfigIdArray.length == 0) {
										break;
									}
								}
							}
						}else{
							for(var i = 0; i < testConfigIdArray.length; i++){
								for (var j = 0; j < testCaseIdArray.length; j++){
									var EWI = {};
									EWI.id = dojox.uuid.generateRandomUuid();
									EWI.testConfigId = testConfigIdArray[i];
									EWI.testConfigName = testConfigNameArray[i];
									EWI.config = this._getConfiguration(testConfigIdArray[i]);
									EWI.testCaseId = testCaseIdArray[j];
									EWI.testCaseName = testCaseNameArray[j];
									EWI.name = testCaseNameArray[j] + "_" + testConfigNameArray[i]+(testPhase[k]?"_"+testPhase[k].name:"");
									if(EWI.name.length > 250){//Trim the name as server can handle only 250
										EWI.name = EWI.name.substring(0, 249);
									}
									EWI.owner = this.owner;
									EWI.testPhase = testPhase[k];
									EWI.parentTestPlan = this.parentTestPlan;
									EWI.testPlanItemId = (this.parentTestPlanUUID == TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN) ? null : this.parentTestPlanUUID;
									EWI.defaultScript = defaultScriptIdArray[j];
									EWI.weight = testCaseWeightArray[j];
									
									EWIList.push(EWI);
								}
							}
						}
					}
				}					
				this.EWIList = EWIList;
			}
			
		},
		
		_displayEWIs: function(ewis){
			this._EWIListWidget.appendEWIs(ewis);
			this._displayLoadStatus(false);
		},
        
        _showEWITable: function(){
            dojox.data.dom.removeChildren(this._ewiList);
            var reassignable = true;
            if (this.testCases && this.parentTestPlanUUID == TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN) {
                reassignable = false;
            }
            this._EWIListWidget = new GeneratedEWITableView({
                parent: this,
                reassignable: reassignable
            });
            this._ewiList.appendChild(this._EWIListWidget.domNode);
			this._displayLoadStatus(true);
        },
        
        _updateEWITable: function(ewis){
            this._addEWIElement(ewis, true);
        },
        
        _addEWIElement: function(ewis, isUpdate){
            if (dojo.isArray(ewis) && ewis.length > 0) {
				  for ( var i = 0 ; i < ewis.length; i++){
				  	ewis[i].config = this._getConfiguration(ewis[i].testConfigId);
				  }
				  if (isUpdate == true) {
                       this._EWIListWidget.updateEWIs(ewis);
                  }
                  else {
                       this._EWIListWidget.appendEWIs(ewis);
                  }
            }
        },
		
		_getConfiguration: function(id){
			for( var i = 0; i < this.modeledConfigs.length; i++){
				if (id == this.modeledConfigs[i].id){
					return this.modeledConfigs[i];
				}
			}
		},
        
        _EWIDeleted: function(args){
            this._EWIListWidget.removeSelectedEWIs();
        },
        
        _onReassign: function(){
            this._selectedEWI = this._EWIListWidget.getSelectedEWIs();
            if (this._selectedEWI.length == 0) {
				this._displayAlertDialog("", Constants.getMessage("msgSelectEWIs"));
                return;
            }
            var floatDiv = new FloatingDiv();
            floatDiv.initialize({
                title: Constants.getMessage("labelChangeOwner")
            });
            var reassignWidget = new ReassignPopup({
                objectScope: this,
                callbackFunction: "_changeElement",
                valueType: "owner"
            });
            floatDiv.addChild(reassignWidget);
            
            var handler = {
                objectScope: reassignWidget,
                callbackFunction: "initData",
                success: function(users){
                    var datas = [];
                    if (dojo.isArray(users) && users.length > 0) {
                        for (var i = 0; i < users.length; i++) {
                            if (users[i].name != "ADMIN" && users[i].name != "GUEST" && !users[i].archived) {
								if(com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(users[i].itemId))
									users[i].name = Constants.getMessage("labelUnassigned");
                                var data = {};
                                data.value = users[i].name;
                                data.id = users[i].userId;
								data.item = users[i];
                                datas.push(data);
                            }
                        }
                    }
                    var args = {
                        datas: datas,
                        type: "User"
                    }
                    this.objectScope[this.callbackFunction].call(this.objectScope, args);
                },
                error: function(e){
                	console.error(e);
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			UserClient.getContributors(responseHandler);
        },
        
        _onChangeTestPhase: function(){
            this._selectedEWI = this._EWIListWidget.getSelectedEWIs();
            if (this._selectedEWI.length == 0) {
				this._displayAlertDialog("", Constants.getMessage("msgSelectEWIs"));
                return;
            }
            var floatDiv = new FloatingDiv();
            floatDiv.initialize({
                title: Constants.getMessage("labelChangeIteration")
            });
            var reassignWidget = new ReassignPopup({
                objectScope: this,
                callbackFunction: "_changeElement",
                valueType: "testPhase"
            });
            floatDiv.addChild(reassignWidget);
            
            var handler = {
                objectScope: reassignWidget,
                callbackFunction: "initData",
                success: function(phases){
                    var datas = [];
                    if (dojo.isArray(phases) && phases.length > 0) {
                        for (var i = 0; i < phases.length; i++) {
                            var data = {};
                            data.value = phases[i].name;
                            data.id = phases[i].itemId;
							data.item = phases[i];
                            datas.push(data);
                        }
                    }
                    var args = {
                        datas: datas,
                        type: "Iteration"
                    }
                    this.objectScope[this.callbackFunction].call(this.objectScope, args);
                },
                error: function(){
                
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            TimeboxClient.getTestPhases(responseHandler, {
                testPlanId: this.parentTestPlanUUID
            });
        },
        
		_onConfig: function(){
			var self = this;
		    var args = {
                okCallback: dojo.hitch(self, "_handleWeightChanged"),
				actionId : "weight"
            };
            var selector = new SelectWeightPopup();
            selector.initialize(args);
		},
		
		_handleWeightChanged: function(args){
			if (args.weight) {
				this._selectedEWI = this._EWIListWidget.getSelectedEWIs();
				if (dojo.isArray(this._selectedEWI)) {
					for (var i = 0; i < this._selectedEWI.length; i++) {
						this._selectedEWI[i].weight = args.weight;
					}
					this._updateEWITable(this._selectedEWI);
				}
			}
		},
		
        _changeElement: function(typeValue){
            this._selectedEWI = this._EWIListWidget.getSelectedEWIs();
            if (dojo.isArray(this._selectedEWI)) {
					for(var i = 0; i < this._selectedEWI.length; i++){
	                    if (typeValue.valueType == "testPhase") {
	                        this._selectedEWI[i].testPhase = typeValue.item;
	                    }
	                    else 
	                        if (typeValue.valueType == "owner") {
	                            this._selectedEWI[i].owner = typeValue.item;
	                        }
					}
					this._updateEWITable(this._selectedEWI);
            }
        },
		
		_assembleEWIIds: function(){
			var ewiIds = [];
			for(var i = 0 ; i < this._selectedEWI.length; i++){
				ewiIds.push(this._selectedEWI[i].id);
			}
			return ewiIds;
		},
		
		_displayLoadStatus: function(status){
            this._nextButton.disabled = status;
            this._previousButton.disabled = status;
			this._progressIndicator.style.display = status ? "inline" : "none";
        },
        
        _error: function(errorObj){
            confirm(errorObj.message);
        },
		
		_displayAlertDialog: function(title, message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.setSecondaryTitle(title);
            alertDialog.open();
        },
		
		_validateEWI: function(){
			var content = this._EWIListWidget.tableViewer.getContent();
			for(var i=0; i<content.length; i++){
				var row = content[i];
				if (row.weight <= 0 || row.weight > parseInt(Constants.MAX_INT_VALUE_IN_HEX, 10)) {
					this._EWIListWidget.setStatus(Constants.getMessage("labelWeightValueWarning"), ViewHeaderLayout.WARNING);
					return false;
				}
			}
			return true;
		},
		
		updateEWIBlockingState: function(testCaseId, isBlocking){
			if(this.EWIList && this.EWIList.length > 0){
				for(var i=0;i<this.EWIList.length;i++){
					if(this.EWIList[i].testCaseId == testCaseId){
						this.EWIList[i].isBlocking = isBlocking;
					}
				}
				this._EWIListWidget.updateEWIs(this.EWIList);
			}	
		},
		
		_getWorkItems: function(){
			if(this.testCases && this.testCases.length > 0 && this.testCases[this._fetchedWIForTestCasesCount] ){
				var self = this;
				var testCaseItemId = this.testCases[this._fetchedWIForTestCasesCount].versionableItemId;
				this.currentTestCaseId = testCaseItemId;
				com.ibm.rqm.defects.web.client.internal.CmIntegrationClient.getPlanItemLinks({testArtifactItemId: testCaseItemId},  dojo.hitch(this, "receivedWorkitems"));
			}	
		},
		
		receivedWorkitems: function(status, workitemReferences){
			if(workitemReferences && workitemReferences.length > 0){
				for(var j=0;j<workitemReferences.length;j++){
					//TODO VS: Might need changes based on the reference dto.
					if(workitemReferences[j].stateGroup && workitemReferences[j].stateGroup != "Closed"){//$non-nls
						this.updateEWIBlockingState(this.currentTestCaseId, true);
						break;	
					}
				}
			}
			this._fetchedWIForTestCasesCount++;
			if(this._fetchedWIForTestCasesCount < this.testCases.length)
				this._getWorkItems();
		},
		
		_tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId){
			if(columnIndex == 4){
				this._onReassign();
			}else if (columnIndex ==5){
				this._onChangeTestPhase();
			}else if (columnIndex ==6){
				this._onConfig();
			}
		},
		
		initExecutionPreference: function(){
			console.debug("WHITCH.initExecutionPreference()");
			var self = this;
			var handler = {
				success: function(executionPref){
					console.debug("Loaded ExecutionPreferences..");
					var preferences = executionPref && executionPref.value ? dojo.fromJson(executionPref.value) : {};
					//if block on plan items is true in the preferences then resolve the block status
					if (preferences.blockOnPlanitems && preferences.blockOnPlanitems == true){
						jazz.core.internal.loader.load_async("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient", dojo.hitch(self, "_getWorkItems"));
					}
				},
				failure: function(){
					console.error("Unable to load execution pref");
				}
			}
			var option = new com.ibm.asq.common.web.client.internal.option();
			var handler = new ServiceResponseHandler(handler, "success", "failure");
			option.getProjectPreferences(handler, getCurrentProjectArea().itemId, Constants.EXECUTION_SYSTEM_CONSTRAINTS);
		}
		
    });
})();
