/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationListPanel");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationListPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationListPanel");
dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");
dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){ // module container
    
	var WHITCHClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
	var TestConfigurationUtil = com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
	var ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationListPanel", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationListPanel], {
        
        constructor: function(args){
            this.testPlan = (args.testPlan != null) ? args.testPlan : null;
			//the test plan UUID for applying added Configurations
			this.configurationAppliedTestPlanUUID = this.testPlan.versionableItemId;
        },
        
		//@Overriden from ConfigurationListPanel
        _initTitle: function(){
			this._title.appendChild(document.createTextNode(Constants.getMessage("labelGeneratedConfigurations")));
            this._titleName.appendChild(document.createTextNode(this.testPlan.name));
            this.connect(this._nextButton, "onclick", "onNext");
            this.connect(this._previousButton, "onclick", "onPrevious");
            this._executionwork_objImg1.src = ImageCache.EWI;
			dojox.data.dom.removeChildren(this._nextButton);
			this._nextButton.appendChild(document.createTextNode(Constants.getMessage("labelFinish")));
			this._stepLabel3.style.display = "none";
        },
		
		//@Overriden from ConfigurationListPanel
		onNext: function(){
			this._displayLoadStatus(true);
            var configs = this._testConfigListWidget.getTableViewer().getContent();
			this.controller.commit(configs);		
		}
    });
    
})();
