/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.HiddenableDialog");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.HiddenableDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.HiddenableDialog", com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog, {
        
		hiddenable: true,
		preCheck: null,
		
		postCreate: function(){
			this.inherited('postCreate', arguments);
			this.blockerDiv.style.zIndex = 1001;
			this.domNode.style.zIndex = 1002;
		},
		
		_yesAction: function(){
			if(dojo.isFunction(this.preCheck) && !this.preCheck()){
				return;
			}
            if (this.hiddenable) {
                this.hide();
            }
            else {
                this.close();
            }
            if (this.yesCallback && typeof this.yesCallback == "function") 
                this.yesCallback(this.yesCallbackData);
        },
        
        _noAction: function(){
            if (this.hiddenable) {
                this.hide();
            }
            else {
                this.close();
            }
            if (this.noCallback && typeof this.noCallback == "function") 
                this.noCallback(this.noCallbackData);
        },
        
        // Summary: 
        // Show the Dialog. Only used to show a hidden Dialog.
        show: function(){
			this.blockerDiv.style.display = "block";
            this.domNode.style.display = "block";
			this.updatePosition();
        },
        
        // Summary: Only hide the dialog, but not destroy the domNode;
        hide: function(){
			this.blockerDiv.style.display = "none";
            this.domNode.style.display = "none";
        },
		
		// Override from SelectionDialog. don't truncate the title.
		_truncate: function(){
		
		}
    
    });
    
})();
