/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanelBody");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.Slider");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
(function() {
var WIGHTINGHIGH = 5;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
dojo.declare(
	"com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanelBody",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/WeightingPanelBody.html"),
		
		constructor: function(args) {
			this.env = args.env;
		},
		
     	postCreate: function() {
		  	this._weightlabel.appendChild(document.createTextNode(Constants.getMessage("labelWeightingsText")));
	        this._initWeightings(this.env);
	        this._setTabContainer();			
		},	
		
		getWeightings: function(){
			return this.weightings;
		},
		
		_initWeightings: function(env){
			this.weightings = new Array(env.values.length);
			for(var i=0; i<env.values.length; i++){
				this.weightings[i] = 1;
			}
		},
		
		_setTabContainer: function() {
			dojox.data.dom.removeChildren(this._itemListTableBody);
			for(var i=0; i<this.env.values.length ; i++){
				var tr = this._createWeightElement(this.env.values[i], i);
				
				this._itemListTableBody.appendChild(tr);
			}
		},
		
		_createWeightElement: function(value, index){
			var tr = document.createElement("tr");
			var td = document.createElement("td");
			td.appendChild(document.createTextNode(value + ":"));
			td.className = "attributeNameNode";
			tr.appendChild(td);
			tr.setAttribute("value",index);

			var weight = document.createTextNode(1);
			
			var td = document.createElement("td");
			td.className = "scalebarNode";
			var slider = this._getSlider(1);
			this._addSliderChangeEvent(slider, tr, weight);
			td.appendChild(slider.domNode);
			tr.appendChild(td);
			
			var td = document.createElement("td");
			td.appendChild(weight);
			td.className = "weightValueNode";
			tr.appendChild(td);
			
			return tr;
		},
		
		_addSliderChangeEvent: function(slider, tr, textNode) {
			var self = this;
			slider.onChange = function(e){
				textNode.nodeValue = e;
				self.weightings[tr.getAttribute("value")] = Number(e);
			}
		},
		
		_getSlider:function(value){
			var slider = new dijit.form.HorizontalSlider({
				minimum: 1,
				maximum: WIGHTINGHIGH,
				discreteValues: WIGHTINGHIGH,
				intermediateChanges: false,
				showButtons: true,
				value: value
				});
			slider.startup();
			return slider;
		},
		
		_error: function(errorObj) {
			alert(errorObj.message);
		}			
	}
);

})();
