//debug duplicatedialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation  2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.DuplicateDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.DuplicateDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojox.data.QueryReadStore");


dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

// Summary
// Display a dialog box asking for user confirmation of Duplicate. Requires the user to select 
// a destination project area. By default one is selected. 

(function()
{
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
	var SelectUtility = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
	var ProjectAreaSelector = com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelector;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.DuplicateDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/DuplicateDialog.html"),
		onDuplicateOk: null,
		onDuplicateCacncel: null,
		_labelProjectArea: Constants.getMessage("labelProjectArea1"),
		_projectAreaCombo: null,
		_title: null,
		_value: null,
		
			
		 constructor: function(args){
		 	this._title = args.title;
			this._appArgs = args.appArgs;
		 },
			
       	postCreate: function() {
			this.show();	
		},
		
		_onValueChanged: function(value, valid)
		{
			this._dialog.getOkButton().disabled = !valid;
		},
		
		show: function() {
			var dialogArgs = {
				zIndex: 998,
				primaryTitle: this.title,				
                okCallback: dojo.hitch(this, "_onOk"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this._appArgs.onValueChanged = dojo.hitch(this, "_onValueChanged");
			this._appArgs.onEnterSelected = dojo.hitch(this, "_onEnterSelected");
			this._appArgs.onSelectorBuilt = dojo.hitch(this, "_onSelectorBuilt");						
			this.paSelector = new ProjectAreaSelector(this._appArgs);
			this._projectAreaCombo.appendChild(this.paSelector.domNode);
            this._dialog.setWidth("350px");
			this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = true;
			this._dialog.getCancelButton().disabled = false;	
            this._dialog.open();
		},
		
		_onSelectorBuilt: function(){
			 this._dialog.getOkButton().disabled = false;
		},
		
		_onEnterSelected: function(){
			if(!this._dialog.getOkButton().disabled){
				this.paSelector.getSelection(this.onDuplicateOk);
				this._dialog.close();
			}				
		},
		
		_onOk: function()
		{
			this.paSelector.getSelection(this.onDuplicateOk);
		},

		_onCancel: function()
		{
			this.onDuplicateCancel();			
		}
		
	});
})();
