/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("jazz.ui.HoverPopup");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordsContentFilterProvider");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("dojox.string.BidiComplex");

(function() {

var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TestScriptClient		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 			= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var GlobalEvents			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var COMMAND_CREATE			= "create"; //$NON-NLS$
var AbstractFilteredPagingTableView  = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var KeywordClient              = com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient;
var _textContent			= dojo.isIE ? "innerText" : "textContent";

dojo.declare("KeywordLibraryView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    getNumColumns: function(content){
        return 3;
    },
    
    getColumnHeading: function(content, index){
        var headings = [
			"",
			Constants.getMessage("labelKeywords"),
			Constants.getMessage("labelType")
        ];
        return headings[index];
    },

    getColumnIdName: function(index){
        var ids = [
        "",
        "name",
        "scriptTypeIds"
        ]; 
        return ids[index];
    },
    
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex == 2);   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 10;
            case 1: 
                return 60;
            case 2: 
                return 30;
        }
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return rowData.elements[0].value;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;				 
        }
        return type;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.elements[0].value;
                break;
            case 1: 
                val = rowData.elements[1].value;
                break;
            case 2: 
                val = rowData.elements[2].value;
                break;
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 0) {
           val = {};
           val.image = ImageCache.TEST_SCRIPT;
 		   val.href = rowData.link;
        }		  		  		  
        return val;
    }    
});
dojo.declare("KeywordLibraryView.TableRowRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer,
{
	editor:null,
	labelReplaceStatement: Constants.getMessage("labelReplaceStatement"),
	labelInsertBefore: Constants.getMessage("labelInsertBefore"),
	msgDragAndDropKeyword: Constants.getMessage("msgDragAndDropKeyword"),
	
	constructor :function(params){
		this.editor = params.editor;
		this.keywordType = "KeywordType";
	},
	renderRow: function(viewer, rowObject, trNode){
		var doc = document;
		
		var anchor = doc.createElement('a');
        var img = doc.createElement('img');
        img.src = ImageCache.TEST_SCRIPT;
		img.alt = "Title";
		anchor.href = "javascript:{}";
		anchor.appendChild(img);
        var td = doc.createElement("td");
		td.appendChild(anchor);
		
        viewer.tooltips.push(new jazz.ui.HoverPopup({html: this.msgDragAndDropKeyword, around:[img]}));
        trNode.appendChild(td);
        
		var len = rowObject.elements.length-1;
        var provider = viewer.getContentProvider();
        
        for (var j =1; j<len; j++){
            var element = rowObject.elements[j];
            var type = provider.getCellDisplayType(rowObject, j);
            var data = element.value;
            var extendedInfo = provider.getCellDisplayExtendedInfo(rowObject, j);
            var cellRenderer = viewer.getCellRenderer(type);            
            var colWidth = viewer.getColumnWidthInPixel(j); 
            var td = doc.createElement("td");
            if(colWidth > 10) {
                colWidth -= 6;
            }
            // delegate the cell rendering to our renderer to ensure
            // table settings is adhered.
            if (viewer.isCompactMode) {
                td.nowrap = true;
                td.style.width = colWidth;
                td.style.overflowX = "hidden";
            }
            var node = cellRenderer.renderCell(viewer, data, extendedInfo, viewer.getCellModifier(), rowObject, j, colWidth);
            td.appendChild(node);
            trNode.appendChild(td);
        }
        var editorId = rowObject.elements[rowObject.elements.length-1];
        trNode["editorId"] = editorId;
		var rowId = "_tr"+editorId+rowObject.elements[0].value; //0 contains the ID
		trNode.id=rowId;
		trNode.type = this.keywordType;
		this._attachContextMenu(trNode,rowObject.scriptObj,viewer);
		// the trNode is not yet connected to the tbody at this time, as the tableViewer uses
		// a fragment to collect all the rows and append them all at once.  The dnd support
		// looks up the parent chain and breaks because of the fragment, so we defer
		// setting up the DND.
		setTimeout(dojo.hitch(this,function(){
			var _dojo = dojo;
			if(!_dojo.hasClass(trNode.parentNode,"dojoDndSource")){
				if(this.dndSource)
					this.dndSource.destroy();
				this.dndSource= new _dojo.dnd.Source(trNode.parentNode,{
					accept:[],
					copyOnly:true,
					singular:true,
					selfAccept:false,
					selfCopy:false,
					creator:this._dndCreator
				});
				
				//changes to dnd classes to improve performance especially on IE
				this.dndSource._changeState = _dojo.hitch(this.dndSource,function(type, newState){
					var state  = type.toLowerCase() + "State";
					if((!this[state] && newState == "")|| (this[state] == newState))
						return;
					var prefix = "dojoDnd" + type;
					var oldClass = prefix + this[state];
					var newClass = prefix + newState;
					if(oldClass == newClass)
						return;
					var oldClassName = this.node["className"];
					var newClassName = dojo.trim((" " + oldClassName + " ").replace(" " + oldClass + " ", " "+newClass+" "));
					if(oldClassName != newClassName)
						this.node["className"] = newClassName;
					this[state] = newState;
				});
			}
			this.dndSource.setItem(rowId, {data: rowObject, type: [this.keywordType]});
			_dojo.addClass(trNode, "dojoDndItem");
		}),0);
    },
    
	
    _dndCreator:function(row,hint){
        if(hint == "avatar"){
			var span = document.createElement("span");
			span[_textContent] = row.elements[1].value;
            var editorId = row.elements[row.elements.length-1];
            return {node: span, data: row, type: [this.keywordType]};
		}
	},
	_attachContextMenu: function(node,scriptObj,viewer){
		var callback = this;
		if(node){
			var pMenu = new dijit.Menu({targetNodeIds:[node]});
            pMenu.addChild(new dijit.MenuItem({
				label: this.labelInsertBefore,
				scriptObj: scriptObj, 
				callback: callback, 
				onClick:this._insertKeyword}));
            pMenu.addChild(new dijit.MenuItem({
				label:this.labelReplaceStatement,
				scriptObj: scriptObj, 
				callback: callback, 
				onClick:this._replaceCurrentWithKeyword}));
            pMenu.startup();
			viewer.menus.push(pMenu);
		}
	},
	
	_replaceCurrentWithKeyword: function(){
		var editor = this.callback.editor;
		if(editor){
			var source = editor.stepsDndSource;
			if (source) {
				var node = source.anchor;
				if (node) {
					editor._addKeyword(node, this.scriptObj, true,false);
					editor.setParentDirty();
				}
				else 
					this.callback._displayAlertDialog(Constants.getMessage("msgNoStepToReplace"));
			}
		}
	},
	_insertKeyword: function(){
		var editor = this.callback.editor;
		if (editor) {
			var source = editor.stepsDndSource;
			if (source) {
				var node = source.anchor;
				if (node) {
					editor._addKeyword(node, this.scriptObj, false,false);
					editor._updateStepNum(editor._stepsTableBody.rows, node.sectionRowIndex);
					editor.setParentDirty();
				}
				else 
					this.callback._displayAlertDialog(Constants.getMessage("msgNoStep"));
			}
		}
	},
	_displayAlertDialog: function(message){
        var alertDialog = new AlertDialog({
            'message': message
        });
        alertDialog.open();
    }
});

dojo.declare("KeywordLibraryView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
    
});

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView",
	[dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/KeywordLibraryView.html"),
		
		labelKeywordView: Constants.getMessage("labelKeywordView"),
		editor:null,
		constructor: function() {
            this.rows = [];
            this.showQueryFilters = true;  // default to show filters
		},
		
		postCreate: function() {
            this.connect(this._showHide, "onclick", "_clickArrow");
			this.connect(this._showBar, "onmouseover", "_mouseHandler");
			this.connect(this._showBar, "onmouseout", "_mouseHandler");
            this._panelCache = {};
            this._onAnimationEnd();
			this.rows = [];
			this.vOpen = false;
			this._tableViewerNode.style.display = "none";
			this.headerCollapsImg.src = CommonImageCache.EXPAND_ICON;
			this.connect(this.headerCollapsImg,"onclick","toggleView");
			this.connect(this.headerCollapsImg,"onkeypress","toggleView");
			this.connect(this.titleRow,"onclick","toggleView");
			this.connect(this.titleRow,"onkeypress","toggleView");
			this.connect(this.titleRow,"onmouseover","_onMouseOverImg");
			this.connect(this.titleRow,"onmouseout","_onMouseOutImg");
			//cshelp
			if (this._cshelp) {
		        var cshelp = new CSHelp({
		        	contextID: "rqm_keyword_view.html"
		        });
				cshelp.setButtonLabel(Constants.getMessage("labelKeywordLibCSHelp"));
		        this._cshelp.appendChild(cshelp.domNode);
			}
			this.dndTopic = dojo.subscribe("/dnd/drop",this, "_dndDrop");
			this.stepsDndSource = new dojo.dnd.Target(this.keywordView, {
					accept: [this.editor.id],
					copyOnly:true,
					selfAccept:false,
					selfCopy:false,
					creator:this._dndCreator
				});
			this.stepsDndSource._changeState = dojo.hitch(this.stepsDndSource,function(type, newState){
				var state  = type.toLowerCase() + "State";
				if((!this[state] && newState == "")|| (this[state] == newState))
					return;
				var prefix = "dojoDnd" + type;
				var oldClass = prefix + this[state];
				var newClass = prefix + newState;
				if(oldClass == newClass)
					return;
				var oldClassName = this.node["className"];
				var newClassName = dojo.trim((" " + oldClassName + " ").replace(" " + oldClass + " ", " "+newClass+" "));
				if(oldClassName != newClassName)
					this.node["className"] = newClassName;
				this[state] = newState;
			});
            // initialize options for the view builder, search and callback methods are
            // set in KeywordList.js
            this.setTypeLabel(Constants.getMessage("labelKeywords"));
            if (this.postQueryFilterCallback) {
                this.setSearchFilterCallback(this.postQueryFilterCallback);
            }
            
            // apply the user preference whether to initially open the view builder
            if (this.showQueryFilters) {
                this._initializeFilters();             
            } else {
//                this._initialize();
            }
		},

        // Constructs the query filter definitions and the content filter provider for the
        // table. The table will construct the filters section based on the definitions.
        // 
        _initializeFilters: function() {
            // create the filter provider for the table
            this.filterProvider = new com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordsContentFilterProvider(this, this.isInitiallyOpen());
            var providerFilters = this.filterProvider.filters;
        
            // add the modified time filter
            var dateTimeFilter = {
                processFilter: true, // parent class handle processing the to and from date time params
                name: "modifiedDateTime",  // must match what the filter provider looks for before runQuery()
                fromKey: "modifiedFrom",
                toKey: "modifiedTo",
                label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
                prompt: Constants.getMessage("labelModified")
            };
            this.addDateTimeRangeFilter(dateTimeFilter, providerFilters);
            
            // add the script type filter
            var scriptTypesFilter = {
                name: "scriptTypeIds" // must match key in the arg list of the API
            };

            // add script state filter
            this.addScriptTypeFilter(scriptTypesFilter, providerFilters, dojo.hitch(this, "_initializeScriptState"));
        },

        _initializeScriptState: function() {
            // add script state filter
            var providerFilters = this.filterProvider.filters;
            this.addArtifactStateFilter(providerFilters);

            // continue initialization
//            this._initialize();
        },

        _constructTableContentProvider: function() {
            //create the table provider
            this.provider = new KeywordLibraryView.TableProvider({
                tableViewer: this,
                isVirtual: this.contentIsVirtual,
                currentPageIndex: this.currentPage,
                totalPageCount: this.totalPages,
                totalContentCount: this.totalSize || -1,
                pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
                
                vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
                {
                    // the table provider can be recreated many times
                    // we need to retain the current page size, page index, etc.
                    // when it is recreated.
                    this.pageSize = pageSize;
                    this.currentPage = pageIndex;
                    this.runQuery(null, /*updatePageOnly*/ true);
                }),
                vcRunQuery: dojo.hitch(this, function(pageSize)
                {
                    this.pageSize = pageSize;
                    this.queryToken = null;
                    this.runQuery(null, /*updatePageOnly*/ true);
                })
            });    
            return this.provider; 
        },
        
        _initialize: function() {
			this.initialized =  true;
            this._displayTable();
            this.initRunQuery();
        },
    
        // @override AbstractFilteredPagingTableView to insert sort by last modified.
        _prepareQueryArgs: function(filterArgs, updatePageOnly) {
            var args = this.inherited("_prepareQueryArgs", arguments);
            var sortArgs = args['sortColumns'];
            
            if(!sortArgs) {
                sortArgs = [];
            }
            sortArgs.push("modifiedDateTime:DESCENDING");
            args['sortColumns'] = sortArgs;
            return args;
        },
        
		_dndDrop:function(source,nodes,iscopy,target){
			if(target.parent == this.keywordView)
				setTimeout(dojo.hitch(this, "getAllTags",nodes),0);
		},
		getAllTags:function(nodes){
			var self = this;
			var callback={
				success:function(tags){
					var tagList = self._parseTags(tags);
					self.showNewKeywordDialog(nodes,tagList);
				},
				error:function(e){
					self._error(e);
				}
			}
			var handler = new ServiceResponseHandler(callback, "success", "error");
			KeywordClient.getKeywordTags(handler);
		},
		_parseTags:function(tags){
			var tagList = [];
			if(tags && tags.length>0){
				tags = dojox.string.BidiComplex.stripSpecialCharacters(tags);
				var tagArr = [tags];
				if(tags.indexOf(',')>0)
					tagArr = tags.replace(/\,/g," ").split(" ");
				else if(tags.indexOf(' ')>0)
					tagArr = tags.split(" ");
				for(var tag in tagArr){
					if(tagArr[tag].length>0 && tagArr[tag]!=" ")
						tagList.push({
							id: tagArr[tag]
						});
				}
			}
			return tagList;
		},
		showNewKeywordDialog:function(nodes,tagList){
			if(!nodes || !nodes.length)
				return;
			this.droppedSteps = nodes;
			this.editor._preserveEditedContent();
			this.editor._destroyEditor();
			var steps = [];
			var len = nodes.length;
			for(var i=0;i<len;i++){
				var step = this.editor._getStepForRow(nodes[i]);
				if(!step.content|| dojo.trim(step.content).length === 0 || unescape(step.content) == '<br />'){
					var alertDialog = new AlertDialog({
						primaryTitle:Constants.getMessage("labelError"),
            			message: Constants.getMessage("msgStepContentRequired", step.num)
        			});
        			alertDialog.open();
					return;
				}
				steps.push(step);
			}
			var args = {
	            itemType: Constants.MODEL_TYPE_KEYWORD,
	            onOkCallback: dojo.hitch(this, "_handleAddNewItem"),
				showAssociate:false,
				okCallbackData:steps,
				tagList:tagList
        	}
			this.keywordPopup = new com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup(args);
		},
		_dndCreator:function(row,hint){
			var newRow = document.createElement("tr");	
            return {node: newRow, data: null, type: []};
		},
		_handleAddNewItem:function(steps){
			var newItem = this.keywordPopup.getItemForDisplay();
			var self = this;
	        var handler = {
	            success: function(testScript) {
	                self._createKeyword(testScript, newItem);
	            },
	            error: function(e) {
	                self._error(e);
	            }
	        }
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var scriptObj = {
				name: newItem.name,
				type: "Manual",
				description: Constants.getMessage("labelKeywordDesc"),
				newScript: true,
				state:Constants.STATETRANSITION_STATE_DRAFT,
				elements:this._convertStepsToCommands(steps)
			};
			TestScriptClient.saveTestScript(responseHandler, scriptObj);
		},
		_createKeyword:function(testScript,newItem){
			var responseHandler = new ServiceResponseHandler(this, "_createFinished", "_error");	
			var keywordObj = {
				newKeyword:true,
				name: newItem.name,
				tags: newItem.tags,
				manualScript:testScript.versionableItemId  ? testScript.versionableItemId: testScript.itemId,
				defaultScript:testScript.versionableItemId ? testScript.versionableItemId: testScript.itemId
			};
			com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.postKeywordDTO(responseHandler, keywordObj);
		},
		_convertStepsToCommands:function(steps){
			var commands = [];
            var len = steps?steps.length:0;
            for (var i = 0; i < len; i++) {
	            var step = steps[i];
	            var element = {
	                num: i+1,
	                typeName: step.elementType.name     
	            }
				if (step.summary != null) {
					element.summary = step.summary;
				}
	            if (step.content != null) {
	            	element.content = step.content;
	            }
	            if (step.expectedResult != null) {
	            	element.expectedResult = step.expectedResult;
	            }					
	            if (step.properties) {
	            	element.properties = step.properties;
	            }
	            var command = {cmd: COMMAND_CREATE,elementObj: element}
	            commands.push(command);
            }
            return commands;
		},
		_createFinished:function(keyword){
			dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_KEYWORD, [keyword]]);
			var args = {
            	'message': Constants.getMessage("msgReplaceStepsWithKeyword"),
            	'yesCallback':dojo.hitch(this,"_replaceStepsWithKeyword"),
            	'yesCallbackData': keyword,
            	'noCallback': dojo.hitch(this,function(){this.droppedSteps = null;}),
            	'noCallbackData': null
        	};
        	var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        	confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			confirmDialog.open();
		},
		_replaceStepsWithKeyword:function(keyword){
			if (this.droppedSteps && this.droppedSteps.length > 0) {
				this.editor._addKeyword(this.droppedSteps[0], keyword, true,true);
				var len = this.droppedSteps.length;
				for (var i = 1; i < len; i++) {
					this.droppedSteps[i].parentNode.removeChild(this.droppedSteps[i]);
				}
				this.editor._reOrganizeSteps();
			}
			this.droppedSteps = null;
		},
        
		_fillScripts: function(keywords){
            this.rows = [];
			if(keywords){
				var len = keywords.length;
				for(var i=0;i<len ; i++){
					if(keywords[i].archived)
						continue;
					var script = keywords[i].defaultScript ? keywords[i].defaultScript:keywords[i].manualScript;
					var type =  Constants.getExtensionDisplayMessage(script.scriptType.name);
					if(script.scriptType.name == "Manual")
						type = Constants.getMessage("labelManual");
					var scriptId = script.id;
					this.rows.push({
						elements: [ { value: keywords[i].id},
									{ value: keywords[i].name},
									{value: type},
									this.editor.id],
						scriptObj: keywords[i]				
					});
				}
			}	
			this._updateTable();
		},
		
		_displayTable: function(){
			if (!this.tableViewer) {
				this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({tooltips:[],menus:[],noItemMessage:Constants.getMessage("labelKeywordNoItems")});
				this.tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelKeywordView")));
				this._tableViewerNode.appendChild(this.tableViewer.domNode);
				this.keywordRowRenderer = new KeywordLibraryView.TableRowRenderer({
					editor: this.editor
				});
                
                var tableListener = new KeywordLibraryView.TableListener();
                this.tableViewer.setTableListener(tableListener);
                
                // hide the footer paging, the table is too tight to show 
                // the status + paging control
                if(this.tableViewer.footerPageControlNode)
                    dojo.style(this.tableViewer.footerPageControlNode, "display", "none");
				this.tableViewer.setCustomRowRenderer(this.keywordRowRenderer);
				this.tableViewer.setContentPageSize(10);
				this.tableViewer.setContent(this.rows);
				this.tableViewer.setContentProvider(this._constructTableContentProvider());

                // initialize options for the view builder
                this.setSearchFunction(dojo.hitch(KeywordClient, "searchKeywords"));
                this.setSearchCallback(dojo.hitch(this, "_fillScripts"));

                this.initFilterProvider(this.filterProvider);
                this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);

				this.tableViewer.show();
				//need to do this tweaking to keep the keyword library view from not getting too wide
				var pageSelectParent = this.tableViewer.PageSelectControlNode.parentNode;
				if (pageSelectParent) 
					pageSelectParent.parentNode.removeChild(pageSelectParent);
				var actionsAreaParent = this.tableViewer.actionsAreaNode.parentNode;
				if (actionsAreaParent) 
					actionsAreaParent.parentNode.removeChild(actionsAreaParent);
				var pageControlParent = this.tableViewer.PageControlNode.parentNode;
				if (pageControlParent) 
					pageControlParent.removeAttribute('nowrap');
            }
        },
        
        _updateTable: function(){
            this._refreshTable(this.rows);
		},
		_refreshTable:function(content){
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content);
            }
            else {
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            }
		},
		_error: function(errorObj) {
			console.debug("Error: (message: '" + errorObj.message + "') in KeywordLibrary#_error");
			
		},
		uninitialize: function(){
			dojo.unsubscribe(this.dndTopic);
			this.dndTopic = null;
			if(this.stepsDndSource){
				this.stepsDndSource.destroy();
			}
			if(this.keywordRowRenderer && this.keywordRowRenderer.dndSource)
				this.keywordRowRenderer.dndSource.destroy();
			if (this.tableViewer) {
				var tooltips = this.tableViewer.tooltips;
				dojo.forEach(tooltips, function(tooltip){
					if (tooltip.destroyRecursive) {
						tooltip.destroyRecursive();
					}
				});
				this.tableViewer.tooltips = [];
				var menus = this.tableViewer.menus;
				dojo.forEach(menus, function(menu){
					if (menu.destroyRecursive) {
						menu.destroyRecursive();
					}
				});
				this.tableViewer.menus = [];
			}
			
		},
			
		_mouseHandler: function(event) {
			var type;
			if( dojo.isIE && !event )
			{
				type = window.event.type;
			}
			else
				type = event.type;
			
			if(this._isShowing && type == "mouseout"){
				this._innerBar.style.display = "none";
				this._showBar["className"] = dojo.trim((" " + this._showBar["className"] + " ").replace(" show-bar ", " show-bar-open-inactive "));
			}else if(this._isShowing && type == "mouseover"){
				this._innerBar.style.display = "block";
				this._showBar["className"] = dojo.trim((" " + this._showBar["className"] + " ").replace(" show-bar-open-inactive ", " show-bar "));
			}
		},
        
        _clickArrow: function(e) {
            var args = {
                node: this.domNode.parentNode,
                duration: 200,
                properties: {
                    width: {unit: "px"}
                },
                onEnd: dojo.hitch(this, "_onAnimationEnd")
            };
				
            if (this._isShowing) {
                // hide
				this.rightView.style.display = "none";
                args.properties.width.start = 240;
                args.properties.width.end = 10;
            } else {
                // show
                args.properties.width.start = 10;
                args.properties.width.end = 240;
            }
            
            var anim = dojo.animateProperty(args);
            anim.play();
        },
            
        _onAnimationEnd: function() {
            if (this._isShowing) {
				this._showHide["className"] = dojo.trim((" " + this._showHide["className"] + " ").replace(" arrow-right ", " arrow-left "));
                this._isShowing = false;
				this._innerBar.style.display = "block";
				this._showBar["className"] = dojo.trim((" " + this._showBar["className"] + " ").replace(" show-bar-open-inactive ", " show-bar "));
				//For defect 10092: deal with Chrome separately
				if(navigator.userAgent.indexOf("Chrome") >= 0)
					this._showHide.style.left = (this._showBar.offsetLeft + 10) + "px";
            } else {
				this._showHide["className"] = dojo.trim((" " + this._showHide["className"] + " ").replace(" arrow-left ", " arrow-right "));
				this._innerBar.style.display = "none";
				this._showBar["className"] = dojo.trim((" " + this._showBar["className"] + " ").replace(" show-bar ", " show-bar-open-inactive "));
				this.rightView.style.display = "block";
				this._isShowing = true;
				//For defect 10092: deal with Chrome separately
				if(navigator.userAgent.indexOf("Chrome") >= 0)
					this._showHide.style.left = "";
            }
			if(dojo.isFF == 2)
				this.parent.switchBidiContentArea(this._isShowing);
        },
		onArtifactChanged: function(changeType, artifactType, artifactArray){
			if(this.tableViewer){
				if (changeType == GlobalEvents.ArtifactsAdded) {
                    // refresh the content to pickup any new keywords
                    this._invalidateQuery();
				}else {
					var len = artifactArray.length;
					var rows = this.rows;
					for (var i = 0; i < len; i++) {
						var len2 = rows.length;
						for (var j = 0; j < len2; j++) {
							if (rows[j].elements[0].value == artifactArray[i].id) {
								if (artifactArray[i].archived) 
									rows.splice(j, 1);
								else {
									var script = artifactArray[i].defaultScript ? artifactArray[i].defaultScript : artifactArray[i].manualScript;
									var type = Constants.getExtensionDisplayMessage(script.scriptType.name);
									var scriptId = script.id;
									var row = {
										elements: [{value: artifactArray[i].id}, {value: artifactArray[i].name}, {value: type}, this.editor.id],
										scriptObj: artifactArray[i]
									};
									rows.splice(j, 1, row);
								}
								break;
							}
						}
					}
					this._updateTable();
				}
			}	
		},
		_onMouseOverImg: function(e){
	        this.titleRow.className = "title-row image-hover";
	        if (this.vOpen) {
	            this.headerCollapsImg.src = CommonImageCache.COLLAPSE_HOV_ICON;
	            this.headerCollapsImg.title = Constants.getCommonMessage("actionLabel_Collapse")
	        }
	        else {
	            this.headerCollapsImg.src = CommonImageCache.EXPAND_HOV_ICON;
	            this.headerCollapsImg.title = Constants.getCommonMessage("actionLabel_Expand")
	        }
	    },
	            
	    _onMouseOutImg: function(e) {
	        this.titleRow.className = "title-row";
	        if(this.vOpen)
	            this.headerCollapsImg.src = CommonImageCache.COLLAPSE_ICON;
	        else
	            this.headerCollapsImg.src = CommonImageCache.EXPAND_ICON;
	    },
		toggleView:function(e){
			dojo.stopEvent(e);
			if(this.vOpen){
				this._tableViewerNode.style.display = "none";
				this.vOpen = false;
			}else{
				this._tableViewerNode.style.display = "block";
				this.vOpen = true;
				if(!this.initialized)
					this._initialize();
			}
		}

	}
);

})();
