/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup");

dojo.require("dojox.data.dom");
dojo.require("dojo.number");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.template.TemplateClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.CategorySelection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function(){
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var SaveParticipant = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant; 
	var TemplateClient = com.ibm.rqm.planning.web.client.internal.template.TemplateClient;
	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var ContributorSelect = com.ibm.asq.common.web.ui.internal.widgets.ContributorSelect;
    var INITIAL_STATE = "com.ibm.rqm.planning.common.new";  
	
    /**
     *
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup", [dijit._Widget, dijit._Templated], {
        
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/NewItemPopup.html"),
		
		width: (dojo.isFF == 3) ? "430px" : "500px",
		
		labelname: Constants.getMessage("labelname"),
		labeldescription: Constants.getMessage("labeldescription"),
		labelweight: Constants.getMessage("labelweight"),
		labelTemplate: Constants.getMessage("labelTemplate"),
		labeltype: Constants.getMessage("labeltype"),
		labelowner: Constants.getMessage("labelowner"),
		labelOk: Constants.getMessage("labelOk"),
		labelCancel: Constants.getMessage("labelCancel"),
        
        constructor: function(args){
            this.itemType = null;
			this._templates = null;
			this.useSaveContext = true;
            this.onOkCallback = null;
        },
		
		postCreate: function() {
            if (!this.itemType) {
                throw new Error("Parameter 'itemType' is REQUIRED!");   
            } else if (!this.onOkCallback) {
                throw new Error("Parameter 'onOkCallback' is REQUIRED!");   
            }
            //type specific setup
            if (this.itemType == Constants.MODEL_TYPE_SCRIPT) {
                dojo.removeClass(this._typeNode, "hidden");
                EditorUtil.initScriptTypes(this._type, "Manual");  
                this._type.disabled = true;              
                this._leftColumn.width="100%";
                
            } else if (this.itemType == Constants.MODEL_TYPE_CASE) {
                dojo.removeClass(this._weightNode, "hidden");
				this._weight.value = Constants.TEST_CASE_DEFAULT_WEIGHT;
                dojo.removeClass(this._categoriesNode, "hidden");
				dojo.removeClass(this._templateNode, "hidden");				
                dojox.data.dom.removeChildren(this._categoriesNode);
				this._loadTemplates();
	            this._categorySelect = new com.ibm.rqm.planning.web.ui.internal.view.construction.CategorySelection({
	                artifactType: Constants.MODEL_TYPE_CASE,
					selectDefaults: true, //always select defaults, since the artifact is always NEW
                    afterInitialize: dojo.hitch(this, function(){
                        try {
                            // reparent the rows of selects into the this table and adjust the width to line up
                            var selectElements = this._categorySelect._categoriesNode.getElementsByTagName("SELECT");
                            dojo.forEach(selectElements, dojo.hitch(this, function(select){
                                select.style.width = "200px";
                            }));
                            var rowElements = this._categorySelect._categoriesNode.getElementsByTagName("TR");
                            while(rowElements.length > 0){
                                this._newItemPopupTable.tBodies[0].appendChild(rowElements[0]);
                            }
                        } catch (e) {
                            console.error(e);
                        }
                    })
	            });
                this._categoriesNode.appendChild(this._categorySelect.domNode);                
            
			} 

			if (this.itemType != Constants.MODEL_TYPE_PLAN) {
				//enable owner selection (for all types)
            	dojo.removeClass(this._ownerNode, "hidden");
            	//EditorUtil.initContributors(this._owner, null);
				this._ownerSelect = new ContributorSelect();
				dojox.data.dom.removeChildren(this._ownerCell);
				this._ownerCell.appendChild(this._ownerSelect.domNode);
            }
			
			//show this widget as a dialog
			this._showAsDialog();
			
			//set focus on name
			setTimeout(dojo.hitch(this, function() {this._name.focus()}), 50);			
   
		},
		
		_showAsDialog: function() {
            var dialogArgs = {				
				primaryTitle: this.getTitle(),
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };
            
			if (!this._dialog) {
				this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
				if (this.itemType == Constants.MODEL_TYPE_CASE) {
					var cshelp = new CSHelp({contextID: "rqm_new_test_cases.html"});
					cshelp.setButtonLabel(Constants.getMessage("labelAddNewCSHelp"));
					this._dialog.setSecondaryTitleNode(cshelp.domNode);
				} else if (this.itemType == Constants.MODEL_TYPE_SCRIPT) {
					var cshelp = new CSHelp({contextID: "rqm_new_test_scripts.html"});
					cshelp.setButtonLabel(Constants.getMessage("labelAddNewCSHelp"));
					this._dialog.setSecondaryTitleNode(cshelp.domNode);
				}	
				this._dialog.setWidth(this.width);	
				//this._dialog.setSecondaryTitle(this.getTitle());
				this._dialog.contentContainer.appendChild(this.domNode);
				this._dialog.getOkButton().disabled = false;
			}
			this._dialog.open();					
		},
        
        getTitle: function() {
            if (this.itemType == Constants.MODEL_TYPE_PLAN) {
				return Constants.getMessage("labelNewItemTitle", Constants.TYPE_PLAN);
			} else if (this.itemType == Constants.MODEL_TYPE_CASE) {
                return Constants.getMessage("labelNewItemTitle", Constants.TYPE_CASE);
            } else if (this.itemType == Constants.MODEL_TYPE_SCRIPT) {
                return Constants.getMessage("labelNewItemTitle", Constants.TYPE_SCRIPT);
            }       
        },
		
		isUseSaveContext: function() {
			return this.useSaveContext;
		},		
		
		_loadTemplates: function() {
			if (this.itemType == Constants.MODEL_TYPE_CASE) {
				//load the templates
				SelectUtility.add( this._template, new Option(Constants.getMessage("labelLoading"), "") );
	            var srh = new ServiceResponseHandler(this, "_setTemplates", "_error");
	            TemplateClient.getTemplates(srh, {editorId: Constants.EDITOR_ID_CASE});    				
			}
		},
		
		_setTemplates: function(templates) {
            this._templates = templates;
			dojox.data.dom.removeChildren(this._template);
            for (var i = 0; i < (this._templates ? this._templates.length : 0); i++) {                        
                var option = new Option(Constants.getExtensionDisplayMessage(this._templates[i].name), this._templates[i].itemId);
                option.selected = this._templates[i].isDefault;
				SelectUtility.add( this._template, option );
            }
			if(this._name && !this._name.disabled)		
				dijit.focus(this._name);	
		},
		
        _getTemplate: function(itemId) {
            for (var i = 0; i < (this._templates ? this._templates.length : 0); i++) {                        
                if (this._templates[i].itemId == itemId) {
					return this._templates[i];
				}
            }    
			return null;       
        },		
        
        getAttributes: function() {
            var item = {
                itemType: this.itemType,
                name: this._name.value,
                description: this._description.value,
                state: INITIAL_STATE
            }
            if (this.itemType == Constants.MODEL_TYPE_CASE) {
                item.weight = this._weight.value;
                var selections = this._categorySelect.getSelectedItemIds();
                if (selections) {
                    item.categories = selections.join();
                }
				//if (this._owner && this._owner.textContent != Constants.getMessage("labelUnassigned")) {
                if (this._ownerSelect && this._ownerSelect.hasSelection()) {
				    //HACK - force owner into summary section's workitem until
					//we decide on an official artifact ownership strategy				
					var wiList = [{
						state: "1",
						section: "com.ibm.rqm.planning.editor.section.testCaseSummary",
						owner: this._ownerSelect.getSelectedItemId(),
						projectAreaName: EditorUtil.getCurrentProjectArea().name
					}];
					item.workItemsJsonString = dojo.toJson(wiList);
				}
				if (this._template.value != null) {
					var template = this._getTemplate(this._template.value);
					item.templateItemId = template.itemId;
					item.templateStateId = template.stateId;
				}
            } else if (this.itemType == Constants.MODEL_TYPE_SCRIPT) {
                item.scriptType = this._type.value;
				if (this._ownerSelect && this._ownerSelect.hasSelection()) {
                    item.ownerId = this._ownerSelect.getSelectedItemId();
					//HACK - force owner into summary section's workitem until
					//we decide on an official artifact ownership strategy				
					var wiList = [{
						state: "1",
						section: "com.ibm.rqm.planning.editor.section.testScript.manual",
						owner: item.ownerId,
						projectAreaName: EditorUtil.getCurrentProjectArea().name
					}];
					item.workItemsJsonString = dojo.toJson(wiList);
				}

            }
            return item;
        },        
        
        getItemForDisplay: function() {
            var item = {
                id: "",
                newItem: true,
                itemType: this.itemType,
                name: this._name.value,
                description: this._description.value,
                state: INITIAL_STATE,
                modified: new Date() 
            }
            //set owner (even for test case), as this is for display only         
            var owner = this._ownerSelect ? this._ownerSelect.getSelectedValue() : null;
            if (owner != null) {
                item.owner = {
                    itemId: owner.itemId,
                    name: owner.label
                }                    
            }			
			//type specific attributes
            if (this.itemType == Constants.MODEL_TYPE_CASE) {
                item.weight = this._weight.value;
                item.categories = this._categorySelect.getSelectedItemIds();
                if (this._template.value != null) {
                    item.template = this._getTemplate(this._template.value);
                }				

            } else if (this.itemType == Constants.MODEL_TYPE_SCRIPT) {
                item.scriptType = {name: this._type.value};
            }			
            return item;
        },        
        
        getItemSaveParticipant: function() {
            var args = this.getAttributes();
            var participant = new com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemSaveParticipant(args);
            return participant;
        },
        
        validate: function() {
            return this.getItemSaveParticipant().validate();           
        },
		
        _onOK: function() {
			this._dialog.getOkButton().disabled = true;
            if (!this.validate()) {
                this._dialog.getOkButton().disabled = false;
				return false;
            } else {
                //this._okButton.disabled = true; 
                this.onOkCallback();			
			}
        },
        
        _onCancel: function(){
            //this.floatingPane.hide();
        },
		
        _error: function(e){
            alert(this.declaredClass + ": Error: " + e.message);
        }		   
        
    });
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemSaveParticipant", [SaveParticipant],
    {
        constructor: function(args) {
            if (!args.itemType) {
                throw new Error("Parameter 'itemType' is REQUIRED!");
            }
            this._itemType = args.itemType;
            this._name = args.name;
            this._description = args.description;
            this._weight = args.weight;
			this._templateItemId = args.templateItemId;
			this._templateStateId = args.templateStateId;
            this._ownerId = args.ownerId;
            this._scriptType = args.scriptType;
            this._state = args.state;
            this._categories = args.categories;
			this.testCaseDesignHTML = args.testCaseDesignHTML;
			this.elementsJsonString = args.elementsJsonString;
			this.dictionaryJsonString = args.dictionaryJsonString;
			this._workItemsJSON = args.workItemsJsonString;
        },
        
        getItemId: function(){
            return null;
        },
        
        getItemType: function(){
            return this._itemType;
        },
        
        isNew: function(){
            return true;
        },
        
        // @override for SaveParticipant
        validate: function(){
            if (!this._name || dojo.trim(this._name).length == 0) {
                alert(Constants.getMessage("msgNameRequired"));
                return false;
            }
            //for TestCase, validate the weight 
            if (this._itemType == Constants.MODEL_TYPE_CASE) {
              if (!this._weight || dojo.trim(this._weight).length == 0 || isNaN(dojo.number.parse(this._weight))) {
                    alert(Constants.getMessage("msgNumericWeightRequired"));
                    return false;
                }
            }
            return true;
        },
        
        // @override for SaveParticipant
        getAttributes: function(){
            var attributes = {
                newItem: true,
                //id: this.isNew() ? null : this.artifact.id,
                name: this._name,
                description: this._description,                               
                state: this._state
                //workItemJsonString: dojo.toJson(workItemData)
            };
			if (this._itemType == Constants.MODEL_TYPE_CASE) {
                attributes.newTestCase = true;
                attributes.weight = this._weight ? this._weight : Constants.TEST_CASE_DEFAULT_WEIGHT;
                if (this._categories) {
                    attributes.categories = this._categories;
                }            
				if (this._workItemsJSON) {
					attributes.workItemsJsonString = this._workItemsJSON;
				}     
                attributes.templateItemId = this._templateItemId;
                attributes.templateStateId = this._templateStateId;
				
            } else if (this._itemType == Constants.MODEL_TYPE_SCRIPT) {
                attributes.newScript = true;
                attributes.ownerId = this._ownerId;
                attributes.type = this._scriptType;
				if (this._workItemsJSON) {
					attributes.workItemsJsonString = this._workItemsJSON;
				}     

				if(this.testCaseDesignHTML){
					attributes.testCaseDesignHTML = this.testCaseDesignHTML;
				}
				if(this.dictionaryJsonString){
					attributes.dictionaryJsonString = this.dictionaryJsonString;
				}
            }
            return attributes;
        },
        
        // @override for SaveParticipant
        saveFinished: function(savedItem){
            this.artifact = savedItem;
            this.setDirty(false);
        },
        
        // @override for SaveParticipant
        saveFailed: function(status){
            //TODO how to handle this case?
        }        
    
    });    
})();
