/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup");

dojo.require("dojox.data.dom");
dojo.require("dojo.number");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");

(function(){
    var CSHelp 					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants; 
	var TagWidget				= com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget;
	var WidgetUtil 				= com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
	var TestScriptClient        = com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var TestScriptTableView     = com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView;
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup", [dijit._Widget, dijit._Templated], {
        templateString: '<div class="com-ibm-rqm-construction-newitem-popup">' +
                        '   <table dojoAttachPoint="_formNode" width="100%"><tbody>' +
                        '      <tr dojoAttachPoint="_nameNode">' +
                        '         <td width="40%"><label for="name" class="label">${labelName}</label></td>' +    
                        '         <td width="60%" style=\"padding-top:5px;\"><input id="name" class="bordered-element" type="text" size="40" dojoAttachPoint="_name" class="input"></input></td>' +
                        '      </tr>' +   
                        '      <tr dojoAttachPoint="_tagsNode">' +
                        '         <td width="40%"><span class="label">${labelTags}<span></td>' +    
                        '         <td width="60%" style=\"padding-top:5px;\"><div dojoAttachPoint="_tags"></div></td>' +
                        '      </tr>'+
						'      <tr>'+
						'      <td colspan=2 style=\"padding-top:5px;\">'+
						'         <div dojoAttachPoint="_associateSection">'+
						'            <input type="checkbox" dojoAttachPoint="_checkValue" dojoAttachEvent="onclick: _checkValueChange"></input>'+
						'            <label style=\"padding:5px\">${labelUseExistingScript}</label>'+
						'         </div>'+
						'      </td>'+
						'      </tr>'+						  
                        '   </tbody></table>' +
						'   <div dojoAttachPoint="_scriptTable"></div>'+                                        
                        '</div>',
        
		width: "600px",
		labelName:Constants.getMessage("labelName"),
		labelTags:Constants.getMessage("labelTags"),
		labelUseExistingScript:Constants.getMessage("labelUseExistingScript"),
        constructor: function(args){
            this.onOkCallback = null;
			this.tagList = [];
			this.showAssociate = true;
			this.okCallbackData = null;
        },
		postCreate: function() {
			var defaultManual = false;
            if (!this.onOkCallback) {
                throw new Error("Parameter 'onOkCallback' is REQUIRED!");   
            }
            var onlyMinePref = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getStoredUserPreferences(
                Constants.USER_UI_CUSTOMISE_QUERYLISTS_ONLY_MY_ASSETS_CATEGORY.key
            );
            this._onlyMineByDefault = onlyMinePref && !dojo.isArray(onlyMinePref) && onlyMinePref.value == true;

			var execPrefs = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getExecutionPreference();
			if(execPrefs && execPrefs.associatemanual)
				defaultManual = true;
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				okCallbackData:this.okCallbackData,
				style: "z-index: 990;",
				zIndex: 990
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.setSecondaryTitle(Constants.getMessage("labelNewItemTitle",Constants.TYPE_KEYWORD));
            this._dialog.getOkButton().disabled = false;
            if (!this.showAssociate) 
				this._associateSection.style.display = 'none';
			else if (defaultManual) {
				this._checkValue.checked = true;
				this._checkValueChange();
			}
			this.show();			
		},
        updateTagList:function(tagList){
			this.tagList = tagList;
		},
		show:function(){
			if(this._tagWidget)
				this._tagWidget.destroy();
			this._tagWidget = new NewKeywordPopup.TagWidget({values:[""],_possibleValues:this.tagList});
			this._tags.appendChild(this._tagWidget.domNode);
			this._name.value = "";
			this._dialog.open(false);
			this._dialog.updatePosition();
		},
        getItemForDisplay: function() {
            var item = {
                name: this._name.value,
				tags:this._tagWidget.tags.value
            }
			if(this._checkValue.checked){
				item.selectedScriptItemId = this._list.getSelectedItems()[0].versionableItemId ? this._list.getSelectedItems()[0].versionableItemId : this._list.getSelectedItems()[0].itemId;
			}
            return item;
        },        
        validate: function() {
            if (!this._name.value || dojo.trim(this._name.value).length == 0) {
                alert(Constants.getMessage("msgNameRequired"));
                return false;
            }
			if (this._checkValue.checked && this._list.getSelectedItems().length <=0) {
				alert(Constants.getMessage("labelSelectTestScript"));
				return false;
			}
			return true;           
        },
		_listTestScripts:function(){
			var tableArgs = {
				profile: Constants.TABLE_PROFILE_MINIMAL,
                showQueryFilters: true,
				allowQuerySnapshots: true,
				minimalAction:true,
                baseTableArgs: {
                    rowsCheckable: true,
                    rowSelectIsSingle: true,
                    showPagingRangeControl: true,
					showFloatinStatusBar:false
                },
                initFilterArgs: {
                    myItemsOnly: this._onlyMineByDefault,
                    includeArchived: false,
                    scriptTypeIds: "com.ibm.rqm.planning.common.scripttype.manual"
                },
				rowCheckedListener:dojo.hitch(this,"rowCheckListener")
			}				
			this._list = new TestScriptTableView(tableArgs);
			this._scriptTable.appendChild(this._list.domNode);
			this._dialog.updatePosition();
		},
		rowCheckListener:function(){
			if (this._list) {
				var items = this._list.getSelectedItems();
				if (items.length > 0) {
					this._dialog.getOkButton().disabled = false;
				}else{
					this._dialog.getOkButton().disabled = true;
				}
			}
		},
		_queryError:function(e){
			console.error(e.msg);
		},
		_checkValueChange:function(){
			if (this._checkValue.checked) {
				this._dialog.getOkButton().disabled = true;
				this._scriptTable.style.display = "inline";
				if (!this._list) {
                    this._listTestScripts();
				}
				else
					this._dialog.updatePosition();
			}else {
				this._scriptTable.style.display = "none";
				this._dialog.updatePosition();
				this._dialog.getOkButton().disabled = false;
			}
		},
        _onOK: function(callbackData) {      
            if (this.validate()) {
				this.onOkCallback(callbackData);
			}
			else {
				return false;
			}
        },        
        _onCancel: function(){

        }        
        
    });
	dojo.declare("NewKeywordPopup.TagWidget", 
             com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget,
{    

		postCreate: function() {
//			WidgetUtil.setSpacerImage(this._spacer);
			var values = this.values;
			this.tags.value = WidgetUtil.getFirstValue(values, true, null, null);
			this._setReadOnlyTagValues(this.tags.value);
			this._previousTagsValue = this.tags.value;
			var self = this;
			this._tagSelector= /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector( {	
					_tagNode: this.tags,
					parentWidget: this,
					_parentNode: this.domNode,
					_callback: function(str) {
						self._updateTagText(str);
					}
				});
/*			if (this.parentController.pageController.isGuest()) {
				dojo.addClass(this.tags, "GuestField");
			}
*/			
			this._tagSelector.setAllTags(this._possibleValues);
			this._isChanged = false;
			this.setReadOnly(false);
			this._areTagsLoaded = true;
		},
		_getAttributeValue: function() {
			return "";//this.workingCopy.getValue({ path: ["attributes", this.attributeId] });			
		},
		
		_setAttributeValue: function(value, isInit){
		}
	});
})();
