//debug projectareaselectordialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation  2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelectorDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.QueryableProjectArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {

var DELAY = 500;
var KEY_ESCAPE = 27;

var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
var QueryableProjectArea = com.ibm.rqm.planning.web.client.internal.QueryableProjectArea;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.ProjectAreaSelectorDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/ProjectAreaSelectorDialog.html"),
		onAdvancedOk: null,
		onAvancedCancel: null,
		projectname: Constants.getMessage("labelEnterPA"),
		matchingProjectAreas: Constants.getMessage("labelMatchingPA"),
		searchLimit: "",
		
	
	constructor: function(args) {
		this.functionArgs = args;
	},
	
	_onOk: function()
	{
		this.onAdvancedOk(
			this.selectedProject			
		);
	},
	
	_onCancel: function()
	{
		this.onAdvancedCancel();
	},
	
	show: function() {

			var dialogArgs = {
				primaryTitle: this.title,				
                okCallback: dojo.hitch(this, "_onOk"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth("350px");
			var cshelp = new CSHelp({contextID: "rqm_projectAreaSelector.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelProjectAreaSelectorCSHelp"));
			this._dialog.setSecondaryTitleNode(cshelp.domNode);
			this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = true;
			this._dialog.getCancelButton().disabled = false;			
            this._dialog.open();
		},
	
	postCreate: function () {
		this.show();
		
		this.projectAreaSelector.size = 15;
		this.connect(this.searchText,"onkeypress","handleSearchChange");
		this.connect(this.searchText,"onchange","handleSearchChange");
		this.connect(this.projectAreaSelector,"onchange", function () {
			this._dialog.getOkButton().disabled = true;			
			for (var i=0; i < this.projectAreaSelector.options.length; i++) {
				if (this.projectAreaSelector.options[i].selected) {
					this._dialog.getOkButton().disabled = false;
					this.selectedProject = {
						itemId: this.projectAreaSelector.options[i].itemId,
						name: this.projectAreaSelector.options[i].name
					};
				}
			}
		});
		this.searchText.focus();
		this._doCancellableSearch();		
	},
	
	
	handleSearchChange: function (e) {
		if(e.keyCode == KEY_ESCAPE) {
			return;
		}
		dojox.data.dom.removeChildren(this.projectAreaSelector);									
		this._doCancellableSearch();
	},
	
	_doCancellableSearch: function() {
		if (this._currentId) {
			clearTimeout(this._currentId);
		}
		this._currentId= setTimeout(dojo.hitch(this, function () {this._doSearch();}), DELAY);
	},
	
	_doSearch: function () {
		var self = this;		
		var serviceObj = {
			success: function (obj) {
				self._loadQueryResults(obj);
			},
			failure: function (errorObj) {
				self._queryError(errorObj);
			}
		}
		var srh= new ServiceResponseHandler(serviceObj, "success", "failure");
		
		var args = {};
		args.maxResults = 50;
		if(this.functionArgs.itemTypeNSUri)
			args.itemTypeNSUri = this.functionArgs.itemTypeNSUri;
		if(this.functionArgs.itemTypeName)
			args.itemTypeName = this.functionArgs.itemTypeName;	
		if(this.searchText.value && this.searchText.value != "")		
			args.namePrefix =  this.searchText.value;
			QueryableProjectArea.getSomeProjectAreas(srh, args);								

	},
	
	_loadQueryResults: function (resultSet) {
		if (resultSet != null) {
			for (var i=0; i < resultSet.length; i++) {				
				var option = new Option(resultSet[i].name, resultSet[i].itemId);
				option.itemId = resultSet[i].itemId;
				option.name = resultSet[i].name;
				this.projectAreaSelector.options[this.projectAreaSelector.options.length] = option;
			}
		}
	},
	
	_queryError: function () {
		this._setStatusMessage(Constants.getMessage("labelqueryfail"), true);
	},
	
	_clearStatusMessage: function() {
		this.searchStatus.style.visibility = "hidden";
	},
	
	_setStatusMessage: function(msg, isError) {
		this.searchStatus.style.visibility = "visible";
		dojox.data.dom.replaceChildren(this.searchStatus, document.createTextNode(msg));
		this.searchStatus.className= isError ? "ErrorStatus" : "NormalStatus";
	}
});

})();