//Test Suite Editor
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("jazz.core.loader");
// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

(function() { // module container
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Constants    			= com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil     			= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var AbstractArtifactEditor 	= com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor;
var SnapshotEnabledEditor = com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor;
var YesNoDialog				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var ViewHeaderLayout 		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor",
	[dijit._Widget, dijit._Templated, AbstractArtifactEditor/*, SnapshotEnabledEditor*/],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/TestSuiteEditor.html"),

		// object initializer
		constructor: function(args) {
			this._isInitialized = false;
			this._isNew = false;
			this._doesPrint = true;
			this._printType = "testsuite";
			this._testPlan = null;
			this._testPlanVersionableItemId = null;
			this._supportsDuplicate = true;			
		},
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {	
            this.inherited('postCreate', arguments);
            this.setArtifactType(Constants.TYPE_SUITE);
			//this.setSnapshotClient(com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient);
			this.setCopy(this.copy === true);
			this._isNew = this.copy === true;
			this._hideToC = false;
		},		
		
		initialize: function(args) {
			if (this.getArtifact() && this.parentController) {
                args.testSuite = this.getArtifact();
                args.parentController = this.parentController;
            }			
            if (args != null) {
                if (args.parentController === null) {
                    throw new Error("TestSuiteEditor#initialize: Missing required parameter 'args.parentController'");
                }
              
                if (args.testSuite != null) {
					this.setNew(this.isCopy());
                    this.setNew(false);
					this.setTestPlanVersionableItemId(args.testSuite.testPlan ? args.testSuite.testPlan.versionableItemId: null); 
					if (this.isCopy()) {
		               // clear out the snapshot info
        		       args.testSuite.snapshotInfo = null;					
            		}   
                    this.setArtifact(args.testSuite);
                }
                
                this.parentController = args.parentController;   
                this.initialized = true;
                
            } else if (!this.initialized) {
                throw new Error("TestCaseEditor#initialize: Missing required parameter 'args'");
                return;
            }
			this._suite = this.getArtifact();
			var artifact = this._suite; 
			this.setNew(!artifact || this.isCopy());
			this.setDirty(this.isCopy());
			this.setIsSnapshot(artifact && !this.isCopy() && this._suite && this._suite.snapshotInfo);   
			var clientClassName = "com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient";
			if (dojo.getObject(clientClassName)) {
				this._finishInit();
			} else {
	            var cb = dojo.hitch(this, "_finishInit");
	            jazz.core.loader.load_async(clientClassName, cb);				
			}
		},
		
		_finishInit: function(){
            //create the header node
			this.createLayout();
			// context sensitive help moved from section to header
			var header = this.getHeader();
            header.setCSHelpId("rqm_test_suite_overview.html");
			header.setCSHelpButtonLabel(Constants.getMessage("labelTestSuiteCSHelp"));
            header.setSummaryEditable(true);
            header.setSummaryLabel(Constants.getMessage("labeldescription"));
			header.onSummaryEdited = dojo.hitch(this, this._setEditorDirty);
            this.setLoading(true);

			dojox.data.dom.removeChildren(header.getInfoAttributesNode());
			if ( this._suite != null ) {			
				this.setOriginator(this._suite.originator.name);
                this.setOwner(this.isReadOnly() ? this._suite.owner.name : this._suite.owner.itemId);
				if ( this._suite.description != null ) {
                    header.setSummary(this._suite.description);
				} else {
                    header.setSummary("");
				}
				this.setState(this._suite.state);
			} else {
				this.setNew(true);
				this.setOriginator(EditorUtil.getCurrentContributor().name);
                this.setOwner();
				header.setSummary("");
				this.setState(Constants.STATETRANSITION_STATE_DRAFT);
			}
            
            if (this.isNew() && !this.isCopy()) {
                this._defaultName = header.getTitle();
                this.setLastSaved(Constants.STATUS_NEW);
            }            
            this.setLoadingArtifactComplete();
		},
      
      	createLayout: function(){
//			this._snapshotsNode = document.createElement("div");
            this._sectionsNode = document.createElement("div");
            //create the common header layout
            this.createHeader("testsuite-icon-48", this._sectionsNode/*,this._snapshotsNode*/);
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(this.getHeader().domNode);
//			this._snapshotsNode.appendChild(this.getSnapshotPane().domNode);
            this._showTOC(this._tableOfContentsNode);
			setTimeout(dojo.hitch(this,function(){
	            //load sections                     
				this.loadSections(this._sectionsNode);
			}),0);	    
        },
		
		//override from AbstractArtifactEditor, add Run button
		createHeader: function(iconClass, contentNode, snapshotsNode) {
            this._header = this.inherited('createHeader', arguments);
            //create the save & cancel & run buttons          
            if (!this.isSnapshot()) {
				 dojox.data.dom.removeChildren(this._header.getRightActionsContainer());
				 dojox.data.dom.removeChildren(this._header.getRightActionsBottomContainer());
				 
				 var self = this;
				var arg = {
            		label: Constants.getMessage("labelExeTestSuite"),
            		showLabel: false,
					iconClass: "execute-icon-image",
            		onClick: function(e) {
						self._onExecuteActionClick();
            		}
        		};
        		
        		//if (this._doesPrint == true) {
				//	this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image");
				//}
					
                var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE_EXE;
                var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            
                if (!perm || perm.execute) {
//                    this._runButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
//                    this._runButton.callback = this._onExecuteActionClick;
//                    this._runButton.setDisabled(false);
//                    this._header.getRightActionsContainer().appendChild(this._runButton.domNode);
					this._runButton = this._header.addLeftViewAction(Constants.getMessage("labelExeTestSuite"), dojo.hitch(this, "_onExecuteActionClick"), null, "execute-icon-image");

                }
				this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
                this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
					
	            if (snapshotsNode && !this.isCopy()) {
	                dojox.data.dom.removeChildren(contentNode);
	                this._snapshotButton = this._header.addRightViewAction(Constants.getMessage("labelCreateNewSnapshot"), dojo.hitch(this, "onSnapshot"));
					 this._snapshotButton.addClass("hidden");
	                this._header.getAltContentNode().appendChild(snapshotsNode);
	                this.connect(this._header, "_selectAltContent", "_snapshotsSelected");
	            }                
                this.updateSaveable();
            } 
			return this._header;     
		},
		//Need to fix the order of the sections WI 16726
		_getDisplayable: function() {
            //which set of sections is the display based on
			var sections = [];		
			var artifact = this.getArtifact();				
			if (this.isNew() || (artifact && !artifact.sections)) {
				var editor = this._editorConfig;
				if(editor.sections && editor.sections.length){
					var summarySection = null;
					var testcasesSection = null;
					var designSection = null; 
					var editorSectionsLength = editor.sections.length;
					for(var i=0;i<editorSectionsLength;i++){
						if(editor.sections[i].id == "com.ibm.rqm.execution.editor.section.summary")
							summarySection =editor.sections[i];
						else if (editor.sections[i].id == "com.ibm.rqm.execution.editor.section.testcases")
							testcasesSection = editor.sections[i];
						else if(editor.sections[i].id == "com.ibm.rqm.execution.editor.section.design")
							designSection = editor.sections[i];
						else{
							sections = sections.concat(editor.sections[i]);
						}	
					}
					//Order needs to be Summary, design and Test Case
					var newSections = [];//Sections might be removed from the UI
					if(summarySection != null)
						newSections.push(summarySection);
					if(designSection != null)
						newSections.push(designSection);
					if(testcasesSection !=null)
						newSections.push(testcasesSection);	
					newSections.concat(sections);
					editor.sections = newSections;	
				}
				return editor.sections;
			} else {
				//for existing arifacts, use the sections persisted on the artifact
				sections = artifact.sections;
/*				var newSections = [];
				if(sections && sections.length){
					var testcasesSectionIndex = null;
					var sectionsLength = sections.length;
					for(var i=0;i<sectionsLength;i++){
						if(sections[i].id == "com.ibm.rqm.execution.editor.section.summary") 
							summarySectionIndex = i;
						else if (sections[i].id == "com.ibm.rqm.execution.editor.section.testcases")
							newSections.unshift(sections[i]);
						else
							newSections.push(sections[i]);
					}
					newSections.unshift(sections[summarySectionIndex]);
					sections = newSections;
					delete newSections;
				}
*/			}

            //get the definitions for each from the EditorRegistry
            var definitions = [];
			var len = sections ? sections.length : 0;
            for (var i = 0; i < len; i++) {
                var def = this._editorRegistry.getSection(this, sections[i].id);
				if (def != null) {
					definitions.push(def);
				} else { 
				    //but allow for custom sections
					definitions.push(sections[i]);
				}
            }
			return definitions;
		},

		//override from AbstractArtifactEditor
		_displaySections: function() {
			 //create and append the section widgets to the editor           
            var sectionDefinitions = this._getDisplayable();
			if(sectionDefinitions && sectionDefinitions.length < 3) {
			 	//display TOC
				this._tocTD.style.display = "none";
				this._hideToC = true;
			 }
			 
			dojox.data.dom.removeChildren(this._sectionsNode);     
            this._sections = [];  
			var len = sectionDefinitions ? sectionDefinitions.length : 0;
			var sectionsNode = document.createDocumentFragment();      
            for (var i = 0; i < len; i++) {
				//for defect 17506
				var isExpand = false;
				if(len < 3 && sectionDefinitions[i].id == "com.ibm.rqm.execution.editor.section.testcases")
					isExpand = true;
				else if(len > 2 && i == 0)
					isExpand = true;
				setTimeout(dojo.hitch(this,function(sectionDef,expanded,lastOne){
	                	this.appendSection(sectionDef, expanded,sectionsNode);
						if (lastOne) {
							this._sectionsNode.appendChild(sectionsNode);
							this.updateTableOfContents(true);
						}
					},sectionDefinitions[i],isExpand,i==len-1),
				20*i);
            }     
			//show the table of contents, if the implementor has specified a domNode for it
			if (!this._hideToC) {
				if (!this.getTableOfContents()) {
					this.loadTableOfContents(this._tocNode);
				} else {
					this.updateTableOfContents(true);
				}
			} else {
				//if no table of contents, must show all sections
				this.setSectionDisplayMode(true);
			}
			// create skip to TOC link
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.display = "inline";
			div.style.visibility = "hidden";
			
			var skipToTOC = document.createElement("a");
			skipToTOC.innerHTML = "Skip to table of content";
			skipToTOC.href = "javascript:{}";
			this.connect(skipToTOC, "onclick", "_skipToTOC");
 
 			div.appendChild(skipToTOC);
			this._header.domNode.appendChild(div);
		},
		
		//override from AbstractArtifactEditor
		updateSaveable: function() {
            this.inherited('updateSaveable', arguments);
			if (this._runButton) {
				var artifact = this.getArtifact();
            	var disabled = !this._saveButton.isDisabled() || this.isSaving() || this.isLoading() || this.isArchived() ||
								artifact && ( !artifact.elements || ( artifact.elements.length == 0 ) );
				this._runButton.setDisabled(disabled);
				
            }
        },
		
		 _contentSelected: function() {
		 	this.inherited('_contentSelected', arguments);
			if (this._runButton) {
                this._runButton.removeClass("hidden");
            }
            if (this._snapshotButton) {                
                this._snapshotButton.addClass("hidden");
            }
		 },
		 
		_snapshotsSelected: function() {
			this.inherited('_snapshotsSelected', arguments);
			if (this._runButton) {
                this._runButton.addClass("hidden");
            }
            if (this._snapshotButton) {                
                this._snapshotButton.removeClass("hidden");
			}
		},		
		
		//@Over-riding for AbstractArtifactEditor onSave
		onSave: function(){      
            //clean Header Status: 
			this.getHeader().clearStatus();
			var sections = this.getSections();
			var preProcessorAvailable = false;
			if(!this.validate()){
				return;
			}
			//set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
			this.preProcessor = [];
			var len = (sections ? sections.length : 0);
            for (var i = 0; i < len; i++) {
                if (dojo.isFunction(sections[i].preProcess)) {
                    this.preProcessor.push({sectionId: sections[i].config.id,value: false});
					sections[i].preProcess();
					preProcessorAvailable  = true;
                }else{
					this.preProcessor.push({sectionId: sections[i].config.id,value: true});
				}
			}
			if(!preProcessorAvailable)
				this.markSectionComplete();	
        },
			
		_saveTestSuite: function(){
			var sections = this.getSections();
			var len = (sections ? sections.length : 0);
			for (var i = 0; i < len; i++) {
                if (sections[i].validate() == false) {
                    return false;
                }
            }  
            //Dont invoke the global save transaction call custom save here                 
            //this.getSaveContext().commit();
			
			var args = {resolveWorkItems: true, 
						resolveElements: true,
						resolveElementFullTestase: false, 
						resolveElementsTestcase: true,
						resolveElementsRequest: false,
						resolveElementsResult: false,
						resolveFullCurrentResult: false,
						resolveCurrentResultElements: false,
						resolveFlattenedTestCase: true,
						resolvePlan: false,
						resolveMinimalPlan: true, 
						resolveSection: true,
						resolveCategory: true
					}
			var myAttributes = this.getAttributes();
			for (var element in myAttributes) 
                  args[element] = myAttributes[element];
			args.stateId = this.getStateId();
			var responseHandler = new ServiceResponseHandler(this, "saveFinished", "_saveError");
			com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.postTestExecutionSuiteDTO(responseHandler, args);
		},	
		
		markSectionComplete: function(id, value){
			var wait = false;
			var preProcessor = this.preProcessor;
			var preProcessorLength=preProcessor.length;
			for(var i=0;i<preProcessorLength;i++){
				if(id && value){
					if(preProcessor[i].sectionId == id){
						preProcessor[i].value = value;
					}
				}
				if(preProcessor[i].value == false)
					wait = true;
			}
			if(!wait){
				this._saveTestSuite();
			}
		},
		
		_saveError: function(status){
			this.setSaving(false);
			if (status!=null && status.message!=null) {
				var re = /^\[(\d+)\]\s*:\s*/;
				status.message = status.message.replace(re, "");
			}
            this.setLastSaved(Constants.STATUS_FAILURE, status);
		},
		
		// @override for SaveParticipant
		validate: function(){
			//validate fields
            var name = this.getHeader().getTitle();
            var detailError = Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestSuite"));
			if (dojo.trim(name).length == 0) {
				if (this.isNew()) {
					this.setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
					return false;
				} else {
					this.getHeader().setTitle(this.getArtifact().name);
				}				
			} else if (this._defaultName && name == this._defaultName) {
				this.setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
                return false;
            }
			return true;
 		},
		
		// @override for SaveParticipant
 		getAttributes: function(){
			var testObj = this.inherited('getAttributes', arguments);
            testObj.newTestExecutionSuite = this.isNew();
            testObj.id = this.isNew() ? null : this.getArtifact().id;
            testObj.name = this.getHeader().getTitle();
			testObj.owner = this.getOwnerValue();
			testObj.state = this.getStateValue();
			testObj.description = this.getHeader().getSummary();
			if(this.getTestPlanVersionableItemId()){
				testObj.versionedTestPlanItemId = this.getTestPlanVersionableItemId();
			} else{
				testObj.removePlan = true;
			}
            // snapshot properties
            if (this._createSnapshot == true) {
                testObj.createSnapshot = true;
                testObj.snapshotName = this._snapshotName;
                testObj.snapshotDescription = this._snapshotDescription;
            }

            return testObj;
 		},
		
		// @override for SaveParticipant
 		getItemType: function()	{
			return Constants.MODEL_TYPE_SUITE;
 		},
		
		// @override for SaveParticipant
 		getItemId: function(){
 			return this.isNew() ? null : this._suite.itemId;
 		},
		
		updateTableOfContents: function(selectFirst) {
			var tocWidget = this.getTableOfContents();
			if(tocWidget) {
				this.inherited('updateTableOfContents', arguments);
			}
        },
		
		// @override for SaveParticipant
 		saveFinished: function(testSuite){
			 
			 if(testSuite && testSuite.elements && testSuite.elements.length >0){
			 	var len = testSuite.elements.length;
				for(var i=0;i<len;i++){
					var element = testSuite.elements[i];
					element.workitem = {
						'id': element.ewiId, 
						'name': element.ewiName,
						'itemId': element.ewiitemId,
						'archived': element.ewiIsArchived,
						'testCase': element.testCase,
						'weight': element.ewiWeight	 };
					var workitem = element.workitem;
					if(element.ewiPlanId){
						workitem.testPlan = {
							'id': element.ewiPlanId,
							'name': element.ewiPlanName,
							'versionableItemId': element.ewiPlanVersionableItemId };
					}	
					if(element.ewiPhaseName){
						workitem.testPhase = {
							'name': element.ewiPhaseName,
							'itemId': element.ewiPhaseItemId };
					}
					if(element.scriptId){
						element.script = {
							'id': element.scriptId,
							'name': element.scriptName,
							'versionableItemId': element.scriptItemId,
							'stateId': element.scriptStateId,
							'scriptType': { 'id': element.scriptTypeId }}; 
					}
					if(element.ewiDefaultScriptId){
						workitem.defaultScript = {
							'id': element.ewiDefaultScriptId,
							'name': element.ewiDefaultScriptName,
							'itemId': element.ewiDefaultScriptItemId,
							'stateId': element.ewiDefaultScriptStateId,
							'scriptType': { 'id':  element.ewiDefaultScriptTypeId }};
					}else{
						workitem.defaultScript = null;
					}	
					workitem.stateId = element.ewiStateId;
					workitem.configuration = element.ewiConfigurationItemId;
					
					delete element.ewiId;
					delete element.ewiName;
					delete element.ewiitemId;
					delete element.ewiIsArchived;
					delete element.testCase;
					delete element.ewiDefaultScriptId;
					delete element.ewiDefaultScriptName;
					delete element.ewiDefaultScriptItemId;
					delete element.ewiDefaultScriptStateId;
					delete element.ewiDefaultScriptTypeId;
					delete element.ewiConfigurationItemId;
					delete element.ewiStateId;
					delete element.ewiPlanId;
					delete element.ewiPlanName;
					delete element.ewiPlanVersionableItemId;
					delete element.ewiPhaseItemId;
					delete element.ewiPhaseName;
					delete element.ewiWeight;
					
					delete element.scriptId;
					delete element.scriptName;
					delete element.scriptItemId;
					delete element.scriptStateId;
					delete element.scriptTypeId;
				}
			 }
			 
			 this.setStateChanged(false);
			 this.inherited('saveFinished', arguments);
			 this._suite = this.getArtifact();
             if (this._createSnapshot) {
                // refresh the snapshot list
                this.getSnapshotPane().refreshSnapshots();
                
                // unset the snapshot properties on the editor so next save doesn't create a snapshot
                this._createSnapshot = false;
                this._snapshotName = null;
                this._snapshotDescription = null;
            }
              
 		},
		
		// @override for AbstractArtifactEditor for message string
		removeSection: function(sectionId) {
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgRemoveSectionFromTestSuite"),
				yesCallback: function(){
					 //set the section to not visible
            		var section = self.getSection(sectionId);
            		section.setVisible(false);
            
            		//add to the list to be removed
            		self._sectionsRemoved.push(sectionId);
            
            		//update the table of contents
            		self.updateTableOfContents(true); 
					self.setDirty(true);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();   
        },
    
        onActivated: function(){
            if(this.tcSectionUpdated) {
                var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
                if (tcSection) {
                    tcSection.refreshContents();
                    this.tcSectionUpdated = false;
                }
            }
        },
		
        // handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            // handle test suites deleted
			var artifact = this.getArtifact();
			var artifactArrayLength = artifactArray.length;
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SUITE)) {
                for (var i = 0; i < artifactArrayLength; i++) {
                    if (artifact && (artifact.id == artifactArray[i].id)) {
                        // it is in the deleted artifacts list, close itself
                        // mark editor with warning of associated test case is changed
                        this.getHeader().setStatus(Constants.getMessage("msgEditorTestSuiteDeleted"), ViewHeaderLayout.ERROR);
                        // done updating the editor if it is deleted
						this.setArchived(true);
						if(this._runButton)
							this._runButton.setDisabled(true);
                        return;
                    }
                }
            }else if ((changeType == GlobalEvents.ArtifactsUpdated) && (artifactType == Constants.TYPE_CASE)) {
				var found =  false;
				for (var i = 0; i < artifactArrayLength; i++) {
                    if (artifact && (artifact.elements && artifact.elements.length > 0)) {
                        var suiteElements = artifact.elements;
						var len = suiteElements.length ;
						for(var j=0;j<len ; j++){
							var workitem = suiteElements[j].workitem;
							if(workitem && workitem.testCase.id == artifactArray[i].id){
								workitem.testCase = artifactArray[i];
								suiteElements[j].workitem = workitem;
								artifact.elements.splice(j, 1, suiteElements[j]);
								found = true;
							}
						}
                    }
                }
				if(found){
					this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
					var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
					if(tcSection && tcSection.isInitialized()){
						//if section is open and initialized, reinitialize it on update.
                        this.tcSectionUpdated = true;
						tcSection.update();
					}
				}
            }else if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_EWI)) {
                var found = false;
				for (var i = 0; i < artifactArrayLength; i++) {
                    if (artifact && (artifact.elements && artifact.elements.length > 0)) {
                        var suiteElements = artifact.elements;
						var len = suiteElements.length ;
						for(var j=0;j<len ; j++){
							var witem = suiteElements[j].workitem;
							if(witem && witem.id == artifactArray[i].id){
								witem.archived = true;//Since deleted safe to say true
								suiteElements[j].workitem = witem;
								this.getArtifact().elements.splice(j, 1, suiteElements[j]);
								found = true;
								//TER information is hidden from the user, user understands only Test case here.
								this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
							}
						}
                    }
                }
				var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
				if(tcSection && tcSection.isInitialized() && found){
					//if section is open and initialized, reinitialize it on update.
                    this.tcSectionUpdated = true;
					tcSection.update();
				}
            }else if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
				var found = false;
				for (var i = 0; i < artifactArrayLength; i++) {
					if (artifact && (artifact.elements && artifact.elements.length > 0)) {
                        var suiteElements = artifact.elements;
						var len =suiteElements.length; 
						for(var j=0;j<len ; j++){
							var witem = suiteElements[j].workitem;
							if(witem){
								if(witem.defaultScript && witem.defaultScript.id == artifactArray[i].id)
									witem.defaultScript = null;
								if(witem && witem.testCase  && witem.testCase.scripts && witem.testCase.scripts.length>0){
									var len2 = witem.testCase.scripts.length;
									for(var j=0;j<len2;j++){
										if(witem.testCase.scripts[j].id == artifactArray[i].id){
											witem.testCase.scripts.splice(j,1);
											found = true;
											break;
										}
									}
								}
							}
						}
                    }
                }
				if(found){
					this.getHeader().setStatus(Constants.getMessage("msgTestCaseOfSuiteUpdated"), ViewHeaderLayout.INFO);
					var tcSection = this.getSection("com.ibm.rqm.execution.editor.section.testcases");
					if(tcSection && tcSection.isInitialized()){
					   //if section is open and initialized, reinitialize it on update.
                        this.tcSectionUpdated = true;
						tcSection.update();
					}
				}
			}
        },
		
		_setEditorDirty: function(value){
			if(value == "")
				value = true;
			if(value != true && value != false){
				value = true;
			}
			if(!this.isDirty())
				this.setDirty(value);
		},
		
		_onExecuteActionClick: function() {
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp", dojo.hitch(this, "_executionSuite"));
		},
		
		_executionSuite: function () {
			if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
				//need to validate that all Test Cases are approved
				var suite = this.getArtifact();
				var testCases = suite.elements;
				var badTestCaseString = "";
				if (testCases && testCases.length > 0){
					var testCasesLength = testCases.length;
					for (var i = 0; i < testCasesLength; i++){
						var tc = testCases[i];
						var state = tc.workitem.testCase.state;
						if (state != Constants.STATETRANSITION_STATE_APPROVED) 
							badTestCaseString += " " + tc.workitem.testCase.name;
					}
				}
				if (badTestCaseString != ""){  //Found and offending test case so display a message and return
					var errorStr = Constants.getMessage("msgCannotExecuteSuiteTestCaseNotApproved", badTestCaseString);
					this.setHeaderStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
					return;
				}else{
					//check for approved test suite.
					if (!suite.state || suite.state != Constants.STATETRANSITION_STATE_APPROVED){
						var errorStr = Constants.getMessage("msgCannotExecuteTestSuiteNotApproved", suite.name);
						this.setHeaderStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
						return;
					}
				}	
			}
			var selPopUp = new com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp();
			selPopUp.initialize(this.getArtifact());
		},
		
		getTestPlanVersionableItemId: function(){
			return this._testPlanVersionableItemId;
		},
		
		setTestPlanVersionableItemId: function(testPlanVItemId){
			this._testPlanVersionableItemId = testPlanVItemId;
		},
		setTestPlan:function(testPlan){
			this._testPlan = testPlan;
		},
		getTestPlan:function(){
			return this._testPlan;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ TestSuiteEditor#_error");
		}
	}
);
}
)();