//TCDS
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseDesignSection");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseDesignSection");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup");
dojo.require("com.ibm.asq.common.web.client.internal.option");

(function(){
	
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
	var Button = dijit.form.Button;
    
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseDesignSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
         templateString: "<div dojoAttachPoint=\"_details\" class=\"com-ibm-rqm-test-planning-summary\">"+
							"<div class=\"editor\">"+
								"<table width=\"100%\">"+
									"<tr>"+
										"<td colspan=\"3\">"+
							              "<div class=\"richText\" dojoAttachPoint=\"_richTextEditorNode\"></div>"+
										"</td>"+
									"</tr>"+
								"</table>"+
							"</div>"+
						"</div>",
        
        initialized: false,
		
		constructor: function(){
        },
        
        postCreate: function(args){
            this.inherited('postCreate', arguments);
			this.addWorkItemSupport(EditorUtil.getCurrentContributor().itemId);
			jazz.core.loader.load_async("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestScriptsSection", function(){})           
        },
		
        //@Overriden from AbstractArtifactEditorSection
        initialize: function(isEditable){
            var testCase = this.getArtifact();
            this.unloadContent(this._richTextEditorNode);
            
			this._richText = new RichTextControl({
                editable: this.isEditable(),
				inEditMode: false,  //default to preview mode
				contentHTML: this.getSection().content ? this.getSection().content : "",
				save: dojo.hitch(this, function(){
					var editor = this.getParentEditor();
					if(dojo.isFunction(editor.onSave)){
						editor.onSave();
					}
				})
			});
			this._richTextEditorNode.appendChild(this._richText.domNode);
			dojo.connect(this._richText, "onChange", this, "setDirty");
			this._richText.show();
			
			/*
			 * Enable this if only test script section is present.
			 */
			var scriptSection = this.getParentEditor().getSection("com.ibm.rqm.planning.editor.section.testCaseScripts");
			var disable = scriptSection && scriptSection.getManualScriptGenerationPreference().disableGeneration ? true : false;
			if(scriptSection && !disable){
				var args = {
	                label: Constants.getMessage("labelCreateManualScriptFromDesign"),
	                onClick: dojo.hitch(this, this._openDialogForInputs),
	                iconClass: "generate-scripts-icon",
	                showLabel: false
	            };
				this.convertToManualTestButton = new Button(args);
				this._richText.addButtonInActionNode(this.convertToManualTestButton);
				this.convertToManualTestButton.disabled = this.isEditable() ? false : true;
			}	
			this.initialized = true;
        },
        
		_openDialogForInputs: function(){
			
			var scriptSection = this.getParentEditor().getSection("com.ibm.rqm.planning.editor.section.testCaseScripts");
			var testCaseName = this.getArtifact() ? this.getArtifact().name : null;
			
			this.manualScriptDialog = new com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestScriptsSection.ManualScriptInputDialog({parent: this, 
																   testCaseName: testCaseName, 
																   testCaseDesign: this._richText.getContentHTML(),
																   testScriptsSection: scriptSection});
			this.manualScriptDialog.initialize();
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getActions: function(){
            return null;
        },
        
        //@Overridden from AbstractArtifactEditorSection         
        getHeaderContent: /* String || DOM Node */ function(isEditable) {
            return null;
        },        
		
		validate: function() {
			return true;
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getAttributes: function(){
           return null;
        },
   
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this.addWorkItemSupport();            
        },

		_onChange: function(){
			this.setDirty();
		},
        reset:function(){
			if(this._richText){
				this._richText._doPreview();
			}
		},
		//Returns the latest content in the design editor
		getContent: function(){
			return this._richText ? this._richText.getContentHTML() : this.getSection().content;
		},
		
		//@Overridden from AbstractArtifactEditorSection:		
        getSectionInfo: function() {      
            this.inherited("getSectionInfo", arguments);
            if (this._richText || this.getSection().content) {
                var strValue = this._richText ? this._richText.getContentXHTML() : this.getSection().content;
                this.getSection().attributes = [];
                this.getSection().attributes.push({
                    type: "richtext",
                    name: "content",
                    value: strValue ? dojo.trim(strValue) : ""
                });
            }
			return this.getSection();
        },
		
        _error: function(e){
            throw new Error("An error occurred: [" + e.message + "] @ TestCaseDesignSection#_error");
        }
    });
})();

