/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestPlanChildrenSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.AbstractTableSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");


(function(){ // module container   
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var AbstractTableSection = com.ibm.rqm.planning.web.ui.internal.view.construction.extension.AbstractTableSection;
	var PlanningPageClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TestPlanMapper = com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
    var TestPlanTableView = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
    var YesNoDialog = com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
	var ServiceResponseHandler     = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var PlanningClient              = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	
    // global save context
    var SaveParticipant = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestPlanChildrenSection", [dijit._Widget, dijit._Templated, AbstractTableSection], {
        templateString: '<div class="com-ibm-rqm-planning-web-ui-internal-view-construction-extension-TestPlanChildrenSection">' +
						'  <div class="options">' +
						'      <input name="rollup-checkbox" id="rollup-checkbox" type="checkbox" dojoAttachPoint="_rollupCheckbox" dojoAttachEvent="onclick: _onRollupClick"></input>' +
						'      <label for="rollup-checkbox" class="" dojoAttachPoint="_rollupLabel">${labelRollUpObjectives}</label>' +
						'  </div>' +	                
						'  <div dojoAttachPoint="_tableNode"></div>' +
						'</div>',
		
		labelRollUpObjectives: Constants.getMessage("labelRollUpObjectives"),
		msgRollUpObjectives: Constants.getMessage("msgRollUpObjectives"),
        
        constructor: function(args) {},
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
			
			//type specific setup
            this._itemType = Constants.TYPE_PLAN;
			this._modelType = Constants.MODEL_TYPE_PLAN;
			this._referencesAddedType = "_childrenAdded";
            this._referencesRemovedType = "_childrenRemoved";
			
			this.useSaveContext = false;			
        },
        
		//@Overridden
        initialize: function(){
			this.inherited('initialize', arguments);
			
			var plan = this.getArtifact();
			this._rollupCheckbox.checked = plan && plan.isRollUpObjectives === true ? true : false;
        },
		
		//@Overridden from AbstractTableSection
		refreshContent: function() {
			var srh = new TestPlanMapper(this, "_refreshContentComplete", "_error");
			PlanningPageClient.getTestPlanChildren(srh, {
				uid: this.getArtifact().versionableItemId
			});			
		},

		//@Overridden from AbstractTableSection
        createTable: function(){                        
          var  args={
				parent: this,
				isInSection: true,
				queryName: null, //do not show header/title
                editable: this.isEditable(),
				printable: this.isPrintView(),
                enableRowSelection: true,
				enableRowEditable: this.isRolePermitsEdit(),
                plans: this.getItems(),
                actions: this._getTableActions(),
                contentIsVirtual: false,
				refreshCallback: dojo.hitch(this, "refreshContent"),
                newItemLinkCallback: dojo.hitch(this, "_handleNewItemLink"),
                headerActionInvoked: dojo.hitch(this, "_TestPlanHeaderColumnActionInvoked"),                
                 _handleCategoriesClick:  dojo.hitch(this,"_showCategoriesDialog")    
                };
            var planTableViewer = new TestPlanTableView(args);                           
            this._planTableViewer = planTableViewer;
            return planTableViewer;
        },
        
        _showCategoriesDialog: function() {
                        var x = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor({
                        artifactType: Constants.MODEL_TYPE_PLAN,
                        onSaved: dojo.hitch(this,"_recreateTable") 
                        });
                        
                        },
        _recreateTable: function(params){
            this.createTable();   
             dojox.data.dom.removeChildren(this._tableNode);
             this._tableNode.appendChild(this._planTableViewer.domNode);                                             
        },     
        
        //actions to be displayed in the table header
        _getTableActions: function(){
            var actions = [];
            
            if (this.isRolePermitsEdit()) {
                actions.push({
                    label: Constants.getMessage("labelAddExistingTestPlans"),
                    actionHandler: dojo.hitch(this, "_handleAddClick"),
                    iconClass: "add-icon-image",
                    disabledOnReadOnly: true
                });
            }
            var tp_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_PLAN;
            var tp_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(tp_type);
			if (!tp_perm || tp_perm.create) {
                actions.push({
                    label: Constants.getMessage("labelAddNewTestPlan"),
                    actionHandler: dojo.hitch(this, "_handleAddNewClick"),
                    iconClass: "add-new-testplan-image",
                    disabledOnReadOnly: true
                });
            }
            
            if (this.isRolePermitsEdit()) {
                actions.push({
                    label: Constants.getMessage("labelRemoveTestPlans"),
                    actionHandler: dojo.hitch(this, "_handleRemoveClick"),
                    iconClass: "remove-enabled-icon-image",
                    disabledOnReadOnly: true
                });
            }
            return actions;
        },
		
        _removeItem: function(item){
            var updatedItems = [];
            var items = this.getItems();
            for (var i = 0; i < items.length; i++) {
                //if this item is not new && its itemId doesn't match the item to be removed's itemId
                var iItem = items[i];
				if (iItem.itemId && iItem.itemId != item.itemId) {
                    //don't touch it; add it back to the list
					updatedItems.push(iItem);
                } else if (iItem.newItem && iItem.uid != item.uid) {
					updatedItems.push(iItem);
                } else {  
                    var itemId = iItem.versionableItemId ? iItem.versionableItemId : iItem.itemId;
                    if (iItem.newItem) {
                        //remove from itemsAdded and do not add to new list
						this._itemsAdded = this._removeItemByUid(this._itemsAdded, iItem.uid);
                    } else if (this._containsItemId(this._itemsAdded, itemId)) {
                        //handle existing items ADDED during this session
						this._itemsAdded = this._removeItemId(this._itemsAdded, itemId);
                    } else {
                        //handle existing references, add them 'removed'
                        this._itemsRemoved.push(itemId);
                   	}
				}
            }
            this.setItems(updatedItems);
        },		
		
        _removeItemByUid: function(array, uid){
            var updatedArray = [];
            for (var i = 0; i < array.length; i++) {
                var item = array[i];
				if (dojo.isString(item) || (item.uid && item.uid != uid)) {
                    updatedArray.push(array[i]);
                }
            }
            return updatedArray;
        },		
        
        _TestPlanHeaderColumnActionInvoked: function(columnIndex, actionId){            
            var planTV = this._planTableViewer;
            var categoryTypes = planTV.categoryTypes;
            this.categoryType = null;            
            for (var i = 0; i < categoryTypes.length; i++) {
                var categoryName = Constants.getMessage(categoryTypes[i].name);
                if (categoryName == actionId) {
                    this.categoryType = categoryTypes[i];
                    break;
                    }
            }                   
            var args = {
                categoryType: this.categoryType,
                actionId: actionId,
                okCallback: dojo.hitch(this, "_handleBulkChanged")
            };
            var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup();
            dlg.initialize(args);
        },
        
        _handleBulkChanged: function(args)
        {                        
            var planTV = this._planTableViewer;            
            var items = planTV.tableViewer.getCheckedRows();
            var size =(items ? items.length : 0);
            for(var i = 0; i < size; i++) 
            {//Add a saveparticipant for each changed plan item          
                var item = items[i];
                this.updatePlanChildItem(item,  args.categoryValueItemId);                
            }
            this.setDirty();
            this._tableViewer.tableViewer.content = this.getItems();
            this._tableViewer.tableViewer.refresh();            
        },
                                
        updatePlanChildItem: function(item, categoryValue)
        {
            //Refresh items
            var oldItems = this.getItems();
            var updatedItems = [];
            var olditemsSize = oldItems.length;
            for (var j = 0; j < olditemsSize ; j++) {
                var tmpItem = oldItems[j];
                if ((tmpItem.newItem && tmpItem.participantId == item.participantId) ||
                    (tmpItem.itemId && item.itemId && tmpItem.itemId == item.itemId)) {                       
                        this.updateCategory(tmpItem,categoryValue);
                   }
                updatedItems.push(tmpItem);
            }   
            this.setItems(updatedItems);   
                        
            var categories =  this.transformCategories(item.categories);
            if(item.newItem) {
                //if this item is new
                var participant = this.getSaveContext().findParticipant(item.participantId);
                var oldAttribute = participant.getAttributes();
                participant.getAttributes = function(){
                    var attributes = {
                        newItem: true,
                        itemId: itemId,
                        //changed
                        categories: categories                       
                    };          
                    if (oldAttribute.workItemsJsonString) {
                        attributes.workItemsJsonString = oldAttribute.workItemsJsonString;
                    }
                    return attributes;
                }; 
            }
            else {
                var versionableItemId = item.versionableItemId ? item.versionableItemId : null;
                var itemId = item.versionableItemId ? item.versionableItemId : item.itemId;
                var stateId = item.itemId;
                var itemType = Constants.MODEL_TYPE_PLAN;
                //existing item, then add saveParticipant
                var saveParticipant = this.getSaveContext().findParticipant(itemId);
                if(!saveParticipant) {
                    //handle existing test case
                    saveParticipant = new SaveParticipant();
                    this.getSaveContext().addParticipant(saveParticipant);
                }
                saveParticipant.setDirty(true);
                saveParticipant.getItemId = function(){
                    return itemId;
                };
                saveParticipant.getVersionableItemId = function(){
                    return versionableItemId;
                };
                saveParticipant.getItemType = function(){
                    return itemType;
                };
                saveParticipant.getStateId = function(){
                    return stateId;
                };
                saveParticipant.getAttributes = function(){
                    var attributes = {
                        itemId: itemId,
                        //changed                        
                        categories: categories
                    };
                    return attributes;
                };
                saveParticipant.saveFinished = function() {
                    saveParticipant.setDirty(false);
                };
            }
                
           
            this.categoryType = null; //clean variable                 
        },
        
        transformCategories: function(categories)
        {
            //For a strange reason, the Save test plan doesn't accept arrays on categories as others do, 
            // it just accepts strings, so we must convert them to strings
            var fString = "";
            if(categories)
            {
                var size = categories.length;
                for(var i=0; i < size; i++)
                {
                    var tmpcategory = categories[i];
                    if(tmpcategory)
                        fString+=tmpcategory.itemId+",";
                }
            }
             return fString;                    
        },
        
        updateCategory: function(item,categoryValue)
        {
          var category = this.getCategory(categoryValue);
          var categories = item.categories;
          var found = false;
          if(categories)
          { 
              var newCategories = [];    
              var catSize = categories.length;
              for(var i=0; i < catSize ; i++)
              {
                  //If the selected category is found change it for the new value
                  var tempCat = categories[i];
                  var catType = (tempCat && tempCat.categoryType)? tempCat.categoryType.itemId : "";
                  if(catType == this.categoryType.itemId )
                  {
                       //If category was found, and category is null
                       //the user most likely selected "unasigned", 
                       //so we must not add the category 
                      if(category != null)                     
                        newCategories.push(category);
                    found = true;   
                  }
                  else  
                    newCategories.push(tempCat);
              }
              item.categories = newCategories;
          }
          else          
               item.categories = [];
               
          if(!found && category != null)
            item.categories.push(category);                                                               
        },
        
        getCategory: function(category)
        {
           if(this.categoryType)
           {           
               var size = this.categoryType.categories.length;           
               for(var i =0;i<size; i++)             
               {
                   var tmpItem = this.categoryType.categories[i];
                   if(tmpItem.itemId == category)
                        return tmpItem;
               }
           }
           return null;           
        },
        
        
        //@Overridden from AbstractArtifactEditorSection
        getAttributes: function(){
			var added = this._simplifyItemsForPost(this._itemsAdded);
            return {
				childrenAdded: dojo.toJson(added),
				childrenRemoved: dojo.toJson(this._itemsRemoved),
				rollupObjectives: this._rollupCheckbox.checked
			};
        },
		
		_simplifyItemsForPost: function(items) {
			items = items || [];
			var iLen = items.length;
			var simplified = [];
			for (var i = 0; i < iLen; i++) {
				var item = items[i];
				var simple = {};
				if (!dojo.isString(item)) {
					simple.isNewItem = true;
					simple.name = item.name;
					simple.description = item.description;
				} else {
					simple.isNewItem = false;
					simple.itemId = item;
				}
				simplified.push(simple);
			}
			return simplified;
		},
		
		_onRollupClick: function() {
			//set the editor to dirty
			this.setDirty();
		},      		
        
        _error: function(error) {
            console.error(this.declaredClass + ": Error occurred: " + error.message);
        }		
        
    })
    
})();
