/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
ComparePlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ComparePlugin");
ComparePlugin.PLUGIN_ID = 'pastecompare';

dojo.require("dijit._editor._Plugin");
dojo.require("dijit.form.Button");
dojo.requireLocalization("dijit._editor", "LinkDialog");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ComparePlugin", [dijit._editor._Plugin], {
        buttonClass: dijit.form.Button,
        useDefaultCommand: false,
        _onCloseDialog: function(){
            if (dojo.isIE) {
                if ("_savedSelection" in this) {
                    var b = this._savedSelection;
                    delete this._savedSelection;
                    this.editor.focus();
                    var range = this.editor.document.selection.createRange();
                    range.moveToBookmark(b);
                    range.select();
                }
            }else 
				this.editor.focus();
			this.compareWidget.setDataEntryOnly(this.checkBox.checked);
			this.editor.parentWidget._updatePasteCompareProperty(this.compareWidget.getData());
			if(this.compareWidget)
				this.compareWidget.destroyRecursive();
			this.compareWidget = null;
        },
        
        _onOpenDialog: function(){
            if (dojo.isIE)
                this._savedSelection = this.editor.document.selection.createRange().getBookmark();
            var allProperties = this.editor.parentWidget._getProperties();
			this.compareWidget = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView({
            	hideActual: true });
            this.compareWidget.setData(allProperties[0]);
			var inputLabel = document.createElement("label");
			this.checkBox = document.createElement("input");
			this.checkBox.type = "checkbox";
			inputLabel.appendChild(this.checkBox);
			if(this.compareWidget.getDataEntryOnly())
				this.checkBox.checked = true;
				
			var checkBoxLabel = document.createElement("label");
			checkBoxLabel.innerHTML = Constants.getMessage("labelDataEntry");
			checkBoxLabel.style.padding = "5px";	
			var args = {
                primaryTitle: Constants.getMessage("labelPasteCompare"),
                isClosable: true,
				okCallback:dojo.hitch(this, "_onCloseDialog")
            }
            var dialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
			dialog.setWidth('600px');
			dialog.contentContainer.appendChild(this.compareWidget.domNode);
			dialog.contentContainer.appendChild(inputLabel);
			dialog.contentContainer.appendChild(checkBoxLabel);
            dialog.open();
			this.compareWidget.setFocus();
        },
        
        _initButton: function(){
            this.command = 'inserthtml';
			this.button = new this.buttonClass({
                label: Constants.getMessage("labelPasteCompare"),
                showLabel: false,
                iconClass: "CompareIcon CompareIconIconPos",
                onClick: dojo.hitch(this, "_onOpenDialog"),
                tabIndex: "-1"
            });            
        },
		updateState: function(){
			if (this.editor.parentWidget) {
				var enabled = this.editor.parentWidget.stepBeingEdited !== -1;
				if (this.enabled !== enabled) {
					this.enabled = enabled;
					this.button.attr('disabled', !enabled);
				}
			}
		}
    });
    dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
        if (o.plugin) {
            return;
        }
        switch (o.args.name) {
            case ComparePlugin.PLUGIN_ID:
                o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ComparePlugin({
                    command: o.args.name
                });
        }
    });
})();
