/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecution");
dojo.provide("com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecution");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.appscan.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
//Dojo widget

(function() { // module container

	var Constants 	= com.ibm.rqm.appscan.web.client.internal.Constants;
    var Utility 	= com.ibm.rqm.planning.web.ui.internal.util.Utility;
   
	dojo.declare("com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecution",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.appscan.web", "ui/internal/view/templates/execution/ASEExecution.html"),
		
		constructor: function(args) {
			this._scriptInfo = args.scriptInfo;
			this._properties = args.scriptInfo.properties;    
   		},
		
		postCreate: function(args) 
		{	
			var jobId = 0;
			
            if (this._properties) {
                for (var i = 0; i < this._properties.length; i++) {
                    if (this._properties[i].propertyName == Constants.JOBID) {
                        jobId = this._properties[i].propertyValue;
						break;
                    }                    
                }
            }
			            
            if (jobId > 0) {
                var path = "Jobs/QuickScanStats.aspx?fiid=" + jobId;
                
                var link = new com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink();
                
                link.initialize({
                    path: path,
                    title: Constants.getMessage("view_stats"),
                    text: Constants.getMessage("view_stats")
                });
                
				// Scan statistics section
				var statsContainer = this._createSection({
                	title: Constants.getMessage("view_stats_header"),
                	summary: link.domNode,
					contextHelpId: "rqm_ase_execution_stats.html"
            	});
				
				this._statsContainer.appendChild(statsContainer.domNode);
				
				this._messages = document.createElement('div');
				this._messages.className = "ase_messages";
           
            	var msgContainer = this._createSection({
                	title: Constants.getMessage("scan_progress_header"),
                	summary: this._messages,
					contextHelpId: "rqm_ase_execution_pages.html"
            	});
            	this._msgContainer.appendChild(msgContainer.domNode);
            }
			else {				
				var testScriptLink = document.createElement('a');
				testScriptLink.href = Utility.getTestScriptURI(this._scriptInfo.id);
				testScriptLink.innerHTML = Constants.getMessage("view_test_script_link");
				var p = document.createElement('p');
				p.appendChild(testScriptLink);
				
				this._errormessages = document.createElement('div');
				this._errormessages.innerHTML = Constants.getMessage("execution_with_no_scan");
				this._errormessages.appendChild(p);
			
            	var errorContainer = this._createSection({
                	title: Constants.getMessage("error_details_header"),
                	summary: this._errormessages
            	});
            	this._statsContainer.appendChild(errorContainer.domNode);
			}
		},
		
		_createSection: function(args)
		{
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false, contextHelpId: args.contextHelpId});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
			
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},
		
		showMessages: function(response)
		{
			if(response){
				var messages = response.messages;
				if (messages && this._messages) {
					dojox.data.dom.removeChildren(this._messages);
					for (var i = 0; i < messages.length; i++) {
						var statusMessage = messages[i].message;
						if (statusMessage && statusMessage.length > 0) {
							var label = document.createElement('label');
							label.id = "_statusMessage" + i;
							label.innerHTML = statusMessage;
							this._messages.appendChild(label);
							this._messages.appendChild(document.createElement('br'));
						}
					}
				}
			}	
		},
		
		_error: function(errorObj) {
			console.error("Error: (message: '" + errorObj.message + "') from ASE Execution#_error");	
		}
});
})();	
