/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
console.debug("Loading: com.ibm.rqm.adapter.commandline.web.ui.internal.view.execution.CommandLineExecutionLog");
dojo.provide("com.ibm.rqm.adapter.commandline.web.ui.internal.view.execution.CommandLineExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
//dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
//Clients
dojo.require("com.ibm.team.process.web.client.projectarea");
(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var DOWNLOAD_SERVICE_URI 		= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/"; //RQM Downaload Service
var TeamServerClient 			= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

dojo.declare("com.ibm.rqm.adapter.commandline.web.ui.internal.view.execution.CommandLineExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.commandline.web", "ui/internal/view/templates/execution/CommandLineExecutionLog.html"),
		postCreate: function() {		
		},
		
		initialize: function()
		{
			var result = this.result;
			var resultProperties = result.properties;
			if (resultProperties)
			{
				var resultPropertiesLength = this.result.properties.length
				for (var i = 0; i < resultPropertiesLength; i++)
				{
					if(resultProperties[i].propertyName == "message")
					{
						var label1 = document.createElement('label');
						label1.innerHTML = resultProperties[i].propertyValue;
						this._detailsContainer.appendChild(label1);
					}
				}
			}
			this._detailsContainer.appendChild(document.createElement("br"));
			if (result.attachments)
			{
				//Write CommandLine Test details here
				//var label = document.createElement('label');
				//label.innerHTML = "CommandLine Execution Log: ";
				//this._detailsContainer.appendChild(label);
				//var attachID = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + this.result.attachments[0].itemId;
				var resultAttachments = result.attachments;
				var len = resultAttachments.length;
				for (var i = 0; i < len; i++){			
//					var text = "Rational CommandLine Tester Log";
//					if (this.result.attachments[i].customField){
//						text = text + ": CustomField='" + this.result.attachments[i].customField + "'";
//					}
					var text="";
					this._detailsContainer.appendChild(this._getDownloadAnchor(resultAttachments[i], text));
					this._detailsContainer.appendChild(document.createElement("br"));
				}
			}
			
		},
		
		_getDownloadAnchor: function(attachment, text) {
		
			var saveAnchor= document.createElement("a");
			saveAnchor.className= "actionLink";
			saveAnchor.target = "_blank";
			saveAnchor.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachment.itemId + "?attach=0";			
			saveAnchor.appendChild(document.createTextNode(text+attachment.name));					
			return saveAnchor;
		}
	}
);

}
)();