/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Clients Required
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
// Utilities required
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
//TestPlanTableView is already loaded by PlanningActionBarEntry.. messing with dojo requires creates problems for 2.0.1. WI 28106
//dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

(function() { // module container

var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants    				   	= com.ibm.rqm.planning.web.client.internal.Constants;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;					
var TestCaseClient   			   	= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
var UserClient 						= com.ibm.asq.common.web.client.internal.ContributorClient;
var ExecutionWorkItemClient 	   	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var Utility						    = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var PlanClient						= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var TimeBoxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var GlobalEvents                    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var TestPlanMapper					= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
var TestCaseMapper					= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var YesNoDialog						= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TestCaseTableView       		= com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RtlmUiUtil						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var CommonImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var CommonUtility                   = com.ibm.asq.common.web.ui.internal.util.Utility;
var TestPlanTableView       		= com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/CreateExecutionWorkItem.html"),
		widgetsInTemplate: true,
		labelBrowse: Constants.getMessage("labelBrowse"),
		constructor: function(){
			this._doesPrint = true;
			this._printType = "executionworkitem";
		},		

		postCreate: function(){		
			this._isNew = true;
            this._dirty = false;
			this._createHeader();
			this.initialize();
			//get the list of contributors
			var responseHandler = new ServiceResponseHandler(this, "_doInitContributors", "_error");			
			UserClient.getContributors(responseHandler);
			
			var colen = Constants.getMessage("labelColen");
            this._TPLabel.innerHTML = Constants.getMessage("labelTestPlan") + colen ;
            this._IterationLabel.innerHTML = Constants.getMessage("labelIteration")+ colen;
            this._executeTCLabel.innerHTML = Constants.getMessage("labelTestCase")+colen;
			this._defaultTSLabel.innerHTML = Constants.getMessage("labelDefaultTS")+ colen;
            this._configLabel.innerHTML =Constants.getMessage("labelAvaiableConfiguration")+ colen;
            this._TC.innerHTML = Constants.getMessage("labelUnassigned");
			this._TP.innerHTML = Constants.getMessage("labelUnassigned");
			this._startLoading();
            
			this.detailSection.setDisplayTitle(Constants.getMessage("labelDetail"));
			this.detailSection.setCSHelpId("rqm_ter_detail.html");
			this.detailSection.setCSHelpButtonLabel(Constants.getMessage("labelDetailHelp"));
			this.testEnvironmentSection.setDisplayTitle(Constants.getMessage("labelConfig"));
            this.testEnvironmentSection.setCSHelpId("rqm_ter_env.html");
			this.testEnvironmentSection.setCSHelpButtonLabel(Constants.getMessage("labelConfigHelp"));
			
			this._browseTP.src = CommonImageCache.ADD_ICON_ENABLED;
			this._browseTP.alt = this._browseTP.title = Constants.getMessage("labelSelectTestPlan");
			this._clearTP.alt = this._clearTP.title = Constants.getMessage("lableClear");
			this._clearTP.src = CommonImageCache.CLEAR_FILTER_ENABLED;
			this.browseTPClickAction = this.connect(this._browseTP,"onclick", "_browseTPClick");
			this.filterTPClickAction = this.connect(this._clearTP, "onclick", "_clearTPClick");
			
			this.connect(this._Iteration,"onchange","_onChange");
			this.connect(this._configurations,"onchange","_onChange");
			this.connect(this._TS,"onchange","_onChange");
			this._browseTC.src = CommonImageCache.ADD_ICON_ENABLED;
			this._browseTC.alt = this._browseTC.title = Constants.getMessage("labelSelectTestCase");
			this._clearTC.alt = this._clearTC.title = Constants.getMessage("lableClear");
			this._clearTC.src = CommonImageCache.CLEAR_FILTER_ENABLED;
			this.browseClickAction = this.connect(this._browseTC,"onclick", "_browseClick");
			this.filterClickAction = this.connect(this._clearTC, "onclick", "_clearClick");
			this.allTestCases = [];
			this.allPlans = [];
			this.testCases = [];
			this._projectAlias = CommonUtility.getCurrentProjectAreaAlias();
			this._initTP();
			this._initTC();
		},
		initialize: function(){
			this._isNew = true;
			this._dirty = false;
			if(this.ewi){
				this._isNew = false;
				this._header.setTitle(this.ewi.name);
			}
			else{
				this._header.setTitle("");
			}
			
			this. _updateBrowserTitle();
					
			//clean header
			dojox.data.dom.removeChildren(this._header.getInfoAttributesNode());
			
			//set originator
			var originatorlabel = document.createElement("span");
            originatorlabel.innerHTML = Constants.getMessage("labeloriginatorLabel");
            var originator = document.createTextNode(this.ewi ? this.ewi.originator.name : getAuthenticatedContributor().name);
            this._header.addInfoAttribute(originatorlabel, originator);
		},
		
		_doInitContributors: function(contributors){	
			var ownerlabel = document.createElement("label");
            ownerlabel.innerHTML = Constants.getMessage("labelowner");
			ownerlabel.setAttribute("for", "owner-select");
            this._owner = document.createElement("select");
			this._owner.id = "owner-select";
			this._owner.name = "owner-select";
			this.connect(this._owner, "onchange", "_onChange");
					
			var ewiData = "";
			if(this.ewi){
				ewiData = this.ewi.owner.name;
			}
			var len = contributors.length;
			for (var i = 0; i < len; i++){
				if (contributors[i].name != "ADMIN" && contributors[i].name != "GUEST"){

					var contributorName = contributors[i].name;
                    if (CommonUtility.isUnassignedUserId(contributors[i].itemId)) {
                        contributorName = Constants.getMessage("labelUnassigned");
                    }
					var option = new Option(contributorName, contributors[i].userId);
					if(ewiData !== "" ){
						if(contributors[i].name == ewiData)
							option.selected = true;
					}
					SelectUtility.add( this._owner, option );
				}
			}
			this._header.addInfoAttribute(ownerlabel, this._owner);
		},
		_initTP: function(plans){
			var ewiData = "";
			var ewi = this.ewi;
			if(ewi){
				this._TPvalue = ewi.testPlan ? ewi.testPlan.id : "global"; 
				this._browseTP.src=CommonImageCache.ADD_ICON_DISABLED;
				this._clearTP.src=CommonImageCache.CLEAR_FILTER_DISABLED;
				this.disconnect(this.browseTPClickAction);this.browseTPClickAction = null;
				this.disconnect(this.filterTPClickAction);this.filterTPClickAction = null;
				this._updateTestCases();
				this._updateIterationCombo();
				var ewiData = ewi.configuration ? ewi.configuration : "global";
                this._endLoading();
			}else {
				this.allPlans = [];
				this._TPvalue = "global";
			}
		},
		
		_appendIterations: function(iterations){
			if(iterations && iterations.length > 0){
				var len = iterations.length;
				var allPlans = this.allPlans;
				var len2 = allPlans.length;
				for(var j=0;j<len;j++){
					var iteration = iterations[j];
					for(var i=0;i<len2;i++){
						if(!allPlans[i].iterations)
							allPlans[i].iterations = [];
						if(allPlans[i].versionableItemId === iteration.targetTestPlanUUID){
							allPlans[i].iterations.push(iteration);
						}	
					}
				}
			}
			this._updateIterationCombo();
		},
		_initTC: function(testCases) {
			this.allTestCases = testCases ? testCases:[];
			if(this.allTestCases.length ===0 )
				this._saveButton.setDisabled(true);
            this._header.setProgressStart(Constants.getMessage("labelLoadConfig"));
			var responseHandler= new ServiceResponseHandler(this, "_updateConfigurationCombo", "_error");
			var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
			cfg.getAllMinimal(responseHandler);
		},
		_updateConfigurationCombo: function(configs){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this.configs = configs;
			this._fillConfigurationCombo(ewiData);
			if(ewiData == "global"){
				this.updateSaveable();
                this._endLoading();
				return;
			}
			//Start the init for TPlans to show Test cases and Iterations
            this._updateIterationCombo();
			this.updateSaveable();
            this._endLoading();
            if (this._isNew) {
                this._header.setEditableTitleFocus();
            }
		},
		_fillConfigurationCombo:function(ewiData){
			dojox.data.dom.removeChildren(this._configurations);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			if(ewiData == "global"){
				option.selected = true;
				this._configurations.disabled = true;
			}
			SelectUtility.add( this._configurations, option );
			if(this.configs){
				var configs = [];
				var planId = this._TPvalue;
				if(planId ==="global"){
					configs = this.configs;
				}else{
					var allPlans = this.allPlans;
					var len = allPlans.length;
					var thisConfigs = this.configs;
					var len2 = thisConfigs.length;
					for(var i=0;i<len;i++){
						var id = parseInt(planId, 10);
						var thePlan = allPlans[i];
						if(thePlan.id === id && thePlan.configurations){
							var len3 = thePlan.configurations.length||0;
							for(var k=0;k<len3;k++){
								for(var j=0;j<len2;j++){
									if(thisConfigs[j].id == thePlan.configurations[k]){
										configs.push(thisConfigs[j]);
									}
								}
							}
						}
					}
				}
				var sortedConfig = [];
				if(configs.length > 0){
					var len3 = configs.length;
			        for ( var i = 0; i < len3; i++ ) {
						sortedConfig.push(configs[i]);
			        }
					sortedConfig = sortedConfig.sort(function(c1, c2) {
			            var cSort1 = c1 && c1.name ? (c1.name).toLowerCase() : "";
			            var cSort2 = c2 && c2.name ? (c2.name).toLowerCase() : "";
			            if(cSort1 == cSort2){
							return 0;
						}else
							return cSort1 < cSort2 ? -1 : 1;//Ascending order
			        });
				}
				configs = sortedConfig;
				var len3 = configs.length;
				for(var i=0;i<len3;i++){
					var opt = new Option(configs[i].name, configs[i].id);
					if(ewiData != "" ){
						if(configs[i].id == ewiData){
							opt.selected = true;
							this._configurations.disabled = true;
						}
					}
					SelectUtility.add( this._configurations, opt );
				}
			}
		},
		_updateIterationCombo: function(){
			var planId = this._TPvalue;
			dojox.data.dom.removeChildren(this._Iteration);
			if(planId ==="global"){
				this._Iteration.disabled = true;
				return;
			}
			this._Iteration.disabled = false;
			var allPlans = this.allPlans;
			var len = allPlans.length;
			var ewi = this.ewi;
			for(var i=0;i<len;i++){
				var id = parseInt(planId, 10);
				if(allPlans[i].id === id){
					var planIterations = allPlans[i].iterations;
					if(planIterations && planIterations.length){
						var ewiData = "";
						if(ewi && ewi.testPlan && ewi.testPlan.id === id && ewi.phase){
							ewiData = ewi.phase.name;
						}
						var len2 = planIterations.length;
						for(var j=0;j<len2;j++){
							var opt = new Option(planIterations[j].name, planIterations[j].itemId);
							if((ewiData !== "" && ewiData === planIterations[j].name)||(ewiData === "" && j == len2-1))  
								opt.selected = true;
							SelectUtility.add( this._Iteration, opt );
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
		},
		_updateTestCases: function(){
			var planId = this._TPvalue;
			if (this.ewi) {
				this._browseTP.src=CommonImageCache.ADD_ICON_DISABLED;
				this._clearTP.src=CommonImageCache.CLEAR_FILTER_DISABLED;
				this.disconnect(this.browseTPClickAction);this.browseTPClickAction = null;
				this.disconnect(this.filterTPClickAction);this.filterTPClickAction = null;
				
				this._TC.innerHTML = this.ewi.testCase.name;
				this._setTS(this.ewi.testCase.scripts,this.ewi.defaultScript);
				this._browseTC.src=CommonImageCache.ADD_ICON_DISABLED;
				this._clearTC.src=CommonImageCache.CLEAR_FILTER_DISABLED;
				this.disconnect(this.browseClickAction);this.browseClickAction = null;
				this.disconnect(this.filterClickAction);this.filterClickAction = null;
				return;
			}
			this._TC.innerHTML = Constants.getMessage("labelUnassigned");
			this._TCItemId = null;
			this._setTS();
			if (planId === "global") 
				this.testCases = this.allTestCases;
			else {
				var allPlans = this.allPlans;
				var len = this.allPlans.length;
				for (var i = 0; i < len; i++) {
					var id = parseInt(planId, 10);
					if (allPlans[i].id === id) {
						this.testCases = allPlans[i].testCases? allPlans[i].testCases:[];
						if (this.testCases.length === 0) {//test Case is required field
							this._saveButton.setDisabled(true);
							return;
						}
						break;
					}
				}
			}
		},
		isDirty:function(){
			return this._dirty;
		},
		setDirty:function(value){
			if (value) {
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, value]);
				this._header.clearStatus();
			}
			this._dirty = value;
		},
		updateSaveable: function() {
            if (this._saveButton) {
                this._saveButton.setDisabled(!this.isDirty());
            }
            if (this._cancelButton) {
                this._cancelButton.setDisabled(!this.isDirty());
            }
            if (this._pdfButton) {
            	this._pdfButton.setDisabled(!this._saveButton.isDisabled());
			}
        },
		onCancel: function(){
			var self = this;
			var args = {
				title: "",
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.setDirty(true);
					self.initialize();
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.setTitle(args.title);
	        dialog.open();
		},
		
		onPDFView: function() {
			var doc = document;
			var identifier = this._printType + "/urn:com.ibm.rqm:" + this._printType +":"+ this.ewi.id;
			var locale = CommonUtility.getSupportedLocale();

			var data = [];
			data.push("<printReq><mimeType>application/pdf</mimeType><fileExtension>pdf</fileExtension>");
			data.push("<resources>");
			data.push("<resource>");
			data.push("<identifier>" + identifier + "</identifier>");
			data.push("<transformArgs>");
			var url = doc.URL;
			url = url.replace(/&/g,"&amp;");
			data.push("<originUrl>" + url + "</originUrl>");
			data.push("<reqNumber>0</reqNumber>");
			data.push("<componentType>STAND_ALONE</componentType>");
			data.push("<printType></printType>");
			data.push("<containsTable>0</containsTable>");
			data.push("<locale>" + locale + "</locale>");
			data.push("</transformArgs>");
			data.push("</resource>");
			if (dojo.isIE) {
				data.push("<isIE>true</isIE>");
			}
			data.push("</resources></printReq>");
			if (printFormDiv == null){
			var printFormDiv = doc.createElement("div");
			var printForm = doc.createElement("form");
			printForm.setAttribute("name","printViewForm");
			printForm.setAttribute("action", net.jazz.ajax._contextRoot + "/secure/service/com.ibm.rqm.xslfo.service.IXSLFOService/" + this._projectAlias);
			printForm.setAttribute("method","POST");
			var printFormData = doc.createElement("input");
			printFormData.setAttribute("name","printData");
			printFormData.setAttribute("type","hidden");
			printFormData.setAttribute("value","");
			printForm.appendChild(printFormData);
			printFormDiv.appendChild(printForm);
			doc.body.appendChild(printFormDiv);}
			printFormData.value = data.join("");
			printForm.submit();
		},
		
		onSave: function(){
			if(!this.ewi){
				if(this._header.getTitle() == ""){
                    var detailError = Constants.getMessage("msgNameRequired");
					this._header.setStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
					return;
				}	
			}
			if (this._isNew && !this._TCItemId) {
                var detailError = Constants.getMessage("msgTestCaseRequired");
				this._header.setStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
				if(!dojo.hasClass(this._TCTD, "box-validation-error"))
					dojo.addClass(this._TCTD, "box-validation-error");
				if(!dojo.hasClass(this._executeTCLabel, "label-validation-error")){
					dojo.addClass(this._executeTCLabel, "label-validation-error");
					dojo.removeClass(this._reqTCMark, "require-validation");
					dojo.addClass(this._reqTCMark, "label-validation-error");
				}
				return;
			}else{
				if(dojo.hasClass(this._TCTD, "box-validation-error"))
					dojo.removeClass(this._TCTD, "box-validation-error");
				if(dojo.hasClass(this._executeTCLabel, "label-validation-error")){
					dojo.removeClass(this._executeTCLabel, "label-validation-error");
					dojo.removeClass(this._reqTCMark, "label-validation-error");
					dojo.addClass(this._reqTCMark, "require-validation");
				}	
			}
			this._setLastSaved(Constants.STATUS_SAVING);
			this.setDirty(false);
			this.updateSaveable();
			this._onSave();
		},
		_onSave: function(){
			var testConfig = this._configurations.value;
			var testCase = this._TCItemId;
			var owner = this._owner.value;
			var name = this._header.getTitle();
			var testPlanItemId = this._getSelectedPlanItemId();
			var testPhase = this._Iteration.disabled ? "" : this._Iteration.value;  
			var params ={
					newExecutionWorkItem: this._isNew,
					owner: owner,
					name: name,
					testCase: testCase
				};
			if (this._TS.value != "" && this._TS.value != "-1") 
				params.defaultScript = this._TS.value;
			if(testConfig && testConfig != "global")
				params.testConfig = testConfig;
			if(testPlanItemId != "global"){
				params.testPlanItemId = testPlanItemId;
			}
			if(testPhase != ""){
				params.testPhase = testPhase;
			}
			if(this.ewi){
				params.id = this.ewi.id;
				if(this.ewi.stateId)
					params.ewiStateId = this.ewi.stateId;
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_savedEWI", "_saveError");
			ExecutionWorkItemClient.postExecutionWorkItem(responseHandler, params);

		},
		_savedEWI: function(args){
			this._setLastSaved(Constants.STATUS_SUCCESS);
            this.wasNew = this._isNew;
			this._isNew = false;
			var responseHandler = new ServiceResponseHandler(this, "_updateUI", "_error");
			ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, {id: args.id});
		},
		_saveError: function(errorObj){
			this._setLastSaved(Constants.STATUS_FAILURE, errorObj);
			this.setDirty(true);
			this.updateSaveable();
		},
		_updateUI: function(ewis){
            dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, ewis ? ewis[0].name : "", "ewi-icon-16-inTab",this._dirty]);
			this.ewi = ewis[0];
			var duplicateTab = false;
			var uri = Utility.getEwiURI(this.ewi.id);
			if(this.wasNew && this.parentController._contentArea.hasPage(uri)){
				this.parentController._contentArea.closeTab(uri);
				duplicateTab = true;
			}
			var name = this._header.getTitle();
			if (name != this.ewi.name || duplicateTab){
				if(duplicateTab){
					this._header.setStatus(Constants.getMessage("labelDuplicateTab"), ViewHeaderLayout.WARNING, Constants.getMessage("msgDuplicateTab"));
				}else{
					this._header.setStatus(Constants.getMessage("labelDuplicate"), ViewHeaderLayout.WARNING, Constants.getMessage("msgDuplicateTER"));
					var anchorNode = document.createElement('span');
					anchorNode.style.textDecoration = "underline";
					anchorNode.style.paddingLeft="5px";
					var label = document.createElement('label');
					label.innerHTML = this.ewi.name;
					anchorNode.appendChild(label);
					this._header.statusLineNode.appendChild(anchorNode);
				}
				dojo.publish(GlobalEvents.ArtifactsUpdated, [ Constants.TYPE_EWI, ewis, null ]);
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.getEwiURI(this.ewi.id)]);
			}else{
				dojo.publish(GlobalEvents.ArtifactsAdded, [ Constants.TYPE_EWI, ewis, null ]);
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.getEwiURI(this.ewi.id)]);
			}
			this.initialize();
		},
		
		closePage: function(){
			this.oldUri = window.location.hash;
			parent.location = Utility.getEwiURI(this.ewi.id);
			setTimeout(dojo.hitch(this, "publishClosure"), 2000);
		},
		
		publishClosure: function(){
			dojo.publish(GlobalEvents.CloseTab, [this.oldUri]);
		},
		
		_setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            
			//VS: Add back permissions, figure out
            // don't change the status message if this is not editable.                                 
//            if (!this.isRolePermitsEdit()) {
//                return;
//            }
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                    if (error.caughtAt) {
                        detail_msg += "<br/><br/><b>" + Constants.getCommonMessage("labelErrorCaughtAt") + "</b> " + error.caughtAt;
                    }                
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1)
                this._header.setStatus(text, st_code, detail_msg);
            else
                this._header.clearStatus();
        },
		_getTestCaseVersionableItemId: function(testCaseItemId){
			if ( this.allTestCases !== null && this.allTestCases.length > 0 ){
				var allTestCases = this.allTestCases;
				var len = allTestCases.length;
				for(var i = 0; i< len; i++){
					if(allTestCases[i].id == testCaseItemId){
						return allTestCases[i].versionableItemId;
					}
				}
			}
		},
		_getSelectedPlanItemId: function(){
			var selectedId = this._TPvalue;
			var itemId = "";
			var allPlans = this.allPlans;
			var len = allPlans.length;
			for (var i = 0; i < len; i++){
				var plan = allPlans[i];
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		onSelectTP: function(){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this._fillConfigurationCombo(ewiData);
			this._updateTestCases();
		},
		_createHeader: function(title) {
			var iconClass = "ewi-icon-48";
			var _header = this._header;
			_header.setIconClass(iconClass);  
			_header.setCSHelpId("rqm_create_ter.html");
			_header.setCSHelpButtonLabel(Constants.getMessage("labelTestExecutionRecordHelp"));
            _header.setNoValueEditableTitleLabel(Constants.getMessage("labelEnterNewEWITitle"));
			_header.setTypeLabel(Constants.getMessage("labelEWI"));
            if (this._doesPrint == true) {
					this._pdfButton = _header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image");
			}
			this._cancelButton = _header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
			this._saveButton = _header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
			this.updateSaveable();
			_header.onTitleEdited = dojo.hitch(this, "_onChange");
			this._pdfButton.setDisabled(true);
            return _header;          
        }, 
		_onChange: function() {
			this.setDirty(true);
			this.updateSaveable();
        },
		_clearClick: function(){
			this._TC.innerHTML = Constants.getMessage("labelUnassigned");
			this._TCId = null;
			this._TCItemId = null;
			this._updateDefaultTestScriptCombo("");
			this._onChange();
		},
		_clearTPClick: function(){
			this._TP.innerHTML = Constants.getMessage("labelUnassigned");
			this._TPvalue = "global";
			this.onSelectTP();
			this._updateIterationCombo();
			this._onChange();
		},
		_browseTPClick:function(){
			var tableArgs = {
				plans: [],
                profile: Constants.TABLE_PROFILE_MINIMAL,
				isSingleSelect:true,
				contentIsVirtual: true,
                showQueryFilters: true,
				isInSection: true,
				showInitLoadProgress:true,
				minimalAction:true,
				showChildPlans:false
			};           
			this._TPlist = new TestPlanTableView(tableArgs);
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelSelectTestPlan"),
                okCallback: dojo.hitch(this, "_setTP"),
				_truncate: function() {},  //disable the Dialog's '_truncate'
			    zIndex: 998,  // need to change the zIndex to allow the table's filters to popup.
                forceZIndex: true	
            };                
            var _dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            _dialog.contentContainer.appendChild(this._TPlist.domNode);
			_dialog.open(false);
			_dialog.updatePosition();
			_dialog.getOkButton().disabled = false;
			this._TPdialog = _dialog;
		},
		_browseClick:function(){
			var planId = this._TPvalue;
			var tableArgs = {
				testCases: this.testCases,
                profile: Constants.TABLE_PROFILE_MINIMAL,
				isSingleSelect:true,
				contentIsVirtual: true,
                showQueryFilters: true
			};
            // add the parent test plan constrain on the query.
			if (planId != "global") {
                tableArgs.parentItemIdArgName = "constrainParentVTestPlan";
                tableArgs.parentVersionItemId = this._getSelectedPlanItemId();
            }
           
			tableArgs.showInitLoadProgress = true;
			this._list = new TestCaseTableView(tableArgs);
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelSelectTestCase"),
                okCallback: dojo.hitch(this, "_setTC"),
				_truncate: function() {},  //disable the Dialog's '_truncate'
			    zIndex: 998,  // need to change the zIndex to allow the table's filters to popup.
                forceZIndex: true	
            };                
            var _dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
	        var cshelp = new CSHelp({contextID: "rqm_add_test_cases.html"});
	        cshelp.setButtonLabel(Constants.getMessage("labelAddExistingCSHelp"));
            _dialog.setSecondaryTitleNode(cshelp.domNode);
            _dialog.contentContainer.appendChild(this._list.domNode);
			_dialog.open(false);
			_dialog.updatePosition();
			_dialog.getOkButton().disabled = false;
			this._dialog = _dialog;
		},
		_refreshTC:function(testcases){
			testcases = testcases?testcases:[];
			var planId = this._TPvalue;
			if (planId != "global") {
				var allPlans = this.allPlans;
				var len = allPlans.length;
				for (var i = 0; i < len; i++){
					if (allPlans[i].id == planId) {
						allPlans[i].testCases = testcases;
						break;
					}
				}
			}else 
				this.allTestCases = testcases;
			this.testCases = testcases;
			this._list.refresh(this.testCases);
		},
		_setTP:function(){
			var addedItems = this._TPlist.getSelectedItems();
			if (addedItems && addedItems.length > 0) {
				this._TPvalue = addedItems[0].id;
				this._TP.innerHTML = addedItems[0].name;
				var createEWISelf = this;
				var allPlans = this.allPlans;
				var len2 = allPlans.length;
				var found = false;
				for(var j=0;j<len2;j++){
					if (addedItems[0].id == allPlans[j].id) {
						found = true;
						break;
					}
				}
				if(!found){
					allPlans.push(addedItems[0]);
					allPlans[len2].iterations = [];
					allPlans[len2].testCases = [];
					var callbackObj = {
						index:len2,
						success: function(results){
							createEWISelf.allPlans[this.index].configurations = results;
							createEWISelf.onSelectTP();
						},
						failure: function(e){
							createEWISelf._error(e);
						}
					}
					var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
					PlanClient.getConfigurations(responseHandler2, addedItems[0].versionableItemId);
					var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
					TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {testPlanId:addedItems[0].versionableItemId});					
				}else{
					this._updateIterationCombo();
					this.onSelectTP();
				}
			}
		},
		_setTC:function(){
			var addedItems = this._list.getSelectedItems();
			if (addedItems && addedItems.length > 0) {
				this._TCId = addedItems[0].id;
				if(addedItems[0].versionableItemId)
					this._TCItemId = addedItems[0].versionableItemId;
				else
					this._TCItemId = this._getTestCaseVersionableItemId(addedItems[0].id);
				this._TC.innerHTML = addedItems[0].name;
				this._updateDefaultTestScriptCombo(this._TCItemId);
				this._onChange();
			}
		},
		_updateDefaultTestScriptCombo: function(tcItemId){
			
			var responseHandler = new TestPlanMapper(this, "_setTS", "_error");
			var args = {versionedTestCaseItemId: tcItemId};
			if (args.versionedTestCaseItemId != "") {
				TestScriptClient.getTestCaseTestScripts(responseHandler, args);
			}	
			else{
				dojox.data.dom.removeChildren(this._TS);
			}
		},
		_setTS: function(testscripts,defaultscript){
			this.allTestScripts = [];
			var allTestScripts = this.allTestScripts;
			dojox.data.dom.removeChildren(this._TS);
			if(testscripts && testscripts.length>0){
				var len = testscripts.length;
				for(var i=0;i<len;i++){
					allTestScripts.push(testscripts[i]);
					var testscript = testscripts[i];
					var option = new Option(testscript.name, testscript.versionableItemId);
					if(defaultscript && defaultscript.versionableItemId == testscript.versionableItemId)
						option.selected = true;
					else if((!defaultscript) && (i === 0))
						option.selected = true;
					SelectUtility.add( this._TS, option );		
				}	
			}		
			var option = new Option(Constants.getMessage("labelNone"), -1);
			SelectUtility.add( this._TS, option );	
		},
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
			if (!this.ewi) {
				var len = artifactArray.length;
				var allPlans = this.allPlans;
				if (artifactType == Constants.TYPE_PLAN) {
					var createEWISelf = this;
					if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
						var found = false;
						for (var i = 0; i < len; i++) {
							var len2 = allPlans.length;
							for(var j=0;j<len2;j++){
								if(allPlans[j].id == artifactArray[i].id){
									if (changeType == GlobalEvents.ArtifactsUpdated) {
										allPlans.splice(j, 1, artifactArray[i]);
										var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
										TimeBoxClient.getTestPhasesSummaryDTO(responseHandler, {testPlanId: artifactArray[i].versionableItemId});
										var callbackObj = {
											index:j,
											success: function(results){
												createEWISelf.allPlans[this.index].configurations = results;
												createEWISelf.onSelectTP();
											},
											failure: function(e){
												createEWISelf._error(e);
											}
										}
										var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
										PlanClient.getConfigurations(responseHandler2, artifactArray[i].versionableItemId);
										break;
									}else{ 
										if(this._TPvalue == allPlans[j].id){
											this._TP.innerHTML = Constants.getMessage("labelUnassigned");
											this._TPvalue ="global";
											this._updateIterationCombo();
											this.onSelectTP();
										}
										allPlans.splice(j, 1);
										break;
									}
									found = true;
								}
							}
						}
					}
					if(changeType == GlobalEvents.ArtifactsUpdated)
						this._header.setStatus(Constants.getMessage("msgTestPlansUpdated"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsDeleted)
						this._header.setStatus(Constants.getMessage("msgTestPlansDeleted"), ViewHeaderLayout.INFO);
				}else if (artifactType == Constants.TYPE_CASE){
					if (changeType == GlobalEvents.ArtifactsAdded) {
						this.allTestCases.concat(artifactArray);
					}else if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
						for (var i = 0; i < len; i++) {
							for(var j=0;j<this.allTestCases.length;j++){
								if (this.allTestCases[j].id == artifactArray[i].id) {
									if (changeType == GlobalEvents.ArtifactsUpdated) {
										this.allTestCases.splice(j, 1, artifactArray[i]);
									}else {
										this.allTestCases.splice(j, 1);
									}
								}
							}
							var len3 = allPlans.length;
							for(var m=0;m<len3;m++){
								if(allPlans[m].testCases){
									for(var n=0;n<allPlans[m].testCases.length;n++){
										if(allPlans[m].testCases[n].id == artifactArray[i].id){
											if(changeType == GlobalEvents.ArtifactsUpdated)
												allPlans[m].testCases.splice(n,1,artifactArray[i]);
											else
												allPlans[m].testCases.splice(n,1);
										}
									}
								}
								if (this._TPvalue == this.allPlans[m].id) {
									this.testCases = this.allPlans[m].testCases;
								}
							}
							if (this._TC.innerHTML == artifactArray[i].name) {
								if(changeType == GlobalEvents.ArtifactsUpdated)
									this._setTS(artifactArray[i].scripts);
								else{
									this._TC.innerHTML = Constants.getMessage("labelUnassigned");
									this._setTS();
								}
							}
						}
					}
					if(changeType == GlobalEvents.ArtifactsUpdated)
						this._header.setStatus(Constants.getMessage("msgTestCasesUpdated"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsDeleted)
						this._header.setStatus(Constants.getMessage("msgTestCasesDeleted"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsAdded)
						this._header.setStatus(Constants.getMessage("msgTestCasesAdded"), ViewHeaderLayout.INFO);	
				}if (artifactType == RtlmUiUtil.TYPE_CONFIG){
					var configs = this.configs;
					if(configs){
						if (changeType == GlobalEvents.ArtifactsAdded) {
							for (var i = 0; i < len; i++) {
								configs.push(artifactArray[i]);
							}
						}else{
							for (var i = 0; i < len; i++) {
								for(var j=0;j<configs.length;j++){
									if (artifactArray[i].id == configs[j].id) {
	                            		if (changeType == GlobalEvents.ArtifactsUpdated) {
											configs.splice(j,1,artifactArray[i]);
										}else if (changeType == GlobalEvents.ArtifactsDeleted) {
											configs.splice(j,1);
										}
									}
								}
							}
						}
						this._fillConfigurationCombo();
						this._header.setStatus(Constants.getMessage("msgTestEnvironmentUpdated",ViewHeaderLayout.INFO));
					}
				}
			}
		},
        
        _startLoading: function()
        {
            this._header.setProgressStart(Constants.getMessage("labelLoadContributors"), /*hideContent*/true);
            dojo.style(this.detailSection.domNode, "visibility", "hidden");
            dojo.style(this.testEnvironmentSection.domNode, "visibility", "hidden");
        },

        _endLoading: function()
        {
            this._header.setProgressEnd();
            dojo.style(this.detailSection.domNode, "visibility", "visible");
            dojo.style(this.testEnvironmentSection.domNode, "visibility", "visible");            
        },
        
		_error: function(errorObj){
            // TODO: better handling
            this._endLoading();
            this._header.setStatus("Error...", Constants.HEADER_STATUS_ERROR, errorObj.message);
			console.error("Error: (message: '" + errorObj.message + "') from Create EWI#_error");
		},
					
		_updateBrowserTitle: function(){
			if (this.page) {
				var name="";
				
				if (this._isNew) {
					name = Constants.getMessage("labelCapitalNew");
				}
				else if (this.ewi && this.ewi.name){
					name = this.ewi.name;
				}
				
				// update browser title
				var browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + name;
				this.page.browserTitle = browserTitle;
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = browserTitle;	

 
			}
		}
	}
);
}
)();
