//FCD
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog");
/*
 * author: vaibhav
 */
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("dijit.form.CheckBox");

(function() { 
var CommonPreferenceClient 		= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var Constants					= com.ibm.rqm.planning.web.client.internal.Constants;
var RichTextControl 			= com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
var ImageCache 					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var ASQImageCache 				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog",[dijit._Widget, dijit._Templated],{

	templateString: "<div class=\"com-ibm-rqm-construction-newitem-popup\">" +
                        	"<div width=\"100%\"><img dojoAttachPoint=\"_topMessageImg\"></img><label dojoAttachPoint=\"_topMessageNode\"></label></div>" +
	                			"<table width=\"100%\">" +
	                				"<tr dojoAttachPoint=\"_verdictNode\">" +
	                					"<td width=\"150px\"><span><b>${labelVerdict}</b></span></td>"+ 
										"<td><span dojoAttachPoint=\"_stepVerdict\"></span></td>" +
										"<img tabIndex=\"0\" class=\"button-point\" dojoAttachPoint=\"_newDefect\" align=\"right\"></img>" +
	                				"</tr>" +
									"<tr dojoAttachPoint=\"_richTextNode\">" +
	                					"<td width=\"150px\"><span><b>${labelActualResult}</b></span></td>"+ 
										"<td colspan=\"2\"><span dojoAttachPoint=\"_actualResult\"></span></td>" +
	                				"</tr>" + 
									"<tr dojoAttachPoint=\"_stopNode\">" +
	                					"<td width=\"150px\"><span><b>${labelStopMsg}</b></span></td>"+ 
										"<td colspan=\"2\"><input type=\"radio\" dojoAttachPoint=\"_stopTestChecked\" dojoType=\"dijit.form.CheckBox\"/></td>" +
	                				"</tr>" + 
	                			"</table>" +
                        "</div>",
	widgetsInTemplate:true,
	labelVerdict: Constants.getMessage("labelStepResult"), 
	labelActualResult: Constants.getMessage("labelActualResult"),
	labelStopMsg: Constants.getMessage("labelStopMsg"),
	defects: [],
	actualResultContent: null,
	
	initialize: function(){
		this._stepVerdict.innerHTML = Constants.getMessage("labelFail");
		dojox.data.dom.removeChildren(this._actualResult);
		this._newDefect.src = ImageCache.NEW_DEFECT;
		this._newDefect.alt = this._newDefect.title = Constants.getMessage("labelAddNewDefect");
		this._topMessageImg.src = ImageCache.NOIMAGE;
		if (!this._richText) {
			this._richText = new RichTextControl({
                editable: true,
				inEditMode: true,  //default to preview mode
				contentHTML: this.actualResultContent ? this.actualResultContent : "" 
			});
            this.connect(this._richText, "onChange", this.onChange);
		}			
		this._actualResult.appendChild(this._richText.domNode);
		
		if(this.newDefectActionCallback){
			this.connect(this._newDefect, "onclick", this.newDefectActionCallback);
		}	
		
		var dialogArgs = {
			primaryTitle: Constants.getMessage("labelConfirmOnFail"),
            okCallback: dojo.hitch(this, "_onOK"),
			cancelCallback: dojo.hitch(this, "_onCancel"),
			movable: true,
			style: "z-index: 80;",
			zIndex: 80
        };
		
        this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		this.floatingPane.setWidth("40%");
		this.floatingPane.getOkButton().disabled = false;    
		this.floatingPane.contentContainer.appendChild(this.domNode);
		this.floatingPane.open();
		this._richText.show();
	},
		
	_onOK: function(){
		if(!this.validate()){
			return false;
		}
		this.floatingPane.getOkButton().disabled = true;
		var args = {
			actualResultContent: dojo.trim(this._richText.getContentHTML()),
			stopTestChecked: this._stopTestChecked.checked
		}
		this.okCallback(args);
	},
	
	_onCancel: function(){
		//Do nothing
	},
						
	onChange: function(){
		if(this._topMessageNode.innerHTML != ""){
			this._topMessageNode.innerHTML = "";//Clear top message
			this._topMessageImg.src = ImageCache.NOIMAGE;
		}
	},
	
	validate: function(){
		if(dojo.trim(this._richText.getContentHTML()) == ""){
			this._topMessageNode.innerHTML = Constants.getMessage("msgMissingActualResult") ;
			this._topMessageImg.src = ASQImageCache.WARNING_ICON;
			return false;
		}
		return true;
	},
	
	uninitialize: function(){
		if(this._richText){
			this._richText.destroy();
		}
	}
	
});
})();
