//ManualExecution
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");

//Dojo widget
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");

dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog");
dojo.require("jazz.util.html");

(function() { // module container
var _textContent=dojo.isIE?"innerText":"textContent"; 

var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var getCurrentProjectArea 			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;

var CommonPreferenceClient 			= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ExecutionClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RegistryClient 					= com.ibm.rqm.planning.web.client.internal.RegistryClient;

var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var StepResultStates				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
var ResultStates					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var ManualExecutionProperties 		= com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
 
var COMMENT_VIEW_TYPE				= "commentView";
var KEYWORD_PROP_TYPE				= "keyword";
var KEYWORD_NAME_TYPE				= 1;
var REMOTE_KEYWORD_TYPE				= 2;
var KEYWORD_STEP_TYPE				= 3;
var NESTED_KEYWORD_TYPE				= 4;
var NOT_RUN_RESULT					= "com.ibm.rqm.execution.common.state.notrun"
var Status                          = "com.ibm.team.repository.web.foundation.Status";

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution",[dijit._Widget, dijit._Templated , ManualExecutionProperties],{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecution.html"),
		labelStep:Constants.getMessage("labelStep"),
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelAttachmentsView: Constants.getMessage("labelAttachmentsView"),
		labelComments: Constants.getMessage("labelComments"),
		labelDefectsView: Constants.getMessage("labelDefectsView"),
		labelCommentsView: Constants.getMessage("labelCommentsView"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelActualResult: Constants.getMessage("labelActualResult"),
		
		widgetsInTemplate:true,
		disableApplyAll: false,
		ewi: null,
		script: null, 
		testcase: null,
		scriptId: null,
		_startTime: null,
		_endTime: null,
		_currentStepNumber: 0,
		_currentIterNumber: 0,
		_resultId: null,
		_resultTypes: [],		
		parentController: null,
		kwScripts: [],
		inProgress: false,
		originalStepNum: null,
		isExecutionOver: false,
		stopTestRequested: false,
		_haltRequested: false,
		//for Datapool: 
		_cells: [],

		postCreate: function() {
			this.script = this.__scriptObject;
			this.stepNumber = 1;
			this._elementMap = [];
			var handler = new ServiceResponseHandler(this, "_setElementTypes", "_error");
			RegistryClient.getAllExecutionElementTypes(handler);
			this._setInitialValues([this.__ewiObject]);			
			this.uncommittedProperty = [];
			this._menus = [];
			this.move_pointer_here = [];
			this.move_pointer_here_by_enter = [];
			this._stepTitle.innerHTML = Constants.getMessage("labelScriptSteps");
			if(!this.printView){
				this._attachment.src = ImageCache.ATTACHMENT_VIEW;
				this._comment.src = ImageCache.COMMENT_VIEW;
				this._defect.src = ImageCache.NEW_DEFECT;
				this._associateDefect.src = ImageCache.DEFECT_VIEW; 
				this._pause.src = ImageCache.PAUSE_ICON;
				this._togglecomment.src = ImageCache.TOGGLE_COMMENT;
				this._resultDropDownButton.src = ImageCache.DROPDOWN_ARROW;
				this._pause.title = Constants.getMessage("labelClickToPauseExe");
				this._resume.title = Constants.getMessage("labelClickToResumeExe");
				this._resume.style.display = 'none';
				this._attachment.title = Constants.getMessage("labelShowAttach");
				this._comment.title =Constants.getMessage("labelComments");
				this._defect.title = Constants.getMessage("labelAddNewDefect");
				this._associateDefect.title = Constants.getMessage("labelAddExistingDefect");
				this._togglecomment.title = Constants.getMessage("labelShowHideComments");
				this._stepsTable.className = "item-table";
				this._stepsHaveVerdict = Utility.getStepsHaveVerdict();
							
				this._passButton.src = ImageCache.PASS_ICON;
				this._passButton.title = Constants.getMessage("labelPass");
				this._passButton.alt = Constants.getMessage("labelPass");
				this._passButtonClickEvent = this.connect(this._passButton, "onclick", this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress",dojo.hitch(this,this._onEnterResultSelected,""));
				
				this._failButton.src = ImageCache.FAIL_ICON;
				this._failButton.title = Constants.getMessage("labelFail");
				this._failButton.alt = Constants.getMessage("labelFail");
				this._failButtonClickEvent = this.connect(this._failButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.INCONCLUSIVE];
				this._otherResultButton.title = Constants.getMessage("labelInconclusive");
				this._otherResultButton.alt = Constants.getMessage("labelInconclusive");
				this._otherResultButtonIdentifier = StepResultStates.INCONCLUSIVE;
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress",  
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));

				if(Utility.getExecutionPreferences().disableApplyAll){
					dojox.data.dom.removeChildren(this._applyAllNode);
					this.disableApplyAll = true;
					this._richTextNode.width = "37%";
					this._applyAllNode.width = "1px";
					this._applyAllButton = null;
					this.tableRowNode.deleteCell(4);
				}else{
					this._applyAllButton.src = ImageCache.APPLY_ALL;
					this._applyAllButton.title = Constants.getMessage("labelApplyAll");
					this._applyAllButton.alt = Constants.getMessage("labelApplyAll");
					this.applyAllButtonClickEvent = this.connect(this._applyAllButton, "onclick", this._applyVerdictForAllStepsRemaining);
					this.applyAllButtonEnterEvent = this.connect(this._applyAllButton, "onkeypress", this._onEnterApplyAll);
				}
				this.showCommentsCol = false;
			}else{
				this.hideToolBar();
			}
			this.ID_KW_TYPE= this.id+"_kwType";
			this.ID_KW_SUMMARY= this.id+"_kwSummary";
			this.TR_ID=this.id + "_tr";
			this.IMG_ID = this.id+"_img";
			this.STEP_DESC_ID = this.id+"_stepDesc";
			this.RESULT_ID = this.id+"_results";
			this.PROPS_ID = this.id+"_prop";
			this.DEFECT_ICON = this.id+"_defectIcon";
			this.DEFECT_ID	= this.id+"_defect";
			this.ATTACH_ICON = this.id+"_attachIcon";
			this.ATTACH_ID = this.id+"_attach";
			this.COMMENT_ICON = this.id+"_commentIcon";
			this.COMMENT_ID = this.id+"_comment";
			this.COMPARE_ICON = this.id+"_compareIcon";
			this.COMPARE_ID = this.id+"_compare";
			this._resultDropDownButton.id = this.id+"resultDropdownIcon";
			this.STEP_EXP_RES_ID = this.id + "_expRes";
			this.STEP_ACT_RES_ID = this.id + "_actRes";
			this.ID_COMMENT_COL_AREA = this.id+"_commentColArea";
			this.ID_COMMENT_COL_CELL = this.id+"_commentColCell";
			setTimeout(dojo.hitch(this, "_connectMouseListeners"), 200);	
		},
		
		_getElementTypeById: function(id) {
			return this._elementMap[id];
		},	
		
		_setElementTypes: function(elementTypes) {
			var len = elementTypes.length;
			for(var i=0;i<len;i++){
				if(elementTypes[i].name == "Execution Step")
					elementTypes[i].displayName = Constants.getMessage("labelExecutionStep");
				else if(elementTypes[i].name == "Reporting Step")
					elementTypes[i].displayName = Constants.getMessage("labelReportingStep");
				else if(elementTypes[i].name == "Keyword")
					elementTypes[i].displayName = Constants.getMessage("labelKeyword");	
				elementTypes[i].iconUrl = ImageCache.getTypeIconURL(elementTypes[i])
				this._elementMap[elementTypes[i].id] = elementTypes[i];	
			}
		},
		_postExecute:function(){
			var par = {
				ewiItemId: this.ewiItemId,
				testScriptItemid: this.script.versionableItemId  ? this.script.versionableItemId: this.script.itemId,
				owner: getAuthenticatedContributor().userId,
				ewiStateId:this.ewi.stateId,
				startTime:this._startTime
			}
			if(this.requestId){
				par.requestId = this.requestId;
			}
			var self = this;
			var callbackObj ={
				success: function(result){
					self._resultId = result.itemId;
					self._resultIdInt = result.id;
					self._resultStateId = result.stateId;
					self.ewi.stateId = result.ewiStateId;
					self.ewi.currentResult = result;
					if(result.requestStateId && dojo.trim(result.requestStateId).length > 0){
						//Update if valid
						self.requestStateId = result.requestStateId;
					}
					self.parentWidget._resultId = result.itemId;//Update resultID in EPB for tabclosure
					self.parentSection._resultId = result.itemId;//Update resultID in MES for consistant data.	
					dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.startExecution(self.ewiItemId, self.runScriptId, self._resultId, self.requestId, self.ergId)]);
					dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_EXE_LOG, [result]]);
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self.ewi]]);
					self._updateInProgress = false; 
					self._getResult(result);
				},
				error: function(e){
					self._updateInProgress = false;
					self._saveError(e);
				}	
			}	
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");			
			ExecutionWorkItemClient.postExecute(responseHandler, par);
		},
		hideToolBar: function(){
			this.toolbarNode.style.display = "none";
			this.tableContentNode.style.height = "auto";
			this.showCommentsCol = true;
			dojo.style(this.comments_col_header, 'display', '');
			dojo.style(this.comments_col, 'display', '');
		},
		
		_setInitialValues: function(ewi){
			this.ewi = ewi.length?ewi[0]:ewi;
			if(this.ewi.testCase !== null)
				this.testcase = this.ewi.testCase.name;
			if(this.runScriptId === null)
				this.runScriptId = this.ewi.defaultScript.versionableItemId;
			if(this._resultId === null){
				this._postExecute();
			}else{
				if(this._iterationSelect){
					this._iterationSelect.disabled = true;
				}
				var args = { resultItemId: this._resultId };
				var responseHandler = new ServiceResponseHandler(this, "_getResult", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
			//Get the ExecutionElementResultStates from the controller (EABE)
			this._initStateTypes(this.parentController.getElementResultStates());
		},
		
		_initStateTypes: function(types){
			var _resultTypes = [];
			var len = types.length;
			for (var i = 0; i < len; i++) {
				if(types[i].id == NOT_RUN_RESULT){
					continue;
				}
				_resultTypes.push(types[i]);
			}
			this._resultTypes = _resultTypes;
			
		},
		_getResult: function(result){
			this._collectDateTime("start");
            this._ER = result;
			this._resultStateId = result.stateId;
			this._resultIdInt = result.id;
			this._initializeLog();
		},
		_initializeLog: function(){
			if(!this._ER.elementResults || this._ER.elementResults.length == 0){
				this.parentSection._displayAlertDialog(Constants.getMessage("msgNoStepInScript"));
				this._toggleApplyButton(true);
				this._disableImages();
				this._pause.src = ImageCache.NOIMAGE;
				return;
			}
			this._iterations = this._ER.iterations || 1;
			this.numberOfSteps = this._ER.iterationSize;
			this.initIteration();
			this.initialise();
		},
	
	    initIteration: function(){
			var _iterations = this._iterations;
            if (_iterations > 1) {
				var len = _iterations;
                for (var i = 1; i <= len ; i++) {
                    var opt = new Option(i, i);
                    SelectUtility.add(this._iterationSelect, opt);
                }
                SelectUtility.select(this._iterationSelect, _iterations);
                this._iterationSelect.style.display = "inline";
            } 
        },
		
		initialise: function(){
			this._paused = false;
			this._layoutUI();
			if (this.nestedKeywordPresent) {				
				this._displayAlertDialog(Constants.getMessage("msgNestedKeywordPresent"));
			}
		},
		_layoutUI:function(){
			var elementResults =this._ER.elementResults;
			this._disableResultSelectBox(false);
            this._resume.style.display = 'none';    
			dojox.data.dom.removeChildren(this._stepsTableBody);
			var numberOfSteps = this.numberOfSteps;
			var _iterations = this._iterations;
			var _currentIterNumber = this._currentIterNumber;
			var doc = document;
			var stepsWithVerdict = 0;
			this.completedStepsWithVerdict = 0;
			//Add for print view
			if(this.printView && _iterations > 1){
				var len = _iterations;
				this.stepNumber = 1;
				for(var j=0;j<len ;j++){
					var total = j*numberOfSteps;
					for(var i = 0; i < numberOfSteps; i++){
						var index = i+total;
						this._createStepRow(doc,index, elementResults[index]);
					}
					if(j<_iterations)
						_currentIterNumber++;
				}
			}else{
				// present the initial iteration
				var total = _currentIterNumber * numberOfSteps;
				this.stepNumber = 1;
				for(var i = 0; i < numberOfSteps; i++){
					var index = i+total;
					var ret = this._createStepRow(doc,index, elementResults[index]);
					if(ret)
						stepsWithVerdict+=1;
					
				}
				this.actualNumberOfSteps = this.stepNumber-1;
				this.stepsWithVerdict = stepsWithVerdict;				
				this._updateIteration();
			}

			if ((_currentIterNumber + 1) == _iterations) {
				//Add one extra row for pointer to move after execution
				this._createStepRow(doc,numberOfSteps * _iterations, null);	
			}
			if (this._ER.elementResults[0].result.id != NOT_RUN_RESULT) {
                this._updateTableForIncompleteExecution(this._ER);
            }else if(this._ER.elementResults[0].keywordStepType == KEYWORD_NAME_TYPE && 
					elementResults[1] && (elementResults[1].keywordStepType == KEYWORD_STEP_TYPE ||
					elementResults[1].keywordStepType == NESTED_KEYWORD_TYPE)){
						this._updateTableForIncompleteExecution(this._ER);
			}else {
				var eleResult = elementResults[0];
                this.setProperties(eleResult);
                if (this._currentStepNumber == 0 && eleResult.keywordStepType == REMOTE_KEYWORD_TYPE) {
                    this._createKeywordDialog();
                }else if (this._currentStepNumber == 0 && eleResult.keywordStepType == KEYWORD_NAME_TYPE){
					if (elementResults[1] && (elementResults[1].keywordStepType == KEYWORD_STEP_TYPE ||
						elementResults[1].keywordStepType == NESTED_KEYWORD_TYPE)) {
						this.setProperties(elementResults[1]);
						this._moveStepPointer(true);
						this._currentStepNumber = 1;
					}
					this._disableResultSelectBox(false);
				}
            }
			this._destroyEditor();
			this._updateActualResultSection(doc,this._currentStepNumber);
		},
		
		_updateTableForIncompleteExecution: function(result){
			var elementResults = result.elementResults ? result.elementResults : [];
			var count = elementResults.length;
			var _currentStepNumber = 0;
			var completedStepsWithVerdict = 0;
			for(var i = 0; i < count; i++){
				var elementResult = elementResults[i];
				if (elementResult.keywordStepType == KEYWORD_NAME_TYPE) {
					var eleResult = elementResults[i+1];
					if (eleResult && (eleResult.keywordStepType == KEYWORD_STEP_TYPE ||
						eleResult.keywordStepType == NESTED_KEYWORD_TYPE)) {
							this._moveStepPointer(true,_currentStepNumber,_currentStepNumber+1);
							_currentStepNumber += 1;
							continue;
					}
				}
				if((elementResult.result.id == NOT_RUN_RESULT)||
					(elementResult.keywordStepType == REMOTE_KEYWORD_TYPE 
						&& elementResult.result.id == StepResultStates.INCONCLUSIVE))
					break;
				completedStepsWithVerdict+=1;
				this._updateResult(elementResult.result, _currentStepNumber);
				this._moveStepPointer(true,_currentStepNumber,_currentStepNumber+1);
				_currentStepNumber += 1;
			}
			this.completedStepsWithVerdict = completedStepsWithVerdict;
			this._currentStepNumber = _currentStepNumber;
            if (_currentStepNumber == this.numberOfSteps * this._iterations) {
				this.parentWidget.updateProgress(100);
				var resultStateId = elementResults[count-1].resultStateId? elementResults[count-1].resultStateId:this._resultStateId;
                this._setCurrentResult(resultStateId,false);
                return;
            }
			this._updateProgressBar();
			//Update Properties for only last execution element result
			var elementResult = elementResults[_currentStepNumber];
			this.setProperties(elementResult);
			this._startTime = result.startTime;
			this._disableResultSelectBox(false);
			if( elementResult.keywordStepType == REMOTE_KEYWORD_TYPE){
				this._createKeywordDialog();
			}
		},
		
        ////////////////////////////////
		// Layout 
		////////////////////////////////		
		
		_createStepRow: function(doc,index, stepObj){
			if(stepObj && stepObj.keywordStepType == NESTED_KEYWORD_TYPE)
				this.nestedKeywordPresent = true;
				
			//Sanitize the description, expectedresult and actualresult
			if(stepObj){
				if(stepObj.description){
					stepObj.description = jazz.util.html.removeScript(stepObj.description);
				}
				if(stepObj.expectedResult){
					stepObj.expectedResult = jazz.util.html.removeScript(stepObj.expectedResult);
				}
				if(stepObj.actualResult){
					stepObj.actualResult = jazz.util.html.removeScript(stepObj.actualResult);
				}	
			}
			var targetRow = this._getEmptyRow(doc);
			targetRow.id = this.TR_ID+index;
			this._stepsTableBody.appendChild(targetRow);
			var ruleRow = doc.createElement("tr");
			var ruleCell = doc.createElement("td");
			ruleCell.colSpan=12;
			var hr = doc.createElement("hr");
			hr.color="#D6D6D6";
			hr.size="1";
			hr.style.margin="0px";
			ruleCell.appendChild(hr);
			ruleRow.appendChild(ruleCell);
			this._stepsTableBody.appendChild(ruleRow); 
			var stepNum = this.stepNumber;
			if (stepObj && stepObj.keywordStepType == KEYWORD_NAME_TYPE ) {
				if (this._ER.elementResults[index + 1] && (this._ER.elementResults[index + 1].keywordStepType == KEYWORD_STEP_TYPE ||
					this._ER.elementResults[index + 1].keywordStepType == NESTED_KEYWORD_TYPE)) {
				
						this._insertKeywordNameRow(doc, targetRow, stepObj, stepNum, index);
						this.stepNumber += 1;
						return false;
				}
			}
			dojox.data.dom.removeChildren(targetRow);
			//Step image
			var stepCell = this._getEmptyCell(doc);
			var stepImg = doc.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			if((index < this._iterations * this.numberOfSteps) && (index % this.numberOfSteps == 0)){
				stepImg.src = this.printView ? ImageCache.NO_IMAGE : ImageCache.EXECUTION_ARROW;
				dojo.addClass(targetRow, "selected-row");
			}
			else
				stepImg.src= ImageCache.NOIMAGE;	
			stepImg.className = "type-image";
			stepImg.id = this.IMG_ID+ index;
			
			stepCell.appendChild(stepImg);			
			targetRow.appendChild(stepCell);
			
			//step number cell
			var numCell = this._getEmptyCell(doc);
            if (!stepObj || stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE) 
				numCell[_textContent]="";
			else {
				numCell[_textContent]=stepNum;
				this.stepNumber+=1;
			}
			targetRow.appendChild(numCell);
			
			//step type cell
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
            if (!stepObj) 
                typeImg.src = ImageCache.NOIMAGE;
            else if(stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE){
				typeImg.src = ImageCache.NOIMAGE;
			}else{
				var stepType = this._getElementTypeById(stepObj.stepType);
                typeImg.title = stepType.name?stepType.name:"";
                typeImg.alt = stepType.name?stepType.name:"";
                typeImg.src = ImageCache.getTypeIconURL(stepType);
            }
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
            
			//result type cell
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "";
			resultSelect.id = this.RESULT_ID + index;
			resultSelect.className = "type-image";
			resultCell.appendChild(resultSelect);			
			targetRow.appendChild(resultCell);
			
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc);
			var descriptionInput = doc.createElement('div');
			dojo.addClass(descriptionInput,"step-detail-col");
            if (!stepObj) {
				descriptionInput.innerHTML = "";
				this.execOverField = descriptionInput;
			}
			else {
				descriptionInput.innerHTML = unescape(stepObj.description);
			}
			descriptionInput.id = this.STEP_DESC_ID + index;
			if (stepObj && (stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE)) {
				var stepTypeImg = doc.createElement("img");
				var stepType = this._getElementTypeById(stepObj.stepType);
				stepTypeImg.title = stepType.name?stepType.name:"";
                stepTypeImg.alt = stepType.name?stepType.name:"";
                stepTypeImg.src = ImageCache.getTypeIconURL(stepType);
				stepTypeImg.className = "type-image";
				descriptionInput.innerHTML = "";
				descriptionInput.appendChild(stepTypeImg);
				descriptionInput.innerHTML = descriptionInput.innerHTML+unescape(stepObj.description);
			}
			descriptionCell.appendChild(descriptionInput);	
			targetRow.appendChild(descriptionCell);
			if(!stepObj){
				var emptyTD = doc.createElement('td');
				emptyTD.colSpan = 6;
				targetRow.appendChild(emptyTD);
				return false;
			}			
			if(stepObj){
				//Expected result
				var expectedCell = this._getEmptyCell(doc);
				var expectedDiv = doc.createElement('div');
				dojo.addClass(expectedDiv,"step-detail-col");
			    expectedDiv.innerHTML = stepObj.expectedResult ? unescape(stepObj.expectedResult) : "";
				expectedDiv.id = this.STEP_EXP_RES_ID + index;				
				expectedCell.appendChild(expectedDiv);	
				targetRow.appendChild(expectedCell);
				
				//Actual result
				var actualCell = this._getEmptyCell(doc);
				var actualDiv = doc.createElement('div');
				dojo.addClass(actualDiv,"step-detail-col");
			    actualDiv.innerHTML = stepObj && stepObj.actualResult ? unescape(stepObj.actualResult) : "";
				actualDiv.id = this.STEP_ACT_RES_ID + index;
				actualCell.appendChild(actualDiv);	
				targetRow.appendChild(actualCell);
                //Changes for Properties 
                var properties = [];
                if(stepObj)
                    properties = stepObj.properties;
                var propshtml = this._createPropertiesHtml(doc,index, properties,stepObj.attachments,stepObj.comment,stepObj.compare);
                
                var commentColCell = this._getEmptyCell(doc);
				if(!this.printView){
					var commentArea = doc.createElement("textarea");
					commentArea.id = this.ID_COMMENT_COL_AREA+index;
					commentArea.value = stepObj.comment?stepObj.comment:"";
					this.connect(commentArea,'onblur',dojo.hitch(this,function(index,e){
						this.updateCommentProperty(e.target.value,index);
						if(index == this._currentStepNumber){
							this.comment = e.target.value;
							this._updateCurrentStepProps(COMMENT_VIEW_TYPE);
						}
					},index));
					commentColCell.appendChild(commentArea);
				}	
				commentColCell.align = "right";
				dojo.style(commentColCell,"width","15%");
				targetRow.appendChild(commentColCell);
				commentColCell.id = this.ID_COMMENT_COL_CELL+index;
				if(!this.showCommentsCol)
					dojo.style(commentColCell,'display','none');
					
                targetRow.appendChild(propshtml[0]);
                targetRow.appendChild(propshtml[1]);
                targetRow.appendChild(propshtml[2]);
                targetRow.appendChild(propshtml[3]);
            }
			return true;
		},
		_insertKeywordNameRow:function(doc,stepRow,stepObj,stepNum,index){
			var stepCell = this._getEmptyCell(doc);
			var stepImg = doc.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			stepImg.src = ImageCache.NOIMAGE;
			stepRow.appendChild(stepCell);
			var numCell = this._getEmptyCell(doc);
			numCell[_textContent]=stepNum;
			stepRow.appendChild(numCell);
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
			var stepType = this._getElementTypeById(stepObj.stepType);            
            typeImg.title = stepType.name?stepType.name:"";
            typeImg.alt = stepType.name?stepType.name:"";
            typeImg.src = ImageCache.getTypeIconURL(stepType);
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			stepRow.appendChild(typeCell);
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "type-image";
			resultCell.appendChild(resultSelect);
			resultSelect.id = this.RESULT_ID + index;
			stepRow.appendChild(resultCell);
			
			var nameCell = this._getEmptyCell(doc);
			nameCell[_textContent]=unescape(stepObj.description);
			nameCell.colSpan=9;
			stepRow.appendChild(nameCell);
		},
		
		////////////////////////////////
		// Main Execution related stuff
		////////////////////////////////
		onSelectIteration: function(event){
			this._iterations = this._iterationSelect.value;
			this._layoutUI();
			if(event){
                dojo.stopEvent(event);
            }
		},
		_applyAll:function(){
			this.parentSection.setCancelDisabled(true);
			this.parentSection.setStopDisabled(true);
			var args = {id:this._resultIdInt,resultStateId:this._resultStateId };
			var applyAllParams = {startIndex:this._currentStepNumber,result:this.currentResultId};
			if(this.onlyCurrentIteration)
				applyAllParams.endIndex = (this._currentIterNumber*this.numberOfSteps)+this.numberOfSteps-1;
			args.elementApplyAllJsonString = dojo.toJson([applyAllParams]);
			this._collectDateTime("stop");
			args.startTime = this._startTime? parseInt(this._startTime): null;
			args.endTime =  parseInt(this._endTime);
			args.machine =  Constants.getMessage("labelLocalComputer");
			args.owner = getAuthenticatedContributor().userId;
			args.ewiItemId = this.ewi.itemId;//This sets EWI's currentResult.
			var self = this;
			var callback = {
				success:function(result){
					self._resultId = result.itemId;
					self._ER = result;
					self.oneStepExecution = false;
					self._resultStateId = result.stateId;
					var current = 0;
					var next = 0;
					self.uncommittedProperty = [];
					var numberOfSteps = self.numberOfSteps;
					if(self._currentIterNumber == self._iterations -1)
						self.onlyCurrentIteration = false;
					if (!self.onlyCurrentIteration) {
						self._currentIterNumber = self._iterations-2;
						self.stepNumber  = self.actualNumberOfSteps*(self._currentIterNumber+1)+1;
						current = numberOfSteps*(self._currentIterNumber+1)-1;
						next = current+1+numberOfSteps;
						self._currentStepNumber = self._iterations*numberOfSteps;
						self.completedStepsWithVerdict = self._iterations*self.stepsWithVerdict;
					}else{
						self._currentStepNumber = (self._currentIterNumber+1)*numberOfSteps;
						current = (self._currentIterNumber+1)*numberOfSteps-1;
						self.completedStepsWithVerdict = (self._currentIterNumber+1)*self.stepsWithVerdict;
						next = current+1;
					}
                    // A flag to indicate we're tearing things down. This would stop unncessarily
                    // recreating another editor.
                    self._inProcessApplyAll = true;
					self._moveStepPointer(false,current,next);
					if (!self.onlyCurrentIteration) {
						var start = current+1;
						var end = start+numberOfSteps;
						var elementResults = result.elementResults;
						var _dojo = dojo;
						var doc = doc;
						self._moveStepPointer(true,start,end);
						for(var i=start;i<end;i++){
							if (elementResults[i].keywordStepType == KEYWORD_NAME_TYPE) {
								if(elementResults[i+1] && (elementResults[i+1].keywordStepType == KEYWORD_STEP_TYPE || 
									elementResults[i+1].keywordStepType == NESTED_KEYWORD_TYPE))
								continue;
							}
							self._updateResult(elementResults[i].result, i);
							var tr = _dojo.byId(self.TR_ID + i,doc);
							if(!self.move_pointer_here[i])
								self.move_pointer_here[i] = self.connect(tr, "onclick", self._changeStepPointer);
							if (!self.move_pointer_here_by_enter[i]) {
								self.move_pointer_here_by_enter[i] = self.connect(tr, "onkeypress", function(e){
									var charCode = (e.which) ? e.which : e.keyCode;
									if (charCode == 13 && self._changeStepPointer) 
										self._changeStepPointer(e);
								});
							}
							tr.setAttribute("tabIndex", 0);
							tr.style.cursor = "pointer";
						}
						self._setCurrentResult(self._resultStateId, true);
					}else{
						self.setProperties(result.elementResults[next]);
						self._toggleApplyButton(false);
						self._disableResultSelectBox(false);
					}
					self._updateProgressBar();
                    delete self._inProcessApplyAll;
				},
				failure:function(errorObj){
					self._saveError(errorObj);
				}
			}
            // destroy the editor now. If we destroy it after (in _moveStepPointer call stack),
            // while remove the table rows, it could tickle a IE problem where any input fields
            // would stop getting any keyboard inputs. (no cursor). 
            this._destroyEditor();
            
			var responseHandler=new ServiceResponseHandler(callback, "success", "failure");
	    	ResultClient.postExecutionResultDTO(responseHandler, args);
		},
		onApply: function(skipPost){
			if(!this._iterationSelect.disabled){
				this._iterationSelect.disabled = true;
			}
			if(this._haltRequested){
				return;//Either stop or cancel was requested, dont process the request. Do not process any update on this stage
			}else{
				this._updateInProgress = true;
			}
			var _iterations = this._iterations;
			this._toggleApplyButton(true);
			this._pause.src = ImageCache.PAUSE_ICON;
			var _currentStepNumber = this._currentStepNumber;
			if(_currentStepNumber == this.numberOfSteps * _iterations){
				this.parentWidget.enableNavigationToResultPage();
				return;
			}
			this.parentSection.setCancelStopDisabled(false);
            var result = this._getStepResult(_currentStepNumber);
			var elementResult  = this._ER.elementResults[_currentStepNumber];
			//Call service to store the result: service needs index from 1
			var args = {
				stepIndex: _currentStepNumber,
				executionResult: this._resultId,
				resultElementStateTypeId: result.id,
				resultStateId:this._resultStateId,
				stepItemId:elementResult.internalId
			}
			if(elementResult.comment)
				args.comment = elementResult.comment;
			if(elementResult.compare)
				args.compare = elementResult.compare;
			if(_currentStepNumber == 0){
				args.startTime = parseInt(this._startTime);
				args.endTime = parseInt(this._startTime);
				args.iterations = _iterations;	
			}
			var addAttachmentItemIds = this._buildAttachmentIdList(elementResult.attachments,true);
            if(addAttachmentItemIds.length > 0)
                args.addStepAttachmentItemIds = addAttachmentItemIds;
            var removeAttachmentItemIds = this._buildAttachmentIdList(elementResult.removedAttachments);
            if(removeAttachmentItemIds.length>0)
                args.removeStepAttachmentItemIds = removeAttachmentItemIds;
			var properties = this.getProperties();
            if(properties.length > 0)
                args.addProperties = properties;
			var value = this.editor ? this.editor.getValue() : "";
			if(value == '<br />' || value == '<br/>')
				value = "";
			else 
				value = escape(value);
			value = this.wrapAsXhtml(value);
			args.actualResult = value;
			var defectIdList = this._buildDefectIdList(properties);
            if(defectIdList.length>0)
                args.defectIds = defectIdList;
            if(_currentStepNumber == this.numberOfSteps * _iterations -1){
			    this._collectDateTime("stop");
				args.startTime = this._startTime? parseInt(this._startTime): null;
				args.endTime =  parseInt(this._endTime);
				args.machine =  Constants.getMessage("labelLocalComputer");
				args.owner = getAuthenticatedContributor().userId;
				args.ewiItemId = this.ewi.itemId;//This sets EWI's currentResult.
            }
            else {
                args.resultState = ResultStates.IN_PROGRESS;
			}
			var responseHandler=new ServiceResponseHandler(this, "isEndOfExecution", "_saveError");
    		ResultClient.postApplyResult(responseHandler, args);
		},
		
		_updateActualResultSection: function(doc,current, next){
			if(!this._paused && this.oneStepExecution){
				this._destroyEditor();
				return;
			}
			var elementResults = this._ER.elementResults;
			var content = "";
			if(this.printView){
				var index = this.isExecutionOver ? next : current;
				var attachNode = dojo.byId(this.STEP_ACT_RES_ID+index,doc);
				if(attachNode)
					attachNode.innerHTML = elementResults[index].actualResult ? unescape(elementResults[index].actualResult) : ""; 
				return;
			}
            // if w're in apply all, don't need to recreate the editor. 
            else if(!this.editor && !this._inProcessApplyAll){
					var index = this.isExecutionOver ? next : current;
					var attachNode = dojo.byId(this.STEP_ACT_RES_ID+index,doc);
					if(!attachNode) 
						return;
					if(!this.toolbar || !this.toolbar.domNode){
						//toolbar domnode becomes null when editor cannot be destroyed completely.
						this.toolbar = new dijit.Toolbar();
						dojox.data.dom.removeChildren(this._richToolbar);
//						dojo.removeClass(this.toolbar.domNode,"dijitToolbar");
						this._richToolbar.appendChild(this.toolbar.domNode);
					}
					var args = {
						height: '',
						minHeight: '25px',
						focusOnLoad: true,
						parentWidget: this,
						plugins: ["undo","redo","|","cut","copy","paste","|","bold","italic","underline","strikethrough",
								"insertOrderedList","insertUnorderedList","indent","outdent","|",
								"justifyLeft","justifyRight","justifyCenter","justifyFull","|",'fontSize', 'fontName',
								'foreColor', 'hiliteColor', 'dijit._editor.plugins.AlwaysShowToolbar',
								 'insertimage','cleanup'],
						toolbar: this.toolbar
					};
					this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor(args, attachNode);
                    content = elementResults[index].actualResult ? unescape(elementResults[index].actualResult) : "";
				}else if(!this._inProcessApplyAll){
					var editorNode = this.editor.domNode;
					var currentEditorValue = null;
					var value = this.editor.getValue();
					if(value == '<br />' || value == '<br/>')
						value = "";
					else
						currentEditorValue = escape(value);
					currentEditorValue = this.wrapAsXhtml(value);
					elementResults[current].actualResult = currentEditorValue ? currentEditorValue : "";
					var nextNode = dojo.byId(this.STEP_ACT_RES_ID+next,doc);
					if(nextNode){
						this.editor.endEditing(true);
						//Change prev node from editor to div
						this.editor.srcNodeRef = nextNode;
						this.editor.open(nextNode);
						content = elementResults[next].actualResult ? unescape(elementResults[next].actualResult) : "";
					}
				}
				if(content != "" && !this._inProcessApplyAll)	
					this.editor.replaceValue(content);
				if(next == this.numberOfSteps * this._iterations){
					//For the last step in the script
					var currentParentNode = this.editor.domNode.parentNode;
						this._destroyEditor();
					var actualDiv = dojo.byId(this.STEP_ACT_RES_ID + current,doc);
					if(!actualDiv){
						actualDiv = doc.createElement('div');
						actualDiv.id = this.STEP_ACT_RES_ID + current;
						currentParentNode.appendChild(actualDiv);
					}
			    	actualDiv.innerHTML = elementResults[current].actualResult ? unescape(elementResults[current].actualResult) : "";
				}
		},
		
		_destroyEditor: function(){
			if(this.editor){
                this.editor._onBlur();
                this.editor.close();
				this.editor.destroyRecursive();
			}
			this.editor = null;	
		},
		
		_moveStepPointer: function(updateProps, currentStep, nextStep){
			//make image go to next line
			try{
			var current = "";
			var next = "";
			if(!isNaN(currentStep) && !isNaN(nextStep))	{
				current = currentStep;
				next = nextStep;
			}else{
				current = this._currentStepNumber;
				next = this._currentStepNumber + 1;
			}
			var tr = dojo.byId(this.TR_ID + current,doc);
			if(tr && dojo.hasClass(tr, "selected-row")){
				dojo.removeClass(tr, "selected-row");
			}
			var doc = document;
			var elementResults = this._ER.elementResults;
			if (next > current) {
				this._showNextIteration(doc,elementResults,current);
			}
			var imgCurr = dojo.byId(this.IMG_ID + current,doc);
			if (imgCurr) {
				var imgCellCurr = imgCurr.parentNode;
				dojox.data.dom.removeChildren(imgCellCurr);
				var stepImgCurr = doc.createElement("img");
				stepImgCurr.title = "";
				stepImgCurr.alt = "";
				stepImgCurr.src = ImageCache.NOIMAGE;
				stepImgCurr.className = "type-image";
				stepImgCurr.id = this.IMG_ID + current;
				imgCellCurr.appendChild(stepImgCurr);
			}
			
			var trNext = dojo.byId(this.TR_ID + next,doc);
			if(trNext && !dojo.hasClass(trNext, "selected-row")){
				dojo.addClass(trNext, "selected-row");
			}
			if (tr) {
				if(!this.move_pointer_here[current])
					this.move_pointer_here[current] = this.connect(tr, "onclick", this._changeStepPointer);
				if (!this.move_pointer_here_by_enter[current]) {
					this.move_pointer_here_by_enter[current] = this.connect(tr, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this._changeStepPointer) 
							this._changeStepPointer(e);
					});
				}
				if (dojo.isIE) {
					//for accessibility issue: when tab to focus, the row has no dashed border when tab to focus. 
					//changing text color to identify focused row
					this.add_focus_handle = this.connect(tr, "onfocus", function(e){
						tr.style.color = "#8A9084";
					});
					this.add_blur_handle = this.connect(tr, "onblur", function(e){
						tr.style.color = "#000";
					});
				}
				tr.setAttribute("tabIndex", 0);
				tr.style.cursor = "pointer";
			}
			var img = dojo.byId(this.IMG_ID + next,doc);
			if (img) {
				var imgCell = img.parentNode;
				dojox.data.dom.removeChildren(imgCell);
				var stepImg = doc.createElement("img");
				stepImg.title = "";
				stepImg.alt = "";
				stepImg.src = this.printView ? ImageCache.NOIMAGE : ImageCache.EXECUTION_ARROW;
				stepImg.className = "type-image";
				stepImg.id = this.IMG_ID + next;
				imgCell.appendChild(stepImg);
			}
			var stepObj = elementResults[current];
			if(updateProps == true && stepObj){
				var attachCurr = dojo.byId(this.ATTACH_ID  + current,doc);
				var defectCurr = dojo.byId(this.DEFECT_ID  + current,doc);
				var commentCurr = dojo.byId(this.COMMENT_ID  + current,doc);
				var compareCurr = dojo.byId(this.COMPARE_ID  + current,doc);
				var propshtml = this._createPropertiesHtml(doc,current,stepObj.properties,stepObj.attachments,stepObj.comment,stepObj.compare);
				if(attachCurr)
					attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
				if(defectCurr)
					defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
				if(commentCurr)
					commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);					
			}
			if(this.editor && !this._inProcessApplyAll)
				this._updateActualResultSection(doc,current, next);
			else if(!this.isExecutionOver)
				this._updateActualResultSection(doc,next);
			else
				this._updateActualResultSection(doc,null,next);
			}catch(e){
				console.debug("Error in Move step Pointer");
			}
		},
		_showNextIteration:function(doc,elementResults,current){
			// present the next iteration
			var numberOfSteps = this.numberOfSteps;
			var _iterations = this._iterations;
			var _currentIterNumber = this._currentIterNumber;
			if ((_currentIterNumber + 1) < _iterations && (current + 1) == (_currentIterNumber + 1) * numberOfSteps) {
				_currentIterNumber +=1;
				this._currentIterNumber += 1;
				this._updateIteration();
				
				// erase last iteration
				dojo.forEach(this.move_pointer_here, dojo.hitch(this,function(evt){
					this.disconnect(evt);
				}));
				dojo.forEach(this.move_pointer_here_by_enter, dojo.hitch(this,function(evt){
					this.disconnect(evt);
				}));
				this.move_pointer_here = [];
				this.move_pointer_here_by_enter = [];
				this._destroyEditor();
                this._clearTableContents(this._stepsTableBody);
				
				var total = _currentIterNumber*numberOfSteps;
				for (var i = 0; i < numberOfSteps; i++) {
					this._createStepRow(doc,i + total, elementResults[i + total]);
				}
				if ((_currentIterNumber + 1) == _iterations) {
					//Add one extra row for pointer to move after execution
					this._createStepRow(doc,numberOfSteps * _iterations, null);
				}
			}
		},
        _clearTableContents: function(tbody)
        {            
            if(tbody && tbody.rows.length > 0) {
                var nToDelete = tbody.rows.length - 1;
                
                for(var i = nToDelete; i >= 0; i--) {
                    tbody.deleteRow(i);
                }
            }
        },        
		_updateIteration: function() {
			dojox.data.dom.removeChildren(this._iterationNode);
			if (this._iterations > 1) {
				this._iterationNode.innerHTML = Constants.getMessage("msgRunningDatapoolIteartion", this._currentIterNumber + 1);
			}
		},
		
		_updateProgressBar: function(){
			if (!this.updatingProgress) {
				this.updatingProgress = true;
				var percent = (parseFloat(parseFloat(this.completedStepsWithVerdict) / parseFloat(this.stepsWithVerdict * this._iterations)) * 100);
				this.parentWidget.updateProgress(percent);
				var self = this;
				if (this.requestId) {
					var innerCallback = {
						callSuccess: function(obj){
							self.updatingProgress = false;
							self.requestStateId = obj.stateId
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [obj]]);
						},
						callFailure: function(errorObj){
							self.updatingProgress = false;
							self._saveError(errorObj);
						}
					}
					if(percent != 100 && !this._haltRequested){//Halt updates the request, this would lead to race condition so dont allow update
						var responseHandler = new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
						ExecutionClient.postResponse(responseHandler, {
							requestId: this.requestId,
							stateId: this.requestStateId,
							message: "",
							progress: parseInt(percent),
							statusCode: "200",
							projectAreaItemId: getCurrentProjectArea().itemId,
							data: "dummy"
						});
					}else{
						this.updatingProgress = false;
					}	
				} else
					this.updatingProgress = false;
			}
		},
		
		isEndOfExecution: function(resultElement){
			var _currentStepNumber = this._currentStepNumber;
			this.uncommittedProperty.splice(_currentStepNumber,1);
			if(resultElement)
				this._resultStateId = resultElement.resultStateId;
			var elementResults = this._ER.elementResults;
			elementResults[_currentStepNumber] = resultElement;
			var result = this._getStepResult(_currentStepNumber);
			this._updateResult(result, _currentStepNumber);
			this.completedStepsWithVerdict+=1;
			var next = _currentStepNumber+1;
			if (elementResults[next] && elementResults[next].keywordStepType == KEYWORD_NAME_TYPE) {
				if(elementResults[next+1] && (elementResults[next+1].keywordStepType == KEYWORD_STEP_TYPE || 
					elementResults[next+1].keywordStepType == NESTED_KEYWORD_TYPE))	
				next += 1;
			}
			this._moveStepPointer(false,_currentStepNumber,next);
			_currentStepNumber = next;
			this._currentStepNumber = _currentStepNumber;
			if (this.oneStepExecution && CommonPreferenceClient.getExecutionPreference().animation) {
				this._applyAll();
				return;
			}
			var elementResult  = elementResults[_currentStepNumber];
			var total = this.numberOfSteps * this._iterations;
			if (!this.oneStepExecution || _currentStepNumber != total) {
				this._updateProgressBar();
			}
			this._updateInProgress = false;
			if(_currentStepNumber == total)	    	
                this._setCurrentResult(resultElement.resultStateId,true);
			else if(!this._paused && elementResult.keywordStepType == REMOTE_KEYWORD_TYPE){
				this.setProperties(elementResult);
               	this._createKeywordDialog();
			}
			else if(!this._paused && this.oneStepExecution){
				this.onApply();
			}else if (this.stopTestRequested){
				this.stopTestRequested = false;
				this.onStop();
			}else{
				this.setProperties(elementResult);
				this._toggleApplyButton(false);
				this._disableResultSelectBox(false);
			}
		},
        
		_applyVerdictForAllStepsRemaining: function(){
			//Check in the user pref if we should show the dialog or not.
			if(!this.currentResultId){
				this.currentResultId = StepResultStates.PASSED;
			}
			if(CommonPreferenceClient.getExecutionPreference().applyall){
				//Value is true so confirm before proceeding.
					var args = {
					parentEditor: this, 
					okCallback: dojo.hitch(this, this._afterConfirmation),
					verdictTypes: this._resultTypes,
					selectedVerdictId: this.currentResultId,
					onlyCurrent:this.onlyCurrentIteration,
					showOnlyCurrent:this._iterations>1?true:false
					};
				this.confirmationDialog = new com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog(args);
				this.confirmationDialog.initialize();
			}else{
				this._afterConfirmation({verdict: this.currentResultId});//Apply the current verdict to following steps.
			}
			
		},
		
		_afterConfirmation: function(args){
			this._updateResultCombo(args.verdict);
			this.onlyCurrentIteration = args.onlyCurrent;
			this.oneStepExecution = true;
			this.onApply();
		},
		
		_onEnterApplyAll: function(e) {
			var charCode = (e.which) ? e.which : e.keyCode
			if (charCode == 13 && this.applyAllButtonClickEvent) 
			 	this._applyVerdictForAllStepsRemaining();
		},
        ////////////////////////////////
		// Keyword related stuff
		////////////////////////////////
		_createKeywordDialog: function(){
			this._toggleApplyButton(true);
			var _currentStepNumber = this._currentStepNumber;
            if(this._ER.elementResults[_currentStepNumber].result.id == StepResultStates.INCONCLUSIVE ){
			    this._startExecuteKeyword();
				return;
			}
			var verdictName = Constants.getMessage("labelInconclusive");
			var verdictId = null;
			var _resultTypes = this._resultTypes;
			var len = _resultTypes.length;
			for(var count =0;count<len;count++){
				if(verdictName === _resultTypes[count].name){
					verdictId = _resultTypes[count].id;
					break;
				}
			}
			var args = {	
					stepIndex:_currentStepNumber,
					executionResult: this._resultId,
					resultElementStateTypeId: verdictId,
					resultStateId:this._resultStateId,
					resultState:ResultStates.IN_PROGRESS
				}
			if(_currentStepNumber == 0){
				args.startTime = parseInt(this._startTime);
				args.endTime = parseInt(this._startTime);
				args.iterations = this._iterations;	
			}
			var responseHandler=new ServiceResponseHandler(this, "_startExecuteKeyword", "_saveError");
    		ResultClient.postApplyResult(responseHandler, args);
		},
		
		_startExecuteKeyword:function(eer){
			var eerInternalId = "";
			if(eer){
				this._ER.elementResults[this._currentStepNumber] = eer;
				this._resultStateId = eer.resultStateId;
			}
			else 
				eerInternalId = this._ER.elementResults[this._currentStepNumber].internalId;
			
			var keywordProps = this.propertiesMap[KEYWORD_PROP_TYPE].elements;
			var len = keywordProps.length;
			var requestIdValue = null;
			var scriptId = null;
			var scriptStateId = null;
			for(var j=0;j<len;j++){
				if (keywordProps[j].propertyName == "requestId")
					requestIdValue = keywordProps[j].propertyValue;
				if (keywordProps[j].propertyName == "scriptId")
					scriptId = keywordProps[j].propertyValue;
				if (keywordProps[j].propertyName == "scriptStateId")
					scriptStateId = keywordProps[j].propertyValue;
			}
            if (scriptId) {
				var script = this.kwScripts[scriptId];
                if(script)
					this._executeKeyword(script,eer,eerInternalId,requestIdValue);
				else{
					var self = this;
					var handler = {
	                    success: function(script) {
							if (script && script[0]) {
								self.kwScripts[scriptId] = script[0];
								self._executeKeyword(script[0], eer, eerInternalId, requestIdValue);
							}else{
								self._toggleApplyButton(false);
							}
	                    },
	                    error: function(e) {
							self._saveError(e)
	                        self._toggleApplyButton(false);
	                    }
	                }
					var responseHandler = new ServiceResponseHandler(handler, "success", "error");			      
	                TestScriptClient.getTestScript(responseHandler, scriptId,scriptStateId);
				}
            }
            else
                this._toggleApplyButton(false);
		},
		_executeKeyword:function(script,eer,eerInternalId,requestIdValue){
			var widgetArgs = {
                parentWidget: this,
                ewiItemId: this.ewiItemId,
                parentEditor: this.parentSection.parentEditor,
                stepResultItemId: eer ? eer.internalId : eerInternalId,
                resultId: this._resultIdInt + ""
            }
            if (requestIdValue != null) 
                widgetArgs.requestId = requestIdValue;
            this._keywordExecutionViewer = new com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution(widgetArgs);
            this._keywordExecutionViewer.initialize(script);
		},
		updateCurrentKeywordResult: function(resultStateId){
			this._resultStateId = resultStateId;
            var eer = this._ER.elementResults[this._currentStepNumber];
            var args = {
				stepItemId: eer.internalId,
				executionResult: this._resultId,
				resultStateId:this._resultStateId
			};
			if (this._currentStepNumber != this.numberOfSteps * this._iterations - 1) {
				args.resultState = ResultStates.IN_PROGRESS;
			}
			var responseHandler=new ServiceResponseHandler(this, "finishKeywordExecution", "_saveError");
		    ResultClient.postApplyResult(responseHandler, args);
		},
        
		finishKeywordExecution:function(eer){
            if(eer.properties){
				var len = eer.properties.length;
				for(var i=0;i<len ;i++)
					this.propertiesMap[eer.properties[i].propertyType].elements.push(eer.properties[i]);
			}
			if(eer.resultStateId)
				this._resultStateId = eer.resultStateId;
            this._updateCurrentStepProps();
            this._updateResultCombo(eer.result.id);
			var keywordProps = this.propertiesMap[KEYWORD_PROP_TYPE].elements;
			var newKeywordProps = [];
			var len2 = keywordProps.length;
			//remove the requestId property
			for(var j=0;j<len2;j++){
				if(keywordProps[j].propertyName != "requestId")
					newKeywordProps.push(keywordProps[j]);
			}
			this.propertiesMap[KEYWORD_PROP_TYPE].elements = newKeywordProps;
			this.isEndOfExecution(eer);
		},
		_updateKeywordProgress:function(percent){
			var total = parseFloat(this.numberOfSteps * this._iterations);
			var percentMin = (parseFloat(parseFloat(this._currentStepNumber)/total)*100);
			var percentMax = (parseFloat((parseFloat(this._currentStepNumber+1))/total)*100);
			var scriptPercent = 0;
			if (percentMax > percentMin) {
				scriptPercent = percentMin + (((percentMax - percentMin) * (parseFloat(percent))) / 100);
			}
			this.parentWidget.updateProgress(scriptPercent);
			
		},
		
		_updateKeywordRequestId:function(requestId){
			this.propertiesMap[KEYWORD_PROP_TYPE].elements.push({ 
				propertyType:KEYWORD_PROP_TYPE,
				propertyName:"requestId",
				propertyValue:requestId
			});
			this._onStaleStepUpdate(this._currentStepNumber);
				
		},

        ////////////////////////////////
		// Misc Functions
		////////////////////////////////
        _collectDateTime: function(arg){
			var currentTime = new Date();
			if(arg == "start")
				this._startTime = Utility._convertDateToLong(currentTime);
			else
				this._endTime = Utility._convertDateToLong(currentTime);	
		},		
		_updateResultCombo: function(resultId){
			this.currentResultId = resultId;
		},
		 _createResultContextMenu: function(node){
			var callback = this;
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[node.id]});
            var doc = document;
			var childBlocked = new dijit.MenuItem({label:Constants.getMessage("labelBlocked"), onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.BLOCKED, label:Constants.getMessage("labelBlocked")},{identifier: StepResultStates.BLOCKED})});
			var blockedImg = doc.createElement('img');
			blockedImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.BLOCKED];
			childBlocked.iconNode.appendChild(blockedImg);
			pMenu.addChild(childBlocked);
			
			var inconclusiveChild = new dijit.MenuItem({label:Constants.getMessage("labelInconclusive"),onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.INCONCLUSIVE, label:Constants.getMessage("labelInconclusive")},{identifier: StepResultStates.INCONCLUSIVE})})
			var inconclusiveChildImg = doc.createElement('img');
			inconclusiveChildImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.INCONCLUSIVE];
			inconclusiveChild.iconNode.appendChild(inconclusiveChildImg);
            pMenu.addChild(inconclusiveChild);
			
			var errorChild = new dijit.MenuItem({label:Constants.getMessage("labelError"),onClick:dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.ERROR, label:Constants.getMessage("labelError")},{identifier: StepResultStates.ERROR})})
			var errorChildImg = doc.createElement('img');
			errorChildImg.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[StepResultStates.ERROR];
			errorChild.iconNode.appendChild(errorChildImg);
            pMenu.addChild(errorChild);
            pMenu.startup();

			//Enable the same menu for left click also			
			this.resultMenu = pMenu;
			this._menus.push(pMenu);
			return this.connect(node, "onclick", function(e){this.resultMenu._openMyself(e);});
		},
		
		_setCurrentResult: function(resultStateId,updateProgress){
			this.parentSection._resultItemId = this._resultId;
			this._resultStateId = resultStateId;			
			this.isExecutionOver = true;
			this.parentSection.setCancelStopDisabled(true);
			if(this.execOverField)
				this.execOverField.innerHTML = Constants.getMessage("msgExeOver");
			this._setPointerOnFinalStep(this._currentStepNumber);
			if(updateProgress && (this._currentStepNumber == this.numberOfSteps * this._iterations)){
				var self = this;
				if(self.ergId){
					var innerCallback2 = {
						callSuccess: function(obj){
							self.ergStateId = obj.stateId;
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
							self._saveError(errorObj);
						}
					}
					
					var responseHandler2=new com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper(innerCallback2, "callSuccess", "callFailure");
					var ergArgs = {id: self.ergId, addResults: [self._resultIdInt]};
					if(self.ergStateId)
						ergArgs.stateId = self.ergStateId;							
					com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient.postExecutionResultGroupSummaryDTO(responseHandler2, ergArgs)
				}
				if(self.requestId){
					var innerCallback = {
						callSuccess: function(obj){
							self.requestStateId = obj.stateId;
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
						}
					}
					var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");

					var requestArgs = {isNew: false, id: self.requestId, progress: 100};
					if(self.requestStateId)
						requestArgs.stateId = self.requestStateId;
					requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.complete";	
					ExecutionClient.postCreateRequestDTO(responseHandler, requestArgs);
				}

			}
			if (updateProgress) {
				var self = this;
				if (this.updatingProgress) {
					this.progressUpdateInterval = setInterval(function(){
						if (!self.updatingProgress) {
							clearInterval(self.progressUpdateInterval);
							delete self.progressUpdateInterval;
							self._updateProgressBar();
							self.parentWidget.enableNavigationToResultPage();
						}
					}, 500);
				}
				else {
					this._updateProgressBar();
					this.parentWidget.enableNavigationToResultPage();
				}
			}else {
				this.parentWidget.enableNavigationToResultPage();
			}
		},
		
		_updateResult: function(result, stepIndex){
			var doc = document;
			var resultValue = dojo.byId(this.RESULT_ID + stepIndex,doc);
			var resultCell = resultValue.parentNode;
			dojox.data.dom.removeChildren(resultCell);
			var img = doc.createElement('img');
			img.src = Utility.getImageForResult(result);
			img.title = result.name;
			img.alt = result.name;
			img.className = "type-image";
			img.id = this.RESULT_ID + stepIndex;
			resultCell.appendChild(img);
            this._ER.elementResults[stepIndex].result = result;
		},
        
        _disableResultSelectBox: function(disable){
        	if(this._failButtonClickEvent)
        		this.disconnect(this._failButtonClickEvent);
			if(this._failButtonEnterEvent)
				this.disconnect(this._failButtonEnterEvent);
			if(this._otherResultButtonClickEvent)
				this.disconnect(this._otherResultButtonClickEvent);
			if(this._otherResultButtonEnterEvent)
				this.disconnect(this._otherResultButtonEnterEvent);
			this._failButtonClickEvent = null;
			this._failButtonEnterEvent = null;
			this._otherResultButtonClickEvent = null;
		    this._otherResultButtonEnterEvent = null;
			
			if(disable){
				this.disconnect(this._passButtonClickEvent);
				this.disconnect(this._passButtonEnterEvent);
                this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
				this._passButtonClickEvent = null;
				this._passButtonEnterEvent = null;
	            this.resultDropdownEvent = null;
	            this.resultDropdownEnterEvent = null;
			}else if(!this._stepsHaveVerdict && 
				this._ER.elementResults[this._currentStepNumber].stepType == "com.ibm.rqm.execution.common.elementtype.execution"){
                this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
	            this.resultDropdownEvent = null;
	            this.resultDropdownEnterEvent = null;
			}else{
				if(this._passButtonClickEvent)
                	this.disconnect(this._passButtonClickEvent);
				if(this._passButtonEnterEvent)
                    this.disconnect(this._passButtonEnterEvent);
                
				this._passButtonClickEvent = this.connect(this._passButton, "onclick", this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress", dojo.hitch(this,this._onEnterResultSelected,""));
				this._failButtonClickEvent = this.connect(this._failButton, "onclick", 
					dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress",
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick",
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));
				if(this.resultDropdownEvent)
					this.resultDropdownEvent = this.connect(this._resultDropDownButton, "onclick", function(e){this.resultMenu._openMyself(e);});
				else
					this.resultDropdownEvent = this._createResultContextMenu(this._resultDropDownButton);
				this.resultDropdownEnterEvent = this.connect(this._resultDropDownButton, "onkeypress", 
					function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.resultDropdownEvent) 	
							this.resultMenu._openMyself(e);
					});
			} 
		},
				
		handleResultSelected: function(e){
			var identifier = e.identifier ? e.identifier : "";
			if(identifier != "" && identifier != StepResultStates.FAILED){//From the menu
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[identifier];
				this._otherResultButton.title = e.label;
				this._otherResultButtonIdentifier  = identifier;
			}
			this.currentResultId = identifier != "" ? identifier : StepResultStates.PASSED;
			if(!this.originalStepNum && !this.isExecutionOver){
				if(this.currentResultId == StepResultStates.FAILED){
					var askOnFail = CommonPreferenceClient.getExecutionPreference().askonfail;
					if(askOnFail){
						var args ={
							okCallback: dojo.hitch(this, "markStepFailedWithProperties"),
							actualResultContent: this.editor ? this.editor.getValue() : "",
							newDefectActionCallback: dojo.hitch(this,this._defectIconClicked,"new",null)
						} 
					var promptDialog = new com.ibm.rqm.execution.web.ui.internal.view.execution.FailConfirmationDialog(args);
					promptDialog.initialize();
					}else{
						this.onApply();
					}
				}
				else{
					this.onApply();
				}
			} 
			else
				this._onStaleStepVerdictUpdate();
		},
		
		markStepFailedWithProperties: function(params){
			if(params.actualResultContent){
				this.editor.setValue(params.actualResultContent);
			}
			if(params.stopTestChecked){
				this.stopTestRequested = true;
			}
			this.onApply();
		},
		
		_onEnterResultSelected: function(identifier,e){
			var charCode = (e.which) ? e.which : e.keyCode
			if (charCode == 13) {
				this.handleResultSelected({identifier: identifier});
			}
		},
		
		_toggleApplyButton: function(disable){
			if(!this.disableApplyAll)
				this._applyAllButton.disabled = disable;
			if(this._passButtonClickEvent)
				this.disconnect(this._passButtonClickEvent);
			if(this._passButtonEnterEvent)
				this.disconnect(this._passButtonEnterEvent);
			if(this._failButtonClickEvent)
				this.disconnect(this._failButtonClickEvent);
			if(this._failButtonEnterEvent)
				this.disconnect(this._failButtonEnterEvent);
			if(this._otherResultButtonClickEvent)
				this.disconnect(this._otherResultButtonClickEvent);
			if(this._otherResultButtonEnterEvent)
				this.disconnect(this._otherResultButtonEnterEvent);
			if(this.applyAllButtonClickEvent)
				this.disconnect(this.applyAllButtonClickEvent);
			if(this.applyAllButtonEnterEvent)
				this.disconnect(this.applyAllButtonEnterEvent);
		    this._passButtonClickEvent = null;
			this._passButtonEnterEvent = null;
			this._failButtonClickEvent = null;
			this._failButtonEnterEvent = null;
			this._otherResultButtonClickEvent = null;
			this._otherResultButtonEnterEvent = null;
			this.applyAllButtonClickEvent = null;
			this.applyAllButtonEnterEvent = null;			
			if(!disable){
				this._passButton.src = ImageCache.PASS_ICON;
				this._passButton.setAttribute("tabIndex", 0);
				this._failButton.src = ImageCache.FAIL_ICON;
				this._failButton.setAttribute("tabIndex", 0);
				this._resultDropDownButton.src = ImageCache.DROPDOWN_ARROW;
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.ENABLED[this._otherResultButtonIdentifier];
				this._resultDropDownButton.setAttribute("tabIndex", 0);
				if(!this.disableApplyAll)
					this._applyAllButton.src = ImageCache.APPLY_ALL;

				this._passButtonClickEvent = this.connect(this._passButton, "onclick",this.handleResultSelected);
				this._passButtonEnterEvent = this.connect(this._passButton, "onkeypress",dojo.hitch(this,this._onEnterResultSelected,""));
				this._failButtonClickEvent = this.connect(this._failButton, "onclick",  
						dojo.hitch(this,this.handleResultSelected,{identifier: StepResultStates.FAILED}));
				this._failButtonEnterEvent = this.connect(this._failButton, "onkeypress",
					dojo.hitch(this,this._onEnterResultSelected,StepResultStates.FAILED));
				this._otherResultButtonClickEvent = this.connect(this._otherResultButton, "onclick",
					dojo.hitch(this,this.handleResultSelected,{identifier:this._otherResultButtonIdentifier}));
				this._otherResultButtonEnterEvent = this.connect(this._otherResultButton, "onkeypress", 
					dojo.hitch(this,this._onEnterResultSelected,this._otherResultButtonIdentifier));
				if(this.resultDropdownEvent)
						this.resultDropdownEvent = this.connect(this._resultDropDownButton, "onclick", function(e){this.resultMenu._openMyself(e);});
					else
						this.resultDropdownEvent = this._createResultContextMenu(this._resultDropDownButton);
					this.resultDropdownEnterEvent = this.connect(this._resultDropDownButton, "onkeypress",  
						function(e){
							var charCode = (e.which) ? e.which : e.keyCode;
							if (charCode == 13 && this.resultDropdownEvent) 	
								this.resultMenu._openMyself(e);
						});
				if(!this.disableApplyAll){
					this.applyAllButtonClickEvent = this.connect(this._applyAllButton, "onclick", this._applyVerdictForAllStepsRemaining);
					this.applyAllButtonEnterEvent = this.connect(this._applyAllButton, "onkeypress",  this._onEnterApplyAll);
				}	
			}else{
				this._passButton.setAttribute("tabIndex", -1);
				this._failButton.setAttribute("tabIndex", -1);
				this._otherResultButton.setAttribute("tabIndex", -1);
				this._resultDropDownButton.setAttribute("tabIndex", -1);
				this._passButton.src = ImageCache.PASS_ICON_DISABLED;
				this._failButton.src = ImageCache.FAIL_ICON_DISABLED;
				this._otherResultButton.src = ImageCache.STEP_VERDICT_ICONS.DISABLED[this._otherResultButtonIdentifier];
				
				if(!this.disableApplyAll)
					this._applyAllButton.src = ImageCache.APPLY_ALL_DISABLED;
				this.disconnect(this.resultDropdownEvent);
				this.disconnect(this.resultDropdownEnterEvent);
				this.resultDropdownEvent = null;
				this.resultDropdownEnterEvent = null;
			}
		},
        
        _getStepResult: function(stepNum){
            var result = null;
            if(!stepNum)
                stepNum = this._currentStepNumber;
			var selectedResult = this.currentResultId;
			if(!this._stepsHaveVerdict && this._ER.elementResults[stepNum ].stepType == "com.ibm.rqm.execution.common.elementtype.execution")
				selectedResult = StepResultStates.COMPLETE;
			var _resultTypes = this._resultTypes;
			var len = _resultTypes.length;
			for (var i = 0; i < len; i++) {
				if(_resultTypes[i].id == selectedResult){
					result = _resultTypes[i];
                    break;
				}
			}
			return result;
		},

        _enableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW;
			this._attachment.setAttribute("tabIndex", 0);
			this._attachment.alt = Constants.getMessage("labelShowAttach");
			this._comment.src = ImageCache.COMMENT_VIEW;
			this._comment.setAttribute("tabIndex", 0);
			this._comment.alt = Constants.getMessage("labelComments");
			this._defect.src = ImageCache.NEW_DEFECT;
			this._defect.setAttribute("tabIndex", 0);
			this._defect.alt = Constants.getMessage("labelAddNewDefect");
			this._associateDefect.src = ImageCache.DEFECT_VIEW;
			this._associateDefect.setAttribute("tabIndex", 0);
			this._associateDefect.alt = Constants.getMessage("labelAddExistingDefect");
			this._togglecomment.src = ImageCache.TOGGLE_COMMENT;
			this._togglecomment.setAttribute("tabIndex", 0);
			this._togglecomment.alt = Constants.getMessage("labelShowHideComments");
			this._pause.src = ImageCache.PAUSE_ICON;
			this._pause.alt = Constants.getMessage("labelClickToPauseExe");
			this._resume.alt = "";
			this._stepsTable.className = "item-table";
			this._disableResultSelectBox(false);
            this._connectMouseListeners();
            this._richToolbar.style.display = "";
		},
		
		_disableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW_DISABLED;
			this._attachment.setAttribute("tabIndex", -1);
			this._comment.src = ImageCache.COMMENT_VIEW_DISABLED;
			this._comment.setAttribute("tabIndex", -1);
			this._defect.src = ImageCache.DEFECT_VIEW_DISABLED;
			this._defect.setAttribute("tabIndex", -1);
			this._associateDefect.src = ImageCache.DEFECT_VIEW_DISABLED;
			this._associateDefect.setAttribute("tabIndex", -1);
			this._togglecomment.src = ImageCache.TOGGLE_COMMENT_DISABLED;
			this._togglecomment.setAttribute("tabIndex", -1);
			this._pause.src = "";
			this._pause.alt = "";
			this._resume.src = ImageCache.RESUME_ICON;
			this._resume.setAttribute("tabIndex", 0);
			this._resume.alt = Constants.getMessage("labelClickToResumeExe");
			this._disableResultSelectBox(true);
			this._stepsTable.className = "item-table-disabled";
			this._richToolbar.style.display = "none";
			if(!this.resumeEvent)
			    this.resumeEvent = this.connect(this._resume, "onclick", this._handleResumeClick);
			if(!this.resumeEnterEvent)
			    this.resumeEnterEvent = this.connect(this._resume, "onkeypress", function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.resumeEvent) 	
						this._handleResumeClick(e);
				});		
			//Disconnect events from icons except for Resume
			this.disconnect(this.addDefectEvent);
            this.addDefectEvent = null;
			this.disconnect(this.associateDefectEvent);
            this.associateDefectEvent = null;
			this.disconnect(this.pauseEvent);
            this.pauseEvent = null;
			this.disconnect(this.attachmentImg);
            this.attachmentImg = null;
			this.disconnect(this.attachmentEnterEvent);
            this.attachmentEnterEvent = null;
			this.disconnect(this.commentImg);
            this.commentImg = null;
			this.disconnect(this.commentEnterEvent);
            this.commentEnterEvent = null;
			this.disconnect(this._toggleCommentHandle);
			this._toggleCommentHandle = null;
			this.disconnect(this._togglecommentEnterEvent);
			this._togglecommentEnterEvent = null;
		},
		
		_connectMouseListeners: function(){
            //Connect events to icons
			if(!this.printView){
	            if(!this.addDefectEvent)
				    this.addDefectEvent = this.connect(this._defect, "onclick", dojo.hitch(this,this._defectIconClicked,"new",null));
				if(!this.addDefectEnterEvent)
				    this.addDefectEnterEvent = this.connect(this._defect, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.addDefectEvent) 	
							this._defectIconClicked("new",null);
					});
				if(!this.associateDefectEvent)
				    this.associateDefectEvent = this.connect(this._associateDefect, "onclick", dojo.hitch(this,this._defectIconClicked,"existing",null));
				if(!this.associateDefectEnterEvent)
				    this.associateDefectEnterEvent = this.connect(this._associateDefect, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.associateDefectEvent) 	
							this._defectIconClicked("existing",null);
					});		
	            if(!this.attachmentImg)
				    this.attachmentImg = this.connect(this._attachment, "onclick", this._attachmentIconClicked);
				if(!this.attachmentEnterEvent)
				    this.attachmentEnterEvent = this.connect(this._attachment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.attachmentImg) 	
							this._attachmentIconClicked();
					});		
	            if(!this.commentImg)
				    this.commentImg = this.connect(this._comment, "onclick", this._commentIconClicked);
				if(!this.commentEnterEvent)
				    this.commentEnterEvent = this.connect(this._comment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.commentImg) 	
							this._commentIconClicked();
					});
				if(!this._toggleCommentHandle)
				    this._toggleCommentHandle = this.connect(this._togglecomment, "onclick", this._toggleCommentsColumn);
				if(!this._togglecommentEnterEvent)
				    this._togglecommentEnterEvent = this.connect(this._togglecomment, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this._toggleCommentHandle) 	
							this._toggleCommentsColumn();
					});	
	            if(!this.pauseEvent)
				    this.pauseEvent = this.connect(this._pause, "onclick", this._handlePauseClick);
				if(!this.pauseEnterEvent)
				    this.pauseEnterEvent = this.connect(this._pause, "onkeypress", function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.pauseEvent) 	
							this._handlePauseClick();
					});
				this.disconnect(this.resumeEvent);
	            this.resumeEvent = null;    
				this.disconnect(this.resumeEnterEvent);
	            this.resumeEnterEvent = null;
			}	            
		},
		
        ////////////////////////////////
		// Icon clicks handling
		////////////////////////////////
		onEndOfExecution:function(){
			if(this._staleStepUpdated)
				this._onStaleStepUpdate(this._currentStepNumber);
		},
		
		isDirty:function(){
			if(this.uncommittedProperty.length>0)
				return true;
			else 
				return false;
		},
		
		onCancel:function(){
			if(this.uncommittedProperty.length>0){
				var self = this;
				var args = {
					title: Constants.getMessage("labelConfirmation"),
					message: Constants.getMessage("labelUnSavedProperties"),
					yesCallback: function(){
						self._onCancel();
					},
					noCallback: null
				}
				var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	            dialog.setSecondaryTitle(args.title);
	            dialog.open();
			}else{
				this._onCancel();
			}
			return false;
		},
		
		clearWaitTimer: function(){
			if(this._waitTimer){
				clearTimeout(this._waitTimer);
				delete this._waitTimer;
				console.debug("deleting timer as no update in progress");
			}	
		},
		
		_onCancel: function(){
			this.parentSection.setCancelDisabled(true);
			this.parentSection.setStopDisabled(true);
			this._haltRequested = true;
			if(this._updateInProgress){
				this.clearWaitTimer();
				this._waitTimer = setTimeout(dojo.hitch(this, "_onCancel"), 200);//Wait for in progress update to finish and then come back
				console.debug("creating timer since updating in progress");
				return;
			}else if(this._waitTimer){
				this.clearWaitTimer();
			}
			if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			//Set state of request to cancelled.
			var requestArgs = {isNew: false, id: this.requestId};
			if(this.requestStateId)
				requestArgs.stateId = this.requestStateId;
			var self = this;		
			var innerCallback = {
				callSuccess: function(obj){
					self.requestStateId = obj.stateId;
				},
				callFailure: function(error){
					console.debug("ME: could not cancel Manual request, reason: "+error.message);
				}
			}
			var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
			requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.cancelled";	
			ExecutionClient.postCreateRequestDTO(responseHandler, requestArgs);
			//Set the result state to incomplete
			var self = this;
			if(this._currentStepNumber != 0){
				//Only in this case the result exists.
				this.onStop();
			}else{
				this.parentWidget.publishClosure();
			}
		},

		//On cancel and on stop state of the result is set to incomplete.
		onStop: function(){
			this._haltRequested = true;
			this.parentSection.setStopDisabled(true);
			this.parentSection.setCancelDisabled(true);
			if(this._updateInProgress){
				this.clearWaitTimer();
				this._waitTimer = setTimeout(dojo.hitch(this, "onStop"), 200);//Wait for in progress update to finish and then come back
				console.debug("creating timer since updating in progress");
				return;
			}else if(this._waitTimer){
				this.clearWaitTimer();
			}
			var self = this;
			var callback = {
				callSuccess: function(results){
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EXE_LOG, results]);
					self.ewi.currentResult = results[0];
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_EWI, [self.ewi]]);
					self.parentWidget.publishClosure();
				},
				callFailure: function(error){
					console.debug("ME: failed to update result" + error.message);
					self.parentWidget.publishClosure();
				}
			}
			var args = {
				executionResult: this._resultId,
				resultStateId: this._resultStateId,
				resultState: ResultStates.INCOMPLETE,
				stepIndex: this._currentStepNumber,
				skipStepUpdate: true
			}
			var value = this.editor ? this.editor.getValue() : "";
			if(value == '<br />' || value == '<br/>')
				value = "";
			else 
				value = escape(value);
			value = this.wrapAsXhtml(value);
			args.actualResult = value;
			args.iterations = this._iterations;
			var responseHandler=new ServiceResponseHandler(callback, "callSuccess", "callFailure");
		    ResultClient.postApplyResult(responseHandler, args);
		},
		
		_handlePauseClick: function(e){
			if(e)
				e.preventDefault();
			this._pause.style.display = 'none';
			this._resume.style.display = 'inline';
			this._resume.setAttribute("tabIndex", 0);
			this._toggleApplyButton(true);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			this._disableImages();
			this._paused = true;
			this._resume.focus();
		},
		
		_handleResumeClick: function(e){
			if(e)
				e.preventDefault();
			this._pause.style.display = 'inline';
			this._resume.style.display = 'none';
			this._toggleApplyButton(false);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = this;	
			this._enableImages();
			if(this._paused)
				this._paused = false;
			this._pause.focus();
		},

        ////////////////////////////////
		// Going back to already executed stuff
		////////////////////////////////
		_setPointerOnFinalStep: function(stepNum){
			this._disableImages();
			if(this.isExecutionOver && (parseInt(stepNum,10) == (this.numberOfSteps*this._iterations))){
				//disable all buttons properties
				this._toggleApplyButton(true);
				if(dojo.hasClass(this._stepsTable, "item-table-disabled"))
					dojo.removeClass(this._stepsTable, "item-table-disabled")
				this._stepsTable.className = "item-table";	
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._disableResultSelectBox(true);
				this.disconnect(this.resumeEvent);
                this.resumeEvent = null;
				this.disconnect(this.resumeEnterEvent);
                this.resumeEnterEvent = null;
				this._disablePauseClick(true);
			}else {
				//disable and then re-enable buttons (avoid multiple event attaching)
				this._toggleApplyButton(false);
				this._enableImages();
			}
			if(this.isExecutionOver){
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._pause.src = ImageCache.NOIMAGE;
				this._pause.setAttribute("tabIndex", -1);
				if (this.resumeEvent) {
                    this.disconnect(this.resumeEvent);
                    this.resumeEvent = null;
                }
				if (this.resumeEnterEvent) {
                    this.disconnect(this.resumeEnterEvent);
                    this.resumeEnterEvent = null;
                }
				this._disablePauseClick(true);
			}
		},
		
		_changeStepPointer: function(e){
			try{
				if(!e.currentTarget || !e.currentTarget.id)
					return;
				var stepNum = e.currentTarget.id.split(this.TR_ID)[1];				
				stepNum = parseInt(stepNum,10);
				var _currentStepNumber = this._currentStepNumber;
				if(_currentStepNumber == stepNum)//Same step clicked twice
					return;
                if(this._staleStepUpdated)
                    this._onStaleStepUpdate(_currentStepNumber);
				this._setPointerOnFinalStep(stepNum);
				var elementResults = this._ER.elementResults;
				if(elementResults[_currentStepNumber] && elementResults[_currentStepNumber].result.id == NOT_RUN_RESULT)
					this.originalStepNum = _currentStepNumber;
				else if(this.isExecutionOver)
					this.originalStepNum = stepNum;
				if(stepNum == this.originalStepNum && !this.isExecutionOver)	{
					//Enable Apply / Apply All, Pause remove verdict change listener
					this.originalStepNum = null;
					this._disablePauseClick(false);
				}else {
					//Disable Apply and ApplyAll and Pause buttons
					this._disablePauseClick(true);
					if(elementResults[stepNum])
                    	this._updateResultCombo(elementResults[stepNum].result);	
				}
				if(elementResults[_currentStepNumber])
					elementResults[_currentStepNumber].properties = this.getProperties();
				if(this.inProgress)
					return;
				this.inProgress = true;
				this._moveStepPointer(true, _currentStepNumber, stepNum);
				this.inProgress = false;
				this._currentStepNumber = stepNum;
			    this._disableResultSelectBox(false);
				if(elementResults[stepNum])
					this.setProperties(elementResults[stepNum]);

				if(this.isExecutionOver && (stepNum == (this.numberOfSteps*this._iterations)))
					this._disableResultSelectBox(true);
			
			}catch(error){
				console.debug("----error changing step--- "+ stepNum)
			}
		},
		_disablePauseClick:function(disable){
			if (!disable) {
				this.pauseEvent = this.connect(this._pause, "onclick", this._handlePauseClick);
				this.pauseEnterEvent = this.connect(this._pause, "onkeypress", function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.pauseEvent) 
						this._handlePauseClick();
				});
				this._pause.title = Constants.getMessage("labelClickToPauseExe");
			}else {
				if (this.pauseEvent) {
					this.disconnect(this.pauseEvent);
					this.pauseEvent = null;
				}
				if (this.pauseEnterEvent) {
					this.disconnect(this.pauseEnterEvent);
					this.pauseEnterEvent = null;
				}
				this._pause.title = "";
			}
		},
		setParentDirty:function(){
			if(this.originalStepNum != null)
                this._staleStepUpdated = true;
		},
		_onStaleStepUpdate: function(stepNum){
            var args = {};
			var properties = this.getProperties();
            if(properties.length > 0)
                args.addProperties = properties;
			var elementResults = this._ER.elementResults;
			if(elementResults[stepNum].comment)
				args.comment = elementResults[stepNum].comment;
			if(elementResults[stepNum].compare)
				args.comment = elementResults[stepNum].compare;
            var removeAttachmentItemIds = this._buildAttachmentIdList(elementResults[stepNum].removedAttachments);
            if(removeAttachmentItemIds.length>0)
                args.removeStepAttachmentItemIds = removeAttachmentItemIds;
            var defectIdList = this._buildDefectIdList(properties);
            if(defectIdList.length>0)
                args.defectIds = defectIdList;
            var addAttachmentItemIds = this._buildAttachmentIdList(elementResults[stepNum].attachments,true);
            if(addAttachmentItemIds.length > 0)
                args.addStepAttachmentItemIds = addAttachmentItemIds;
            args.resultElementStateTypeId = elementResults[stepNum].result.id;
			this._callUpdate(args,stepNum);
		},
		
		_onStaleStepVerdictUpdate: function(){
			var result = this._getStepResult(this._currentStepNumber);
			this._updateResult(result, this._currentStepNumber);
            this._staleStepUpdated = true;
		},
		
		_callUpdate: function(args,stepNum){
			args.stepItemId = this._ER.elementResults[stepNum].internalId;
			args.executionResult =  this._resultId;
			args.resultStateId = this._resultStateId;
			var value = this.editor ? this.editor.getValue() : "";
			if(value == '<br />' || value == '<br/>')
				value = "";
			else 
				value = escape(value);
			value = this.wrapAsXhtml(value);
			args.actualResult = value;
            if (this.isExecutionOver && args.resultElementStateTypeId) {
				this._collectDateTime("stop");
				args.startTime = this._startTime ? parseInt(this._startTime) : null;
				args.endTime = parseInt(this._endTime);
				args.machine = Constants.getMessage("labelLocalComputer");
				args.owner = getAuthenticatedContributor().userId;
				args.ewiItemId = this.ewi.itemId;
			}else {
				args.resultState = ResultStates.IN_PROGRESS;
			}
            var self = this;
			var callbackObj ={
				success: function(eer){
					self.uncommittedProperty.splice(stepNum,1);
					self._ER.elementResults[stepNum] = eer;
					self._resultStateId = eer.resultStateId;
                    self._staleStepUpdated = false;
				},
				error: function(errorObj){
					console.error("Error updating step details ["+errorObj.message+ "] _onStaleStepUpdate")
					self._saveError(errorObj);
				}
			}
			var responseHandler=new ServiceResponseHandler(callbackObj, "success", "error");
		    ResultClient.postApplyResult(responseHandler, args);
		},
		
        ////////////////////////////////
		// Error handling
		////////////////////////////////
		_saveError:function(errorObj){
			this.parentSection._displayAlertDialog(errorObj.message);
		},
		_error: function(errorObj) {
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}
			console.error("Error: (message: '" + errorObj.message + "') from Manual Execution#_error");
		},
		
		isExecutionComplete: function(){
			return this.isExecutionOver;
		},
		uninitialize: function(){
			dojo.forEach(this._menus, function(menu){ 
				if(menu.destroyRecursive){
					menu.destroyRecursive();
				}
			});
			this._menus = [];
			this._destroyEditor();
			this.clearWaitTimer();
			this.inherited(arguments);
		},
		
        wrapAsXhtml: function(content) {
            var xhtml = content;
            if (xhtml && dojo.trim(xhtml).length>0) {
                var xhtmlNsUri = "http://www.w3.org/1999/xhtml";
                var xhtmlSafe= new RegExp("^<div[^>]+xmlns=\"" + xhtmlNsUri.replace("/","\\/")); 
                if (!xhtmlSafe.test(xhtml)) {
                    xhtml = "<div xmlns=\"" + xhtmlNsUri + "\">" + xhtml + "</div>";
                }
            }
            return xhtml;
        }
});
})();
