/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("jazz.ui.HoverPopup");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("jazz.util.html");

(function() { // module container
var _textContent=dojo.isIE?"innerText":"textContent"; 

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ReportsClient 			= com.ibm.team.reports.web.client.internal.ReportsClient;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var HoverPopup 				= jazz.ui.HoverPopup;
var getCurrentProjectArea 	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
var CompareView				= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
var RegistryClient 			= com.ibm.rqm.planning.web.client.internal.RegistryClient;

var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;
var DEFECT_URL 						= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DOWNLOAD_SERVICE_URI 			= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var REPORT_REST_SERVICE_URI 		= "com.ibm.team.reports.common.internal.service.IReportRestService";
var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_STEP_COMPARE			= "keyword step";
var NOT_RUN_RESULT					= "com.ibm.rqm.execution.common.state.notrun"
var KEYWORD_NAME_TYPE				= 1;
var REMOTE_KEYWORD_TYPE				= 2;
var KEYWORD_STEP_TYPE				= 3;
var NESTED_KEYWORD_TYPE				= 4;

var ExecutionElementResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecutionLog.html"),
		labelStep:Constants.getMessage("labelStep"),
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelActualResult: Constants.getMessage("labelActualResult"),
		result: null,
		_itemId: null,
		stepAttachments: [],
		defectTooltipMap: {},
		
		reportUrlPrefix: "../../", /* Optional: If not specified, defaults to web ui prefix */
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {		
			//Will receive this.resultItemId, this.ewiId
			this.lastClickedRow = "none";
			this._stepsHaveVerdict = Utility.getStepsHaveVerdict();
			this.DEFECT_ICON = this.id+"_defectIcon";
			this.DEFECT_ID	= this.id+"_defect";
			this.ATTACH_ICON = this.id+"_attachIcon";
			this.ATTACH_ID = this.id+"_attach";
			this.COMMENT_ICON = this.id+"_commentIcon";
			this.COMMENT_ID = this.id+"_comment";
			this.COMPARE_ICON = this.id+"_compareIcon";
			this.COMPARE_ID = this.id+"_compare";
			this.tooltips = [];
			this._elementMap = [];
		},
		
		initialize: function(){
			if (!this.result) {
				return;
			}
			if(this.result.itemId != null){
				this._itemId = this.result.itemId;
			}
			this._showReport();
			this._initElementTypes();
		},
		_initElementTypes: function() {
			var handler = new ServiceResponseHandler(this, "_setElementTypes", "_error");
			RegistryClient.getAllExecutionElementTypes(handler);			
		},
		
		_getElementTypeById: function(id) {
			return this._elementMap[id];
		},	
		
		_setElementTypes: function(elementTypes) {
			var len = elementTypes.length;
			for(var i=0;i<len;i++){
				if(elementTypes[i].name == "Execution Step")
					elementTypes[i].displayName = Constants.getMessage("labelExecutionStep");
				else if(elementTypes[i].name == "Reporting Step")
					elementTypes[i].displayName = Constants.getMessage("labelReportingStep");
				else if(elementTypes[i].name == "Keyword")
					elementTypes[i].displayName = Constants.getMessage("labelKeyword");	
				elementTypes[i].iconUrl = ImageCache.getTypeIconURL(elementTypes[i])
				this._elementMap[elementTypes[i].id] = elementTypes[i];	
			}
			this._initialize();
		},
		_initialize:function(){
			if(this.result.elementResults){
				this.stepNumber = 1;
				var elementResults = this.result.elementResults;
				var len = elementResults.length;
				var doc = document;
				var val = true;
				for(var i = 0; i < len; i++){
					if (elementResults[i] && elementResults[i].keywordStepType == KEYWORD_NAME_TYPE) {
						var next = elementResults[i+1];
						if (next && (next.keywordStepType == KEYWORD_STEP_TYPE || next.keywordStepType == NESTED_KEYWORD_TYPE )
							&& next.result.id == NOT_RUN_RESULT) {
								break;
						}else {
							this._insertKeywordNameRow(doc, elementResults[i], i);
						}
					}else if (elementResults[i].result.id == NOT_RUN_RESULT) {
							break;
					}else {
						this._appendEditableStepRow(doc,elementResults[i],i);
					}
				}
			}
		},
		getHelpContextID: function(){
      		return "rqm_manual_execution_results_overview.html";
   		},
		
		getAttributes: function(){
			return null;
		},
		
		_createPropertiesHtml: function(doc,stepNum,properties,attachments,comment,compare){
			var attachCell = this._getEmptyCell(doc);
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
			var defectCell = this._getEmptyCell(doc);
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right"; 
			var commentCell = this._getEmptyCell(doc);
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right"; 
			var compareCell = this._getEmptyCell(doc);
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right"; 
			
			var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var attachmentsHtml = doc.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(doc.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(doc.createElement("tbody"));
			var commentsHtmlContent = doc.createElement("span"); 
			var defectsHtml = "";
			if(properties){
				var len = properties.length;
				var defectFound = false;
				for(var i=0;i<len;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
							if(defectFound == false){
								var defectImg = doc.createElement("img");
								defectImg.alt= Constants.getMessage("labelDefects");
								defectImg.src = ImageCache.DEFECT;
								defectImg.className = "type-image";
								defectImg.setAttribute("tabIndex", 0);
								defectImg.id = this.DEFECT_ICON + stepNum;
								defectCell.appendChild(defectImg);
								if (dojo.isIE) {
									defectImg.onkeypress = dojo.hitch(this, function(event){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
								else {
									defectImg.onkeypress = this.connect(defectImg, "onkeypress", function(e){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
								defectFound = true;
							}							
							defectCount++;							
							if(properties[i].propertyType == DEFECT_VIEW_TYPE){
                                var defectLabel = Constants.getMessage("labelDefectIdExecution",  properties[i].propertyValue);
								var anchorHTML = "<a href="+DEFECT_URL + properties[i].propertyValue+" target='_blank' tabindex='0'"+
												 "onclick='var e = event?event:window.event;e.stopPropagation?e.stopPropagation():(e.cancelBubble = true);'"+
												 ">"+defectLabel+"</a><br/>";
								defectsHtml+=anchorHTML;
							}else if (properties[i].propertyType == RTC_DEFECT_VIEW_TYPE){
								var defectLabel = properties[i].propertyName;
								var anchorHTML = "<a href="+properties[i].propertyValue+" target='_blank' tabindex='0'"+
												 "onclick='var e = event?event:window.event;e.stopPropagation?e.stopPropagation():(e.cancelBubble = true);'"+
												 ">"+defectLabel+"</a><br/>";
								defectsHtml+=anchorHTML;
							}
							break;
					}
				}
			}
			if (attachments) {
				attachmentCount = attachments.length;
				var attachmentFound = false;
				for (var i = 0; i < attachmentCount; i++) {
					if (attachmentFound == false) {
						var attachImg = doc.createElement("img");
						attachImg.alt = Constants.getMessage("labelAttachment");
						attachImg.src = ImageCache.ATTACHMENT;
						attachImg.className = "type-image";
						attachImg.id = this.ATTACH_ICON + stepNum;
						attachImg.setAttribute("tabIndex", 0);							
						attachCell.appendChild(attachImg);
						attachmentFound = true;
						dojox.data.dom.removeChildren(attachmentsHtmlContent);
					}
					var attachmentsHtmlContentRow = this._getEmptyRow(doc);
					var attachmentsHtmlContentCell = this._getEmptyCell(doc);
					var attachmentsAnchor = doc.createElement("a");
					attachmentsAnchor.target = "_blank";
					attachmentsAnchor[_textContent]=attachments[i].name;
					attachmentsAnchor.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachments[i].itemId;
					attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
					attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
					attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
				}
			}
			if(comment){
				commentFound = true;
				commentsHtmlContent[_textContent]=comment;
				var commentImg = doc.createElement("img");
				commentImg.alt= Constants.getMessage("labelComment");
				commentImg.src = ImageCache.COMMENT;
				commentImg.className = "type-image";
				commentImg.id = this.COMMENT_ICON + stepNum;
				commentImg.setAttribute("tabIndex", 0);
				commentCell.appendChild(commentImg);
			}
			if(compare){
				var compareButton = doc.createElement("button");
				if(dojo.isIE >= 7)
						compareButton.style.backgroundColor = '#FFFFFF';
					else
						compareButton.style.background = "inherit";
				compareButton.style.border="0pt";
				var compareImg = doc.createElement("img");
				compareImg.alt= Constants.getMessage("labelCompare");
				compareImg.src = ImageCache.COMPARE;
				compareImg.className = "type-image";
				compareImg.setAttribute("tabIndex", 0);
				compareButton.id = this.COMPARE_ICON + stepNum;
				compareButton.appendChild(compareImg);
				compareCell.appendChild(compareButton);
				this.connect(compareButton, "onclick", dojo.hitch(this,"_showCompareDialog",stepNum,null));
			}
			if(attachmentCount>0){
				var _attachmentTooltipSpan = doc.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = doc.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				var tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
				this.tooltips.push(tooltip);
			}
			if(defectCount>0){
				var _defectTooltipSpan = doc.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = doc.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				var tooltip = new HoverPopup({
					around: [defectImg],
					html: defectsHtml
				});
				this.tooltips.push(tooltip);
				if(this.defectTooltipMap[stepNum])
					this.defectTooltipMap[stepNum].destroy();
				this.defectTooltipMap[stepNum] = tooltip;
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = doc.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				var tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);
				this.tooltips.push(tooltip);				
			}			
			return [attachCell,defectCell,commentCell,compareCell];
		},		
		_showCompareDialog:function(stepNum,compare){
			var stepCompare = compare ? compare:this.result.elementResults[stepNum].compare;
			if(!stepCompare){
				return;
			}
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			dijit.popup.close(this.compareView);
			if (!this.compareView) {
				this.compareView = new CompareView({
					hideActual: false,
					editable: false,
					callback:dojo.hitch(this,function(){
							dijit.popup.close(this.compareView);
						})
				});
				dojo.style(this.compareView.domNode,"background","white");
				dojo.style(this.compareView.domNode,"border","1px solid gray");
				dojo.style(this.compareView.domNode,"padding","5px");
				dojo.style(this.compareView.domNode,"width","200px");
			}
			this.compareView.setData(stepCompare,true);
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onExecute: function(){}
			});
			this.compareView.setFocus();
		},
		

		_appendEditableStepRow: function(doc,stepObj,stepNum){
			var targetRow = this._getEmptyRow(document);
			targetRow.id = "_tr"+stepNum;
			this.attachmentEvent = this.connect(targetRow, "onclick", this._handleRowClick);
			this._stepsTableBody.appendChild(targetRow);
			this._insertStep(doc,targetRow,stepNum,stepObj);
		},
		
		_insertStep:function(doc,targetRow,stepNum,stepObj){
			dojox.data.dom.removeChildren(targetRow);
			//step number cell
			var numCell = this._getEmptyCell(doc);
			if(stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE)
                numCell[_textContent]="";
            else 
			    numCell[_textContent]=this.stepNumber++;
			targetRow.appendChild(numCell);
			//Sanitize the description, expectedresult and actualresult
			if(stepObj){
				if(stepObj.description){
					stepObj.description = jazz.util.html.removeScript(stepObj.description);
				}
				if(stepObj.expectedResult){
					stepObj.expectedResult = jazz.util.html.removeScript(stepObj.expectedResult);
				}
				if(stepObj.actualResult){
					stepObj.actualResult = jazz.util.html.removeScript(stepObj.actualResult);
				}	
			}
			
			//step type cell
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
			if(stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE){
				typeImg.src = ImageCache.NOIMAGE;
			}else {
				var stepType = this._getElementTypeById(stepObj.stepType);
                typeImg.title = stepType.name?stepType.name:"";
                typeImg.alt = stepType.name?stepType.name:"";
                typeImg.src = ImageCache.getTypeIconURL(stepType);
				typeImg.className="type-image";
			}
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
			
			//result type cell
			var resultCell = this._getEmptyCell(doc);
			var resultImg = doc.createElement("img");
			resultImg.className = "type-image";
			resultImg.src= Utility.getImageForResult(stepObj.result);
			resultImg.alt = ExecutionElementResultStates.LABELS[stepObj.result.id];
			resultImg.id = "_results" + stepNum;
			resultCell.appendChild(resultImg);

			if(stepObj.result&& stepObj.result.id != "com.ibm.rqm.execution.common.state.complete"){
				resultCell.appendChild(doc.createTextNode(ExecutionElementResultStates.LABELS[stepObj.result.id]));
			}
			targetRow.appendChild(resultCell);
			//step name / description cell
			var descriptionCell = this._getEmptyCell(doc);
			var descriptionInput = doc.createElement('div');
			descriptionInput.className = "step-detail-col";
			var desc = stepObj.description?unescape(stepObj.description):"";
			descriptionInput.innerHTML = desc;
			descriptionInput.id = "_stepDesc" + stepNum;
			if(stepObj.keywordStepType == KEYWORD_STEP_TYPE || stepObj.keywordStepType == NESTED_KEYWORD_TYPE) {
				var stepTypeImg = doc.createElement("img");
				var stepType = this._getElementTypeById(stepObj.stepType);
				stepTypeImg.title = stepType.name?stepType.name:"";
                stepTypeImg.alt = stepType.name?stepType.name:"";
                stepTypeImg.src = ImageCache.getTypeIconURL(stepType);
				stepTypeImg.className = "type-image";
				descriptionInput.innerHTML = "";
				descriptionInput.appendChild(stepTypeImg);
				descriptionInput.innerHTML = descriptionInput.innerHTML+desc;
			}
			descriptionCell.appendChild(descriptionInput);	
			targetRow.appendChild(descriptionCell);
			//expected Res
			var expCell = this._getEmptyCell(doc);
			var expDiv = doc.createElement('div');
			expDiv.className = "step-detail-col";
			expDiv.innerHTML = stepObj.expectedResult?unescape(stepObj.expectedResult):"";
			expCell.appendChild(expDiv);
			targetRow.appendChild(expCell);
			//Actual Res
			var actCell = this._getEmptyCell(doc);
			var actDiv = doc.createElement('div');
			actDiv.className = "step-detail-col";
			actDiv.innerHTML = stepObj.actualResult?unescape(stepObj.actualResult):"";
			actCell.appendChild(actDiv);
			targetRow.appendChild(actCell);
			var stepAttachments = stepObj.stepAttachments?stepObj.stepAttachments:[];
			var attachments = stepAttachments.concat(stepObj.attachments?stepObj.attachments:[]);
			var propshtml = this._createPropertiesHtml(doc,stepNum,stepObj.properties,attachments,stepObj.comment,stepObj.compare);
			targetRow.appendChild(propshtml[0]);
			targetRow.appendChild(propshtml[1]);
			targetRow.appendChild(propshtml[2]);
			targetRow.appendChild(propshtml[3]);
		},
			
		_insertKeywordNameRow:function(doc,stepObj,stepNum){
			var stepRow = this._getEmptyRow(doc);
			var numCell = this._getEmptyCell(doc);
			numCell[_textContent]=this.stepNumber++;
			stepRow.appendChild(numCell);
			var typeCell = this._getEmptyCell(doc);
			var typeImg = doc.createElement("img");
			var stepType = this._getElementTypeById(stepObj.stepType);            
            typeImg.title = stepType.name?stepType.name:"";
            typeImg.alt = stepType.name?stepType.name:"";
            typeImg.src = ImageCache.getTypeIconURL(stepType);
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			stepRow.appendChild(typeCell);
			var resultCell = this._getEmptyCell(doc);
			var resultSelect = doc.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "type-image";
			resultCell.appendChild(resultSelect);
			stepRow.appendChild(resultCell);
			var nameCell = this._getEmptyCell(doc);
			nameCell[_textContent]=unescape(stepObj.description);
			nameCell.colSpan=9;
			stepRow.appendChild(nameCell);
			this._stepsTableBody.appendChild(stepRow);

		},
		
		_getEmptyRow: function(doc){
			var row = doc.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(doc,span, align){
			var cell = doc.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			if ( align != null ){
				cell.align = align;
			}
			return cell;
		},
		
		_handleRowClick: function(e){
			e.preventDefault();
			var currentTarget = e.currentTarget.id
			var s = currentTarget.split("_tr")
			if(this.lastClickedRow != "none"){
				var row = document.getElementById("_tr"+this.lastClickedRow)
				row.className = "steps-table-row"
			}	
			this.lastClickedRow = s[1];
			var row = document.getElementById("_tr"+s[1])
			row.className = "selected-row"	
		},
		
		_showReport: function(){
			/*ReportUUID is static and defined for Manual Execution Status report as execution.manualStatus*/
			var self = this;
			var arguments = {
				projectAreaUUID: getCurrentProjectArea().itemId,
				reportUUID: "execution.manualStatus",
				parameterName: "resultId",
				parameterValue: self._itemId,
				showArchived: false,
				urlPrefix: self.reportUrlPrefix
			};
			var serviceObject = {
			// Service success
				success: function(html) {
					self._reportChart.innerHTML = html;
				},
			// Service failure
				failure: function(errorObject) {
					self._error(errorObject);
				}
			};
			var responseHandler = new ServiceResponseHandler(serviceObject, "success", "failure");
			var request = new ServiceRequest(REPORT_REST_SERVICE_URI,"getRenderedReport",arguments);
			// Invoke the service
			TeamServerClient.invokeService(request, responseHandler);
		},
		deleteDefect:function(defectList){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgRemoveDefectAssociation"),
				yesCallback: function(defectList){
					self.parentEditor._deleteDefects(defectList);
					self._deleteDefect(defectList);
					return true;          
				},
				yesCallbackData:defectList
			}
			var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
		},
		_deleteDefect:function(defectList){
			var found = false;
			var elementResults = this.result.elementResults;
			var len2 = elementResults.length;
			var dirtySteps = this.dirtySteps||[];
			if(defectList && defectList.length){
				var len = defectList.length;
				for(var i=0;i<len;i++){
					var defectId = defectList[i].id+"";//convert int to string
					for(var j=0;j<len2;j++){
						var prop = elementResults[j].properties;
						if(prop){
							var len3 = prop.length;
							for (var k = 0; k < len3; k++) {
								var property = prop[k];
								if((property.propertyType == DEFECT_VIEW_TYPE && property.propertyValue == defectId) ||
									(property.propertyType == RTC_DEFECT_VIEW_TYPE && property.propertyValue == defectList[i].defectItemUri))
								{
									prop.splice(k,1);
									dirtySteps.push(elementResults[j]);
									found = true;
									break;
								}
							}
						}
					}
				}
			}
			if(found){
				dojox.data.dom.removeChildren(this._stepsTableBody);
				this.dirtySteps = dirtySteps;
				this.setLogDirty(true);
				this._initialize();
			}
		},
		isLogDirty:function(){
			return this.dirty;
		},
		setLogDirty:function(dirty){
			this.dirty = dirty;
			if(!dirty){
				this.dirtySteps = [];
			}
		},
		getMixInArgs:function(){
			var args = {};
			var steps = [];
			var dirtySteps = this.dirtySteps;
			var len = dirtySteps.length;
			for(var i=0;i<len;i++){
				var step = {};
				step.stepResultItemId = dirtySteps[i].internalId;
				step.properties = dirtySteps[i].properties||[];
				steps.push(step);
			}
			args.elementResultParams = steps;
			return args;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ManualExecutionLog#_error");
		},
		uninitialize: function(){
			dojo.forEach(this.tooltips, function(tooltip){ 
				if(tooltip.destroyRecursive){
					tooltip.destroyRecursive();
				}
			});
			this.tooltips = [];
			if (this.compareView)
				this.compareView.destroyRecursive();
			this.compareView = null;
		}	
	}
);

}
)();
