/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// Utilities
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

	var ImageCache = com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
    var Constants  = com.ibm.rqm.planning.web.client.internal.Constants;
	
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/VPStackedBarChart.html"),
		
		labelVerificationPointsStatus: Constants.getMessage("labelVerificationPointsStatus"),
		
		parentController:null,
		
		postCreate: function() {		
			
			//Not removing the _version of pass fail etc since manipulations are done on them
			//TODO: Keeping check for not null, add typeof aVar == "number" ? 
			//this.pass = typeof this.pass == "number" ? parseInt(this.pass) : 0;
			//this.fail = typeof this.fail == "number" ? parseInt(this.fail) : 0;
			//this.inconclusive = typeof this.inconclusive == "number" ? parseInt(this.inconclusive) : 0;	
			if(this.pass != null)
				this._pass = parseInt(this.pass);
			if(this.fail != null)
				this._fail = parseInt(this.fail);
			if(this.inconclusive != null)
				this._inconclusive = parseInt(this.inconclusive);
			if(this.totalVPs)
				this._totalVPs = this.totalVps;
			else
				this._totalVPs = parseInt(this._pass)+parseInt(this._fail)+parseInt(this._inconclusive);
	
			this._fillTable();
		},
	
		_fillTable: function()
		{
			var passPer = (parseInt(this._pass)/this._totalVPs)*100;
			var failPer = (parseInt(this._fail)/this._totalVPs)*100;
			
			var inconPer = (parseInt(this._inconclusive)/this._totalVPs)*100;
			
			if(passPer != 0)
			{
				this._passCol.width = passPer+"%";
				this._passCol.className = "passCol"
			}
			if(failPer != 0)
			{
				this._failCol.width = failPer+"%";
				this._failCol.className = "failCol"
			}
			if(inconPer != 0)
			{
				this._inconclusiveCol.width = inconPer+"%";
				this._inconclusiveCol.className = "inconclusiveCol"
			}
			
			var passImg = document.createElement("img");
			passImg.src = ImageCache.PASS_ICON;
			this._passColTitle.appendChild(passImg);
			
			var failImg = document.createElement("img");
			failImg.src = ImageCache.FAIL_ICON;
			this._failColTitle.appendChild(failImg);
			
			var inconImg = document.createElement("img");
			inconImg.src = ImageCache.INCON_ICON;
			this._inconclusiveColTitle.appendChild(inconImg);
			
			this._passColTitle.appendChild(document.createTextNode(Constants.getMessage("labelPassed")));
			this._failColTitle.appendChild(document.createTextNode(Constants.getMessage("labelFailed")));
			this._inconclusiveColTitle.appendChild(document.createTextNode(Constants.getMessage("labelInconclusive")));
			
			this._passColValue.appendChild(document.createTextNode(this._pass+""));
			this._failColValue.appendChild(document.createTextNode(this._fail+""));
			this._inconclusiveColValue.appendChild(document.createTextNode(this._inconclusive+""));
			
			//this._totalVPs.innerHTML = this._totalVPs;
		}	
		
		
		
	});
})();
