/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.extension.AttachmentSection");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.extension.AttachmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AttachmentContainer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    /**
     * Widget to display list of link elements in the LeftNavigation.
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.extension.AttachmentSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: "<div dojoAttachPoint=\"_attachmentNode\"></div>",
        
        constructor: function() {	
        },
        
        postCreate: function(args){	
            this.inherited('postCreate', arguments);
            this.addWorkItemSupport();
        },
        
		//will be lazily loaded by getMainContent
		//@Overridden from AbstractArtifactEditorSection
        initialize: function(isEditable){
			this.unloadContent(this._attachmentNode);
			this._attachmentWidget = new com.ibm.rqm.planning.web.ui.internal.view.construction.AttachmentContainer();
			var args = {
				artifact: this.getArtifact(),
                artifactType: this.getArtifactType(),
				parentEditor: this.getParentEditor(),
				parentSection: this,
				isNonEditableMode: !this.isEditable()
			};
			this._attachmentWidget.initialize(args);
			this._attachmentNode.appendChild(this._attachmentWidget.domNode); 		                 
        },
               
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
			if(this._attachmentWidget)
            	this._attachmentWidget.onSave(this.getArtifact());
            this.addWorkItemSupport();			
        },
        
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ AttachmentSection#_error");
        }
    });
})();
