//MES
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.ManualExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

(function() { // module container

var ExecutionViewer			= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
var Constants				= com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents 			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;

dojo.declare( "com.ibm.rqm.execution.web.ui.internal.view.extension.ManualExecutionSection", [dijit._Widget, dijit._Templated, ExecutionViewer], {
   templateString: "<div dojoAttachPoint=\"_manualExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-ManualExecutionSection\"></div>",
   
   queuedOrTakenRequest: true,
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
   		this.setPrintable(true);
		this.setStopAllowed(true);
	},
	
   //Overriden from ExecutionViewer
   initialize: function(){
   		com.ibm.asq.common.web.ui.internal.util.Utility.destroyWidgetsFromNode(this._manualExecutionSection);  
		dojox.data.dom.removeChildren(this._manualExecutionSection);
		if(this.requestId){
			this.setRequestId({id: this.requestId});
		}else
			this.onStartOfExecution(null);
   },
   
   //Overriden from ExecutionViewer
   setRequestId: function(request){
	   	this.requestId = request.id;
		if (!this.parentEditor.getRequestId()) {
			this.parentEditor.setRequestId(this.requestId);
			dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, 
				Utility.startExecution(this.parentEditor.ewi, this.parentEditor.runScript, 
					this.parentEditor._resultId, this.parentEditor.requestId, this.parentEditor.ergId)
				]);
		}
	   	var listArgs = {
				parentController: this.parentController,
				ewiItemId: this.ewiItemId, 
				runScriptId: this.script.versionableItemId, 
				_resultId: this._resultId,
				parentWidget:this.parentEditor,
				parentSection: this,
				requestId: this.requestId,
				printView: this.printView,
				__ewiObject: this.__ewiObject,
				__scriptObject: this.__scriptObject,
				ergId: this.ergId
			}
	    this._manualExecution = new com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution(listArgs); 
		this._manualExecutionSection.appendChild(this._manualExecution.domNode);
		var self = this;
		var param = {
			requestId: this.requestId
		}
		var callbackObj = {
			success: function(requestDTO){
				if(requestDTO && requestDTO.length >0){
					self._updateViewerForRequest(requestDTO);
					dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, requestDTO]);
				}
			},
			failure: function(error){
				console.error("failed to get requestDTO in MES "+error.message);
			}
		}
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(callbackObj, "success", "failure");
		com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getRequestDTO(responseHandler, param);
   },
	
	_updateViewerForRequest: function(requestDTOs){
		this.setCancelDisabled(false);
		this.setStopDisabled(this._resultId ? false : true);
		if(requestDTOs && requestDTOs.length == 1){//Only one request should be returned.
			var requestDTO = requestDTOs[0];
			if(requestDTO.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled" || 
					requestDTO.state.id == "com.ibm.rqm.executionframework.common.requeststate.complete"){
				this._manualExecution.hideToolBar();
				this.setCancelStopDisabled(true);
				this.queuedOrTakenRequest = false;
				if(requestDTO.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled" && this.parentEditor){
					this.parentEditor.setHeaderStatus(Constants.getMessage("msgExeCancel"), 3);
					this.parentEditor.showResultButton.setStyle("display", "none");
					this.parentEditor._header.addRightViewAction(Constants.getMessage("labelClose"), dojo.hitch(this, "onClose"), null, null);
				}else if(requestDTO.state.id == "com.ibm.rqm.executionframework.common.requeststate.complete" && this.parentEditor){
					this.parentEditor.setHeaderStatus(Constants.getMessage("msgExeOver"), 3);
				}
			}
		}	
	},
	
	setCancelStopDisabled: function(disable){
		if(this.queuedOrTakenRequest){
			this.setCancelDisabled(disable);
			this.setStopDisabled(disable);
		}	
	},
	
	//Overriden from ExecutionViewer
	updateParentDetailSection: function(){
		//Do nothing
	},

	getHelpContextID: function(){
		return "rqm_manual_test.html";
	}, 
	
	//Overriden from ExecutionViewer	
	onCancel: function(){
		return this._manualExecution.onCancel();
	},
	
	//Overriden from ExecutionViewer	
	onEndOfExecution: function(){
		this._manualExecution.onEndOfExecution();
		this.inherited('onEndOfExecution', arguments);
	},
	
	cleanUp: function(){
		if(this._manualExecution)
			return this._manualExecution.isDirty();
		else
			return false;
	},
	
	//Over-ridden from ExecutionViewer
	isStopExecutionEnabled: function(){
		if(this._resultId && this._manualExecution){
			if(!this._manualExecution.isExecutionComplete()){
				return true;
			}
		}
		return false;
	},
	
	onStopConfirm: function(){
		this.inherited('onStopConfirm', arguments);
		this._manualExecution.onStop();
	},
	
	_error: function(errorObj){
		console.error("Error: (message: '" + errorObj.message + "') from ManualExecutionSection#_error");
	}
});

})();
