/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.NoScriptExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecution");
dojo.require("dijit.Dialog");

(function() { // module container

var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;

dojo.declare(
   "com.ibm.rqm.execution.web.ui.internal.view.extension.NoScriptExecutionSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], 
   {
   templateString: "<div dojoAttachPoint=\"_noScriptExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-NoScriptExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

   initialize: function(){  
		dojox.data.dom.removeChildren(this._noScriptExecutionSection);
		var listArgs = {
			parentController: this.parentController,
			ewiItemId: this.ewiItemId, 
			runScriptId: null, 
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		}    
	    this._noScriptExecution = new com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecution(listArgs); 
		this._noScriptExecutionSection.appendChild(this._noScriptExecution.domNode);
   },

   //@Overriden from AbstractArtifactEditorSection
   getHelpContextID: function(){
      return "rqm_manual_test.html";
   }, 
   
   //@Overriden from AbstractArtifactEditorSection
   getActions: function(){
      return [];
   },   
      
   //@Overridden from AbstractArtifactEditorSection
   saveFinished: function(){
      //nothing right now            
   },
	
	update: function() {
	   this.initialize();
	},
	
	onCancel: function(){
		this._noScriptExecution.onCancel();
	},
	
	_error: function(errorObj)   
	{
		alert("Error: (message: '" + errorObj.message + "') from NoScriptExecutionSection#_error");
	}
});

})();
