/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.rpt.web.ui.internal.view.extension.PerformanceExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer    				= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
dojo.declare(
   "com.ibm.rqm.adapter.rpt.web.ui.internal.view.extension.PerformanceExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_performanceExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-PerformanceExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
    initialize: function(){   
        if (!dojo.getObject("com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecution")){
            jazz.core.loader.load_async("com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecution", dojo.hitch(this,function(){ 
                jazz.core.loader.load_async("com.ibm.rqm.adapter.rpt.web.ui.internal.RptUiUtil", dojo.hitch(this,"_initialize2"));
            }));
        }else{
            this._initialize2();
        }
    },
    
    _initialize2: function(){       
	   var script = this.script;
		var scriptInfo = {
			itemId: script.versionableItemId  ? script.versionableItemId : script.itemId,
			type: script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
       
		this.scriptInfo = scriptInfo;     
		dojox.data.dom.removeChildren(this._performanceExecutionSection);
		this._perfWidget = new com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecution({
							parentController: this.parentController, 
							ewiItemId: this.ewiItemId, 
							scriptInfo: scriptInfo, 
							parentSection: this
						});
		this._performanceExecutionSection.appendChild(this._perfWidget.domNode);
		this.inherited("initialize", arguments);	        
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
	  return "rqm_performance_test.html";
	}, 
	
	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._perfWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
	
});

})();