/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.ui.internal.view.extension.ReportsActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.reports.web.ui.internal.view.ReportViewer");
dojo.require("com.ibm.rqm.reports.web.ui.internal.view.NewReport");
function userIsAdmin()
{
    var InitializationData     = com.ibm.team.repository.web.client.init.InitializationData;
	var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
	return (permissionInitializer != null && permissionInitializer.canGrantPermission);
}

(function() 
{
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    //var MAX_RECENT_REPORTS = 5;
	var MAX_TAB_LABEL_LENGTH = 20;

	dojo.declare(
		"com.ibm.rqm.reports.web.ui.internal.view.extension.ReportsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function() 
			{
				//this._recent = [];
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				         												
                //create menu items				
				this._addMenuEntry(Constants.getMessage("labelViewReports"), dojo.hitch(this, "viewReports"), false, {'subAction':"viewReports"});
				this._addMenuEntry(Constants.getMessage("labelCopyReport"), dojo.hitch(this, "copyReport"), false, {'subAction':"copyReport"});
				
                var isAdmin = userIsAdmin();                
				if (isAdmin) {
					this._addMenuSeparator();
					this._addMenuEntry(Constants.getMessage("labelAdminDW"), dojo.hitch(this, "adminReports"), false, {'subAction':"adminReports"});
				}
								
                //register actions 
                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewReports", dojo.hitch(this, "viewReports"));
					this.actionDispatcher.registerDispatchAction("viewReport", dojo.hitch(this, "viewReport"));
					this.actionDispatcher.registerDispatchAction("copyReport", dojo.hitch(this, "copyReport"));
					if (isAdmin) {
						this.actionDispatcher.registerDispatchAction("adminReports", dojo.hitch(this, "adminReports"));
					}
                }
			},
			
        /*
         * QM Reports Actions
         */
        _onCancel: function(){
        },
		
        viewReports: function(args){
            var loadFunc = function(tab, onComplete){            
            this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.ReportsView", dojo.hitch(this,function(){
                    var view = new com.ibm.rqm.reports.web.ui.internal.view.ReportsView();
                    view.setView(tab);
                onComplete(tab, view);                
                }, tab, onComplete));                
            };
			var browserTitle = Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllView");
            var page = this._addPage({
                name: Constants.getMessage("labelReports"),                
                onDeferredLoad: dojo.hitch(this, loadFunc),                
                closable: true,
                browserTitle: browserTitle
            });
            
        },
        
        viewReport: function(args){
            console.debug(this.declaredClass + ": viewReport --> entry.");

            var reportViewer = new com.ibm.rqm.reports.web.ui.internal.view.ReportViewer(args);
            var name = this._abbreviate(args.name ? args.name : Constants.getMessage("labelViewReport"));

			//HACK - wrap the reportViewer in a div until we subclass it and can wrap it ourselves; needs to be done
			//because Jazz's CSS namespace is set at a higher level than the viewer itself (Jazz ReportsView page)
			var widgetDiv = document.createElement("div");
			widgetDiv.appendChild(reportViewer.domNode);
			dojo.addClass(widgetDiv, "com-ibm-team-reports");
							
            var reportPage = this._addPage({
                name: name,
                content: widgetDiv,
                closable: true,
				browserTitle: Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + name
            });
            reportPage.reportName = args.name;
            //when the page is closed, clear the local reference
            //dojo.connect(this._reportViewerPage, "destroy", this, dojo.hitch(this, function(){
            //    this._reportViewerPage = null;
            //}));
            //reportViewer.initialize();
            reportViewer.setView(reportPage);
			
            //add this report to the recently run menu
            //this._addRecent(page.name, dojo.hitch(this, "viewReport", args), {'subAction':"viewReport"});
        },
					
        copyReport: function() {   
            //console.debug(this.declaredClass + ": adminReport --> entry.");                  
            var copyReport = new com.ibm.rqm.reports.web.ui.internal.view.NewReport();
			var browserTitle = Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelCopy");
            var page = this._addPage({
                name: Constants.getMessage("labelCopyReport"),
                content: copyReport.domNode,
                closable: true,
				browserTitle: browserTitle
            });
			copyReport.setView(page);         
        },			
		
        adminReports: function(args) {   
            //console.debug(this.declaredClass + ": adminReport --> entry.");		
            var loadFunc = function(tab, onComplete){      	
			this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin", dojo.hitch(this,function(){
			    var view = new com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin({});
			    onComplete(tab, view);                
                }, tab, onComplete));                
            };			
			var browserTitle = Constants.getMessage("labelAdminDW");
            var view = this._addPage({
                name: Constants.getMessage("labelAdminDW"),
                onDeferredLoad: dojo.hitch(this, loadFunc),
                closable: true,
				browserTitle: browserTitle
            });        
        },
		
		/*
		 * Internal
		 */
		
        //TODO move this into a utility
        _abbreviate: function(label) {
            if (dojo.isString(label) && label.length > MAX_TAB_LABEL_LENGTH) {
                label = label.substring(0, MAX_TAB_LABEL_LENGTH);
                label += "...";
            }       
			return label;    
        }
		
        /* TODO implement this - requires changes to ActionBarEntry, MenuPopup
        _addRecent: function(name, callback, options) {
            //add recent to list, 
            var link = {
                name: name,
                callback: callback,
                options: options
            }
            if (this._recent.length > 0) {
                this._recent.push(link);
                if (this._recent.length > MAX_RECENT_REPORTS) {
                    this._recent.splice(0, (this._recent.length - MAX_RECENT_REPORTS));
                }
            }
            //show recent
            if (this._recentDiv) {
                dojox.data.dom.removeChildren(this._recentDiv);
            } else {
                this._addMenuSeparator();
            }
            //show links
            for (var i = 0; i < this._recent.length; i++) {
                var link = this._recent[i];
                this._recentDiv = this._addMenuEntry(link.name, link.callback, false, link.options);
            }
                            
        },
        */						
	}
);
}
)();
