/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer    				= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
var   COMMAND					   	= "command";
var   ARGUMENTS					   	="arguments"
dojo.declare(
   "com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_robotExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-RobotExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
   	initialize: function(){   
		if (!dojo.getObject("com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecution")){
			jazz.core.loader.load_async("com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecution", dojo.hitch(this,"_initialize2"));
		}else{
			this._initialize2();
		}
	},
	_initialize2:function(){
		var script = this.script;
		var scriptInfo = {
			itemId: script.versionableItemId  ? script.versionableItemId : script.itemId,
			type: script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
		if (script != null) {
		  if(script.properties)
		  {
		  	var len = script.properties.length;
			for(var i=0;i<len; i++)
			{
				if(script.properties[i].propertyName === ARGUMENTS)
					scriptInfo.arguments = script.properties[i].propertyValue;	
			}
		  }
		}         
		this.scriptInfo = scriptInfo;     
		dojox.data.dom.removeChildren(this._robotExecutionSection);
		this._cmdWidget = new com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecution({
						parentController: this.parentController, 
						ewiItemId: this.ewiItemId, 
						scriptInfo: scriptInfo, 
						parentSection: this
					});
		this._robotExecutionSection.appendChild(this._cmdWidget.domNode);
		this.inherited("initialize", arguments);	        
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
		
	  return "rqm_robot_test.html";
	}, 

	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._cmdWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
});

})();