/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotScriptEditorSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient")

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");

(function() { // module container

var   Constants                        = com.ibm.rqm.planning.web.client.internal.Constants;
var   Utility                          = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var	  EditorUtil					   = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var   REScriptEditorSection			   = com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;
var   RobotUiUtil					   = null;
dojo.declare(
   "com.ibm.rqm.adapter.robot.web.ui.internal.view.extension.RobotScriptEditorSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection, REScriptEditorSection], 
   {
   templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.robot.web", "ui/internal/view/templates/extension/RobotScriptEditorSection.html"),
   allPlans: [],
   constructor: function(args) {
      this._script = args.script;
   },
   
   postCreate: function() {},   

   initialize: function(){
		if (!dojo.getObject("com.ibm.rqm.adapter.robot.web.ui.internal.RobotUiUtil")){
			jazz.core.loader.load_async("com.ibm.rqm.adapter.robot.web.ui.internal.RobotUiUtil", dojo.hitch(this,"_initialize2"));
		}else{
			this._initialize2();
		}
	},
	_initialize2:function(){
   	
		RobotUiUtil = com.ibm.rqm.adapter.robot.web.ui.internal.RobotUiUtil;
   		this.createBrowseSection(this._selectionArea, this._browseContainer, this._adapterContainer);
		if(!this._robotScriptPathHandle &&  !this.parentEditor.isReadOnly())
	  		this._robotScriptPathHandle = this.connect(this._robotScriptPath, "onkeypress", this.setDirty);         
		this._sharePrefixBox.readOnly = true;
		if (this.parentEditor.isReadOnly()) {
			this._robotScriptPath.readOnly = true;
		}
		this._shareprefixlabel.innerHTML = RobotUiUtil.getMessage("labelSharedLocation");
		this._typeOfScriptLabel.innerHTML = RobotUiUtil.getMessage("labelScriptName");
	},
  
   updateAdapterRadioClicked: function() {
			
		dojo.style(this._shareprefixlabel, "display", "none");
		dojo.style(this._sharePrefixBox, "display", "none");	
		dojo.style(this._typeOfScriptLabel, "display", "none");
		dojo.style(this._robotScriptPath, "display", "none");
		dojo.style(this.adapterSelector._labelScriptPath, "display", "inline");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "inline");		
		if (this._script) 
		{
			this.adapterSelector._scriptPath.value = this._script.fullPath;
		}
	},
	
	updateBrowseRadioListener: function() {
		dojo.style(this.adapterSelector._labelScriptPath, "display", "none");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "none");
		dojo.style(this._shareprefixlabel, "display", "inline");
		dojo.style(this._sharePrefixBox, "display", "inline");	
		dojo.style(this._typeOfScriptLabel, "display", "inline");
		dojo.style(this._robotScriptPath, "display", "inline");
		var _script = this._script;
		if (_script) {
			var relPath = this.stripLeadingSlash(_script.relativePath);
			this._robotScriptPath.value = relPath;
			
			if (_script.sharePrefix) {
				this._sharePrefixBox.value = _script.sharePrefix;
				this._sharePrefixBox.title = _script.sharePrefix;
			} else {
				this._sharePrefixBox.value = "";
				this._sharePrefixBox.title = "";
			}
		}
	},
	
	stripLeadingSlash: function(path) {
		var relPath = path;
		if (relPath.charAt(0) == "\\") {
			relPath = relPath.substring(1, relPath.length);
		}
		return relPath;
	},
	
	setSelectedFiles: function(resource){
		console.debug("setSelectedFiles");
		var fileList = resource.fileList;
		if(fileList && fileList.length >0){
			var initialPath = this.initialPath;
			this._sharePrefixBox.value = initialPath;
			this._sharePrefixBox.title = initialPath;
			var relPath = this.fileList[0].resourceURN.substring(initialPath.length, this.fileList[0].resourceURN.length);		
			relPath = this.stripLeadingSlash(relPath);
			this._robotScriptPath.value = relPath;
		}
   },
   
   setAdapterInfo: function(param){
   	   if(this.info.selectedAdapter)
   	    	this.adapterSelector._scriptPath.value = this.info.scriptPath+"\\"+this.info.selectedScript.name;
		else
		  this.adapterSelector._scriptPath.value = "";
		
   },
   
      //@Overriden from RemoteExecutionScriptEditorSection
   getHelpContextID: function(){
      return null;
   },
   
   //@Overriden from RemoteExecutionScriptEditorSection
   getActions: function(){
      return [];
   },    
   
   getAttributes: function(){
		var args = {};
//		console.debug("RobotScriptEditorSection->getAttributes");
		if(this.browserUsage  == true){
			args.managedByAdapter = false;
			args.sharePrefix = this._sharePrefixBox.value
			var relPath = this._robotScriptPath.value;
			args.relativePath = "\\"+relPath;
			this.absolutePath = this.fileList[0].resourceURN;
		}else if(this.adapterUsage == true){
			args.managedByAdapter = true;
			args.adapterId = this.info.selectedAdapter.id;
			args.fullPath = this.adapterSelector._scriptPath.value;
		}
		return args;
	},
	
   validate: function(){
   		
	   	if (this.browserUsage  == true){
			if (!this._sharePrefixBox.value || dojo.trim(this._sharePrefixBox.value).length == 0) {
				this.setValidationError(RobotUiUtil.getMessage("msgRequiredFieldSharedpath"));
				return false;
			} 
			if (!this._robotScriptPath.value || dojo.trim(this._robotScriptPath.value).length == 0) {
				this.setValidationError(RobotUiUtil.getMessage("msgRequiredFieldScriptName"));
				return false;
			} 
			
		} 
		if (this.adapterUsage == true) {
			
			if(!this.info || !this.info.selectedAdapter)
			{
				this.setValidationError(RobotUiUtil.getMessage("msgRequiredFieldAdapter"));
				return false;
			}
			
			if ( dojo.trim(this.adapterSelector._scriptPath.value).length == 0) {
				this.setValidationError(RobotUiUtil.getMessage("msgRequiredFieldScriptPath"));
				return false;
			}
			
			return true;
		}
		return true;
   },
     
   //@Overridden from RemoteExecutionScriptEditorSection
   saveFinished: function(testScript){
      this._script = testScript;
	 //this.initialize();
	 this.setSectionDirty(false);
   },
   
   getProperties: function(){
   	var props=[];
	return props;
   }
});
})();