//SequenceTestRecordDetails
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.team.process.web.client.projectarea");
(function() { // module container
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var ImageCache     			= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
dojo.declare(
   "com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails",[com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp],{
	
	manualSelection: "manual",
	runtimeSelection: "searchruntime",
	insideSection: true,
	adapterSelectionType: "manual",
	//Over-ridden from selectionPopUp
	_fillTestPlanTestPhase: function(){
		this._planIterationNode.style.display = "none";
		this._messageNode.style.display = "none";
	},
	//Over-ridden from selectionPopUp
	_showAsDialog: function(){
		this.connect(this, "_scriptSelectionChanged", "onChange");
	},
	//Over-ridden from selectionPopUp
	_onRunClick: function(){
		
	},
	//Over-ridden from selectionPopUp
	_getMachinesFromTable: function(machines, context){
		this.inherited(arguments);
		this._checkInCell(machines);
	},
	
	_checkInCell: function(machines){
		//Check for the latest status and
		//update the Cell status in the execution steps.
		var cell = this.mySection.getParentEditor().getCell();
		var cellMachines = cell && cell.topologies ? cell.topologies : [];
		var cellMachinesLength = cellMachines.length;
		var showStatus = "yellow";
		if(!cell){
			showStatus = "green";
		}else if(cellMachines.length == 0 || this.elements.length==0){
			showStatus = "yellow";
		}else{
			var elements = this.elements;
			var elementsLength = this.elements.length;
			for(var i=0;i<elementsLength;i++){
				if(elements[i].adapterId == "runtime"){
					showStatus = "green";//Runtime selection, update with green
					break;
				}else if(elements[i].adapterId == "global"){
					showStatus = "yellow";//If any is Manual script break to show yellow
					break;
				}
				var found = false;
				for(var j=0;j<cellMachinesLength;j++){
					var machineId = elements[i].machine ? elements[i].machine.machineID : null; 
					if(machineId  == cellMachines[i].resourceId){
						found=true;	showStatus = "green";
						break;
					}
				}
				if(!found){
					showStatus = "yellow";//One Machine was not found in the cell, break and update the cell information in the section
					break;
				}
			}
		}
		this._updateStepTable(showStatus);
	},
	
	_updateStepTable: function(showStatus){
		var content = this.mySection.getParentEditor().getStepTableContent();
		var contentLength = content.length;
		for(var i=0;i<contentLength;i++){
			if(content[i].sectionIndex == this.mySection.sectionIndex){
				if(showStatus == "green"){
					content[i].insideCell = true;
				}else{
					//show yellow
					content[i].insideCell = false;
				}
				break; 
			}
		}
		this.mySection.getParentEditor().setStepTableContent(content);
	},
	
	//Over-ridden from selectionPopUp
	_onRuntimeSelectionClick: function(){
		var elements = this.elements;
		var elementsLength = elements.length;
		if (this.getAdapterSelectionType() == this.manualSelection) {
			var backup = {machines: [], adapterImg: [], adapterStatus: []};
			this.setAdatperSelectionType(this.runtimeSelection);
			// Set machines to run time selection and disable the machine selection button for each row and table both.

			for(var i = 0; i < elementsLength; i++){
				var ele = elements[i];
				backup.machines.push(ele.machine);
				backup.adapterImg.push(ele.adapterImg);
				backup.adapterStatus.push(ele.adapterStatus);
				if(ele.selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					ele.machine = {
						name: Constants.getMessage("labelSearchRuntime"),
						adapterInfo: {
							id: "runtime",
							name: Constants.getMessage("labelSearchRuntime"),
							hostName: Constants.getMessage("labelSearchRuntime")
						},
						machineName: Constants.getMessage("labelSearchRuntime")
					};
					ele.adapterImg = ImageCache.NOIMAGE;
					ele.adapterStatus = "";
					ele.selectionCriteria = "runtime";
				}
			}
			this.backup = backup;
			this.mySection.setDirty(true);
			this.changeAction.setDisabled(true);
			this.tableViewer.setContent(this.elements);
			this.tableViewer.refresh();
			this._updateStepTable("green");
			
		} else {
			this.setAdatperSelectionType(this.manualSelection);
			// Reload the adapters for all rows and enanble the the machine selection button for each row and table both.
			if (this.backup) {
				var backup = this.backup; 
				for(var i = 0; i < elementsLength; i++){
					var ele = elements[i];
					if(ele.selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
						ele.machine = backup.machines[i];
						ele.adapterImg = backup.adapterImg[i];
						ele.adapterStatus = backup.adapterStatus[i];
						ele.selectionCriteria = null;
						this._checkInCell([backup.machines[i]]);
					}
				}
				this.mySection.setDirty(true);
				this.tableViewer.setContent(elements);
				this.tableViewer.refresh();
			}
		}
		
	},
	
	validate: function(){
		if(this.suite && !this.suite.id){
            var detailError = Constants.getMessage("msgRequiredField", Constants.getMessage("labelTestRecord"), Constants.getMessage("labelExecutionSequence"));
			this.mySection.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
			return false;
		}
		
		var items = this.elements ? this.elements :[];
		if(items.length == 0){
            var detailError = Constants.getMessage("msgNoCaseForSuiteInSequence", this.suite.name);
			this.mySection.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
			return false;	
		}
		var itemsLength = items.length;
		for(var i=0;i<itemsLength;i++){
			var scriptTypeId = items[i].selectedScriptTypeId;
			var adapterId = items[i].adapterId;
			if(!scriptTypeId || scriptTypeId == ""){
                var detailError = Constants.getMessage("msgScriptNotFoundInTestCaseForSequence", this.elements[i].workitem.testCase.name, this.suite.name);
				this.mySection.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
				return false;
			}
			if(this.getAdapterSelectionType() == this.manualSelection){
				if(scriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual" && (adapterId === "" || adapterId == "global")){
                    var detailError = Constants.getMessage("msgNoAdapterFoundForTestScriptForSequence", items[i].selectedScriptName, this.suite.name);
					this.mySection.getParentEditor().setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
					return false;
				}
			}
		}
		return true;
	},
	
	getAttributes: function(){
		var items = this.elements;
		var itemList = [];
		var itemsLength = items.length;
		for(var i=0;i<itemsLength;i++){
			var item = items[i];
			var itemId = item.workitem.id;
			var index = item.index;
			var scriptId = item.selectedScriptId;
			var adapterId = item.adapterId;
			var adapterObj = item.machine;
			if(adapterId == "" || adapterId == "global"){ // This is a manual script
				itemList.push({index: index, workItemid: itemId, scriptId: scriptId});
			} else if (adapterId == "runtime") { // Adapter to be selected at runtime
				itemList.push({index: index, workItemid: itemId, scriptId: scriptId});
			} else { // Adapter has been selected manually
				if(adapterObj && adapterObj.adapterInfo && adapterObj.machineName){
					itemList.push({index: index, workItemid: itemId, adapterId: adapterId, scriptId: scriptId, hostName: adapterObj.machineName});
				}else{
					itemList.push({index: index, workItemid: itemId, adapterId: adapterId, scriptId: scriptId});
				}
			}
		}
		var attr = {
			adapterSelectionCriteria: (this.getAdapterSelectionType() ? this.getAdapterSelectionType() : this.manualSelection),
			executionRecordId:this.suite.id,
			executionRecordType: this.suite.executionRecordType,
			projectAreaItemId: getCurrentPA().itemId,
			executionElementsJsonString: dojo.toJson(itemList) 
		}
			
		return [attr];
	},
	
	getAdapterSelectionType: function(){
		return this.adapterSelectionType;
	},
	
	setAdatperSelectionType: function(type){
		this.adapterSelectionType = type;
	},
	
    onActivated: function(){
        if(this.tableViewer)
            this.tableViewer.refresh();
    },

	onChange: function(){
		this.mySection.setDirty(true);
	},
	
	_error: function(errorObj){
		console.error("Error: (message: '" + errorObj.message + "') from SequenceTestRecordDetails#_error");
	}
});

})();
