/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer					= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
dojo.declare(
   "com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_testrtExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-TestRTExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
   	initialize: function(){   
		if (!dojo.getObject("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecution")){
			jazz.core.loader.load_async("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecution", dojo.hitch(this,"_initialize2"));
		}else{
			this._initialize2();
		}
	},
	_initialize2:function(){   
	var script = this.script;
		var scriptInfo = {
			itemId: script.versionableItemId  ? script.versionableItemId : script.itemId,
			type: script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
		if (script != null) {
		  if(script.properties)
		  {
		  	var len = script.properties.length;
			for(var i=0;i<len; i++)
			{
				var property =script.properties[i];
				if(property.propertyName === "testRtScriptPath")
					scriptInfo.testrtScriptPath = property.propertyValue;
				if(property.propertyName === "testNodeName")
					scriptInfo.testNodeName = property.propertyValue;
			}
		  }
		}         
        this.scriptInfo = scriptInfo;
		dojox.data.dom.removeChildren(this._testrtExecutionSection);
		this._testrtWidget = new com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecution({
								parentController: this.parentController,
								ewiItemId: this.ewiItemId,
								scriptInfo: scriptInfo,
								parentSection: this
							});
		this._testrtExecutionSection.appendChild(this._testrtWidget.domNode);
		this.inherited("initialize", arguments);	
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
	  return "rqm_testrt_test.html";
	}, 

	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._testrtWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
});

})();