//TSTCS
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteTestCasesSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){ // module container
	var ServiceResponseHandler 				    = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var AbstractArtifactEditorSection 			= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
    var ExecutionWorkItemClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
	var TestSuiteTestCasesTableView				= com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView;
	var getCurrentProjectArea					= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var TestCaseClient   			   			= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var TestCaseConfigSelector					= com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector;
	var Constants    							= com.ibm.rqm.planning.web.client.internal.Constants;
	var EditorUtil 								= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var TestCaseMapper							= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
	var ExecutionPopUp							= com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp;	
	var SelectItemTableDialog   				= com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog;
	var ViewHeaderLayout 						= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var YesNoDialog 							= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
			
    dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteTestCasesSection", 
				[dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {

        templateString: "<div class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-EWISection\">"+
							"<div dojoAttachPoint=\"_ewiSection\" ></div><div dojoAttachPoint=\"_ewiSelectionDialog\"></div>"+
						"</div>",
        
		isSerialExecution: true,
		_initialized: false,
		
        constructor: function(args){
        },
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
        },
        
		//@Overriden from AbstractArtifactEditorSection
        initialize: function(isEsitable) {
			EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)		
            dojox.data.dom.removeChildren(this._ewiSection);
			this._suite = this.getArtifact();
			this.ewis = [];
			var _suite = this._suite;
			//sort based on indexes
			if(_suite  && _suite.elements)
			{
				var eleLen = _suite.elements.length;
				var elements = _suite.elements;
				for(var i=0; i <eleLen;i++)	{
					for(var j=i + 1; j <eleLen;j++){
						if(elements[i].index > elements[j].index){
							var tempElement = elements[i];
							elements[i] = elements[j];
							elements[j] = tempElement;
						}
					}	
				}
				var ewis = [];
				for(var i=0;i<eleLen;i++){
					var element = elements[i];
					if(element.script){
						element.workitem.defaultScript = element.script;
					}
					var ewi = element.workitem;
					ewi.rowId = element.index;
					ewi.defaultScript = element.script;
					ewi.config = {'id': ewi.configuration, 'name': element.ewiConfigurationName };   
					ewis.push(ewi);
				}
				this.ewis = ewis;
				this._suite = _suite;
			}
			if(this._suite){
				this.isSerialExecution = this._suite.sequentialExecution;
			}
			this._showEWITable(this.ewis,Constants.getMessage("labelTestCases"));
			this._initialized = true;
            this.defaultConfigId = null;
        },
		
		isInitialized: function(){
			return this._initialized;
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getHelpContextID: function(){
            return "rqm_ewis.html";
        },
		
		getAttributes: function(){
			if(!this._initialized)
				return null;
			var content = this.ewis ? this.ewis : [];
			var values = [];
			var contentLength = content.length;
			for(var i=0;i<contentLength;i++){
				if(content[i]){
					var con = content[i];
					var element = {index: i, workItemid: con.id};
					 if(con.defaultScript){
					 	element.testScriptId = con.defaultScript.versionableItemId;
					 }else if(con.testCase && con.testCase.scripts && con.testCase.scripts.length > 0){
						//Save information as shown in the editor, if default script for ewi is not present
						//the first script in the test case is shown.
						element.testScriptId = con.testCase.scripts[0].versionableItemId;
					}
					values.push(element);	
				}
			}
			var returnArgs = {
				suiteElementsJsonString: dojo.toJson(values)
			};
			if(this._ewiTableViewer){
				returnArgs.isSerialExecution = !this._ewiTableViewer.getSerialExecutionState();//Checkbox is for parallel wi6856
			}
			return returnArgs;
		},
		
		validate: function(){
			return true;
		},
		
		_showEWITable: function(ewis, name) {
			this.ewis = ewis ? ewis : [];
			//lazy load config info
			ewis = ewis ? ewis : [];
			var ewisLength = ewis.length;
			for (var i = 0; i < ewisLength; i++) {
		        var ewi = ewis[i];
				var scripts = ewi.testCase.scripts;
				if(scripts){
					var defaultScriptFound = false;
					var len=scripts.length;
					for(var j=0;j<len;j++){
						if(scripts[j].archived){
							if(ewi.defaultScript && ewi.defaultScript.versionableItemId == scripts[j].versionableItemId)
								ewi.defaultScript = null;
							scripts.splice(j,1);
							j-=1;
							len-=1;
						}else if(ewi.defaultScript && ewi.defaultScript.versionableItemId == scripts[j].versionableItemId){
							defaultScriptFound = true;
						}
					}
					if(!defaultScriptFound)
						ewi.defaultScript = null;
				}
		    }
			//initially show ewis without config info (lazy loaded)
			var args = {
				executionWorkItems: this.ewis,				
				executable: true,
		        queryName: name ? name : this.queryTitle,
		        actions: this.getTableActions(),
				isSerialExecution: this.isSerialExecution,
				setParentSectionDirty: dojo.hitch(this, "setDirty") 
			};
		    if (this.isEditorSection) {
		        args.showTestCase = this.showTestCase;
		        args.queryName = null;
		        args.editable = this.editable;               
		    }
            
            this.unloadContent(this._ewiSection);
            
		    this._ewiTableViewer = new TestSuiteTestCasesTableView(args);
			
		    //display the table
			this._ewiSection.appendChild(this._ewiTableViewer.domNode);	
		},
		_createCatalog: function(ewi){	
		   this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         //initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig(ewi);
					},
					failure: function(e){
						self._error(e);
					}
				};
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
		
			} else {
				this._setConfig(ewi);
			}
		},
		
		_setConfig: function(ewi){
			this._ewiTableViewer.addConfigurationInfo(ewi.rowId, this.configuration);
		},
		
        getTableActions: function(){
            var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            var canEdit = (!perm || perm.edit);
            var actions = [];
            
            if (canEdit) {
                actions.push({
                    actionId: "addtestcase",
                    label: Constants.getMessage("labelAddExistingTestCases"),
                    actionHandler: dojo.hitch(this, "_handleAddTestCase"),
                    iconClass: "add-icon-image",
                    disabledOnReadOnly: true
                });
            }

            var ewi_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_EWI_EXE;
            var ewi_exe_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type);
            
            if (!ewi_exe_perm || ewi_exe_perm.execute) {
                actions.push({
                    actionId: "execute",
                    label: Constants.getMessage("labelExeTest"),
                    actionHandler: dojo.hitch(this, "_handleExecute"),
                    iconClass: "execute-icon-image",
                    disabledOnReadOnly: false
                });
            }
            
            if (canEdit) {
                actions.push({
                    actionId: "edit",
                    label: Constants.getMessage("labelChangeExecProps"),
                    actionHandler: dojo.hitch(this, "_handleEdit"),
                    iconClass: "change-exec-props-image",
                    disabledOnReadOnly: true
                });
                
                actions.push({
                    actionId: "changescript",
                    label: Constants.getMessage("labelEditDefaultScript"),
                    actionHandler: dojo.hitch(this, "_handleEditScript"),
                    iconClass: "edit-icon-image",
                    disabledOnReadOnly: true
                });
                actions.push({
                    actionId: "save",
                    label: Constants.getMessage("labelSave"),
                    actionHandler: dojo.hitch(this, "_handleSave"),
                    iconClass: "save-icon-image",
                    disabledOnReadOnly: true,
                    hidden: true
                });
                actions.push({
                    actionId: "moveup",
                    label: Constants.getMessage("labelMoveUp"),
                    actionHandler: dojo.hitch(this, "_handleMoveUp"),
                    iconClass: "move-up-image",
                    disabledOnReadOnly: true,
                    disabled: true
                });
                actions.push({
                    actionId: "movedown",
                    label: Constants.getMessage("labelMoveDown"),
                    actionHandler: dojo.hitch(this, "_handleMoveDown"),
                    iconClass: "move-down-image",
                    disabledOnReadOnly: true,
                    disabled: true
                });
                actions.push({
                    actionId: "remove",
                    label: Constants.getMessage("labelRemoveTestCases"),
                    actionHandler: dojo.hitch(this, "_handleRemoveTestCase"),
                    iconClass: "delete-icon-image",
                    disabledOnReadOnly: true
                });
            }
            return actions;
        },
        
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
			this._suite = this.getArtifact();
			if(this._ewiTableViewer){
				this._ewiTableViewer.refresh(this.ewis, this._startEditOnSave ? false : true);
				if(this._startEditOnSave){
					var len = this._startEditOnSave.length;
					for(var i=0;i<len;i++){
						this._ewiTableViewer.setRowChecked(this.ewis[this._startEditOnSave[i]],true);
					}
					this._startEditOnSave = null;
					this._ewiTableViewer.toggleSelectScript(true);
				}
			}
            this.inherited('saveFinished', arguments);
        },
        
        update: function(){
            this.initialize();
        },

        refreshContents: function(){
            if(this._ewiTableViewer && this._ewiTableViewer.tableViewer) {
                this._ewiTableViewer.tableViewer.refresh();
            }
        },
        
		/*
		 * Action Handlers for the table
		 */

		_handleAddTestCase: function(){
			 var params = {
                title: Constants.getMessage("labelAddItems", Constants.TYPE_CASE),
                showQueryFilters: true,
                exclusionList: [],
                itemType: Constants.TYPE_CASE,
				tableId:"RQM-SUITE-TC-SELECT-TABLEVIWER",
                onOk: dojo.hitch(this, "_updateTable"),                    
                onAddNew: function() {
                    alert(Constants.getMessage("labelNotSupported"));
                }
            };
            // Always constraints the list of TCs that belongs to the parent
            // test plan, if a test plan is set for the test suite.
            var parentTP = this.getParentEditor().getTestPlanVersionableItemId() || null;
            if (parentTP) {
				params.parentItemIdArgName = "constrainParentVTestPlan";
				params.parentVersionItemId = parentTP;
			}else {
				params.parentItemIdArgName = "constrainParentVTestPlan";
				params.parentVersionItemId = null;
			}            
            var itemListWidget = new SelectItemTableDialog(params);
			//disable snapshots
			itemListWidget._enableSnapshots = false;
            itemListWidget.show();
		},
	
		_cancelClicked: function(){
			
		},
		
		_updateTable: function(addedItems){
			var items = [];
			var addedItemsLength=addedItems.length;
			for (var j = 0; j < addedItemsLength; j++) {
				var testCase = addedItems[j];//TestCaseMapper.map(addedItems[j]); // converts the summaryDTO to fullDTO
				var item = {
					isNew: true,
					testCase: testCase,
					config: null
				};
				var testPlan = this.getParentEditor().getTestPlan();
				if(testPlan){
					item.testPlan = {};
					item.testPlan.name = testPlan.testPlanName;
					item.testPlan.id = testPlan.testPlanId;
					item.testPlan.versionableItemId = testPlan.testPlanVersionableItemId;
				}
				items.push(item);
			}
			if (items.length > 0) {
				this.setDirty(true);
				this._ewiTableViewer.appendItem(items);
			}
		},
		
		_handleExecute: function(){
			if (this._suite){
				var selectedItems = this._ewiTableViewer.getSelectedItems();
				if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
					var alertString = "";
					var badTestCaseString = "";
					if(!selectedItems || selectedItems.length == 0){
						alertString = "Select a test case to run.";
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, alertString);
						return;
					}
					else if(selectedItems.length > 1){
						alertString = "Select only one test case to run.";
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, alertString);
						return;
					}
					else if(selectedItems[0].testCase.state != Constants.STATETRANSITION_STATE_APPROVED){
						badTestCaseString += " " + selectedItems[0].testCase.name;		
					}
					if (badTestCaseString != ""){ //Found an offending test case so display a message and return
						var errorStr = Constants.getMessage("msgCannotExecuteTestCaseNotApproved", badTestCaseString);
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, errorStr);
						else
							alert(errorStr);
						return;
					}
				}
			 	var execPopUp = new ExecutionPopUp();
				var args = {
					testCase: selectedItems[0].testCase,
					defaultScript:selectedItems[0].defaultScript
				};
				execPopUp.initialize(args);
			}
		},
		_handleEdit: function(){
			var selectedTestCases = this._ewiTableViewer.getSelectedItems();
			if(!selectedTestCases || selectedTestCases.length == 0){
				return;
			}
			this.selectedItem = selectedTestCases;
			var responseHandler= new ServiceResponseHandler(this, "_setEditConfigurations", "_error");
			var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
			cfg.getAllMinimal(responseHandler);
		},
		_handleEditScript: function(){
			if(this._ewiTableViewer.scriptsEditing){
				this.editingScriptInProgress = false;
				this._ewiTableViewer.toggleSelectScript(true);
				var content = this._ewiTableViewer.getTableContent();
				var len2=this.currentSelectedItems.length;
				var len=content.length;
				for(var count=0;count<len;count++){
					for (var i=0;i<len2;i++){
						if(content[count].rowId == this.currentSelectedItems[i].rowId){
							content[count] = this.currentSelectedItems[i];
						}
					}
				}
				this._ewiTableViewer.refresh(content);
				this.currentSelectedItems = [];
				return;
			}
			var selectedItems = this._ewiTableViewer.getSelectedItems(); 
			this.currentSelectedItems = dojo.clone(selectedItems);//Keep a backup for discard changes action
			var selectedIds = [];
			var foundNewItem = false;
			var selectedItemsLength=selectedItems.length;
			for(var i=0;i<selectedItemsLength;i++){
				if(selectedItems[i].isNew == true){
					foundNewItem = true;
				}
				selectedIds.push(parseInt(selectedItems[i].rowId,10));
			}
			
			if(!foundNewItem){
				this._ewiTableViewer.toggleSelectScript(true);
				this.editingScriptInProgress = true;
				this.setDirty(true);
			}	
			else
				this._askToSave(selectedIds);
		},
		
		_handleSave: function(){
			if(this._ewiTableViewer.scriptsEditing)
				this._ewiTableViewer.toggleSelectScript();
			this._ewiTableViewer.refresh(this.ewis, true);
			this.setDirty(true);
			this.editingScriptInProgress = false;
		},
		
		_setEditConfigurations: function(response){
			this.configs = [];
			this.configs.push({name: Constants.getMessage("labelUnassigned"), id: null, stateId: null, configuration: null});
			
			if (response) {
				var responseLength=response.length;
				for(var i=0; i < responseLength; i++){
					this.configs.push(response[i]);
				}
			}

			var args = {
				okCallback: dojo.hitch(this, this._editOkClicked),
				cancelCallback: dojo.hitch(this, this._cancelClicked),
				versionableTestPlanItemId: this.getParentEditor().getTestPlanVersionableItemId()
			};
			this._testCaseSelector = new TestCaseConfigSelector(args);
			var testcases = [];
			var selectedItemLength=this.selectedItem.length;
			for(var i=0;i<selectedItemLength;i++){
				testcases.push(this.selectedItem[i].testCase);
			}
			this._testCaseSelector.initialize({testCases: testcases, configs: this.configs, selectedItem: this.selectedItem[0].testCase});
		},
		
		_editOkClicked: function(args){
			var selectedItem = this.selectedItem;
			var selectedItemLength = selectedItem.length;
			for (var j = 0; j < selectedItemLength; j++) {
				selectedItem[j].isNew = true;
				var changed = false;
				if(args.selectedConfig && args.selectedConfig[0]){

					// Check if the "Unassigned" Configuration is selected
					if (args.selectedConfig[0].name == Constants.getMessage("labelUnassigned") 
							&& (args.selectedConfig[0].id == "null") || (args.selectedConfig[0].id == null))
					{
						selectedItem[j].config = null;
						selectedItem[j].configuration = null;
					}
					else 
					{
						selectedItem[j].config = args.selectedConfig[0];
						selectedItem[j].configuration = args.selectedConfig[0].id;
					}
					changed = true;
				}	
				if(args.testPlanId){
					selectedItem[j].testPlan = {}
					selectedItem[j].testPlan.name = args.testPlanName;
					selectedItem[j].testPlan.id = args.testPlanId;
					selectedItem[j].testPlan.versionableItemId = args.testPlanVersionableItemId;
					changed = true;
					if(args.testPhaseItemId){
						selectedItem[j].testPhase = {};
						selectedItem[j].testPhase.name = args.testPhaseName;
						selectedItem[j].testPhase.itemId = args.testPhaseItemId;
					}
				}else{
					if(selectedItem[j].testPlan)
						changed = true;
					selectedItem[j].testPlan = null;
				}
				if(changed)
					selectedItem[j].id = null;//To make this as New
			}
			this.selectedItem = selectedItem;
			this.setDirty(true);
			this._ewiTableViewer.refresh();
		},
		
		_handleRemoveTestCase: function(){
			if(this._ewiTableViewer){
				var selectedItems = this._ewiTableViewer.getSelectedItems();
				var content = this._ewiTableViewer.getTableContent();
				if(selectedItems.length == 0){
					return;
				}
				var selectedItemsLength = selectedItems.length;
				for(var i=0;i<selectedItemsLength;i++){
					var updatedContent = [];
					var contentLength = content.length;
					for(var j=0;j<contentLength;j++){
						if(content[j].rowId == selectedItems[i].rowId){
							continue;
						}
						updatedContent.push(content[j]);
					}
					content = updatedContent;//swap updated content so that less traversal is needed.
				}
				this.setDirty(true);
				this._ewiTableViewer.refresh(content,true);
				if(content.length ==0)
					this._ewiTableViewer.disableAllActions();
				this.ewis = content;
			}
		},
		_handleMoveUp:function(){
			var selectedItems = this._ewiTableViewer.getSelectedItems();
			var content = this._ewiTableViewer.getTableContent();
			var selectedItemsLength = selectedItems.length;
			for(var i=0;i<selectedItemsLength;i++){
				var rowId = parseInt(selectedItems[i].rowId,10);
				if (rowId != 0) {
					var rowToSwap = dojo.clone(content[rowId - 1]);
					content[rowId - 1] = content[rowId];
					content[rowId - 1].rowId = rowId -1;
					content[rowId] = rowToSwap;
					content[rowId].rowId = rowId;
					this._ewiTableViewer.setRowChecked(content[rowId-1],true);
					this._ewiTableViewer.setRowChecked(content[rowId],false);
				} 
			}
			this.setDirty(true);
			this._ewiTableViewer.refresh();
			this.ewis = content;
		},
		_handleMoveDown:function(){
			var selectedItems = this._ewiTableViewer.getSelectedItems();
			var content = this._ewiTableViewer.getTableContent();
			var selectedItemsLength = selectedItems.length;
			for(var i=selectedItemsLength;i>0;i--){
				var rowId = parseInt(selectedItems[i-1].rowId,10); 
				if (rowId != content.length-1) {
					var rowToSwap = dojo.clone(content[rowId + 1]);
					content[rowId + 1] = content[rowId];
					content[rowId + 1].rowId = rowId + 1;
					content[rowId] = rowToSwap;
					content[rowId].rowId = rowId;
					this._ewiTableViewer.setRowChecked(content[rowId+1],true);
					this._ewiTableViewer.setRowChecked(content[rowId],false);
				}
			}
			this.setDirty(true);
			this._ewiTableViewer.refresh();
			this.ewis = content;
		},
		preProcess: function(){
			if(this._ewiTableViewer){
				if(this.editingScriptInProgress){
					this._handleSave();
				}
				var content = this._ewiTableViewer.getTableContent();
				var items = [];
				var contentLength = content.length;
				for(var i=0;i<contentLength;i++){
					if(content[i].isNew || content[i].archived){
						content[i].isNew = true;
						items.push(content[i]);
					}
				}
				this.totalCount = items.length;
				this.saveCompleteCount = 0;
				this.saveErrorCount = 0;
				if(this.totalCount == 0){
					this.parentEditor.markSectionComplete(this.getSection().id, true);
				}else{
					//create/update EWI here
					var itemsLength = items.length;
					for(var i=0;i<itemsLength;i++){
						var testCase = items[i].testCase.versionableItemId;
						var owner = EditorUtil.getCurrentContributor().userId;
						var name = items[i].testCase.name;
						if(items[i].config && items[i].config.name && (items[i].config.name != Constants.getMessage("labelUnassigned"))){
							name=name + "_" + items[i].config.name;
						}
						var params = {};
						params ={
								owner: owner,
								name: name,
								testCase: testCase
							};
						if(items[i].config)
							params.testConfig = items[i].config.id;
						
						if (!items[i].id || items[i].archived){ 
							params.newExecutionWorkItem = true;
						}else {
							params.id = items[i].id;
							params.ewiStateId = items[i].stateId;
						}
						if(items[i].testPlan && items[i].testPlan.versionableItemId){
							params.testPlanItemId = items[i].testPlan.versionableItemId;
							if(items[i].testPhase && items[i].testPhase.itemId)
								params.testPhase = items[i].testPhase.itemId;
						}
						var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_saveError");
						ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, params);
					}
				}
			}else{
				this.parentEditor.markSectionComplete(this.getSection().id, true);
			}
		},

		_saveSuccess: function(ewi){
			var scripts = ewi.testCase.scripts;
			if(scripts){
				var defaultScriptFound = false;
				var len=scripts.length;
				for(var j=0;j<len;j++){
					if(scripts[j].archived){
						if(ewi.defaultScript && ewi.defaultScript.versionableItemId == scripts[j].versionableItemId)
							ewi.defaultScript = null;
						ewi.testCase.scripts.splice(j,1);
						j-=1;
						len-=1;
					}else if(ewi.defaultScript && ewi.defaultScript.versionableItemId == scripts[j].versionableItemId){
						defaultScriptFound = true;
					}
				}
				if(!defaultScriptFound)
					ewi.defaultScript = null;
			}
			this._appendItemsInTable(ewi);
			this.saveCompleteCount++;
			this._saveComplete();
		},
		
		_appendItemsInTable: function(ewi){
			if (this._ewiTableViewer) {
				this._ewiTableViewer.updateItem(ewi);
				this.ewis = this._ewiTableViewer.getTableContent();
			}
		},
		
		_saveError: function(errorObj){
			console.error("save error in TSTCSection");
			this.saveErrorCount++;
			this._saveComplete();
		},
		
		_saveComplete: function(){
			if(this.totalCount == (this.saveCompleteCount+this.saveErrorCount)){
				this.parentEditor.markSectionComplete(this.getSection().id, true);
			}
		},
		
		_askToSave:function(selectedIds){
			var self = this;
			var args = {
				message: Constants.getMessage("msgSaveRequiredToChange", Constants.TYPE_SUITE, Constants.getMessage("labelDefaultTS")),
				yesCallback: function(){
					self._startEditOnSave = selectedIds;
            		self.getParentEditor().onSave();    
					return true;          
				},
				noCallback: function() {
					return;
				}
			}
			var dialog = new YesNoDialog(args);
       	 	dialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			dialog.open();
		},
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from TestSuiteTestCasesSection#_error");
		}
		
        
    });
    
})();
