/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.extension.TimeboxSection");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.extension.TimeboxSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");

dojo.require("com.ibm.rqm.process.web.ui.internal.view.timebox.MainTimebox");


(function(){ // module container
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.extension.TimeboxSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: "<div dojoAttachPoint=\"_timeboxSection\"></div>",
        
        constructor: function(args) {},
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
			this.addWorkItemSupport();
        },
		
        //@Overriden from AbstractArtifactEditorSection - invoked on first expand
        initialize: function(isEditable){
            var self = this;
            var args = {
                itemId: self.getParentEditor().getVersionableItemId(),
                parentController: self,
				isEditable: isEditable,
				parentSection: self
            }
            this._widget = new com.ibm.rqm.process.web.ui.internal.view.timebox.MainTimebox();
            this._widget.initialize(args);
            dojox.data.dom.removeChildren(this._timeboxSection);
            this._timeboxSection.appendChild(this._widget.domNode);
        },
        
		//@Overriden from AbstractArtifactEditorSection
		//Summary: provide section level validation; this is a hack since any section
        //requiring validation should be using the global save's validation mechanism 
        //@Deprecated: WILL BE REMOVED IN M7B - See RQM WI 2562
        //@Abstract: Override to provide section level validation
        validate: function(){
			var validate = true;
			//check TimeBox table
			if (this._widget && this._widget.getTimeboxWidget()) {
				var tableView = this._widget.getTimeboxWidget();
				validate = tableView.validate();
				if (!validate.value) {
					this.getParentEditor().setHeaderStatus(validate.msg, Constants.HEADER_STATUS_ERROR, validate.msg);
					return false;
				}
			}
			//check Keydate table	
			if (this._widget && this._widget.getKeydateWidget()) {
				var tableView = this._widget.getKeydateWidget();
				validate = tableView.validate();
				if (!validate.value) {
					this.getParentEditor().setHeaderStatus(validate.msg, Constants.HEADER_STATUS_ERROR, validate.msg);
					return false;
				}
			}
            return true;
        },
		
		//@Overriden from AbstractArtifactEditorSection
		setVisible: function(isVisible) {
			this.inherited('setVisible', arguments);
			if(!isVisible && this._widget && this._widget.getTimeboxWidget()) {
				//if the section is removed, then remove all its save participant
				var tableView = this._widget.getTimeboxWidget();
				tableView.removeAllSaveParticipant();
			}
			if(!isVisible && this._widget && this._widget.getKeydateWidget()) {
				//if the section is removed, then remove all its save participant
				var tableView = this._widget.getKeydateWidget();
				tableView.removeAllSaveParticipant();
			}
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getSummaryContent: function(isEditable) {
            return Constants.PROCESS_SUMMARY_INFO_TIME_BOX;
        },
				
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
			this.addWorkItemSupport();
            var artifact = this.getArtifact();
			if (!this._widget) {
				return;
			}
            this._widget._itemId = artifact.versionableItemId;
			this._widget.followupSaveOperation();
			
        }

    });
    
})();
