//debug keywordlist
/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList");
dojo.provide("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.keyword.TagCloud");

(function() {
var DuplicateAction 		= com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var ActionEntityType 		= com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var NewKeywordPopup 		= com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup;
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var KeywordClient 			= com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient;
var SelectItemTableDialog   = com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var RelatedInfoPanel=com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;
/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ProgressUtility = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList", 
    [dijit._Widget, dijit._Templated,com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoAttachPoint="viewHeaderNode"></div>' +
                    '  <div dojoAttachPoint="viewHeaderContainerNode">' +
                    '    <img dojoAttachPoint="statusSuccessNode" class="view-status-icon"></img>' +
                    '    <span dojoAttachPoint="statusLineNode" tabIndex="0" class="view-status-value">&nbsp;</span>' +
                    '  </div>' +
                    '  <div dojoAttachPoint="keywordTableNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '</div>',

    constructor: function() {
	 	this.keywords = [];
	 },
	//override RelatedInfoMixin methods
	getStaticRelatedInfo: function() {
		// This method is called only if this is a top level view in a tab and is selected.
		// It will not contribute to the related info area if it is embedded in a dialog or editor section.
		//
		if (!this._relatedInfo) {
			this._relatedInfo = new RelatedInfoPanel();			
		}
        return this._relatedInfo;
    },
	        
    getStaticRelatedInfoId: function() {
        return "com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList";
    },
    postCreate: function(){
        var headerArg = {
            isCompact: true,
			noline:true,
			title: Constants.getMessage("labelAllKeywords"),
            contextHelpId: "rqm_all_keywords.html"
        };
		this.viewHeader = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout(headerArg);
		this.viewHeader.setCSHelpButtonLabel(Constants.getMessage("labelKeywordsHelp"));
		this.viewHeaderNode.appendChild( this.viewHeader.domNode );
		this.viewHeaderContainerNode.style.cssFloat = "right";
		this.viewHeaderContainerNode.style.margin = "-20px 10px 10px";
		this.statusSuccessNode.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/view/layout/images/success_obj.gif");
		this.clearStatus();		
		jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient",function(){});
		this._initialize();
	},

	uninitialize: function(){
		if (this._relatedInfo){
			this._relatedInfo.destroy();
		}
	},
		
	_initialize:function(){
        if (!this.keywordTable) {
            var tableArgs = {
                postInit: dojo.hitch(this, "_setupActions"),
                // initialize options for the view builder
                _searchFunction: dojo.hitch(KeywordClient, "searchKeywords"),
                _searchCallback:dojo.hitch(this, "_showTable"),
				parentView:this
            };
            this.keywordTable = new com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView(tableArgs);
            this.viewHeader.containerNode.appendChild(this.keywordTable.domNode);
            
            // whenever the keyword table is refreshed, clear our status line.
            if (this.keywordTable.refresh) {
                this.connect(this.keywordTable, "refresh", function(){
                    this.viewHeader.clearStatus();
                })
            }
        } else {
            this.keywordTable.initRunQuery();
        }
	},
    
    _setupActions: function() {
        var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_KEYWORD);        
            if (!permission || permission[PermissionsClient.ACTION_CREATE]) {
                this.keywordTable.addAction("create", Constants.getMessage("labelCreateKeyword"), null, "create-keyword-image", dojo.hitch(this, "onCreate"));
                this.keywordTable.addAction("duplicate", Constants.getMessage("labelDuplicateAction"), null, "duplicate-icon-image", 
											dojo.hitch(this.keywordTable, "invokeAction", "id", this, "onDuplicate"));
				this.keywordTable.setupDuplicateAllowed();											
            }
            if (!permission || permission[PermissionsClient.ACTION_EDIT]) {
                this.keywordTable.addAction("associate", Constants.getMessage("labelAssociateScripts"), this, "associate-keyword-image", dojo.hitch(this, "onAssociate"));
                this.keywordTable.addAction("edit", Constants.getMessage("labelEditKeywords"), this, "edit-keyword-image", dojo.hitch(this, "onEdit"));
                this.keywordTable.addAction("save", Constants.getMessage("labelSaveKeywords"), this, "save-keyword-image", dojo.hitch(this, "onSave"));
            }
            if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
                this.keywordTable.addAction("archive", Constants.getMessage("labelDeleteKeywords"), this, "delete-icon-image", dojo.hitch(this.keywordTable, "invokeAction", "id", this, "onArchive"));
            }
            this.keywordTable.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, "refresh"));
	},
    
    _showTable:function(keywords){
		this.keywords = [];
		if(keywords && keywords.length > 0){
			var len = keywords.length;
			for(var i=0;i<len;i++){
				if(keywords[i].archived)
					continue;
				this.keywords.push({
					id:keywords[i].id,
					name:keywords[i].name,
					defaultScript:keywords[i].defaultScript ? keywords[i].defaultScript:keywords[i].manualScript ,
					tags:keywords[i].tags,
					modified:keywords[i].modified,
					executionScripts:keywords[i].executionScripts,
					manualScript:keywords[i].manualScript,
					stateId:keywords[i].stateId
				});
			}
		}

        this.keywordTable.showKeywords(this.keywords);
		this.keywordTable.disableAction("save");
		this.keywordTable.disableAction("edit");
		this.keywordTable.disableAction("associate");
		this.keywordTable.disableAction("archive");
		this.tagCloud = new com.ibm.rqm.keyword.web.ui.internal.view.keyword.TagCloud({tagList:this.keywordTable.tagList,viewer:this.keywordTable});
		if(this._relatedInfo){
			var group = this._relatedInfo.getInfoGroup(Constants.getMessage("labelTags"), true);
			this._tagArea = group.getActionsNode();
			dojox.data.dom.removeChildren(this._tagArea);
			this._tagArea.appendChild(this.tagCloud.domNode);
		}
	},
	
	onDuplicate: function(ids) {
		var duplicateAction = new  DuplicateAction();
		duplicateAction.setType(ActionEntityType.KEYWORD);
		duplicateAction.execute(ids, dojo.hitch(this, "_duplicateEnd"), dojo.hitch(this, "_duplicateError"));		
	},
		
	_duplicateError: function(e){
		alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));
	},
	
	_duplicateEnd: function(){
		this.keywordTable._invalidateQuery();
	},
	
	onCreate:function(){
		var tagList = this.keywordTable.getTagList();
		var args = {
            itemType: Constants.MODEL_TYPE_KEYWORD,
            onOkCallback: dojo.hitch(this, "_handleAddNewItem"),
			tagList:tagList
        }
        this._newKeywordDialog = new NewKeywordPopup(args);
	},
	onAssociate:function(){
		var selectedKeyword = this.keywordTable.getSelectedRows();
		if(selectedKeyword && selectedKeyword.length > 0 ){
			var responseHandler = new ServiceResponseHandler(this, "_showRemoteScripts", "_error");	
			var scriptObj = {
				includeArchived:false
			};
			com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient.getExecutionScripts(
						responseHandler, scriptObj);
		}
	},
	
	onArchive:function(selectedIds){
		var len = selectedIds.length;
		if(len > 0 ){           
            var messagespan = document.createElement("label");
            messagespan.innerHTML = Constants.getMessage("msgArchiveKeyword",len);
            var yesNoDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog({
				primaryTitle:Constants.getMessage("labelDeleteKeywords"),
                yesCallback:dojo.hitch(this,"_archiveKeyword"),
                yesCallbackData:selectedIds,
				isClosable: true
            });
            yesNoDialog.contentContainer.appendChild(messagespan);
            yesNoDialog.open();			
		}		
	},
	
	_archiveKeyword:function(selectedIds){
		this.toBeArchived = selectedIds;
        this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("labelDeleteKeywords"), 0, null); 
		this._postArchiveKeyword(this);
	},
	_postArchiveKeyword:function(kwSelf){
		if(kwSelf.toBeArchived && kwSelf.toBeArchived.length>0){
			var keywordId = kwSelf.toBeArchived[0];
			kwSelf.toBeArchived.splice(0,1);
			var handler = {
				kwSelf:kwSelf,
	            success: function() {
					if(kwSelf.toBeArchived.length >0){
						kwSelf._postArchiveKeyword(this.kwSelf);
					}else{
                        ProgressUtility.endTaskMonitor(kwSelf.monitorId);
						kwSelf.keywordTable._invalidateQuery();
						kwSelf.clearStatus();
					}
	            },
	            error: function(e) {
                    ProgressUtility.endTaskMonitor(kwSelf.monitorId, e.message);
	            }
	        };
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var scriptObj = {
				id: keywordId,
				stateId: keywordId,  // not used
				archive:true
			};
			KeywordClient.postArchiveKeyword(responseHandler, scriptObj);
		}
	},
    onEdit:function(){
		if(!this.keywordTable.getTableStateForEditing()){
			this.keywordTable.setTableStateForEditing();
		}else{ //discard changes
			this.keywordTable.changedKeywords=[];
			this.keywordTable.unsetTableStateForEditing();
			this.keywordTable.refresh(this.keywords);
			this.clearStatus();
		}
	}, 
	onSave:function(){
		this.keywordTable.unsetTableStateForEditing();
		var changedKeywords = this.keywordTable.getChangedKeywords();
		if(changedKeywords.length>0){
			this.lastChangedKeyword = changedKeywords[changedKeywords.length-1].id;
			var len = changedKeywords.length;
			for(var i=0;i<len;i++)
				this._updateKeywords(changedKeywords[i]);
		}
	},
	_updateKeywords:function(changedKeyword){
		var self = this;
    	var handler = {
        	success: function(keyword) {
            	self._updateKeywordList(keyword);
				if(self.lastChangedKeyword == keyword.id){
					self.keywordTable.refresh(self.keywords);
					self.clearStatus();
				}
        	},
        	error: function(e) {
            	self._postError(e);
        	}
        }		
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
		var keywordObj = {
			id:changedKeyword.id,
			name:changedKeyword.name,
			tags:changedKeyword.tags,
			defaultScript:changedKeyword.defaultScript.versionableItemId ? 
					changedKeyword.defaultScript.versionableItemId:changedKeyword.defaultScript.itemId,
			stateId:changedKeyword.stateId
		};
		KeywordClient.postKeywordDTO(responseHandler, keywordObj);
	},
	_handleAddNewItem:function(){
		var newItem = this._newKeywordDialog.getItemForDisplay();
		if(newItem.selectedScriptItemId){
			this._createKeyword({itemId:newItem.selectedScriptItemId}, newItem);
			return;
		}
		var self = this;
        var handler = {
            success: function(testScript) {
                self._createKeyword(testScript, newItem);
            },
            error: function(e) {
                self._error(e);
            }
        }
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
		var scriptObj = {
			name: newItem.name,
			type: "Manual",
			description: Constants.getMessage("labelKeywordDesc"),
			newScript: true,
			state:Constants.STATETRANSITION_STATE_DRAFT
		};
		TestScriptClient.saveTestScript(responseHandler, scriptObj);
	},

	_createKeyword:function(testScript,newItem){
		var responseHandler = new ServiceResponseHandler(this, "_createFinished", "_postError");	
		var keywordObj = {
			newKeyword:true,
			name: newItem.name,
			tags: newItem.tags,
			manualScript:testScript.versionableItemId  ? testScript.versionableItemId: testScript.itemId,
			defaultScript:testScript.versionableItemId ? testScript.versionableItemId: testScript.itemId
		};
		KeywordClient.postKeywordDTO(responseHandler, keywordObj);
	},

	_createFinished:function(keyword){
		this.clearStatus();
        this._selfCreate = true;
		dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_KEYWORD, [keyword]]);
	},
	_showRemoteScripts:function(scripts){
        var params = {
            title: Constants.getMessage("labelAssociateScripts"),
            parentElement: this.domNode,
            exclusionList: [],                    
            itemType: Constants.TYPE_SCRIPT + " Automated",               
            onOk: dojo.hitch(this, "_handleAddedItems")
        };
        var itemListWidget = new SelectItemTableDialog(params);
        itemListWidget.setExclusionList([]);
		itemListWidget._list.setTableRowsCheckable(true,true);
		itemListWidget.show(scripts);
	},
	_handleAddedItems:function(addedItems){
		var selectedKeyword = this.keywordTable.getSelectedRows();
		if(selectedKeyword && selectedKeyword.length > 0 ){
			var scriptIds = [];
			var len = addedItems.length;
			for (var i = 0; i < len; i++)
				scriptIds.push(addedItems[i].versionableItemId ? addedItems[i].versionableItemId : addedItems[i].itemId);
			var self = this;
	    	var handler = {
	        	success: function(keyword) {
	            	self._updateKeywordList(keyword);
					self.keywordTable.refresh(self.keywords);
	        	},
	        	error: function(e){
	            	self._postError(e);
	        	}
	        }		
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var keywordObj = {
				id:selectedKeyword[0].id,
				stateId:selectedKeyword[0].stateId,
				scripts: scriptIds,
				defaultScript:scriptIds[0]
			};
			KeywordClient.postKeywordDTO(responseHandler, keywordObj);
		}			
	},
	_updateKeywordList:function(keyword,isArchived){
		var found = false;
		var updatedKeywords = [];
		var keywords = this.keywords;
		var len = keywords.length;
		for(var i=0;i<len;i++){
			if(keyword.id == keywords[i].id){
				found = true;
				if (isArchived) {
					keywords.splice(i, 1);
					keyword.archived = true;
					updatedKeywords.push(keyword);
					break;
				}
				if(keyword.defaultScript)
					keywords[i].defaultScript = keyword.defaultScript;
				keywords[i].name = keyword.name;
				keywords[i].tags = keyword.tags;
				keywords[i].executionScripts = keyword.executionScripts;
				keywords[i].modified = keyword.modified;
				keywords[i].stateId = keyword.stateId;
				updatedKeywords.push(keywords[i]);
				break;
			}
		}
		if(found)
			dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_KEYWORD, updatedKeywords]);
	},
	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
		var len  = artifactArray.length;
        
        // notification from ourself for created keyword.
        if (this._selfCreate) {
            this.keywordTable._invalidateQuery();
            delete this._selfCreate;
            return;
        }
        
        // just display a message
        if(artifactType == Constants.TYPE_SCRIPT) {
            this.keywordTable._showArtifactChangedMessage(this.viewHeader, Constants.TYPE_SCRIPT, changeType); 
            return;           
        }
        // Keep this old code for reference...
        // Note: We don't have the entire content anymore. We can't look thru
        // the content on the client side to determine if the query contains
        // the changed artifacts. We can only show a message to have the user to
        // invalidate the query.
        if ((changeType == GlobalEvents.ArtifactsUpdated || changeType == GlobalEvents.ArtifactsDeleted) 
				&& (artifactType == Constants.TYPE_SCRIPT)) {
			var found = false;
			var archivedCount = 0;
			var updatedCount = 0;
			var msgDetail = null;
			var status = -1;
			var changedKeywords = [];
            for (var i = 0; i < len; i++) {
				for(var j=0;j<this.keywords.length;j++){
					if (this.keywords[j].defaultScript.itemId == artifactArray[i].itemId) {
						if(changeType == GlobalEvents.ArtifactsDeleted){
							if(this.keywords[j].manualScript.itemId == artifactArray[i].itemId){
								this.keywords[j].archived = true;
								changedKeywords.push(this.keywords[j]);
								this.keywords.splice(j, 1);
								j = j-1;
								status = 1;
								archivedCount++;
								msgDetail = Constants.getMessage("msgKeywordsManualScriptArchived"); 
							}
							else{
								this.keywords[j].defaultScript = this.keywords[j].manualScript;
								if(this.keywords[j].manualScript.archived){
									this.keywords[j].archived = true;
									changedKeywords.push(this.keywords[j]);
									this.keywords.splice(j, 1);
									status = 1;
									archivedCount++;
									msgDetail = Constants.getMessage("msgKeywordsManualScriptArchived");
								}else{
									changedKeywords.push(this.keywords[j]);
									status = 0;
									msgDetail = Constants.getMessage("msgKeywordsRemoteScriptArchived");
									updatedCount++;
								}
							}
						}else{
							this.keywords[j].defaultScript = dojo.clone(artifactArray[i]);
							if(this.keywords[j].manualScript.itemId == artifactArray[i].itemId)
								this.keywords[j].manualScript = dojo.clone(artifactArray[i]);
							changedKeywords.push(this.keywords[j]);
							status = 0;
							msgDetail = Constants.getMessage("msgKeywordsScriptUpdated");
							updatedCount++;
						}
						found = true;
                	}else if (this.keywords[j].manualScript.itemId == artifactArray[i].itemId && 
							changeType == GlobalEvents.ArtifactsDeleted) {
						this.keywords[j].manualScript.archived = true;
						found = true;
					}
            	}
        	}
			if(found){
				var statusMsg = "";
				this.clearStatus();
				if(status == 0){
					statusMsg = Constants.getMessage("msgKeywordsUpdated",updatedCount);
					this.setStatus(statusMsg,msgDetail);
				}
				else if(status == 1){
					statusMsg = Constants.getMessage("msgKeywordsArchived",archivedCount);
					this.setStatus(statusMsg, msgDetail);
				}
				dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_KEYWORD, changedKeywords]);
				this.keywordTable.refresh(this.keywords);
			}
		}else if(changeType == GlobalEvents.ArtifactsAdded && artifactType == Constants.TYPE_KEYWORD){
			for (var i = 0; i < len; i++) {
				var keyword = artifactArray[i];
				this.keywords.push({
					id: keyword.id,
					name: keyword.name,
					defaultScript: keyword.defaultScript ? keyword.defaultScript : keyword.manualScript,
					tags: keyword.tags,
					modified: keyword.modified,
					executionScripts: [],
					manualScript: keyword.manualScript,
					stateId: keyword.stateId
				});
			}
			this.keywordTable.refresh(this.keywords);
		}
    },
	_postError:function(e){
		alert(e.message);
	},
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ KeywordList#Error");
	},
    refresh: function() {
         this._initialize();
         this.clearStatus();
    },
    
    // set the status message in the header
    //
    clearStatus: function() {
        this.statusLineNode.innerHTML = "";
        this.statusSuccessNode.style.display = "none";
        this.viewHeaderContainerNode.style.display = "none";
    },
    
    setStatus: function(status, /*optional*/details) {
    	this.viewHeaderContainerNode.style.display = "inline";

        var stText = status;
        var detailText = details;
        
        // stop the status line from extending too far off to the
        // left. Cap its length at 40. Show the full text in the tooltip.
        //
        if((status.length - 40) > 5) {
            stText = status.substr(0, 40) + "...";
            if(details) {
                detailText = status + "\n" + details;
            }
        }
        
        // detail message is in the tooltip popup
        if (this.statusPopup) {
            this.statusPopup.destroy();
        }
        this.statusPopup = new jazz.ui.HoverPopup({html: (details) ? detailText : status, around:[this.statusLineNode]});        
    	this.statusLineNode.innerHTML = stText;    	
    	this.statusSuccessNode.style.display = "inline";
    }
});

})();
