/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource");
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

(function(){
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
    var RequirementTableView = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView;
	var RequirementConnectClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	
	// cap max number of import results at 1000
	var MAX						= 50;

    /**
     *
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.requirement.web", "ui/internal/view/templates/requirement/RequirementsSource.html"),
        widgetsInTemplate: true,
        
        labelRefresh: Constants.getMessage("labelRefresh"),
		labelSource: Constants.getMessage("labelRequirementSource"),
		labelURI: Constants.getMessage("labelRequirementURI"),
		labelRequisitePro: Constants.getMessage("labelRequisitePro"),
		labelPort: Constants.getMessage("labelRequirementPort"),
		labelProject: Constants.getMessage("labelRequirementProject"),
		labelLoading: Constants.getMessage("labelLoading"),
		labelUserId: Constants.getMessage("labelRequirementUserId"),
		labelPassword: Constants.getMessage("labelRequirementPassword"),
		labelGettingInfo: Constants.getMessage("labelLoading"),
		labelType: Constants.getMessage("labelRequirementType"),
		labelMultipleTypes: Constants.getMessage("labelRequirementMultipleTypes"),
		labelImport: Constants.getMessage("labelRequirementImport"),
		labelBack: Constants.getMessage("labelRequirementBack"),
		labelNext: Constants.getMessage("labelRequirementNext"),
		labelStep1GettingInfo: Constants.getMessage("labelLoading"),
		
		invokeTimes: 0,
		
		returnedNum: 0,
		
		currentInvokeTime: 0,
		
        constructor: function(args){
            this.onCancel = args.onCancel;
            this.onDone = args.onDone;
			this.requirements = args.requirements;
			this.parent = args.parent;
			this.reqConnection = null;
			this.selectedItemId = null;
			this.project = null;
			this.type = null;
			this.previousType = null;
			this.allConnections = new Array();
			this._allImportedReqs = [];
			this._addedRequirements = [];
			this._requirementTablesByType = [];
        },
		
        postCreate: function(){
            this._loadConnections();
        },
		
		_loadConnections: function() {
			//display inditator info before loaded
			this.step1ProgressInfoIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._step1ImageGettingInfo);
			this._step1ImageGettingInfo.appendChild(img);
			
			var responseHandler = new ServiceResponseHandler(this, "_loadReqproProperties", "_error");
            RequirementConnectClient.getRequirementConnectionDTOs(responseHandler, null);
		},
	
        _loadReqproProperties: function(results){
			this._setToNewConnection();
            var select = document.createElement("select");
			SelectUtility.add( select, new Option("", null) );
			this.allConnections = results;
            for (var j = 0; j < (results ? results.length : 0); j++) {
				var uri = results[j].hostname + ":" + results[j].port;
				var option = new Option(uri, results[j].id);
				SelectUtility.add( select, option );
            }
            var args = {
                autoComplete: "false",
                onKeyUp: dojo.hitch(this, "_connectionChanged", results),
				onChange: dojo.hitch(this, "_connectionChanged", results),
				invalidMessage: Constants.getMessage("msgRequirementURIInvalid"),
				regExp:"http(s)?:\/\/(.)+"
            }
            this.combo = new dijit.form.ComboBox(args, select);
			this.combo.domNode.style.width = "302pt";
            dojox.data.dom.removeChildren(this._hostName);
            this._hostName.appendChild(this.combo.domNode);
			this.combo._showResultList = function(){
				this.inherited('_showResultList', arguments);
				var parent = this._popupWidget.domNode.parentNode;
				if(parent) {
					parent.style.zIndex = "10009";
				}
			}
			
			this.step1ProgressInfoIndicator.style.display = "none";
        },
        
        _connectionChanged: function(results){
			var combox = this.combo;
        	var selected = this.combo.getValue();
			//validate data
			if(selected && selected.length > 0 && combox.isValid()){
				this._nextToStep2Button.disabled = false;
			}else {
				this._nextToStep2Button.disabled = true;
				combox._setDisplayedValueAttr(combox.attr('displayedValue'), true);
			}
			
			if(results && results.length > 0){
				for(var i=0; i<results.length; i++){
					var uri = results[i].hostname + ":" + results[i].port;
					if(uri == selected){
						this.selectedItemId = results[i].id;
						this.reqConnection = results[i];
						return;
					}
				}
				//new connection is selected again
				this.reqConnection = null;
				this._setToNewConnection();
			} 
        },
        
        _onProjectRefresh: function(){
            if (!this.reqConnection) return;
            
            var handler = {
                self: this,
                success: function(connectionDTO) {
                    var self = this.self;
                    var allConn = self.allConnections;
                    // update the project list in our master list of connections.
                    for(var i = 0; i < allConn.length; i++) {
                        var conn = allConn[i];
                        if(conn.id == connectionDTO.id) {
                            conn.projects = connectionDTO.projects;
                            break;
                        }
                    }
                    this.updateConnection(connectionDTO);
                },
                failure: function(e) {
                    this.self._error(e);
                    this.updateConnection(this.self.reqConnection);
                },
                updateConnection: function(reqConnection) {
                    var self = this.self;
                    self._onProjectsLoaded(reqConnection);
                    self._setPage2ControlsDisabled(false);
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
            RequirementConnectClient.getUpdatedRequirementConnectionDTO(responseHandler, {id: this.reqConnection.id});
            
            this._setPage2ControlsDisabled(true);
            this._showProjectLoading();
        },
        
        _setPage2ControlsDisabled: function(disable) {
            this._refreshProject.attr('disabled', disable);
            this._toStep3Button.disabled = disable;
            this._toStep1Button.disabled = disable;  
        },
        
		_onNextToStep2: function(event){
			this.combo.domNode.style.display = "none";
			if (this.reqConnection) {
				this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
				this._requirementsource.style.display = "none";
				this._requirementcustomize.className = "show";
				this._requirementcustomize.style.display = "block";
				this._onProjectsLoaded(this.reqConnection);
			}
			else {
				var uri = this.combo.getValue();
				var values = uri.split(":");
				this.hostname = values[0]+":"+values[1];
				this.port = values[2];
				if (!this.port) {
					this.port = 80;
				}
				
				var param = {
					hostname: this.hostname,
					port: this.port,
					name: this.hostname,
					connectionType: Constants.getMessage("labelReqProType")
				}
				if (this._isNewConnectDuplicate(param)) {
					if (this.hostname) {
						this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
						this._requirementsource.style.display = "none";
						this._requirementcustomize.className = "show";
						this._requirementcustomize.style.display = "block";
						this.loadProjects(param);
					}
					else {
						this.combo.domNode.style.display = "block";
						this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoHostName"));
					}
				}
				else{
				    this.combo.domNode.style.display = "block";
				}
			}
			if(event){
                dojo.stopEvent(event);
            }
        },
		
		_onNextToStep3: function(event){
			this.progressInfoIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._imageGettingInfo);
			this._imageGettingInfo.appendChild(img);
			this._toStep3Button.disabled = true;
			
			var param = {
				connectionItemId: this.reqConnection.internalId,
				projectItemId: this._project.value,
				username: this._username.value,
				password: this._password.value
			}
			
			//get project name
			for(var i=0;i<this.projects.length;i++){
				if(this.projects[i].internalId==this._project.value){
					this.importPrjName=this.projects[i].name;
					break;
				}
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_loadStep3", "_errorToStep3");
            RequirementConnectClient.getSummaryRequirementProject(responseHandler, param);
            if(event){
                dojo.stopEvent(event);
            }
		},
		
		_loadStep3: function(project) {
			this.progressInfoIndicator.style.display = "none";
			this._toStep3Button.disabled = false;
            this.setTitle(Constants.getMessage("labelImportRequirementStep3"));
            this._requirementcustomize.style.display = "none";
            this._requirementListDiv.className = "show";
			this._requirementListDiv.style.display = "block";
			this.parent.importFloatingPane.setWidth("76%");
			this.parent.importFloatingPane.updatePosition();
				
            dojox.data.dom.removeChildren(this._requirementList);
            var args = {
				inDialogMode: true,
				noInitEmptyMessage: true,
                requirements: [],
                editable: true,
                isExternal: true,
                hideResetButton: true
            };
            this._reqTableViewer = new RequirementTableView(args);
            this._requirementList.appendChild(this._reqTableViewer.domNode);
            
			if (project) {
				this.types = project.types;
				this._createTypeSelection(this.types);
			}
        },
        
		_isNewConnectDuplicate: function(param) {
			if(this.allConnections && this.allConnections.length) {
				for(var i=0; i<this.allConnections.length; i++){
					var connect = this.allConnections[i];
					if( (connect.hostname == param.hostname || "http://"+connect.hostname == param.hostname || connect.hostname == "http://"+param.hostname) && connect.port == param.port){
						var message = Constants.getMessage("msgAddConnection", connect.name, connect.name);
						this._displayAlertDialog(Constants.getMessage("labelAlert"), message);	
						return false;
					}
				}
			}
			return true;
		},
		
        _showProjectLoading: function(){
            dojox.data.dom.removeChildren(this._project);
            var option = document.createElement("option");
            option.text = option.value = Constants.getMessage("labelLoading");
            this._project.appendChild(option);            
        },
        
        loadProjects: function(param){
            this._showProjectLoading();
			var responseHandler = new ServiceResponseHandler(this, "_postNewConnection", "_error");
	        RequirementConnectClient.postRequirementConnection(responseHandler, param);
        },
		
		_postNewConnection: function(conn){
			if(conn && conn.id){
				var responseHandler = new ServiceResponseHandler(this, "_getConnectionById", "_error");
            	RequirementConnectClient.getRequirementConnectionDTOs(responseHandler, {id: conn.id});
			}
			else {
				this._error();
				this._toStep1();
			}
		},
        
		_getConnectionById: function(items){
			if(items && items.length>0){
				this.allConnections = new Array();
				this.allConnections.push(items[0]);
				this._onProjectsLoaded(items[0]);
			}
			else{
				this._error();
				if(items && items.length>0){
					//remove current connection
					var responseHandler = new ServiceResponseHandler(this, "_toStep1", "_error");
            		RequirementConnectClient.getDeleteRequirmentConnection(responseHandler, {id: items[0].id});
				}
			}
		},
		
		_setToNewConnection: function(){
			this.reqConnection = null;
			this.selectedItemId = null;
		},
		
		 _onProjectsLoaded: function(requirementConnection){
			this.reqConnection = requirementConnection;
			this.projects = requirementConnection.projects;
			dojox.data.dom.removeChildren(this._project);
			if(this.projects && this.projects.length > 0){
				for(var i = 0; i<this.projects.length; i++){
			   		var option = new Option(this.projects[i].name, this.projects[i].internalId);
					SelectUtility.add( this._project, option );
 					if(i == 0)
						option.selected = true;
				}
			}
			else {
				this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoProject"));
			}			
        },
		
		_createTypeSelection: function(types) {
			dojox.data.dom.removeChildren(this._type);
			if (types && types.length > 0) {
				var prompt = new Option(Constants.getMessage("msgSelectReqTypePrompt"), "promptId");
				prompt.disabled = true;
				SelectUtility.add( this._type, prompt );
				
				for (var i = 0; i < types.length; i++) {
					var option = new Option(types[i].name, types[i].id);
					SelectUtility.add( this._type, option );
				}
				prompt.selected = true;
			}
		},
		
		_loadTypeItemsToTable: function(type){
			// disable the type combo + the buttons while we're fetching the items.
			this._type.disabled = true;
			this._finishButton.disabled = true;
			this._backToStep2Button.disabled = true;
			
			var param = {
				connectionItemId: this.reqConnection.internalId,
				projectItemId: this._project.value,
				typeItemId: type.internalId,
				username: this._username.value,
				password: this._password.value
			}
			var handler = {
				self: this,
				reqType: type,
				success: function(requirements){
					var self = this.self;
					var isPriority = (requirements && requirements.length > 0 && requirements[0].priority);
					var provider;
					var pArgs = {isVirtual: false};
					if (isPriority) {
						provider = new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider(pArgs);
					}
					else {
						provider = new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider(pArgs);
					}
					var tableViewer = self._reqTableViewer.tableViewer;
					self._type.disabled = false;
					self._finishButton.disabled = false;
					self._backToStep2Button.disabled = false;
					tableViewer.endLoadingProgress();
					tableViewer.setContentProvider(provider);
					var newRqe = self._filterExistReq(self.requirements, requirements);
					
					self._reqTableViewer.refresh(newRqe);
					
					// if we had previously selected rows and we're going back this type,
					// reselect them.
					if(this.reqType.selectedItems && this.reqType.selectedItems.length > 0) {
						tableViewer.selectRows(this.reqType.selectedItems);
						tableViewer.refresh();
					}
				},
				failure: function(e){
					var msg = Constants.getMessage("msgErrorGetReqTypeItems", this.reqType.name, e && e.message ? e.message : "Unknown");
					var self = this.self;
					self._type.disabled = false;
					self._finishButton.disabled = false;
					self._backToStep2Button.disabled = false;
					self._reqTableViewer.tableViewer.endLoadingProgress();
					self._reqTableViewer.tableViewer.showContentError(msg);
				}
			};
			var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
			
			// the items has already been fetched. Just load it into the table.
			if(type.items) {
				handler.success(type.items);
				return;
			}
			RequirementConnectClient.getRequirementItemsByType(responseHandler, param);
			
			// make the table to show loading while we're fetching the requirements
			if (this._reqTableViewer.initialized) {
				this._reqTableViewer.refresh([]);
				this._reqTableViewer.tableViewer.showLoadingProgress();
			}
		},
		
		_onTypeChange: function(e) {
			var type = null;
			var typeId = this._type.value;
			if(typeId == "promptId") {
				return;
			}
            if(this.types && this.types.length>0){
				for(var i=0; i<this.types.length; i++){
					if(typeId == this.types[i].id){
						type = this.types[i];
					} else if(this.previousType == this.types[i].id) {
						// Cache the fetched items. We'll just load it when it's
						// being visited again.
						this.types[i].items = this._reqTableViewer.tableViewer.getContent();
						this.types[i].selectedItems = this._reqTableViewer.getSelectedRows();
					}
				}
			}
			this.previousType = typeId;
			this._loadTypeItemsToTable(type);
			if(e){
                dojo.stopEvent(e);
            }
		},
        
        _onBackToStep1: function(event){
            this.setTitle(Constants.getMessage("labelImportRequirementStep1"));
            this._requirementsource.className = "show";
            this._requirementcustomize.className = "hidden";
			this._requirementsource.style.display = "block";
            this._requirementcustomize.style.display = "none";
			this.combo.domNode.style.display = "block";
			if(event){
                dojo.stopEvent(event);
            }
        },
        
		 _onBackToStep2: function(event){
            this.setTitle(Constants.getMessage("labelImportRequirementStep2"));
            this._requirementcustomize.className = "show";
            this._requirementListDiv.className = "hidden";
			this._requirementcustomize.style.display = "block";
            this._requirementListDiv.style.display = "none";
			this.parent.importFloatingPane.setWidth("60%");
			this.parent.importFloatingPane.updatePosition();
			this._username.value = "";
			this._password.value = "";
			this._finishButton.disabled = false;
			if(event){
                dojo.stopEvent(event);
            }
        },
		
        _onImport: function(event){
            var items = this._reqTableViewer.getSelectedRows();
			if(this._multipleTypes.checked) {
				for(var i=0; i<this.types.length; i++) {
					if ((this.types[i].id != this._type.value) && this.types[i].selectedItems) {
						items = items.concat(this.types[i].selectedItems);
					}
				}	
			}
			if(items==null || items.length==0){
				this._displayAlertDialog(Constants.getMessage("labelAlert"), Constants.getMessage("msgNoRequirement"));
				return;
			}
			this._progressIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._image);
			this._image.appendChild(img);
			
			this._finishButton.disabled = true;
			var uri = this.combo.getValue();
			var prefix = uri.indexOf("https") >= 0 ? "reqprohttps/" : "reqpro/";
			var idx = uri.indexOf("//")+2;
			var protocolAndHost = uri.substring(idx, uri.length);	
			
            for (var i = 0; i < items.length; i++) {
				if (items[i].status == "removed") {
					this._displayAlertDialog(Constants.getMessage("labelAlert"), items[i].name + " has been removed, it can't be added.");
					this._finishButton.disabled = false;
					return;
				}
				else {	
					this._addedRequirements.push({						
						//externalId: "http://" + this.combo.getValue() + ":" + this._port.value + "/ReqWeb/ReqTabbedProp_Page.jsp?ReqKey=" + items[i].reqKey + "&shortCut=true&showMainFrame=true&txtProject="+this.importPrjName+"&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>",						
						//generalize externalid of reqpro requirements like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
						//also support "https" <-> "reqprohttps"			
						externalId: prefix + protocolAndHost + "/" + this.importPrjName.replace(/ /g,"%20") + "/" + items[i].reqKey,
						internalId: items[i].internalId,
						name: items[i].name ? items[i].name : items[i].tag, // if name is blank, use tag instead
						summary: items[i].description,
						externalTag: items[i].tag,
						priority: items[i].priority,
						reviewStatus: items[i].reviewStatus,
						packageInfo: items[i].packageInfo,
						reqType: items[i].reqType
					});
				}
            }
			
			//import requirements
            this.totalReqToImport = this._addedRequirements.length;
            this._progressLabel.innerHTML = Constants.getMessage("msgStartReqImport", this.totalReqToImport);
			this.invokeTimes = Math.ceil(this.totalReqToImport/MAX) ;
			var startIndex = this.currentInvokeTime * MAX;
			var endIndex = (this.currentInvokeTime==this.invokeTimes-1) ? this._addedRequirements.length : startIndex + MAX;
			var tmpArray = this._addedRequirements.slice(startIndex, endIndex);
					
			var responseHandler = new ServiceResponseHandler(this, "_importFinished", "_importFailure");
            RequirementWorkItemClient.postRequirementWorkItems(responseHandler, {
            	addedRequirements: tmpArray
            });
            if(event){
                dojo.stopEvent(event);
            }
        },
		
		_importFinished: function(requirements) {
			this.returnedNum++;
			for (var j=0; j < (requirements ? requirements.length : 0); j++) {   
			    this._allImportedReqs.push(requirements[j]);                 
            }
			this.currentInvokeTime++;
            var nImported = Math.min(this.currentInvokeTime * MAX, this.totalReqToImport);
            this._progressLabel.innerHTML = Constants.getMessage("msgImportReqStat", nImported, this.totalReqToImport);
			if(this.currentInvokeTime < this.invokeTimes) {
				var startIndex = this.currentInvokeTime * MAX;
				var endIndex = (this.currentInvokeTime==this.invokeTimes-1) ? this._addedRequirements.length : startIndex + MAX;
				var tmpArray = this._addedRequirements.slice(startIndex, endIndex);
					
				var responseHandler = new ServiceResponseHandler(this, "_importFinished", "_importFailure");
            	RequirementWorkItemClient.postRequirementWorkItems(responseHandler, {
            		addedRequirements: tmpArray
            	});
			}
			if (this.returnedNum == this.invokeTimes) {
				this.onDone(this._allImportedReqs);
			}
		},
		
		_importFailure: function(error) {
			this.returnedNum++;
			this.currentInvokeTime++;
            var nImported = Math.min(this.currentInvokeTime * MAX, this.totalReqToImport);
            this._progressLabel.innerHTML = Constants.getMessage("msgImportReqStat", nImported, this.totalReqToImport);
			if(this.currentInvokeTime < this.invokeTimes) {
				var startIndex = this.currentInvokeTime * MAX;
				var endIndex = (this.currentInvokeTime==this.invokeTimes-1) ? this._addedRequirements.length : startIndex + MAX;
				var tmpArray = this._addedRequirements.slice(startIndex, endIndex);
					
				var responseHandler = new ServiceResponseHandler(this, "_importFinished", "_importFailure");
            	RequirementWorkItemClient.postRequirementWorkItems(responseHandler, {
            		addedRequirements: tmpArray
            	});
			}
			if (this.returnedNum == this.invokeTimes) {
				this.onDone(this._allImportedReqs);
			}
		},
		
		_filterExistReq: function(exists, toBeFilter) {
			if(!toBeFilter || toBeFilter.length == 0 || !exists || exists.length == 0)
				return toBeFilter;
			var newReqs = [];
			var i = 0 , j = 0 , flag;
			
			var uri = this.combo.getValue();
			var prefix = uri.indexOf("https") >= 0 ? "reqprohttps/" : "reqpro/";
			var idx = uri.indexOf("//")+2;
			var protocolAndHost = uri.substring(idx, uri.length);	
			var solidString =  prefix + protocolAndHost + "/" + this.importPrjName.replace(/ /g,"%20") + "/";		
			
//			var protocolAndHost = this.combo.getValue();
//			if(!protocolAndHost.match(/^https?:\//i))
//				protocolAndHost = "http://" + protocolAndHost;
//			var solidString = protocolAndHost + this.combo.getValue() + ":" + this._port.value + "/ReqWeb/ReqTabbedProp_Page.jsp?ReqKey=";
			while (i < toBeFilter.length) {
				flag = true;
				for (j = 0; j < exists.length; j = j + 1) {
					var externalId = solidString + toBeFilter[i].reqKey;
					if (exists[j].externalId === externalId) {
						flag = false;
						break;
					}
				}
				if (flag) {
					newReqs.push(toBeFilter[i]);
				}
				i = i + 1;
			}
			return newReqs;
		},
		
		_toStep1: function(result){
			this._onBackToStep1();
			this._loadConnections();
		},
		
		_errorToStep3: function(e) {
			this.progressInfoIndicator.style.display = "none";
			this._toStep3Button.disabled = false;
			this._displayAlertDialog(Constants.getMessage("labelError"), e.message);
		},
		
		_displayAlertDialog: function(title, message) {
	         var alertDialog = new AlertDialog({'message': message, 'okCallback': dojo.hitch(this, function(){
				dijit.focus(this.parent.importFloatingPane._headerText);
			})});
    	    alertDialog.setSecondaryTitle(title);
        	alertDialog.open();
		},
		
        _error: function(e){
			this._displayAlertDialog(Constants.getMessage("labelError"), e.message);
        }
    });
})();
