/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader");
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var Uploader = com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader;
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var RequirementsSource = com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsSource;
    
    /**
     *
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader", [Uploader], {
    
        templatePath: dojo.moduleUrl("com.ibm.rqm.requirement.web", "ui/internal/view/templates/requirement/RequirementsUploader.html"),
        
        labelExternalRadio: Constants.getMessage("labelImportExternal"),
        labelLocalRadio: Constants.getMessage("labelImportLocal"),
        labelBrowse: Constants.getMessage("labelBrowse"),
		labelUpload: Constants.getMessage("labelUpload"),
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
            this._mainImportSection.titleContainerNode.style.display = "none";
            this._enableLocalMode();
            this.connect(this.importExternalRadio, "onclick", "_enableExternalMode");
            this.connect(this.importLocalRadio, "onclick", "_enableLocalMode");
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelImportRequirementHelp"));
        },
        
        
        // TODO implement staged import per UX design
        _enableExternalMode: function(){
            this.importExternalArea.style.display = "block";
            this.importLocalArea.style.display = "none";
            var uploadButton = this.getUploadButton();
            uploadButton.enabled = false;
        },
        
        _enableLocalMode: function(){
            this.importLocalRadio.checked = true;
            this.importLocalArea.style.display = "inline";
            this.importExternalArea.style.display = "none";
            var uploadButton = this.getUploadButton();
            uploadButton.enabled = false;
        },
        
        _onClickLaunchRequirementTool: function(event){
            if(event){
                dojo.stopEvent(event);
            }
            var self = this;
            var setTitle = function(title){
                self.importFloatingPane.setTitle(title);
            };
            var onCancel = function(){
                self.importFloatingPane.close();
            };
            var onDone = function(requirements){
                self.importFloatingPane.close();
                self._onRequirementsImported(requirements);
                self._enableLocalMode();
            };
            this._requirementsSource = new RequirementsSource({
                requirements: this._requirements,
                setTitle: setTitle,
                onCancel: onCancel,
                onDone: onDone,
                parent: self
            });
            var args = {
                primaryTitle: Constants.getMessage("labelImportRequirementStep1"),
                displayCloseAction: true,
                isClosable: true,
                contentNode: this._requirementsSource.domNode,
				zIndex: 9998
            }
            this.importFloatingPane = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            this.importFloatingPane._yesButton.style.display = "none";
            this.importFloatingPane._noButton.style.display = "none";
			var self = this;
            dojox.data.dom.removeChildren(this.importFloatingPane._headerText);
            var span1 = document.createElement("span");
            span1.innerHTML = args.primaryTitle;
            this.importFloatingPane._headerText.appendChild(span1);
            var cshelp = new CSHelp({
                contextID: "rqm_import_req.html"
            });
			cshelp.setButtonLabel(Constants.getMessage("labelImportRequirementHelp"));
            var span2 = document.createElement("span");
            span2.appendChild(cshelp.domNode);
            this.importFloatingPane._headerText.appendChild(span2);
            
            dojo.mixin(this.importFloatingPane, {
                "setTitle": function(title){
                    dojox.data.dom.removeChildren(this._headerText);
                    var span1 = document.createElement("span");
                    span1.innerHTML = title;
                    this._headerText.appendChild(span1);
                    var cshelp = new CSHelp({
                        contextID: "rqm_import_req.html"
                    });
					cshelp.setButtonLabel(Constants.getMessage("labelImportRequirementHelp"));
                    var span2 = document.createElement("span");
                    span2.appendChild(cshelp.domNode);
                    this._headerText.appendChild(span2);
					dijit.focus(this._headerText);
                }
            });
            this.importFloatingPane.open(true);
        },
        
        _onRequirementsImported: function(requirements){
            var args = {
                'message': requirements.length + " " + Constants.getMessage("msgRequirementsImported"),
                'okCallback': null,
                'okCallbackData': null,
                'cancelCallback': null,
                'cancelCallbackData': null
            };
            var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
            confirmDialog.open();
        }
        
    });
})();
