/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * File Browser widget - Simultate File browsing capability -Starting Point Shared location should be entered
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.rqm.execution.web.client.internal.executionframework.ResourceClient");

(function(){ // module container
    
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ImageCache					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
	var CommonImageCache			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var PlanClient					= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var Constants					= com.ibm.rqm.planning.web.client.internal.Constants;
	var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var TimeBoxClient				= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
	var TestPlanMapper				= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
	var SelectUtility 				= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	 
    dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser", [dijit._Widget, dijit._Templated], {
        templateString: "<div class= \"com-ibm-rqm-execution-resourcebrowser-file-browser\" dojoAttachPoint=\"_fileContainer\">" +
							"<label style='font-family:Arial;font-size:9pt;font-style: italic;' dojoAttachPoint=\"_message\"></label>"+
							"<div dojoAttachPoint=\"_containerNode\">"+
								"<table style=\"width: 80%;\"><tbody>"+
									"<tr style=\"width: 100%;\">"+
										"<td style=\"width: 20%;\"><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_lableTP\"></label></td>"+
										"<td style=\"width: 35%;\"><select style=\"width:100%;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_TP\" dojoAttachEvent=\"onchange: _planUpdated\"></select></td>"+
										"<td style=\"width: 5%;\"></td>"+
										"<td style=\"width: 20%;\"><label style=\"font-family:Arial;font-size:9pt; marginLeft: 10px;\" dojoAttachPoint=\"_lableIteration\"></label></td>"+
										"<td style=\"width: 20%;\"><select style=\"width:100%;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_Iteration\" dojoAttachEvent=\"onchange: _iterationsUpdated\"></select></td>"+
									"</tr>"+
									"<tr style=\"width: 100%;\">"+
										"<td style=\"width: 20%;\"><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_lableLocation\"></label></td>"+
										"<td style=\"width: 35%;\"><select style=\"width:100%;font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_sharedPath\" dojoAttachEvent=\"onchange: _pathUpdated\"></select></td>"+
										"<td style=\"width: 5%;\"></td>"+
										"<td style=\"width: 20%;\"></td>"+
										"<td style=\"width: 20%;\"></td>"+
									"</tr></tbody>"+
								"</table>"+
								"<table style=\"width: 60%;\"><tbody>"+
									"<tr style=\"width: 100%;\">"+
										"<td style=\"width: 50%;\"><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_relLocationLabel\"></label></td>"+
										"<td colspan=\"2\"><label style=\"font-family:Arial;font-size:9pt;width: 50%;\"\" dojoAttachPoint=\"_relLocationValue\"></label></td>"+
									"</tr></tbody>"+
								"</table>"+
								"<div class=\"bread-crums-header\" dojoAttachPoint=\"_breadcrums\"></div>"+
								"<div class=\"resource-list\" dojoAttachPoint=\"_table\"></div>"+
								"<table style=\"float: left;\"><tbody>"+
									"<tr>"+
										"<td width=\"10px;\"><td>"+
										"<td><input type=\"checkbox\" dojoType=\"dijit.form.CheckBox\" dojoAttachPoint=\"_checkboxValue\"></input></td>"+
										"<td><label dojoAttachPoint=\"_checkboxLabel\" style='font-family:Arial;font-size:9pt;'></label></td>"+
									"</tr></tbody>"+
								"</table>"+
							"</div>"+
						"</div>",
        
		singleSelect: false,
		resources: [],
		widgetsInTemplate: true,
		allPlans: [],
		sharedLocationPath: null,
		PLAN_RESOURCES_SECTION_ID: "com.ibm.rqm.planning.editor.section.planResources",
		
        constructor: function(args){
			this.folderHistory = [];
			this.lastClickedTime = 0;
			this.fileLastClickedTime = 0;
			this.clickDelay = 500;
			this.IEclickDelay = 1000;
			this.selectedFiles = [];
			this.FILE_ID = this.id+"_file_";
		},

        postCreate: function(){
			this._lableLocation.innerHTML = Constants.getMessage("labelSharedLocation");
			this._relLocationLabel.innerHTML = Constants.getMessage("labelRelativeLocation");
			this._lableIteration.innerHTML = Constants.getMessage("labelIteration");
			this._lableTP.innerHTML = Constants.getMessage("labelTestPlan");
			this._checkboxLabel.innerHTML = Constants.getMessage("labelShowAllFiles");
			this.connect(this._checkboxValue, "onChange", "_handleCheckboxSelectionChanged");
			if(this.singleSelect == false){
				dojo.style(this._relLocationLabel, "display", "none");
				dojo.style(this._relLocationValue, "display", "none");
			}
			var responseHandler = new ServiceResponseHandler(this, "_fillSharedLocations", "_error");			
			var option = new com.ibm.asq.common.web.client.internal.option();
			option.getProjectPreferences(responseHandler, getCurrentProjectArea().itemId, Constants.SHARED_RESOURCES_LOCATION_CATEGORY);
			SelectUtility.add( this._TP, new Option(Constants.getMessage("labelLoading"), "") );
			var responseHandler = new TestPlanMapper(this, "_initTP", "_error");
			PlanClient.getTestPlansSummary(responseHandler, {});
		},

		_preInitialize: function(){
			if(this.script && this.script.managedByAdapter == false){
				this._relLocationValue.innerHTML = this.script.sharePrefix +"\\"+this.script.relativePath;
				this.shareName = this.script.sharePrefix;
				this.testPlanId = this.getProperty(this.script.properties, "testPlanId");
				this.milestoneItemId = this.getProperty(this.script.properties, "milestoneItemId");
			}
		},

		setScriptInfo: function(script, scriptType){
			this.scriptType = scriptType;
			this.script = script;
			this._preInitialize();
			this._updateLocations();
			var shareLocation = this._sharedPath.value;
			var args = {
					resourceType: "folder",
					resourceName: shareLocation,
					resourceURN: shareLocation
				}
				this.startBrowsing(args);
		},
		getInitialPath: function(){
			return this.sharedLocationPath;
		},
		
		getPlan: function(){
			var planId = this._TP.value;
			return {id: planId};
		},
		
		getPhase: function(){
			var phaseItemId = this._Iteration.value;
			return {itemId: phaseItemId};
		},
		
		getProperty: function(properties, name){
			var value = "";
			var len = properties.length;
			for(var i=0;i<len;i++){
				if(properties[i].propertyName == name){
					value= properties[i].propertyValue;
					break;
				}
			}
			return value;
		},

		_initTP: function(plans){
			this.allPlans = plans;
			
			dojox.data.dom.removeChildren(this._TP);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			SelectUtility.add( this._TP, option );
			
			if(plans && plans.length>0){
				var len = plans.length;
				for(var i=0;i<len;i++){
					var plan = plans[i];
					var option = new Option(plan.name, plan.id);
					if(this.testPlanId == plan.id)
						option.selected = true;
					SelectUtility.add( this._TP, option );
				}	
				var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
				TimeBoxClient.getTestPhasesDTO(responseHandler, {});
			}else{
				//Skip all plan stuff as no plans found, go to file shared location directly
				var shareLocation = this._sharedPath.value;
				var args = {
						resourceType: "folder",
						resourceName: shareLocation,
						resourceURN: shareLocation
					}
				this.startBrowsing(args);
			}
		},
		
		_appendIterations: function(iterations){
			if (iterations && iterations.length>0 && this.allPlans && this.allPlans.length>0) {
				var allPlans = this.allPlans;
				var len = allPlans.length;
				for(var j=0;j<len;j++){
					var plan = allPlans[j];
					for(var i=0;i<iterations.length;i++){
						if(plan.versionableItemId === iterations[i].targetTestPlanUUID){
							if(!plan.iterations)
								plan.iterations = [];
							plan.iterations.push(iterations[i]);
						}    
					}
				}			
			}
			//If no plans are found then this will not be executed.
			// start the recursion
			this.planResourcesToGet = this.allPlans.concat();
			this.recursionGuard = this.planResourcesToGet.length; // for safety check in recursion
			var firstPlan = this.planResourcesToGet[ this.planResourcesToGet.length-1 ];
			var responseHandler= new ServiceResponseHandler(this, "_appendResource", "_error");
			var args = {"testPlanVersionableUUID": firstPlan.versionableItemId,
			             "sectionId": this.PLAN_RESOURCES_SECTION_ID};
			PlanClient.getTestPlanSection(responseHandler,args );
		},
		
		_appendResource: function(section){
			this.recursionGuard--;
			var plan = this.planResourcesToGet.pop();
			if (section!=null) {
				plan.resources = (section.content != "" ? dojo.fromJson(section.content) : [])
			}
			if (this.planResourcesToGet.length>0 && this.recursionGuard>0) {   // recurse again
				var nextPlan = this.planResourcesToGet[ this.planResourcesToGet.length-1 ];
				var responseHandler= new ServiceResponseHandler(this, "_appendResource", "_error");
				var args = {"testPlanVersionableUUID": nextPlan.versionableItemId,
				             "sectionId": this.PLAN_RESOURCES_SECTION_ID};
				PlanClient.getTestPlanSection(responseHandler,args );
			} else {  // done with recursion
				this._planUpdated();
			}
		},
		
		_updateIterationCombo: function(){
			var planId = this._TP.value;
			dojox.data.dom.removeChildren(this._Iteration);
			if(planId ==="global"){
				this._Iteration.disabled = true;
				return;
			}
			this._Iteration.disabled = false;
			var milestoneItemId = this.milestoneItemId;
			var allPlans = this.allPlans;
			var len = allPlans.length;
			for(var i=0;i<len;i++)	{
				var id = parseInt(planId, 10)
				if(allPlans[i].id === id)	{
					var planIterations = allPlans[i].iterations;
					if(planIterations)	{
						var len2 = planIterations.length;
						for(var i=0;i<len2;i++)	{
							var opt = new Option(planIterations[i].name, planIterations[i].itemId);
							if(milestoneItemId && milestoneItemId == planIterations[i].itemId)
								opt.selected = true;
							if((!milestoneItemId || milestoneItemId == "") && len2 == (i + 1))
							     opt.selected = true;	
							SelectUtility.add( this._Iteration, opt );
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
		},
		
		_planUpdated: function(event){
			this._updateIterationCombo();
			this._updateLocations();
			if(event){
                 dojo.stopEvent(event);
            }
		},
		
		_iterationsUpdated: function(event){
			this._updateLocations();
			if(event){
                 dojo.stopEvent(event);
            }
		},
		
		_updateLocations: function(){
			var locations = [];
			var resolvedPath = [];
			var allLocations = false;
			if("global" == this._TP.value){
				locations = this.locations;
				allLocations=true;
			}else{
				var allPlans = this.allPlans;
				var len = allPlans.length;
				if (this.scriptType) {
					var scriptTypeName = this.scriptType.name;
					for (var i = 0; i < len; i++) {
						if (this._TP.value == allPlans[i].id) {
							if (allPlans[i].resources) {
								var resources = allPlans[i].resources;
								var len2 = resources.length;
								for (var j = 0; j < len2; j++) {
									if ( scriptTypeName == resources[j].type) {
										locations.push(resources[j].location);
										this.initialPath = resources[j].location;
										var newLoc = resources[j].location;
										if (resources[j].resolvedPath.indexOf(Constants.INCLUDE_PLAN) != -1) {
											newLoc += "\\" + this._TP.options[this._TP.options.selectedIndex].text;
										}
										if (resources[j].resolvedPath.indexOf(Constants.INCLUDE_ITERATION) != -1) {
											if (this._Iteration.options && this._Iteration.options.selectedIndex != -1) 
												newLoc += "\\" + this._Iteration.options[this._Iteration.options.selectedIndex].text;
										}
										resolvedPath.push(newLoc);
										break;
									}
								}
							}
						}
					}
				}	
			}
			dojox.data.dom.removeChildren(this._sharedPath);
			var len3 = locations.length;
			for ( var i = 0; i < len3; i++ ) {
				var option = new Option(allLocations ? locations[i] : resolvedPath[i], allLocations ? locations[i] : resolvedPath[i]);
				SelectUtility.add( this._sharedPath, option );
			}
			var shareLocation = this._sharedPath.value;
			var args = {
					resourceType: "folder",
					resourceName: shareLocation,
					resourceURN: shareLocation
				}
			this.startBrowsing(args);
		},
		
		_fillSharedLocations: function(prefEntry) {			
			var locations = prefEntry ? dojo.fromJson(prefEntry.value) : [];
			var len = locations.length;
			for ( var i = 0; i < len; i++ ) {
				var option = new Option(locations[i], locations[i]);
				SelectUtility.add( this._sharedPath, option );
			}
			this.locations = locations;
			if(this.locations.length == 0){
				this._message.innerHTML = Constants.getMessage("msgNoSharedLocation");
				this._containerNode.style.display = "none";
			}else{
				this._message.innerHTML = "";
				this._containerNode.style.display = "inline";
			}
			this._pathUpdated();
		},
				
		_pathUpdated: function(event){
			if(this._TP.value == "global"){
				this.initialPath = this._sharedPath.value;
			}
			var args = {
				resourceType: "folder",
				resourceName: this.initialPath,
				resourceURN: this.initialPath
			}
			this.startBrowsing(args);
			if(event){
                 dojo.stopEvent(event);
            }
		},

//////////////////////////Browsing functions///////////////////

		startBrowsing:function(startResource){
			this.folderHistory =[];
			this.selectedFiles = [];
			this.sharedLocationPath = this._sharedPath.value; 
			dojox.data.dom.removeChildren(this._table);
			this.initialize(startResource)
		},


		initialize: function(resource){
			var img = document.createElement('img');
			img.src = CommonImageCache.VIEW_PROGRESS;
			var label = document.createElement('label');
			label.innerHTML = Constants.getMessage("labelLoadingContent");
			dojo.addClass(label, "loading-label");
			
			dojox.data.dom.removeChildren(this._table);
			this._table.appendChild(img);
			this._table.appendChild(label);
			
			var params = {
				dataStorePath: resource.resourceURN,
				projectArea: getCurrentProjectArea().itemId
			}
			params.isFilterByExtensionDisabled = this._checkboxValue.checked
			params.filterExtension = this.scriptType ? this.scriptType.fileExtension : null;
			this.currentDataStorePath = params.dataStorePath;
			
			this._updateBreadCrums(resource);
			if(params.dataStorePath){
				var responseHandler = new ServiceResponseHandler(this, "_updateInfo", "_error");			
				com.ibm.rqm.execution.web.client.internal.executionframework.ResourceClient.getResourcesInfo(responseHandler, params);
			}else if(params.dataStorePath == ""){
				//Possible a plan was chosen where no sharelocation is found, show message
				dojox.data.dom.removeChildren(this._table);
				this._table.appendChild(document.createTextNode(Constants.getMessage("labelNoShareLocation")));
			}
		},
		
		getResources: function(){
			/*
			 * Change since 1.0.1
			 */
			//Unless specifically mentioned in the adapter to hide the extension, we show the extensions.
			//workitem 9603
			if(this.scriptType.showExtension){
				return this.selectedFiles;				
			}else{
				//Strip the extension
				var selectedFiles =  this.selectedFiles;
				var len = selectedFiles.length -1;
				for(var i=len ;i >= 0; i--){
					if(selectedFiles[i].resourceName.lastIndexOf(".") >= 0)
						selectedFiles[i].resourceName = selectedFiles[i].resourceName.substring(0, selectedFiles[i].resourceName.lastIndexOf("."));
				}
				return selectedFiles;
			}
		},
		
		_updateInfo: function(info){
			var returnVals = info && info.length > 0? info:  [];
			this._seperateFileFolders(returnVals);	
		},
		
		_seperateFileFolders: function(values){
			this.folders = [];
			this.files = [];
			var len = values.length;
			for(var i=0;i<len;i++){
				if(values[i].resourceType == "folder")
					this.folders.push(values[i]);
				else
					this.files.push(values[i])	
			}
			var res = values && values.length > 0 ? values[0] : ""
			this._buildBrowseArea();
		},
		
		_updateBreadCrums: function(res){
			this._updateFolderHistory(res);
			dojox.data.dom.removeChildren(this._breadcrums);
			var folderHistory = this.folderHistory;
			var len = folderHistory.length;
			for(var i=0;i<len;i++){
				var node = document.createElement('label');
				node.innerHTML = folderHistory[i].resourceName;
				if(i<folderHistory.length-1){
					node.className = "bread-crums";
					this.connect(node, "onclick", this._handleBreadCrumClick);
				}	
				node.resource = folderHistory[i];
				this._breadcrums.appendChild(node);
				if(i<folderHistory.length-1){	
					var seperatorString = " > ";
					var sepLabel = document.createElement('label');
					sepLabel.innerHTML = seperatorString;
					this._breadcrums.appendChild(sepLabel);
				} 
			}
		},
		
		_updateFolderHistory: function(res){
			var found = false;
			var tempFolderList = [];
			
			var resource = {
				resourceName: res.resourceName,
				resourceURN: res.resourceURN
			}
			var folderHistory = this.folderHistory;
			var len = folderHistory.length;
			for(var i=0;i<len; i++){
				if(folderHistory[i].resourceURN == resource.resourceURN){
					found = true;//Folder is found from the prev fetched list.
					tempFolderList.push(folderHistory[i])
					break;
				}else
					tempFolderList.push(folderHistory[i])
			}
			if(!found){
				//New Folder
				tempFolderList.push(resource);
			}	
			this.folderHistory = tempFolderList;
		},
		
		_buildBrowseArea: function(){
			var doc = document;
			var folders = this.folders;
			var len = folders.length;
			dojox.data.dom.removeChildren(this._table);
			
			if(this.folderHistory && this.folderHistory.length > 1){
				var span = doc.createElement('span');
				span.className = "span-file";
				span.style.cursor = "pointer";
				span.resourceInfo = this.folderHistory[this.folderHistory.length - 2 ];
				var img = doc.createElement('img')
				img.src = ImageCache.FOLDER;
				img.style.verticalAlign="middle";
				var name = doc.createElement('label');
				name.innerHTML = "..";
				name.style.verticalAlign = "middle";
				name.style.cursor = "pointer";
				this.connect(span, "onclick", this._onDoubleClick);//Single click move up
				span.appendChild(img);
				span.appendChild(name);
				this._table.appendChild(span);
				this._table.appendChild(doc.createElement('br'));
			}
			
			for(var i=0;i<len;i++){
				var span = doc.createElement('span');
				span.className = "span-file";
				span.style.cursor = "pointer";
				span.resourceInfo = folders[i];
				var img = doc.createElement('img')
				img.src = ImageCache.FOLDER;
				img.style.verticalAlign="middle";
				var name = doc.createElement('label');
				name.innerHTML = folders[i].resourceName;
				name.style.verticalAlign = "middle";
				name.style.cursor = "pointer";
				this.connect(span, "onclick", this._onFolderClick);
				span.appendChild(img);
				span.appendChild(name);
				this._table.appendChild(span);
				this._table.appendChild(doc.createElement('br'));
			}
			var files = this.files;
			var len2 = files.length;
			for(var i=0;i<len2;i++){
				var span = doc.createElement('span');
				span.className = "span-file";
				span.id = this.FILE_ID+i;
				var img = doc.createElement('img')
				img.src = ImageCache.FILE;
				img.style.verticalAlign="middle";
				var name = doc.createElement('label'); 
				name.innerHTML = files[i].resourceName;
				name.style.verticalAlign = "middle";
				span.appendChild(img);
				span.appendChild(name);
				span.resource = files[i];
				this.connect(span, "onclick", this._onFileClick);
                
                // The browser would select and highlight the text in
                // the path of a shift click selection. Clear the text selection
                // highlight to avoid confusion.
                this.connect(span, "onmouseup", this._clearTextSelection);
				this._table.appendChild(span);
				this._table.appendChild(doc.createElement('br'));
				this._checkSelectionHistory(span);
			}
		},
		
		_checkSelectionHistory: function(span){
			var currentURN = span.resource.resourceURN;
			var selectedFiles = this.selectedFiles;
			var len = selectedFiles.length;
			for(var i=0;i<len;i++){
				if(selectedFiles[i].resourceURN == currentURN ){
					dojo.addClass(span, "selected-file");
					if(this.singleSelect == true)
						this.prevNode = span;
					break;
				}	
			}
		},
		
		_onFileClick: function(e){
			var time = new Date().getTime();
			var delay = dojo.isIE ? this.IEclickDelay : this.clickDelay; 
			if (delay > (time - this.fileLastClickedTime)) {//capture double-click quickly and then validate
				if (this.callback && dojo.hasClass(e.currentTarget, "selected-file") && 
						e.currentTarget.resource.resourceURN == this.prevNode.resource.resourceURN) {
					this.selectedFiles = [];
					this.selectedFiles.push(e.currentTarget.resource);
					this.callback();
					return false;
				}
			}
			this.fileLastClickedTime = time;
			var selected = false;
			if(!dojo.hasClass(e.currentTarget, "selected-file")){
				if(e.currentTarget.resource)
					this.selectedFiles.push(e.currentTarget.resource);
				dojo.addClass(e.currentTarget, "selected-file");
				selected = true;
			}else{
				var currentURN = e.currentTarget.resource.resourceURN;
				var index = -1;
				var found = false;
				var selectedFiles = this.selectedFiles;
				var len = selectedFiles.length;
				for(var i=0;i<len;i++){
					if(selectedFiles[i].resourceURN == currentURN ){
						found = true;
						index = i;
						break;
					}
				}
				if(index != -1)
					this.selectedFiles.splice(index, 1);
				dojo.removeClass(e.currentTarget, "selected-file");
			}
			if(this.singleSelect == true){
				var newFile = this.selectedFiles[this.selectedFiles.length -1];
				this.selectedFiles =[];
				if(newFile)//possible unselection so check for file before putting
					this.selectedFiles.push(newFile);
				var currentURN = newFile && newFile.resourceURN ? newFile.resourceURN : "unselected";//non-nls
				var prevURN = this.prevNode && this.prevNode.resource ? this.prevNode.resource.resourceURN : "";//Need to make this differnt from above   
				if(this.prevNode && currentURN != prevURN)//On clicking same node repeatedly
					dojo.removeClass(this.prevNode, "selected-file");
			}else{
				if(e.shiftKey && this.prevNode){
					var selectAll = false;
					if(dojo.hasClass(this.prevNode,"selected-file")&& selected)
						selectAll = true;
					//range selection/unselection
					var prevId = this._getFileNum(this.prevNode.id);
					var currId = this._getFileNum(e.currentTarget.id);
					var start = parseInt(prevId,10);
					var end = parseInt(currId,10);
					if(end < start){
						start = end;
						end = parseInt(prevId,10);
					}
					var selectedFiles = this.selectedFiles;
					var len = selectedFiles.length;
					for(var i=start;i<end+1;i++){
						var spanNode = dojo.byId(this.FILE_ID+i);
						if(spanNode){
							var selectedURN = spanNode.resource.resourceURN;
							var selectedIndex = -1;
							for(var j=0;j<len;j++){
								if(selectedFiles[j].resourceURN == selectedURN ){
									selectedIndex = j;	
									break;
								}
							}
							if ((selectedIndex == -1) && selectAll) {
								this.selectedFiles.push(spanNode.resource);
								dojo.addClass(spanNode, "selected-file");
							}
							if ((selectedIndex != -1) && !selectAll) {
								this.selectedFiles.splice(selectedIndex, 1);
								dojo.removeClass(spanNode, "selected-file");
							}
						}
					}
				}
			}
			this.prevNode = e.currentTarget;
			if (e.stopPropagation) {//FF
				e.stopPropagation();
            	e.preventDefault();
			}//IE
			e.cancelBubble = true;
			e.returnValue = false;
			return false;
		},

        // Clears the text selection as a by product of shift click
        // selection of items. The browser would select the range of 
        // text that falls in the shift click event. This is shown as
        // another highlight on top of the selected items highlight.
        // 
        _clearTextSelection: function()
        {
            var txt;
            try {
                if (window.getSelection) {
                    txt = window.getSelection();
                    
                    if(txt)
                        window.getSelection().removeAllRanges(); 
                }
                else if (document.selection){
                    txt = document.selection.createRange().text;
                    if(txt)
                        document.selection.empty();
                }
            }
            catch (e) {
                // Just in case the browser doesn't support selection clearing.
            }
        },
        
		_getFileNum:function(fileId){
			return fileId.substr(fileId.lastIndexOf("_") + 1);
		},
		_onFolderClick: function(e){
			//Simulate Double click
			var time = new Date().getTime();
			var delay = dojo.isIE ? this.IEclickDelay : this.clickDelay;
			if(delay > (time - this.lastClickedTime)){
				this._onDoubleClick(e);
			}else{
				this.lastClickedTime = time;
			}
		},
		
		_onDoubleClick: function(e){
			this.initialize(e.currentTarget.resourceInfo);
		},
		
		_handleBreadCrumClick: function(e){
			this.initialize(e.currentTarget.resource);
		},
		
		_handleCheckboxSelectionChanged: function(){
			var currentResourceURN = {resourceURN: this.currentDataStorePath};
			this.initialize(currentResourceURN);
		},
		
		_error: function(errorObj){
			dojox.data.dom.removeChildren(this._table);
			this._table.appendChild(document.createTextNode(errorObj.message));
			console.error("Error in File Browser "+ errorObj.message + " ");
			
		}        
    });
    
})();
