//TestRecordView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");
(function() {
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var CollapsibleSection				= com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection;
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var _AbstractEditorSection			= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection;
var ASQUtility 						= com.ibm.asq.common.web.ui.internal.util.Utility;
var Utility 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView", [dijit._Widget, dijit._Templated, _AbstractEditorSection],
{
		templateString: "<div><div dojoAttachPoint=\"detailSection\"></div></div>",
		
		_initialized: false,
		
		postCreate: function(){
			this.initialize();
		},
		
		initialize: function(){
			this._initialized = false;
			this._createLayout();
		},

		_createLayout: function(sequence){
			if(!dojo.getObject("com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails")){
				if(!dojo.getObject("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp")){
					jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp", dojo.hitch(this,function(){
						jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails", dojo.hitch(this, "_createDetailsView"));
					}));
				}else{
					jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails", dojo.hitch(this, "_createDetailsView"));
				}
			}
			else{
				this._createDetailsView();
			}	
			this._initialized = true;
			var modsNeeded = [];
			modsNeeded.push("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
			modsNeeded.push("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper");
			modsNeeded.push("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
			Utility.loadModules(modsNeeded);
		},
		
		_createDetailsView: function(){
			this.cleanUpNode(this.detailSection);
			//dojox.data.dom.removeChildren(this.detailSection);
			this.detailTableView = new com.ibm.rqm.execution.web.ui.internal.view.extension.SequenceTestRecordDetails({mySection: this});
			this.detailTableView.initialize({/*suite/suite proxy object*/});
			this.detailSection.appendChild(this.detailTableView.domNode);
			this.testRecordAdded(this.details.attributes.record, this.details.attributes.type);
		},
		
		testRecordAdded: function(item, type){
			this.recordType = type;
			var args = {
					id: item.id,
					resolveWorkItems: false,
					resolveCurrentResult: false,
					resolveSection: false,
					resolveElements: true,
					resolveElementsResult: false,
					resolveElementsRequest: false,
					resolveElementsTestcase: true,
					resolveElementFullTestase: false,
					includeArchived:true
				}
			if(type == Constants.MODEL_TYPE_SUITE){
				args.resolveMinimalPlan = true;
				var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(this, "_updateDetailsSectionWithSuite", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler, args);
			}else{
				args.resolvePlan =  true;
				args.resolvePhase = true;
				var responseHandler = new ServiceResponseHandler(this, "_updateDetailsWithTER", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, args);
			}
		},
		
		_updateDetailsWithTER: function(items){
			var item = null;
			if(items.length > 0)
				item = items[0];
			else
				item = items;
            
            if (item.archived) {        
                this.getParentEditor().setArchivedItemStepContents(item.name);
            }
            			
			/*
			 * Since the section understands the format of a suite, 
			 * convert the TER into a suite proxy
			 */
			item.testPhase = item.phase;	
			var suiteProxy = {elements: []};
			suiteProxy.elements.push({index: 0, adapterId: 0, workitem: item});	
			suiteProxy.id = item.id;
			suiteProxy.name = item.name ? item.name : item.testCase.name;
			//Replace CurrentResutlGroup here
			suiteProxy.currentResultGroup = this.details.attributes.record.currentResultGroup ? this.details.attributes.record.currentResultGroup : null;
			suiteProxy.executionRecordType = Constants.MODEL_TYPE_EWI;	
			this.setDetailsTableContent(suiteProxy);	
		},
		
		_updateDetailsSectionWithSuite: function(items){
			var item = null;
			if(items.length > 0)
				item = items[0];
			else
				item = items;

            if (item.archived) {        
                this.getParentEditor().setArchivedItemStepContents(item.name);
            }				
				
			item.currentResultGroup = this.details.attributes.record.currentResultGroup;
			item.executionRecordType = Constants.MODEL_TYPE_SUITE;	
			this.setDetailsTableContent(item);		
		},
		
		setDetailsTableContent: function(suite){
			if(this.detailTableView)
				this.detailTableView.initialize(suite);
		},
		
		//Over-ridden from _AES
		validate: function(){
			if(this.detailTableView)
				return this.detailTableView.validate();
			else
				return true;	
		},
		
		//Over-ridden from _AES
		getAttributes: function(){
			var details = this.detailTableView.getAttributes();
			var attributes = {
				type: Constants.TYPE_TEST,
				attributes: dojo.toJson(details)
			}
			return attributes;
		},
		
		onActivated: function(){
			if(this.detailTableView)
				this.detailTableView.onActivated();
		},
		
		cleanUpNode: function(node){
			if(node){
				ASQUtility.destroyWidgetsFromNode(node);
				dojox.data.dom.removeChildren(node);	
			}
		},
		
		uninitialize: function(){
			if(this.detailTableView)
				this.detailTableView.destroy();
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from TestRecordView#_error");
		}
	}
);
}
)();