/**BuildTable***************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildTableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");

(function() {
var TableConstants 		= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var BuildUiUtil			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var ImageCache			= com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache;
var CommonImageCache	= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;

dojo.declare("BuildDefTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    },
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});
dojo.declare("BuildDefTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    getNumColumns: function(content){
        return 3;
    },
    
    _columnHeadings: [
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription")
    ],
    
    ids: [
        "statusIds",
        "name",
        "description"
    ],
    
    getColumnIdName: function(index){
        return this.ids[index];
    },
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    getIsColumnGroupable: function(content, atColumnIndex){
        // no groupable columns
	 	return false;
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex == 1||atColumnIndex == 2);  
    },

    _columnWidths: [12,30,58],

    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return rowData.id;
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		if (atColumnIndex == 0) {
			if (rowData.state) {
				type = TableConstants.RENDER_TYPE_IMAGE;
			}else
				return type;
		}else if (atColumnIndex == 1) {
			return TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
		switch (atColumnIndex) {
			case 0:
				val = rowData.state? BuildUiUtil.getDisplayName(rowData.state.stateId,rowData.state.displayName):"";
				break;
			case 1:
				val = rowData.name || "";
				break;
			case 2:
				val = rowData.description || "";
				break;
		}
        return val;				       
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = {};
		switch(atColumnIndex){
			case 0:
				if(rowData.state && (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.ok" || rowData.state == "OK")){
					val.image = ImageCache.BUILD_STATUS_SUCCESS;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelOK"));
				}else if(rowData.state && (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.error" || rowData.state == "Error")){
					val.image = ImageCache.BUILD_STATUS_ERROR;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelError"));
				}else if (rowData.state && (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstatus.inprogress" || rowData.state == "In Progress")){
					val.image = ImageCache.BUILD_STATUS_INPROGRESS;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelInProgress"));
				}else if (rowData.state && (rowData.state.stateId == "com.ibm.buildintegration.common.states.unassigned" || rowData.state == "Unassigned")){
					val.image = ImageCache.BUILD_STATUS_UNASSIGNED;
					val.tooltip = BuildUiUtil.getMessage("labelUnassigned");
				}else
					val.image = CommonImageCache.NOIMAGE;
				break;
			case 1:
				val.href = BuildUiUtil.getBuildDefURI(rowData.id);
		}
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildDefTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '</div>',

    widgetsInTemplate: false,
    
    constructor: function() {
        this.showQueryFilters = true;  // default to show filters
	},

    postCreate: function(){
        // initialize options for the view builder, search and callback methods are
        // set in BuildDefList.js
        this.setTypeLabel(BuildUiUtil.getMessage("labelBuildDefs"));
        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        // apply the user preference whether to initially open the view builder
        if (this.showQueryFilters) {
			setTimeout(dojo.hitch(this,function(){
				this._initialize();
			}),0);
            this._initializeFilters();             
        }else{
			this._initialize();
			this._initialize2();
		}
    },

    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildTableContentFilterProvider(
            this,
            this.isInitiallyOpen(),
            Constants.getMessage("labelFilterDescriptionAllVisible", BuildUiUtil.getMessage("labelBuildDefs")),
            2
        );
        
        var providerFilters = this.filterProvider.filters;
        
        providerFilters.push({
            name: "description", // must match key in the arg list of the API
            title: Constants.getMessage("labelDescription"),
            promptTitle: Constants.getMessage("labelDescription"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null,
            params: null
        });

        this.filterProvider.addStatusFilter(providerFilters, dojo.hitch(this, "_initialize2"));
    },
	_initialize2:function(){
		if (this.showQueryFilters) {
            this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
		this.initRunQuery();
	},
    _initialize: function(){
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({autoSaveSettings:true,allowAdjustSettings:true});
		this.tableViewer.tableId = "RQM-BUILD-DEF-TABLEVIEWER";
        this._tableViewerNode.appendChild(this.tableViewer.domNode);	
        this.tableViewer.setContentProvider(this._constructTableContentProvider());
		this.tableViewer.setTableListener(new BuildDefTableView.TableListener());
		this.tableViewer.setTableSummary(BuildUiUtil.getMessage("labelTableSummary", BuildUiUtil.getMessage("labelAllBuildDefs")));
        this.tableViewer.setTableRowsCheckable(false, false);
		this.refreshBtn = this.tableViewer.addAction("refresh", BuildUiUtil.getMessage("labelRefresh"), 
					this, "refresh-icon-image", dojo.hitch(this, "refresh"));
		this.setContent(this.builds);
        this.tableViewer.show();
    },
    _constructTableContentProvider: function() {
        //create the table provider
        this.provider = new BuildDefTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });    
        return this.provider; 
    },

	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		this.builds = content? content:[];
		this.tableViewer.setContent(this.builds);	
	},
	refresh:function(){
		this.refreshBtn.setDisabled(true);
		this.refreshQuery();
	},
	refreshTable:function(content){
        this.builds = content? content:[];

        // we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        if (this.updatePageOnly) {
            this.provider.loadPageContent(content);
        }
        else {
            this.tableViewer.setContent(content);
            this.tableViewer.refresh();
        }
		this.refreshBtn.setDisabled(false);
	}
	});

})();
