/**BuildTable***************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildTableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var BuildUiUtil				= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var ImageCache				= com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
var Utility 				= com.ibm.asq.common.web.ui.internal.util.Utility;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;

dojo.declare("BuildTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(parentView) {
        this.parentView = parentView;
    },
    rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount = realSelection ? selection.length : tableViewer.getContentPageSize(); // use the page size for select all

        if (this.parentView.deleteActionNode && this.parentView.editable)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
		//if table view has a rowCheckListener, invoke it
        var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener) && p.editable) {
            p.rowCheckedListener(rowObject, state);
        }	
		
	},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    },
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("BuildTableView.TableContentProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
	constructor: function(args) {
        dojo.mixin(this, args);
		this.pendingString = BuildUiUtil.getMessage("labelPending");
    },
    getNumColumns: function(content){
		if(this.min_profile != null)
			return 4;
        return 7;
    },
 
    ids: [
        "statusIds",
        "stateIds",
        "name",
        "description",
        "completionDateTime",
        "bvtStatus",
        ""
    ],
    
    getColumnIdName: function(index){
        return this.ids[index];
    },

    _columnHeadings: [
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelState"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription"),
		BuildUiUtil.getMessage("labelCompletionTime"),
		BuildUiUtil.getMessage("labelBvtStatus"),
		BuildUiUtil.getMessage("labelTestsRun")
    ],
 
    _columnHeadingsMin: [
        BuildUiUtil.getMessage("labelStatus"),
		BuildUiUtil.getMessage("labelState"),
		BuildUiUtil.getMessage("labelBuild"),
		BuildUiUtil.getMessage("labelDescription")
    ],

    getColumnHeading: function(content, index){
		var headings = this.min_profile ? this._columnHeadingsMin : this._columnHeadings;
        return headings[index];
    },
    
    getIsColumnGroupable: function(content, atColumnIndex){
		return (atColumnIndex != 6);
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex != 6);     
    },
    getColumnWidth: function(content, atColumnIndex){
		if(!this.min_profile){
			switch (atColumnIndex) {
				case 0:
					return 5;
				case 1:
					return 5;
				case 2:
					return 15;
				case 3:
					return 30;
				case 4:
					return 15;
				case 5:
					return 15;
				case 6:
					return 15;
			}
		}else{
			switch (atColumnIndex) {
				case 0:
					return 10;
				case 1:
					return 15;
				case 2:
					return 30;
				case 3:
					return 45;
			}
		}
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
		if(rowData.buildRecord)
			return rowData.buildRecord.id;
		return rowData.id;  
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        
        if(atColumnIndex == 4) {
            return TableConstants.RENDER_TYPE_DATE;
        }
		if(atColumnIndex > 2)
			return type;
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		if (atColumnIndex == 0) {
//			if (buildRecord.status) {
//				if (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.inprogress" || buildRecord.status == "In Progress")
//					return type; 
//				else if(buildRecord.status.stateId == "com.ibm.buildintegration.common.states.unassigned" || buildRecord.status == "Unassigned")
//					return type;
//				else
					type = TableConstants.RENDER_TYPE_IMAGE;
//			}else
//				return type;
		}
		else if (atColumnIndex == 1) {
//			if (buildRecord.state) 
				type = TableConstants.RENDER_TYPE_IMAGE;
		}else{
			if (buildRecord.name) 
				type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		switch (atColumnIndex) {
			case 0:
				val = buildRecord.status ? BuildUiUtil.getDisplayName(buildRecord.status.stateId, buildRecord.status.displayName) : "";
				break;
			case 1:
				val = buildRecord.state ? BuildUiUtil.getDisplayName(buildRecord.state.stateId, buildRecord.state.displayName) : this.pendingString;
				break;
			case 2:
				val = buildRecord.name || this.pendingString;
				break;
			case 3:
				val = buildRecord.description || "";
				break;
			case 4:
                if (buildRecord.endTime > -1) {
                    val = new Date(); //Completed
                    val.setTime(buildRecord.endTime);
                }
				break;
			case 5:
				val = BuildUiUtil.getResultString(rowData.rollupstate || "");
				break;
			case 6:
				val = rowData.totalPass && rowData.totalSteps ? rowData.totalPass + "/" + rowData.totalSteps : "";
				break;
		}
        return val;				       
    },
    
    getCellRawData: function(rowData, atColumnIndex)
    {
        if (atColumnIndex == 4) {
            var buildRecord = rowData.buildRecord ? rowData.buildRecord : rowData;
            return buildRecord.endTime || "";
        }
        return this.getCellDisplayData(rowData, atColumnIndex);
    },  
          
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = {};
		var buildRecord = rowData.buildRecord?rowData.buildRecord:rowData;
		switch(atColumnIndex){
			case 0:
				if(buildRecord.status && (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.ok" || buildRecord.status == "OK")){
					val.image = ImageCache.BUILD_STATUS_SUCCESS;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelOK"));
				}else if(buildRecord.status && (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.error" || buildRecord.status == "Error")){
					val.image = ImageCache.BUILD_STATUS_ERROR;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelError"));
				}else if (buildRecord.status && (buildRecord.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.inprogress" || buildRecord.status == "In Progress")){
					val.image = ImageCache.BUILD_STATUS_INPROGRESS;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelInProgress"));
				}else if (buildRecord.status && (buildRecord.status.stateId == "com.ibm.buildintegration.common.states.unassigned" || buildRecord.status == "Unassigned")){
					val.image = ImageCache.BUILD_STATUS_UNASSIGNED;
					val.tooltip = BuildUiUtil.getMessage("labelUnassigned");
				}else
					val.image = CommonImageCache.NOIMAGE;
				break;
			case 1:
				val.image = CommonImageCache.NOIMAGE;
				if (buildRecord.state) {
					if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.complete" || buildRecord.state.displayName == "Complete") {
						val.image = ImageCache.BUILD_COMPLETED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelComplete"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.running" || buildRecord.state.displayName == "Running") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelRunning"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.inprogress" || buildRecord.state.displayName == "In Progress") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelInProgress"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.queued" || buildRecord.state.displayName == "Queued") {
						val.image = ImageCache.BUILD_QUEUED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelQueued"));
					}else if (buildRecord.state.stateId == "com.ibm.rqm.buildintegration.buildstate.cancelled" || buildRecord.state.displayName == "CANCELLED") {
						val.image = ImageCache.BUILD_CANCELLED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelCancelled"));
					}else if (buildRecord.state.stateId == "com.ibm.buildintegration.common.states.unassigned" || buildRecord.state == "Unassigned"){
						val.image = ImageCache.BUILD_UNASSIGNED;
						val.tooltip = BuildUiUtil.getMessage("labelUnassigned");						
					}
				}else{
					val.image = ImageCache.BUILD_RUNNING;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelPending"));
				}
				break;
			case 2:
				if(buildRecord.name)
					val.href = BuildUiUtil.getBuildRecordURI(buildRecord.id);
		}
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '</div>',

    widgetsInTemplate: false,
	rowCheckedListener:null,
	tableRowsCheckable:null,
	min_profile:null,
	editable:true,
    
    constructor: function(args) {
		this.actions = args.actions?args.actions:[];
		this.tableRowsCheckable = args.tableRowsCheckable;
		this.min_profile = args.min_profile;
		this.editable = args.editable;
		this.consoleNode = args.consoleNode;
        this.showQueryFilters = true;  // default to show filters
        this.builds = [];
	 },

    postCreate: function(){
        // initialize options for the view builder, search and callback methods are
        // set in BuildList.js
        this.setTypeLabel(BuildUiUtil.getMessage("labelBuildRecords"));
        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        
        // this is an initial table inside the build def. 
        // this is not going to be a paged content table.
        if (this.buildDefId && this.buildDefId == -1) {
            this.contentIsVirtual = false;
        } 
		setTimeout(dojo.hitch(this,function(){
			this._initialize();
		}),0);       
        // apply the user preference whether to initially open the view builder
        if (this.showQueryFilters) {
            this._initializeFilters();             
        }
    },

    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildTableContentFilterProvider(
            this,
            this.isInitiallyOpen(),
            Constants.getMessage("labelFilterDescriptionAllVisible", BuildUiUtil.getMessage("labelBuildRecords")),
            5,
            true // include BVT status filter
        );
        var providerFilters = this.filterProvider.filters;

        providerFilters.push({
            name: "description", // must match key in the arg list of the API
            title: Constants.getMessage("labelDescription"),
            promptTitle: Constants.getMessage("labelDescription"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null,
            params: null
        });
        
        this.filterProvider.addStatusAndStateFilter(providerFilters, dojo.hitch(this, "_initialize2"));
        var dateTimeFilter = {
            processFilter: true,  // let superclass process our time filters
            name: "completionDateTime",  // must match what is used in the column id of the content provider and runQuery()
            fromKey: "startTime", // remap to server expected arg name
            toKey: "endTime",
            label: BuildUiUtil.getMessage("labelCompletionTime") + Constants.getMessage("labelColen"),
            prompt: BuildUiUtil.getMessage("labelCompletionTime")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, providerFilters);
    },
	_initialize2:function(){
		if (this.showQueryFilters && this.buildDefId!=-1) {
            this.initFilterProvider(this.filterProvider);
            // run initial query if it is not for a new build definition
            this.initRunQuery();
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
	},
    _initialize: function(){
		var allowAdjustSettings = this.min_profile?false:true;
		var args = {
            handleVirtualSelectAll: true,            
            autoSaveSettings: allowAdjustSettings,
            allowAdjustSettings: allowAdjustSettings
        }
		if(!this.min_profile){
			args.sortByColumn = 5;
			args.sortDir= TableConstants.SORT_DIR_DESCEND;
		}
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(args);
		if(allowAdjustSettings)
			this.tableViewer.tableId = this.consoleNode? "RQM-BUILD-RECORD-TABLEVIEWER":"RQM-BUILD-QUERY-TABLEVIEWER";
        this._tableViewerNode.appendChild(this.tableViewer.domNode);	
        this.tableViewer.setContentProvider(this._constructTableContentProvider());
		this.tableViewer.setTableListener(new BuildTableView.TableListener(this));
		this.tableViewer.setTableSummary(BuildUiUtil.getMessage("labelTableSummary", BuildUiUtil.getMessage("labelAllBuilds")));
        this.tableViewer.setTableRowsCheckable(this.tableRowsCheckable, (this.singleSelectable ? this.singleSelectable : false));
        if(this.buildDefId!=-1)
		  this.refreshBtn = this.addAction({
				name:"refresh", label:BuildUiUtil.getMessage("labelRefresh"), 
				context:this, icon:"refresh-icon-image",callback: dojo.hitch(this, "refresh")});
		for(var i=0;i<this.actions.length;i++){
			var actionBtn = this.addAction(this.actions[i]);
			if(!this.editable)
				actionBtn.setDisabled(true);
		}
		this.setContent(this.builds);
        this.tableViewer.show();
        if ((!this.buildDefId || this.buildDefId == -1) && dojo.isFunction(this._searchCallback)) {
            this._searchCallback(this.builds);
            this.tableViewer.endLoadingProgress();
        }
    },

    _constructTableContentProvider: function() {
        //create the table provider
        this.provider = new BuildTableView.TableContentProvider({
            min_profile: this.min_profile, 
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });    
        return this.provider; 
    },
        
	addAction:function(action){
		if(action.name == "removeBuildRec"){
			this.deleteActionNode = this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback); 
			this.deleteActionNode.setDisabled(true);
			return this.deleteActionNode;
		}else
			return this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback);
	},
	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		this.builds = content? content:[];
		this.tableViewer.setContent(this.builds);	
	},

    // @override to add in our extra query arguments.
    _remapQueryArgs: function(filterArgs) {
        var args = this.inherited("_remapQueryArgs", arguments);
        
        //Include the buildDefId filter parameter
        if (this.buildDefId && this.buildDefId != -1 && args) {
            args.buildDefId = this.buildDefId; 
        }
        return args;
    },
    
    // @override 
	runQuery: function(filterArgs, updatePageOnly) {
	    /**
	     * We have 3 cases here:
	     * if this.buildDefId=null we will return all filtered build records
	     * if this.buildDefId=-1  we won't do the search, because it means it were called from new build def.
         * if this.buildDefId=N we will filter the build records that belongs to the 
         * specified Build Definition Id (handled by _remapQueryArgs)
	     */
	    if (this.buildDefId && this.buildDefId==-1){
	       if (dojo.isFunction(this._searchCallback)) {
                this._searchCallback([]);
                this.tableViewer.endLoadingProgress();
           }
        } else {
            this.inherited("runQuery", arguments);
        }	          
    },
	refresh:function(){
        if (this.refreshBtn) 
            this.refreshBtn.setDisabled(true);
            
        // this is the new build def case. No searching is required.
        if (this.buildDefId && this.buildDefId == -1) {
            this.tableViewer.showLoadingProgress();
            if (this.parentController) {
                this.parentController.initialize();
            }
            this.tableViewer.endLoadingProgress();
        }
        else {
            // in both query page & inside an existing build def page,
            // we can just refresh the query.
            this.refreshQuery();
        }
	},
	refreshTable:function(content){ 
        this.builds = content? content:[];

        // we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        if (this.updatePageOnly) {
            this.provider.loadPageContent(content);
        }
        else {
            this.tableViewer.setContent(content);
            this.tableViewer.refresh();
        }
		if(this.refreshBtn)
		  this.refreshBtn.setDisabled(false);		  
	},
	_convertLongToDate: function(/*accepts long*/longDate){
		var date = new Date();
		date.setTime(longDate);
		if(date == "Invalid Date")
			return "";
		return dojo.date.locale.format(date, {formatLength: "medium"});
		
	},
    // @override - to remove deselected items from the selected all set.
    // Build record rows are irregular objects, it has an outer object
    // that wraps around the actual record, buildRecord.
    //    compareFunc - not used. Replaced with our own comparator func.
    _removeDeselectedItems: function(idType, allItems, compareFunc)
    {
        var deselectedItems = this.tableViewer.getVirtualDeselectedRows();
        var dlen = deselectedItems.length;
        if(dlen > 0) {
            for(var i = 0; i < dlen; i++) {
                var item = deselectedItems[i];
                var deselectedObj = item.buildRecord ? item.buildRecord : item;
                var removeId = deselectedObj[idType];
                if(removeId) {
                    this._removeIdFromList(idType, allItems, removeId, 
                        // use our own comparator function to compare the id & a row's id.
                        function(idType, row, id){
                            var obj = row.buildRecord ? row.buildRecord : row;
                            return (obj[idType] == id);
                        }
                    );
                }
            }
        }
        return allItems;
    }    
});

})();
