/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");

(function(){
	var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var DOWNLOAD_SERVICE_URI = "com.ibm.rqm.integration.service.IIntegrationService/"; //RQM Downaload Service
    var ProcessAreaName = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().alias;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var DatapoolClient = com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
    var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
	var ActionPackage = com.ibm.rqm.planning.web.ui.internal.model.action;	
	var ActionEntityType = ActionPackage.ActionEntityType;	
	var ProgressUtility = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        constructor: function(parentView){
            this.parentView = parentView;
        },
        
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            var pv = this.parentView;
            var selection = tableViewer.getCheckedRows();
            var selectionCount = (dojo.isArray(selection)) ? selection.length : 2; // assign '2' to indicate more then 1 in select all
            var hasSelection = selectionCount > 0;
            
            if (pv.deleteActionNode) 
                pv.deleteActionNode.setDisabled(selectionCount == 0);
			if (pv.duplicateActionNode)
			    pv.duplicateActionNode.setDisabled(selectionCount == 0);			
            if (selectionCount == 1) {
            	pv.printActionNode.setDisabled(false);
            	dojo.style(this.parentView.printActionNode.domNode, "opacity", 1.0);
            }
    		else {
    			pv.printActionNode.setDisabled(true);
    			dojo.style(this.parentView.printActionNode.domNode, "opacity", 0.3);
    		}
        },
        
        groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
            this.rowCheckStateChanged(tableViewer, rowObjects, state);
        },
        
        tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
            if (callback != null && dojo.isFunction(callback)) {
                if (callbackData != null) {
                    callback(callbackData);
                }
                else {
                    callback();
                }
            }
        },

        tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
        {
            if(callback) {
                callback(actionId, filters);
            }                     
        }
    });
    
    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableProvider", 
                 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider, {
        getNumColumns: function(content){
            return 3;
        },
	    _columnHeadings: [
			Constants.getMessage("labelName"),
			Constants.getMessage("labelDescription"), 
			Constants.getMessage("labelDateFileDatapool")
    	],
        
        getColumnHeading: function(content, index){
	        return this._columnHeadings[index];
        },
        
        ids: [
            "name",
            "description",
            ""
        ],

        getColumnIdName: function(index){
            return this.ids[index];
        },

        getColumnHeadingImage: function(content, atColumnIndex){
            return null;
        },
        
        getIsColumnGroupable: function(content, atColumnIndex){
            return false;
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return atColumnIndex < 2;
        },
    	
    	_columnWidths: [20,50,30],
    	    
        getColumnWidth: function(content, atColumnIndex){
	        return this._columnWidths[atColumnIndex];
        },
        
        getContentObjects: function(content){
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.itemId;
        },
        
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_TEXT;
            if (atColumnIndex == 0 || atColumnIndex == 2) {
                type = TableConstants.RENDER_TYPE_LINK;
            }
            return type;
        },
        
        getCellAlignment: function(rowData, atColumnIndex){
            return TableConstants.ALIGN_LEFT;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.name;
                    break;
                case 1:
                    val = rowData.description;
                    break;
                case 2:
                    val = rowData.dataAttachment ? rowData.dataAttachment.fileName : "";
                    break;
            }
            return val;
        },
        
        getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = null;
            if (atColumnIndex == 0) {
                val = {};
                val.href = Utility.getViewDatapoolURI(rowData.itemId);
            }
            if (atColumnIndex == 2) {
                val = {};
				val.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + "resources/"+ ProcessAreaName + "/attachment/urn:com.ibm.rqm:attachment:"+(rowData.dataAttachment ? rowData.dataAttachment.id : "");
            }
            return val;
        }
    });
    
    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolContentFilterProvider",
        com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider, {

        constructor: function(tableView, openSection){
            this.tableView = tableView;
            this.initOpenFilter = openSection;
            
            // define the static filter
            this.filters = [];
            this.filters.push({
                name: "name", // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            });
            this.filters.push({
                name: "description", // must match key in the arg list of the API
                title: Constants.getMessage("labelDescription"),
                promptTitle: Constants.getMessage("labelDescription"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            });
        },
        
        getTitle: function(){
            return Constants.getMessage("labelFilterTitle");
        },
        
        getIsSectionOpenInitially: function(){
            return this.initOpenFilter;
        },
        
        getSummaryText: function(){
            return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelDatapool"));
        },
        
        getInitialVisibleFilterCount: function(){
            return 1;
        },
        
        getFilters: function(){
            return this.filters;
        },
        
        getFilterCount: function(){
            return this.filters.length;
        },
        
        getFilterName: function(index){
            return this.filters[index].name;
        },
        
        getFilterTitle: function(index){
            return this.filters[index].title;
        },
        
        getFilterPromptTitle: function(index){
            return this.filters[index].promptTitle;
        },
        
        getFilterType: function(index){
            return this.filters[index].type;
        },
        
        getFilterDefaultValue: function(index){
            return this.filters[index].defaultValue;
        },
        
        getFilterParams: function(index){
            return this.filters[index].params;
        },
        
        getCustomField: function(index){
            return null;
        },
        
        getActionsInfo: function(){
            var actions = [{
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }];
            return actions;
        },
        
        filterResetActionInvoked: function(actionName, filters){
            // reset the filters.
            this.tableView.tableViewer.clearContentFilters();
        },
        
        filterRunActionInvoked: function(actionName, filters){
            var args = {};
            
            for (var nameKey in filters) {
                if (filters[nameKey] != null) {
                    args[nameKey] = filters[nameKey] || "";
                    if (args[nameKey] == 'Any@@') {
                        args[nameKey] = '';
                    }
                }
            }
            this.tableView.runQuery(args);
        }
    });

    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView", 
                 [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView], 
    {
        templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',
		widgetsInTemplate: true,
        pdfPrintType: "datapool",  // define the pdf print type. Our super class will handle it.
        
        constructor: function(){
            this.datapools = null;
            this.refreshCallback = null;
            this.queryName = null;
            this.showInitLoadProgress = false;
            this.showQueryFilters = true;  // default to show filters
        },
        
        postCreate: function(){
			this.viewHeaderNode.setCSHelpId("rqm_all_data.html"); 
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAllDatapool")+Constants.getMessage("labelHelp"));

            // hook in the method to obtain all results' item ids.
            this._getAllResultsItemIds = dojo.hitch(DatapoolClient, "getAllSearchResultItemIds");
            
            // initialize options for the view builder
            this.setTypeLabel(Constants.getMessage("labelDatapool"));
            this.setSearchFunction(dojo.hitch(DatapoolClient, "getSearchDatapools"));
            this.setSearchCallback(dojo.hitch(this, "refresh"));

            if (this.postQueryFilterCallback) {
                this.setSearchFilterCallback(this.postQueryFilterCallback);
            }
        
            // apply the user preference whether to initially open the view builder
            if (this.showQueryFilters) {
                // create the filter provider for the table
                this.filterProvider = new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolContentFilterProvider(this, this.isInitiallyOpen());
            }
            this._initialize();
        },

        _initialize: function(){
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
                allowAdjustSettings: true,
                autoSaveSettings: true,
                handleVirtualSelectAll: true,            
                tableId: "RQM-DATAPOOL-TABLEVIEWER"                          
            });
            this.tableViewer = tableViewer;
            this._tableViewerNode.appendChild(tableViewer.domNode);
            
            var content = this.datapools ? this.datapools : [];
            this.queryName = this.queryName ? this.queryName : "Datapools";
            this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
            this.viewHeaderNode.setTitle(this.queryName);
            tableViewer.setContentPageSize(20);
            tableViewer.setContent(content);
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
            tableViewer.setContentProvider(this._constructTableContentProvider());
            tableViewer.setTableListener(new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableListener(this));
            for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
                var action = this.actions[i];
                // if a refresh action is added, need to rehook to our refresh action.
                if(action.id && action.id == "refresh") {
                    action.actionHandler = dojo.hitch(this, "refreshQuery");
                }
                tableViewer.addAction(action.label, action.label, this, action.iconClass, action.actionHandler);
            }
            var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_DATAPOOL);
            // archive support
            if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
                this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "invokeAction", "itemId", this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
            tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);

            if (this.showQueryFilters) {
                this.initFilterProvider(this.filterProvider);
                tableViewer.setContentFilterAttributeProvider(this.filterProvider);
            }

            tableViewer.show();
                        
            //print button content
    		var printMenu = new dijit.Menu({ style: "display: none;"});
            var historyOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelHistory"),
            	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")
            });
            printMenu.addChild(historyOption);
    		
           	this.printActionNode = tableViewer.addAction(
           			"printpdf",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick"),
           			printMenu
           	);      	

           	this.printActionNode.setDisabled(true);
			this.duplicateActionNode = tableViewer.addAction(
	        		"duplicate",
        			Constants.getMessage("labelDuplicateAction"),
	        		null,
        			"duplicate-icon-image",
        			dojo.hitch(this, "invokeAction", "itemId", this, "_onDuplicateActionClick"));
			this.duplicateActionNode.setDisabled(true);
			var duplicateAction = new DuplicateAction();
			duplicateAction.isDuplicateAllowed(ActionEntityType.DATAPOOL, dojo.hitch(this, "_isDuplicateAllowedCallback"));			
			
           	dojo.style(this.printActionNode.domNode, "opacity", 0.3);
           	//end print button content

            this.initRunQuery();
        },
		
		_onDuplicateActionClick: function(ids) {
			var duplicateAction = new  DuplicateAction();
			duplicateAction.setType(ActionEntityType.DATAPOOL);
			duplicateAction.execute(ids, dojo.hitch(this, "_invalidateQuery"), dojo.hitch(this, "_duplicateError"));		
		},

		_isDuplicateAllowedCallback: function(allowed){
			if(!allowed)
				this.duplicateActionNode.domNode.style.display = "none";			
		},
		
		_duplicateError: function(e){
			alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));		
		},
		
	    _constructTableContentProvider: function() {
            //create the table provider
            this.provider = new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableProvider({
                tableViewer: this,
                isVirtual: this.contentIsVirtual,
                currentPageIndex: this.currentPage,
                totalPageCount: this.totalPages,
                totalContentCount: this.totalSize || -1,
                pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
                
                vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
                {
                    // the table provider can be recreated many times
                    // we need to retain the current page size, page index, etc.
                    // when it is recreated.
                    this.pageSize = pageSize;
                    this.currentPage = pageIndex;
                    this.runQuery(null, /*updatePageOnly*/ true);
                }),
                vcRunQuery: dojo.hitch(this, function(pageSize)
                {
                    this.pageSize = pageSize;
                    this.queryToken = null;
                    this.runQuery(null, /*updatePageOnly*/ true);
                })
            });    
            return this.provider; 
        },
        
        _onDeleteActionClick: function(selectedIds) {
	        // check if any selected test cases are current displayed in another tabs
	        var openedArtifacts = [];
	        var selectedDPs = [];
            var selectedRows = this.tableViewer.getCheckedRows();
        
            if (dojo.isArray(selectedRows) && this.artifactsDisplayContainer) {
	            var userSelectedDPs = this.tableViewer.getCheckedRows();
	            var len = userSelectedDPs.length; 
	            if (len > 0) {
	                for (var i = 0; i < len; i++) {
	                    var dpURI = Utility.getViewDatapoolURI(userSelectedDPs[i].itemId);
	                    if (this.artifactsDisplayContainer.hasPage(dpURI)) {
	                        openedArtifacts.push(userSelectedDPs[i]);
	                    } else {
	                        selectedDPs.push(userSelectedDPs[i]);
	                    }
	                }
	            }
	        } else {
                // can't check for opened tab, just show the deleting confirmation
	            selectedDPs = null;
	        }
			var len2 = (selectedDPs) ? selectedDPs.length : selectedIds.length;
	        this.selectedDPs = selectedDPs;
	        var prompt = Constants.getMessage("msgDelDatapoolConfirm",len2);
	        if (openedArtifacts.length > 0) {
	            if (len2 > 0) {
	                // some selected artifacts are not opened in tabs
	                prompt = Constants.getMessage("msgDelSomeOpenDatapoolConfirm");
	            } else {
	                // all selected artifacts are opened in tabs
	                prompt = Constants.getMessage("msgDelAllOpenDatapoolConfirm");
	            }
	        }
	
	        var args = {
	            'message': prompt,
	            'options': openedArtifacts,
                'selectedIds': selectedIds,
	            'okCallback': 
	                function(view) {
	                    view._deleteAction();
	                },
	            'okCallbackData': this,
	            'cancelCallback': null,
	            'cancelCallbackData': null
	        };
	        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog(args);
	        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
	        this.confirmDialog.open();
	    },
	    
	    _deleteAction: function() {         
            var deleteIds;
            var dlg = this.confirmDialog;

            this.confirmDialog = null;
            if (this.selectedDPs) {
                this.selectedDPs = this.selectedDPs.concat(dlg.getSelection());
                var count = this.selectedDPs.length;
                deleteIds = [];
                for(var i = 0; i < count; i++) {
                    deleteIds.push(this.selectedDPs[i].itemId);
                }
            }
            else {
                // no special handling of opened items, just use all deleted ids.
                deleteIds = dlg.selectedIds;
            }
            var totalDeleteCnt = this.selectedDPCount = deleteIds.length;
	
	        if (totalDeleteCnt > 0) {
	            this.deleteActionNode.setDisabled(true);
	            this.errorDPCount = 0;
	            this.deletedDPCount = 0;
	
                this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingDatapool"), totalDeleteCnt, null);  
	            for (var i = 0; i < totalDeleteCnt; i++) {
	                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
	                DatapoolClient.archiveDatapool(responseHandler,
	                        {
	                            itemId: deleteIds[i],
	                            archive: true
	                        });
	            }
	        }
	    },
	    
	    _deleteSuccess: function(response) {
	        this.deletedDPCount++;
	        this._setDeleteStatus();
	
	    },
	    
	    _deleteFailure: function(err) {
	        this.errorDPCount++;
	        this._setDeleteStatus();
	    },
	    
	    _setDeleteStatus: function() {
            var currDeletedCnt = (this.deletedDPCount + this.errorDPCount);
        
            ProgressUtility.updateTask(this.monitorId, currDeletedCnt);
	        if (currDeletedCnt == this.selectedDPCount) {
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedDatapools", this.deletedDPCount, this.selectedDPCount),
                    this.errorDPCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedDPCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
                if (this.deletedDPCount > 0) {
	                // notify all pages (including itself) datapool are deleted
                    this._deleteFromSelf = true;
                    // TODO: virtual select all case don't have selectedScripts... need to use itemIds in
                    // notification.
	                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_DATAPOOL, this.selectedDPs]);
	            }
	        }
	    },
        
	    // handler on artifacts changed
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
            if (artifactType == Constants.TYPE_DATAPOOL) {
                if (this._deleteFromSelf && changeType == GlobalEvents.ArtifactsDeleted && this._invalidateQuery) {
                    this._invalidateQuery();
                    delete this._deleteFromSelf;
                    return;
                }
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_DATAPOOL, changeType);
            }
	    },	
        
        refresh: function(content){
			this.datapools = content;
            
            this.tableViewer.endLoadingProgress();
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content || []);
            }
            else {
                this.tableViewer.setContent(content || []);
                this.tableViewer.refresh();
            }
			var listener = this.tableViewer.getTableListener();
			if(listener)
				listener.rowCheckStateChanged(this.tableViewer);
            if (this.viewHeaderNode) {
                this.viewHeaderNode.clearStatus();
            }
        },
		
		setInProgress: function(msg) {
			this.viewHeaderNode.setProgressStart(msg);
		},
	
		stopInProgress: function() {
			this.viewHeaderNode.setProgressEnd();
		}
    });
    
})();
