//PreviewTable
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.PreviewScriptTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup");

(function() {

var TableViewer=com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var CommonUtility  = com.ibm.asq.common.web.ui.internal.util.Utility;
var Constants 		= com.ibm.rqm.planning.web.client.internal.Constants;
var Constants_getMessage=Constants.getMessage;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var SelectOwnerPopup=com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup;
dojo.declare("PreviewScriptTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("PreviewScriptTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("PreviewScriptTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        var doc=document;
        var moreContents = doc.createElement("div");
        var toggle = doc.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("PreviewScriptTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 3;
    },
    
    _columnHeadings:  [
            Constants_getMessage("labelTestCase"),
			Constants_getMessage("labelTestScriptName"),
            Constants_getMessage("labelOwner")
        ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        if(atColumnIndex == 2) {
            var img = {
				actionId: Constants_getMessage("labelOwner"),
				src: ImageCache.BULK_CHANGE,
				disabled: true
			};
			img.tooltip = Constants_getMessage("labelChangeProperties", img.actionId);
			return img;
        }
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 30;
            case 1: 
                return 40;
            case 2: 
                return 30;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_preview_testscript" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 1: 
                type = TableConstants.RENDER_TYPE_EDITABLE_TEXT;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
            case 1: 
                val = rowData.testScriptName;; 
                break;
            case 2: 
                val = rowData.owner.name;
                break;
        }
        return val;
    },

    getCellRawData: function(rowData, atColumnIndex)
    {
		var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
            case 1: 
                val = rowData.testScriptName; 
                break;
            case 2: 
                val = rowData.owner.name;
                break;
        }
        return val;
    }, 

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		  /*
        if (atColumnIndex == 6) {
           val = {};
			  val.image = ImageCache.REMOVE_DISABLED;
           val.mouseOutImage = ImageCache.REMOVE_DISABLED;
			  val.mouseOverImage = ImageCache.REMOVE_ENABLED;
        }
        if(atColumnIndex == 6 &&(rowData.col5 == "Jane" || rowData.col5 == "Luke")) {
            val = {};
            val['mouseOverImage'] = ImageCache.TEST_PLAN;
            val['mouseOutImage'] = ImageCache.TEST_SCRIPT;
        }
        if(atColumnIndex == 6 && rowData.col5 == "Bill") {
            val = {};
            val['select'] = (typeof rowData.selection != "undefined") ? rowData.selection : null;
            val['choices'] = [
                {'text':'room 123', 'value':'123'}, 
                {'text':'room 223', 'value':'223'}, 
                {'text':'room 323', 'value':'323'}, 
                {'text':'room 423', 'value':'423'}];
        }    
        */    
        return val;
    }
    
    
});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.PreviewScriptTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
	                 '   <div>' +
						  '      <span dojoAttachPoint="_queryTitle" class="query-title"></span>' +
						  '      <span dojoAttachPoint="_queryName" class="query-name"></span>' +
						  '   </div>' +
						  '</div>',

    widgetsInTemplate: true,

    constructor: function() {
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		
		EditorUtil.getContributors(this, "initialize", "_error");
		  
    },
	
	initialize: function(owners){
		if(owners){
			var length=owners.length;
			for(var i=0;i<length;i++){
				var owner=owners[i];
				if(CommonUtility.isUnassignedUserId(owner.itemId))
						owner.name = Constants_getMessage("labelUnassigned");
			}
		}
		this.owners = owners;
		var tableViewer = new TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
			showPagingControl: true,
			showPagingRangeControl: true,
            showGroupFilterControls: false,
            showPagingActionsControls: false,
            tableId: "PREVIEW-TESTSCRIPT-TABLEVIEWER"                                
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);

		var testCases=this.testCases;
		var length=testCases.length;
		for(var i= 0;i<length;i++){
			var testCase=testCases[i];
			testCase.testScriptName = Constants_getMessage("labelManualScriptInitialTitle", testCase.name);
			testCase.owner = {'name': Constants_getMessage("labelUnassigned") };
		}
        var content = this.testCases ? this.testCases : [];

        tableViewer.setContentPageSize(10);
        tableViewer.setContent(content);
		this.provider = new PreviewScriptTableView.TableProvider({
            owners: owners
        });	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new PreviewScriptTableView.TableListener({parentView: this}));
        tableViewer.setCellModifier(new PreviewScriptTableView.CellModifier());
		tableViewer.setTableSummary(Constants_getMessage("labelTableSummary", this.queryName));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
        tableViewer.show();
		this.tableViewer = tableViewer;
		 
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	tableHeaderColumnActionInvoked: function(columnIndex, actionId) {
		var args = {
			owners: this.owners,
			actionId: actionId,
			okCallback: dojo.hitch(this, "_handleOwnerChange")
		}
		var dlg = new SelectOwnerPopup();
		dlg.initialize(args);
	},
	
	_handleOwnerChange: function(args){
		var selectedItems = this.tableViewer.getCheckedRows();
		var ownerItemId = args.OwnerItemId;
		var selectedOwner = null;
		var owners=this.owners;
		var length=owners.length;
		for(var i=0;i<length;i++){
			var owner=owners[i];
			if(owner.itemId == ownerItemId){
				selectedOwner = owner; 
				break;
			}
		}
		for(var j in selectedItems){
			selectedItems[j].owner= selectedOwner;
		}
		this.tableViewer.refresh();	
	},
	
	validate: function(){
		this._queryTitle.innerHTML = "";
		var allRows = this.getContent();
		var length=allRows.length;
		for(var i=0;i<length;i++){
			var scriptName = allRows[i].testScriptName;
			if(scriptName == "" || scriptName.length > 254){
				this._queryTitle.innerHTML = "Invalid script name for test case " + allRows[i].name; 
				return false;
			}
		}
		return true;
	},
	
	_error: function(error){
		console.error("Error in PreviewScriptTableView "+ error.message);
	}
});
})();
