//debug requirement
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");

(function() {

var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var UserClient = com.ibm.asq.common.web.client.internal.ContributorClient;	
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var LOCATION                = net.jazz.ajax._contextRoot + "/web/projects/";
var WORKITEM_URL 				= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var RENDER_TYPE_REQLINK = "RenderType.ReqLink";
var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ActionPackage = com.ibm.rqm.planning.web.ui.internal.model.action;
var ActionEntityType = ActionPackage.ActionEntityType;

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	parentView: null,
    
	constructor: function(testView)
	{
    	this.parentView = testView;
	},
	// Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
	rowCheckStateChanged: function(tableViewer, rowObject, state)
    {

		var listener = this.rowCheckListener;
      	if (listener && listener.context && listener.method) {
			listener.method.apply(listener.context, [rowObject, state]);
		}
        
        var p = this.parentView;
        var requirements = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(requirements);
		var selectionCount = realSelection ? requirements.length : 2; // use 2 to indicate select all.
        
        var disabledSingleSelect = (selectionCount != 1 || !tableViewer.isEditable());
		var disabledMultipleSelect = (selectionCount == 0 || !tableViewer.isEditable());
		if (p.clearStatusActionNode) {
            // If this is a virtual select all, always enable the action.
            // We enable the action when ANY rows has updated or removed.
            // So, other rows that don't have this value would get 'cleared'
            // as well. Not a big deal.
			var disable = selectionCount > 0 ? false : true;
            if (realSelection && selectionCount > 0) {
                for (var i = 0; i < requirements.length; i++) {
                    if (requirements[i].status == "updated" || requirements[i].status == "removed") {
                        disable = false;
                        break;
                    }
                }
            }
			p.clearStatusActionNode.setDisabled(disable);
		}
		if (p.assoicatedTestPlanNode) {
			p.assoicatedTestPlanNode.setDisabled(disabledSingleSelect); 
		}
		if (p.assoicatedTestCaseNode) {
			p.assoicatedTestCaseNode.setDisabled(disabledSingleSelect);
		}	
		if (p.disaccosicateButton) {
			p.disaccosicateButton.setDisabled(disabledMultipleSelect);
		}
		if (p.deleteButton) {
			p.deleteButton.setDisabled(disabledMultipleSelect);
		}
		if (p.createCaseButton) {
			p.createCaseButton.setDisabled(disabledMultipleSelect);
		}
        if (p.duplicateActionNode)
            p.duplicateActionNode.setDisabled(selectionCount == 0);
		if (p.bulkchangeActionNode)
		    p.bulkchangeActionNode.setDisabled(selectionCount == 0);

        //if table view has a rowCheckListener, invoke it
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
            p.rowCheckedListener(rowObject, state);
        }           
	},
	
	groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
	// Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        }        
    },
	
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		if (this.parentView && this.parentView.requirementHeaderColumnActionInvoked) {
			this.parentView.requirementHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
		}         
    }   
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementRowCheckedHandler",
			TableViewer.RowCheckedHandler, 
{
    /*
     * Don't know why we've to override the normal table behavior!
     */
	getRowCheckState: function(rowObject)
    {
        var provider = this.viewer.getContentProvider();
        var id = provider.getRowDataId(rowObject);
        var check = false;
        
        // virtual select all, if the item is in our state 
        // map, it was de-selected.
        if(this.inVirtualSelectAll) {
            return (typeof this.rowStates[id] == "undefined");
        }
        if(id && (typeof this.rowStates[id] != "undefined")) {
            check = this.rowStates[id].checked;
        } else if (rowObject && rowObject.selected) {
			this.setRowCheckState(rowObject, true);
			return true;
		}
        return check;
    }				
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer,
{
	renderCell: function(viewer, cellData, extendedDisplayInfo,cellModifier, rowObject, columnIndex, cellWidthHint)
	{
		var doc=document;
		var node = doc.createElement("a");
        var textData = cellData + "";
        var displayNode = document.createElement("div");
        var href = "#";
                
        if(extendedDisplayInfo && (typeof extendedDisplayInfo['href'] != "undefined")) {
            href = extendedDisplayInfo['href'];
        }
        if(viewer.isCompactMode && typeof cellWidthHint != "undefined") {
            textData = this._handleCompactCellText(viewer, textData, extendedDisplayInfo, displayNode, cellWidthHint);
        }
        else {
            // the parent class's attach tooltip will not create a tooltip
            // if the string is null, or undefined. Don't have to check it here.
            this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);            
        }
        displayNode.innerHTML = textData;
        node.appendChild(displayNode);
        node.href = href;
		node.target ="_blank";
		return node;
	}
	
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	parentView: null,
    
   	constructor: function(testView)	{
        	this.parentView = testView;
    },
		
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 5) {
            if(dojo.isString(newValue)) {
                //rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		// do nothing
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    // Summary:
    //
	
    getNumColumns: function(content)
    {
        return 10;
    },
    
	_columnHeadings: [
        	Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelId"), //"WorkItem No.",
            Constants.getMessage("labelCommunityRiskHeader"),
			Constants.getMessage("labelRiskAssessment"),
            Constants.getMessage("labelSourceIdRequirementTable"),
			Constants.getMessage("labelRequirementSourceWithoutColon"),			
            Constants.getMessage("labelName"),
            Constants.getMessage("labelPackageInfoRequirementTable"),
            Constants.getMessage("labelDescriptionRequirementTable"),
            Constants.getMessage("labelOwner")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },
    
    _columnIdNames: [
        'status',
        'id',
        'communityRisk',
        'calculatedRisk',
        'sourceId',
        'sources',
        'name',
        'requirementPackage',
        'description',
        'ownerUUIDs'
    ],
    
    getColumnIdName: function(columnIndex)
    {
        return this._columnIdNames[columnIndex];
    },

    getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 9);
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        // Currently all columns are sortable except risk.
        return !(atColumnIndex == 2 || atColumnIndex == 3);     
    },
    
    _columnWidths: [6,9,10,10,10,5,10,20,20,15],
    getColumnWidth: function(content, atColumnIndex)
    {
    	// note - using the array lookup rather than a switch statement
    	// is about 17x faster on FF 3.5 - but the same speed on IE7 and IE8.
    	// Probably not worth making these fixes any further.
    	return this._columnWidths[atColumnIndex];
    },
    
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		if (atColumnIndex == 3 && this.tableViewer.queryName) {
            return {
                actionId: "risk",
                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelRiskAssessment")),
                src: ImageCache.BULK_CHANGE
            };
		}
		if (atColumnIndex == 9 && this.tableViewer.queryName) {
            return {
                actionId: "owner",
                tooltip: Constants.getMessage("labelChangeProperties", Constants.getMessage("labelOwner")),
                src: ImageCache.BULK_CHANGE
            };
		}
		return null;
    },
	
	getIsColumnVisible: function(atColumnIndex)
    {
        if(atColumnIndex == 2 || atColumnIndex == 5 || atColumnIndex == 7)
			return false;
		return true;
    },
	
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
            case 1: 
                type = TableConstants.RENDER_TYPE_LINK;  //RENDER_TYPE_REQLINK;
                break;	
			case 2: 
                type = TableConstants.RENDER_TYPE_FADEINOUT;  
                break;	
			case 3: 
                type = TableConstants.RENDER_TYPE_FADEINOUT;  
                break;		
			case 6:
				if (rowData.externalUrl != null && rowData.externalUrl.match(/^https?:\//i)) {
					type = RENDER_TYPE_REQLINK;		
				}
				else if (rowData.externalId!=null && ( rowData.externalId.match(/^reqpro\//i) || rowData.externalId.match(/^reqprohttps\//i) || rowData.externalId.match(/^doors\//i) || rowData.externalId.match(/^https?:\//i) || rowData.externalId.match(/^caliberrm\//i))) {
					type = RENDER_TYPE_REQLINK;		
				}else{
					type = TableConstants.RENDER_TYPE_LINK;
				}
				break; 			 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.id ? parseInt(rowData.id, 10) : "";
                break;
			case 2: 
                val = this._getRiskLevel(rowData.risk, "communityRisk");
                break;
			case 3: 
                val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                break;
			case 4: 
                val = rowData.externalTag ? rowData.externalTag : "";
                break;
			case 5: 
                val = this.getReqSourse(rowData.externalId);
                break;
            case 7: 
                val = rowData.packageInfo ? rowData.packageInfo : "";
                break;
            case 6: 
                val = this.encodeSpecialChars(rowData.name);
                break;
			case 8: 
                val = this.restoreTags(rowData.description);
                break;
            case 9: 
                val = "";
				if (rowData.owner) {
					if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(rowData.owner.itemId)) 
						val = Constants.getMessage("labelUnassigned");
					else 
						val = rowData.owner.name;
				}
                break;
			case 0: 
				if(!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status=="unknown")
					val = "";
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;          

        }
        return val;
    },

    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        if(atColumnIndex == 1) {
            val = {};
			val.href = Utility.getViewWorkItemURI(rowData.id);  
			val.linkType = Constants.getMessage("RequirementId");
        }
		if(atColumnIndex == 2) {
            val = {};
			var image = ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "communityRisk")];
            if (image) {
                val.image = image;
                val.tooltipInfo = {
                    createContents: dojo.hitch(this, this._createTooltip, rowData),
                    onOpen: dojo.hitch(this, this._openTooltip, rowData),
                    onClose: dojo.hitch(this, this._closeTooltip)
                };
            }
        }
		if(atColumnIndex == 3) {
            val = {};
            var image = this.tableViewer.queryName ? ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "calculatedRisk")] : ImageCache.RISK_LEVELS_READONLY[this._getRiskLevel(rowData.risk, "calculatedRisk")];
            if (image) {
                val.image = image;
                val.tooltipInfo = {
                    createContents: dojo.hitch(this, this._createTooltip, rowData),
                    onOpen: dojo.hitch(this, this._openTooltip, rowData),
                    onClose: dojo.hitch(this, this._closeTooltip)
                };
            }
        }
		if(atColumnIndex == 6){
			val = {};
			if (rowData.externalUrl!=null && rowData.externalUrl.match(/^https?:\//i)) {
				val.href = rowData.externalUrl;
			}
			else if (rowData.externalId!=null) {
				var eid=rowData.externalId;
				if(rowData.externalId.match(/^reqpro\//i)){
					// for requirement from reqpro, externaid is like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
					eid = eid.substring("reqpro/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					eid = eid.substring(idx+1,eid.length);
					idx=eid.indexOf("/");
					var project = eid.substring(0, idx);
					var reqKey = eid.substring(idx+1, eid.length);
					//form reqweb url like: "http://<server>:<port>/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=<project>&ReqKey=<reqKey>&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>"
					val.href = "http://" + serverAndPort + "/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=" + project + "&ReqKey=" + reqKey +"&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>";
				}
				else if(rowData.externalId.match(/^reqprohttps\//i)){
					// for requirement from reqpro https, externaid is like: "reqprohttps/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
					eid = eid.substring("reqprohttps/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					eid = eid.substring(idx+1,eid.length);
					idx=eid.indexOf("/");
					var project = eid.substring(0, idx);
					var reqKey = eid.substring(idx+1, eid.length);
					//form reqweb url like: "https://<server>:<port>/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=<project>&ReqKey=<reqKey>&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>"
					val.href = "https://" + serverAndPort + "/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=" + project + "&ReqKey=" + reqKey +"&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>";
				}					
				else if(rowData.externalId.match(/^doors\//i)){
					// for requirement from doors, externaid is like: "doors/<server>:<port>/<otherPart>", see wi9912
					eid = eid.substring("doors/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					var otherPart = eid.substring(idx+1, eid.length);
					//form doors url like: "doors://<server>:<port>/?<otherPart>"
					val.href = "doors://" + serverAndPort + "/?" + otherPart.replace(/%26/gi, "&");
				}					
				else if(rowData.externalId.match(/^caliberrm\//i)){
					// for requirement from CaliberRM, externaid is like: "caliberrm/<SERVER LOCATION>/<CaliberRM REQUIREMENT INTERNAL ID>", see wi 18359
					eid = eid.substring("caliberrm/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverLocation = eid.substring(0, idx);
					var otherPart = eid.substring(idx+1, eid.length);
					//for caliber url like: "alm://caliberrm!<server_location>/<otherPart>"
					val.href = "alm://caliberrm!" + serverLocation + "/" + otherPart.replace(/%26/gi, "&");
				}					
				else{
					val.href = Utility.getViewWorkItemURI(rowData.id);  
					val.linkType = Constants.getMessage("RequirementId");
				}
			}
		}		  
        return val;
    },
	
	restoreTags: function(value){
    	var rawText = value;
        rawText = rawText.replace(/\&gt;/gi, ">");
        rawText = rawText.replace(/\&lt;/gi, "<");
        rawText = rawText.replace(/\&amp;/gi, "&");
        rawText = rawText.replace(/\&tilde;/gi, "~");
        rawText = rawText.replace(/\&quot;/gi, "\"");
        rawText = rawText.replace(/\&circ;/gi, "^");
        rawText = rawText.replace(/\&nbsp;/gi, " ");
        rawText = rawText.replace(/<br\/>/gi, "\n");
        rawText = rawText.replace(/\&#09;/g, "\t");
        return rawText;
    },
	
	// encode special characters for html display for requirement names, see wi11946
	encodeSpecialChars: function(str){
		var rawText = str;
		rawText = rawText.replace(/&/gi, "&amp;");
        rawText = rawText.replace(/>/gi, "&gt;");
        rawText = rawText.replace(/</gi, "&lt;");        
        rawText = rawText.replace(/"/gi, "&quot;");
        return rawText;
	},
	
	//filter externalTag to identify its source: ReqPro, DOORS, RRC, CaliberRM or Local
	getReqSourse: function(externalTag) {
		var source = Constants.getMessage("labelLocalRequirement");
		if(externalTag && (externalTag.indexOf("reqpro")==0 || externalTag.indexOf("reqprohttps")==0)){
			// for requirement from reqpro, externaid is like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
			var source = Constants.getMessage("labelReqproRequirement");
		}
		else if(externalTag.indexOf("doors")==0){
			// for requirement from doors, externaid is like: "doors/<server>:<port>/<otherPart>", see wi9912
			var source = Constants.getMessage("labelDoorsRequirement");
		}		
		else if(externalTag.indexOf("caliberrm")==0){
			// for requirement from CaliberRM, externaid is like: "caliberrm/<SERVER LOCATION>/<CaliberRM REQUIREMENT INTERNAL ID>", see wi 18359
			var source = Constants.getMessage("labelCaliberRequirement");
		}		
		return source;			
	},
	
	//return value is int (0 ~ 5)
	_getRiskLevel: function(dtoRisk, riskType) {
		if (dtoRisk) {
			var levelString = null;
			switch (riskType) {
				case "communityRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("communityRisk")+14, dtoRisk.indexOf("communityRisk")+15);
					break;
				case "calculatedRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("calculatedRisk")+15, dtoRisk.indexOf("calculatedRisk")+16);
					break;
			}
			var level = Number(levelString);
            if (level != NaN && level >= 0) {
				return level;
            } 
		}
		return 0;
	},
	
	_createTooltip: function(rowData, hoverPopup) {
		this.riskTooltipWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview({
			artifact: rowData,
			artifactType: Constants.MODEL_TYPE_REQUIREMENT,
			editable: this.tableViewer.queryName ? true : false
		});
		hoverPopup.content = this.riskTooltipWidget.domNode;
	},
	
	_openTooltip: function(data) {
	},
	
	_closeTooltip: function(hoverPopup) {
		hoverPopup._lastOpen = -1;
		if(this.riskTooltipWidget && this.tableViewer.queryName) 
			this.riskTooltipWidget.onSave(this.tableViewer);
	} 
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 3;
    },
    
	_columnHeadings: [
			Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable")
    ],
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },
	
    _columnIdNames: [
        '',
        'name',
        ''
    ],
    
    getColumnIdName: function(columnIndex)
    {
        return this._columnIdNames[columnIndex];
    },

	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (content && content.length > 0 )?(atColumnIndex == 0):false;
    },

	_columnWidths: [5,35,65],
    getColumnWidth: function(content, atColumnIndex)
    {
   		return this._columnWidths[atColumnIndex];
    },
	
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		return null;
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return true;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData ? rowData.name : "";
                break;
            case 2: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 0: 
                if(!rowData||!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
	                
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 7;
    },
    
	_columnHeadings: [
			Constants.getMessage("labelStatusRequirementTable"),
			Constants.getMessage("labelSourceIdRequirementTable"),
			Constants.getMessage("labelPackageInfoRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable"),
			Constants.getMessage("labelPriorityRequirementTable"),
			Constants.getMessage("labelReviewStatusRequirementTable")
    ],
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },
    
    _columnIdNames: [
        '',
        '',
        '',
        'name',
        '',
        '',
        ''
    ],
    
    getColumnIdName: function(columnIndex)
    {
        return this._columnIdNames[columnIndex];
    },

	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 5 || atColumnIndex == 6 || atColumnIndex == 0);
    },
	
	getColumnHeadingImage: function(content, atColumnIndex)
    {
		return null;
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return true;
    },
	
	_columnWidths: [5,10,10,25,45,5,5],
    getColumnWidth: function(content, atColumnIndex)
    {
   		return this._columnWidths[atColumnIndex];
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
			case 1:
				val = rowData ? rowData.tag : "";
				break;
			case 3:
				val = rowData ? rowData.name : "";
				break;
            case 2: 
                val = rowData ? rowData.packageInfo: "";
                break;
            case 4: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 5: 
                val = rowData ? rowData.priority : "";
                break;
			case 6: 
                val = rowData ? rowData.reviewStatus : "";
                break;
			case 0: 
				if(!rowData || !rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("RequirementTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);		
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyRequirements"),
                promptTitle: Constants.getMessage("labelOnlyMyRequirements"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine, params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null, params: null
            }, {
                name: "status", // must match key in the arg list of the API
                title: Constants.getMessage("labelStatusRequirementTable") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelStatusRequirementTable"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {
                    options: [{
                        name: Constants.getMessage("labelRequirementNormal"),
                        value: "normal",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelRequirementUpdated"),
                        value: "updated",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelRequirementRemoved"),
                        value: "removed",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelUnknown"),
                        value: "unknown",
                        checked: false
                    }]
                }
            }, {
                name: "id", // must match key in the arg list of the API
                title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelId"),
                type: TableContentFilterProvider.FIELD_NUMERIC,
                defaultValue: null,
                params: null
            }, {
                name: "sourceId",  // must match key in the arg list of the API
                title: Constants.getMessage("labelSourceIdRequirementTable") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelSourceIdRequirementTable"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }, {
                name: "sources", // must match key in the arg list of the API
                title: Constants.getMessage("labelRequirementSource"),
                promptTitle: Constants.getMessage("labelRequirementSourceWithoutColon"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {
                    options: [{
                        name: Constants.getMessage("labelLocalRequirement"),
                        value: "local",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelReqproRequirement"),
                        value: "reqpro",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelDoorsRequirement"),
                        value: "doors",
                        checked: false
                    }, {
                        name: Constants.getMessage("labelCaliberRequirement"),
                        value: "caliberrm",
                        checked: false
                    }]
                }
            }, {
                name: "description",  // must match key in the arg list of the API
                title: Constants.getMessage("labelDescriptionRequirementTable") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelDescriptionRequirementTable"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }, {
                name: "requirementPackage",
                title: Constants.getMessage("labelPackageInfoRequirementTable") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelPackageInfoRequirementTable"),
                type: TableContentFilterProvider.FIELD_TEXT_POPUP,
                defaultValue: null, 
                params: {
                    fieldWidth: 300,
                    fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormCheckboxOverrideTextField",
                    fieldArgs: {
                        checkboxLabel: Constants.getMessage("labelOnlyReqNoPackage"),
                        checkboxValue: "-"
                    }
                }
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelRequirements"));
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilters: function() {
        return this.filters;
    },
		
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        // custom field widget are dynamically created and stored as the params of the filter
		return this.filters[index].params;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        if (this.tableView) {
            // must have the view context to perform the query and update the table display
            var args = {};
            
            for (var nameKey in filters) {
                // iterate through the filters and skip those that are not specified
                if (filters[nameKey] != null) {
                        args[nameKey] = filters[nameKey] || "";
                        if(args[nameKey] == 'Any@@')
                            args[nameKey] = '';
                }
            }
            this.tableView.runQuery(args);
        }
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',
	widgetsInTemplate: true, 
    pdfPrintType: "requirement",  // define the pdf print type. Our super class will handle it.

    editable: true,
    printable: false,
	isExternal: false,
	hideResetButton: false,
    inDialogMode: false,
    showDuplicateAction: true,
    
    constructor: function() {
        this.actions = [];
        this.requirements = [];
        this.showInitLoadProgress = false;
		this.showQueryFilters = false;
    },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);    
		    
		//load class in Risk component
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview", function(){});
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", function(){});
		jazz.core.internal.loader.load_async("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", function(){});
				
		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
        this.isQueryPage = this.queryName;
		
        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(RequirementWorkItemClient, "getAllSearchResultItemIds");
		this._initialize();
		// apply the user preference whether to initially open the 
        // filter area
        if (this.showQueryFilters) {
			//init options for running search			
	        this.setSearchFunction(dojo.hitch(RequirementWorkItemClient, "searchRequirements"));
			this.setSearchCallback(dojo.hitch(this, "show"));
	        this.setTypeLabel(Constants.getMessage("labelAllReqmt"));
			
			//init filters
			this._initializeFilters();
        }             
	},
	
	// Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new RequirementTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());
		var filters = this.filterProvider.filters;
		
		// save the status filter to add later after the originator
//        this.statusFilter = {
//            name: "status", // must match key in the arg list of the API
//            title: Constants.getMessage("labelstatus"),
//            promptTitle: Constants.getMessage("labelstatus"),
//            type: TableContentFilterProvider.FIELD_TOGGLELIST,
//            defaultValue: [],
//            params: {
//                options: [{
//                    name: Constants.getMessage("labelRequirementNormal"),
//                    value: Constants.getMessage("labelRequirementNormal"),
//                    checked: false
//                }, {
//                    name: Constants.getMessage("labelRequirementUpdated"),
//                    value: Constants.getMessage("labelRequirementUpdated"),
//                    checked: false
//                }, {
//                    name: Constants.getMessage("labelRequirementRemoved"),
//                    value: Constants.getMessage("labelRequirementRemoved"),
//                    checked: false
//                }]
//            }
//        };
		
		// save the status filter to add later after the originator
        this.tagFilter = {
            name: "tag", // must match key in the arg list of the API
            title: Constants.getMessage("labelTagRequirementTable"),
            promptTitle: Constants.getMessage("labelTagRequirementTable"),
            type: TableContentFilterProvider.FIELD_TEXT,
			defaultValue: null, params: null
        };
		
		// add the risk assessment filters
        var calculatedRiskFilter = {
            name: "calculatedRisk",  // must match key in the arg list of the API
            label: Constants.getMessage("labelRiskAssessment") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelRiskAssessment")
        };
        this.addRiskFilter(calculatedRiskFilter, filters);
        
        var communityRiskFilter = {
            name: "communityRisk",  // must match key in the arg list of the API
            label: Constants.getMessage("labelCommunityRiskHeader") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelCommunityRiskHeader")
        };
        this.addRiskFilter(communityRiskFilter, filters);

		// initlize the orginator filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(contributors) {
				contributors = contributors || [];
        		for (var i = 0; i < contributors.length; i++) {
            		if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(contributors[i].itemId)) {
                		contributors[i].name = Constants.getMessage("labelUnassigned");
            		}
            		contributors[i].value = contributors[i].itemId;
                    contributors[i].checked = false;
        		}
				var owners = {
                    name: "ownerUUIDs",  // must match key in the arg list of the API
                    title: Constants.getMessage("labelowner"),
                    promptTitle: Constants.getMessage("labelOwner"),
                    type: TableContentFilterProvider.FIELD_TOGGLELIST,
                    defaultValue: [],
                    params: (contributors == null) ? null : {options: contributors}
            	};
				self.filterProvider.filters.push(owners);
//                self.filterProvider.filters.push(self.statusFilter);
               // add the tag filter
                self.filterProvider.filters.push(self.tagFilter);
				self._initialize2();
            },
			
            failure: function(e) {
                self._error(e);
                // add the status and tag filters to the end even when
                // it failed to initialize the originator filter
//                self.filterProvider.filters.push(self.statusFilter);
                self.filterProvider.filters.push(self.tagFilter);
				self._initialize2();
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        UserClient.getContributors(responseHandler);
    },	
	
    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = this.inherited("_remapQueryArgs", arguments);

        // if requirementPackage is set, check to re-map to use boolean no package param
        if (filterArgs["requirementPackage"] != null) {
            filterArgs = dojo.clone(filterArgs);
            if (filterArgs["requirementPackage"] == "-") {
                filterArgs["isForNonePackage"] = true;
            } else {
                filterArgs["packageName"] = filterArgs["requirementPackage"];
            }
            delete filterArgs["requirementPackage"];
        }
        return filterArgs;
    },
	_initialize2:function(){
		if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
			this.initRunQuery();
        }
	},
	_initialize: function() {
        //create the table viewer
        var tableId = (this.tableId) ? this.tableId : (this.isQueryPage) ? "RQM-REQ-QUERY-TABLEVIWER" : "RQM-REQ-TABLEVIWER";
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode 
			showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
            allowAdjustSettings: !this.printable,
            autoSaveSettings: !this.printable,
            handleVirtualSelectAll: true,
            displayInPopup: this.inDialogMode,
            tableId: tableId       
        });
		
        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer;
		
		
		// the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
		if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
	        this.viewHeaderNode.setCSHelpId("rqm_all_req.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelRequirementTableViewHelp"));
			this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
			this.domNode.appendChild(tableViewer.domNode);
        }
		                        
        var content = this.requirements ? this.requirements : [];
        
        tableViewer.setContent(content);
        tableViewer.setContentProvider(this._constructTableContentProvider());
		tableViewer.registerCellRenderer(RENDER_TYPE_REQLINK, 
            new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer);
		tableViewer.rowCheckedHandler = new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementRowCheckedHandler(tableViewer);
		tableViewer.setTableListener(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener(this));
        tableViewer.setCellModifier(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier(this));
        tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ false);
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
				
        //add external actions to the table viewer
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
		    var actionButton = tableViewer.addAction(action.label, action.label, this, action.iconClass, action.actionHandler);
        	if (action.label == Constants.getMessage("labelAssociatedTestPlans")) {
				this.assoicatedTestPlanNode = actionButton;
				this.assoicatedTestPlanNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelAssociatedTestCases")) {
				this.assoicatedTestCaseNode = actionButton;
				this.assoicatedTestCaseNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelDisassociateRequirements")) {
				this.disaccosicateButton = actionButton;
				this.disaccosicateButton.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelArchive")) {
				this.deleteButton = actionButton;
				this.deleteButton.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelCreateTestCases")) {
				this.createCaseButton = actionButton;
				this.createCaseButton.setDisabled(true);
			}
		}
		
        if (!this.inDialogMode && this.showDuplicateAction) {
    		this.duplicateActionNode = tableViewer.addAction(
    	        		"duplicate",
            			Constants.getMessage("labelDuplicateAction"),
    	        		null,
            			"duplicate-icon-image",
						dojo.hitch(this, "invokeAction", "id", this, "_onDuplicateActionClick"));						
    		this.duplicateActionNode.setDisabled(true);
			var duplicateAction = new DuplicateAction();
			duplicateAction.isDuplicateAllowed(ActionEntityType.REQUIREMENT, dojo.hitch(this, "_isDuplicateAllowedCallback"));
    		this.printActionNode = tableViewer.addAction(
            			"printpdf",
            			Constants.getMessage("labelPDFView"),
            			null,
            			"pdf-icon-image",
            			dojo.hitch(this, "_onPrintPdfActionClick")
            );
        }
        
		//add trace action
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_REQ_WORKITEM;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
        if(!this.hideResetButton && !this.inDialogMode) {
        	if (!perm || perm.changestatus) {
        		this.clearStatusActionNode = tableViewer.addAction("changeStatus", // action id
        				Constants.getMessage("labelResetRequirementStatus"), // label
        				null, // callback data
        				"reset-reqstatus-icon-image", // icon class
        		dojo.hitch(this, "invokeAction", "id", this, "_onChangeStatusActionClick")); // callback
        		this.clearStatusActionNode.setDisabled(true);
        	}
        }
        if(this.showInitLoadProgress) {
            this.tableViewer.showLoadingProgress();
        }
        if(this.noInitEmptyMessage) {
            this.tableViewer.noItemMessage = " ";
        }
        this.tableViewer.show();
        this.tableViewer.setEditable(this.editable);     
		this.initialized = true;
    },

    _constructTableContentProvider: function() {
        var providerClass = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider;
        var isVirtual = this.contentIsVirtual;
        
        if(this.isExternal) {
            providerClass = com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider;
            isVirtual = false;
        } else if(this.isExternalByPriority){
             providerClass = com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider;
              isVirtual = false;
        }
        
        //create the table provider
        this.provider = new providerClass({
            tableViewer: this,
            isVirtual: isVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });    
        return this.provider; 
    },
	
	_onChangeStatusActionClick: function(selectedIds) {
		if (selectedIds.length > 0) {
			this.refreshData(selectedIds);
		}
	},
    
    setEditable: function(isEditable) {
        this.editable = isEditable;   
        this.tableViewer.setEditable(this.editable);     
    },
    
	show: function(requirements) {
        this.refresh(requirements || []);
		if(dojo.isFunction(this.stopInProgress))
        	this.stopInProgress(); 	
	 },
	 
    refresh: function(requirements) {
      	this.requirements = this._filterArchivedRequirements(requirements);

        // we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        this.tableViewer.endLoadingProgress();
		
        if(this.noInitEmptyMessage) {
			this.noInitEmptyMessage = false;
            this.tableViewer.noItemMessage = "";
        }
        if (this.updatePageOnly) {
            this.provider.loadPageContent(this.requirements);
        }
        else {
            this.tableViewer.setContent(this.requirements);
            this.tableViewer.refresh();
        }
        if(this.showInitLoadProgress) {
            this.showInitLoadProgress = false;
        }
      	this.tableViewer.setEditable(this.editable);
		var listener = this.tableViewer.getTableListener();
		if(listener){
			listener.rowCheckStateChanged(this.tableViewer);
		}		
    },
	
    _onDuplicateActionClick: function(ids) {
        var duplicateAction = new  DuplicateAction();
        duplicateAction.setType(ActionEntityType.REQUIREMENT);
        duplicateAction.execute(ids, dojo.hitch(this, "_invalidateQuery"), dojo.hitch(this, "_duplicateError"));       
    },

    _isDuplicateAllowedCallback: function(allowed){
		if(!allowed)
			this.duplicateActionNode.domNode.style.display = "none";			
	},
	
    _duplicateError: function(e){
        alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));     
    },
    
	//change status with latest data
    refreshData: function(selectedIds){
		if (selectedIds.length > 0) {
			this._needUpdatedReq = selectedIds;
            var args = {
                'message': Constants.getMessage("msgConfirmUpdateRequirement"),
                'yesCallback': dojo.hitch(this, "_refreshDataAction")
            };
            var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
            confirmDialog.open();
        } else {
			var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': Constants.getMessage("msgNoRequirementInSuspect")});
    	    alertDialog.setSecondaryTitle(Constants.getMessage("labelAlert"));
        	alertDialog.open();
		}
    },
    
	_refreshDataAction: function() {
        var method = (this.contentIsVirtual) ? "_invalidateQuery" : "_refreshNewestData";
		var responseHandler = new ServiceResponseHandler(this, method, "_error");
        RequirementWorkItemClient.getLastestWorkItemDTOs(responseHandler, {
                    	ids: this._needUpdatedReq
                	});
	},
	
    _refreshNewestData: function(requirements){
        var newRequirements = new Array();
		if (this.requirements && this.requirements.length) {
            for (var i = 0; i < this.requirements.length; i++) {
				var noChange = true; 
				//for update
				for (var j = 0; requirements && j < requirements.length; j++) {
					if (this.requirements[i].id == requirements[j].id) {
						newRequirements.push(requirements[j]);
						noChange = false;
						break;
					}
				}
				//for delete
				if (noChange) {
					for (var k = 0; k < this._needUpdatedReq.length; k++) {
						if (this._needUpdatedReq[k] == this.requirements[i].id) {
							noChange = false;
							break;
						}
					}
				}
                if (noChange) {
				    this.requirements[i].selected = false;
					newRequirements.push(this.requirements[i]);
				}
            }
            this.requirements = newRequirements;
            this.refresh(newRequirements);
            
            // notify any interested party about the requirements updates.
            this.onStatusRefreshed(newRequirements);	
		}
    },
	
    onStatusRefreshed: function(requirements) {
        // the requirement table view can install default action to refresh the 
        // statuses of the listed requirement. When that occurred, this method is
        // notified with the updated list. Parent object can override this method
        // refresh any cached requirements it might hold.    
    },
    
	//Hack: remove archived requirements. Service won't filter archived requirements
	_filterArchivedRequirements: function(requirements) {
		var newReqs = [];
		for(var i = 0; i < (requirements ? requirements.length : 0); i++) {
			if(requirements[i].status != "archived")
				newReqs.push(requirements[i]);
		}
		delete requirements;
		return newReqs;
	},
    
	// API - deprecate, use getVirtualSelectedRows instesad
	getSelectedRows: function() {
	    var selectrows = this.tableViewer.getCheckedRows();
		return selectrows;
	},
	
	getViewer: function() {
		return this.tableViewer;
	}
});

dojo.declare("Requirement.BulkChangeAction", 
             com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction, 
{
    artifactType: Constants.MODEL_TYPE_REQUIREMENT,
    
    invokePost: function(responseHandler, params)
    {
        this.inherited("invokePost", arguments);
        if (this.actionId == "risk") {
            com.ibm.rqm.risk.web.client.internal.risk.RiskClient.postSwitchRiskProfile(responseHandler, params);
        }
        else {
            // needs to remap the args for the requirement service.
            var args = {
                'ids': params.ids,
                'ownerUUID': params.ownerId
            }
            RequirementWorkItemClient.postReassignRequirementOwner(responseHandler, args)
        }
    }
});


dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExtRequirementTableView", com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView, {
	
	_initialize: function() {
		this.inherited("_initialize", arguments);
        
		this.tableViewer.setTableRowsCheckable(!this.printable, /* isSingleSelect */ false);
		this.tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		this.tableViewer.show();
	},
	
	requirementHeaderColumnActionInvoked: function(tableViewer, columnIndex, actionId){
        var idType = (actionId == "owner") ? "id" : "itemId";
        this.invokeAction(idType, this, "doBatchUpdate", columnIndex, actionId);
	},
    
    // @override.
    //    Abstract method to actually performs the batch change operations. Specific
    //    subclassess need to override this method to do the work on the artifact type.
    doBatchUpdate: function(itemIds, columnIndex, actionId) {
        var itemIdArgName = (actionId == "owner") ? "ids" : "artifactItemIds";
        var action = new Requirement.BulkChangeAction({
            actionId: actionId,
            itemIdsArgName: itemIdArgName,
            itemIds: itemIds,
            completeCallback: dojo.hitch(this, "_invalidateQuery"),
            errorCallback: dojo.hitch(this, "_invalidateQuery")
        });
        action.execute();
    }    
});

})();
