/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Load: com.ibm.rqm.risk.web.ui.internal.view.table.RisksInSectionTableView");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.table.RisksInSectionTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.risk.web.client.internal.risk.RiskClient");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskFactorsDetailDialog");

(function(){
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var util = com.ibm.team.workitem.web.client.util;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var RiskClient = com.ibm.rqm.risk.web.client.internal.risk.RiskClient;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	var RiskAssessmentStar = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar;
	var RENDER_TYPE_RISKBUBBLE = "RenderType.RiskBubble";
	var NONE = "None";
	
	dojo.declare("RisksInSectionTableView.RiskBubbleCell", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer, {
        // Summary:
        //    Renders the cell content. For renderer that can modify the cell value,
        //    
        renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/ cellModifier, rowObject, columnIndex, cellWidthHint){
            var node;
            var contentProvider = viewer.getContentProvider();
            var editable = viewer.isEditable() && (contentProvider ? contentProvider.getIsCellEditable(rowObject, columnIndex) : false);
            
			var riskWidget = null;
			var isRiskWidget = false;
			if (extendedDisplayInfo && extendedDisplayInfo['isRiskWidget']) {
				isRiskWidget = extendedDisplayInfo['isRiskWidget'];
			}
            if (editable) {
				riskWidget = this._createStarWidget(dojo.number.parse(cellData), editable, isRiskWidget);
                riskWidget.cellModifier = cellModifier;
	            riskWidget.rowObject = rowObject;
	            riskWidget.columnIndex = columnIndex;
				riskWidget.onChangeHandler = function() {
					var newValue = this.getValue()+"";
                    if (this.cellModifier) 
                        this.cellModifier.cellValueChanged(null, newValue, this.rowObject, this.columnIndex);
				}
            }
            else {
                riskWidget = this._createStarWidget(dojo.number.parse(cellData), editable, isRiskWidget);
            }
            this.cellNodes.push(riskWidget);
            return riskWidget.domNode;
        },
		
		_createStarWidget: function(value, editable, isRiskWidget, onChangeHandler) {
			var star = new RiskAssessmentStar({
				value: value,
				editable: editable,
				isRiskWidget: isRiskWidget,
				onChangeHandler: editable ? onChangeHandler : null
			});
			dojo.addClass(star.domNode, "inlineRiskLevel");
			return star;
		},
    
        disconnectAll: function()
        {
            //console.debug("================RiskBubbleCell disconnectAll");
            this.inherited(arguments);
            var cellNodes = this.cellNodes;
            var len = cellNodes.length;
            for(var i = 0; i < len; i++) {
                var node = cellNodes[i];
                if(node.destroy)
                    node.destroy();
            } 
            this.cellNodes = [];
        }
    });
	
    dojo.declare("RisksInSectionTableView.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        parentView: null,
        
        constructor: function(testView){
            this.parentView = testView;
        },
        
        // Summary:
        //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
        //   called.
        //
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            var selectionCount = tableViewer.getCheckedRows().length;
            if (this.parentView.deleteActionNode) 
                this.parentView.deleteActionNode.setDisabled(selectionCount == 0 || !tableViewer.isEditable());
			if (this.parentView.editActionNode) 
                this.parentView.editActionNode.setDisabled(selectionCount != 1 || !tableViewer.isEditable());	
        },
		
		 // Summary:
        //    If the client have registered table actions, this message will be fired when an action (button)
        //    is invoked by the user.
        //
        tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
            if (callback != null && dojo.isFunction(callback)) {
                if (callbackData != null) {
                    callback(callbackData);
                }
                else {
                    callback();
                }
            }
        }
    });
    
    dojo.declare("RisksInSectionTableView.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
        
        constructor: function(viewer, parent){
            this.tableViewer = viewer;
            this.parent = parent;
        },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
            switch (columnIndex) {
                case 0:
                    rowObject.assessFactor.name = newValue;
                    break;
				case 1: 
					rowObject.riskScore = newValue;
					break;
				case 2: 
					rowObject.currentImpact = newValue;	
					break;
				case 3: 
					rowObject.weight = newValue;	
					break;
				case 4: 
					rowObject.mitigationAction = newValue;	
					break;
                default:
                    break;
            }
			if(this.parent.parentEditor) {
				this.parent.parentEditor.setDirty(true);
			}
			if(this.parent.parentSection){
				this.parent.parentSection.setDirty(true);
			}
        },
        
        cellActionInvoked: function(rowObject, columnIndex){
        }
    });
    
    dojo.declare("RisksInSectionTableView.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        constructor: function(args) {
			this.editable = args.editable;
			this.isInSection = args.isInSection;
    	},
	
		// Summary:
        //
        getNumColumns: function(content){
            return this.isInSection ? 5 : 4;
        },
        
        //If data in any of the columns is required indicate it here.
        //cols is an array of column indices.
        //The required column headings will have an asterisk appended to them ie "Name" becomes "Name *"
        //The asterisk will ONLY be applied if there are rows in the table.
        setRequiredColumns: function(cols){
            this.requiredCols = cols;
        },
        
        // Summary:
        //
        getColumnHeading: function(content, index){
            var headings = [Constants.getMessage("labelRisk"),  Constants.getMessage("labelCalculation"), Constants.getMessage("labelCurrentImpact"), Constants.getMessage("labelImportance"), Constants.getMessage("labelMitigation")];
            //If any of the columns are required then append an * to the column header to indicate the data is required
            if (this.requiredCols) {
                for (var i = 0; i < this.requiredCols.length; i++) 
                    headings[this.requiredCols[i]] += " *";
            }
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
			if(atColumnIndex == 1)
				return false;
            return true;
        },
        
        getColumnWidth: function(content, atColumnIndex){
            var width = 2;
            // Note: this table seems to be always in section. So,
            // the non-section values never used. 
            switch (atColumnIndex) {
                case 0:
                    width = this.isInSection ? 25 : 25;
                    break;
                case 1:
                    width = this.isInSection ? 15 : 45;
                    break;
				case 2:
                    width = this.isInSection ? 15 : 15;
                    break;
				case 3:
                    width = this.isInSection ? 15 : 15;
                    break;
				case 4:
                    width = 30;
                    break;
            }
            return width;
        },
        
        getIsCellEditable: function(rowData, atColumnIndex){
			if(this.editable && ((atColumnIndex == 2)||(atColumnIndex == 3)))
				return true;
			return false;
        },
        
        // Summary:
        //    The only assumptions the table have on the data that it displays
        //    is that it's an array contents. These are the data content/object that
        //    will be displayed in the table rows.
        //
        getContentObjects: function(content){
            // our content is already an array of objects
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.assessFactor.itemId || rowData.assessFactor.id ;
        },
        
        // Summary:
        //    Returns the type of the cell to be displayed. By default, the TableViewer
        //    will support a set of cell types. The type of the cell will map to a specific
        //    cell renderer (to be discussed).
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_TEXT;
            switch (atColumnIndex) {
				case 1:
					type = RENDER_TYPE_RISKBUBBLE;
                    break;
				case 2:
					type = TableConstants.RENDER_TYPE_ENUM;
                    break;
				case 3:
					type = RENDER_TYPE_RISKBUBBLE;
                    break;
            }
            return type;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.assessFactor.name;
                    break;
				case 1:
					val = rowData.riskScore ? rowData.riskScore : "0";
//					else {
//						if(rowData.likelihood) {
//							val = Constants.getMessage("msgStaticFactorValue", 
//								RiskUtil.getLikelyhoodText(rowData.likelihood), 
//								RiskUtil.getCostText(rowData.cost));
//						}
//						else {
//							val = Constants.getMessage("msgCaseWeightValue", rowData.veryHigh, rowData.high, rowData.medium, rowData.low, rowData.veryLow); 
//						}
//					}
                    break;
				case 2:
                    val = rowData.currentImpact ? rowData.currentImpact : "-1";
                    break;
                case 3:
                    val = rowData.weight ? rowData.weight : "0";
                    break;
				case 4:
                    val = rowData.mitigationAction;
                    break;
            }
            return val;
        }, 
		
		getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = {};
            switch (atColumnIndex) {
				case 1: 
					val['isRiskWidget'] = true;
					break;
                case 2:
                    val['select'] = rowData.currentImpact;
                    val['choices'] = [{
						'text': Constants.getMessage("labelUnassigned"),
                        'value': "-1"
					}, {
						'text': Constants.getMessage("labelNoImpact"),
                        'value': "0"
					}, {
						'text': Constants.getMessage("labelShortLow"),
                        'value': "1"
					}, {
						'text': Constants.getMessage("labelShortMid"),
                        'value': "2"
					}, {
						'text': Constants.getMessage("labelShortHigh"),
                        'value': "3"
					}];
                    break;
				case 1: 
					val['isRiskWidget'] = false;
					break;
            }
            return val;
        }
        
    });
    
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.table.RisksInSectionTableView", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
		' <div><span dojoAttachPoint="viewTitle"></span></div>' +
		' <div dojoAttachPoint="tableNode"></div>' +
        '</div>',
        
        editable: true,
        printable: false,
        widgetsInTemplate: true,
		newAdded: 0,
        parentTable: null,
		factors: [],
		isInSection: false,
		typeName: "", // the name of the artifact, or none.
        
		appendCallback: null,
		replaceCallback: null,
		
        postCreate: function(){
            this.inherited("postCreate", arguments);
			this._initialize();
        },
        
        _initialize: function(factors){
			if(this.isInSection) {
				this.viewTitle.style.display = "none";
			}
			
			this.factors = factors ? factors : [];
			
            //create the table viewer
            
            //turn on adjustable controls if this is NOT print view (regular view)
            var showCtrls = !this.printable;
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
                allowAdjustSettings: showCtrls,
                autoSaveSettings: showCtrls,
                tableId: this.typeName + "-RQM-RISKS-INSECTION-TABLEVIEWER",
				showFilterControl: showCtrls,
				showTableControls: showCtrls,
				isCompactMode: true
            });
			tableViewer.registerCellRenderer(RENDER_TYPE_RISKBUBBLE, new RisksInSectionTableView.RiskBubbleCell());
            tableViewer.setTableRowsCheckable(this.editable, /* isSingleSelect */ false);
			
            this.tableNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
            
            
            var contentProvider = new RisksInSectionTableView.TableProvider({
				editable: this.editable,
				isInSection: this.isInSection
			});
            
            tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRiskTable")));
            
			if(this.isInSection) {
                this.templateActionNode = tableViewer.addAction("template", // action id
                	Constants.getMessage("labelSwitchRiskProfile"), // label
                 	null, // callback data
                 	"template-icon-16", // icon class
                 	dojo.hitch(this, "_onTemplateActionClick")); // callback
			}
			
			this.editActionNode = tableViewer.addAction("edit", // action id
            	Constants.getMessage("labelEditRisk"), // label
             	null, // callback data
             	"edit-icon-image", // icon class
             	dojo.hitch(this, "_onEditActionClick")); // callback
			this.editActionNode.setDisabled(true);
			
            this.addActionNode = tableViewer.addAction("addProfile", // action id
             	Constants.getMessage("labelAddRisk"), // label
             	null, // callback data
             	"add-icon-image", // icon class
             	dojo.hitch(this, "_onAddClick")); // callback
            this.addActionNode.setDisabled(true);
			
			this.deleteActionNode = tableViewer.addAction("delete", // action id
            	Constants.getMessage("labelDeleteRisk"), // label
             	null, // callback data
             	"delete-icon-image", // icon class
             	dojo.hitch(this, "_onDeleteActionClick")); // callback
			this.deleteActionNode.setDisabled(true);
			
            tableViewer.setContent(this.factors);
            tableViewer.setContentProvider(contentProvider);
            tableViewer.setTableListener(new RisksInSectionTableView.TableListener(this));
            tableViewer.setCellModifier(new RisksInSectionTableView.CellModifier(tableViewer, this));
            tableViewer.show();
			
            //if parent section available and not editable, table should not be editable
            tableViewer.setEditable(this.editable);
        },
        
		refresh: function(artifactType, newContents, profileName) {
			if(profileName) {
				this.viewTitle.innerHTML = '<b>' + Constants.getMessage("labelRisksForProfile", profileName) + '</b>';
			}
			if (artifactType) {
				this.artifactType = artifactType;
				this.factors = newContents ? newContents : [];
				this.addActionNode.setDisabled(this.editable ? false : true);
			}
			else {
				this.factors = [];
				this.addActionNode.setDisabled(true);
			}
			this.tableViewer.setContent(this.factors);
			this.tableViewer.refresh();
			this._resetActionButtons();
		},
		
		setParentTable: function(table){
			this.parentTable = table;
		},
		
        _onDeleteActionClick: function() {
			var dels = this.tableViewer.getCheckedRows();
			if (dels && dels.length > 0) {
                for (var i = 0; i < dels.length; i++) {
                    this.tableViewer.deleteItem(dels[i]);
                }
				this.factors = this.tableViewer.getContent();
				this.tableViewer.refresh();
				if(this.parentTable && this.parentTable.parentEditor){
					this.parentTable.parentEditor.setDirty(true);
				}
				if(this.parentSection){
					this.parentSection.setDirty(true);
				}
            }
			this._resetActionButtons();
		},
		
		_onAddClick: function() {
			var detailDialog = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskFactorsDetailDialog({
				selectedFactors: this.factors,
				detailTable: this,
				isInSection: this.isInSection,
				artifactType: this.artifactType
			});
			if(this.parentTable && this.parentTable.parentEditor){
				this.parentTable.parentEditor.setDirty(true);
			}
			if(this.parentSection){
				this.parentSection.setDirty(true);
			}
		},
		
		_onEditActionClick: function() {
			var select = this.tableViewer.getCheckedRows();
			if (select && select.length == 1) {
				var detailDialog = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskFactorsDetailDialog({
					title: Constants.getMessage("labelEditRisk"),
					selectedFactors: select,
					isInEdit: true,
					isInSection: this.isInSection,
					detailTable: this,
					artifactType: this.artifactType
				});
				if(this.parentTable && this.parentTable.parentEditor){
					this.parentTable.parentEditor.setDirty(true);
				}
				if(this.parentSection){
					this.parentSection.setDirty(true);
				}
			}
		},
		
		_onTemplateActionClick: function() {
			var artifactType = Constants.MODEL_TYPE_PLAN;
			switch (this.artifactType) {
				case Constants.getMessage("labelTestCase"):
					artifactType = Constants.MODEL_TYPE_CASE;
					break;
				case Constants.getMessage("labelRequirement"):
					artifactType = Constants.MODEL_TYPE_REQUIREMENT;
					break;
			}
			var profileDialog = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog({
				artifactType: artifactType,
				appendCallback: this.appendCallback ? this.appendCallback : dojo.hitch(this, "_appendProfile"),
				replaceCallback: this.replaceCallback ? this.replaceCallback : dojo.hitch(this, "_replaceProfile")
			})
		},
		
		_appendProfile:function(args) {
			if(args && args.selectedProfile) {
				var newFactors = args.selectedProfile.riskMeasurements;
				this.factors = this._mergeFactors(this.factors, newFactors);
				this.tableViewer.setContent(this.factors);
				this.tableViewer.refresh();
				this._resetActionButtons();
				if(this.parentSection){
					this.parentSection.setDirty(true);
				}
			}
		},
		
		_replaceProfile: function(args) {
			if(args && args.selectedProfile) {
				this.factors = args.selectedProfile.riskMeasurements;
				this.tableViewer.setContent(this.factors);
				this.tableViewer.refresh();
				this._resetActionButtons();
				if(this.parentSection){
					this.parentSection.setDirty(true);
				}
			}
		},
		
		_mergeFactors: function(oldFactors, newFactors) {
			var results = oldFactors;
			for(var i = 0; i < newFactors.length; i++) {
				var isIn = false;
				for(var j = 0; j < oldFactors.length; j++) {
					if(oldFactors[j].assessFactor.id == newFactors[i].assessFactor.id) {
						isIn = true;
						break;
					}
				}
				if(!isIn)
					results.push(newFactors[i]);
			}
			return results;
		},
		
		addNewFactors: function(newFactors) {
			this.factors = this.factors.concat(newFactors);
			this.tableViewer.setContent(this.factors);
			this.tableViewer.refresh();
			this._resetActionButtons();
		},
		
		updateFactors: function(newFactors) {
			for(var i = 0; i < this.factors.length; i++) {
				for (var j = 0; j < newFactors.length; j++) {
					if (this.factors[i].assessFactor.id == newFactors[j].assessFactor.id) {
						this.factors[i] = newFactors[j];
					}
				}
			}
			this.tableViewer.setContent(this.factors);
			this.tableViewer.refresh();
			this._resetActionButtons();
		},
		
		getFactors: function() {
			return this.factors;
		},
		
		_resetActionButtons: function() {
			this.deleteActionNode.setDisabled(true);
			this.editActionNode.setDisabled(true);
		},
		
		getCurrentValues: function() {
			var ids = [];
			var likelihoods = [];
			var costs = [];
			var dynamicRiskValues = [];
			var currentImpacts = [];
			var weights = [];
			var mitigationActions = [];
			if(!this.factors || this.factors.length == 0) {
				return null;
			}
			for (var i = 0; i < (this.factors ? this.factors.length : 0); i++) {
				ids.push(this.factors[i].assessFactor.id);
				weights.push(this.factors[i].weight);
				currentImpacts.push(this.factors[i].currentImpact ? this.factors[i].currentImpact : "-1");
				mitigationActions.push(this.factors[i].mitigationAction ? this.factors[i].mitigationAction : "");
				if(this.factors[i].likelihood) {
					likelihoods.push(this.factors[i].likelihood);
					costs.push(this.factors[i].cost);
					dynamicRiskValues.push(NONE);
				}
				else {
					likelihoods.push(NONE);
					costs.push(NONE);
					dynamicRiskValues.push(this.factors[i].veryHigh+","+
						this.factors[i].high+","+
						this.factors[i].medium+","+
						this.factors[i].low+","+
						this.factors[i].veryLow);
				}
			}
			var results = {
				riskFactorIds: ids,
				likelihoods: likelihoods,
				costs: costs,
				dynamicRiskValues: dynamicRiskValues,
				currentImpacts: currentImpacts,
				weights: weights
			};
			if(mitigationActions.length > 0)
				results.mitigationActions = mitigationActions;
			return results;
		},
		
        _error: function(errorObj){
            console.debug(errorObj.message);
        }
    });
})();
