//SequenceResultStepsTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.util.DomConstructor");

(function() {

var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient 					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var Utility  						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

dojo.declare("SequenceResultStepsTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("SequenceResultStepsTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("SequenceResultStepsTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 4;
    },
    
    _columnHeadings:[
			Constants.getMessage("labelStep"),
			Constants.getMessage("labelExecutable"),
            Constants.getMessage("labelTarget"),
			Constants.getMessage("labelActualResult")
    ],
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0:
				return 25;
			case 1:
				return 25;
			case 2:
				return 25;
			case 3: 
                return 25;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_seq_res_steps_table" + rowData.externalResultId;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
			case 3: 
                type = (rowData.stepType == Constants.TYPE_TEST && (!rowData.resultItemId || !rowData.resultState)) 
																? TableConstants.RENDER_TYPE_TEXT 
																: TableConstants.RENDER_TYPE_LINK;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = (rowData.stepType == Constants.TYPE_AUTOMATION ? Constants.getMessage("labelAutomation") :
						(rowData.executionRecordType == Constants.MODEL_TYPE_SUITE ? Constants.getMessage("labelTestSuite"): 
						Constants.getMessage("labelTestExecutionRecord") ));
                break;
            case 1: 
                val = rowData.executable ? rowData.executable : Constants.getMessage("labelUnassigned"); 
                break;
            case 2: 
                val = rowData.machine ? rowData.machine : Constants.getMessage("labelUnassigned");
                break;
			case 3: 
				val = rowData.resultState != null ? Utility.getResultString(rowData.resultState) : Constants.getMessage("labelNotStarted");
				break;
        }
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		if(atColumnIndex == 3){
			val ={};
			val.tooltip = Constants.getMessage("labelClickToOpen");
			if(rowData.stepType == Constants.TYPE_TEST){
				if(rowData.executionRecordType == Constants.MODEL_TYPE_SUITE){
					val.href = Utility.showSuiteResult(rowData.resultItemId);
				}else if(rowData.executionRecordType == Constants.MODEL_TYPE_EWI){
					val.href = Utility.getResultURI(rowData.resultItemId);
				}		
			}else{
				//Automation
				var self = this;
		    	//TODO IE7- need to manage release of these connections
				val.onclick = function(){
					var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
				   	var responseHandler = new ServiceResponseHandler(self, "_jobLogSuccess", "_jobLogError");
					inven.getJobLog( responseHandler, 
									 rowData[ "job" ][ "providerName" ],
									 rowData[ "job" ][ "providerInstance" ],
									 rowData[ "id" ] );
		            
		            // bring up the dialog immediately. Initially shows a
		            // loading message.                 
		            self._createLogDialog(com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil.getMessage("appWorking"));
				};
			}
		}
		return val;
    },
	//TODO VS: This is a HACK :< Code from JobStatusTableProvider.js, to be removed after refactoring
	_jobLogSuccess: function( log )
	{
        var text = (log && log.length > 0) ? log : com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil.getMessage("NoLogAvailable");
        if(this.dlgContentNode) {
            this.dlgContentNode.innerHTML = text;
        }
	},
	
	_jobLogError: function( errorObj )
	{
        if(this.dlgContentNode) {
            this.dlgContentNode.innerHTML = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil.getMessage("ErrorRetrievingLog");
        }
	},
    
    _createLogDialog: function(text)	
    {
        var panel = '<div dojoType="dijit.layout.LayoutContainer" style="padding:5px; width: 620px; height: 400px">' +
                '<div dojoType="dijit.layout.ContentPane" layoutAlign="client" dojoAttachPoint="textNode">' +
                '  <pre style="padding:5px; overflow:scroll"><div dojoAttachPoint="logContentNode"></div></pre>' +
                '</div>' +
            '</div>';
        var dom = new com.ibm.asq.common.web.ui.internal.util.DomConstructor( panel );
        var dlg = new SequenceResultStepsTable.JobStatus.Dialog( { title: com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil.getMessage("jobLog") } );
        this.dlgContentNode = dom.logContentNode;
        
        // Just in case the user close the dialog before the content came back.
        // Clear the node for updating the dialog's content.
        dlg.closed = dojo.hitch(this, function(){
            this.dlgContentNode = null;
        });
        dom.logContentNode.innerHTML = text;
        dlg.containerNode.appendChild( dom.domNode );
        dlg.show();
    }
});

dojo.declare("SequenceResultStepsTable.JobStatus.Dialog", 
             dijit.Dialog,
{
    hide: function()
    {
        this.inherited("hide", arguments);
        this.closed();  
    },
    closed: function()
    {
        // override to receive dialog closed.
    }
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView", 
    [dijit._Widget, dijit._Templated],
{    
   templateString: '<div dojoAttachPoint="_tableViewerNode1" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.stepResults = [];
		this._actionButtons = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
		jazz.core.internal.loader.load_async("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil", function f(){});
		jazz.core.internal.loader.load_async("com.ibm.rational.test.lm.web.client.internal.inventory", function f(){});
    },
	
	initialize: function(seqResult){
		this.seqResult = seqResult;
		this.stepResults = seqResult.stepResults ? seqResult.stepResults : [];
		if(!this.tableViewer){
			dojox.data.dom.removeChildren(this._tableViewerNode);     
			var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            allowAdjustSettings: true,
	            autoSaveSettings: true,
	            tableId: "SEQUENCE-RESULT-STEPS-TABLEVIEWER"                                
	        });        
	        this._tableViewerNode.appendChild(tableViewer.domNode);
	
	        var content = this.stepResults;
	
	        tableViewer.setContentPageSize(20);
	        tableViewer.setContent(content);
	        tableViewer.setContentProvider(new SequenceResultStepsTableView.TableProvider());
	        tableViewer.setTableListener(new SequenceResultStepsTableView.TableListener({parentView: this}));
	        tableViewer.setCellModifier(new SequenceResultStepsTableView.CellModifier());
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", "Step Results"));
			tableViewer.setTableRowsCheckable(false, /* isSingleSelect */ false);
			
			this.actions = this.getTableActions();
			var actionLen = (this.actions ? this.actions.length : 0);
			for (var i = 0; i < actionLen; i++) {
	            var action = this.actions[i];
	            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
	            if (action.disabled && action.disabled == true)
	                actionButton.setDisabled(true);
	            if (action.hidden && action.hidden == true)
	                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
				if(action.actionId == "delete"){
					this.deleteActionNode = actionButton;
				}	
	            this._actionButtons.push(actionButton);
	        }
	        tableViewer.show();
			this.tableViewer = tableViewer;
		}else{
			this.tableViewer.setContent(this.stepResults);
			this.tableViewer.refresh();
		}	
	},
	
	getTableActions: function(){
		var actions = [];
		actions.push({
                    actionId: "refresh",
                    label: Constants.getMessage("labelRefresh"),
                    actionHandler: dojo.hitch(this, "_handleRefresh"),
                    iconClass: "refresh-icon-image"
                });
		return actions;		
	},

	_handleRefresh: function(){
		if(this.parentSection && this.seqResult){
			var args = {itemId: this.seqResult.itemId};
				var responseHandler = new ServiceResponseHandler(this.parentSection, "fillData", "_error");
				SequenceClient.getExecutionSequenceResultsDTO(responseHandler, args);
		}
	},

	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	_error: function(error){
		console.error("Error in SequenceResultStepsTableView "+ error.message);
	}
});
})();
