//SequenceTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.mapper.ExecutionSequenceMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

(function() {

var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient 					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var Utility  						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ExecutionSequenceMapper 		= com.ibm.rational.test.lm.sequencer.web.client.internal.mapper.ExecutionSequenceMapper;
var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var TableContentFilterProvider  	= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var EditorUtil 						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var PlanningConstants				= com.ibm.rqm.planning.web.client.internal.Constants;
var PermissionsClient   			= com.ibm.asq.common.web.client.internal.PermissionsClient;
var ProgressUtility  = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("SequenceTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
  rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount = realSelection ? selection.length : tableViewer.getContentPageSize(); // use the page size for select all

		if (this.parentView.deleteActionNode) {
			if (selectionCount > 0) {
				this.parentView.deleteActionNode.setDisabled(false);
			}
			else {
				this.parentView.deleteActionNode.setDisabled(true);
			}
		}

		if (selectionCount == 1) {
			this.parentView.printActionNode.setDisabled(false);
			dojo.style(this.parentView.printActionNode.domNode, "opacity", 1.0);
		}
		else {
			this.parentView.printActionNode.setDisabled(true);
			dojo.style(this.parentView.printActionNode.domNode, "opacity", 0.3);
		}

		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    },

    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId){
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("SequenceTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex){}
});

dojo.declare("SequenceTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
				
        // define the static filters
        this.filters = [];
		this.filters.push(
        {
            name: "myItemsOnly",  // must match key in the arg list of the API
            title: PlanningConstants.getMessage("labelOnlyMySequences"),
            promptTitle: PlanningConstants.getMessage("labelOnlyMySequences"),
            type: TableContentFilterProvider.FIELD_CHECKBOX,
            defaultValue: this.defaultToMine, 
            params: null
        });
		this.filters.push({
	        name: "name",  // must match key in the arg list of the API
	        title: PlanningConstants.getMessage("labelname"),
	        promptTitle: PlanningConstants.getMessage("labelName"),
	        type: TableContentFilterProvider.FIELD_TEXT,
	        defaultValue: null, 
	        params: null
        });
    },
	
	getTitle: function() {
        return PlanningConstants.getMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return PlanningConstants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelExecutionSequence"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 5;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: PlanningConstants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: PlanningConstants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
                    args[nameKey] = '';
                }
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("SequenceTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    getNumColumns: function(content){
        return 6;
    },
    
	_columnHeadings: [
		"",
        Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
		Constants.getMessage("labelOwner"),
		Constants.getMessage("labelModified"),
		Constants.getMessage("labelHistory")
    ],
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },

    _columnIds: [
        "",
        "id",
        "name",
        "ownerUUIDs",
        "modified",
        ""
    ],
    
    getColumnIdName: function(index) {
        return this._columnIds[index];
    },

    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        return (atColumnIndex == 3);
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex > 0 && atColumnIndex < 5);     
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 13;
            case 2: 
                return 35;
			case 3:
				return 22;
			case 4:
				return 20;
			case 5:
				return 5			
        }
        return 0;
    },

    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_sequence_main_table" + rowData.id;
    },

    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1:
			case 2: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 4: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;
			case 5: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;			
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return (atColumnIndex == 0 || atColumnIndex == 5? TableConstants.ALIGN_CENTER : TableConstants.ALIGN_LEFT);
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = "";
                break;
            case 1: 
                val = rowData.id; 
                break;
            case 2: 
                val = rowData.name;
                break;
			case 3: 
                val = rowData.owner ? rowData.owner.name : (rowData.ownerName ? rowData.ownerName : Constants.getMessage("labelUnassigned"));
                break;
			case 4: 
                var date = new Date();
                date.setTime(rowData.modified);
                val = date; //Last Modified
                break;
			case 5: 
                val = "";
                break;	
        }
        return val;
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
		var val = null;
		if(atColumnIndex == 0){
			val ={};
			val.image = ImageCache.EXECUTION_SEQ;
			val.tooltip = Constants.getMessage("labelClickToOpen");
			val.href = Utility.getSequenceURI(rowData.id);
		}else if(atColumnIndex == 1 || atColumnIndex == 2){
			val = {}
			val.href = Utility.getSequenceURI(rowData.id);
			val.tooltip = Constants.getMessage("labelClickToOpen");
		}else if(atColumnIndex == 5){
			val ={};
			val.image = ImageCache.EXECUTION_SEQ_RESULT;
			val.tooltip = Constants.getMessage("labelClickToOpen");
			val.href = Utility.getSequenceResultsURI(rowData.id);
		}	
		return val;
    }
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,
    pdfPrintType: "executionsequence",  // define the pdf print type. Our super class will handle it.

    constructor: function() {
		this.actions = [];
		this.sequences = [];
		this._actionButtons = [];
	 },

    postCreate: function() {
		this.inherited("postCreate", arguments);
		EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)
		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias(); //needed for PDF button

        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(SequenceClient, "getAllSearchResultItemIds");
	},
	
	initialize: function(args){
		this.isQueryPage = this.queryName;
        if (this.isQueryPage) {
            this.viewHeaderNode.setTitle(this.queryName);
           
        } else {
            this.viewHeaderNode.domNode.style.display = "none";
        }

		//init options for running search		
		this.viewHeaderNode.setCSHelpId("rqm_allview_exec_sequence.html");
		this.viewHeaderNode.setCSHelpButtonLabel(PlanningConstants.getMessage("labelViewSequences")+" "+Constants.getMessage("labelHelp"));
        this.setSearchFunction(dojo.hitch(SequenceClient, "searchExecutionSequences"));
        this.setSearchCallback(dojo.hitch(this, "show"));
		this.setResponseHandlerType(ExecutionSequenceMapper);
        this.setTypeLabel(this.queryName);
		
		this._initializeFilters();
	},
	
	_initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new SequenceTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());

        var filters = this.filterProvider.filters;
        
        // add id filter
        filters.push({
            name: "id", // must match key in the arg list of the API
            title: PlanningConstants.getMessage("labelId") + PlanningConstants.getMessage("labelColen"),
            promptTitle: PlanningConstants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });
        
        // add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified",  // must match what the filter provider looks for
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: PlanningConstants.getMessage("labelModified") + PlanningConstants.getMessage("labelColen"),
            prompt: PlanningConstants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, filters);

        //callback: initialize the orginator/owner contributor filters       
		var originatorFilter = {           
            //filterName, filterLabel, filterPrompt, filterType, callback
            name: "originatorUUIDs",
            label: PlanningConstants.getMessage("labeloriginatorLabel"),
            prompt: PlanningConstants.getMessage("labelOriginator"),
            type:TableContentFilterProvider.FIELD_TOGGLELIST
        }	
		this.addContributorFilter(originatorFilter, filters, dojo.hitch(this, "_initializeOwnerFilter"));
    },		
	
    _initializeOwnerFilter: function() {
        var ownerFilter = {           
            name: "ownerUUIDs",
            label: PlanningConstants.getMessage("labelOwner") + PlanningConstants.getMessage("labelColen"),
            prompt: PlanningConstants.getMessage("labelOwner"),
            type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        // the user list is cached for the contributors and will not fetch the user list again
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, dojo.hitch(this, "_initialize"));
    },
    
	_initialize: function(sequences){
		this.sequences = sequences ? sequences : [];
		if(!this.tableViewer){
			dojox.data.dom.removeChildren(this._tableViewerNode);     
			var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            allowAdjustSettings: true,
	            autoSaveSettings: true,
                handleVirtualSelectAll: true,            
	            tableId: "SEQUENCE-MAIN-TABLEVIEWER"                                
	        });        
            this.tableViewer = tableViewer;
	        this._tableViewerNode.appendChild(tableViewer.domNode);
			this.initFilterProvider(this.filterProvider);			
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);           

	        var content = this.sequences;
	
	        tableViewer.setContent(content);
	        tableViewer.setContentProvider(this._constructTableContentProvider());
	        tableViewer.setTableListener(new SequenceTableView.TableListener({parentView: this}));
	        tableViewer.setCellModifier(new SequenceTableView.CellModifier());
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
			tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
			
			//add refresh action (use 'refreshQuery' api)
	        tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, "refreshQuery"));
					
			this.actions = this.getTableActions();
			var actionLen = (this.actions ? this.actions.length : 0);
			for (var i = 0; i < actionLen; i++) {
	            var action = this.actions[i];
	            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
	            if (action.disabled && action.disabled == true)
	                actionButton.setDisabled(true);
	            if (action.hidden && action.hidden == true)
	                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
				if(action.actionId == "delete"){
					this.deleteActionNode = actionButton;
				}	
	            this._actionButtons.push(actionButton);
	        }
			
	        tableViewer.show();
			
			//print button content
			var printMenu = new dijit.Menu({ style: "display: none;"});
	        var historyOption = new dijit.MenuItem({
	        	label: PlanningConstants.getMessage("printLabelHistory"),
	        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")
	        });
	        printMenu.addChild(historyOption);
			
	       	this.printActionNode = tableViewer.addAction(
	       			"printpdf",
	       			PlanningConstants.getMessage("labelPDFView"),
	       			null,
	       			"pdf-icon-image",
	       			dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print"),
	       			printMenu
	       	);      	

	       	this.printActionNode.setDisabled(true);
	       	dojo.style(this.printActionNode.domNode, "opacity", 0.3);
	       	//end print button content
		
			//if preference specifies, run the query			
			this.initRunQuery();
			
		} else{
			if (this.isQueryPage) {
				this.viewHeaderNode.setProgressEnd();
                this.viewHeaderNode.clearStatus();
			}
			this.tableViewer.endLoadingProgress();
            
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(this.sequences);
            }
            else {
                this.tableViewer.setContent(this.sequences);
                this.tableViewer.refresh();
            }
		}	
	},

    _constructTableContentProvider: function() {
        //create the table provider
        this.provider = new SequenceTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });    
        return this.provider; 
    },
	
	getTableActions: function(){
		var actions = [];
		var seqPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_SEQUENCE);
		if (!seqPerm || seqPerm[PermissionsClient.ACTION_ARCHIVE]) {
			actions.push({
				actionId: "delete",
				label: Constants.getMessage("labelDelete"),
				actionHandler: dojo.hitch(this, "invokeAction", "uuid", this, "_handleDelete"),
				iconClass: "delete-icon-image",
				disabledOnReadOnly: true,
				disabled: true
			});
		}	
		return actions;		
	},
	
	show: function(sequences) {
		sequences = sequences?sequences:[];
		this._initialize(sequences);
        this.stopInProgress();
     },
	 
	_handleDelete: function(selectedIds){
		var selectedSequences = selectedIds;
		var len = selectedSequences.length;
        var args = {
            'message': Constants.getMessage("msgDelTestSuiteConfirm",len),
            'yesCallback': dojo.hitch(this, "_deleteAction"),
            'yesCallbackData': selectedIds,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function(selectedIds) {         
		if(this.deleteActionNode)
        	this.deleteActionNode.setDisabled(true);
            
        this.deleteIds = selectedIds;
        var selectedSequenceCount = this.selectedSequenceCount = selectedIds.length;
        this.errorSequenceCount = 0;
        this.deletedSequenceCount = 0;
        if (selectedSequenceCount > 0) {
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingExecSequence"), selectedSequenceCount, null); 
            for (var i = 0; i < selectedSequenceCount; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                SequenceClient.postArchiveExecutionSequence(responseHandler,{
                            itemId: selectedIds[i],
                            archive: true
                        });
            }
        }
    },
    
    _deleteSuccess: function(response) {
        this.deletedSequenceCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        this.errorSequenceCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        var progressCnt = this.deletedSequenceCount + this.errorSequenceCount;
        ProgressUtility.updateTask(this.monitorId,  progressCnt);
        
        if (progressCnt == this.selectedSequenceCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedExecSequence", this.deletedSequenceCount, this.selectedSequenceCount),
                    this.errorSequenceCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedSequenceCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedSequenceCount > 0) {
                this._deleteFromSelf = true;
                // TODO: virtual select all case don't have selectedCases... need to use itemIds in
                // notification.
                // notify all pages (including itself) execution sequences are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_SEQUENCE, this.deleteIds]);
            }
        }
    },
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	disableAllActions: function(){
		var actions = this.tableViewer.getActionButtons();
		for(var action in actions){
			if(actions[action].actionId != "add")
				actions[action].setDisabled(true);
		}
	},
	
	onArtifactChanged: function(changeType, artifactType, artifactArray) {
        if (artifactType == Constants.TYPE_SEQUENCE) {
            if (this._deleteFromSelf && changeType == GlobalEvents.ArtifactsDeleted && this._invalidateQuery) {
                this._invalidateQuery();
                delete this._deleteFromSelf;
                return;
            }
            if (this.isQueryPage) {
                this._showArtifactChangedMessage(this.viewHeaderNode, PlanningConstants.TYPE_EXECUTION_SEQUENCE, changeType);
                return;
            }
            
            if (changeType == GlobalEvents.ArtifactsAdded) {
				var content = this.tableViewer.getContent();
				content = content.concat(artifactArray);
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            } else {
				var content = this.tableViewer.getContent();
				var arrLen = artifactArray.length;
                for (var i = 0; i < arrLen; i++) {
                    var contentLength = content.length;
					for (var j = 0; j < contentLength; j++) {
                        if (artifactArray[i].id == content[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                content.splice(j, 1, artifactArray[i]);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                content.splice(j, 1);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
                            }
                            break;
                        }
                    }
                }
            }
        }
    },

	_error: function(error){
		console.error("Error in SequenceTableView "+ error.message);
	}
});
})();
