//SLTV
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.SuiteLogTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredExecutionPagingTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionPagingTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultGroupClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
var AllResultsMapper = com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper;
var ProgressUtility  = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

var LabelNA = Constants.getMessage("labelNA");

/************************************************
* Please refer to the changesets for defect 27769
* to determine what statements were commented or
* changed to disallow unsupported print options.
************************************************/
dojo.declare("SuiteLogTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount = realSelection ? selection.length : tableViewer.getContentPageSize(); // use the page size for select all
		var p = this.parentView;

        if (p.deleteActionNode)
            p.deleteActionNode.setDisabled(selectionCount == 0);
        if(p.printHistoryCARActionNode)
        	p.printHistoryCARActionNode.setDisabled(selectionCount == 0);
       	
		//Print action node
		/* if (selectionCount == 0) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfsummarymenu");
			p.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfsummarymenu");
			p.enableAction("printpdfmultiplemenu");
			p.showAction("printpdfmultiplemenu");
		} else if (selectionCount == 1) {
			p.hideAction("printpdfsummarymenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfhistorycarmenu");
			p.showAction("printpdfhistorycarmenu");
		} */
    },
	
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
     	if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		else if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("SuiteLogTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{    
    getNumColumns: function(content){
        return 11;
    },
 
 
    _columnHeadings: [
		Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
        Constants.getMessage("labelCompleted"),
		Constants.getMessage("labelState"),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelPass")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelFail")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted")),
		Constants.getMessage("labelTestPlan"),
		Constants.getMessage("labelIteration")
    ],
 	ids: [
		"id","name","completed","stateIds",
		"pointsPass","pointsFail","pointsBlocked","pointsInconclusive","pointsAttempted",
		"testPlan","testPhaseName"
    ],
    
    getColumnIdName: function(index){
        return this.ids[index];
    },
	
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
 
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
	getIsColumnVisible: function(atColumnIndex){
		return (!(atColumnIndex >3));
	},
	
    getIsColumnGroupable: function(content, atColumnIndex){
        return ((atColumnIndex > 0 && atColumnIndex < 4)||(atColumnIndex > 8));     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex <4 || atColumnIndex >8);   
    },
    
    _columnWidths: [13,37,25,25,10,10,10,10,10,10,10],

    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_suite_result_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 1: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
            case 2: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;
			case 9: 
                type = rowData.testPlan ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
                break;						 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
				val = rowData.id;
				break;
			case 1:
                var name = rowData.name ? rowData.name : "";
				val = Constants.getMessage("labelNamedResult", name);
				break;	
            case 2:
				val = LabelNA; 
                if (rowData.endTime > 0) {
                   val = new Date(); //Completed
                   val.setTime(rowData.endTime);
                }
                break;   
            case 3: 
                val = Utility.getStatusText(rowData); //State
                break;
			case 4: 
                val = rowData.pointsPassed; //Pass points
                break;
			case 5: 
                val = rowData.pointsFailed; //Fail points
                break;
			case 6: 
                val = rowData.pointsBlocked; //Blocked points
                break;
			case 7: 
                val = rowData.pointsInconclusive; //Inconclusive points
                break;
			case 8: 
                val = rowData.pointsAttempted; //Attempted points
                break;				 
			case 9: 
                val = rowData.testPlan?rowData.testPlan.name:""; //Plan
                break;
			case 10: 
                val = rowData.phaseName?rowData.phaseName:""; //MileStone
                break;				 
        }
        return val;
    },
    getCellRawData: function(rowData, atColumnIndex)
    {
        // don't need to convert the long time value to Time object.
        // return the raw data for sorting/grouping operations.
        if(atColumnIndex == 2) {
            return rowData.endTime|| "";
        }
        return this.getCellDisplayData(rowData, atColumnIndex);
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){ 
        var val = {};
        // name column: attach to the result page.
		if(atColumnIndex == 1) {
            val.href = this.getHref(rowData);
        }
		else if(atColumnIndex == 9 && rowData.testPlan && rowData.testPlan.id){
			val.href = Utility.getTestPlanURI(rowData.testPlan.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        return val;
    },
	
	getHref: function(rowData) {
		return Utility.showSuiteResult({ id: rowData.id });
	}
});

dojo.declare("SuiteLogTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyResults"),
                promptTitle: Constants.getMessage("labelOnlyMyResults"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelExeResults"));
    },
	
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },	
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
					args[nameKey] = '';
				}
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.SuiteLogTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
    pdfPrintType: "testsuitelog",  // define the pdf print type. Our super class will handle it.

    constructor: function() {
	 	this.results = null;
        this.showInitLoadProgress = false;
		this._actionButtons = [];
        this.showQueryFilters = false;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;

        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(ExecutionResultGroupClient, "getAllSearchResultItemIds");
        
        this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		setTimeout(dojo.hitch(this,function(){
			this._initialize();
		}),0);
        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
        if (this.isQueryPage && this.showQueryFilters) {
	        //setup search details
			this.setSearchFunction(dojo.hitch(ExecutionResultGroupClient, "searchSuiteResults"));
	        this.setSearchCallback(dojo.hitch(this, "refresh"));
	        this.setResponseHandlerType(AllResultsMapper);
	        this.setTypeLabel(Constants.getMessage("labelAllSuiteResult"));
		    
			//initialize filters
            this._initializeFilters();
			
        }
	},
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new SuiteLogTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());
		//append new filters - owner and then states (via callback)
        var callback = dojo.hitch(this, function(){
	        var statesFilter = {           
	            //filterName, filterLabel, filterPrompt, filterType, callback
	            name: "stateIds",
	            label: Constants.getMessage("labelStateLabel"),
	            prompt: Constants.getMessage("labelState"),
				type:TableContentFilterProvider.FIELD_TOGGLELIST
	        }
	        this.addExecutionStateFilter(statesFilter, this.filterProvider.filters, dojo.hitch(this, "_initialize2")); 			
		});
		
		//append owner field
        var ownerFilter = {
            name: "ownerUUIDs",
            label: Constants.getMessage("labelowner"),
            prompt: Constants.getMessage("labelOwner") ,
			type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, callback);
        var filters = this.filterProvider.filters;
        
        filters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });

        filters.push({
            name: "testPhaseName",  // must match key in the arg list of the API
            title: Constants.getMessage("labelIteration") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelIteration"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, params: null
        });

        // add the test plan filter
        var testPlanFilter = {
            name: "testPlan",  // must match what the filter provider looks for
            label: Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestPlan"),
            artifactType: Constants.TYPE_PLAN,
            simpleKey: "testPlanName",
            advancedKey: "vTestPlanItemIds"
        };
        this.addAdvancedArtifactFilter(testPlanFilter, filters);

        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "completed",  // must match what the filter provider looks for
            fromKey: "completedFrom",
            toKey: "completedTo",
            label: Constants.getMessage("labelCompleted") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelCompleted")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, filters);
    },
	
    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = this.inherited("_remapQueryArgs", arguments);
        
        // test plan filter can be simple by name or advanced by array of id
        if (filterArgs["testPlan"] != null) { // expect to be single entry array
            filterArgs = dojo.clone(filterArgs);
            for (var key in filterArgs["testPlan"]) {
                if (key != "advancedObj") {
                    filterArgs[key] = filterArgs["testPlan"][key];
                }
            }
            delete filterArgs["testPlan"];
        }
        return filterArgs;
    },

	_initialize: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            allowMultiSort: true,
            handleVirtualSelectAll: true,            
            tableId: "RQM-SUITE-LOG-TABLEVIEWER",
			sortByColumn:2,
			sortDir:TableConstants.SORT_DIR_DESCEND                                
        });        
		
        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer;
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.results ? this.results : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelSuiteResults");
        
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
			this.viewHeaderNode.setCSHelpId("rqm_view_exec_results.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelSuiteResultsHelp"));
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
		this.provider = this._constructTableContentProvider();	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new SuiteLogTableView.TableListener(this));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_RESULT;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
		if (this.isQueryPage && (!perm || perm.archive)) {
            this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "invokeAction", "itemId", this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
		tableViewer.setTableRowsCheckable(true, false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		  		
		//******print button content******
		var printHistoryCARMenu = new dijit.Menu({ style: "display: none;"});
		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
		
        var normalOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelCAR"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });
        var historyOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelHistory"),
        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")
        });
        var summaryOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelSummary"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });        
        var multipleOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelMultiple"),
        	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
        });
		
        //printHistoryCARMenu.addChild(normalOption);
        printHistoryCARMenu.addChild(historyOption);      
        printSummaryMenu.addChild(summaryOption);
        printMultipleMenu.addChild(multipleOption);
        
       	this.printSummaryActionNode = tableViewer.addAction(
       			"printpdfsummarymenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printSummaryMenu
       	);      	
       	this._actionButtons.push(this.printSummaryActionNode);
       	//this.enableAction("printpdfsummarymenu");
       	this.hideAction("printpdfsummarymenu");
       	
       	this.printHistoryCARActionNode = tableViewer.addAction(
       			"printpdfhistorycarmenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print"),
       			printHistoryCARMenu
       	);
       	this._actionButtons.push(this.printHistoryCARActionNode);
       	//this.hideAction("printpdfhistorycarmenu");
       	this.disableAction("printpdfhistorycarmenu");
       	
       	this.printMultipleActionNode = tableViewer.addAction(
       			"printpdfmultiplemenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printMultipleMenu
       	);
       	this._actionButtons.push(this.printMultipleActionNode);
       	this.hideAction("printpdfmultiplemenu");
		//******end print button content******
		
		if(!this.showQueryFilters && (!content || !content.length)){
			this.printSummaryActionNode.setDisabled(true);
			this.printHistoryCARActionNode.setDisabled(true);
			this.printMultipleActionNode.setDisabled(true);
		}
    },
	_initialize2:function(){
		//if preference specifies, run the query
		if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
			this.initRunQuery();
			this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},
    _constructTableContentProvider: function() {
        //create the table provider
        return new SuiteLogTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
    /*
	_onPrintPdfActionClick: function() {
		var selectedScripts = this.tableViewer.getCheckedRows();
		var type;
		var summary = false;
		if (!selectedScripts.length){
			selectedScripts = this.results;
			type = "executionresult";
			summary = true;
		}else {
			type = "testsuitelog";
		}
		var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		this.tableViewer.sendPdfPrintRequest(selectedScripts,type,loc,this._projectAlias, summary);
	},
	
	_onPrintHistoryActionClick: function() {
		var selectedScripts = this.tableViewer.getCheckedRows();
    	var type = "testsuitelog";
    	var selectedScripts = this.tableViewer.getCheckedRows();
		var loc = window.location.href;
		loc = loc.replace(/[&]/g,"%26");
		var summary = false;
		if (!selectedScripts.length){
			selectedScripts = this.results;
			summary = true;
		}
		this.tableViewer.sendPdfHistoryRequest(selectedScripts,type,loc,this._projectAlias, summary);
	},
*/
	_onDeleteActionClick: function(selectedIds) {
		var selectedERs = selectedIds;
		var len = selectedERs.length;
        var args = {
            'message': Constants.getMessage("msgDelSuiteResultConfirm",len),
            'yesCallback': dojo.hitch(this, "_deleteAction"),
            'yesCallbackData': selectedIds,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function(selectedIds){
        this.deleteActionNode.setDisabled(true);
        var selectedERG = selectedIds.length;
        this.selectedIds = selectedIds;
        this.archivedERGs = 0;
        
        if (selectedERG > 0) {
            var self = this;
            var callbackERG = {
                success: function(par){
                    self.archivedERGs = par;
                    self._setDeleteStatus();
                },
                failure: function(err){
                    self.errorERCount++
                    self._setDeleteStatus(err);
                }
            }
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingSuiteResult"), 0, null);
            var responseHandler = new ServiceResponseHandler(callbackERG, "success", "failure");
            ExecutionResultGroupClient.postDeleteResult(responseHandler, {
                uuids: selectedIds,
                archive: true
            });
        }
    },
    
    _setDeleteStatus: function(err) {
        ProgressUtility.endTaskMonitor(this.monitorId, (err && err.message) ? err.message : null);
		if (this.isQueryPage){
            this._invalidateQuery();
			var message = Constants.getMessage("msgDeletedSuiteResults", this.archivedERGs, this.selectedERG);
            this.viewHeaderNode.setStatus(
                message,
                this.errorERCount == 0 ? ViewHeaderLayout.SUCCESS : ViewHeaderLayout.INFO
            );
		}	
    },

	refresh: function(content) {
        if(this.showInitLoadProgress && !this.inProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		if(this.printSummaryActionNode && this.printHistoryCARActionNode 
				&& this.printMultipleActionNode){
			var disable = (!content || !content.length);
			/*this.printSummaryActionNode.setDisabled(disable);
			this.printHistoryCARActionNode.setDisabled(disable);
			this.printMultipleActionNode.setDisabled(disable);*/
		}
		this.results = content;
		// we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        if (this.updatePageOnly) {
			this.provider.loadPageContent(content);
		}
		else {
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		}
		if(!this.skipClearStatus)
			this.viewHeaderNode.clearStatus();
		else
			this.skipClearStatus = false;
    },

	uninitialize: function(){
		//Remove menu items
		var menus = this._actionButtons;
		var menuLength = menus ? menus.length : 0;
		if(menus && menuLength>0){
			for(var i=0;i<menuLength;i++){
				menus[i].destroyRecursive();
			}
		}
	},
	
	getActionButton: function(actionId) {
    	 var len = this._actionButtons ? this._actionButtons.length : 0;
         for (var i = 0; i < len; i++) {
        	 if (this._actionButtons[i].actionId == actionId) {
        		 return this._actionButtons[i];
             }
         }        
      },

	hideAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.addClass(button.domNode,"dijitDisplayNone");
          }
      },
      
	showAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.removeClass(button.domNode,"dijitDisplayNone");
          } 
      },    

	disableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(true);
          } 
      },
  	
	enableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(false);
          } 
      }
});

})();