/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 		= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        		= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var CommonUtility		= com.ibm.asq.common.web.ui.internal.util.Utility;
var OptionsDialog    	= com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog;
var TestScriptClient	= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var GlobalEvents   		= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Constants      		= com.ibm.rqm.planning.web.client.internal.Constants;
var PermissionsClient   = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout    = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var UserClient 			= com.ibm.asq.common.web.client.internal.ContributorClient;    
var RegistryClient      = com.ibm.rqm.planning.web.client.internal.RegistryClient;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var DEFAULT_SCRIPT_TYPE = "Manual";
var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var  DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var ActionEntityType = com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;
var ProgressUtility = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("TestScriptTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },
	// Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = (dojo.isArray(selection)) ? selection.length : 2; // assign '2' to indicate more then 1 in select all
        var hasSelection = selectionCount > 0;
        var p = this.parentView;
        
        if (p.deleteActionNode)
            p.deleteActionNode.setDisabled(!hasSelection || !tableViewer.isEditable());
		
		if (p.bulkchangeActionNode)
            p.bulkchangeActionNode.setDisabled(!hasSelection);
			
        //if table view has a rowCheckListener, invoke it
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
            p.rowCheckedListener(rowObject, state);
        }
		if (!hasSelection) {
			p.disableAction("duplicate");						
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfsummarymenu");
			p.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			p.enableAction("duplicate");
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfsummarymenu");
			p.enableAction("printpdfmultiplemenu");
			p.showAction("printpdfmultiplemenu");
		} else if (selectionCount == 1) {
			p.enableAction("duplicate");			
			p.hideAction("printpdfsummarymenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfhistorycarmenu");
			p.showAction("printpdfhistorycarmenu");
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		if (this.parentView.parent && this.parentView.parent._TestScriptHeaderColumnActionInvoked) {
			this.parentView.parent._TestScriptHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
		}         
    }            
});

dojo.declare("TestScriptTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        alert(Constants.getMessage("labelCellValueChanged",rowObject.col1,newValue));
        
        // store the new values in our internal data model
        if(columnIndex == 6) {
            if(dojo.isString(newValue)) {
                rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		//handle delete action
		if (columnIndex == 5) {
		   alert(Constants.getMessage("labelNotYetSupported"));
		}
    }
});

dojo.declare("TestScriptTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("TestScriptTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);		
        this.COLUMNS = {
            TYPE: this.toColumn("", 2, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, null),
            ID: this.toColumn(Constants.getMessage("labelId"), 15, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_LINK, 'id'),
            NAME: this.toColumn(Constants.getMessage("labelName"), 33, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_LINK, 'name'),
			STATE: this.toColumn(Constants.getMessage("labelState"), 10, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'state'),
            SCRIPT_TYPE: this.toColumn(Constants.getMessage("labelScriptType"), 20, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, null, 'scriptTypeIds'),
            MODIFIED: this.toColumn(Constants.getMessage("labelModified"), 20, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'modified')
        }
		
        this.COLUMNS.ALL = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.NAME, this.COLUMNS.STATE, this.COLUMNS.SCRIPT_TYPE, this.COLUMNS.MODIFIED];
		this.COLUMNS.MINIMAL = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.NAME, this.COLUMNS.SCRIPT_TYPE, this.COLUMNS.MODIFIED];
		
        this.columnProfile = null;
        this.columnProfileName = null;
        this.setProfile(this.profile ? this.profile : "ALL"); //default to 'ALL' (full) column profile 	
    },
    
    toColumn: function(name, width, groupable, alignment, type, rowName, dbName) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            alignment: alignment,
            type: type,
            rowName: rowName,
            dbName: dbName || rowName
        }
    },  
	
    setProfile: function(/* string */ profile) {
        if (this.COLUMNS[profile]) {
            this.columnProfileName = profile;
            this.columnProfile = this.COLUMNS[profile];
        }
    },	

    getColumnIndex: function(name) {
        for (var i = 0; i < this.columnProfile.length; i++) {
            if (this.columnProfile[i].name == name) {
                return i;
            }
        }
        return -1;
    },	
			
    getColumnIdName: function(columnIndex)
    {
        var profile = this.columnProfile[columnIndex];
        return profile.dbName;
    },

    // Summary:
    //
    getNumColumns: function(content)
    {
        return this.columnProfile.length;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this.columnProfile[index].name;
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {  
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },   
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].groupable;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].name != this.COLUMNS.TYPE.name;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        var column = this.columnProfile[atColumnIndex];
        if (this.columnProfileName == "ALL") {
            return column.width;
        }
		//TODO - refactor into base class or create profile class
        //if using a smaller column profile, adjust widths
        var total = 0;
        for (var colName in this.columnProfile) {
            total += this.columnProfile[colName].width;
        }
        //split the difference between all columns proportionately
        var rowBuffer = 100 - total;   //percentage of width unused
        var columnBuffer = rowBuffer * (column.width / total);  //proportionately redistrubute
        return (column.width + Math.round(columnBuffer));  
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_testScript_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = this.columnProfile[atColumnIndex].type;
        // link is disabled as text label if the test script is archived
        if (rowData.archived && (type == TableConstants.RENDER_TYPE_LINK)) {
            return TableConstants.RENDER_TYPE_TEXT;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        var colName = this.columnProfile[atColumnIndex].name;
        switch(colName) {
            case this.COLUMNS.TYPE.name: 
                val = "";
                break;
            case this.COLUMNS.ID.name: 
                val = rowData.id;
                break;
            case this.COLUMNS.NAME.name: 
                val = rowData.name;
//				if (rowData.snapshotInfo) {
//					var snap = rowData.snapshotInfo;
//					val += Constants.getMessage("labelRevisionInfo", snap.revision, snap.name);
//				}else if (rowData.snapshotInfoName && rowData.snapshotInfoRevision) {
//					val += Constants.getMessage("labelRevisionInfo", rowData.snapshotInfoRevision, rowData.snapshotInfoName);
//				}
                break;
            case this.COLUMNS.STATE.name:
            	if (rowData.archived){ 
                	val =  Constants.getMessage("labelDeleted");
                } else {
                	var s = rowData.state; 
                	if (s == ""){
                		val = "";
                	}else{
                		val = EditorUtil.getStateNameFromID(s);
                	}
                }             
                break;
            case this.COLUMNS.SCRIPT_TYPE.name:
                if (rowData.scriptType) {
					if(rowData.scriptType.name == DEFAULT_SCRIPT_TYPE)
						val = Constants.getMessage("labelManual");
					else
						val = Constants.getExtensionDisplayMessage(rowData.scriptType.name);
				} else if (rowData.scriptTypeName) {
					if(rowData.scriptTypeName == DEFAULT_SCRIPT_TYPE)
						val = Constants.getMessage("labelManual");
					else
						val = Constants.getExtensionDisplayMessage(rowData.scriptTypeName);
				} else {
					val = Constants.getMessage("labelUnknown");
				}                         
                break;
            case this.COLUMNS.MODIFIED.name: 
                val = new Date();
                val.setTime(rowData.modified);
                break;   
            default:
                val = "";
                break;            
        }
        return val;		
    },

    getCellRawData: function(rowData, atColumnIndex)
    {
        var val = "";
        var rowName = this.columnProfile[atColumnIndex].rowName;
        
        if(rowName) {
            return (rowData[rowName] || val);
        }
        
        var colName = this.columnProfile[atColumnIndex].name;
        if(colName == this.COLUMNS.SCRIPT_TYPE.name) {
            if (rowData.scriptType) {
				if(rowData.scriptType.name == DEFAULT_SCRIPT_TYPE)
					val = Constants.getMessage("labelManual");
				else
                	val = Constants.getExtensionDisplayMessage(rowData.scriptType.name);
            } else if (rowData.scriptTypeName) {
				if(rowData.scriptTypeName == DEFAULT_SCRIPT_TYPE)
					val = Constants.getMessage("labelManual");
				else
                	val = Constants.getExtensionDisplayMessage(rowData.scriptTypeName);
            } else {
                val = Constants.getMessage("labelUnknown");
            }                         
        }
        return val;
    },
        
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = {};
        var colName = this.columnProfile[atColumnIndex].name;
        switch(colName) {
            case this.COLUMNS.TYPE.name: 
                val.image = ImageCache.TEST_SCRIPT;
				val.tooltip = rowData.archived ? Constants.getMessage("labelTSDeleted") : Constants.getMessage("labelClickToOpenTestScript");
                if (!rowData.archived) {
                    if (rowData.newItem && this.newItemLinkCallback) {
                        val.onclick = dojo.hitch(this, function(){
                            this.newItemLinkCallback(rowData.participantId);
                        });
                    }  else if (rowData.snapshotInfo) {
                        val.href = Utility.getTestScriptURI(rowData.versionableItemId, null,rowData.snapshotInfo.revision,rowData.snapshotInfo.name);
					}else if(rowData.snapshotInfoName && rowData.snapshotInfoRevision){
						val.href = Utility.getTestScriptURI(rowData.versionableItemId, null,rowData.snapshotInfoRevision,rowData.snapshotInfoName);
                    } else {
                        val.href = Utility.getTestScriptURI(rowData.id);
                    }
                }
                break;
            case this.COLUMNS.ID.name:
                if (!rowData.archived) {
                    val.linkType = Constants.getMessage("TestScriptID");
                }
            case this.COLUMNS.NAME.name: 
                if (!rowData.archived) {
                    if (rowData.newItem && this.newItemLinkCallback) {
                        val.onclick = dojo.hitch(this, function(){
                            this.newItemLinkCallback(rowData.participantId);
                        });
                    } else if (rowData.snapshotInfo) {
                        val.href = Utility.getTestScriptURI(rowData.versionableItemId, null,rowData.snapshotInfo.revision,rowData.snapshotInfo.name);
                    }else if(rowData.snapshotInfoName && rowData.snapshotInfoRevision){
						val.href = Utility.getTestScriptURI(rowData.versionableItemId, null,rowData.snapshotInfoRevision,rowData.snapshotInfoName);
					} else {
                        val.href = Utility.getTestScriptURI(rowData.id);
                    }
                }
                break;
            default:
                break;			        
        }
        return val; 		
    }
    
    
});

dojo.declare("TestScriptTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine, addSnapshotsFilter) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
		this.addSnapshotsFilter = addSnapshotsFilter;

        // define the static filters
        this.filters = [];
		this.filters.push(
        {
            name: "myItemsOnly",  // must match key in the arg list of the API
            title: Constants.getMessage("labelOnlyMyTestScripts"),
            promptTitle: Constants.getMessage("labelOnlyMyTestScripts"),
            type: TableContentFilterProvider.FIELD_CHECKBOX,
            defaultValue: this.defaultToMine, params: null
        });
		if (this.addSnapshotsFilter == true) {
            this.filters.push({
                name: "includeSnapshots",  // must match key in the arg list of the API
                title: Constants.getMessage("labelIncludeSnapshots"),
                promptTitle: Constants.getMessage("labelIncludeSnapshots"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: false, params: null               
            });
        }			
		this.filters.push({
	        name: "name",  // must match key in the arg list of the API
	        title: Constants.getMessage("labelname"),
	        promptTitle: Constants.getMessage("labelName"),
	        type: TableContentFilterProvider.FIELD_TEXT,
	        defaultValue: null, 
	        params: null
        });
        // numeric id filter
        this.filters.push({
            name: "id",  // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null, 
            params: null
        });
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelTestScripts"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 5;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },

    getFilterIdName: function(index) {
        var filter = this.filters[index];
        return filter.dbName || filter.name;        
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
                    args[nameKey] = '';
                }
            }
        }
        this.tableView.runQuery(args);
    }
});


dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    // allows clients to control whether the table should show
    // change settings controls.
    allowChangingTableSettings: true,
    pdfPrintType: "testscript",  // define the pdf print type. Our super class will handle it.
    editable: true,
	printable: false,
    widgetsInTemplate: true,
    baseTableArgs: null,
    
    constructor: function() {
	 	this.scripts = null;
		this.newItemLinkCallback = null;
		this.rowCheckedListener = null;
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
		this.allowQuerySnapshots = false;
		this._actionButtons = [];
        this.allowSelectAll = true;
        this.displayInPopup = false;
        
//		console.debug("++++++++++++++++++++TestscriptTableView Constructor");
	 },

    uninitialize: function() 
    {
        this.scripts = null;
        this.tableViewer = null;
    },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;

        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(TestScriptClient, "getAllSearchResultItemIds");

		//init options for running search
		this.setSearchFunction(dojo.hitch(TestScriptClient, "searchTestScripts"));
		this.setSearchCallback(dojo.hitch(this, "show"));
		this.setTypeLabel(Constants.getMessage("labelScript"));
        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
		
		this._projectAlias = CommonUtility.getCurrentProjectAreaAlias();
        // apply the user preference whether to initially open the filter area
        if (this.showQueryFilters) {
        	this._initScriptTypes();	         
        }
		this._initialize();
    },
    _initialize2:function(){
		if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
			this.initRunQuery();
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
	},
    _initialize: function() 
    {
        //create table viewer       
        var isMinimal = this.profile && this.profile != Constants.TABLE_PROFILE_ALL;
        var allowChangeSettings = (this.allowChangingTableSettings && (!isMinimal || this.tableId));
        var tableArgs = {
            showPagingControl: !this.printable,
            showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,     
            allowAdjustSettings: allowChangeSettings,
            handleVirtualSelectAll: true,            
            autoSaveSettings: allowChangeSettings,
            allowSelectAll: this.allowSelectAll,
            displayInPopup: this.displayInPopup
        };
        // there are client specified table args, apply them.
        if(this.baseTableArgs && dojo.isObject(this.baseTableArgs)) {
            dojo.mixin(tableArgs, this.baseTableArgs);
        }
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableArgs); 		
		      
        // setup the table's id for saving table settings
        // Also, the per-session saved filter is indexed by
        // the table's id, need to set this up before creating
        // the filter provider. 
        if(!isMinimal || this.tableId) {
            var id = (this.tableId) ? this.tableId : ((this.isQueryPage) ? "RQM-TS-QUERY-TABLEVIWER" : "RQM-TS-TABLEVIWER");
            tableViewer.tableId = id;
        }
        this.tableViewer = tableViewer;
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        
        var content = this.scripts ? this.scripts : [];
        
        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_test_scripts.html");        
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAllTestScript")+" "+Constants.getMessage("labelHelp"));
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
        tableViewer.setContent(content);
		tableViewer.setTableRowsCheckable(this.editable && !this.printable);
        this.provider = this._constructTableContentProvider();
	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new TestScriptTableView.TableListener(this));
        tableViewer.setCellModifier(new TestScriptTableView.CellModifier());       
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestScripts"))); 
        if (this.enableRowSelection) {
            tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ false);
        }        

		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		
		var length=(this.actions ? this.actions.length : 0);
        for (var i = 0; i < length; i++) {
            var action = this.actions[i];
            if (!(this.readOnly && action.disableOnReadOnly)) {
                if (!this.isQueryPage && action.label == Constants.getMessage("labelRemoveTestScripts")) {//If not querypage remove action will be sent
					this.deleteActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
					this.deleteActionNode.setDisabled(true);
				}
				else if (action.label == Constants.getMessage("labelChangeTestScriptProperties")) {
					this.bulkchangeActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
					this.bulkchangeActionNode.setDisabled(true);
				}
				else {
					tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				}	
            }
        }  		
		
        var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SCRIPT);
		if (this.isQueryPage) {
            if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
                this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "invokeAction", "versionableItemId", this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
			this.duplicateActionNode = tableViewer.addAction(
    	       		"duplicate",
            		Constants.getMessage("labelDuplicateAction"),
    	       		null,
            		"duplicate-icon-image",
    				dojo.hitch(this, "invokeAction", "id", this, "_onDuplicateActionClick"));
    		var duplicateAction = new  DuplicateAction();
			duplicateAction.isDuplicateAllowed(ActionEntityType.TEST_SCRIPT, dojo.hitch(this, "_isDuplicateAllowedCallback"));
 		
    		this._actionButtons.push(this.duplicateActionNode);				
          	this.duplicateActionNode.setDisabled(true);       
        }
		
        if(!this.minimalAction) {            
            //******print button content******
    		var printHistoryCARMenu = new dijit.Menu({ style: "display: none;"});
    		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
    		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
    		
            var normalOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelCAR"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
            var historyOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelHistory"),
            	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")
            });
            var summaryOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelSummary"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });        
            var multipleOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelMultiple"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
    		
            printHistoryCARMenu.addChild(normalOption);
            printHistoryCARMenu.addChild(historyOption);      
            printSummaryMenu.addChild(summaryOption);
            printMultipleMenu.addChild(multipleOption);
            
           	this.printSummaryActionNode = tableViewer.addAction(
           			"printpdfsummarymenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick"),
           			printSummaryMenu
           	);      	
           	this._actionButtons.push(this.printSummaryActionNode);
           	this.enableAction("printpdfsummarymenu");
           	
           	this.printHistoryCARActionNode = tableViewer.addAction(
           			"printpdfhistorycarmenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print"),
           			printHistoryCARMenu
           	);
           	this._actionButtons.push(this.printHistoryCARActionNode);
           	this.hideAction("printpdfhistorycarmenu");
           	
           	this.printMultipleActionNode = tableViewer.addAction(
           			"printpdfmultiplemenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick"),
           			printMultipleMenu
           	);
           	this._actionButtons.push(this.printMultipleActionNode);
           	this.hideAction("printpdfmultiplemenu");
            //******end print button content******
        }
                      		  
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        this.tableViewer.show();
        this.tableViewer.setEditable(this.editable);	
		
		if(!this.showQueryFilters && (!content || !content.length)){
			if (!this.minimalAction) {
				this.printSummaryActionNode.setDisabled(true);
				this.printHistoryCARActionNode.setDisabled(true);
				this.printMultipleActionNode.setDisabled(true);
			}
		}
    },

    _constructTableContentProvider: function() {
        //create the table provider
        return new TestScriptTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            profile: this.profile ? this.profile : Constants.TABLE_PROFILE_ALL,
            newItemLinkCallback: this.newItemLinkCallback,      
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
    
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function(scriptTypes) {
        // create the filter provider for the table
        this.filterProvider = new TestScriptTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine(), this.allowQuerySnapshots);

        this.moreFilters = [];
		
        // initlize the orginator filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(contributors) {
				contributors = contributors || [];
				var length=contributors.length;
                for (var i = 0; i < length; i++) {
                	var contributor=contributors[i];
                    if (CommonUtility.isUnassignedUserId(contributor.itemId)) {
                        contributor.name = Constants.getMessage("labelUnassigned");
                    }
                    contributor.value = contributor.itemId;
                    contributor.checked = false;
                }
                
                var originators = {
                    name: "originatorUUIDs",  // must match key in the arg list of the API
                    title: Constants.getMessage("labeloriginatorLabel"),
                    promptTitle: Constants.getMessage("labelOriginator"),
                    type: TableContentFilterProvider.FIELD_TOGGLELIST,
                    defaultValue: [],
                    params: (contributors == null) ? null : {options: contributors}
                };
                var selfFilters=self.filterProvider.filters;
                selfFilters.push(originators);
                // add the category filters to the end if there is any
                var moreFilters=self.moreFilters;
                var length=moreFilters.length;
                for (var j = 0; j < length; j++) {
                    selfFilters.push(moreFilters[j]);
                }
                self._initialize2();
            },
            
            failure: function(e) {
                self._error(e);
                // add the category filters to the end if there is any even when
                // it failed to initialize the originator filter
                var selfFilters=self.filterProvider.filters;
                var moreFilters=self.moreFilters;
                var length=moreFilters.length;
                for (var j = 0; j < length; j++) {
                    selfFilters.push(moreFilters[j]);
                }
                self._initialize2();
         	}
        };
        
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        UserClient.getContributors(responseHandler);
		//add state filter
        this.addArtifactStateFilter(this.moreFilters);

        // modified date time filter - default to one week ago
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified",  // must match the content provider
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, this.moreFilters);

        if (scriptTypes != null && scriptTypes.length > 0) {
            var types = [];
            var length=scriptTypes.length;
            for(var i = 0; i < length; i++) {
            	var scriptType=scriptTypes[i];
                if (scriptType.name == "Unknown" || scriptType.name == "NoScript") { continue; }
                types.push({
                    name: scriptType.displayName,
                    value: scriptType.id,
                    checked: false
                });
            }

            this.moreFilters.push({
                name: "scriptTypeIds",  // must match key in the arg list of the API
                title: Constants.getMessage("labelScriptType") + Constants.getMessage("labelColen"),
                promptTitle: Constants.getMessage("labelScriptType"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: null,
                params: {'options': types}
            });
        }
    },
    
    _initScriptTypes: function() 
    {
        var self = this;
        var serviceObj = {
            success: function(scriptTypes) {
                self._sortScriptTypes(scriptTypes);
                self._initializeFilters(scriptTypes);
            },
            failure: function(e) {
                self._error(e);
                self._initializeFilters();
            }
        };
        var handler = new ServiceResponseHandler(serviceObj, "success", "failure");
        RegistryClient.getAllExecutionScriptTypes(handler);         
    },
    
    _sortScriptTypes: function(types) 
    {
        var length=types.length;
        for (var i = 0; i < length; i++) {
        	var type=types[i];
        	var name=type.name;
            if (name == "Unknown" || name == "NoScript") { continue; }
            type.displayName = (name == DEFAULT_SCRIPT_TYPE) ? Constants.getMessage("labelManual") : 
            												  Constants.getExtensionDisplayMessage(name);
        }
        
        for(var ix = 0; ix < length; ix++ ) {
            for(var iy = ix + 1; iy < length; iy++ ) {
                if(types[iy].displayName < types[ix].displayName) {
                    var swap = types[ix];
                    types[ix] = types[iy];
                    types[iy] = swap;
                }
            }
        }
    },
	
	_onDuplicateActionClick: function(ids) {
		var duplicateAction = new  DuplicateAction();
		// TODO this won't work until I get Matt's latest change. Hacked right now to only support Manual
		duplicateAction.setType(ActionEntityType.MANUAL_TEST_SCRIPT);
		duplicateAction.execute(ids, dojo.hitch(this, "_invalidateQuery"), dojo.hitch(this, "_duplicateError"));	
	},
	
	
	_isDuplicateAllowedCallback: function(allowed){
		if(!allowed)
			this.duplicateActionNode.domNode.style.display = "none";			
	},
	
	_duplicateError: function(e){
		alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));	
	},

	_onDeleteActionClick: function(selectedIds) {
        // check if any selected test cases are current displayed in another tabs
        var openedArtifacts = [];
        var selectedScripts = [];
        var selectedRows = this.tableViewer.getCheckedRows();
        
        if (dojo.isArray(selectedRows) && this.artifactsDisplayContainer) {
            var userSelectedScripts = this.tableViewer.getCheckedRows();
            var len = userSelectedScripts.length;
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    var scriptURI = Utility.getTestScriptURI(userSelectedScripts[i].id);
                    if (this.artifactsDisplayContainer.hasPage(scriptURI)) {
                        openedArtifacts.push(userSelectedScripts[i]);
                    } else {
                        selectedScripts.push(userSelectedScripts[i]);
                    }
                }
            }
        } else {
            // can't check for opened tab, just show the deleting confirmation
            selectedScripts = null;
        }
        var len2 = (selectedScripts) ? selectedScripts.length : selectedIds.length;
		this.selectedScripts = selectedScripts;
        var prompt = "";
        if (len2 > 1) {
            prompt = Constants.getMessage("msgRemoveItem2", len2, Constants.getMessage("labelScript"));
        } else if (len2 == 1) {
            prompt = Constants.getMessage("msgRemoveItem", Constants.getMessage("labelScript"), this.selectedScripts[0].name);
        }
        if (openedArtifacts.length > 0) {
            if (len2 > 0) {
                // some selected artifacts are not opened in tabs
                prompt = Constants.getMessage("msgDelSomeOpenTestScriptConfirm");
            } else {
                // all selected artifacts are opened in tabs
                prompt = Constants.getMessage("msgDelAllOpenTestScriptConfirm");
            }
        }

        var args = {
            'message': prompt,
            'options': openedArtifacts,
            'selectedIds': selectedIds,
            'okCallback': 
                function(view) {
                    view._deleteAction();
                },
            'okCallbackData': this,
            'cancelCallback': null,
            'cancelCallbackData': null
        };
        this.confirmDialog = new OptionsDialog(args);
        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
        this.confirmDialog.open();
    },

    _deleteAction: function() {         
        var deleteIds;
        var dlg = this.confirmDialog;

        this.confirmDialog = null;
        // we have possible shown options to not delete certain items, check it.
        if (this.selectedScripts) {
            this.selectedScripts = this.selectedScripts.concat(dlg.getSelection());
            var count = this.selectedScripts.length;
            deleteIds = [];
            for(var i = 0; i < count; i++) {
                deleteIds.push(this.selectedScripts[i].versionableItemId);
            }
        }
        else {
            // no special handling of opened items, just use all deleted ids.
            deleteIds = dlg.selectedIds;
        }
        var totalDeleteCnt = deleteIds.length;
		this.selectedScriptCount = totalDeleteCnt;
        if (totalDeleteCnt > 0) {
            this.deleteActionNode.setDisabled(true);
            this.errorScriptCount = 0;
            this.deletedScriptCount = 0;

            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingTestScripts"), totalDeleteCnt, null);  
            for (var i = 0; i < this.selectedScriptCount; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                var args = {
                    versionableItemId: deleteIds[i],
                    archive: true
                };
                // Note: We can just use the test script archive method to archive any
                // type of test scripts. The RemoteExecutionScriptClient would be just
                // calling the same test script method to archive. No need to have separate
                // calls.
                //
				//var scriptTypeId = (this.selectedScripts[i].scriptTypeId) ? this.selectedScripts[i].scriptTypeId :
				//    (this.selectedScripts[i].scriptType) ? this.selectedScripts[i].scriptType.id : null;
				//if (scriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual")
                TestScriptClient.archiveTestScript(responseHandler, args);
                //else
                //    com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient.archiveTestScript(responseHandler, args);
            }
        }
    },
	
    _deleteSuccess: function(response) {
        this.deletedScriptCount++;
        this._setDeleteStatus();

    },
    
    _deleteFailure: function(err) {
        this.errorScriptCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        var currDeletedCnt = (this.deletedScriptCount + this.errorScriptCount);
        
        ProgressUtility.updateTask(this.monitorId, currDeletedCnt);
        if (currDeletedCnt == this.selectedScriptCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedTestScript", this.deletedScriptCount, this.selectedScriptCount),
                    this.errorScriptCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedScriptCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedScriptCount > 0) {
                // notify all pages (including itself) test plans are deleted
                this._deleteFromSelf = true;
                // TODO: virtual select all case don't have selectedScripts... need to use itemIds in
                // notification.
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_SCRIPT, this.selectedScripts]);
                delete this.selectedScripts;
                delete this.selectedScriptCount;
            }
        }
    },
	
     // API
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },
     
    getAction: function(actionId) {
    	var len = this.actions?this.actions.length:0;
        for (var i = 0; i < len; i++) {
        	if (this.actions[i].actionId == actionId) {
        		return this.actions[i];
            }
        }        
     },
      
     getActionButton: function(actionId) {
    	 var len = this._actionButtons ? this._actionButtons.length : 0;
         for (var i = 0; i < len; i++) {
        	 if (this._actionButtons[i].actionId == actionId) {
        		 return this._actionButtons[i];
             }
         }        
      },
      
      hideAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.addClass(button.domNode,"dijitDisplayNone");
          }
      },
      
      showAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.removeClass(button.domNode,"dijitDisplayNone");
          } 
      },    

  	  disableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(true);
          } 
      },
  	
  	  enableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(false);
          } 
      }, 

     refresh: function(content, skipClearStatus) {
		this.scripts = content;
         var cancelProgress = this.showInitLoadProgress;
        
         // we don't create the table until we fetched the categories.
         // The table may not have existed at this point. The real data
         // has arrived. Always reset the init load progress flag. 
         if(this.showInitLoadProgress) {
             this.showInitLoadProgress = false;
         }
         if (this.tableViewer) {
            if(cancelProgress) {
                this.tableViewer.endLoadingProgress();
            }
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content);
            }
            else {
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            }
		 }
         if (this.viewHeaderNode && !skipClearStatus) {
             this.viewHeaderNode.clearStatus();
         }
		 
		 if (this.tableViewer)
		 {
	 		 var listener = this.tableViewer.getTableListener();
			 if(listener)
				listener.rowCheckStateChanged(this.tableViewer);
		 }

     },
	 
	 show: function(scripts) {
        this.refresh(scripts || []);
        this.stopInProgress();
        if (this.queryFiltersCallback) {
            this.queryFiltersCallback();
        }	 	
	 },
	 
	 // handler on artifacts changed
     onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about test scripts
        if (artifactType == Constants.TYPE_SCRIPT) {
            if (this._deleteFromSelf && changeType == GlobalEvents.ArtifactsDeleted) {
                if(this._invalidateQuery)
                    this._invalidateQuery();
                delete this._deleteFromSelf;
                return;
            }             
            if (this.isQueryPage) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_SCRIPT, changeType);
                return;
            }
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add test scripts to the table
                if (!this.scripts) {
                    this.scripts = artifactArray;
                } else {
                    this.scripts = this.scripts.concat(artifactArray);
                }
                this.refresh(this.scripts, true);
            } else {
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of test scripts in the table
                    for (var j = 0; j < this.scripts.length; j++) {
                        // handle the matching test script
                        if (artifactArray[i].id == this.scripts[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap test script on update
                                this.scripts.splice(j, 1, artifactArray[i]);
                                this.refresh(this.scripts, true);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove test script from table on delete
                                this.scripts.splice(j, 1);
                                this.refresh(this.scripts, true);
                            }
                            break;
                        }
                    }
                }
            }
        }
    },
	
	setTableRowsCheckable: function(checkable, isSingleSelect){
		this.tableViewer.setTableRowsCheckable(this.editable && checkable, isSingleSelect);
	},
    
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }
          
});

})();
