/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDefectSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");

(function(){
    var ConfirmationDialog = com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;        
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;    
    var FormNumericField    = com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField;
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDefectSelector", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/timebox/PlanDefectSelector.html"),       
        title: "",
        labelPlanDefects: "",
        RowNode:null,
        
        constructor: function(args){
            this.okCallback = null;
            this.isEditable = null;          
            this.ItemId = null;            
            this.planDefects = null;
            this.contentHeight = "125px"; 
            this._dialog = null;    
                                   
        },
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
          
            var table = document.createElement("table");
            table.cellSpacing ="15";
            table.width="350px"; 
            var row=table.insertRow(0);            
            var row2=table.insertRow(1);   
            var cell1=row.insertCell(0);
            var cell2=row2.insertCell(0);
            
            dojox.data.dom.removeChildren(this._DataNode);
            this._DataNode.appendChild(table);
            
            this.ExpectedDefects = new FormNumericField({
            fieldLabel: Constants.getMessage("labelExpectedDefects"),
            required: true
            });
        
            this.ValidDefects = new FormNumericField({
            fieldLabel: Constants.getMessage("labelValidDefects"),
            required: true
             });
        
            cell1.appendChild(this.ExpectedDefects.domNode);
            cell2.appendChild(this.ValidDefects.domNode);
            
            var dialogArgs = {
                primaryTitle: this.title,              
                isClosable: false,
                zIndex: 100,
                okCallback:dojo.hitch(this, "_yesAction")
                              
            };
            
            if(this.planDefects){
                this.ExpectedDefects.setValue(this.planDefects[0]);
                this.ValidDefects.setValue(this.planDefects[1]);
            }
            this._dialog = new ConfirmationDialog(dialogArgs);            
            this.ExpectedDefects.onValueChanged = dojo.hitch(this, "_onChange");
            this.ValidDefects.onValueChanged = dojo.hitch(this, "_onChange");            
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog._yesButton.disabled=true;
            this._dialog.open();                       
        },
        
        initialize: function(){                    
                         
        },
        
        _onChange: function()
        {
          this._dialog._yesButton.disabled=!(this.ExpectedDefects.textField.isValid() && this.ValidDefects.textField.isValid());  
        },
        
        _yesAction: function()
        {
           var data = {
                      PlannedDefects: this.ExpectedDefects.getValue(),
                      ValidDefects: this.ValidDefects.getValue()
                   };
           this.RowNode.newValueEntered(data);
        },
        
        _setDirty: function()
        {
        
        },
        
        _error: function(e){
            console.error(this.declaredClass + ": error: " + (e ? e.message : ""));
        }
        
    })
})();
