/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Load: com.ibm.rqm.process.web.ui.internal.view.timebox.TimeboxTable");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.timebox.TimeboxTable");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.NumberTextBox");

dojo.require("dojox.data.dom");
dojo.require("dojo.date.locale");

dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDetailsDialog");
dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDefectSelector");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

(function(){
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
	var getCurrentProjectArea 	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var REPORT_REST_SERVICE_URI = "com.ibm.team.reports.common.internal.service.IReportRestService";
	var TimeboxClient 			= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
	var AlertDialog 			= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
    var minutes = 1000 * 60;
    var hours = minutes * 60;
    var days = hours * 24;
    var years = days * 365;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var TooltipBuilder = com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder;
    var util = com.ibm.team.workitem.web.client.util;
	var RENDER_TYPE_INPUTTEXT = "RenderType.InputText";
	var RENDER_TYPE_EDITTABLE_TEXT_BUTTON = "TimeboxTable.EditableTextButton";
    var DATE_FORMAT             = "yyyy-MM-dd";  //$NON-NLS$
	
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	// global save context
    var SaveParticipant = com.ibm.rqm.planning.web.ui.internal.model.SaveParticipant;
	
	   dojo.declare("TimeboxTable.EditableTextButton", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer, {
        // Summary:
        //    Renders the cell content. For renderer that can modify the cell value,
        //    
        renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/ cellModifier, rowObject, columnIndex, cellWidthHint){
            var node;
			var button;
	        var contentProvider = viewer.getContentProvider();
	        var editable = viewer.isEditable() && (contentProvider ? contentProvider.getIsCellEditable(rowObject, columnIndex) : false);
	        
	        if (editable) {
				var inputLabel = document.createElement("label");
				var table = document.createElement("table");
				var tbody = document.createElement("tbody");
				table.appendChild(tbody);
				var tr = tbody.insertRow(0);
				
				node = document.createElement("label");
				node.innerHTML = cellData;
	            var widthStyled = false;
	            
	            if(extendedDisplayInfo && dojo.isObject(extendedDisplayInfo)) {
	    			if (extendedDisplayInfo['textWidth']) {
	                    node.style.width = extendedDisplayInfo['textWidth'];
	                    widthStyled = true;
	                }    
	    			if (extendedDisplayInfo['size']) {
	                    node.size = extendedDisplayInfo['size'];
	                    widthStyled = true;
	                }    
	                if(extendedDisplayInfo['class'])
	                    dojo.addClass(node, extendedDisplayInfo['class']);
	            }
	            // by default, if not IE always add style to stretch the field
	            // to the table cell width. 
	            if(!widthStyled && !dojo.isIE) {
	                dojo.addClass(node, "editText-cell");
	            }
	                
	            node.cellModifier = cellModifier;
	            node.rowObject = rowObject;
	            node.columnIndex = columnIndex;
	            node.oldValue = cellData;
	                    
	            node.onkeyup = function() {
	                var oldValue = this.oldValue;
	                this.oldValue = this.value;
	                
	                if (oldValue != this.value && this.cellModifier)
	                    this.cellModifier.cellValueChanged(oldValue, this.value, this.rowObject, this.columnIndex);
	            }
                var cell1 = tr.insertCell(0);
                dojo.attr(cell1, "align", "center");
                cell1.style.width = "70%";
                cell1.style.paddingRight = "0px";
                cell1.style.borderBottom = "0px";
                cell1.appendChild(node);
				var arg={};
				if(columnIndex==5)
				{
                     arg = {
                        label: Constants.getMessage("labelPlanDetails"),
                        onClick: dojo.hitch(viewer, "planDetailsClick", [true, node, rowObject.col3, rowObject.col4, rowObject.itemId])
                     };
                    arg["iconClass"] = "plan-details-icon";
                    
				}
				else
				{
				    node.newValueEntered = function(value)
                    {
                      var oldValue = this.oldValue;
                      this.oldValue = this.value;
                    
                    if (this.oldValue != value && this.cellModifier)
                        this.cellModifier.cellValueChanged(oldValue, value, this.rowObject, this.columnIndex); 
                    };
				    arg = {
                        label: Constants.getMessage("labelPlanDetails"),
                        onClick: dojo.hitch(viewer, "defectsClick", [true, rowObject.itemId,rowObject.col11,rowObject.col7,node])
                     };
                    arg["iconClass"] = "archive-icon-image";
				    
				}
                arg["showLabel"] = false;
                var button = new com.ibm.asq.common.web.ui.internal.widgets.Button(arg);
					
				var cell2 = tr.insertCell(1);
				cell2.style.width = "70%"
				cell2.style.paddingLeft = "0px";
				cell2.style.paddingRight = "0px";
				cell2.style.borderBottom = "0px";
				cell2.appendChild(button.domNode);
				
				inputLabel.appendChild(table);
				
				if(extendedDisplayInfo && dojo.isObject(extendedDisplayInfo))
	            	this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);
				return inputLabel;
	        } 
	        else {
	            node = document.createElement("span");
	            this._renderCellText(viewer, cellData, extendedDisplayInfo, node, cellWidthHint);
				return node;
	        }
        },
		
		valueChanged: function(node) {
			
		}
    });
	
	dojo.declare("TimeboxTable.InputTextBox", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer, {
        // Summary:
        //    Renders the cell content. For renderer that can modify the cell value.
		//    Invoke cellValueChanged when input is blured
        //    
        renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/ cellModifier, rowObject, columnIndex, cellWidthHint){
            var node;
            var contentProvider = viewer.getContentProvider();
            var editable = viewer.isEditable() && (contentProvider ? contentProvider.getIsCellEditable(rowObject, columnIndex) : false);
            
            if (editable) {
                var inputLabel = document.createElement("label");
                node = document.createElement("input");
                node.type = "text";
                node.value = cellData;
                var widthStyled = false;
                
                if (extendedDisplayInfo && dojo.isObject(extendedDisplayInfo)) {
                    // Ignore sizing information if the cell size hint is provided.
                    // the cell's size hint takes precedance.
                    if (!cellWidthHint && extendedDisplayInfo['textWidth']) {
                        node.style.width = extendedDisplayInfo['textWidth'];
                        widthStyled = true;
                    }
                    if (!cellWidthHint && extendedDisplayInfo['size']) {
                        node.size = extendedDisplayInfo['size'];
                        widthStyled = true;
                    }
                    if (extendedDisplayInfo['class']) 
                        dojo.addClass(node, extendedDisplayInfo['class']);
                }
                // by default, if not IE always add style to stretch the field
                // to the table cell width. 
                if (!widthStyled && !dojo.isIE) {
                    dojo.addClass(node, "editText-cell");
                }
                dojo.addClass(node, "editText-cell-border");
                // restrict the size of the box to the width hint.
                if(cellWidthHint)
                    node.style.width = cellWidthHint + "px";
                
                node.cellModifier = cellModifier;
                node.rowObject = rowObject;
                node.columnIndex = columnIndex;
                node.oldValue = cellData;
                
                this.connect(node, "onblur", function(e){
                    var node = e.target;
                    if (node) {
                        var oldValue = node.oldValue;
                        node.oldValue = node.value;
                    
                        if (oldValue != node.value && node.cellModifier) 
                            node.cellModifier.cellValueChanged(oldValue, node.value, node.rowObject, node.columnIndex);
                    }
                });
                inputLabel.appendChild(node);
                if (extendedDisplayInfo && dojo.isObject(extendedDisplayInfo)) 
                    node.tooltip = this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);
                
                this.cellNodes.push(node);    
                return inputLabel;
            }
            else {
                node = document.createElement("span");
                this._renderCellText(viewer, cellData, extendedDisplayInfo, node, cellWidthHint);
                return node;
            }
        },
    
        disconnectAll: function()
        {
            //console.debug("================TimeboxTable.InputTextBox disconnectAll");
            this.inherited(arguments);
            
            var cellNodes = this.cellNodes;
            var len = cellNodes.length;
            for(var i = 0; i < len; i++) {
                var node = cellNodes[i];
                node.cellModifier = null;
                node.rowObject = null;
                node.columnIndex = null;
                node.oldValue = null;
                if(node.tooltip && node.tooltip.destroy) {
                    node.tooltip.destroy();
                }
                node.tooltip = null;
                node.onmouseover = null;
                node.onmouseout = null;
                node.onhover = null;
                node.onunhover = null;
            }
            this.cellNodes = [];
        } 
    });
    
    dojo.declare("TimeboxTable.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
         parentView: null,
    
    	constructor: function(testView)
    	{
        	this.parentView = testView;
    	},
	
		// Summary:
        //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
        //   called.
        //
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            rowObject.selected = state;
			var selectionCount = tableViewer.getCheckedRows().length;
			if (this.parentView.deleteActionNode)
            	this.parentView.deleteActionNode.setDisabled(selectionCount == 0 || !tableViewer.isEditable());
        },
		
		// Summary:
    	//    If the client have registered table actions, this message will be fired when an action (button)
    	//    is invoked by the user.
    	//
    	tableContentActionInvoked: function(tableViewer, actionId, callbackData)
    	{
        	switch(actionId){
				case "add":
					this.parentView._handleAddNewClick();
					break;
				case "remove":
					this.parentView._handleDeleteClick();
					break;
				case "preview":
					this.parentView._handlePreviewClick(tableViewer);
					break;
				default:
					break;
			}      
    	}
    });
    
    dojo.declare("TimeboxTable.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
        
        constructor: function(viewer, parent){
            this.tableViewer = viewer;
			this.parent = parent;
        },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
			if(this.parent.parentSection){
				this.parent.parentSection.setDirty();
			}
			if(rowObject.type == 0) {
				rowObject.isChanged = true;
			}
            switch (columnIndex) {
                case 0:
					rowObject.col1 = newValue;
                    break;
                case 1:
					rowObject.col2 = newValue;
                    break;
                case 2:
					rowObject.col3 = this._getDateString(newValue);
					this._calculateExpDuration(rowObject);
//					this._resetExpEndDate(rowObject);
                    break;
				case 3:
					rowObject.col4 = this._getDateString(newValue);
					this._calculateExpDuration(rowObject);
//					this._resetExpEndDate(rowObject);
                    break;	
                case 4:
					//input number, add " d"
					newValue = dojo.trim(newValue);
					if(newValue ==""||newValue == "d"||newValue == "w")
						newValue = Constants.getMessage("labelDurationUnit", "0");
					if(!isNaN(dojo.number.parse(newValue)))
						newValue = Constants.getMessage("labelDurationUnit", newValue);
					newValue = this.weekTodays(newValue);
					rowObject.col5 = newValue;
					this._resetExpEndDate(rowObject);
					break
				case 5:
					rowObject.col6 = newValue;
					break;
				case 6:
				    rowObject.col11=newValue['PlannedDefects'];
				    rowObject.col7=newValue['ValidDefects'];
				    this.tableViewer.refresh();
				    break;
                case 7:
					rowObject.col8 = this._getDateString(newValue);
					this._calculateDuration(rowObject);
//					this._resetEndDate(rowObject);
                    break;
				case 8:
					rowObject.col9 = this._getDateString(newValue);
					this._calculateDuration(rowObject);
//					this._resetEndDate(rowObject);
                    break;
                case 9:
					//input number, add " d"
					if(newValue ==""||newValue == "d"||newValue == "w")
						newValue = Constants.getMessage("labelDurationUnit", "0");
					if(!isNaN(dojo.number.parse(newValue)))
						newValue = Constants.getMessage("labelDurationUnit", newValue);
					newValue = this.weekTodays(newValue);
					rowObject.col10 = newValue;
					this._resetEndDate(rowObject);
                    break;
                default:
                    break;
            }
        },
       
	   weekTodays: function(newValue){
			if(newValue.search(/^(\d+)\s*w$/) != -1){
				var wLocation = newValue.indexOf("w");
				newValue = newValue.substring(0,wLocation);
				newValue = dojo.trim(newValue);
				var week = dojo.number.parse(newValue);
				var days = week * 7;
				newValue = Constants.getMessage("labelDurationUnit", days);
			}
			if(newValue.search(/^(\d+)\s*w\s*(\d+)\s*d$/) != -1){
				var wLocation = newValue.indexOf("w");
				var weekPart = newValue.substring(0,wLocation);
				weekPart = dojo.trim(weekPart);
				var dayPart = newValue.substring(wLocation+1);
				var week = dojo.number.parse(weekPart);
				var weekPartDays = week * 7;
				dayPart = dojo.trim(dayPart);
				var dLocation = dayPart.indexOf("d");
				dayPart = dayPart.substring(0,dLocation);
				dayPart = dojo.trim(dayPart);
				var dayPartDays = dojo.number.parse(dayPart);
				var days = weekPartDays + dayPartDays;
				newValue = Constants.getMessage("labelDurationUnit", days);
			}
			return newValue;
	   },
	   
        cellActionInvoked: function(rowObject, columnIndex){
        },
		
		_getDateString: function(value) {
			if (value instanceof Date) {
				return dojo.date.locale.format(value, {datePattern: DATE_FORMAT,selector: "date"});
			} else {
				return value;
			}
		},
		
		_resetExpEndDate: function(rowObject) {
			if(rowObject.col3 != null && rowObject.col3 != "" && rowObject.col5 != null && rowObject.col5 != ""){
				var start = dojo.date.stamp.fromISOString(rowObject.col3);
				var duration = rowObject.col5;
				var dArr = duration.split("d");
				if (dArr && dArr.length > 0) {
					duration = dArr[0];
				}
				var newValue = dojo.date.add(start, "day", parseInt(duration, 10)-1);
				newValue = dojo.date.locale.format(newValue,{datePattern:"yyyy-MM-dd", selector:"date"});
				rowObject.newEDate = newValue;
				rowObject.col4 = newValue;
				this.tableViewer.refresh();
			}
		},
		_calculateExpDuration: function(rowObject) {
			if(rowObject.col3 != null && rowObject.col4 != null && rowObject.col3 != "" && rowObject.col4 != ""){
				var start = dojo.date.stamp.fromISOString(rowObject.col3);
				var end = dojo.date.stamp.fromISOString(rowObject.col4);
				var duration = dojo.date.difference(start, end, "day")+1;
				if (duration >= 0) {
					rowObject.newDuration = duration;
					rowObject.col5 = Constants.getMessage("labelDurationUnit", duration);
					this.tableViewer.refresh();
				}
			}
		},

		_resetEndDate: function(rowObject) {
			if(rowObject.col8 != null && rowObject.col8 != "" && rowObject.col10 != null && rowObject.col10 != ""){
				var start = dojo.date.stamp.fromISOString(rowObject.col8);
				var duration = rowObject.col10;
				var dArr = duration.split("d");
				if (dArr && dArr.length > 0) {
					duration = dArr[0];
				}
				var newValue = dojo.date.add(start, "day", parseInt(duration, 10)-1);
				newValue = dojo.date.locale.format(newValue,{datePattern:"yyyy-MM-dd", selector:"date"});
				rowObject.newEDate = newValue;
				rowObject.col9 = newValue;
				this.tableViewer.refresh();
			}
		},
		
		_calculateDuration: function(rowObject) {
			if(rowObject.col8 != null && rowObject.col9 != null && rowObject.col8 != "" && rowObject.col9 != ""){
				var start = dojo.date.stamp.fromISOString(rowObject.col8);
				var end = dojo.date.stamp.fromISOString(rowObject.col9);
				var duration = dojo.date.difference(start, end, "day")+1;
				if (duration >= 0) {
					rowObject.newDuration = duration;
					rowObject.col10 = Constants.getMessage("labelDurationUnit", duration);
					this.tableViewer.refresh();
				}
			}
		}
    });
    
    dojo.declare("TimeboxTable.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        // Summary:
        //
        getNumColumns: function(content){
            return 10;
        },

		//If data in any of the columns is required indicate it here.
		//cols is an array of column indices.
		//The required column headings will have an asterisk appended to them ie "Name" becomes "Name *"
		//The asterisk will ONLY be applied if there are rows in the table.        
		setRequiredColumns:function(cols)
		{
			this.requiredCols = cols;
		},
        // Summary:
        //
        getColumnHeading: function(content, index){
            var headings = [Constants.PROCESS_NAME_TIME_BOX, 
			Constants.PROCESS_DESCRIPTION_TIME_BOX, 
			Constants.PROCESS_START_DATE_TIME_BOX, 
			Constants.PROCESS_END_DATE_TIME_BOX,
			Constants.PROCESS_DURATION_TIME_BOX, 
			Constants.PROCESS_POINTS_TIME_BOX, 
            Constants.PROCESS_DEFECTS,
			Constants.PROCESS_ACT_START_DATE_TIME_BOX, 
			Constants.PROCESS_ACT_END_DATE_TIME_BOX,
			Constants.PROCESS_ACT_DURATION_TIME_BOX, 
			Constants.PROCESS_OWNER_TIME_BOX];
			//If any of the columns are required AND then append an * to the column header to indicate the data is required
			var requiredCols = this.requiredCols;
			if (requiredCols){
				var len = requiredCols.length;
				for (var i = 0; i < len; i++)
					headings[requiredCols[i]] += " *";
			}
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return (atColumnIndex != 3 && atColumnIndex != 4 && atColumnIndex != 7 && atColumnIndex != 8 );
        },
        
        getColumnWidth: function(content, atColumnIndex){
            var width = 2;
            switch (atColumnIndex) {
                case 0:
                    width = 5;
                    break;
                case 1:
                    width = 7;
                    break;
                case 2:
                    width = 15;
                    break;
                case 3:
                    width = 15;
                    break;
				case 4:
					width = 3;
					break;
                case 5:
                    width = 14;
                    break;                    
                case 6:
                    width = 8;
                    break;                    
                case 7:
                    width = 15;
                    break;
				case 8:
                    width = 15;
                    break;
				case 9:
                    width = 3;
                    break;
            }
            return width;
        },
        getIsCellEditable: function(rowData, atColumnIndex){
            return true;
        },
        
        // Summary:
        //    The only assumptions the table have on the data that it displays
        //    is that it's an array contents. These are the data content/object that
        //    will be displayed in the table rows.
        //
        getContentObjects: function(content){
            // our content is already an array of objects
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.itemId;
        },
        
        // Summary:
        //    Returns the type of the cell to be displayed. By default, the TableViewer
        //    will support a set of cell types. The type of the cell will map to a specific
        //    cell renderer (to be discussed).
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_EDITABLE_TEXT;
            
            switch (atColumnIndex) {
                case 2:
                case 3:
				case 7:
                case 8:
                    type = TableConstants.RENDER_TYPE_EDITABLE_DATE;     
                    break;
				case 5:
				case 6: 
					type = RENDER_TYPE_EDITTABLE_TEXT_BUTTON;
					break;
				case 4:
				case 9:
					type = RENDER_TYPE_INPUTTEXT;
					break;	
            }
            return type;
        },
        
        // Summary:
        //    Returns the display data of the cell. For cell renderer type of TEXT, this will
        //    be the string. Others cell render type would be Date, or integer value, etc. If the 
        //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
        //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
        //    cell types such as image where it could have multiple values for different states, the 
        //    client also needs to implement the next method.
        //    
        //    Client must implement this method to provide the cell data.
        //    
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.col1;
                    break;
                case 1:
                    val = rowData.col2;
                    break;
                case 2:
                    val = rowData.col3;
                    break;
				case 3:
                    val = rowData.col4;
                    break;
                case 4:
                    val = rowData.col5;
                    break;
                case 5:
                    val = rowData.col6;
                    break;
                case 6: 
                    val = rowData.col11;
                    break;
				case 7:
                    val = rowData.col8;
                    break;	
                case 8:
                    val = rowData.col9;
                    break;
				case 9:
                    val = rowData.col10;
                    break;
            }
            return val;
        },
        
        
        // Summary:
        //    If applicable, returns the extended display information of the cell. The return extended
        //    info must be an object with the following attributes:
        //    
        //    {
        //      /* attribute common for all cell renderer types */
        //      "tooltip": <string>,
        //
        //      /* attributes for IMAGE and ACTION cell renderer types */
        //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
        //      "image": base image URL,  
        //      "mouseOverImage": image URL, (optional)
        //      "mouseOutImage": image URL,  (optional) (overrides "image")
        //
        //      /* attributes for SELECT cell renderer type */
        //      "select" : 'value', the selection in the combo
        //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
        //
        //      /* attributes for CHECKBOX cell renderer type */
        //      "state" : <true, false> initial state of the check box
        //
        //      /* attributes for LINK cell renderer type */
        //      "href" : <string> the href string for the link
        //    }
        //
        //    Client can implement this method to provide extended display infor for the cell.
        //    Certain cell renderer type will require the client to implement this method to
        //    provide needed display information, such as an image ACTION.
        //
        getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = {};
            if (dojo.isIE) {
				if (atColumnIndex == 0 || atColumnIndex == 4 || atColumnIndex == 5 || atColumnIndex == 8 )
				{
					val['size'] = "1";
				}
				else if (atColumnIndex == 1) {
					val['size'] = "25";
				}
			}
                
			if(atColumnIndex == 4 || atColumnIndex == 8) {
				val['tooltip'] = Constants.getMessage("msgDuration") 
										+ "<BR>" + Constants.getMessage("msgDurationExample");
			}
            if (rowData.selected) {
                val['state'] = true;
            }
            return val;
        }
        
        
    });
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.timebox.TimeboxTable", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
        //        '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode">' +
        //        '  </div>' +
        '</div>' ,
        editable: true,
        printable: false,

        widgetsInTemplate: true,
		
        constructor: function(args){
            //			this.owners = args.owners;
            this.phaseResults = null;//args.timeboxResults;
            this._itemId = null;//args.itemId;
            this.content = null;
            this.owner = null;
            this.deleted = null;
            this.added = null;
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
			this.phasePendingSaveObject = null;
			this._newId = 0;
        },
        
        initialize: function(args){
			this.parentSection = args.parentSection ? args.parentSection : null;
			this.printable = args.printable ? args.printable : false; 
			this.editable = this.parentSection && this.parentSection.isEditable();
            this.deleted = new Array();
            this.phaseResults = args.timeboxResults;
			this.parentController = args.parentController;
			this.tableType = args.tableType;
            this._itemId = args.itemId;
            this.owner = args.owner;

	        //create the table viewer
	        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            //turn off all controls if in print mode 
	            showPagingControl: !this.printable,
				showPagingRangeControl: !this.printable,
	            showGroupFilterControls: !this.printable,
	            showPagingActionsControls: !this.printable,
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-PROC-TIMEBOX-TABLEVIEWER",
				planDetailsClick: dojo.hitch(this,"_handlePlanDetailsClick"),
				defectsClick: dojo.hitch(this,"_handleDefectsClick")
		     
	        });
					
            this.domNode.appendChild(tableViewer.domNode);			
            this.tableViewer = tableViewer;
			
			if(this.tableType == "phase")
				this.removeAllParticipant();
			            
            this.content = this.createContent();
            var contentProvider = new TimeboxTable.TableProvider();
			//The first column (Name) is required			
			contentProvider.setRequiredColumns([0]);
            
            var permType = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_PROCESS_PHASE;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(permType);
            var canAddDelete = (!perm || perm.create);
            
			if(this.tableType == "phase"){
				tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestSchedule")));
                if (canAddDelete) {
                    tableViewer.addAction("add", Constants.PROCESS_ADD_TEST_ITERATIONS_TIME_BOX, null, "add-icon-image");
                    this.deleteActionNode = tableViewer.addAction("remove", Constants.PROCESS_REMOVE_TEST_ITERATIONS_TIME_BOX, null, "remove-enabled-icon-image");
					this.deleteActionNode.setDisabled(true);
					tableViewer.addAction("preview", Constants.getMessage("labelExecutionTrendReportPreview"), null, "preview-icon-image");
                }
			} else if(this.tableType == "keydate"){
				tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelKeyDate")));
                if (canAddDelete) {
                    tableViewer.addAction("add", Constants.PROCESS_ADD_KEY_DATES_TIME_BOX, null, "add-icon-image");
                    this.deleteActionNode = tableViewer.addAction("remove", Constants.PROCESS_REMOVE_KEY_DATES_TIME_BOX, null, "remove-enabled-icon-image");
					this.deleteActionNode.setDisabled(true);
                }
			}
            
			tableViewer.setContent(this.content);
            tableViewer.setContentProvider(contentProvider);
			tableViewer.setTableListener(new TimeboxTable.TableListener(this));
			tableViewer.setCellModifier(new TimeboxTable.CellModifier(tableViewer, this));
			tableViewer.registerCellRenderer(RENDER_TYPE_INPUTTEXT, new TimeboxTable.InputTextBox());
			tableViewer.registerCellRenderer(RENDER_TYPE_EDITTABLE_TEXT_BUTTON, new TimeboxTable.EditableTextButton());
            tableViewer.show();
			
			//if parent section available and not editable, table should not be editable
			tableViewer.setEditable(this.editable);
        },
		
		removeAllParticipant: function() {
			var saveContext = this.parentController.getSaveContext();
			var iter = saveContext._participants.getIterator();
			var newParticipants = new dojox.collections.ArrayList();
			while (!iter.atEnd())
			{
				var participant = iter.get();
				if (participant.getItemType() != "com.ibm.rqm.process.TestPhase") {
					newParticipants.add(participant);
				}
			}
			saveContext._participants = newParticipants;
		},
		
        createContent: function(){
            var rows = [];
			var phaseResults = this.phaseResults;
            if (phaseResults == null) {
                return rows;
            }
			var len = phaseResults.length;
            for (var i = 0; i < len; i++) {
                var res = phaseResults[i];
                var obj = {
                    //                	col1: res.itemId,
                    col1: res.name,
                    col2: res.description,
                    col3: res.expectedStartDate?res.expectedStartDate.split(" ")[0]:"",
                    col4: res.expectedEndDate?res.expectedEndDate.split(" ")[0]:"",
                    col5: Constants.getMessage("labelDurationUnit", res.expectedDuration),  
                    col6: res.expectedTotalPoints,
                    col7: res.expectedValidityRate,
                    col8: res.startDate?res.startDate.split(" ")[0]:"",
                    col9: res.endDate?res.endDate.split(" ")[0]:"",	
                    col10: Constants.getMessage("labelDurationUnit", res.duration),  
                    col11: res.expectedDefects,
                    itemId: res.itemId,
					stateId: res.stateId,
					isChanged: false,
                    type: 0 //type=0: existed; type=1: new;
                };
                rows.push(obj);
				//if in editable mode, add participant
				if (this.editable) {
					this._addSaveParticipant(obj);
				}
            }
            return rows;
        },
		
        _handleAddNewClick: function(){
            var obj = {
                col1: "",
                col2: "",
                col3: "",
                col4: "",
                col5: "",
                col6: 0,
                col7: "",
                col8: "",
                col9: "",
                col10: "",
                col11: "",                
				itemId: ++this._newId,
				stateId: null,
                type: 1
            };
            this.content.push(obj);
			this._addSaveParticipant(obj);
            this.tableViewer.setContent(this.content);
            this.tableViewer.refresh();
			if(this.parentSection){
				this.parentSection.setDirty();
			}
        },
        
        _handleDeleteClick: function(){
			this.parentSection.getParentEditor().clearStatus();
            var dels = this.tableViewer.getCheckedRows();
			var len = dels.length;
            if (dels && len > 0) {
                for (var i = 0; i < len; i++) {
                    this.deleted.push(dels[i]);
                    this.tableViewer.deleteItem(dels[i]);
					this._removeSaveParticipant(dels[i]);
                }
				this.content = this.tableViewer.getContent();
				this.tableViewer.refresh();
				if(this.parentSection){
					this.parentSection.setDirty();
				}
            }
            else {
				this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.PROCESS_REMOVE_MSG_TIME_BOX);
			}
        },
		
		_handlePreviewClick: function(tableViewer) {
			var errorMessage;
			
			var selectedContent = tableViewer.getCheckedRows();
			var selectedLength = selectedContent.length;
			var zeroPoint = true;
			
			if (this.parentSection && this.parentSection.isSectionDirty()){
				errorMessage = Constants.getMessage("msgUnsavedChange");
			}else if(this.content.length==0){
				errorMessage = Constants.getMessage("msgNoPhaseData");
			}else if(selectedLength <= 0) {
				errorMessage = Constants.getMessage("msgNoSelectedPhase");
			}else if(selectedLength > 1) {
				errorMessage = Constants.getMessage("msgSelectMorePhase");
			}else if(selectedLength == 1) {
				if( selectedContent[0].col6 ==0){
					errorMessage = Constants.getMessage("msgSelectedPhasesPointsZero");
				}
			}
            if (errorMessage) {
                var dialogArgs = {
	                'message': errorMessage
	            };
				var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(dialogArgs);
				alertDialog.open();
            }else{
				var dialogArgs = {
	                primaryTitle: Constants.getMessage("labelExecutionTrendReportPreview"),
	                isClosable: false,
	                zIndex: 100
	            };
				this._previewDialog = new AlertDialog(dialogArgs);
				
				// Add the parameters of test plan and iteration
				var parameterNames = new Array(1);
				var parameterValues = new Array(1);
				
				parameterNames[0] = "PHASE_ITEMID";
				parameterValues[0] = selectedContent[0].itemId;;
				
				var args = {
				    projectAreaUUID: getCurrentProjectArea().itemId,
				    reportUUID: "executionTrend.preview",
				    parameterName: parameterNames,
				    parameterValue: parameterValues,
				    
				    showArchived: false,
				    getCached: false,
				    urlPrefix: "../../"
				};
				var self = this;
				var serviceObject = {
				    success: function(html){
						var div = document.createElement("div");
						div.innerHTML = html;
						dojox.data.dom.removeChildren(self._previewDialog.contentContainer);
						self._previewDialog.contentContainer.appendChild(div);
						if (self._previewDialog) {
							self._previewDialog.open();
						}			    },
				    failure: function(errorObject){
						self._error(errorObject);
				    }
				};
				var responseHandler = new ServiceResponseHandler(serviceObject, "success", "failure");
				var request = new ServiceRequest(REPORT_REST_SERVICE_URI, "postRenderReport", args);
				TeamServerClient.invokeService(request, responseHandler);
			}
		},
        
        changeRowEditable: function(isCheckble){
            if (isCheckble) {
                this.tableViewer.setTableRowsCheckable(this.editable && !this.printable, false);
                this.tableViewer.setEditable(true);
            }
            else {
                this.tableViewer.setTableRowsCheckable(false, false);
                this.tableViewer.setEditable(false);
            }
            this.tableViewer.show();
        },
        
		_addSaveParticipant: function(obj){
			//if not in editable mode, do not add participant
			if (!this.editable) {
				return;
			}
			//otherwise, create a save participant and and add it to the save context			
            var itemId = (obj == null)? null: obj.itemId; 
             var   saveParticipant = new SaveParticipant();
                saveParticipant.getItemId = function () { 
					return (obj.type == 1)?null:itemId; 
				};
				saveParticipant.setVersionableItemId(itemId);
				saveParticipant.getStateId = function(){
                	return obj.stateId;
            	};
                saveParticipant.getItemType = function(){
                	return "com.ibm.rqm.process.TestPhase";
            	};
				var self = this;
				saveParticipant.isDirty = function () {
					var isdirty = self._isDirty(itemId); 
					return isdirty;
				};
				saveParticipant.getAttributes = function(){
                	return self._getSaveParam(itemId);
            	};
                this.parentController.getSaveContext().addParticipant(saveParticipant);
            var parent = this.parentController.getParentEditor();
            if (parent != null) {
                this.parentController.getSaveContext().createReference(saveParticipant, "testPlanId", parent);
            }
        },
		
		_removeSaveParticipant: function(obj) {
			var itemId = obj.itemId;
		 	var saveContext = this.parentController.getSaveContext();
			if(obj.type == 1) {
				//new item
				var iter = saveContext._participants.getIterator();
				while (!iter.atEnd()) {
					var participant = iter.get();
					if (participant.getItemType() == "com.ibm.rqm.process.TestPhase" && 
						participant.getVersionableItemId() == itemId) {
						saveContext.removeParticipant(participant);
					}
				}
			}
		},
		
		_getSaveParam: function(itemId) {
			var param = {};
			var deleteArray = new Array();
			var addArray = new Array();
			var updateArray = new Array();
			var deleted = this.deleted;
			var len = deleted?deleted.length:0;
			if (deleted && len > 0) {
				for (var i = 0; i < len; i++) {
					if (deleted[i].type == 0 && deleted[i].itemId == itemId) {
						deleteArray.push({
							itemId: deleted[i].itemId
						});
					}
				}
			}
			var content = this.content;
			var len2 = content?content.length:0;
			if (content && len2 > 0) {
				for (var i = 0; i < len2; i++) {
					if (content[i].type == 1 && content[i].itemId == itemId) {
						var obj = content[i];
						var params = {
							name: obj.col1,
							description: obj.col2,
							expectedStartDate: obj.col3,
							expectedEndDate: obj.col4,
							expectedDuration: obj.col5,
							expectedTotalPoints: (obj.col6.toString()=="")?0:obj.col6,
							expectedValidityRate: (obj.col7 && obj.coll7!="")?obj.col7:0,
							expectedDefects: (obj.col11 && obj.coll11!="")?obj.col11:0,
							startDate: obj.col8,
							endDate: obj.col9,
							duration: obj.col10,
							tableType: this.tableType,
							testPlanId: this._itemId
						};
						addArray.push(params);
					}else if (content[i].type == 0 && content[i].itemId == itemId && content[i].isChanged) {
						var obj2 = content[i];
						var params2 = {
							itemId: obj2.itemId,
							stateId: obj2.stateId,
							name: obj2.col1,
							description: obj2.col2,
							expectedStartDate: obj2.col3,
							expectedEndDate: obj2.col4,
							expectedDuration: obj2.col5,
							expectedTotalPoints: (obj2.col6.toString()=="")?0:obj2.col6,
							expectedValidityRate: (obj2.col7 && obj2.coll7!="")?obj2.col7:0,
							expectedDefects: (obj2.col11 && obj2.coll11!="")?obj2.col11:0,
							startDate: obj2.col8,
							endDate: obj2.col9,
							duration: obj2.col10,
							tableType: this.tableType,
							testPlanId: this._itemId
						};
						updateArray.push(params2);
					}
				}
			}
			param.remove = deleteArray;
			param.update = updateArray;
			param.add = addArray;
			return {operationJson: dojo.toJson(param)};
		},
		
		_isDirty: function(itemId) {
			var deleted = this.deleted;
			var len = deleted?deleted.length:0;
			if (deleted && len > 0) {
				for (var i = 0; i < len; i++) {
					if (deleted[i].type == 0 && deleted[i].itemId == itemId) {
						return true;
					}
				}
			}
			var content = this.content;
			var len2 = content?content.length:0;
			if (content && len2 > 0) {
				for (var i = 0; i < len2; i++) {
					if (content[i].type == 1 && content[i].itemId == itemId) {
						return true;
					}else if (content[i].type == 0 && content[i].itemId == itemId && content[i].isChanged) {
						return true;
					}
				}
			}
			return false;
		},
		
		//return value is {msg: string, value: boolean}
		validate: function() {
			var content = this.content;
			var len2 = content?content.length:0;
			if (content && len2 > 0) {
				for (var i = 0; i < len2; i++) {
					var obj = content[i];
					if (obj.col1 == "" || obj.col1==null) {
						//name 
						return {
							msg: Constants.PROCESS_VALIDATE_REQUIRE_MSG_TIME_BOX,
							value: false
						};
					}
					if( (obj.col3 != "" && dojo.date.locale.parse(obj.col3, { datePattern: "yyyy-MM-dd", selector: "date" })==null) 
						|| (obj.col4 != "" && dojo.date.locale.parse(obj.col4, { datePattern: "yyyy-MM-dd", selector: "date" })==null)
						|| (obj.col8 != "" && dojo.date.locale.parse(obj.col8, { datePattern: "yyyy-MM-dd", selector: "date" }) ==null)
						|| (obj.col9 != "" && dojo.date.locale.parse(obj.col9, { datePattern: "yyyy-MM-dd", selector: "date" })==null)) {
						//start date
						return {
							msg: Constants.getMessage("msgInvalidDateErrorBox"),
							value: false
						};
					}
					if (obj.col3 != "" && obj.col4 != "" && obj.col3 > obj.col4) {
						return {
							msg: Constants.PROCESS_VALIDATE_DURATION_MSG_TIME_BOX,
							value: false
						};
					}
					if (obj.col8 != "" && obj.col9 != "" && obj.col8 > obj.col9) {
						return {
							msg: Constants.PROCESS_VALIDATE_DURATION_MSG_TIME_BOX,
							value: false
						};
					}
					if (obj.col5 != "" && (obj.col5.search(/^\s*(\d+)\s*d$/) == -1) || obj.col10 != "" && (obj.col10.search(/^\s*(\d+)\s*d$/) == -1)) {
						// duration 
						return {
							msg: Constants.getMessage("msgDurationErrorBox"),
							value: false
						};
					}
					else{
						if (obj.col5 != ""){
							var value5 = parseInt(obj.col5.substring(0, obj.col5.length-1), 10);
							if (isNaN(value5) || value5 > 9999) 
								return {
									msg: Constants.getMessage("msgDurationErrorBox"),
									value: false
								};
						}
						
						if(obj.col10 != ""){
							var value10 = parseInt(obj.col10.substring(0, obj.col10.length-1), 10);
							if (isNaN(value10) || value10 > 9999) 
								return {
									msg: Constants.getMessage("msgDurationErrorBox"),
									value: false
								};
						}
					}
					if (obj.col6.toString()!= "" && (obj.col6.toString().search(/^(\d+)$/) == -1)) {
						//point
						return {
							msg: Constants.getMessage("msgPointsErrorBox"),
							value: false
						};
					}
				}
			}
			return this._checkUniqueName();
		},
		
		removeAllSaveParticipant: function() {
			var objs = this.tableViewer.getContent();
			var len = objs ? objs.length:0;
            for (var i = 0; i < len; i++) {
				this._removeSaveParticipant(objs[i]);
            }
		},
		
		_checkUniqueName: function() {
			var content = this.content;
			var len2 = content?content.length:0;
			if (content && len2 > 0) {
				var type = (this.tableType == "phase") ? Constants.PROCESS_TEST_ITERATION_TABLE_TIME_BOX : Constants.PROCESS_KEY_DATE_TABLE_TIME_BOX;
				for (var i = 0; i < len2; i++) {
					for (var j = i+1; j < len2; j++) {
						if(content[i].col1 == content[j].col1) {
							return {
                                msg: Constants.getMessage("msgNameRequireMsgTimeBox", content[j].col1, type),
								value: false
							};
						}
					}
				}
			}
			return {value: true};
		},
		
		_handlePlanDetailsClick: function(params){
			var errorMessage;
			if(this.parentSection&&this.parentSection.isSectionDirty()){
				errorMessage = Constants.getMessage("msgUnsavedChange");
			}
			if (params[2] == "" || params[3] == ""){
				errorMessage = Constants.getMessage("msgMissingDate");
			}
			if (!errorMessage) {
				var planDetailsDataObj;
				var planDetailsDataArray;
				var phaseResults =  this.phaseResults;
				var len = phaseResults.length;
				for(var i=0;i<len;i++){
					if(params[4]&&params[4]==phaseResults[i].itemId){
						planDetailsDataObj = phaseResults[i].testPhaseDetails;
						break;
					}
				}
                
                if (planDetailsDataObj) {
                    planDetailsDataArray = new Array();
                    for (var i = 0; i < planDetailsDataObj.length; i++) {
                        var date = util.fromISOString(planDetailsDataObj[i].date.split("T")[0]);
                        planDetailsDataArray.push([date, planDetailsDataObj[i].pointsAttempted, planDetailsDataObj[i].pointsCompleted, planDetailsDataObj[i].comment]);
                    }
                }                
                this.planDetails = new com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDetailsDialog({
					okCallback: dojo.hitch(this,"_planDetailsSaveFinished"),
                    isEditable: params[0],
                    startDate: params[2],
                    endDate: params[3],
                    testPhaseItemId: params[4],
                    testPlanId: this._itemId,
                    planDetails: planDetailsDataArray ? planDetailsDataArray : null
                });
			}else{
				var dialogArgs = {
	                'message': errorMessage
	            };
				var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(dialogArgs);
				alertDialog.open();
			}
		},
		
		_handleDefectsClick: function(params){
		    var dialogArgs={
		        ItemId: params[1],		       
                showCancel: false,
                isClosable: false,
                title: Constants.getMessage("labelDefectDetails"),
                labelPlanDefects: Constants.getMessage("labelDefectDetails"), 
                isEditable: this.editable,
                planDefects: ((params[2] && params[2]!="")&&(params[3] && params[3]!=""))?[params[2],params[3]]:null,
                RowNode: params[4]
        };
        this.defectsDlg = new com.ibm.rqm.process.web.ui.internal.view.timebox.PlanDefectSelector(dialogArgs);        
        },
		
		_planDetailsSaveFinished: function(phaseUnsavedObject){
			if(phaseUnsavedObject){
				this.phasePendingSaveObject = phaseUnsavedObject;
				var content = this.tableViewer.getContent();
				var contentLen = content ? content.length : 0;
				for(var i=0;i<contentLen;i++){
					if(content[i].itemId == phaseUnsavedObject.itemId){
						content[i].col6 = phaseUnsavedObject.expectedTotalPoints;
						this.tableViewer.refresh();
						break;
					}
				}
				if(this.parentSection){
					this.parentSection.setDirty();
				}
			}
			//this.parentSection.saveFinished();
		},

		followupSaveOperation: function(callback){
			if(this.phasePendingSaveObject != null){
				var clbObj = {
					success: function(){
						this.phasePendingSaveObject = null;
						callback();
					},
					
					failure: function(){
						this.phasePendingSaveObject = null;
						callback();
					}
				}
				var responseHandler = new ServiceResponseHandler(clbObj, "success", "failure");
                TimeboxClient.postUpdateTestPhase(responseHandler, this.phasePendingSaveObject);
			}else
				callback();
		},
		
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
