
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkItemsViewlet");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.WorkItemsViewlet");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.QueryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.WorkItemTableView");

(function()
{
var QueryClient			= com.ibm.rqm.planning.web.client.internal.QueryClient;
var ImageCache			= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Constants 			= com.ibm.rqm.planning.web.client.internal.Constants;
var TooltipBuilder		= com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder;
var Utility				= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var WorkItemTableView   = com.ibm.rqm.planning.web.ui.internal.view.table.WorkItemTableView;

var Viewlet 			= com.ibm.team.dashboard.web.ui.Viewlet;
var JazzWorkItemsViewlet = com.ibm.team.workitem.viewlets.web.ui.internal.WorkItemsViewlet;

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;	
var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkItemsViewlet",	JazzWorkItemsViewlet,
{

	getViewletStrId: function()
	{
		return "com.ibm.rqm.planning.web.viewlets.workitem";			
	},
		
	refreshthis: function() {
		delete this._results;
		if (this._detailsWidgets) {
			for (var i in this._detailsWidgets)
				this._detailsWidgets[i].destroy();
		}
		this._detailsWidgets = new Object();
		if (this.getPreference("query") != "-1") {
			if (this._currentQuery != this.getPreference("query")) 
				this._setLoading(true);
			else 
				this.getSite().setLoading(true);
			var self = this;
			var serviceObject = {
				success: function(/* TestArtifactWorkItemSummaryDTO[] */ workItemSummaryDTOs){
					self._results = workItemSummaryDTOs;
					if (workItemSummaryDTOs) {
						self.getSite().setSecondaryTitle("(" + workItemSummaryDTOs.length + ")");
					}
					self._setLoading(false);
					self.update();
					self.getSite().doneRefresh();
				},
				failure: function(error){
					self._setLoading(false);
					self.getSite().doneRefresh();
				}
			};
			this._currentQuery = this.getPreference("query");
			var responseHandler = new ServiceResponseHandler(serviceObject, "success", "failure");
			
			/*
			QueryClient.execute(0, 500, "", {
				itemId: this._currentQuery
			}, ["modified"], [false] /descending/, responseHandler);
			*/
			
			QueryClient.execute(
			/* start index */ 		0, //index ? index - 1 : 0, */
			/* page size */			100, //WorkItemUtil._getDefaultQueryPageSize(),*/
			/* token */				"",
			/* query */				{itemId: this._currentQuery}, //query,
			/* orderAttributes */	["modified"], //orderAttributes,
			/* orderDirections */	[false] /* descending */, //orderDirections,
									responseHandler);			
		}
		else {
			this.update();
			this.getSite().doneRefresh();
		}
	},
	
	updatethis: function() {
		// this._currentNode is used to replace existing table nodes
		/*
		this._currentNode = this._resultsTableBody.firstChild;
		while (this._currentNode && this._currentNode.nodeName == "#text")
			this._currentNode = this._currentNode.nextSibling;
		for (var i = 0; this._results && i < this._results.length && (i < this.getPreference("items") || this.isZoomed()); i++) {
			this._createResultRow(this._results[i]);
		}
		if (this._results && this._results.length > 0 && !this.isZoomed())
			this._createFooter();
		// remove any remaining old rows after populating the table
		while(this._currentNode) {
			var removeNode = this._currentNode;
			this._currentNode = this._currentNode.nextSibling;
			this._resultsTableBody.removeChild(removeNode);
		}
		*/
		this._showResults();
		//this._updateVisibility();
	},	
	
	_showResults: function(results) {
		//dojox.data.dom.removeChildren(this._resultsTable);
		dojox.data.dom.removeChildren(this._contentArea);
		results = results ? results : [];
	   this._tableViewer = new WorkItemTableView({summaries: results});
	   this._contentArea.appendChild(this._tableViewer.domNode);
		this._contentArea.style.width = "100%";		
	},
	
	_viewWorkItem: function(args)
	{
		var viewletId = "com.ibm.rqm.planning.web.viewlets.workitem";
		
		this._findAndCallViewlet(viewletId, args.id);
	},
	
	_findAndCallViewlet: function(viewletId, data)
	{
		var container = this.container;
		var viewletPage = container.viewletPage;
		var dashboardContainer = viewletPage.dashboardContainer;
		var currentPage = dashboardContainer.getCurrentPage();
		var columns = currentPage.columns;
		
		var clen= columns.length;
		for (var j = 0; j < clen; j++)
		{
			var widgets = columns[j].widgets;
			var wlen = widgets.length;

			for (var i = 0; i < wlen; i++)
			{
				var id = widgets[i].viewletDefinition.id;

				if (id == viewletId)
				{
					var viewlet = widgets[i]._viewlet;
					
					viewlet.artifactSelected( {id: data} );
				}
			}
		}
	},
	
	_viewArtifact: function(args)
	{
		var viewletId = "";
		
		switch (args.type) {
			case "TestPlan": 
			   viewletId = "com.ibm.rqm.planning.web.viewlets.testplan";
				break;
			case "Sizing": 
			   viewletId = "";
				break;
		}
		
		this._findAndCallViewlet(viewletId, args.id);
	},	
		
	hasZoomableContent: function() {
		if (this._count && this._count > 10)
			return true;
		return false;
	},
	
	settingsChanged: function(oldSettings, newSettings)
	{
		if ((oldSettings.preferences.query != newSettings.preferences.query) ||
			(oldSettings.preferences.items != newSettings.preferences.items))
		{
			this.getSite().refresh();
		}
		else
		{
			this.update();
		}
	}

});

})();
