/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
(function() {

var Root             = "com.ibm.rqm.planning.home.actionDispatcher";
var BaseActionHref   = "#action=" + Root;


// Summary:
//    Utility object to compose URIs for reservations page's actions.
//
com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil = 
{

    // Summary:
    //    Creates the URI to forward to the new reservation view.  
    //        
    getNewConfigurationURI: function()
    {
		var timestamp = dojo.date.locale.format(new Date(), {selector:"time", timePattern:"hh:mm:ss"});
		var uri = BaseActionHref + "&subAction=createConfiguration" + "&id=" + timestamp + "&type=" + "Machine";
		return uri;	
    },
	
    getEditConfigurationURI: function(id) 
    {
        return BaseActionHref + "&subAction=viewConfiguration" + "&id=" + id + "&type=" + "Machine";
    },
	
	getCopyConfigurationURI: function(id)
	{
        return BaseActionHref + "&subAction=copyConfiguration" + "&id=" + id + "&type=" + "Machine";
    },		
	
	
	// Summary:
    //     Creates the URI to forward to the Configuration query view. Optionally, 
    //     caller can specify whether to refresh the current query result, and/or
    //     removing a cached view in page.
    //     
    // params:
    //     args = {refresh:[true|false], removeViewId:id}
    //
    getQueryConfigurationURI: function(args)
    {
        var uri = BaseActionHref + "&subAction=manageConfiguration";
        
        if(args) {
            if(args.refresh)
                uri += "&refresh=true";
            if(args["removeViewId"] != null)
                uri += ("&removeViewId=" + args.removeViewId);
        }
        return uri;
    }
};
})();
