//LabActionBarEntry
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.extension.LabActionBarEntry");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() 
{
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;

	dojo.declare(
		"com.ibm.rational.test.lm.web.ui.internal.views.extension.LabActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
                this.initError = dojo.getObject("com.ibm.rqm.planning.web.ui.initError");
			},
           
            _showInitError: function()
            {
                // create a dialog to for the user to select a team area
                var container = document.createElement('span');
                var label1 = document.createTextNode(Constants.getMessage("errRTLMLabMgrGrpNotSet"));
                var label2 = document.createTextNode(this.initError['errorMessage']);
                container.appendChild(label1);
                container.appendChild(document.createElement('br'));
                container.appendChild(document.createElement('br'));
                container.appendChild(label2);
                                    
                var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog();
                alertDialog.contentContainer.appendChild(container);
                alertDialog.setSecondaryTitle(Constants.getMessage("titleRTLMDisabled"));
                alertDialog.open();
            },
           
            _populateMenuEntries: function()
            {
                if (this.initError) {
                    // disable lab management if init failed - just put up entry to show
                    // the error message in the popup
                    this._addNonDispatchableMenuEntry(Constants.getMessage("labelRTLMDisabled"), dojo.hitch(this, "_showInitError"), true, null);
                    return;
                }
                
                var resPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE);
                var impPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_DEPRECATED);
                var resGroupPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);
                var testEnvPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);
                var requestPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_REQUEST);
				var schemaPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_SCHEMA);

                this._addMenuEntry(Constants.getMessage("labelViewResources"), dojo.hitch(this, "_findResourceAdvanced"), false, {'subAction': "searchAssetAdvanced"});
                this._addMenuSeparator();
                
                if (!resPerm || resPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewMach"), dojo.hitch(this, "_createMachine"), false, {
                        'subAction': "newMachine",
                        'tq': ""
                    });
                    this._addMenuEntry(Constants.getMessage("labelNewVMImg"), dojo.hitch(this, "_createVirtualImage"), false, {
                        'subAction': "newVirtualImage",
                        'tq': ""
                    });
                    this._addMenuSeparator();
                }
                if (!resGroupPerm || resGroupPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewResGrp"), dojo.hitch(this, "_createResourceGroup"), false, {
                        'subAction': "newGroup",
                        'tq': ""
                    });
                }
                this._addMenuEntry(Constants.getMessage("labelAllResGrp"), dojo.hitch(this, "_manageResourceGroups"), false, {'subAction': "manageGroups"});
                this._addMenuSeparator();
                
                if (!requestPerm || requestPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewReq"), dojo.hitch(this, "_createRequest"), false, {
                        'subAction': "createRequest",
                        'tq': ""
                    });
	                this._addMenuEntry(Constants.getMessage("labelAllReq"), dojo.hitch(this, "_manageRequests"), false, {'subAction': "manageRequest"});
    	            this._addMenuSeparator();
                }

                if (!resPerm || resPerm[PermissionsClient.ACTION_CREATE]) 
				{
					this._addMenuEntry(Constants.getMessage("labelAllRsvp"), dojo.hitch(this, "_onClickManageReservations"), false, {'subAction': "manageReservations"});
					this._addMenuSeparator();
				}
//Test Environments (Configurations)                  
                if (!testEnvPerm || testEnvPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewCfg"), dojo.hitch(this, "_createConfiguration"), false, {
                        'subAction': "createConfiguration",
                        'tq': ""
                    });
                }
                this._addMenuEntry(Constants.getMessage("labelAllCfg"), dojo.hitch(this, "_onClickManageConfigurations"), false, {'subAction': "manageConfigurations"});
                this._addMenuSeparator();
//Test Cells
                
                if (!testEnvPerm || testEnvPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestCell"), dojo.hitch(this, "_createTestCell"), false, {
                        'subAction': "createTestCell",
                        'tq': ""
                    });
                }

                this._addMenuEntry(Constants.getMessage("labelAllTestCells"), dojo.hitch(this, "_allTestCells"), false, {'subAction': "allTestCells"});
                this._addMenuSeparator();

//Automations                
                this._addMenuEntry(Constants.getMessage("labelAllAuto"), dojo.hitch(this, "_runAutomation"), false, {'subAction': "runAutomation"});
                this._addMenuEntry(Constants.getMessage("labelAllInvHist"), dojo.hitch(this, "_onClickManageInventory"), false, {'subAction': "manageInventory"});
                
                var needSep = true;
                if (!impPerm || impPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuSeparator();
                    this._addMenuEntry(Constants.getMessage("labelImportRes"), dojo.hitch(this, "_onClickImportResources"), false, {
                        'subAction': "importAsset"
                    });					
                    needSep = false;
                }
				
                if (!resPerm || resPerm[PermissionsClient.ACTION_ARCHIVE]) {
                    this._addMenuSeparator();
                    this._addMenuEntry(Constants.getMessage("labelArchivedLabResources"), dojo.hitch(this, "_manageArchivedAssets"), false, {'subAction': "manageArchivedAssets"});
                }

/*
 * MFV Not available for beta.  Uncomment after the Beta ships
                this._addMenuEntry(Constants.getMessage("labelImportResTemp"), dojo.hitch(this, "_onClickImportResourceTemplate"), false, {'subAction': "importTemplate"});
 */                               
                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewAsset", dojo.hitch(this, "_onViewAsset"));
                    this.actionDispatcher.registerDispatchAction("viewGroup", dojo.hitch(this, "_onViewGroup"));
                    this.actionDispatcher.registerDispatchAction("viewRequest", dojo.hitch(this, "_onViewRequest"));
                    this.actionDispatcher.registerDispatchAction("viewConfiguration", dojo.hitch(this, "_onViewConfiguration"));
                    this.actionDispatcher.registerDispatchAction("viewDeployments", dojo.hitch(this, "_onViewDeployments"));					
                    this.actionDispatcher.registerDispatchAction("viewInventory", dojo.hitch(this, "_onViewInventory"));					
                    this.actionDispatcher.registerDispatchAction("copyConfiguration", dojo.hitch(this, "_onCopyConfiguration"));
	                this.actionDispatcher.registerDispatchAction("createTestCell", dojo.hitch(this, "_createTestCell"));  //Need this for creating a Test Cell from a Test Environment
                    this.actionDispatcher.registerDispatchAction("viewTestCell", dojo.hitch(this, "_onViewTestCell"));
                }
            },
           
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
                this._populateMenuEntries();
			},
            
			/*
			_findResource: function(args)
			{
			    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView(args);
				var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelFind");
                this._addPage( {name: Constants.getMessage("labelFindRes"), content: view, closable: true, browserTitle: browserTitle});				
			},
			_allResource: function(args)
			{
			    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView(args);
				var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelAllView");
                this._addPage( {name: Constants.getMessage("labelAllRes"), content: view, closable: true, browserTitle: browserTitle});	
			},
			*/
			_findResourceAdvanced: function(args)
			{ 
                var loadFunc = function(tab, onComplete){			    
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView", dojo.hitch(this, function(tab, onComplete){
                            var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView(args);
                            onComplete(tab, view);
                    }, tab, onComplete));
                };   			    
				var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelViewResources");								
                this._addPage( {
                    name: Constants.getMessage("labelViewResources"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),                    
                    closable: true,
                    browserTitle: browserTitle
                });				
			},
			
            _manageArchivedAssets: function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView(args);
                        onComplete(tab, view); 
                    }, tab, onComplete));
                };               
				var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelDeletedAndHidden");
                this._addPage( {
                    name: Constants.getMessage("labelArchivedLabResources"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });        
            },
            
            _onViewAsset:function(args)
            { 
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", dojo.hitch(this, function(tab, onComplete){           
                        var argInt = {
                            assetId: args.id,
                            assetType: args.type,
                            isNew: false,
                            isDeleted: (typeof args.deleted != "undefined" && args.deleted == "true")
                            };
                         var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView(argInt);
                         view.page = tab;
                         view._updateBrowserTitle();                         
                         onComplete(tab, view);
                    }, tab, onComplete));
                };               
                var page = this._addPage({
                    name: Constants.getMessage("labelViewMach"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },

            _onViewGroup: function(args) {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", dojo.hitch(this, function(tab, onComplete){
                        var initMessage = null;
                        var initStatus = null;
                        if (args.initMessage)
                            initMessage = args.initMessage;    
                        if (args.initStatus)
                            initStatus = args.initStatus;
                        var viewArgs = {
                            groupId:args.id, 
                            isNew:false, 
                            statusMessage:initMessage, 
                            statusState:initStatus
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView(viewArgs);
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };                                                

                this._addPage( {
                    name: Constants.getMessage("labelResGrp"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },
            
            _onViewRequest:function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView", dojo.hitch(this, function(tab, onComplete){
                        var formArg = {
                            requestId: args.id, 
                            isNew: false
                        };
                       var view = new com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView(formArg);
                       onComplete(tab, view);                        
                    }, tab, onComplete));
                };                
               
                this._addPage( {
                    name: Constants.getMessage("labelViewReq"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });   
            },

            _onViewConfiguration:function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", dojo.hitch(this, function(tab, onComplete){               
                       var editorArgs = {
					       isNew: false,
                           configId: args.id,
                           assetType: args.type
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs); 
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };             
                
                this._addPage({
                    name: Constants.getMessage("labelViewCfg"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },

            _onCopyConfiguration:function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", dojo.hitch(this, function(tab, onComplete){      
                        var editorArgs = {
					        isNew: true,
                            isCopy: true,
                            configId: args.id,
                            assetType: args.type
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs); 
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };             
                this._addPage({
                    name: Constants.getMessage("labelViewCfg"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },
			
            _onViewDeployments: function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", dojo.hitch(this, function(tab, onComplete){
                        var viewArgs = {};
                        if(args && args.autoDeployRefresh) {
                            viewArgs['autoDeployRefresh'] = args.autoDeployRefresh;
                        } 
                        var view =  new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView(viewArgs);
                        onComplete(tab, view);                        
                        }, tab, onComplete));
                };        
                                               
                this._addPage({
                    name: Constants.getMessage("labelViewInvHist"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
            },

            _onViewInventory: function(args)
            {
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", dojo.hitch(this, function(tab, onComplete){
                            var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView(); 
                            onComplete(tab, view);                        
                        }, tab, onComplete));
                };                          
				this._addPage({
					name: Constants.getMessage("labelViewInvHist"),
					onDeferredLoad: dojo.hitch(this, loadFunc),   
                	closable: true
				});
            },
			
//			_onClickMyResources: function()
//			{
//				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView", "_myResources");
//			},
			
//			_myResources: function()
//			{
//				this._addPage( {name: Constants.getMessage("labelMyRes"), content: "This is the work area for Finding a Machine.", closable: true});
//			},

			_createMachine: function(args)
			{
			    var loadFunc = function(tab, onComplete){
    			    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", dojo.hitch(this, function(tab, onComplete){
    			         var id = dojo.date.locale.format(new Date(), {
                         selector: "time",
                         timePattern: "hh:mm:ss"
                         });
                         var viewArgs = {
                            assetId: id,
                            assetType: "Machine" /* CML: hack */,
                            isNew: true
                         };
                         var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView(viewArgs);
                         view.page = tab;
                         view._updateBrowserTitle();
                         tab.controlButton.containerNode.className = "machine-icon-16";
    			         onComplete(tab, view);                        
                     }, tab, onComplete));
                };        
                var page = this._addPage({
                    name: Constants.getMessage("labelNewMach"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),   
                    closable: true
                });
			},

            _createVirtualImage: function(args)
            {                
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", dojo.hitch(this, function(tab, onComplete){
                        var id = dojo.date.locale.format(new Date(), {
                            selector: "time",
                            timePattern: "hh:mm:ss"
                        });
                        var viewArgs = {
                            assetId: id,
                            assetType: "VirtualImage" /* CML: hack */,
                            isNew: true
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView(viewArgs);
                        view.page = tab;
                        view._updateBrowserTitle();
                        tab.controlButton.containerNode.className = "vm-icon-16";
                        onComplete(tab, view);                        
                     }, tab, onComplete));
                };  
                
                var page = this._addPage({
                    name: Constants.getMessage("labelNewVMImg"),
                    onDeferredLoad: dojo.hitch(this, loadFunc), 
                    closable: true
                });
            },
			
			_onClickImportResources: function()
			{
			    var loadFunc = function(tab, onComplete){
    			    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView", dojo.hitch(this, function(tab, onComplete){
                        var viewArgs = {
                           importType:"asset"
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView(viewArgs);                			        
    			        onComplete(tab, view);                        
                    }, tab, onComplete));
                };  		    
			   
				var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
                this._addPage({
                    name: Constants.getMessage("labelImportRes"),
                    onDeferredLoad: dojo.hitch(this, loadFunc), 
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_onClickImportResourceTemplate: function()
			{
			    var loadFunc = function(tab, onComplete){
    			    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView", dojo.hitch(this, function(tab, onComplete){
    			        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView({importType:"schema"});
    			        onComplete(tab, view);                        
                        }, tab, onComplete));
                };     
                this._addPage({
                    name: Constants.getMessage("labelImportResTemp"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),                     
                    closable: true
                });
			},
			
			_manageResourceGroups: function(args)
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView", dojo.hitch(this, function(tab, onComplete){
                            var viewArgs = {showAll:true};
                            var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView(viewArgs);
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };      			    			    
				var browserTitle = Constants.getMessage("labelResGrp") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");					
                this._addPage({
                    name: Constants.getMessage("labelAllResGrp"),
                    onDeferredLoad: dojo.hitch(this, loadFunc), 
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_createResourceGroup: function(args)
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", dojo.hitch(this, function(tab, onComplete){
                        var id = dojo.date.locale.format(new Date(), {
                            selector: "time",
                            timePattern: "hh:mm:ss"
                        });
                        var viewArgs = {
                            groupId: id,
                            isNew: true
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView(viewArgs);
                        view.page = tab;
                        view._updateBrowserTitle();
                        // initialize the tab's icon.
                        tab.controlButton.containerNode.className = "machine-group-icon-16";
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };   
                    
                
                var page = this._addPage({
                    name: Constants.getMessage("labelNewResGrp"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),                    
                    closable: true
                });
			},
			
			_onClickManageConfigurations: function()
			{
			   var loadFunc = function(tab, onComplete){
			     this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView();
			        onComplete(tab, view);                        
                  }, tab, onComplete));
               };   			       
			   var browserTitle = Constants.getMessage("labelConfiguration") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._addPage({
                    name: Constants.getMessage("labelAllCfg"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),       
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_createConfiguration: function(args)
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", dojo.hitch(this, function(tab, onComplete){
                        var id = dojo.date.locale.format(new Date(), {
                            selector: "time",
                            timePattern: "hh:mm:ss"
                        });
                        var editorArgs = {
                        isNew: true,
                        configId: id,
                        assetType: "Machine"    // CML: hack
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs);
                        view.page = tab;
                        view._updateBrowserTitle();
                        // initialize the tab's icon.
                        tab.controlButton.containerNode.className = "config-icon-16";                   
                        onComplete(tab, view);                        
                  }, tab, onComplete));
               };
               
               
                var page = this._addPage({
                    name: Constants.getMessage("labelNewCfg"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),       
                    closable: true
                });
			},

			_createTestCell: function(args)
			{
			    var loadFunc = function(tab, onComplete){
			    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor", dojo.hitch(this, function(tab, onComplete){
			        var editorArgs = {
                        isNew: true,
                        testEnvironmentID: args.testEnvironmentID
                    };
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor(editorArgs);
                    view.page = tab;
                    view._updateBrowserTitle();
                        // initialize the tab's icon.
                    tab.controlButton.containerNode.className = "testcell-icon-16";
			        onComplete(tab, view);                        
                  }, tab, onComplete));
                };
			    		    
				
				var page = this._addPage({
				    name: Constants.getMessage("labelNewTestCell"),
                    onDeferredLoad: dojo.hitch(this, loadFunc), 
				    closable: true
				});
			},

			_onViewTestCell: function(args)
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor", dojo.hitch(this, function(tab, onComplete){
                        var editorArgs = {
                            isNew: false,
                            cellID: args.cellID
                        };
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellEditor(editorArgs);
                        view.page = tab;
                        view._updateBrowserTitle();
                        // initialize the tab's icon.
                        tab.controlButton.containerNode.className = "testcell-icon-16";
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };

				var page = this._addPage({
				    name: Constants.getMessage("labelNewTestCell"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    onWidgetCreated: dojo.hitch(this, function(widget){
                        
                    }),
				    closable: true
				});
			},

			_allTestCells: function()
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellQueryView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellQueryView(); 
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };
                    		    
				var browserTitle = Constants.getMessage("labelAllTestCells"); 
                this._addPage({
                    name: Constants.getMessage("labelAllTestCells"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
			},

			
            _onClickManageCollections: function( arguments )
            {
                if( arguments[ "id" ] )
                {
                    dojo.setObject( "com.ibm.rational.test.lm.web.collection-id", arguments[ "id" ] );
                }
                
                if( arguments[ "type" ] )
                {
                    dojo.setObject( "com.ibm.rational.test.lm.web.collection-type", arguments[ "type" ] );                  
                }
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.collections.CollectionsQueryView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.collections.CollectionsQueryView();        
                        onComplete(tab, view);                        
                    }, tab, onComplete));
                };
                
				var browserTitle = Constants.getMessage("labelVirtualCollection") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._addPage({
                    name: Constants.getMessage("labelAllVirtualCollections"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
            },
            
			_manageRequests: function()
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestView();                    
                        onComplete(tab, view);                        
                    }, tab, onComplete));                    
                };
				var browserTitle = Constants.getMessage("labelRequest") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView"); 
                this._addPage({
                    name: Constants.getMessage("labelAllReq"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_createRequest: function(args)
			{
			    var loadFunc = function(tab, onComplete){
			    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView", dojo.hitch(this, function(tab, onComplete){
			        var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var formArg = {
                        requestId: id,
                        isNew: true
                    };
                    if(args) {
                        for(var argName in args) {
                            formArg[argName] = args[argName];
                        }
                    }
                    var view =  new com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView(formArg);
                    view.page = tab;
                    view ._updateBrowserTitle();
                        // initialize the tab's icon.
                    tab.controlButton.containerNode.className = "request-icon-16";
			        onComplete(tab, view);                        
                    }, tab, onComplete));                    
                };
			    
                
                var page = this._addPage({
                    name: Constants.getMessage("labelNewReq"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_runAutomation: function(args)
			{
			    var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView();
                           if(args)
                                view.showAutomationsForMachines( args.assetId );                            
                        onComplete(tab, view);                        
                    }, tab, onComplete));                    
                };
                    	    
				var browserTitle = Constants.getMessage("labelAutomation") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");						
                this._addPage({
                    name: Constants.getMessage("labelAllAuto"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
            },
			
			_onClickManageInventory: function(args)
			{
			   var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView();
                        onComplete(tab, view);                        
                    }, tab, onComplete));                    
                };                    
                    
			   var browserTitle = Constants.getMessage("labelInventoryHistory") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
               this._addPage({
                    name: Constants.getMessage("labelAllInvHist"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_onClickManageReservations: function()
			{
			   var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations", dojo.hitch(this, function(tab, onComplete){
                        var view = new com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations();
                        onComplete(tab, view);                        
                    }, tab, onComplete));                    
                };        
			   var browserTitle = Constants.getMessage("labelReservation") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
               this._addPage({
                    name: Constants.getMessage("labelAllRsvp"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
					browserTitle: browserTitle
                });
			},
			
			_error: function(error) 
			{
				console.debug("LabActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
