/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
//
// Author: L. To
//
// Summary:
//    A simple title widget for the custom element provider. The title widget 
//    displays the title for a multi-value (array) attribute. It also creates
//    a button to add a new value to the array attribute. The widget has a layout
//    as follows:
//
//    +----------------------------------------------+
//    | title     + (add button) 
//    +----------------------------------------------+
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.ArrayAttributeTitle");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function() {

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.ArrayAttributeTitle", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class= "array-attribute-title" dojoAttachPoint="domNode" tabindex="-1">' +
                    '       <span class= "title-node" dojoAttachPoint="titleNode">' +
                    '       </span>' +
                    '       <button class="button-node" dojoAttachPoint="addNode" dojoAttachEvent="onclick: _addNodeClickHandler">' +
                    '         <img dojoAttachPoint="addNodeImg">' +
                    '         </img>' +
                    '       </button>' +
                    '</div>',

    title: null,
	callbackData: null,
	
	imgSrc: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/images/icons/elcl16/add_exc.gif"),
	
    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		if(this.title) {
			this.titleNode.innerHTML = this.title;
		}
		this.addNodeImg.src = this.imgSrc;
    },
	
	_addNodeClickHandler: function()
	{
		this.onAddValueClick(this.callbackData);
	},
	
	// Summary:
	//    Application callback method to handle the add button click event.
	//    Override this method to receive the add button clicked event.
	// 
	onAddValueClick: function()
	{
		
	}

});

})();

