//MachineSearchView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView");
  
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util");
 
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.MoreLessCollapsibleArea");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineListBaseView");

dojo.require("com.ibm.asq.common.web.client.internal.admin");
dojo.require("com.ibm.rational.test.lm.web.client.internal.reservations");
dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory" );

dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.catalogAttrBuilder.CatalogAttrBuilder");

//
// Summary:
//
(function() {
	var InventoryUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil;
	var AssetContentProviderFactory = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory;		
	var DefaultCustomElementProvider = com.ibm.rational.test.lm.web.ui.internal.views.machines.DefaultCustomElementProvider;
	var CustomElementProvider = com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider;
	var MachineInfo = com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchInfo;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var ConfigPartBuilder = com.ibm.rational.test.lm.web.ui.internal.widgets.catalogAttrBuilder.CatalogAttrBuilder;
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var adminService = new com.ibm.asq.common.web.client.internal.admin();
    var CommonPreferenceClient = com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
    var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
    
    // add-on information about automation & inventory provider information in Row data.
	var AUTOMATION_DATA = 'AutomationProviderInfo';
    var INVENTORY_DATA = 'InventoryProviderInfo';
    
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView", 
    [com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineListBaseView, dijit._Widget, dijit._Templated,
     com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin],
{    
    templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/views/machines/templates/MachineSearchView.html"),
    widgetsInTemplate: true,
	asset: null,
	assetType: "Machine",
	
	fromDateControl:null,
	toDateControl:null,
    clearButton: null,
    configSelectorButton: null,
    
	availLabel: RtlmUiUtil_getMessage("Availability")+":",
	includeAssetLabel: RtlmUiUtil_getMessage("includeAssetLabel"),
	groupSelectorLabel: RtlmUiUtil_getMessage("labelAllGroups"),
	   
    postCreate: function() {        
        this.inherited("postCreate", arguments);

        this.permissionsHash = {};

		this.viewHeaderNode.setTitle(RtlmUiUtil_getMessage("ViewLabResources"));
		this.viewHeaderNode.setCSHelpId("rtlm_advancedsearch.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", RtlmUiUtil_getMessage("AdvancedSearch")));
		
        this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-SEARCH-ASSET-TABLEVIEWER"                         
        });
        // initialize the table with empty contents first.
        this.tableContentProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchTableProvider( this.assetType );
        this.tableContentProvider.receiver = this;                
        this.tableViewer.setContentProvider( this.tableContentProvider );
        var emptyContent = {Data:[]};
        this.tableViewer.setContent(emptyContent);
        this.tableViewer.show();
        
        this.tableViewer.setTableRowsCheckable( true );
		this.tableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("AdvancedSearch")));
				
		this.searchButton = this.tableViewer.addAction("Search", RtlmUiUtil_getMessage("Refresh"), null, "refresh-icon-image", dojo.hitch( this, this._search ) );
		this.configureButton = this.tableViewer.addAction("ConfigAutomation", RtlmUiUtil_getMessage( "Configure Automation" ), null, "configure-automation-icon-image", dojo.hitch( this, this._automateSelected ));
		this.configureButton.setDisabled( true );
		this.deployButton = this.tableViewer.addAction("DeployImage", RtlmUiUtil_getMessage( "Deploy" ), null, "configure-deploy-icon-image",  dojo.hitch( this, this._deploySelected ));
		this.deployButton.setDisabled( true );
		this.discoverButton = this.tableViewer.addAction("DiscoverImage", RtlmUiUtil_getMessage( "Discover Image(s)" ), null, "discover-icon-image", dojo.hitch( this, this._discoverSelected ) );
		this.discoverButton.setDisabled( true );

		this.reserveButton = this.tableViewer.addAction("ReserveMachine", RtlmUiUtil_getMessage("resMachine"), null, "reserve-icon-image", dojo.hitch( this, this._reserveSelected ) );
		this.reserveButton.setDisabled( true );

		this.unReserveButton = this.tableViewer.addAction("UnReserveMachine", RtlmUiUtil_getMessage("unresMachine"), null, "unreserve-icon-image", dojo.hitch( this, this._unReserveSelected ) );
		this.unReserveButton.setDisabled( true );

        // add actions to delete/hide resources if the user has permissions
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE);  
        if(perm && perm[PermissionsClient.ACTION_ARCHIVE]) {
            this.hideButton = this.tableViewer.addAction("Hide", RtlmUiUtil_getMessage("labelHideButton"), "hide", "hide-icon-image", dojo.hitch(this, "_archiveSelected"));
            this.hideButton.setDisabled( true );

            this.deleteButton = this.tableViewer.addAction("Delete", RtlmUiUtil_getMessage("labelDeleteButton"), "delete", "delete-icon-image", dojo.hitch(this, "_archiveSelected"));
            this.deleteButton.setDisabled( true );
        }           
		
		this._constructDateArea();
        this._constructGroupArea();
        
		this._constructForm();
						
		this.resultAreaNode.appendChild( this.tableViewer.domNode );
		
		this.newReservations = [];

		this._loadAssetTypeToForm();
		
		//If we were called from the config search view to start with a named config then load and display it here
		if (this.initialConfigID != null)
		{
			var configs = new com.ibm.rational.test.lm.web.client.internal.config();
			var responseHandler= new ServiceResponseHandler(this, "_loadConfigSuccessHandler", "_loadConfigErrorHandler");
	
			configs.retrieveConfigurationWithDetails(responseHandler, this.initialConfigID);
		}
		else
		{
        // start the search if we're preferenced to do so.
        if(this._runOnOpen)
		    this._search();			
		}
    },
	
	_chooseConfig : function()
	{
        var dig_args = {title:RtlmUiUtil_getMessage("srchSelectResouceDesc")};
		this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog(dig_args);
		this.selectDlg.setOKAction(dojo.hitch( this, this._handleSelectOK ));
		this.selectDlg.show();
	},
	
	_handleSelectOK :function()
	{
		var selectedPart = this.selectDlg.getSelectedAssetDescriptor();
		if (selectedPart != null)
		{
			this.configPart =  selectedPart;
			this._updateConfigurationValue();
		}
	},
	
	setConfiguration: function(configurationPart) {
		if (configurationPart) {
			this.configPart = configurationPart;
			this.asset = configurationPart.document; // get the configuration containing this part. No method yet, hack to access.
			
			this._updateConfigurationValue();
		}
	},
	
	_updateConfigurationValue: function() {
		//MFV 04/11/08  FOR NOW WE ONLY BUILD CONFIGS FOR MACHINES
		//THIS WILL HAVE TO CHANGE EVENTUALLY			
		this.assetType = "Machine";
		
		//Load the asset type so the layout will work correctly
		//NOTE THAT _loadAssetType will clear the results table
		this._loadAssetType();

		//Insert the selected part into "this.asset" which is a config
		var rootAtt = this.asset.getRootAttribute();
		//Remove the 0th element which is the existing part
		rootAtt.removeArrayValue(0);
		//Add in the new part
        rootAtt.addArrayValue(this.configPart);

		//Refresh the ui using the new part			
        this.configBuilder.assetType = this.assetType;
        this.configBuilder.setCatalogAttribute(rootAtt, 0);
	},
	
	_loadConfigSuccessHandler : function(response)
	{
		var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
		var config = catalog.createConfigurationFromJson(response.configuration);
		var part = config.getRootPart(this.initialPartIndex);
		this.setConfiguration(part);
		
        // start the search if we're preferenced to do so.
        if(this._runOnOpen)
		    this._search();					
	},
	
	_loadConfigErrorHandler : function(response)
	{
		this.viewHeaderNode.setStatus("Error occurred. Unable to initialize search from config.", ViewHeaderLayout.ERROR);		
	},
	
    _getSelectAssetTypeValue: function() 
    {
        return this.configBuilder.assetType;
    },
	
	//Retrieve the asset type from the selector and load the type
	_loadAssetTypeToForm: function()
	{
		this.assetType = this.configBuilder.assetType;
		this._loadAssetType();
	},
	
    _updateViewOnAssetType: function()
    {
        if( this.assetType == "Machine" )
        {
            this.configureButton.domNode.style.display = "";
            this.deployButton.domNode.style.display = "none";
            this.discoverButton.domNode.style.display = "";
            this.reserveButton.domNode.style.display = "";
            this.unReserveButton.domNode.style.display = "";
        }
        else if( this.assetType == "VirtualImage" )
        {
            this.configureButton.domNode.style.display = "none";
            this.deployButton.domNode.style.display = "";
            this.discoverButton.domNode.style.display = "none";
            this.reserveButton.domNode.style.display = "none";
            this.unReserveButton.domNode.style.display = "none";
        }
        
        this.tableContentProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchTableProvider( this.assetType );
        this.tableContentProvider.receiver = this;
                
        this.tableViewer.setContentProvider( this.tableContentProvider );
        
        var tableListener = new com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchListener  ( {"receiver": this} );
        this.tableViewer.setTableListener( tableListener );
        
        tableListener.tableContentActionInvoked = function(tableViewer, actionId, /*optional*/callbackData, /*optional*/callback) {
            if(callback) {
                callback(callbackData);
            }
        };
        
        // clear the table contents
        this._clearTable();
        
    },
    
	//Load the asset type specified in this.assetType
	_loadAssetType: function()
	{
        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
        this.asset = catalog.createConfiguration(this.assetType); 

        // initialize the config with any default search criteria.
        this._initDefaultCriteria();
        
        this.configBuilder.assetType = this.assetType;
        this.configBuilder.setCatalogAttribute(this.asset.getRootAttribute(), 0);
        
        this._updateViewOnAssetType();
	},

    // Summary:
    //    Add actions to the builder's panel. 
    //
    _addViewBuilderAction: function(name, title, callback)
    {
        var button = document.createElement("button");
        button.innerHTML = title;
        button.name = name;

        this.actionNode.appendChild(button);
        this.connect(button, "onclick", callback);
        return button;
    },
	
    // Summary:
    //    When creating a new configuration/asset, we need to initialize it
    //    with any default criteria. The current preferenceable criteria is
    //    whether the asset belongs to the current user.
    //
    _initDefaultCriteria: function()
    {
        // Initialize the configuration to include the current user
        // as the owner, if the default is always query for 'mine' assets.
        // 
        if(this._onlyMineByDefault) {
            var owner_attr = this.asset.getRoot().getAttribute("owner");
            var currUser = com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR;
            if (owner_attr && currUser) {
                var me = {
                    "ds": currUser.name,
                    "uuid": currUser.itemId
                };
                owner_attr.setValue(me);
            }
        }
    },
    
    _initViewBuilder: function()
    {        
        //get the required user preferences
        var initOpenPref = CommonPreferenceClient.getStoredUserPreferences(
            CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key
        );
        this._initiallyOpen = initOpenPref && !dojo.isArray(initOpenPref) && initOpenPref.value == true;
        
        var onlyMinePref = CommonPreferenceClient.getStoredUserPreferences(
            CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_ONLY_MY_ASSETS_CATEGORY.key
        );
        this._onlyMineByDefault = onlyMinePref && !dojo.isArray(onlyMinePref) && onlyMinePref.value == true;

        var runOnOpenPref = CommonPreferenceClient.getStoredUserPreferences(
            CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key
        );
        this._runOnOpen = runOnOpenPref && !dojo.isArray(runOnOpenPref) && runOnOpenPref.value == true;
        
        this.searchSectionNode.setTitle(RtlmUiUtil_getMessage("labelViewBuilder"));
        this.searchSectionNode.setAttributeAreaHidden(true);
        this.searchSectionNode.summaryNode.innerHTML = RtlmUiUtil_getMessage("srchCriteriaInfo");
        
        if(this._initiallyOpen)
            this.searchSectionNode.toggle();

        this.actionNode = document.createElement("div");
        dojo.addClass(this.actionNode, "action-container");
        this.searchSectionContentNode.appendChild(this.actionNode);

        //Hookup the clear and run button
        this.clearButton = this._addViewBuilderAction("clear", RtlmUiUtil_getMessage("labelReset"), "_clearAttributes");
        this.topSearchButton = this._addViewBuilderAction("run", RtlmUiUtil_getMessage("labelRun"), "_search");
    },
    
	_constructForm: function()
	{        
        this._initViewBuilder();
        
		//Create the actions for the area
		this._addAdvancedActions();
        
        // create the config builder. configurate the builder to show 
        // all root asset types. This allows the user to change the config
        // to root types other then 'Machine' directly in the builder.
        // 
        this.configBuilder = new ConfigPartBuilder({
                'style': "plain",
                'mode': "EDITABLE",
                'canRemove': false,
                'assetType': this.assetType,
                'showAllRootTypes': true,    
                  
                // give the builder a more suiteable width for the search
                // page area. The default width is a bit too wide. This allows
                // the page to align the builder's fields with the time/availiability
                // criteria fields.
                'width': dojo.isIE ? 380 : 360,          
                'onRootTypeChanged':  dojo.hitch(this, "_rootAssetTypeChanged")
            }, this.searchFormNode);
	},
	
    // Summary:
    //   This method is the notification extension for the config builder widget. It's
    //   called when the user changed the root type and that a new config asset is used.
    //
    _rootAssetTypeChanged: function(type, asset)
    {
        this.assetType = type;
        this.asset = asset;
        
        // initialize the config with any default search criteria and reload the config
        // into the builder.
        this._initDefaultCriteria();
        this.configBuilder.setCatalogAttribute(this.asset.getRootAttribute(), 0);
            
        this._updateViewOnAssetType();
    },
    
	_clearAttributes: function()
	{
		//Reset the dates
        this._inClearDate = true;
		this.fromDateControl.setDisplayedValue("");
		this.toDateControl.setDisplayedValue("");
        
        this._clearDateFieldsConstraints();
        this._inClearDate = false;
        
		//Reset the times
        var startOfDayTime = new Date();
        startOfDayTime.setHours(0, 0, 0, 0);
		this.fromTimeControl.setTime(startOfDayTime);
        var endOfDayTime = new Date();
        endOfDayTime.setHours(23, 59, 0, 0);
		this.toTimeControl.setTime(endOfDayTime);

		//Reset the config
		this._loadAssetTypeToForm();
        
        // reset any date validation messages, etc.
        this._dateValueChanged();
	},
    
    _clearDateFieldsConstraints: function()
    {
        var minDate = this._getMinDate();
        
        this.fromDateControl.constraints['min'] = minDate;
        if(this.fromDateControl.constraints['max'])
            delete this.fromDateControl.constraints['max'];
        
        this.toDateControl.constraints['min'] = minDate;
        if(this.toDateControl.constraints['max'])
            delete this.toDateControl.constraints['max'];

        if (this.fromDateControl._picker) {
            var picker = this.fromDateControl._picker;
            delete picker;
            this.fromDateControl._picker = null;
        }
        if (this.toDateControl._picker) {
            var picker = this.toDateControl._picker;
            delete picker;
            this.toDateControl._picker = null;
        }
        this.fromDateControl.isValid(true);
        this.toDateControl.isValid(true);
    },
    
    _getMinDate: function()
    {
        var todayDate = new Date();
        todayDate.setHours(0, 0, 0, 0);
        return todayDate;
    },        

	_constructDateArea: function()
	{
		//Create the quick select control
		this.createQuickSelect(this.availabilityNode);

		//Create the "From" widgets
		var txt = document.createTextNode(RtlmUiUtil_getMessage("srchFrom")+": ");
		this.fromDateLabelNode.appendChild(txt);
		
        var today = this._getMinDate();
        var node = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            fieldLabel: txt,
            name: "From",
            value: "",
            minDate:today,
            invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),      
            onChange: dojo.hitch(this, "_fromDateValueChanged"),
            onkeyup: dojo.hitch(this, "_fromDateValueChanged"),            
            "class": "text-field"
        });
        this.fromDateNode.appendChild(node.domNode);
        node.init();
        this.fromDateControl = node;
	    
		// from time picker		
		var timeSpan = document.createElement("span");
	    this.fromDateNode.appendChild(timeSpan);
		
		this.fromTimeControl = new com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector({}, timeSpan);							
        dojo.style(this.fromTimeControl.domNode, "display", "inline");
		this.connect(this.fromTimeControl, "onChange", "_dateValueChanged");

		
		//Create the "To" widgets
		var toTxt = document.createTextNode(RtlmUiUtil_getMessage("srchTill")+": ");
		this.toDateLabelNode.appendChild(toTxt);

        var toNode = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            name: "To",
            fieldLabel: toTxt,
            value: "",
            minDate:today,
            invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_toDateValueChanged"),
            onkeyup: dojo.hitch(this, "_toDateValueChanged"),            
            "class": "text-field"
        });
        this.toDateNode.appendChild(toNode.domNode);
        toNode.init();
        this.toDateControl = toNode;
		
		// to time picker		
        var endOfDayTime = new Date();
        endOfDayTime.setHours(23, 59, 0, 0);
		var toTimeSpan = document.createElement("span");
	    this.toDateNode.appendChild(toTimeSpan);
		this.toTimeControl = new com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector({time:endOfDayTime}, toTimeSpan);							
        dojo.style(this.toTimeControl.domNode, "display", "inline");
		this.connect(this.toTimeControl, "onChange", "_dateValueChanged");
	},
	
	createQuickSelect: function(appendTo)
	{
		this.quickSelect = document.createElement("select");
		dojo.addClass(this.quickSelect, "quick-select");
		
		this.connect(this.quickSelect, "onchange", "_quickSelectChange");
		var options = this.quickSelect.options;
		var getMsg = RtlmUiUtil_getMessage;
		options[0] = new Option( " ", "none" );
		options[1] = new Option( getMsg("Today"), "today" );
		options[2] = new Option( getMsg("Tomorrow"), "tomorrow" );
		options[3] = new Option( getMsg("Next2Days"), "next2" );
		options[4] = new Option( getMsg("Next5Days"), "next5" );
		
        this.quickSelect.id = "lm-search-quick-select";
        this.availabilityLabelNode.setAttribute("for", "lm-search-quick-select");

		appendTo.appendChild(this.quickSelect);		
	},
	
	_quickSelectChange: function()
	{
		var selValue = this.quickSelect.options[this.quickSelect.selectedIndex].value;
		// Initialize start time to "now"
		var defaultStartTime = new Date();
		var defaultEndTime = new Date();
		defaultEndTime.setHours(23);
		defaultEndTime.setMinutes(59);
		
		this.inQuickSelectChange = true;

		if (selValue=="none")
		{
			// "none" has clearing effect so switch time to noon
			// rather than "now" used for Today, Tomorrow, etc.
			defaultStartTime.setHours(0);
			defaultStartTime.setMinutes(0);
			this.fromTimeControl.setTime(defaultStartTime);
			this.fromDateControl.setDisplayedValue("");
			this.toDateControl.setDisplayedValue("");
		}
		else if(selValue == "today")
		{
			var startDate =  new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);
			
			this.toDateControl.setValue(startDate);
			this.toTimeControl.setTime(defaultEndTime);			
		}
		else if(selValue == "tomorrow")
		{
			var startDate = new Date();
			startDate.setDate(startDate.getDate()+1);
			this.fromDateControl.setValue(startDate);
			// Reset to default time for "tomorrow" reservation,
			// rather than "now".
			defaultStartTime.setHours(0);
            defaultStartTime.setMinutes(0);
			this.fromTimeControl.setTime(defaultStartTime);
			
			this.toDateControl.setValue(startDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}
		else if(selValue == "next2")
		{
			var startDate = new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);

			var endDate = new Date();
			endDate.setDate(startDate.getDate()+1);
			
			this.toDateControl.setValue(endDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}
		else if(selValue == "next5")
		{
			var startDate = new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);

			var endDate = new Date();
			endDate.setDate(startDate.getDate()+4);
			
			this.toDateControl.setValue(endDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}		
		
		this.inQuickSelectChange = false;
	},	
    _constructGroupArea: function() {
        // set up the group selector
//        this.groupSelector.onChange = dojo.hitch(this, "_updateActionButtons");
//        dojo.addClass(this.groupSelector.textbox, "my-text-field");
        this.groupSelector.isValid = function() {
            if (this.getDisplayedValue() == "")
                return true;
            else
                return this._isvalid;
        };

        var datastore = {};
        datastore.data = { "theIdentifier": "uuid",  "items": [] };

        var myGroups = GroupUtil.getAllGroups();
        var myGroups_length = myGroups.length;
        for (var i = 0; myGroups && ( i < myGroups_length ); i++) {
            var aGroup = { 'name': myGroups[i].name, 'uuid': myGroups[i].id };
            datastore.data.items.push(aGroup);
        }

        this.groupSelector.store = new dojo.data.ItemFileReadStore(datastore);
        this.groupSelector.setDisabled(!this.useGroupCheckBox.checked);
    },
    
    _toggleGroup: function() {
        if (!this.useGroupCheckBox.checked) {
            if (!this.groupSelector.isValid()) {
                this.groupSelector.setDisplayedValue("");
            }
        }
        this.groupSelector.setDisabled(!this.useGroupCheckBox.checked);
    },
    
    _fromDateValueChanged :function()
    {
        if(this._inClearDate)
            return;

        if(this.fromDateControl.isValid() && this.fromDateControl.getValue()) {
            var minDate = this.fromDateControl.getValue();
            var toField = this.toDateControl;
            
            toField.constraints['min'] = minDate;
            
            // force an update of the calendar in the field.
            // Otherwise, the calendar would not pick up the new
            // constraints.
            if(toField._picker) {
                var picker = toField._picker;
                delete picker;
                toField._picker = null; 
            }
            toField.isValid(false);   
        }
        this._dateValueChanged();
    },

    _toDateValueChanged :function()
    {
        if(this._inClearDate)
            return;

        if (this.toDateControl.isValid() && this.toDateControl.getValue()) {
            var maxDate = this.toDateControl.getValue();
            var fromField = this.fromDateControl;
            
            fromField.constraints['max'] = maxDate;

            // force an update of the calendar in the field.
            // Otherwise, the calendar would not pick up the new
            // constraints.
            if (fromField._picker) {
                var picker = fromField._picker;
                delete picker;
                fromField._picker = null;
            }
            fromField.isValid(false);
        }
        this._dateValueChanged();
    },

    _validateDates :function(fromDate, toDate)
    {
        if (fromDate == null || toDate == null)
            return false;

        var fromDateLong = fromDate.getTime();
        var toDateLong = toDate.getTime();
        
        if (fromDateLong == null || toDateLong == null)
            return false;
        
        if (fromDateLong >= toDateLong)
            return false;
            
        return true;
    },

    _dateValueChanged :function()
    {
        if (!this.inQuickSelectChange)
            this.quickSelect.selectedIndex = 0;
        
        // if the date range is not valid, disable
        // the search button and show the appropriate
        // message.
        var isValid = this.fromDateControl.isValid() && this.toDateControl.isValid();
        this.topSearchButton.disabled = !isValid;
        
        if (!isValid) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("invalidSearchDateRange"), ViewHeaderLayout.ERROR);
        }
        else {
            this.viewHeaderNode.clearStatus();
        }
		this._checkButtonStatus();
        this.tableViewer.refresh();
    },
	
	_onDateCheckClick : function()
	{
		this._checkButtonStatus();
	},

    _checkActionPermissionForMachineId: function(id, action)
    {
        if(this.permissionsHash[id]) {
            return this.permissionsHash[id][action];
        }
        // optimistically set to has permission.
        return true;
    },
        
    // a row was checked so lets enable and disable actions appropriately    
    _checkButtonStatus: function(tableViewer, rowObject, state)
    {
        var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
        // deselection
        if (rows_length == 0) {
            this._checkAllButonsStatus();
            return;
        }
        
        var fetchPermList = [];
        for (var i = 0; i < rows_length; i++) {
            var id = rows[i][( ( this.assetType == "VirtualImage" ) ? "VirtualImage.id" : "machine.id" )];
            
            if(!this.permissionsHash[id]) {
                fetchPermList.push(id);
            }
        }            
        
        // we have all of the permissions for the rows, can check right away
        if(fetchPermList.length == 0) {
            this._checkAllButonsStatus();
            return;
        }
        
        var responseHandler = new ServiceResponseHandler
        (
            {
                _self: this,
                _success: function (perms) {
                    if (perms) {
                        // store the permissions in a table hashed by its id.
                        var perms_length = perms.length;
                        for (var i = 0; i < perms_length; i++) {
                            this._self.permissionsHash[perms[i]['itemId']] = perms[i];
                        }
                    }
                    this._self._checkAllButonsStatus();
                },
                _failure: function (errObj) {
                    // optimistically disables permission check
                    this._self._checkAllButonsStatus();
                }
            },
            "_success",
            "_failure"
        );
        
        // fetches the permissions for the rows, before we start the button
        // enablement check.
        adminService.getResourcePermissions(responseHandler, fetchPermList);
    },
	
	_checkAllButonsStatus : function()
	{
        var checkedRows = this.tableViewer.getCheckedRows();

        if( this.assetType == "Machine" ) {
            this._checkReserveButtonStatus(checkedRows);
            this._checkUnReserveButtonStatus(checkedRows);
            this._checkConfigureButtonStatus(checkedRows);
            this._checkDiscoverButtonStatus(checkedRows);
        }
        else if( this.assetType == "VirtualImage" ) {
            this._checkDeployButtonStatus(checkedRows);            
        }     
        this._checkDeleteButtonStatus(checkedRows);        
        this._checkHideButtonStatus(checkedRows);        
	},

    _checkDeleteButtonStatus: function(checkedRows)
    {
        if(this.deleteButton)
            this.deleteButton.setDisabled( checkedRows.length == 0 );
    },

    _checkHideButtonStatus: function(checkedRows)
    {
        //Only enable automations if anyone of the machines applicable
        if(this.hideButton)
            this.hideButton.setDisabled( checkedRows.length == 0 );
    },
    	
	_checkReserveButtonStatus : function(checkedRows)
	{
		var enable = true;
		if (this.fromDateControl.getValue() == null || this.toDateControl.getValue() == null)
			enable = false;
		else
		{
			//Dates are enabled.  Now ensure that at least one row is selected
			//and that only unreserved rows are selected
			var rows = checkedRows;
            var rows_length = rows.length;
			if (rows_length == 0)
				enable = false;
			else
			{
				//Loop over all the rows.  If any are already reserved then disable the reserve button
				for (var i = 0; i < rows_length; i++) 
				{
					var rowData = rows[i];
                    var reservePerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canReserve");
					if ((reservePerm == false) || this._isMachineReserved(rowData["machine.id"])) 
					{
						enable = false;
						break;
					}
				}
			}
		}
		this.reserveButton.setDisabled(!enable);
	},
	
	_checkUnReserveButtonStatus : function(checkedRows)
	{
		var enable = true;
		//Dates are enabled.  Now ensure that at least one row is selected
		//and that only unreserved rows are selected
		var rows = checkedRows;
        var rows_length = rows.length;
		if (rows_length == 0)
			enable = false;
		else
		{
			//Loop over all the rows.  If any are already reserved then disable the reserve button
			for (var i = 0; i < rows_length; i++) 
			{
				var rowData = rows[i];
                var reservePerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canReserve");
				if ((reservePerm == false) || !this._isMachineReserved(rowData["machine.id"])) 
				{
					enable = false;
					break;
				}
			}
		}
		this.unReserveButton.setDisabled(!enable);
	},
	
    _enableConfigurationButton: function(selectedRows) 
    {
        var selectedRow_len = selectedRows.length;
        var disable = true;
        
        for (var i = 0; i < selectedRow_len; i++) {
            var rowData = selectedRows[i];
            
            // we allow the action to be enabled when
            // there's at least one automatable machine.
            if(rowData[AUTOMATION_DATA]) {
                disable = false;
                break;
            }
        }
        this.configureButton.setDisabled(disable);
    },
    
	_checkConfigureButtonStatus : function(checkedRows)
	{
		//Only enable automations if anyone of the machines applicable
        var checkedRows_length = checkedRows.length;

        if( checkedRows_length == 0 )
        {
            this.configureButton.setDisabled(true);
            return;
        }
        
        // quick check to see if any of the selected machines that the
        // user can't run automation, before checking for automatable.
        // Also, determine whether we need to fetch the automation
        // provider info.
        var checkAutomationList = [];
        for (var i = 0; i < checkedRows_length; i++) 
        {
            var rowData = checkedRows[i];
            var automatePerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canAutomate");
            if ((automatePerm == false)) 
            {
                this.configureButton.setDisabled(true);
                return;
            }
            // If the rowData doesn't have automation data fetched, 
            // We'll need to fetch that info. Save this row.
            if(typeof rowData[AUTOMATION_DATA] == "undefined") {
                checkAutomationList.push(rowData);
            }
        }
		// All selected rows have automation info fetched. We can 
        // just enable/disable the action.
        if(checkAutomationList.length == 0) {
            this._enableConfigurationButton(checkedRows);
            return;
        }
        
        // there are rows that don't have automation data, fetch them. 
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
		var numdone = 0;
		var enable = false;
	    var checkList_len = checkAutomationList.length;
        	        
		for( var i = 0; i < checkList_len; i++ )
		{
            var rowData = checkAutomationList[i];
			var id = this.tableContentProvider.getRowDataId(rowData);
			var checkHandler = new ServiceResponseHandler
			(
				{
					parent: this,
					machineRow: rowData,
					_success: function( response )
					{
						numdone++;
                        // record the automation info directly in the row data.
                        var automatable = response && ( response.length > 0 );
                        this.machineRow[AUTOMATION_DATA] = automatable;

						if( numdone == checkList_len )
						{
							this.parent._enableConfigurationButton(checkedRows);
						}
					},
					_failure: function( errObj )
					{
                        numdone++;
                        if( numdone == checkList_len )
                        {
                            this.parent._enableConfigurationButton(checkedRows);
                        }
					}
				},
				"_success",
				"_failure"
			);
			inven.getAutomationsForAsset( checkHandler, id );
		}
	},
	
	_checkDeployButtonStatus: function(checkedRows)
	{
		//Only enable deploy if anyone of the machines applicable
        var virtualizePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_VIRTUALIZATION);  
        var canVirtualize = (!virtualizePerm || virtualizePerm[PermissionsClient.ACTION_DEPLOY]);

		this.deployButton.setDisabled( checkedRows.length == 0 || !canVirtualize );
	},
	
    _enableDiscoverButton: function(selectedRows) 
    {
        if(!this.discoverButton) {
            return;
        }
        var selectedRow_len = selectedRows.length;
        var disable = selectedRow_len == 0 || false;
        
        for (var i = 0; i < selectedRow_len; i++) {
            var rowData = selectedRows[i];
            
            // all selected rows must be discoverable before
            // we would enable the action.
            if(!rowData[INVENTORY_DATA]) {
                disable = true;
                break;
            }
        }
        if (disable) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("machineDiscoverDisabled"), ViewHeaderLayout.WARNING);       
        }
        this.discoverButton.setDisabled(disable);
    },

	_checkDiscoverButtonStatus: function(checkedRows)
	{
        this.viewHeaderNode.clearStatus();
				
        if(!this.discoverButton) {
            return;
        }

        var enable = true;
        var rows = checkedRows;
        var rows_length = rows.length;
        if (rows_length == 0)
            enable = false;
        else
        {
            var checkAutomationList = [];
            for (var i = 0; i < rows_length; i++) 
            {
                var rowData = rows[i];
                var discoverPerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canDiscover");
				
                if (discoverPerm == false) 
                {
                    enable = false;
                    break;
                }
                // If the rowData doesn't have inventory data fetched, 
                // We'll need to fetch that info. Save this row.
                if(typeof rowData[INVENTORY_DATA] == "undefined") {
                    checkAutomationList.push( rowData[ "machine.id" ] );
                }
            }
			
			if (enable) {
                // We've fetched these rows' inventory data. We can just
                // set the enablement state.
                if(checkAutomationList.length == 0) {
                    this._enableDiscoverButton(checkedRows);
                    return;
                }
                
                // go ahead and fetch the inventory data.
				var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
				var checkHandler = new ServiceResponseHandler({
					parent: this,
					_success: function(response){
                        var canDiscover = response && (response == "true");
                        // record the fetched inventory data.
                        for (var i = 0; i < rows_length; i++) {
                            var rowData = rows[i];
                            rowData[INVENTORY_DATA] = canDiscover;
                        }
                        this.parent._enableDiscoverButton(checkedRows);
					},
					_failure: function(errObj){
                        this.parent._enableDiscoverButton(checkedRows);
					}
				}, "_success", "_failure");
				
				inven.isInventoryAvailable(checkHandler, checkAutomationList);
				return;
			}
        }
		
		this.discoverButton.setDisabled( !enable );
	},
	
	_search: function()
    {
    	try
    	{
            // clear the contents and disable all table actions 
            this.permissionsHash = {};
            this._clearTable();
            this.searchButton.setDisabled( true );
            this._checkButtonStatus();
            
		   	var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_searchError");
	        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
	        
	        this.viewHeaderNode.clearStatus();
	        this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("srchWorking"));
            this.tableViewer.showLoadingProgress();
	
			this._searchAttributeCriteria = MachineInfo.getSearchAttributeCriteria()[this.assetType];
			if (this.fromDateControl.getValue() != null && this.toDateControl.getValue())
			{ 
	            var fromDate = new Date(this.fromDateControl.getValue());
	            var fromTime = this.fromTimeControl.getTime();
	            if (fromTime) {
	                fromDate.setHours(fromTime.getHours());
	                fromDate.setMinutes(fromTime.getMinutes());
	            }
	            var toDate = new Date(this.toDateControl.getValue());
	            var toTime = this.toTimeControl.getTime();
	            if (toTime) {
	                toDate.setHours(toTime.getHours());
	                toDate.setMinutes(toTime.getMinutes());
	            }
	            if (this._validateDates(fromDate, toDate)) {
	                if (this.useGroupCheckBox.checked && this.groupSelector.isValid() && this.groupSelector.getValue()) {
	                    var groupResponseHandler = new ServiceResponseHandler(this, "_searchSuccessWrapper", "_searchError");
	                    var group = new com.ibm.rational.test.lm.web.client.internal.group();
	                    group.searchForAssetsInGroup(groupResponseHandler, 
	                    	this.groupSelector.getValue(), this._searchAttributeCriteria, this.asset);
	                } else {
	                    var searchParam = {
	                        configuration: this.asset,
	                        columns: ( this._searchAttributeCriteria ),
	                        from: fromDate.getTime(),
	                        to: toDate.getTime()
	                    };
	                    catalog.search(responseHandler, searchParam);
	                }
	            } else alert(RtlmUiUtil_getMessage("msgCheckDates"));
	        } else {
	            if (this.useGroupCheckBox.checked && this.groupSelector.isValid() && this.groupSelector.getValue()) {
	                var groupResponseHandler = new ServiceResponseHandler(this, "_searchSuccessWrapper", "_searchError");
	                var group = new com.ibm.rational.test.lm.web.client.internal.group();
	                group.searchForAssetsInGroup(groupResponseHandler, this.groupSelector.getValue(), this._searchAttributeCriteria, this.asset);
	            } else {
	                var searchParam = {
	                    configuration: this.asset,
	                    columns: ( this._searchAttributeCriteria )
	                };
	                catalog.search(responseHandler, searchParam);
	            }
	        }
        }
        catch( e )
        {
        	this.searchButton.setDisabled( false );
        }
    },
	
    _searchSuccessWrapper: function( response ) {
    	this.searchButton.setDisabled( false );
        var result = [];
        var allColumns = ( com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineInfo.getSearchAttributeCriteria()[this.assetType] ).split(", ");
        var allColumns_length = allColumns.length;
        var data_length = response.Data.length;
        for( var i = 0; i < data_length; i++ ) {
            var aRow = [];
            for (var col = 0; col < allColumns_length; col++) {
                var colName = allColumns[col];
                aRow.push(response.Data[i][col][colName]);
            }
            // group asset not of the same family type will have all null columns
            // but we can skip if the first column is null which is the uuid
            if (aRow[0])
                result.push(aRow);
        }
        this._searchSuccess({ Data: result});
    },
	
	_searchSuccess: function( response )
	{
    	this.searchButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
        this.tableViewer.endLoadingProgress();
        this.tableViewer.noItemMessage = "";

		if (!(response.Header)){
			var colnames = this._searchAttributeCriteria.replace(/, /g,',');
			colnames = colnames.split(',');
			response.Header = colnames;
		}
        this.tableViewer.setContent( response );
		this.lastSearchResult = response;
        this.tableViewer.refresh();
	},
	
	_searchError: function( message, error )
	{
    	this.searchButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
        this.tableViewer.endLoadingProgress();
        this.viewHeaderNode.setStatus("Error occurred. Unable to perform asset search.", ViewHeaderLayout.ERROR);		
	},
	
	_clearTable: function()
	{
        // loads an empty content to the table to clear the content.
        var emptyContent = {Data:[]};
        
        // don't show the standard empty content message. This is intensional
        // to have an empty content in the table.
        this.tableViewer.noItemMessage = " ";
        this.tableViewer.setContent(emptyContent);
        this.tableViewer.refresh();
	},
	
	_automateSelected: function( event )
	{
		var rows = this.tableViewer.getCheckedRows();
		var machines = { "Data": [], "Header": ["machine.id", "machine.name"] };
		var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
            var rowData = rows[ iRow ];
			var id = this.tableContentProvider.getRowDataId( rowData );
			if( rowData[AUTOMATION_DATA] )
			{
				machines.Data.push( [ id,
								 	  this.tableContentProvider.getCellDisplayData( rowData, this.tableContentProvider.getColumnIndex( "machine\\.name" ) ) ] );
			}
		}
		
		dojo.setObject( "com.ibm.rational.test.lm.web.machines", machines );
				
		var uri = InventoryUriUtil.getAutomationsURI();
		
		window.location.href = uri;
	},
	
	_onkeypress: function( event )
	{
		if( event && event.keyCode )
		{
			if( event.keyCode == 13 ||
				event.keyCode == 10 )
			{
				this._search();
			}
		}
	},
	
	_reserveSelected : function()
	{
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( rows[ iRow ] ) ;
			this.doResAction(id);
		}	
	},

	_unReserveSelected : function()
	{
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( rows[ iRow ] ) ;
			this.doUnResAction(id);
		}	
	},
	
	//Callback from the table when the reserve/unreserve button is clicked
	doResAction: function(id)
	{
		if (!this._isMachineReserved(id))  //NOT reserved in this session already
		{
			var responseHandler = new ServiceResponseHandler(this, "_reserveSuccess", "_reserveError");
			var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();
			
			//Get the from and to dates and times
			if (this.fromDateControl.getValue() != null && this.toDateControl.getValue()) //Should ALWAYS be true or the reserve button should have been disabled 
			{
				var fromDate = new Date(this.fromDateControl.getValue());
				var fromTime = this.fromTimeControl.getTime();
				if (fromTime) 
				{
					fromDate.setHours(fromTime.getHours());
					fromDate.setMinutes(fromTime.getMinutes());
				}
				var toDate = new Date(this.toDateControl.getValue());
				var toTime = this.toTimeControl.getTime();
				if (toTime) 
				{
					toDate.setHours(toTime.getHours());
					toDate.setMinutes(toTime.getMinutes());
				}
				if (this._validateDates(fromDate, toDate)) 
				{
					this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("msgReserving"));
					reservations.createReservation(responseHandler, id, fromDate.getTime(), toDate.getTime());
				}
				else 
					alert(RtlmUiUtil_getMessage("msgCheckDates"));
			}
		}
	},

	doUnResAction : function(id)
	{
		//Determine if we need to reserve or un-reserve
		if (this._isMachineReserved(id))  //has it been reserved in this session already
		{
			this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("msgUnReserving"));
			var resID = this._getResID(id)
			var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();
			var handler = new MachineSearchView.UnreserveHandler(this, resID);
		   	var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			reservations.cancelReservation(responseHandler, resID);
		}
	},
		
	_reserveSuccess:function(response)
	{
		this.viewHeaderNode.setProgressEnd();
		var reservationID = response.id;
		//We need to instantiate the machine in order to retrieve the machine id
        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
		var machine = catalog.createAssetFromJson(response.configuration);
		var machineID = machine.getId();
		
		this.newReservations.push({id:machineID, resID:reservationID, resFrom:response.reserveFrom, resTo:response.reserveTo});
		this.tableViewer.refresh();
		this._checkButtonStatus();
	},
	
	_reserveError:function(response)
	{
		this.viewHeaderNode.setProgressEnd();
		this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgReserveMachineFailed"), ViewHeaderLayout.ERROR);		
	},

	_isMachineReserved:function(id)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].id == id) 
			{
				//If a date range is specified, see if the reservation is within that range
				if (this.fromDateControl.getValue() != null && this.toDateControl.getValue())
				{
					var fromDate = new Date(this.fromDateControl.getValue());
					var fromTime = this.fromTimeControl.getTime();
					if (fromTime) 
					{
						fromDate.setHours(fromTime.getHours());
						fromDate.setMinutes(fromTime.getMinutes());
					}
					var toDate = new Date(this.toDateControl.getValue());
					var toTime = this.toTimeControl.getTime();
					if (toTime) 
					{
						toDate.setHours(toTime.getHours());
						toDate.setMinutes(toTime.getMinutes());
					}
					var fromResDate = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util.convertTimeStampToDate(this.newReservations[i].resFrom);
					var toResDate = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util.convertTimeStampToDate(this.newReservations[i].resTo);
 
					if (this._overlappingDates(fromDate, toDate, fromResDate, toResDate))
						return true;
				}
				else  //This is kind of an error case.  No sense checking reservations if no date has been specified by the user.
					return true;
			}
		}
		return false;
	},
	
	_overlappingDates: function(fromDate, toDate, fromResDate, toResDate)
	{
		//Check for existing reservation entirely within the date range.
		if (fromDate < fromResDate && toDate > toResDate)
			return true;
		
		//Check for start date within reservation
		if (fromDate >= fromResDate && fromDate <= toResDate)
			return true;
			
		//Check for end date within reservation
		if (toDate >= fromResDate && toDate <= toResDate)
			return true;
	},
	
	_getResID : function(id)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].id == id)
				return this.newReservations[i].resID;
		}
		return null;
	},
	
	_removeRes : function(resID)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].resID == resID)
				this.newReservations[i] = null;
		}
	},
	
	_deploySelected: function(){
		var rows = this.tableViewer.getCheckedRows();
		var vis = [];
		var rows_length = rows.length;
		for (var iRow = 0; iRow < rows_length; iRow++) {
			vis.push(this.tableContentProvider.getRowDataId(rows[iRow]));
		}
		
		dojo.setObject( "com.ibm.rational.test.lm.web.virtualimages", vis );
		
		var uri = InventoryUriUtil.getDeploymentURI();
		
		window.location.href = uri;
	},
	
	_discoverSelected: function(){
		var rows = this.tableViewer.getCheckedRows();
		var vis = [];
        var rows_length = rows.length;
		for (var iRow = 0; iRow < rows_length; iRow++) {
			vis.push(this.tableContentProvider.getRowDataId(rows[iRow]));
		}
		
		dojo.setObject( "com.ibm.rational.test.lm.web.discoverimages", vis );
		
		var uri = InventoryUriUtil.getDiscoverURI();
		
		window.location.href = uri;
	},
	
    _addAdvancedActions: function()
	{
		this._addAdvancedAction(RtlmUiUtil_getMessage("srchSelectResouceDesc"), dojo.hitch(this, "_chooseConfig"), null, "select-part-icon-image" );
	},
		
	_addAdvancedAction: function(label, callback, callbackData, iconClass)
	{
		var arg = {
            label: label,
            showLabel: !iconClass,       // must show label if no icon is specified
            onClick: function( e ) {
				this.clientCallback(this.callbackData, e);
            },
            'class': "com-ibm-asq-common-web-ui-editor-container-action"
        };
        
        if (iconClass) {
            arg["iconClass"] = iconClass;
        }
        var button = new dijit.form.Button(arg);
		
        // store the client callback and data into the button
        button.clientCallback = callback
        button.callbackData = callbackData;
		
		//NOTE that this is not being added as a section action.
		//Rather it is added to the summary.  This is a special case for the select LRD action.
		//Currently this is the only action so this is OK.
		//If we want actual section actions added to the top right of the section then this will have to change.
		this.searchSectionNode.summaryNode.appendChild(button.domNode);
        return button;
	},
	
	_updatePostDelete: function()
	{
	   this._search();
	},
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray){
        // reservations have been canceled. remove it from our reservation list
        // if found.
        if (artifactType == RtlmUiUtil.TYPE_RESERVATION_CANCELED) {
            var artifactArray_length = artifactArray.length;
            for(var i = 0; i < artifactArray_length; i++) {
                this._removeRes(artifactArray[i]);
            }
        }
        this.tableViewer.refresh();
         this._checkAllButonsStatus();
    }
    
});

//Class to handle the response when unreserving machines
//We need the class because there may be simultaneous calls to the unreserve machine service
//and we need to know the id of the cancelled reservation but the response from the unreserve service does
//not contain the id of cancelled reservation.
//Therefore we set the id in the constructor.
dojo.declare("MachineSearchView.UnreserveHandler", null,
{
	constructor: function(parentView, id)
	{
		this.parentView = parentView;
		this.id = id;  //Remember the id for later use
	},
	
	success: function(response) 
	{
		this.parentView.viewHeaderNode.setProgressEnd();
		this.parentView._removeRes(this.id);  //Remove the reservation from our array of reservations
		this.parentView.tableViewer.refresh();
		this.parentView._checkButtonStatus();
	},
	error: function(response) 
	{
		this.parentView.viewHeaderNode.setProgressEnd();
		this.parentView.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgReserveMachineFailed"), ViewHeaderLayout.ERROR);		
	}	
});
})();
