// ********  QUERY ASSETS VIEW ********* //

/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.AssetDescriptionSelectorDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineListBaseView");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.client.internal.admin");

(function() 
{
	var MachineInfo = com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchInfo;
    var adminService = new com.ibm.asq.common.web.client.internal.admin();
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var InventoryUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil;
	var catalog = new com.ibm.asq.common.web.client.internal.Catalog();	
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
	
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView", 
    [com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineListBaseView, dijit._Widget, dijit._Templated], 
{
	//This line is NECESSARY fot the attachPoints in the PageLayout to get instantiated
	widgetsInTemplate: true,
	
	//The layout of the page.
	templateString: 
		'<div class="com-ibm-rational-test-lm-query-machine" id="${id}" dojoAttachPoint="domNode">' +
		'<div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode">' + 		
		' <!-- The table of configurations -->  '+
		' <div dojoAttachPoint="configurations_panel"> '+
        '   <div dojoAttachPoint=advancedSearchNode>' +
        '     <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" dojoAttachPoint="advancedSearchSection" title=${areaTitle} open="true">'+
        '       <table cellpadding="8px" cellspacing="4px"> '+
        '         <tr>' +
        '           <td>${availLabel}' +
        '           </td>'+
        '           <td dojoAttachPoint="dateAvailTD">' +
        '           </td>'+
        '         </tr>'+
        '         <tr> '+
        '           <td>' +
        '             <span class="date-label">${availFromLabel}</span>' +
        '           </td>'+
        '           <td dojoAttachPoint="dateFromTD"> '+
        '           </td> '+
        '         </tr> '+
        '         <tr> '+
        '           <td>' +
        '             <span class="date-label">${availToLabel}</span>' +
        '           </td>'+
        '           <td dojoAttachPoint="dateToTD"> '+
        '           </td> '+
        '         </tr> '+
        '       </table> '+
        '     </div>' +
        '   </div>' +
        '   <!-- table resultarea --> '+
        '   <div class="result-area" dojoAttachPoint="resultDiv"> '+
        '   </div> '+
		' </div>' +
		'</div>',
    
    areaTitle: RtlmUiUtil_getMessage("SearchCriteria"),
    availLabel: RtlmUiUtil_getMessage("Availability")+":",
    availFromLabel: RtlmUiUtil_getMessage("srchFrom")+": ",
    availToLabel: RtlmUiUtil_getMessage("srchTill")+": ",
    
    postCreate: function()
    {
		this.assetType = "Machine";
		this.asset = catalog.createConfiguration(this.assetType);
		this.configPart = this.asset.getRootPart(0);
		this.newReservations = [];
		this.queryInUse = false;
		this.lastFromDate = null;
		this.lastToDate = null;
        this.permissionsHash = {};
		
        com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView.superclass.postCreate.apply(this);
		this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("ClearAttributes"), dojo.hitch(this, "_clearAttributes"), null, "clearform-icon-image");
		this.searchAction = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("searchAssetAction"), dojo.hitch(this, "_searchAssets"), null, "search-icon-image");
		
		//Set the title and cs help id on the page
		this.viewHeaderNode.setTitle(RtlmUiUtil_getMessage("MachTitleSearch"));
		this.viewHeaderNode.setCSHelpId("rtlm_findlabres.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", RtlmUiUtil_getMessage("MachTitleSearch")));
		
		//Create the advanced search more/less area
		this.createAdvancedSearchArea();
		
		//Create the table that will hold the reservations
		//If we were called from the config search view to start with a named config then load and display it here
		if (this.initialConfigID != null) 
		{
			var configs = new com.ibm.rational.test.lm.web.client.internal.config();
			var responseHandler = new ServiceResponseHandler(this, "_loadConfigSuccessHandler", "_loadConfigErrorHandler");
			
			configs.retrieveConfigurationWithDetails(responseHandler, this.initialConfigID);
		}
		else 
		{
			this.createTable();
			this.loadTable();
		}
	},
	
	createTable: function()
	{
		this._clearTable();
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-QUERY-ASSET-TABLEVIEWER"                         
        });
		this.tableContentProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineSearchTableProvider( this.assetType );
		this.tableContentProvider.receiver = this;
		this.tableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("MachTitleSearch")));
				
		this.tableViewer.setTableRowsCheckable( true );

		this.tableViewer.setContentProvider( this.tableContentProvider );
		this.tableViewer.setTableListener( this );		
		this.resultDiv.appendChild( this.tableViewer.domNode );

        this.resultLabel = document.createElement("span");
        this.resultLabel.className = "view-label";

        this.tableViewer.contentControlNode.appendChild(this.resultLabel);
		this.createTableActions();

        var emptyContent = {Data:[]};
        
        // don't show the standard empty content message. This is intensional
        // to have an empty content in the table.
        this.tableViewer.noItemMessage = " ";
        this.tableViewer.setContent(emptyContent);
        this.tableViewer.show();
        
	},
	
	loadTable: function()
	{
		this.refreshButton.setDisabled( true );
	   	var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_searchError");
        
        this.viewHeaderNode.clearStatus();
        this.viewHeaderNode.setProgressStart("Searching...");

		this._searchAttributeCriteria = MachineInfo.getSearchAttributeCriteria()[this.assetType];
		if (this.fromDateControl.getValue() != null && this.toDateControl.getValue()) 
		{
            var fromDate = new Date(this.fromDateControl.getValue());
            var fromTime = this.fromTimeControl.getTime();
            if (fromTime) 
			{
                fromDate.setHours(fromTime.getHours());
                fromDate.setMinutes(fromTime.getMinutes());
            }
            var toDate = new Date(this.toDateControl.getValue());
            var toTime = this.toTimeControl.getTime();
            if (toTime) 
			{
                toDate.setHours(toTime.getHours());
                toDate.setMinutes(toTime.getMinutes());
            }
            if (this._validateDates(fromDate, toDate)) 
			{
                    var searchParam = {
                        configuration: this.asset,
                        columns: ( this._searchAttributeCriteria ),
                        from: fromDate.getTime(),
                        to: toDate.getTime()
                    };
					//If this is a different search date and time then clear the reservations list
					if (this.lastFromDate != null && this.lastToDate != null)
						if (fromDate.getTime() != this.lasFromDate || toDate.getTime() != this.lastToDate)
							this.newReservations = [];
					//Save these search dates for comparison later
					this.lastFromDate = fromDate.getTime();
					this.lastToDate = toDate.getTime();
							
                    catalog.search(responseHandler, searchParam);
            } else alert(RtlmUiUtil_getMessage("msgCheckDates"));
        } 
		else 
		{
				//Clear out the reservation dates since we are searching without a date specification
				this.newReservations = [];

                var searchParam = {
                    configuration: this.asset,
                    columns: ( this._searchAttributeCriteria )
                };
                catalog.search(responseHandler, searchParam);
        }
/*
		this._searchAttributeCriteria = MachineInfo.getSearchAttributeCriteria()[this.assetType];
		
		var searchParam = {
                    configuration: this.asset,
                    columns: ( this._searchAttributeCriteria )
                };
        catalog.search(responseHandler, searchParam);		
*/
	},
	
	_searchSuccess: function( response )
	{
    	this.refreshButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
		if (!(response.Header)){
			var colnames = this._searchAttributeCriteria.replace(/, /g,',');
			colnames = colnames.split(',');
			response.Header = colnames;
		}
        
        this.tableViewer.noItemMessage = "";
        this.tableViewer.setContent( response );
		this.lastSearchResult = response;
        this.tableViewer.show();
		//Display the appropriate label for the table
        /*
         * Don't show a label. It's not really necessary and looks funny with 
         * the grouping control. 
         *
		if (this.queryInUse || this.fromDateControl.getValue() != null) 
			this.resultLabel.innerHTML = RtlmUiUtil_getMessage("SearchResults");
		else 
		{
			if (this.assetType=="Machine")
				this.resultLabel.innerHTML = RtlmUiUtil_getMessage("AllMachines");
			else
				this.resultLabel.innerHTML = RtlmUiUtil_getMessage("AllVIs");
		}
		*/
	},
	
	_searchError: function( message, error )
	{
    	this.refreshButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus("Error occurred. Unable to perform asset search.", ViewHeaderLayout.ERROR);		
	},
	
	_clearTable: function()
	{
		// also clear the result too.
        dojox.data.dom.removeChildren(this.resultDiv);
	},
	

	_loadConfigSuccessHandler : function(response)
	{
		this.initialConfigName = response.name;
		var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
		var config = catalog.createConfigurationFromJson(response.configuration);
		var part = config.getRootPart(this.initialPartIndex);
		this.setConfiguration(part);
	},
	
	_loadConfigErrorHandler : function(response)
	{
		this.viewHeaderNode.setStatus("Error occurred. Unable to initialize search from config.", ViewHeaderLayout.ERROR);		
	},

	setConfiguration: function(part) 
	{
		if (part != null)
		{
			this.configPart =  part;
			this.asset = this.configPart.document; // get the configuration containing this part. No method yet, hack to access.
			this.summaryArea.setPart(this.configPart);
			this.summaryArea.refresh();
			this.summaryArea.setName(this.initialConfigName + " - " + part.instanceRoot.Label);
			this.queryInUse = true;
			this.createTable();
			this.loadTable();
		}	
	},	

	createAdvancedSearchArea: function()
	{
		//Hide the expand collapse button
		this.advancedSearchSection.headerCollapsImg.style.display="none";
		this.advancedSearchSection.setTitle(RtlmUiUtil_getMessage("SearchCriteria"));
		
		//Create the summary area
		//First the label
		this.summaryArea = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary();
		this.summaryArea.setName(RtlmUiUtil_getMessage("srchCriteriaInfoSelOnly"));
		this.summaryArea.setDefaultClass("view-label-grey");
		this.summaryArea.setNameClass("view-label")
		
		//Add the search action
		this.advancedSearchSection.summaryNode.appendChild(this.summaryArea.domNode);
		
		//Create the actions for the area
		this._addAdvancedActions();

		//Create the Date Range Area
		this._createDateArea();
	},
    
    _clearDateFieldsConstraints: function()
    {
        var minDate = this._getMinDate();
        
        this.fromDateControl.constraints['min'] = minDate;
        if(this.fromDateControl.constraints['max'])
            delete this.fromDateControl.constraints['max'];
        
        this.toDateControl.constraints['min'] = minDate;
        if(this.toDateControl.constraints['max'])
            delete this.toDateControl.constraints['max'];

        if (this.fromDateControl._picker) {
            var picker = this.fromDateControl._picker;
            delete picker;
            this.fromDateControl._picker = null;
        }
        if (this.toDateControl._picker) {
            var picker = this.toDateControl._picker;
            delete picker;
            this.toDateControl._picker = null;
        }
        this.fromDateControl.isValid(true);
        this.toDateControl.isValid(true);
    },

    _getMinDate: function()
    {
        var todayDate = new Date();
        todayDate.setHours(0, 0, 0, 0);
        return todayDate;
    },
    	
	_createDateArea: function()
	{
        var today = this._getMinDate();

		//Create the "Availability Label
		//Create the quick select control
		this.createQuickSelect(this.dateAvailTD);
				
		//Create the "From" widgets
	    var node = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
	        name: "From",
	        value: "",
            minDate:today,
	        invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
	        nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),      
            onChange: dojo.hitch(this, "_fromDateValueChanged"),
            onkeyup: dojo.hitch(this, "_fromDateValueChanged"),            
			"class": "DateField"
	    });
        this.dateFromTD.appendChild(node.domNode);
        node.init();
		this.fromDateControl = node;
		
		// from time picker		
		var timeSpan = document.createElement("span");
	    this.dateFromTD.appendChild(timeSpan);
		
		this.fromTimeControl = new com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector({}, timeSpan);							
        dojo.style(this.fromTimeControl.domNode, "display", "inline");
		this.fromTimeControl.onChange = dojo.hitch(this, "_dateValueChanged");

		
		//Create the "To" widgets
	    var toNode = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
	        name: "To",
	        value: "",
            minDate:today,
	        invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
	        nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_toDateValueChanged"),
            onkeyup: dojo.hitch(this, "_toDateValueChanged"),            
			"class": "DateField"
	    });
        this.dateToTD.appendChild(toNode.domNode);
        toNode.init();
        this.toDateControl = toNode;
		
		// to time picker		
        var endOfDayTime = new Date();
        endOfDayTime.setHours(23, 59, 0, 0);

		var toTimeSpan = document.createElement("span");
	    this.dateToTD.appendChild(toTimeSpan);
		this.toTimeControl = new com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector({time:endOfDayTime}, toTimeSpan);							
        dojo.style(this.toTimeControl.domNode, "display", "inline");
		this.toTimeControl.onChange = dojo.hitch(this, "_dateValueChanged");
	},
	
	createQuickSelect: function(appendTo)
	{
		var selectLabel = document.createElement("label");
		this.quickSelect = document.createElement("select");
		dojo.addClass(this.quickSelect, "quick-select");
		this.connect(this.quickSelect, "onchange", "_quickSelectChange");
		var options = this.quickSelect.options;
		var getMsg = RtlmUiUtil_getMessage;
		options[0] = new Option( " ", "none" );
		options[1] = new Option( getMsg("Today"), "today" );
		options[2] = new Option( getMsg("Tomorrow"), "tomorrow" );
		options[3] = new Option( getMsg("Next2Days"), "next2" );
		options[4] = new Option( getMsg("Next5Days"), "next5" );
		
		selectLabel.appendChild(this.quickSelect);
		appendTo.appendChild(selectLabel);
	},
	
	_quickSelectChange: function()
	{
		var selValue = this.quickSelect.options[this.quickSelect.selectedIndex].value;
		var defaultStartTime = new Date();
		defaultStartTime.setHours(0);
		defaultStartTime.setMinutes(0);
		var defaultEndTime = new Date();
		defaultEndTime.setHours(23);
		defaultEndTime.setMinutes(59);
		
		this.inQuickSelectChange = true;
		if (selValue=="none")
		{
			this.fromDateControl.setDisplayedValue("");
			this.toDateControl.setDisplayedValue("");
		}
		else if(selValue == "today")
		{
			var startDate =  new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);
			
			this.toDateControl.setValue(startDate);
			this.toTimeControl.setTime(defaultEndTime);			
		}
		else if(selValue == "tomorrow")
		{
			var startDate = new Date();
			startDate.setDate(startDate.getDate()+1);
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);
			
			this.toDateControl.setValue(startDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}
		else if(selValue == "next2")
		{
			var startDate = new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);

			var endDate = new Date();
			endDate.setDate(startDate.getDate()+1);
			
			this.toDateControl.setValue(endDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}
		else if(selValue == "next5")
		{
			var startDate = new Date();
			this.fromDateControl.setValue(startDate);
			this.fromTimeControl.setTime(defaultStartTime);

			var endDate = new Date();
			endDate.setDate(startDate.getDate()+4);
			
			this.toDateControl.setValue(endDate);
			this.toTimeControl.setTime(defaultEndTime);				
		}		

		this.inQuickSelectChange = false;
		
	},

    _fromDateValueChanged :function()
    {
        if(this._inClearDate)
            return;
            
        if(this.fromDateControl.isValid() && this.fromDateControl.getValue()) {
            var minDate = this.fromDateControl.getValue();
            var toField = this.toDateControl;

            toField.constraints['min'] = minDate;
            
            // force an update of the calendar in the field.
            // Otherwise, the calendar would not pick up the new
            // constraints.
            if(toField._picker) {
                var picker = toField._picker;
                delete picker;
                toField._picker = null; 
            }
            toField.isValid(false);   
        }
        this._dateValueChanged();
    },

    _toDateValueChanged :function()
    {
        if(this._inClearDate)
            return;

        if (this.toDateControl.isValid() && this.toDateControl.getValue()) {
            var maxDate = this.toDateControl.getValue();
            var fromField = this.fromDateControl;
            
            fromField.constraints['max'] = maxDate;

            // force an update of the calendar in the field.
            // Otherwise, the calendar would not pick up the new
            // constraints.
            if (fromField._picker) {
                var picker = fromField._picker;
                delete picker;
                fromField._picker = null;
            }
            fromField.isValid(false);
        }
        this._dateValueChanged();
    },

    _validateDates :function(fromDate, toDate)
    {
        if (fromDate == null || toDate == null)
            return false;

        var fromDateLong = fromDate.getTime();
        var toDateLong = toDate.getTime();
        
        if (fromDateLong == null || toDateLong == null)
            return false;
        
        if (fromDateLong >= toDateLong)
            return false;
            
        return true;
    },

	_dateValueChanged :function()
	{
		if (!this.inQuickSelectChange)
			this.quickSelect.selectedIndex = 0;
        
        // if the date range is not valid, disable
        // the search button and show the appropriate
        // message.
        var isValid = this.fromDateControl.isValid() && this.toDateControl.isValid();
        this.searchAction.setDisabled(!isValid);
        
        if (!isValid) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("invalidSearchDateRange"), ViewHeaderLayout.ERROR);
        }
        else {
            this.viewHeaderNode.clearStatus();
        }    
	},
	
	_addAdvancedActions: function()
	{
		this._addAdvancedAction(RtlmUiUtil_getMessage("srchSelectResouceDesc"), dojo.hitch(this, "_chooseLRD"), null, "select-part-icon-image" );
	},
		
	_addAdvancedAction: function(label, callback, callbackData, iconClass)
	{
		var arg = {
            label: label,
            showLabel: !iconClass,       // must show label if no icon is specified
            onClick: function( e ) {
				this.clientCallback(this.callbackData, e);
            },
            'class': "com-ibm-asq-common-web-ui-editor-container-action"
        };
        
        if (iconClass) {
            arg["iconClass"] = iconClass;
        }
        var button = new dijit.form.Button(arg);
		
        // store the client callback and data into the button
        button.clientCallback = callback
        button.callbackData = callbackData;
		
		//NOTE This is a little odd.
		//We wanted the select LRD action near the prompt for the LRD rather than at the top right of the section.
		//So append the button to the name.
		//There are other places in the code (clear, successfully loading an LRD) where the name is modified so the also call into
		//_addAdvancedActions in order to recreate the button when the name is cleared/updated
		this.summaryArea.nameArea.appendChild(button.domNode);
        return button;
	},
	
	//Action handlers
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) 
	{
		callback(callbackData);
	},
	
    _checkActionPermissionForMachineId: function(id, action)
    {
        if(this.permissionsHash[id]) {
            return this.permissionsHash[id][action];
        }
        // optimistically set to has permission.
        return true;
    },
        
    // Summary:
    //    Method to be called when a row object is being selected 
    //    
    //    
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
        // deselection
        if (rows_length == 0) {
            this._checkButtonStatus();
            return;
        }
        
        var fetchPermList = [];
        for (var i = 0; i < rows_length; i++) {
            var id = rows[i]["machine.id"];
            
            if(!this.permissionsHash[id]) {
                fetchPermList.push(id);
            }
        }            
        
        // we have all of the permissions for the rows, can check right away
        if(fetchPermList.length == 0) {
            this._checkButtonStatus();
            return;
        }
        
        var responseHandler = new ServiceResponseHandler
        (
            {
                _self: this,
                _success: function (perms) {
                    if (perms) {
                        var perms_length = perms.length;
                        // store the permissions in a table hashed by its id.
                        for (var i = 0; i < perms_length; i++) {
                            this._self.permissionsHash[perms[i]['itemId']] = perms[i];
                        }
                    }
                    this._self._checkButtonStatus();
                },
                _failure: function (errObj) {
                    // optimistically disables permission check
                    this._self._checkButtonStatus();
                }
            },
            "_success",
            "_failure"
        );
        
        // fetches the permissions for the rows, before we start the button
        // enablement check.
        adminService.getResourcePermissions(responseHandler, fetchPermList);
    },
	
	createTableActions: function()
	{
		this.refreshButton = this.tableViewer.addAction( "Search", RtlmUiUtil_getMessage("Refresh"), null, "refresh-icon-image", dojo.hitch( this, this._refreshSelected ) );
		
		this.configureButton = this.tableViewer.addAction( "Automation", RtlmUiUtil_getMessage( "Configure Automation" ), null, "configure-automation-icon-image", dojo.hitch( this, this._automateSelected ) );
		this.configureButton.setDisabled( true );

		this.reserveButton = this.tableViewer.addAction( "Reserve", RtlmUiUtil_getMessage("resMachine"), null, "reserve-icon-image", dojo.hitch( this, this._reserveSelected ) );
		this.reserveButton.setDisabled( true );

		this.unReserveButton = this.tableViewer.addAction( "UnReserve", RtlmUiUtil_getMessage("unresMachine"), null, "unreserve-icon-image", dojo.hitch( this, this._unReserveSelected ) );
		this.unReserveButton.setDisabled( true );

        // add actions to delete/hide resources if the user has permissions
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE);  
        if(perm && perm[PermissionsClient.ACTION_ARCHIVE]) {
            this.hideButton = this.tableViewer.addAction("Hide", RtlmUiUtil_getMessage("labelHideButton"), "hide", "hide-icon-image", dojo.hitch(this, "_archiveSelected"));
            this.hideButton.setDisabled( true );

            this.deleteButton = this.tableViewer.addAction("Delete", RtlmUiUtil_getMessage("labelDeleteButton"), "delete", "delete-icon-image", dojo.hitch(this, "_archiveSelected"));
            this.deleteButton.setDisabled( true );
        }                   
	},
	
	_refreshSelected: function()
	{
		this.createTable();
		this.loadTable();
	},
	
	_checkButtonStatus: function()
	{
		this._checkReserveButtonStatus();
		this._checkUnReserveButtonStatus();
		this._checkConfigureButtonStatus();
        this._checkDeleteButtonStatus();        
        this._checkHideButtonStatus();        
	},

    _checkDeleteButtonStatus: function()
    {
        var checkedRows = this.tableViewer.getCheckedRows();
        if(this.deleteButton)
            this.deleteButton.setDisabled( checkedRows.length == 0 );
    },

    _checkHideButtonStatus: function()
    {
        //Only enable automations if anyone of the machines applicable
        var checkedRows = this.tableViewer.getCheckedRows();
        if(this.hideButton)
            this.hideButton.setDisabled( checkedRows.length == 0 );
    },
	
	_checkReserveButtonStatus : function()
	{
		var enable = true;
		if (this.fromDateControl.getValue() == null || this.toDateControl.getValue() == null)
			enable = false;
		else
		{
			//Dates are enabled.  Now ensure that at least one row is selected
			//and that only unreserved rows are selected
			var rows = this.tableViewer.getCheckedRows();
            var rows_length = rows.length;
			if (rows_length == 0)
				enable = false;
			else
			{
				//Loop over all the rows.  If any are already reserved then disable the reserve button
				for (var i = 0; i < rows_length; i++) 
				{
					var rowData = rows[i];
                    var reservePerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canReserve");
					if ((reservePerm == false) || this._isMachineReserved(rowData["machine.id"])) 
					{
						enable = false;
						break;
					}
				}
			}
		}
		this.reserveButton.setDisabled(!enable);
	},
	
	_checkUnReserveButtonStatus : function()
	{
		var enable = true;
		//Dates are enabled.  Now ensure that at least one row is selected
		//and that only unreserved rows are selected
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
		if (rows_length == 0)
			enable = false;
		else
		{
			//Loop over all the rows.  If any are already reserved then disable the reserve button
			for (var i = 0; i < rows_length; i++) 
			{
				var rowData = rows[i];
                var reservePerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canReserve");
				if ((reservePerm == false) || !this._isMachineReserved(rowData["machine.id"])) 
				{
					enable = false;
					break;
				}
			}
		}
		this.unReserveButton.setDisabled(!enable);
	},
	
	_checkConfigureButtonStatus : function()
	{
		//Only enable automations if anyone of the machines applicable
		var checkedRows = this.tableViewer.getCheckedRows();
        var checkedRows_length = checkedRows.length;
        if( checkedRows_length == 0 )
        {
            this.configureButton.setDisabled(true);
            return;
        }
        
        // quick check to see if any of the selected machines that the
        // user can't run automation, before checking for automatable.
        for (var i = 0; i < checkedRows_length; i++) 
        {
            var rowData = checkedRows[i];
            var automatPerm = this._checkActionPermissionForMachineId(rowData["machine.id"], "canAutomate");
            if (automatPerm == false) 
            {
                this.configureButton.setDisabled(true);
                return;
            }
        }
		
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
		var numdone = 0;
		var enable = false;
		this.automatable = {};
		
		for( var iRow = 0; iRow < checkedRows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( checkedRows[ iRow ] );
			var checkHandler = new ServiceResponseHandler
			(
				{
					parent: this,
					machineid: id,
					_success: function( response )
					{
						numdone++;
						if( response && ( response.length > 0 ) )
						{
							this.parent.automatable[ this.machineid ] = true;
							enable = true;
						}
						
						if( numdone == checkedRows_length )
						{
							this.parent.configureButton.setDisabled( !enable );
						}
					},
					_failure: function( errObj )
					{
						this.parent.automatable = {};
						this.parent.configureButton.setDisabled(true);
					}
				},
				"_success",
				"_failure"
			);
			
			inven.getAutomationsForAsset( checkHandler, id );
		}
	},
	
	_automateSelected: function( event )
	{
		var rows = this.tableViewer.getCheckedRows();
		var machines = { "Data": [], "Header": ["machine.id", "machine.name"] };
		var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( rows[ iRow ] );
			if( this.automatable && this.automatable[ id ] )
			{
				machines.Data.push( [ id,
								 	  this.tableContentProvider.getCellDisplayData( rows[ iRow ], this.tableContentProvider.getColumnIndex( "machine\\.name" ) ) ] );
			}
		}
		
		dojo.setObject( "com.ibm.rational.test.lm.web.machines", machines );
				
		var uri = InventoryUriUtil.getAutomationsURI();
		
		window.location.href = uri;
	},
	
		
	//Reservation actions
	_reserveSelected : function()
	{
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( rows[ iRow ] ) ;
			this.doResAction(id);
		}	
	},

	_unReserveSelected : function()
	{
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows.length;
		this.unReserveCount = rows_length;  //Save the number of unreserves so that we don't reload the table until we've done them all.
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			var id = this.tableContentProvider.getRowDataId( rows[ iRow ] ) ;
			this.doUnResAction(id);
		}	
	},
	
	//Callback from the table when the reserve/unreserve button is clicked
	doResAction: function(id)
	{
		if (!this._isMachineReserved(id))  //NOT reserved in this session already
		{
			var responseHandler = new ServiceResponseHandler(this, "_reserveSuccess", "_reserveError");
			var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();
			
			//Get the from and to dates and times
			if (this.fromDateControl.getValue() != null && this.toDateControl.getValue() != null) //Should ALWAYS be true or the reserve button should have been disabled 
			{
				var fromDate = new Date(this.fromDateControl.getValue());
				var fromTime = this.fromTimeControl.getTime();
				if (fromTime) 
				{
					fromDate.setHours(fromTime.getHours());
					fromDate.setMinutes(fromTime.getMinutes());
				}
				var toDate = new Date(this.toDateControl.getValue());
				var toTime = this.toTimeControl.getTime();
				if (toTime) 
				{
					toDate.setHours(toTime.getHours());
					toDate.setMinutes(toTime.getMinutes());
				}
				if (this._validateDates(fromDate, toDate)) 
				{
					this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("msgReserving"));
					reservations.createReservation(responseHandler, id, fromDate.getTime(), toDate.getTime());
				}
				else 
					alert(RtlmUiUtil_getMessage("msgCheckDates"));
			}
		}
	},

	doUnResAction : function(machineID)
	{
		//Determine if we need to reserve or un-reserve
		if (this._isMachineReserved(machineID))  //has it been reserved in this session already
		{
			this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("msgUnReserving"));
			var resID = this._getResID(machineID);

			//Because the Reservations.cancelReservation method does not return the ID of the reservation being cancelled
			//We create a new instance of this handler for each machine being unreserved.  The reservationID is passed in the constructor
			var unResHandler = new com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView.unresHandler(this, resID);

			var responseHandler = new ServiceResponseHandler(unResHandler, "_unReserveSuccess", "_unReserveError");
			var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();
			reservations.cancelReservation(responseHandler, resID);
		}
	},
		

	_reserveSuccess:function(response)
	{
		this.viewHeaderNode.setProgressEnd();
		var reservationID = response.id;
		//We need to instantiate the machine in order to retrieve the machine id
        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
		var machine = catalog.createAssetFromJson(response.configuration);
		var machineID = machine.getId();
		
		this.newReservations.push({id:machineID, resID:reservationID});
		this.tableViewer.setContent( this.lastSearchResult );
		this.tableViewer.show();
		this._checkButtonStatus();
	},
	
	_reserveError:function(response)
	{
		this.viewHeaderNode.setProgressEnd();
		this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgReserveMachineFailedMaybeReserved"), ViewHeaderLayout.ERROR);		
	},

	_handleUnReserveSuccess: function(resID)
	{
		this.unReserveCount--;
		this._removeRes(resID); //Remove the reservation from our array of reservations
		if (this.unReserveCount <= 0) 
		{
			this.viewHeaderNode.setProgressEnd();
			this.tableViewer.setContent(this.lastSearchResult);
			this.tableViewer.show();
			this._checkButtonStatus();
		}
	},
	
	_handleUnreserveError: function(resID)
	{
		this.unReserveCount--;
		this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgUnReserveMachineFailed"), ViewHeaderLayout.ERROR);
		if (this.unReserveCount <= 0) 
			this.viewHeaderNode.setProgressEnd();
	},
	
	_isMachineReserved:function(id)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].id == id)
				return true;
		}
		return false;
	},
	
	_getResID : function(id)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].id == id)
				return this.newReservations[i].resID;
		}
		return null;
	},
	
	_removeRes : function(resID)
	{
        var res_length = this.newReservations.length;
		for (var i = 0; i < res_length; i++)
		{
			if (this.newReservations[i] != null && this.newReservations[i].resID == resID)
				this.newReservations[i] = null;
		}
	},
	
	_chooseLRD : function()
	{
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler= new ServiceResponseHandler(this, "_loadAllConfigsSuccessHandler", "_loadAllConfigsErrorHandler");
	
		configs.getAll(responseHandler);	
	},
	
	_loadAllConfigsSuccessHandler :function(response)
	{
		this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.AssetDescriptionSelectorDialog({title:RtlmUiUtil_getMessage("srchSelectResouceDesc")});
		this.selectDlg.setOKAction( dojo.hitch( this, this._handleSelectOK ), RtlmUiUtil_getMessage("srchTestDataNotNeeded") );
		if (response) 
		{
            var response_length = response.length;
			for (var i = 0; i < response_length; i++) 
			{
				var name = response[i].name;
				var id = response[i].id;
				
				this.selectDlg.addListItem(id, name);
			}
		}
		this.selectDlg.show();
	},
	
	_handleSelectOK :function()
	{
		var selectedPart = this.selectDlg.getSelectedAssetDescriptor();
		if (selectedPart != null)
		{
			this.configPart =  selectedPart;
			
			//Create a new "this.asset" and insert the selected part into it
			this.asset = catalog.createConfiguration(this.assetType);			
			var rootAtt = this.asset.getRootAttribute();
			//Remove the 0th element which is the existing part
			rootAtt.removeArrayValue(0);
			//Add in the new part
	        rootAtt.addArrayValue(this.configPart);
        			
			this.summaryArea.setPart(this.configPart);
			this.summaryArea.refresh();
			this.summaryArea.setName(this.selectDlg.getSelectedConfigName() + " - " + this.selectDlg.getSelectedPartName());
			//Setting the name cleared out the action to select an LRD so add it again
			this._addAdvancedActions();
			this.queryInUse = true;
		}
	},
	
	_loadAllConfigsErrorHandler: function()
	{
	
	},
	
	_searchAssets: function()
	{
        this.permissionsHash = {};
		this.createTable();
		this.loadTable();
	},
	
	_clearAttributes: function()
	{
		this.asset = catalog.createConfiguration(this.assetType);
		this.configPart = this.asset.getRootPart(0);
		this.summaryArea.setPart(this.configPart);
		this.summaryArea.refresh();
		this.summaryArea.setName(RtlmUiUtil_getMessage("srchCriteriaInfoSelOnly"));
		this.queryInUse = false;
		
		//Reset the dates
        this._inClearDate = true;
        
		this.fromDateControl.setDisplayedValue("");
		this.toDateControl.setDisplayedValue("");

        this._clearDateFieldsConstraints();

        this._inClearDate = false;

        // reset any date validation messages, etc.
        this._dateValueChanged();
        		
		//Reset the times
        var startOfDayTime = new Date();
        startOfDayTime.setHours(0, 0, 0, 0);
		this.fromTimeControl.setTime(startOfDayTime);
        var endOfDayTime = new Date();
        endOfDayTime.setHours(23, 59, 0, 0);
		this.toTimeControl.setTime(endOfDayTime);

		//Clear out the quick date selector
		this.quickSelect.options[0].selected = true;
		
		//Clear the result table
		this.createTable();
		this.tableViewer.show();

		//Re add the select LRD action		
		this._addAdvancedActions();
	},

    _updatePostDelete: function() 
    {
        this.loadTable();
    }    
});

//Because the Reservations.cancelReservation method does not return the ID of the reservation being cancelled
//We create a new instance of this handler for each machine being unreserved.  The reservationID is passed in the constructor
dojo.declare ("com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView.unresHandler", null, 
{
	constructor: function(parent, resID)
	{
		this.parent = parent;
		this.resID = resID;
	},
	
	_unReserveSuccess:function(response)
	{
		this.parent._handleUnReserveSuccess(this.resID);
	},

	_unReserveError:function(response)
	{
		this.parent._handleUnreserveError(this.resID);
	}
});

})();	