// com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");

dojo.require("com.ibm.rational.test.lm.web.client.internal.reservations");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.reservations.QueryReservationWidget");

(function() 
{
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
	var RequestUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil;
	var QueryReservationWidget = com.ibm.rational.test.lm.web.ui.internal.views.reservations.QueryReservationWidget;
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
    
	dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations", [dijit._Widget, dijit._Templated, com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener], 
	{
		//This line is NECESSARY fot the attachPoints in the PageLayout to get instantiated
		widgetsInTemplate: true,
		_comboValues: null,
		_itemCount: 0,
		
		//The layout of the page.
		templateString: 
		'<div id="${id}" dojoAttachPoint="domNode">' +
		'    <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout"' +
		'         isCompact="true" noline="true" dojoAttachPoint="myPageLayout">' + 		
		'        <!-- The table of reservations -->  '+
		'        <div dojoAttachPoint="reservations_panel">'+
		'            <div dojoAttachPoint="QueryReservationsNode" />' +
		'       </div>' +
		'    </div>'+
		'</div>',

//===========================================================

		
	postCreate: function()
    {
		this.inherited("postCreate", arguments);
  
  		//Set the title and cs help id on the page
		this.myPageLayout.setTitle(RtlmUiUtil_getMessage("resReservationsPageTitle"));
		this.myPageLayout.setCSHelpId("rtlm_reservations_page.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.myPageLayout.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", RtlmUiUtil_getMessage("resReservationsPageTitle")));
				
	    var params = {defaultQuery: QueryReservationWidget.ALL_RESERVATION_QUERY_ID, 
		              isMultiSelectTable: true,
                      loadQueryAtCreate: false,
					  runQueryCallback: dojo.hitch(this, "updateCancelButton"),
					  progressStartCallback: dojo.hitch(this, "_startProgress"),
					  progressEndCallback: dojo.hitch(this, "_endProgress")};
        this.reservationWidget = new QueryReservationWidget(params, this.QueryReservationsNode);
		
		this.resultTable = this.reservationWidget.resultTable;
		this.reservationWidget.setRowCheckStateListener(this);
        
        this.cancelResButton = this.resultTable.addAction("cancel", RtlmUiUtil_getMessage("resCancelSelected"), null, "unreserve-icon-image", dojo.hitch( this, this.cancelReservations ) );
        this.updateButtonStatus();              
        
        // don't let the reservation result widget load the query combo during 
        // widget instantiation time. It's possible that combo results is returned before the 
        // widget is completed creation and it would call into the updateButtonStatus() (thru
        // _endProgress()), and our resultTable attribute would not have been initialized.
        // Explicitly init the query combo after the widget has been created.
        this.reservationWidget.loadQueryCombo();
	},
	
	_onRefreshActionClick: function()
	{
		this.reservationWidget.runSelectedQuery();
	},
	
	_startProgress : function()
	{
		this.myPageLayout.setProgressStart(RtlmUiUtil_getMessage("resMsgRetrievingReservationsWorking"));
		this.updateButtonStatus();
	},
	
	_endProgress : function()
	{
		this.myPageLayout.setProgressEnd();
		this.updateButtonStatus();
	},
	
	//Return true if any rows are checked
	isAnyRowChecked: function()
    {
		return this.getCheckedCount() > 0;
    },
	
	getCheckedCount : function()
	{
		var resultTable = this.resultTable;
		var checkedRows = resultTable.getCheckedRows();
		return checkedRows.length;
	},
	
    _hasCancelPermissions: function()
    {
        var selectedRows = this.resultTable.getCheckedRows();
        var selectedRows_length = selectedRows.length;
        for(var i = 0; i < selectedRows_length; i++) {
            if(selectedRows[i]["canCancel"] == false)
                return false;
        }
        return true;
    },
    
	//Enable the cancel button if any rows are checked
	updateButtonStatus: function()
    {
		var checkedRows = this.getCheckedCount();
        var disableCancel = true;
        var hasPerm = true;
         
        if(checkedRows > 0) {
            hasPerm = this._hasCancelPermissions();
            disableCancel = !hasPerm;
        }
        this.cancelResButton.setDisabled(disableCancel);
        
        // show a warning message if the user doesn't have perm to
        // cancel the reservation.
        if(!hasPerm) {
            this.myPageLayout.setStatus(RtlmUiUtil_getMessage("resNoPermToCancel"), 
                ViewHeaderLayout.WARNING, RtlmUiUtil_getMessage("resNoPermToCancelDetails"));
        }
    },
	
	//Callback when a query is run
	updateCancelButton : function()
	{
		this.updateButtonStatus();
	},
	    
	cancelReservations : function()
	{
		var table = this.resultTable;
		var checkedRows = table.getCheckedRows();
        var checkedRows_length = checkedRows.length;
		if (checkedRows_length == 0)
			return;

		//Let the user know we are cancelling......
		this.myPageLayout.setProgressStart(RtlmUiUtil_getMessage("resCanceling"));
		this._reservationToCancel = [];
        this.canceledRes = [];
		for (var i = 0; i < checkedRows_length; i++)
		{
			var row = checkedRows[i];
            this._reservationToCancel.push(row);
		}
        this._cancelCnt = 0;
        this._cancelReservation(this._reservationToCancel[this._cancelCnt]);
	},

    doneCancelReservation: function()
    {
        this.myPageLayout.setProgressEnd();
        this.reservationWidget.runSelectedQuery();
        
        delete this._reservationToCancel;
        delete this._cancelCnt;

        if(this.canceledRes.length > 0)
            dojo.publish(GlobalEvents.ArtifactsUpdated, [ RtlmUiUtil.TYPE_RESERVATION_CANCELED, this.canceledRes ]);
            
        delete this.canceledRes;
        
        var resErrs_length = this.resErrs ? this.resErrs.length : 0;
        if(resErrs_length > 0) {
            var mess = "";
            for(var i = 0; i < resErrs_length; i++) {
                mess = this.resErrs[i] || "";
            }
            this.myPageLayout.setStatus(RtlmUiUtil_getMessage("msgUnableCancelReservations"), ViewHeaderLayout.ERROR, mess);
        }
    },

    cancelResSuccess: function(response)
    {
        var res = this._reservationToCancel[this._cancelCnt];
        
        // save the reservation that was canceled successfully.
        this.canceledRes.push(res.id);
        
        // we've canceled all of the selected reservations, or there're
        // more reservation needed to be canceled.
        this._cancelCnt++;
        if (this._cancelCnt == this._reservationToCancel.length) 
        {
            this.doneCancelReservation();
        }
        else {
            this._cancelReservation(this._reservationToCancel[this._cancelCnt]);
        }
        
    },
    
    cancelResfail: function(errorType, errorMessage)
    {
        // we've canceled all of the selected reservations, or there're
        // more reservation needed to be canceled.
        this._cancelCnt++;
        if (this._cancelCnt == this._reservationToCancel.length) 
        {
            this.doneCancelReservation();
        }
        else {
            this._cancelReservation(this._reservationToCancel[this._cancelCnt]);
        }
        if(this.resErrs == null)
            this.resErrs = [];
        this.resErrs.push(errorType.message);
    },
    
    _cancelReservation: function(res)
    {
        var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "cancelResSuccess", "cancelResfail");
        var reservations = new com.ibm.rational.test.lm.web.client.internal.reservations();

        //Get the dates of the reservation to determine if we are to perform a Cancel or a Release
        var fromDate = RtlmUiUtil.convertTimeStampToDate(res.reserveFrom);
        var toDate = RtlmUiUtil.convertTimeStampToDate(res.reserveTo);
        var today = new Date();
        if (fromDate <= today && toDate >= today)  //Do Release
        {
            reservations.endReservation(responseHandler, res.id);
            
        }
        else  //Do Cancel
        {
            reservations.cancelReservation(responseHandler, res.id);
        }  
    },
    
 	//Callback from the table when a row is checked	
	rowCheckStateChanged : function(tableViewer, rowObject, state)
    {
		//Update the button accordingly
        this.myPageLayout.clearStatus();
        this.updateButtonStatus();
    },
	
	init: function() 
	{
		console.debug("Reservations.init");
	}
});

})();
