/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/


dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummaryAndEditor");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.ASQValidateTextBox");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ActionConfigSummary");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.DefaultAssetContentProvider");

(function() 
{
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var AssetContentProviderFactory = com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory;
var DefaultAssetContentProvider = com.ibm.rational.test.lm.web.ui.internal.views.machines.DefaultAssetContentProvider;
var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummaryAndEditor", [dijit._Widget, dijit._Templated, com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener],
{    
    templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
	                '  <tr width="100%">' +
                    '   <table dojoAttachPoint="partTable" align="left" width="100%" cellPadding="0" cellSpacing="0" border="0">' +
                    '     <tr width="100%" dojoAttachPoint="partRow">' +
                    '       <td width="100%" align="left">' +
					'         <div dojoAttachPoint=moreLessNode>' +
					'         </div>' +
					'       </td>' +
					'     </tr> ' +
                    '   </table>' +
					'  </tr>' +
					'</div>',

    widgetsInTemplate: true,
	
	part:null,
	
	expand:false,
	
	edit:false,
	
	partLabel:null,
	
	editLabel:false,
	
	changeCallback:null,
	
	assetType:"Machine",
	
	isNew:false,
	
	postCreate:function()
	{
		//Create the more-less area for this config part
		this.moreLessSection = new com.ibm.asq.common.web.ui.internal.view.common.MoreLessCollapsibleArea( {editableLabel:true, title:this.partLabel, collapsedTitle:this.partLabel, open:this.expand} );
		this.moreLessSection.addAction( RtlmUiUtil_getMessage("configDeleteResourceDescription"), dojo.hitch( this, this._deleteSection), null, "delete-icon-image" );
		if (this.editLabel)
			this.moreLessSection.editableTitleNode._edit();
		this.moreLessSection.editableTitleNode.onChange = dojo.hitch(this, "_labelChanged");	

		//Now create a table that will be contained in the more/less section
		//The table will contain two rows.  One for the summary info and one for the detail/editing area
		var dataTable = document.createElement("table");
		dataTable.cellPadding = "0";
		dataTable.cellSpacing = "0";
		dataTable.border = "0";
		dataTable.align = "left";
		dataTable.width = "100%"
		var dataBody = document.createElement("tbody");
		dataTable.appendChild(dataBody);
		
		//save the table and body to "member variables" in case we need to mess with them later
		this.dataTable = dataTable;
		this.dataBody = dataBody;
		
		//Create the two rows in the table
		this.summaryRow = document.createElement("tr");
		this.summaryTD = document.createElement("td");
		this.detailRow = document.createElement("tr");
		this.detailRow.width="100%";
		this.detailTD = document.createElement("td");
		this.detailTD.width="100%";

		
		
		//Create the summary section and attach it to the datatable
		this.summarySection = new com.ibm.rational.test.lm.web.ui.internal.widgets.ActionConfigSummary({configPart:this.part});
		//Determine the label for the edit/summary button.  If we are editing then use Summary otherwise use Edit
		var buttonLabel = this.edit ? RtlmUiUtil_getMessage("cfgSummary") : RtlmUiUtil_getMessage("cfgEdit");
		this.summarySection.addAction(buttonLabel, dojo.hitch(this, "_edit"), {});
		this.summaryTD.appendChild(this.summarySection.domNode);
		this.summaryRow.appendChild(this.summaryTD);
		this.dataBody.appendChild(this.summaryRow);
		
		//Now create the detail section
        var formLayout = new com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm(this.detailTD);
		this.custProvider = new ConfigSummaryAndEditor.EditorCustomElementProvider(formLayout);
		this.custProvider.isNew = this.isNew;
        var provider = AssetContentProviderFactory.getAssetConfigurationProvider(this.assetType, formLayout, this);
        formLayout.setContentProvider(provider);
        formLayout.setCustomElementProvider(this.custProvider);         
        formLayout.setContent(this.part);
        formLayout.doLayout();
        formLayout.loadDataToForm();
		
        this.formLayout = formLayout;
		this.detailRow.appendChild(this.detailTD);
		this.dataBody.appendChild(this.detailRow);
		
		//The detail section (The formLayout) was created with the detailTD as its root.
		//So just append the detailTD to the detailRow, append the detailRow to the dataTable
		//add add the dataTable to the collapsible section
		if (this.edit == false)
			this.detailTD.style.display = "none";

        // set the container div display to hold the table
        //
        this.moreLessSection.contentNode.style.display = "table";
        this.moreLessSection.contentNode.style.width = "100%";
		this.moreLessSection.contentNode.appendChild(this.dataTable);
		this.moreLessNode.appendChild(this.moreLessSection.domNode);

	},
	
	_edit :function(callbackData)
	{
		if (this.detailTD.style.display == "none") 
		{
			callbackData.buttonNode.innerHTML = RtlmUiUtil_getMessage("cfgSummary");
			this.detailTD.width="100%";
			this.detailTD.style.display = "inline";
		}
		else 
		{
			this.detailTD.width="100%";
			this.detailTD.style.display = "none";
			callbackData.buttonNode.innerHTML = RtlmUiUtil_getMessage("cfgEdit");
			this.summarySection.setPart(this.part);
			this.summarySection.refresh();
		}
	},
	
	_labelChanged: function(value)
	{
		//We don't want to allow an empty label so set it to be "undefined"
		if (value == null || value == "")
			value = RtlmUiUtil_getMessage("undefined");
			
		this.moreLessSection.setTitle(value);
		this.moreLessSection.setCollapsedTitle(value);
		this.part.document.setLabelByTag(this.part.getTag(), value);
		if (this.changeCallback != null)
			this.changeCallback();
	},
	
	_deleteSection: function()
	{
		//ensure this is not the only part in the config
		if (this.part.document.getRootParts().length == 1)
		{
			alert(RtlmUiUtil_getMessage("configCantRemoveLastDescriptor"));
			return;
		}
		var self = this;
		var args = {
			message: RtlmUiUtil_getMessage("configConfirmRemovePart"),
			yesCallback: function(){
					self._removeThisPartFromTheConfig();
					self.partTable.style.display = "none";
					if (self.deleteCallback)
						self.deleteCallback();
					return true;          
			},
			noCallback: function() {
				return;
			}
		}
		var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(RtlmUiUtil_getMessage("msgConfirmTitle"));
		dialog.open();
	},
	
	_removeThisPartFromTheConfig :function()
	{
		var parts = this.part.document.getRootParts();
		var partTag = this.part.getTag();
        var parts_length = parts.length;
		for (var i = 0; i < parts_length; i++)
		{
			if (parts[i].getTag() == partTag)
			{
				this.part.document.removeRootPart(i);
				 break;
			}
		}
	},

    clearEditedState: function()
    {
        this.formLayout.clearAllEditedState();
    },
    
    // Summary:
    //     capture meta value changed event.
    // 
    attributeValueChanged: function(attributeKey, oldValue, newValue)
    {
		if (this.changeCallback != null)
			this.changeCallback(attributeKey, oldValue, newValue);
        
        // edit form value changed, update the header to reflect the changes. 
        this.custProvider.refreshHeadersInfo();
        this.summarySection.refresh();
    },

    // Summary:
    //     implements the form listener's interface
    // 
    attributeDeleteActionInvoked: function(attributeKey)
	{
		// deleting an attribute is just like editing 
		// values in the form, handle the form value changed.
		//
		this.attributeValueChanged(attributeKey, null, null);
	},
	
	addChangeHandler: function(handler)
	{
		this.changeCallback = handler;
	},
	
	addDeleteHandler: function(handler)
	{
		this.deleteCallback = handler;
	}
	
});

// Summary:
//     Custom element provider for the asset detail view's section form. It creates a 
//     editor's section container as the section's header area. The editor section container
//     can display attributes/summary information in its header area.
// 
dojo.declare("ConfigSummaryAndEditor.EditorCustomElementProvider", 
             [com.ibm.rational.test.lm.web.ui.internal.views.machines.ActionCustomElementProvider],
{   

    isNew: false,
    
    refreshHeadersInfo: function()
    {
        for(var i in this.sectionCreatedState) {
           var header = this.sectionCreatedState[i];
            this._loadSummaryInfo(header['sectionKey'], header);
        }
    },
    
    // Summary:
    //    Returns a widget that is the section header.
    //
    constructSectionHeader: function(sectionKey)
    {
        if( !( this.actionButtons ) )
    	{
    		this.actionButtons = {};
    	}
    	
    	if( !( this.actionButtons[ sectionKey.id ] ) )
    	{
    		this.actionButtons[ sectionKey.id ] = {};
    	}
    	
        var sectionInfo = this.layoutForm.getContentProvider().getSectionInfo(this.layoutForm.getContent(), sectionKey);   
        var header = null;
        var isOpen = (typeof sectionKey.open != "undefined") ? sectionKey.open : true;
        
        // if we already have shown this section, this's not the initial section creation,
        // show it always.
        if(this.sectionCreatedState[sectionKey.id]) {
            isOpen = true;
        }
        
        var csHelpId = sectionKey.contextHelpId;
        if (this.isNew) {
            csHelpId = sectionKey.contextHelpIdNew;
            
            if (sectionKey.id == "machine.details" || sectionKey.id == "vm.details")
                isOpen = true;
        }
            
        header = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer({
                title: RtlmUiUtil_getMessage(sectionInfo.title), 
                contextHelpId: csHelpId,
                csHelpProviderId: com.ibm.rational.test.lm.web.CSHelpID,
                open: isOpen,
                editable: true,
                'sectionKey': sectionKey
            });
            
        this.sectionCreatedState[sectionKey.id] = header;
        
		//Add in the actions, if any.
		//The only two actions we know about right now are add (for adding a new OS, Software, etc) and edit to edit
		//the available fields.
        if(sectionKey.actions) 
		{
            var actions_length = sectionKey.actions.length;
			for (var i = 0; i < actions_length; i++) 
			{
				if (sectionKey.actions[i] == "add") 
					this.actionButtons[ sectionKey.id ][ sectionKey.actions[i] ] = header.addAction("add", dojo.hitch(this, "_handleAddAttributeValueFromSection"), sectionKey, null, "add-icon-image");
				if (sectionKey.actions[i] == "edit") 
					this.actionButtons[ sectionKey.id ][ sectionKey.actions[i] ] = header.addAction(RtlmUiUtil_getMessage("editparms"), dojo.hitch(this, this.dlgFunction), sectionKey, null, "edit-icon")
			}
        }

        var groups_length = sectionKey.groups.length;
        for( var iGroup = 0; iGroup < groups_length; iGroup++ )
		{
			var shown = this.layoutForm.getContentProvider().getAttributeDisplayListForSection( sectionKey, sectionKey.groups[ iGroup ].root );
			
			if( shown && ( shown.length == 0 ) )
			{
				if( this.actionButtons && this.actionButtons[ sectionKey.id ] && this.actionButtons[ sectionKey.id ][ "add" ] )
					this.actionButtons[ sectionKey.id ][ "add" ].setDisabled( true );
			}
		}

        this._loadSummaryInfo(sectionKey, header);
        return header;
    },
    
    _loadSummaryInfo:function(sectionKey, header)
    {
        var groups = sectionKey.groups;
        var root = groups[0].root;
        var asset = this.layoutForm.getContent();
        var isAssetRoot = this._isAttributePathRoot(root);
        var part = this._getAttributeParent(asset, root);
        var rootAttrName = null;
        var rootAttr = null;
        
        // clear the info area first.
        header.clearAllInfoAttributes();
        header.setSummary("");
        
        if(!isAssetRoot) {
            rootAttrName = root.slice(root.lastIndexOf(".") + 1);
            rootAttr = part.getAttribute(rootAttrName);
            
            if(rootAttr.getType() != DefaultAssetContentProvider.TYPE_PART)
                return;
        }
        
        if(groups[0].infoAttributes) {
            var infoAttributes_length = groups[0].infoAttributes.length;
            for(var i = 0; i < infoAttributes_length; i++) {
                var attrName = groups[0].infoAttributes[i];
                var title = RtlmUiUtil_getMessage(attrName);
                var val = "<i>" + RtlmUiUtil_getMessage("noValue") + "</i>";
                var tmpVal = null;
                
                if(rootAttr) {
                    tmpVal = this._getAttributeDisplayValue(rootAttr, attrName);
                }
                else {
                    tmpVal = this._getPartAttributeValue(part, attrName);
                }
                if(tmpVal && tmpVal.length > 0) {
                    val = tmpVal;
                    header.addInfoAttribute(title, "<b>" + val + "</b>", null, null, false, null);
                }
            }
        }
        if(groups[0].summaryAttribute && part) {
            var attrName = groups[0].summaryAttribute[0];
            var attr = part.getAttribute(attrName);
            var title = RtlmUiUtil_getMessage(attrName);
            var val = (attr.getValue()) ? attr.getValue() : "";
            header.setSummary(val);
        }
    },
    
    _getAttributeDisplayValue: function(attr, attrName)
    {
        var val = null;
        
        if(attr.isArray()) {
            var arrayValue = attr.getArrayValues();
            var arrayValue_length = arrayValue.length;
            if(arrayValue_length > 0) {
                var val = "";
                for(var i = 0; i < arrayValue_length; i++) {
                    var attrPart = arrayValue[i];
                    
                    if(attrName == attr.getName()) {
                        val = val + attrPart.getName();
                    }
                    else {
                        val = val + this._getPartAttributeValue(attrPart, attrName);
                    }
                    if(i + 1 < arrayValue_length)
                        val = val + ", ";
                }
            }
        }
        else {
            var part = attr.getValue();
            val = this._getPartAttributeValue(part, attrName);
        }
        return val;
    },
    
    _getPartAttributeValue: function(part, attrName)
    {
        var attr = part.getAttribute(attrName);
        var attrVal = attr.getValue(); 
        var type = attr.getType();

        if(attrVal) {
            attrVal = (type == DefaultAssetContentProvider.TYPE_POINTER) ? attrVal.getDisplayString() : attrVal;
        }
        else 
            attrVal = "";    
                        
        return attrVal;
    },
	
	//MFV NEW
	dlgFunction: function( sectionKey )
	{
        var dlg_args = { title:RtlmUiUtil_getMessage("titleSelectAtributes"), "sectionKey": sectionKey };
		var dlg = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ParameterDialog(dlg_args);
		var elements = {};
        var contentProvider = this.layoutForm.getContentProvider();
        var groups_length = sectionKey.groups.length;
		for( var iGroup = 0; iGroup < groups_length; iGroup++ )
		{
			var attrs = contentProvider.getAttributeDisplayListForSection( sectionKey, sectionKey.groups[ iGroup ].root, true );
			if(attrs) {
                var attrs_length = attrs.length;
	            for( var iAttr = 0; iAttr < attrs_length; iAttr++ )
	            {
	                elements[ attrs[ iAttr ] ] = {};
	                elements[ attrs[ iAttr ] ].id = attrs[ iAttr ];
	                elements[ attrs[ iAttr ] ].selected = true;
	            }
			}
			var hiddenAttrs = contentProvider.getAttributeHiddenListForSection( sectionKey, sectionKey.groups[ iGroup ].root );
            
			if(hiddenAttrs) {
                var hiddenAttrs_length = hiddenAttrs.length;
	            for( var iAttr = 0; iAttr < hiddenAttrs_length; iAttr++ )
	            {
	                elements[ hiddenAttrs[ iAttr ] ] = {};
	                elements[ hiddenAttrs[ iAttr ] ].id = hiddenAttrs[ iAttr ];
	                elements[ hiddenAttrs[ iAttr ] ].selected = false;
	            }				
			}
		}

		dlg.setOptions( elements );
		dlg.setOKaction( dojo.hitch( this, this.parametersChanged ) );
		
		dlg.show();
	},
	
	parametersChanged: function( sectionKey, parameters )
	{
		var shown = [];
		var hidden = [];
		
		for( var elem in parameters )
		{
			if( parameters[ elem ] == true )
			{
				shown.push( elem );
			}
			else
			{
				hidden.push( elem );				
			}
		}
		
        var contentProvider = this.layoutForm.getContentProvider();
        var groups_length = sectionKey.groups.length;
		for( var iGroup = 0; iGroup < groups_length; iGroup++ )
		{
			contentProvider.setShowHideAttributeForSection( sectionKey, sectionKey.groups[ iGroup ].root, shown, hidden );
		}
/*	
        // this code is broken as getSectionHeader does not exist.     
 	
		var sHdr = this.getSectionHeader( sectionKey );
		
		//Get the add button and disable it if nothing is going to be shown anyways
		var button = sHdr.getActionButton( "add" );
		
		if( ( shown.length == 0 ) && button )
		{
			button.setDisabled( true );
		}
		else if( button )
		{
			button.setDisabled( false );
		}
*/		
	}
});

})();
