/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
//
// Summary:
//      Subclassed from the dijit.form.ValidationTextBox to change the template
//		so that it does not use the dijit css styles for certain elements which cause
//		problems in IE.
//
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.ReTemplatedValidationTextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("jazz.ui.HoverPopup");

(function(){
	
dojo.declare(
    "com.ibm.asq.common.web.ui.internal.widgets.ReTemplatedValidationTextBox",
    dijit.form.ValidationTextBox,
{   
// NOTE: don't override the new 2.0 jazz/dojo templateString in the base widget yet. Need to fix the IE loading problem first
// before we can see if this is still necessary. lto 2/26/09
//    templateString: "<table style=\"display: -moz-inline-stack;\" class=\"dijit dijitReset asqTextBoxInline\" cellspacing=\"0\" cellpadding=\"0\"\r\n\tid=\"widget_${id}\" name=\"${name}\"\r\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse\" waiRole=\"presentation\"\r\n\t><tr class=\"dijitReset\"\r\n\t\t><td class=\"dijitReset asqInputField\" width=\"100%\"\r\n\t\t\t><input dojoAttachPoint='textbox,focusNode' dojoAttachEvent='onfocus,onblur:_onMouse,onkeyup,onkeypress:_onKeyPress' autocomplete=\"off\"\r\n\t\t\ttype='${type}' name='${name}'\r\n\t\t/></td\r\n\t\t><td class=\"dijitReset dijitValidationIconField\" width=\"0%\"\r\n\t\t\t><div dojoAttachPoint='iconNode' class='dijitValidationIcon'></div><div class='dijitValidationIconText'>&Chi;</div\r\n\t\t></td\r\n\t></tr\r\n></table>\r\n"
//	templateString:"<div class=\"dijit dijitReset asqTextBoxInline dijitInlineTable dijitLeft\"\n\tid=\"widget_${id}\"\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse\" waiRole=\"presentation\"\n\t><div style=\"overflow:hidden;\"\n\t\t><div class=\"dijitReset dijitValidationIcon\"><br></div\n\t\t><div class=\"dijitReset dijitValidationIconText\">&Chi;</div\n\t\t><div class=\"dijitReset asqInputField\"\n\t\t\t><input class=\"dijitReset\" dojoAttachPoint='textbox,focusNode' dojoAttachEvent='onfocus:_update,onkeyup:_update,onblur:_onMouse,onkeypress:_onKeyPress' autocomplete=\"off\"\n\t\t\ttype='${type}' name='${name}'\n\t\t/></div\n\t></div\n></div>\n",

    uninitialize: function(){
        // clean up the tool tip.
        if (this.tooltip) {
            this.tooltip.destroy();
            delete this.tooltip;
        }
    },
    displayMessage: function(/*String*/ message){
        if (this._message == message) {
            return;
        }
        this._message = message;

        // message is changed or maybe cleared
        if (this.tooltip) {
            this.tooltip.close();
            this.tooltip.destroy();
        }

        if (message) {
            this.tooltip = new jazz.ui.HoverPopup({html: message, openDelay: 300, around:[this.domNode]});
            this.tooltip.open();
        }
    }
});
})();
