/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 // Summary:
 //    
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.PanelLayout");
dojo.require("dojo.fx");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.PanelLayout",
             null,
{    
    panelContainer: null,

    postscript: function(/*Object?*/params)
    {
        dojo.mixin(this, params);
    },
    
    doLayoutAllChildren: function()
    {
        var mb = this.panelContainer.contentBox;
        var pWidth = this.panelContainer.panelWidth - 2;
        var dim = {
            t: 0,
            l: 0,
            w: pWidth,
            h: (mb.h - 4)
        };
        
        for(var i = 0; i < this.panelContainer.panels.length; i++) {
            this.panelContainer.panels[i].resize(dim);
        }
        this.adjustContentContainerSize();
        
    },
    
    doLayout: function(panel)
    {
        var mb = this.panelContainer.contentBox;
        var pWidth = this.panelContainer.panelWidth - 2;
        
        dojo.style(panel.domNode, "position", "relative");
        dojo.style(panel.domNode, "float", "left");
        var dim = {
            t: 0,
            l: 0,
            w: pWidth,
            h: (mb.h - 4)
        };
        panel.resize(dim);
        this.adjustContentContainerSize();
    },
    
    adjustContentContainerSize: function()
    {
        var nPanel = this.panelContainer.getPanelCount();
        var content = this.panelContainer.getContent();
        var contentWidth = (nPanel * (this.panelContainer.panelWidth + 2));
		if(contentWidth >0)
        	content.style.width = contentWidth + "px";        
    },
    
    setFirstVisiblePanel: function(whichPanel, force)
    {
        var firstPanel = whichPanel || 0;
        var nPanels = this.panelContainer.getPanelCount();
        var nVisiblePanels = this.panelContainer.getNumVisiblePanels();
        
        if(typeof whichPanel == "undefined") {
            if(nVisiblePanels < 1) {
                return;
            }
            if(nPanels > nVisiblePanels) {
                firstPanel = nPanels - nVisiblePanels;
            }
        }
        var isValid = firstPanel >= 0 && firstPanel < nPanels;
        if(isValid && (firstPanel != this.panelContainer.getFirstPanelPosition() || force)) {
            var leftPos = 0;
            
            // find the left position of the panel. The panels are
            // positioned relatively. Their left pos is always 0.
            // Need to add up all the widths of the panels.
            for (var i = 0; i < firstPanel; i++) {
                var panel = this.panelContainer.getPanelAt(i);
                var panelDim = dojo.marginBox(panel.domNode);
                leftPos += panelDim.w;
            }
            var content = this.panelContainer.getContent();
            var offset = (leftPos > 0) ? (leftPos + 1) : 0;
            var slide = dojo.fx.slideTo({
                node: content, 
                left: ((0 - offset) + ""), 
                unit: "px"});
            slide.play();
            
            // record the first panel id in the container.
            this.panelContainer.setFirstPanelPosition(firstPanel);
        }
    }
    
});

})();
