/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage");

dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.wizard.WizardPage");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){

var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status					= com.ibm.team.repository.web.foundation.Status;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 			= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage", 
			 [com.ibm.asq.common.web.ui.internal.wizard.WizardPage, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/wizard/templates/ArtifactCopyWizardPage.html"),
	values:[],
	items:[],
	pageId:null,
	allowUnique:false,
	lastSelectedValues:[],	
	faultyTargetValues:[],
	constructor: function(args) {
		this.items = args.items||[];
		this.lastSelectedValues = [];
        this.faultyTargetValues = [];
	},
	postCreate: function() {
		this.targetSelects = [];
		this._isPageComplete = false;
		this.initialized = false;
	},
	getContentNode: function() {
		if (!this.initialized) {
			this._isPageComplete = true;
			this._displayContents(this.items);
			this.initialized = true;
		}
		return this._rootNode;
	},
	
	_displayContents:function(items){
		var doc = document;
		var tbody = this._detailsTable;
		var len = items.length;
		if(items[0] && items[0].alternatives && items[0].alternatives.length < len){
			this._displayAlertDialog(Constants.getMessage("msgCorrelateFail",this._wizardDialog._wizard.targetPA));
			this._isPageComplete = false;
		}
		for (var i = 0; i < len; i++) {
		    var hint = "";
		    if (items[i].hint) {
		        hint = items[i].hint.itemId || items[i].hint.name;
		    }
			this._createRow(doc,tbody,items[i].sourceItem,items[i].alternatives || [],hint);
		}
		
		if (this.allowUnique) {
		    for (var id in this.lastSelectedValues) {
		        var value = this.lastSelectedValues[id];
				var targetSelects  = this.targetSelects;
		        var len = targetSelects.length;
		        for (var i = 0; i < len; i++) {
		            var targetSelect = targetSelects[i];
		            if (targetSelect.id == id) {
		                continue;
		            }
					var len2 = targetSelect.options.length;
		            for (var j = 0; j < len2; j++) {
		                var option = targetSelect.options[j];
		                if (option.value == value) {
		                    option.disabled = true;
		                }
		            }
		        }
		    }
		}		
	},
	_createRow:function(doc,tbody,source,targets,hint){
		var tr = this._getEmptyRow(doc);
		var td1 = this._getEmptyCell(doc);
		var sourceLabel = doc.createElement("label");
		sourceLabel.innerHTML = source.name;
		td1.appendChild(sourceLabel);
		td1.style.color = "rgb(0,0,0)";
		tr.appendChild(td1);
		var td2 = this._getEmptyCell(doc);
		var targetSelect = doc.createElement("select");
		targetSelect.id = this.id+source.name;
		var len = targets.length;
		targetSelect.options[0] = new Option("", "");
		
		for(var i=0;i<len;i++){
			var value = targets[i].itemId;
			if (!value) {
				value = targets[i].name;
			}
			targetSelect.options[i + 1] = new Option(targets[i].name,value);
			if(hint && hint == value){
				targetSelect.options[i + 1].selected = true;
				this.lastSelectedValues[targetSelect.id] = value;
			}
		}
            
		this.targetSelects.push(targetSelect);
		td2.appendChild(targetSelect);
		tr.appendChild(td2);
		tbody.appendChild(tr);
		
		if (!hint) {
            this.setPageComplete(false);
            this.faultyTargetValues.push(targetSelect.id);
            targetSelect.parentNode.previousSibling.style.color="rgb(255,0,0)";
        }
		
        this.connect(targetSelect, "onchange", this._onChange);
	},
	_onChange:function(e){
	    var targetSelect = e.target;
	    var selectedValue = e.target.value;
		setTimeout(dojo.hitch(this, this._handleOnChange,targetSelect,selectedValue),0);
		if(e.stopPropagation) //FF
			e.stopPropagation();
		e.cancelBubble = true;//IE
		return;
	},
	_handleOnChange:function(targetSelect,selectedValue){
		var faultyTargetValues = this.faultyTargetValues;
	    targetSelect.parentNode.previousSibling.style.color="rgb(0,0,0)";
	    if (selectedValue == "") {
	        targetSelect.parentNode.previousSibling.style.color="rgb(255,0,0)";
	        faultyTargetValues.push(targetSelect.id);
	    } else {
			var len = faultyTargetValues.length;
	        for (var i=0;i<len;i++) {
	            if (faultyTargetValues[i] == targetSelect.id) {
	                faultyTargetValues.splice(i, 1);
					i-=1;
					len-=1;
	            }
	        }
	    }
	        
        if (this.allowUnique) {
            var lastValue = this.lastSelectedValues[targetSelect.id];
			var targetSelects = this.targetSelects;
			var len2 = targetSelects.length;
            for (var i = 0; i < len2 ; i++) {
                if (targetSelects[i].id == targetSelect.id) {
                    continue;
                }
                var len3 = targetSelects[i].options.length;
                for (var j = 0; j < len3; j++) {
                    var option = targetSelects[i].options[j];
                    if (option.value != "" && option.value == selectedValue) {
                        option.disabled = true;
                    }
                    if (lastValue && lastValue != "" && option.value == lastValue) {
                        option.disabled = false;
                    }
                }
            }
            this.lastSelectedValues[targetSelect.id] = selectedValue;
	    }
	    
	    if (this.faultyTargetValues.length > 0) {
	        this.setPageComplete(false);
	    } else {
	        this.setPageComplete(true);
	    }
	},
	_getEmptyRow: function(doc) {
		var row = doc.createElement("tr");
		return row;
	},
		
	_getEmptyCell: function(doc,span, align){
		var cell = doc.createElement("td");
		cell.width = "50%";
		return cell;
	},
	aboutToHide:function(){
		var items = this.items;
		var len = items.length;
		var sourceValues = [];
		var targetValues = [];
		var optTargetValues = [];
		var targetSelects = this.targetSelects;
		for (var i = 0; i < len; i++) {
		    var source = items[i].sourceItem.itemId;
		    if (!source) {
		        source = items[i].sourceItem.name;
		    }
			sourceValues.push(source)
			targetValues.push(targetSelects[i].value);
			optTargetValues.push("");
		}
		this.values = {sourceItems:sourceValues,targetItems:targetValues,optTargetData:optTargetValues};
	},
	getValues:function(){
		return this.values;
	},
	_displayAlertDialog: function(message){
        var args = {
			message: message
		}
		var alertDialog = new AlertDialog( args );
        alertDialog.open();
},
	__sentinel: null // terminates this class definition
});

com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create= function(params) {
	return new com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage(params);
};

})();
