/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.internal.wizard.WizardPage");

dojo.require("dijit._Widget");

dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");

dojo.require("com.ibm.team.repository.web.foundation.Status");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function(){

var NullProgressMonitor		= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var Status					= com.ibm.team.repository.web.foundation.Status;
var DefectsUIUtil 			= com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
	
dojo.declare("com.ibm.rqm.defects.web.ui.internal.wizard.WizardPage", 
			 [dijit._Widget], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	_wizardDialog: null,
	_pageTitle: null,
	_pageDescription: null,
	_isPageComplete: true,
	
	constructor: function() {
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------	

	getTitle: function() {
		return this._pageTitle;
	},

	getDescription: function() {
		return this._pageDescription;
	},

	getContentNode: function() {
		throw new Error(DefectsUIUtil.getMessage("labelNoGetContentNode"));
	},

	isPageComplete: function() {
		return this._isPageComplete;
	},
	
	setWizardDialog: function(wizardDialog) {
		this._wizardDialog= wizardDialog;
	},
	
	aboutToShow: function(runWhenReady) {
		runWhenReady(Status.OK_STATUS);
	},

	aboutToHide: function() {
		
	},
	
	// ---- WizardPage api -------------------------------------------------------------------------------------------------	

	setPageComplete: function(complete) {
		this._isPageComplete= complete;
		if (this._wizardDialog != null) {
			this._wizardDialog.updateButtons();
		}
	},
	
	runWithProgress: function(progressMonitoredCode) {
		if (this._wizardDialog != null) {
			this._wizardDialog.runWithProgress(progressMonitoredCode);
		} else {
			this.runWithProgress(new NullProgressMonitor())
		}
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

com.ibm.rqm.defects.web.ui.internal.wizard.WizardPage.constructorArgs= function(title, description) {
	return {
		_pageTitle: title,
		_pageDescription: description
	};
};

})();
