/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar")

dojo.require("com.ibm.team.repository.web.foundation.ProgressMonitor");

dojo.require("dojox.data.dom");

dojo.require("jazz.ui.Dialog");

(function(){
	
dojo.declare("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog", 
			 [dijit._Widget, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_dialogRoot: null,
	_titleContainer: null,
	_messageContainer: null,
	_content: null,
	_progressSection: null,
	_progressBar: null,
	_progressMessage: null,
	_actionButtons: null,
	
	_title: null,
	_message: null,
	_width: "40%",
	_progressBarWidget: null,
	_contentNode: null,
	_buttons: null,
	
	runWithProgress: function(progressMonitoredCode) {
		var monitor= new com.ibm.rqm.defects.web.ui.view.common.DeferredDialog._ProgressMonitor(this);
		this._progressSection.style.visibility= "visible";
		progressMonitoredCode(monitor);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.rqm.defects.web", "ui/view/common/templates/DeferredDialog.html"),

	postCreate: function() {
		
		dojox.data.dom.replaceChildren(this._messageContainer, document.createTextNode(this._message));
		
		this._progressBarWidget= new dijit.ProgressBar({}, this._progressBar);
		this._progressBarWidget.update({indeterminate: true});
		
		this._dialog = new jazz.ui.Dialog({
			contentNode: this._dialogRoot,
			primaryTitle: this._title,
			width: this._width,
			isClosable: true
		});
		
		dojox.data.dom.replaceChildren(this._content, this._contentNode);
		dojox.data.dom.replaceChildren(this._actionButtons, this._buttons);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	close: function() {
		this._dialog.close();
	},
	
	_notifyBeginTask: function(name) {
		dojox.data.dom.replaceChildren(this._progressMessage, document.createTextNode(name));
	},

	_notifyDone: function() {
		this._progressSection.style.visibility= "hidden";
		dojox.data.dom.removeChildren(this._progressMessage);
	},

	__sentinel: null // terminates this class definition
});

dojo.declare("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog._ProgressMonitor",
			 [com.ibm.team.repository.web.foundation.ProgressMonitor], {

	constructor: function(deferredDialog) {
		this._deferredDialog= deferredDialog;
	},

	// ---- ProgressMonitor implementation ---------------------------------------------------------------------------------

	beginTask: function(name) {
		this._deferredDialog._notifyBeginTask(name);
	},

	done: function() {
		this._deferredDialog._notifyDone();
	},

	__sentinel: null // terminates this class definition
});

})();
