/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.ServiceProviderDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function(){

    var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
    var SelectUtil = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
    
    dojo.declare("com.ibm.rqm.defects.web.ui.view.common.ServiceProviderDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.defects.web", "ui/view/common/templates/ServiceProviderDialog.html"),
        
        //STYLE: "position: absolute; top: 30%; left: 30%; width: 30%; height:40%",
        width: "400px",
        title: DefectsUIUtil.getMessage("labelServiceProviderTitle"),
        labelSelectServiceProvider: DefectsUIUtil.getMessage("labelSelectServiceProvider"),
        
        constructor: function(args){
            this.onOk = function(){
            };
            this.onClose = function(){
            };
            this.serviceProviders = [];
        },
        
        postCreate: function(){
            var dialogArgs = {
                primaryTitle: this.title,
                okCallback: dojo.hitch(this, "_onOk"),
                onBeforeClose: dojo.hitch(this, "_onClose")
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth(this.width);
            this._dialog.getOkButton().disabled = false;
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.open();
            
            this._showServiceProviders();
        },
        
        _onOk: function(){
            var sp = this._getServiceProvider(this._serviceProviderSelect.value);
            if (dojo.isFunction(this.onOk)) {
				if (this._dialog && this._dialog.opened) {
					this._dialog.close();
				}
                this.onOk(sp);
            }
        },
        
        _onClose: function(){
            if (dojo.isFunction(this.onClose)) {
            	this.onClose();
            }
        },
        
        _showServiceProviders: function(){
            dojox.data.dom.removeChildren(this._serviceProviderSelect)
            for (var i = 0; i < this.serviceProviders.length; i++) {
                var sp = this.serviceProviders[i];
                SelectUtil.add(this._serviceProviderSelect, new Option(sp.name, sp.servicesUrl));
            }
        },
        
        _getServiceProvider: function(servicesUrl){
            for (var i = 0; i < this.serviceProviders.length; i++) {
                if (this.serviceProviders[i].servicesUrl == servicesUrl) {
                    return this.serviceProviders[i];
                }
            }
        },
        
        _error: function(e){
            console.error(this.declaredClass + ": error: " + (e ? e.message : ""));
        }
        
    });
    
})();
